/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/product/common/product","vs/editor/common/config/editorOptions","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(Z){for(var e=[],m=0,L=Z.length;m<L;m++)e[m]=me[Z[m]];return e};define(me[54],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,I){if(!L)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=m}),define(me[55],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(n){const T=[];for(let u in n)m.call(n,u)&&T.push(n[u]);return T}e.values=L;function I(n,T){for(let u in n)if(m.call(n,u)&&T({key:u,value:n[u]},function(){delete n[u]})===!1)return}e.forEach=I;function C(n,T){const u=Object.create(null);for(const h of n){const c=T(h);let g=u[c];g||(g=u[c]=[]),g.push(h)}return u}e.groupBy=C;function R(n){const T=Object.create(null);return n&&n.forEach((u,h)=>{T[h]=u}),T}e.fromMap=R;function k(n,T){const u=[],h=[];for(let c of n)T.has(c)||u.push(c);for(let c of T)n.has(c)||h.push(c);return{removed:u,added:h}}e.diffSets=k;function D(n,T){const u=[],h=[];for(let[c,g]of n)T.has(c)||u.push(g);for(let[c,g]of T)n.has(c)||h.push(g);return{removed:u,added:h}}e.diffMaps=D;class A{constructor(){this.map=new Map}add(T,u){let h=this.map.get(T);h||(h=new Set,this.map.set(T,h)),h.add(u)}delete(T,u){const h=this.map.get(T);!h||(h.delete(u),h.size===0&&this.map.delete(T))}forEach(T,u){const h=this.map.get(T);!h||h.forEach(u)}}e.SetMap=A}),define(me[56],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(R){return(k,D,A)=>{let n=null,T=null;if(typeof A.value=="function"?(n="value",T=A.value):typeof A.get=="function"&&(n="get",T=A.get),!T)throw new Error("not supported");A[n]=R(T,D)}}e.createDecorator=m;function L(R,k,D){let A=null,n=null;if(typeof D.value=="function"?(A="value",n=D.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(A="get",n=D.get),!n)throw new Error("not supported");const T=`$memoize$${k}`;D[A]=function(...u){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,u)}),this[T]}}e.memoize=L;function I(R,k,D){return m((A,n)=>{const T=`$debounce$${n}`,u=`$debounce$result$${n}`;return function(...h){this[u]||(this[u]=D?D():void 0),clearTimeout(this[T]),k&&(this[u]=k(this[u],...h),h=[this[u]]),this[T]=setTimeout(()=>{A.apply(this,h),this[u]=D?D():void 0},R)}})}e.debounce=I;function C(R,k,D){return m((A,n)=>{const T=`$throttle$timer$${n}`,u=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,c=`$throttle$pending$${n}`;return function(...g){if(this[u]||(this[u]=D?D():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[u]=k(this[u],...g)),this[c])return;const _=this[h]+R;_<=Date.now()?(this[h]=Date.now(),A.apply(this,[this[u]]),this[u]=D?D():void 0):(this[c]=!0,this[T]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),A.apply(this,[this[u]]),this[u]=D?D():void 0},_-Date.now()))}})}e.throttle=C}),define(me[16],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function I(v){D(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=I;function C(v){D(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=C;function R(v){if(v instanceof Error){let{name:t,message:r}=v;const s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:s}}return v}e.transformErrorForSerialization=R;const k="Canceled";function D(v){return v instanceof Error&&v.name===k&&v.message===k}e.isPromiseCanceledError=D;class A extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=A;function n(){const v=new Error(k);return v.name=v.message,v}e.canceled=n;function T(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=T;function u(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=u;function h(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function c(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=g;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class P extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=P;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function o(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=o;function a(v,t=Object.create(null)){const r=new Error(v);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(me[20],ge([0,1,16]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,X=0){return H[H.length-(1+X)]}e.tail=L;function I(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=I;function C(H,X,J=(fe,_e)=>fe===_e){if(H===X)return!0;if(!H||!X||H.length!==X.length)return!1;for(let fe=0,_e=H.length;fe<_e;fe++)if(!J(H[fe],X[fe]))return!1;return!0}e.equals=C;function R(H,X,J){let fe=0,_e=H.length-1;for(;fe<=_e;){const Se=(fe+_e)/2|0,Le=J(H[Se],X);if(Le<0)fe=Se+1;else if(Le>0)_e=Se-1;else return Se}return-(fe+1)}e.binarySearch=R;function k(H,X){let J=0,fe=H.length;if(fe===0)return 0;for(;J<fe;){const _e=Math.floor((J+fe)/2);X(H[_e])?fe=_e:J=_e+1}return J}e.findFirstInSorted=k;function D(H,X,J){if(H=H|0,H>=X.length)throw new TypeError("invalid index");let fe=X[Math.floor(X.length*Math.random())],_e=[],Se=[],Le=[];for(let We of X){const Ne=J(We,fe);Ne<0?_e.push(We):Ne>0?Se.push(We):Le.push(We)}return H<_e.length?D(H,_e,J):H<_e.length+Le.length?Le[0]:D(H-(_e.length+Le.length),Se,J)}e.quickSelect=D;function A(H,X){const J=[];let fe;for(const _e of H.slice(0).sort(X))!fe||X(fe[0],_e)!==0?(fe=[_e],J.push(fe)):fe.push(_e);return J}e.groupBy=A;function n(H,X,J){const fe=[];function _e(We,Ne,Ke){if(Ne===0&&Ke.length===0)return;const z=fe[fe.length-1];z&&z.start+z.deleteCount===We?(z.deleteCount+=Ne,z.toInsert.push(...Ke)):fe.push({start:We,deleteCount:Ne,toInsert:Ke})}let Se=0,Le=0;for(;;){if(Se===H.length){_e(Se,0,X.slice(Le));break}if(Le===X.length){_e(Se,H.length-Se,[]);break}const We=H[Se],Ne=X[Le],Ke=J(We,Ne);Ke===0?(Se+=1,Le+=1):Ke<0?(_e(Se,1,[]),Se+=1):Ke>0&&(_e(Se,0,[Ne]),Le+=1)}return fe}e.sortedDiff=n;function T(H,X,J){const fe=n(H,X,J),_e=[],Se=[];for(const Le of fe)_e.push(...H.slice(Le.start,Le.start+Le.deleteCount)),Se.push(...Le.toInsert);return{removed:_e,added:Se}}e.delta=T;function u(H,X,J){if(J===0)return[];const fe=H.slice(0,J).sort(X);return c(H,X,fe,J,H.length),fe}e.top=u;function h(H,X,J,fe,_e){return J===0?Promise.resolve([]):new Promise((Se,Le)=>{(async()=>{const We=H.length,Ne=H.slice(0,J).sort(X);for(let Ke=J,z=Math.min(J+fe,We);Ke<We;Ke=z,z=Math.min(z+fe,We)){if(Ke>J&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,m.canceled)();c(H,X,Ne,Ke,z)}return Ne})().then(Se,Le)})}e.topAsync=h;function c(H,X,J,fe,_e){for(const Se=J.length;fe<_e;fe++){const Le=H[fe];if(X(Le,J[Se-1])<0){J.pop();const We=k(J,Ne=>X(Le,Ne)<0);J.splice(We,0,Le)}}}function g(H){return H.filter(X=>!!X)}e.coalesce=g;function _(H){let X=0;for(let J=0;J<H.length;J++)H[J]&&(H[X]=H[J],X+=1);H.length=X}e.coalesceInPlace=_;function P(H,X,J){H.splice(J,0,H.splice(X,1)[0])}e.move=P;function E(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=E;function o(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=o;function a(H,X){if(!X)return H.filter((fe,_e)=>H.indexOf(fe)===_e);const J=Object.create(null);return H.filter(fe=>{const _e=X(fe);return J[_e]?!1:(J[_e]=!0,!0)})}e.distinct=a;function v(H){const X=new Set;return H.filter(J=>X.has(J)?!1:(X.add(J),!0))}e.distinctES6=v;function t(H){const X=Object.create(null);return J=>{const fe=H(J);return X[fe]?!1:(X[fe]=!0,!0)}}e.uniqueFilter=t;function r(H,X){for(let J=H.length-1;J>=0;J--){const fe=H[J];if(X(fe))return J}return-1}e.lastIndex=r;function s(H,X){return H.length>0?H[0]:X}e.firstOrDefault=s;function i(H,X,J=(fe,_e)=>fe===_e){let fe=0;for(let _e=0,Se=Math.min(H.length,X.length);_e<Se&&J(H[_e],X[_e]);_e++)fe++;return fe}e.commonPrefixLength=i;function l(H){return[].concat(...H)}e.flatten=l;function d(H,X){let J=typeof X=="number"?H:0;typeof X=="number"?J=H:(J=0,X=H);const fe=[];if(J<=X)for(let _e=J;_e<X;_e++)fe.push(_e);else for(let _e=J;_e>X;_e--)fe.push(_e);return fe}e.range=d;function f(H,X,J){return H.reduce((fe,_e)=>(fe[X(_e)]=J?J(_e):_e,fe),Object.create(null))}e.index=f;function w(H,X){return H.push(X),()=>y(H,X)}e.insert=w;function y(H,X){const J=H.indexOf(X);if(J>-1)return H.splice(J,1),X}e.remove=y;function p(H,X,J){const fe=H.slice(0,X),_e=H.slice(X);return fe.concat(J,_e)}e.arrayInsert=p;function S(H,X){let J;if(typeof X=="number"){let fe=X;J=()=>{const _e=Math.sin(fe++)*179426549;return _e-Math.floor(_e)}}else J=Math.random;for(let fe=H.length-1;fe>0;fe-=1){const _e=Math.floor(J()*(fe+1)),Se=H[fe];H[fe]=H[_e],H[_e]=Se}}e.shuffle=S;function b(H,X){const J=H.indexOf(X);J>-1&&(H.splice(J,1),H.unshift(X))}e.pushToStart=b;function F(H,X){const J=H.indexOf(X);J>-1&&(H.splice(J,1),H.push(X))}e.pushToEnd=F;function N(H,X){return Array.isArray(H)?H.map(X):X(H)}e.mapArrayOrNot=N;function G(H){return Array.isArray(H)?H:[H]}e.asArray=G;function K(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=K;function M(H,X){for(const J of H){const fe=X(J);if(fe!==void 0)return fe}}e.mapFind=M;function U(H,X,J){const fe=$(H,X),_e=H.length,Se=J.length;H.length=_e+Se;for(let Le=_e-1;Le>=fe;Le--)H[Le+Se]=H[Le];for(let Le=0;Le<Se;Le++)H[Le+fe]=J[Le]}e.insertInto=U;function O(H,X,J,fe){const _e=$(H,X),Se=H.splice(_e,J);return U(H,_e,fe),Se}e.splice=O;function $(H,X){return X<0?Math.max(X+H.length,0):Math.min(X,H.length)}function B(H,X){let J=Number.MAX_SAFE_INTEGER,fe=0;return H.forEach((_e,Se)=>{const Le=X(_e);Le<J&&(J=Le,fe=Se)}),fe}e.minIndex=B;function x(H,X){let J=Number.MIN_SAFE_INTEGER,fe=0;return H.forEach((_e,Se)=>{const Le=X(_e);Le>J&&(J=Le,fe=Se)}),fe}e.maxIndex=x;class j{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let J=this.firstIdx;for(;J<this.items.length&&X(this.items[J]);)J++;const fe=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,fe}takeFromEndWhile(X){let J=this.lastIdx;for(;J>=0&&X(this.items[J]);)J--;const fe=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,fe}}e.ArrayQueue=j}),define(me[74],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const I=this;let C=!1,R;return function(){return C||(C=!0,R=L.apply(I,arguments)),R}}e.once=m}),define(me[75],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(me[76],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function I(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=I;const C=Object.freeze([]);function R(){return C}L.empty=R;function*k(v){yield v}L.single=k;function D(v){return v||C}L.from=D;function A(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=A;function n(v){return v[Symbol.iterator]().next().value}L.first=n;function T(v,t){for(const r of v)if(t(r))return!0;return!1}L.some=T;function u(v,t){for(const r of v)if(t(r))return r}L.find=u;function*h(v,t){for(const r of v)t(r)&&(yield r)}L.filter=h;function*c(v,t){let r=0;for(const s of v)yield t(s,r++)}L.map=c;function*g(...v){for(const t of v)for(const r of t)yield r}L.concat=g;function*_(v){for(const t of v)for(const r of t)yield r}L.concatNested=_;function P(v,t,r){let s=r;for(const i of v)s=t(s,i);return s}L.reduce=P;function*E(v,t,r=v.length){for(t<0&&(t+=v.length),r<0?r+=v.length:r>v.length&&(r=v.length);t<r;t++)yield v[t]}L.slice=E;function o(v,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,v];const s=v[Symbol.iterator]();for(let i=0;i<t;i++){const l=s.next();if(l.done)return[r,L.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return s}}]}L.consume=o;function a(v,t,r=(s,i)=>s===i){const s=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const l=s.next(),d=i.next();if(l.done!==d.done)return!1;if(l.done)return!0;if(!r(l.value,d.value))return!1}}L.equals=a})(m=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function R(t,r=!1){let s=0,i=t.length,l="",d=0,f=16,w=0;function y(K){let M=0,U=0;for(;M<K;){const O=t.charCodeAt(s);if(O>=48&&O<=57)U=U*16+O-48;else if(O>=65&&O<=70)U=U*16+O-65+10;else if(O>=97&&O<=102)U=U*16+O-97+10;else break;s++,M++}return M<K&&(U=-1),U}function p(K){s=K,l="",d=0,f=16,w=0}function S(){const K=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&A(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&A(t.charCodeAt(s)))for(s++;s<t.length&&A(t.charCodeAt(s));)s++;else return w=3,t.substring(K,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&A(t.charCodeAt(s))){for(s++;s<t.length&&A(t.charCodeAt(s));)s++;M=s}else w=3;return t.substring(K,M)}function b(){let K="",M=s;for(;;){if(s>=i){K+=t.substring(M,s),w=2;break}const U=t.charCodeAt(s);if(U===34){K+=t.substring(M,s),s++;break}if(U===92){if(K+=t.substring(M,s),s++,s>=i){w=2;break}switch(t.charCodeAt(s++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const $=y(4);$>=0?K+=String.fromCharCode($):w=4;break;default:w=5}M=s;continue}if(U>=0&&U<=31)if(D(U)){K+=t.substring(M,s),w=2;break}else w=6;s++}return K}function F(){if(l="",w=0,d=s,s>=i)return d=i,f=17;let K=t.charCodeAt(s);if(k(K)){do s++,l+=String.fromCharCode(K),K=t.charCodeAt(s);while(k(K));return f=15}if(D(K))return s++,l+=String.fromCharCode(K),K===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),f=14;switch(K){case 123:return s++,f=1;case 125:return s++,f=2;case 91:return s++,f=3;case 93:return s++,f=4;case 58:return s++,f=6;case 44:return s++,f=5;case 34:return s++,l=b(),f=10;case 47:const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!D(t.charCodeAt(s));)s++;return l=t.substring(M,s),f=12}if(t.charCodeAt(s+1)===42){s+=2;const U=i-1;let O=!1;for(;s<U;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,O=!0;break}s++}return O||(s++,w=1),l=t.substring(M,s),f=13}return l+=String.fromCharCode(K),s++,f=16;case 45:if(l+=String.fromCharCode(K),s++,s===i||!A(t.charCodeAt(s)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=S(),f=11;default:for(;s<i&&N(K);)s++,K=t.charCodeAt(s);if(d!==s){switch(l=t.substring(d,s),l){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return l+=String.fromCharCode(K),s++,f=16}}function N(K){if(k(K)||D(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let K;do K=F();while(K>=12&&K<=15);return K}return{setPosition:p,getPosition:()=>s,scan:r?G:F,getToken:()=>f,getTokenValue:()=>l,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>w}}e.createScanner=R;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function A(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function T(t,r){const s=[],i=new Object;let l;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function w(y,p,S,b){d.value=y,d.offset=p,d.length=S,d.type=b,d.colonOffset=void 0,l=d}try{o(t,{onObjectBegin:(y,p)=>{if(r<=y)throw i;l=void 0,f=r>y,s.push("")},onObjectProperty:(y,p,S)=>{if(r<p||(w(y,p,S,"property"),s[s.length-1]=y,r<=p+S))throw i},onObjectEnd:(y,p)=>{if(r<=y)throw i;l=void 0,s.pop()},onArrayBegin:(y,p)=>{if(r<=y)throw i;l=void 0,s.push(0)},onArrayEnd:(y,p)=>{if(r<=y)throw i;l=void 0,s.pop()},onLiteralValue:(y,p,S)=>{if(r<p||(w(y,p,S,v(y)),r<=p+S))throw i},onSeparator:(y,p,S)=>{if(r<=p)throw i;if(y===":"&&l&&l.type==="property")l.colonOffset=p,f=!1,l=void 0;else if(y===","){const b=s[s.length-1];typeof b=="number"?s[s.length-1]=b+1:(f=!0,s[s.length-1]=""),l=void 0}}})}catch(y){if(y!==i)throw y}return{path:s,previousNode:l,isAtPropertyKey:f,matches:y=>{let p=0;for(let S=0;p<y.length&&S<s.length;S++)if(y[p]===s[S]||y[p]==="*")p++;else if(y[p]!=="**")return!1;return p===y.length}}}e.getLocation=T;function u(t,r=[],s=C.DEFAULT){let i=null,l=[];const d=[];function f(y){Array.isArray(l)?l.push(y):i!==null&&(l[i]=y)}return o(t,{onObjectBegin:()=>{const y={};f(y),d.push(l),l=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{l=d.pop()},onArrayBegin:()=>{const y=[];f(y),d.push(l),l=y,i=null},onArrayEnd:()=>{l=d.pop()},onLiteralValue:f,onError:(y,p,S)=>{r.push({error:y,offset:p,length:S})}},s),l[0]}e.parse=u;function h(t,r=[],s=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function d(y){return i.children.push(y),y}o(t,{onObjectBegin:y=>{i=d({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,p,S)=>{i=d({type:"property",offset:p,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:p,length:S,parent:i})},onObjectEnd:(y,p)=>{i.length=y+p-i.offset,i=i.parent,l(y+p)},onArrayBegin:(y,p)=>{i=d({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,p)=>{i.length=y+p-i.offset,i=i.parent,l(y+p)},onLiteralValue:(y,p,S)=>{d({type:v(y),offset:p,length:S,parent:i,value:y}),l(p+S)},onSeparator:(y,p,S)=>{i.type==="property"&&(y===":"?i.colonOffset=p:y===","&&l(p))},onError:(y,p,S)=>{r.push({error:y,offset:p,length:S})}},s);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=h;function c(t,r){if(!t)return;let s=t;for(let i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===i){s=d.children[1],l=!0;break}if(!l)return}else{const l=i;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=c;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=g;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=_(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function P(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=P;function E(t,r,s=!1){if(P(t,r,s)){const i=t.children;if(Array.isArray(i))for(let l=0;l<i.length&&i[l].offset<=r;l++){const d=E(i[l],r,s);if(d)return d}return t}}e.findNodeAtOffset=E;function o(t,r,s=C.DEFAULT){const i=R(t,!1);function l(J){return J?()=>J(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(J){return J?fe=>J(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const f=l(r.onObjectBegin),w=d(r.onObjectProperty),y=l(r.onObjectEnd),p=l(r.onArrayBegin),S=l(r.onArrayEnd),b=d(r.onLiteralValue),F=d(r.onSeparator),N=l(r.onComment),G=d(r.onError),K=s&&s.disallowComments,M=s&&s.allowTrailingComma;function U(){for(;;){const J=i.scan();switch(i.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:K||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(J){case 12:case 13:K?O(10):N();break;case 16:O(1);break;case 15:case 14:break;default:return J}}}function O(J,fe=[],_e=[]){if(G(J),fe.length+_e.length>0){let Se=i.getToken();for(;Se!==17;){if(fe.indexOf(Se)!==-1){U();break}else if(_e.indexOf(Se)!==-1)break;Se=U()}}}function $(J){const fe=i.getTokenValue();return J?b(fe):w(fe),U(),!0}function B(){switch(i.getToken()){case 11:let J=0;try{J=JSON.parse(i.getTokenValue()),typeof J!="number"&&(O(2),J=0)}catch(fe){O(2)}b(J);break;case 7:b(null);break;case 8:b(!0);break;case 9:b(!1);break;default:return!1}return U(),!0}function x(){return i.getToken()!==10?(O(3,[],[2,5]),!1):($(!1),i.getToken()===6?(F(":"),U(),X()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function j(){f(),U();let J=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(J||O(4,[],[]),F(","),U(),i.getToken()===2&&M)break}else J&&O(6,[],[]);x()||O(4,[],[2,5]),J=!0}return y(),i.getToken()!==2?O(7,[2],[]):U(),!0}function H(){p(),U();let J=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(J||O(4,[],[]),F(","),U(),i.getToken()===4&&M)break}else J&&O(6,[],[]);X()||O(4,[],[4,5]),J=!0}return S(),i.getToken()!==4?O(8,[4],[]):U(),!0}function X(){switch(i.getToken()){case 3:return H();case 1:return j();case 10:return $(!0);default:return B()}}return U(),i.getToken()===17?s.allowEmptyContent?!0:(O(4,[],[]),!1):X()?(i.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.visit=o;function a(t,r){let s=R(t),i=[],l,d=0,f;do switch(f=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:d!==f&&i.push(t.substring(d,f)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),d=s.getPosition();break}while(l!==17);return i.join("")}e.stripComments=a;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(me[138],ge([0,1,57]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(D,A,n){let T,u,h,c,g;if(A){for(c=A.offset,g=c+A.length,h=c;h>0&&!k(D,h-1);)h--;let d=g;for(;d<D.length&&!k(D,d);)d++;u=D.substring(h,d),T=C(u,n)}else u=D,T=0,h=0,c=0,g=D.length;const _=R(n,D);let P=!1,E=0,o;n.insertSpaces?o=I(" ",n.tabSize||4):o="	";const a=(0,m.createScanner)(u,!1);let v=!1;function t(){return _+I(o,T+E)}function r(){let d=a.scan();for(P=!1;d===15||d===14;)P=P||d===14,d=a.scan();return v=d===16||a.getTokenError()!==0,d}const s=[];function i(d,f,w){!v&&f<g&&w>c&&D.substring(f,w)!==d&&s.push({offset:f,length:w-f,content:d})}let l=r();if(l!==17){const d=a.getTokenOffset()+h,f=I(o,T);i(f,h,d)}for(;l!==17;){let d=a.getTokenOffset()+a.getTokenLength()+h,f=r(),w="";for(;!P&&(f===12||f===13);){const p=a.getTokenOffset()+h;i(" ",d,p),d=a.getTokenOffset()+a.getTokenLength()+h,w=f===12?t():"",f=r()}if(f===2)l!==1&&(E--,w=t());else if(f===4)l!==3&&(E--,w=t());else{switch(l){case 3:case 1:E++,w=t();break;case 5:case 12:w=t();break;case 13:P?w=t():w=" ";break;case 6:w=" ";break;case 10:if(f===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?w=" ":f!==5&&f!==17&&(v=!0);break;case 16:v=!0;break}P&&(f===12||f===13)&&(w=t())}const y=a.getTokenOffset()+h;i(w,d,y),l=f}return s}e.format=L;function I(D,A){let n="";for(let T=0;T<A;T++)n+=D;return n}function C(D,A){let n=0,T=0;const u=A.tabSize||4;for(;n<D.length;){const h=D.charAt(n);if(h===" ")T++;else if(h==="	")T+=u;else break;n++}return Math.floor(T/u)}function R(D,A){for(let n=0;n<A.length;n++){const T=A.charAt(n);if(T==="\r")return n+1<A.length&&A.charAt(n+1)===`
`?`\r
`:"\r";if(T===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=R;function k(D,A){return`\r
`.indexOf(D.charAt(A))!==-1}e.isEOL=k}),define(me[139],ge([0,1,57,138]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(A,n,T){return C(A,n,void 0,T)}e.removeProperty=I;function C(A,n,T,u,h){const c=n.slice(),g=[],_=(0,m.parseTree)(A,g);let P,E;for(;c.length>0&&(E=c.pop(),P=(0,m.findNodeAtLocation)(_,c),P===void 0&&T!==void 0);)typeof E=="string"?T={[E]:T}:T=[T];if(P)if(P.type==="object"&&typeof E=="string"&&Array.isArray(P.children)){const o=(0,m.findNodeAtLocation)(P,[E]);if(o!==void 0)if(T===void 0){if(!o.parent)throw new Error("Malformed AST");const a=P.children.indexOf(o.parent);let v,t=o.parent.offset+o.parent.length;if(a>0){const r=P.children[a-1];v=r.offset+r.length}else v=P.offset+1,P.children.length>1&&(t=P.children[1].offset);return R(A,{offset:v,length:t-v,content:""},u)}else return R(A,{offset:o.offset,length:o.length,content:JSON.stringify(T)},u);else{if(T===void 0)return[];const a=`${JSON.stringify(E)}: ${JSON.stringify(T)}`,v=h?h(P.children.map(r=>r.children[0].value)):P.children.length;let t;if(v>0){const r=P.children[v-1];t={offset:r.offset+r.length,length:0,content:","+a}}else P.children.length===0?t={offset:P.offset+1,length:0,content:a}:t={offset:P.offset+1,length:0,content:a+","};return R(A,t,u)}}else if(P.type==="array"&&typeof E=="number"&&Array.isArray(P.children))if(T!==void 0){const o=`${JSON.stringify(T)}`;let a;if(P.children.length===0||E===0)a={offset:P.offset+1,length:0,content:P.children.length===0?o:o+","};else{const v=E===-1||E>P.children.length?P.children.length:E,t=P.children[v-1];a={offset:t.offset+t.length,length:0,content:","+o}}return R(A,a,u)}else{const o=E,a=P.children[o];let v;if(P.children.length===1)v={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===o){const t=P.children[o-1],r=t.offset+t.length,s=P.offset+P.length;v={offset:r,length:s-2-r,content:""}}else v={offset:a.offset,length:P.children[o+1].offset-a.offset,content:""};return R(A,v,u)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${P.type}`);else{if(T===void 0)throw new Error("Can not delete in empty document");return R(A,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(T)},u)}}e.setProperty=C;function R(A,n,T){let u=k(A,n),h=n.offset,c=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;h>0&&!(0,L.isEOL)(u,h-1);)h--;for(;c<u.length&&!(0,L.isEOL)(u,c);)c++}const g=(0,L.format)(u,{offset:h,length:c-h},T);for(let P=g.length-1;P>=0;P--){const E=g[P];u=k(u,E),h=Math.min(h,E.offset),c=Math.max(c,E.offset+E.length),c+=E.content.length-E.length}const _=A.length-(u.length-c)-h;return[{offset:h,length:_,content:u.substring(h,c)}]}e.withFormatting=R;function k(A,n){return A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)}e.applyEdit=k;function D(A,n){let T=n.slice(0).sort((h,c)=>{const g=h.offset-c.offset;return g===0?h.length-c.length:g}),u=A.length;for(let h=T.length-1;h>=0;h--){let c=T[h];if(c.offset+c.length<=u)A=k(A,c);else throw new Error("Overlapping edit");u=c.offset}return A}e.applyEdits=D}),define(me[140],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new m(()=>I(this.getValue()))}}e.Lazy=m}),define(me[6],ge([0,1,74,76]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let C=null;function R(s){C=s}if(e.setDisposableTracker=R,I){const s="__is_disposable_tracked__";R(new class{trackDisposable(i){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(l)},3e3)}setParent(i,l){if(i&&i!==E.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function k(s){return C?.trackDisposable(s),s}function D(s){C?.markAsDisposed(s)}function A(s,i){C?.setParent(s,i)}function n(s,i){if(!!C)for(const l of s)C.setParent(l,i)}function T(s){return C?.markAsSingleton(s),s}e.markAsSingleton=T;class u extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=u;function h(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=h;function c(s){if(L.Iterable.is(s)){let i=[];for(const l of s)if(l)try{l.dispose()}catch(d){i.push(d)}if(i.length===1)throw i[0];if(i.length>1)throw new u(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=c;function g(...s){const i=_(()=>c(s));return n(s,i),i}e.combinedDisposable=g;function _(s){const i=k({dispose:(0,m.once)(()=>{D(i),s()})});return i}e.toDisposable=_;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return A(i,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new P,k(this),A(this._store,this)}dispose(){D(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&A(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&A(i,null),i}}e.MutableDisposable=o;class a{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class v{constructor(){this.references=new Map}acquire(i,...l){let d=this.references.get(i);d||(d={counter:0,object:this.createReferencedObject(i,...l)},this.references.set(i,d));const{object:f}=d,w=(0,m.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(i,d.object),this.references.delete(i))});return d.counter++,{object:f,dispose:w}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...l){const d=this.referenceCollection.acquire(i,...l);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(f){throw d.dispose(),f}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(me[95],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const R=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=R}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,R){const k=new m(C);if(this._first===m.Undefined)this._first=k,this._last=k;else if(R){const A=this._last;this._last=k,k.prev=A,A.next=k}else{const A=this._first;this._first=k,k.next=A,A.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const R=C.prev;R.next=C.next,C.next.prev=R}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Re,ye){for(var Ce=0;Ce<ye.length;Ce++){var ne=ye[Ce];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Re,ne.key,ne)}}function e(Re,ye,Ce){return ye&&Z(Re.prototype,ye),Ce&&Z(Re,Ce),Re}function m(Re,ye){if(!!Re){if(typeof Re=="string")return L(Re,ye);var Ce=Object.prototype.toString.call(Re).slice(8,-1);if(Ce==="Object"&&Re.constructor&&(Ce=Re.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Re);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return L(Re,ye)}}function L(Re,ye){(ye==null||ye>Re.length)&&(ye=Re.length);for(var Ce=0,ne=new Array(ye);Ce<ye;Ce++)ne[Ce]=Re[Ce];return ne}function I(Re,ye){var Ce=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Ce)return(Ce=Ce.call(Re)).next.bind(Ce);if(Array.isArray(Re)||(Ce=m(Re))||ye&&Re&&typeof Re.length=="number"){Ce&&(Re=Ce);var ne=0;return function(){return ne>=Re.length?{done:!0}:{done:!1,value:Re[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){C.exports.defaults=Re}C.exports={defaults:R(),getDefaults:R,changeDefaults:k};var D=/[&<>"']/,A=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(ye){return u[ye]};function c(Re,ye){if(ye){if(D.test(Re))return Re.replace(A,h)}else if(n.test(Re))return Re.replace(T,h);return Re}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Re){return Re.replace(g,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var P=/(^|[^\[])\^/g;function E(Re,ye){Re=Re.source||Re,ye=ye||"";var Ce={replace:function(de,be){return be=be.source||be,be=be.replace(P,"$1"),Re=Re.replace(de,be),Ce},getRegex:function(){return new RegExp(Re,ye)}};return Ce}var o=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,ye,Ce){if(Re){var ne;try{ne=decodeURIComponent(_(Ce)).replace(o,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}ye&&!a.test(Ce)&&(Ce=l(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(de){return null}return Ce}var t={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Re,ye){t[" "+Re]||(r.test(Re)?t[" "+Re]=Re+"/":t[" "+Re]=y(Re,"/",!0)),Re=t[" "+Re];var Ce=Re.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:Re.replace(s,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:Re.replace(i,"$1")+ye:Re+ye}var d={exec:function(){}};function f(Re){for(var ye=1,Ce,ne;ye<arguments.length;ye++){Ce=arguments[ye];for(ne in Ce)Object.prototype.hasOwnProperty.call(Ce,ne)&&(Re[ne]=Ce[ne])}return Re}function w(Re,ye){var Ce=Re.replace(/\|/g,function(be,we,Fe){for(var qe=!1,He=we;--He>=0&&Fe[He]==="\\";)qe=!qe;return qe?"|":" |"}),ne=Ce.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>ye)ne.splice(ye);else for(;ne.length<ye;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function y(Re,ye,Ce){var ne=Re.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Re.charAt(ne-de-1);if(be===ye&&!Ce)de++;else if(be!==ye&&Ce)de++;else break}return Re.substr(0,ne-de)}function p(Re,ye){if(Re.indexOf(ye[1])===-1)return-1;for(var Ce=Re.length,ne=0,de=0;de<Ce;de++)if(Re[de]==="\\")de++;else if(Re[de]===ye[0])ne++;else if(Re[de]===ye[1]&&(ne--,ne<0))return de;return-1}function S(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(Re,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=Re),ye>>=1,Re+=Re;return Ce+Re}var F={escape:c,unescape:_,edit:E,cleanUrl:v,resolveUrl:l,noopTest:d,merge:f,splitCells:w,rtrim:y,findClosingBracket:p,checkSanitizeDeprecation:S,repeatString:b},N=C.exports.defaults,G=F.rtrim,K=F.splitCells,M=F.escape,U=F.findClosingBracket;function O(Re,ye,Ce,ne){var de=ye.href,be=ye.title?M(ye.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");return Re[0].charAt(0)!=="!"?(ne.state.inLink=!0,{type:"link",raw:Ce,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])}):{type:"image",raw:Ce,href:de,title:be,text:M(we)}}function $(Re,ye){var Ce=Re.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var ne=Ce[1];return ye.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var B=function(){function Re(Ce){this.options=Ce||N}var ye=Re.prototype;return ye.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},ye.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:G(be,`
`)}}},ye.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=$(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},ye.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=G(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ye.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},ye.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},ye.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Fe,qe,He,Je,nt,ae,Ee,ce,q=de[1].trim(),Te=q.length>1,Pe={type:"list",raw:"",ordered:Te,start:Te?+q.slice(0,-1):"",loose:!1,items:[]};q=Te?"\\d{1,9}\\"+q.slice(-1):"\\"+q,this.options.pedantic&&(q=Te?q:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+q+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ye.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(qe=2,ce=Ee[0].trimLeft()):(qe=de[2].search(/[^ ]/),qe=de[1].length+(qe>4?1:qe),ce=Ee[0].slice(qe-de[1].length)),Je=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Pe.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<Ee.length;He++){if(ae=Ee[He],this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(ae)){be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}if(!Je){ae.trim()||(Je=!0),ae.search(/[^ ]/)>=qe?ce+=`
`+ae.slice(qe):ce+=`
`+ae;continue}if(ae.search(/[^ ]/)>=qe||!ae.trim()){ce+=`
`+ae.slice(qe);continue}else{be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}}Pe.loose||(nt?Pe.loose=!0:/\n *\n *$/.test(be)&&(nt=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Fe=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:ce}),Pe.raw+=be,ne=ne.slice(be.length)}Pe.items[Pe.items.length-1].raw=be.trimRight(),Pe.items[Pe.items.length-1].text=ce.trimRight(),Pe.raw=Pe.raw.trimRight();var at=Pe.items.length;for(He=0;He<at;He++)this.lexer.state.top=!1,Pe.items[He].tokens=this.lexer.blockTokens(Pe.items[He].text,[]),Pe.items[He].tokens.some(function(wt){return wt.type==="space"})&&(Pe.loose=!0,Pe.items[He].loose=!0);return Pe}},ye.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):M(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},ye.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},ye.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:K(de[1]).map(function(nt){return{text:nt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Fe,qe,He,Je;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=K(be.rows[Fe],be.header.length).map(function(nt){return{text:nt}});for(we=be.header.length,qe=0;qe<we;qe++)be.header[qe].tokens=[],this.lexer.inlineTokens(be.header[qe].text,be.header[qe].tokens);for(we=be.rows.length,qe=0;qe<we;qe++)for(Je=be.rows[qe],He=0;He<Je.length;He++)Je[He].tokens=[],this.lexer.inlineTokens(Je[He].text,Je[He].tokens);return be}}},ye.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:M(de[1])}},ye.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):M(de[0]):de[0]}},ye.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=G(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=U(de[2],"()");if(Fe>-1){var qe=de[0].indexOf("!")===0?5:4,He=qe+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Je=de[2],nt="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Je);ae&&(Je=ae[1],nt=ae[3])}else nt=de[3]?de[3].slice(1,-1):"";return Je=Je.trim(),/^</.test(Je)&&(this.options.pedantic&&!/>$/.test(be)?Je=Je.slice(1):Je=Je.slice(1,-1)),O(de,{href:Je&&Je.replace(this.rules.inline._escapes,"$1"),title:nt&&nt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ye.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O(be,we,be[0],this.lexer)}},ye.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var qe=we[0].length-1,He,Je,nt=qe,ae=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+qe);(we=Ee.exec(de))!=null;)if(He=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!He){if(Je=He.length,we[3]||we[4]){nt+=Je;continue}else if((we[5]||we[6])&&qe%3&&!((qe+Je)%3)){ae+=Je;continue}if(nt-=Je,!(nt>0)){if(Je=Math.min(Je,Je+nt+ae),Math.min(qe,Je)%2){var ce=ne.slice(1,qe+we.index+Je);return{type:"em",raw:ne.slice(0,qe+we.index+Je+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var q=ne.slice(2,qe+we.index+Je-1);return{type:"strong",raw:ne.slice(0,qe+we.index+Je+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}}}}},ye.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=M(be,!0),{type:"codespan",raw:de[0],text:be}}},ye.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},ye.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},ye.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Fe;return be[2]==="@"?(we=M(this.options.mangle?de(be[1]):be[1]),Fe="mailto:"+we):(we=M(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ye.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Fe;if(be[2]==="@")we=M(this.options.mangle?de(be[0]):be[0]),Fe="mailto:"+we;else{var qe;do qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(qe!==be[0]);we=M(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ye.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):M(be[0]):be[0]:we=M(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),x=F.noopTest,j=F.edit,H=F.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:x,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=j(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=j(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=j(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=j(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=j(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=j(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=H({},X),X.gfm=H({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=j(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=H({},X.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:x,paragraph:j(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:x,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:x,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=j(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=j(X._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=j(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=j(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=j(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=j(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=j(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=j(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=j(J.reflink).replace("label",J._label).getRegex(),J.reflinkSearch=j(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=H({},J),J.pedantic=H({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=H({},J.normal,{escape:j(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),J.gfm.url=j(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=H({},J.gfm,{br:j(J.br).replace("{2,}","*").getRegex(),text:j(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:X,inline:J},_e=B,Se=C.exports.defaults,Le=fe.block,We=fe.inline,Ne=F.repeatString;function Ke(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Re){var ye="",Ce,ne,de=Re.length;for(Ce=0;Ce<de;Ce++)ne=Re.charCodeAt(Ce),Math.random()>.5&&(ne="x"+ne.toString(16)),ye+="&#"+ne+";";return ye}var ee=function(){function Re(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Se,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Le.normal,inline:We.normal};this.options.pedantic?(ne.block=Le.pedantic,ne.inline=We.pedantic):this.options.gfm&&(ne.block=Le.gfm,this.options.breaks?ne.inline=We.breaks:ne.inline=We.gfm),this.tokenizer.rules=ne}Re.lex=function(ne,de){var be=new Re(de);return be.lex(ne)},Re.lexInline=function(ne,de){var be=new Re(de);return be.inlineTokens(ne)};var ye=Re.prototype;return ye.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ye.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,qe,He;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(nt){return(we=nt.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(qe=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var nt=Infinity,ae=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ce){Ee=ce.call({lexer:this},ae),typeof Ee=="number"&&Ee>=0&&(nt=Math.min(nt,Ee))}),nt<Infinity&&nt>=0&&(qe=ne.substring(0,nt+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Fe=de[de.length-1],He&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we),He=qe.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(ne){var Je="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Je);break}else throw new Error(Je)}}return this.state.top=!0,de},ye.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},ye.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Fe,qe,He=ne,Je,nt,ae;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Je=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)Ee.includes(Je[0].slice(Je[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Je.index)+"["+Ne("a",Je[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Je=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Je.index)+"["+Ne("a",Je[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Je=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Je.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(nt||(ae=""),nt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(we=q.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,He,ae)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,z)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,z))){ne=ne.substring(we.raw.length),de.push(we);continue}if(qe=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var q=Infinity,Te=ne.slice(1),Pe=void 0;be.options.extensions.startInline.forEach(function(Ye){Pe=Ye.call({lexer:this},Te),typeof Pe=="number"&&Pe>=0&&(q=Math.min(q,Pe))}),q<Infinity&&q>=0&&(qe=ne.substring(0,q+1))}(),we=this.tokenizer.inlineText(qe,Ke)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(ae=we.raw.slice(-1)),nt=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(ne){var ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:Le,inline:We}}}]),Re}(),re=C.exports.defaults,le=F.cleanUrl,Y=F.escape,oe=function(){function Re(Ce){this.options=Ce||re}var ye=Re.prototype;return ye.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(be=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Y(we,!0)+'">'+(be?ne:Y(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:Y(ne,!0))+`</code></pre>
`},ye.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},ye.html=function(ne){return ne},ye.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ne,de,be){var we=de?"ol":"ul",Fe=de&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},ye.listitem=function(ne){return"<li>"+ne+`</li>
`},ye.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ne){return"<p>"+ne+`</p>
`},ye.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},ye.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},ye.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},ye.strong=function(ne){return"<strong>"+ne+"</strong>"},ye.em=function(ne){return"<em>"+ne+"</em>"},ye.codespan=function(ne){return"<code>"+ne+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ne){return"<del>"+ne+"</del>"},ye.link=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+Y(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},ye.image=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},ye.text=function(ne){return ne},Re}(),ve=function(){function Re(){}var ye=Re.prototype;return ye.strong=function(ne){return ne},ye.em=function(ne){return ne},ye.codespan=function(ne){return ne},ye.del=function(ne){return ne},ye.html=function(ne){return ne},ye.text=function(ne){return ne},ye.link=function(ne,de,be){return""+be},ye.image=function(ne,de,be){return""+be},ye.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var ye=Re.prototype;return ye.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},ye.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Re}(),je=oe,Qe=ve,et=Me,ke=C.exports.defaults,ct=F.unescape,Q=function(){function Re(Ce){this.options=Ce||ke,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Qe,this.slugger=new et}Re.parse=function(ne,de){var be=new Re(de);return be.parse(ne)},Re.parseInline=function(ne,de){var be=new Re(de);return be.parseInline(ne)};var ye=Re.prototype;return ye.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Fe,qe,He,Je,nt,ae,Ee,ce,q,Te,Pe,Ye,Xe,at,wt,_t,ht,gt,ft=ne.length;for(we=0;we<ft;we++){if(q=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(gt=this.options.extensions.renderers[q.type].call({parser:this},q),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){be+=gt||"";continue}switch(q.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(q.tokens),q.depth,ct(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(Ee="",ae="",He=q.header.length,Fe=0;Fe<He;Fe++)ae+=this.renderer.tablecell(this.parseInline(q.header[Fe].tokens),{header:!0,align:q.align[Fe]});for(Ee+=this.renderer.tablerow(ae),ce="",He=q.rows.length,Fe=0;Fe<He;Fe++){for(nt=q.rows[Fe],ae="",Je=nt.length,qe=0;qe<Je;qe++)ae+=this.renderer.tablecell(this.parseInline(nt[qe].tokens),{header:!1,align:q.align[qe]});ce+=this.renderer.tablerow(ae)}be+=this.renderer.table(Ee,ce);continue}case"blockquote":{ce=this.parse(q.tokens),be+=this.renderer.blockquote(ce);continue}case"list":{for(Te=q.ordered,Pe=q.start,Ye=q.loose,He=q.items.length,ce="",Fe=0;Fe<He;Fe++)at=q.items[Fe],wt=at.checked,_t=at.task,Xe="",at.task&&(ht=this.renderer.checkbox(wt),Ye?at.tokens.length>0&&at.tokens[0].type==="paragraph"?(at.tokens[0].text=ht+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=ht+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:ht}):Xe+=ht),Xe+=this.parse(at.tokens,Ye),ce+=this.renderer.listitem(Xe,_t,wt);be+=this.renderer.list(ce,Te,Pe);continue}case"html":{be+=this.renderer.html(q.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(ce=q.tokens?this.parseInline(q.tokens):q.text;we+1<ft&&ne[we+1].type==="text";)q=ne[++we],ce+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);be+=de?this.renderer.paragraph(ce):ce;continue}default:{var Tt='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Tt);return}else throw new Error(Tt)}}}return be},ye.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Fe,qe,He=ne.length;for(we=0;we<He;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=qe||"";continue}switch(Fe.type){case"escape":{be+=de.text(Fe.text);break}case"html":{be+=de.html(Fe.text);break}case"link":{be+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{be+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{be+=de.codespan(Fe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{be+=de.text(Fe.text);break}default:{var Je='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return be},Re}(),te=ee,pe=Q,ze=B,tt=oe,st=ve,lt=Me,vt=F.merge,Dt=F.checkSanitizeDeprecation,ue=F.escape,Ie=C.exports.getDefaults,Ue=C.exports.changeDefaults,Ge=C.exports.defaults;function $e(Re,ye,Ce){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=vt({},$e.defaults,ye||{}),Dt(ye),Ce){var ne=ye.highlight,de;try{de=te.lex(Re,ye)}catch(qe){return Ce(qe)}var be=function(He){var Je;if(!He)try{ye.walkTokens&&$e.walkTokens(de,ye.walkTokens),Je=pe.parse(de,ye)}catch(nt){He=nt}return ye.highlight=ne,He?Ce(He):Ce(null,Je)};if(!ne||ne.length<3||(delete ye.highlight,!de.length))return be();var we=0;$e.walkTokens(de,function(qe){qe.type==="code"&&(we++,setTimeout(function(){ne(qe.text,qe.lang,function(He,Je){if(He)return be(He);Je!=null&&Je!==qe.text&&(qe.text=Je,qe.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=te.lex(Re,ye);return ye.walkTokens&&$e.walkTokens(Fe,ye.walkTokens),pe.parse(Fe,ye)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ue(qe.message+"",!0)+"</pre>";throw qe}}$e.options=$e.setOptions=function(Re){return vt($e.defaults,Re),Ue($e.defaults),$e},$e.getDefaults=Ie,$e.defaults=Ge,$e.use=function(){for(var Re=this,ye=arguments.length,Ce=new Array(ye),ne=0;ne<ye;ne++)Ce[ne]=arguments[ne];var de=vt.apply(void 0,[{}].concat(Ce)),be=$e.defaults.extensions||{renderers:{},childTokens:{}},we;Ce.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Je=be.renderers?be.renderers[He.name]:null;Je?be.renderers[He.name]=function(){for(var nt=arguments.length,ae=new Array(nt),Ee=0;Ee<nt;Ee++)ae[Ee]=arguments[Ee];var ce=He.renderer.apply(this,ae);return ce===!1&&(ce=Je.apply(this,ae)),ce}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Fe.renderer&&function(){var He=$e.defaults.renderer||new tt,Je=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Te=new Array(q),Pe=0;Pe<q;Pe++)Te[Pe]=arguments[Pe];var Ye=Fe.renderer[Ee].apply(He,Te);return Ye===!1&&(Ye=ce.apply(He,Te)),Ye}};for(var nt in Fe.renderer)Je(nt);de.renderer=He}(),Fe.tokenizer&&function(){var He=$e.defaults.tokenizer||new ze,Je=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Te=new Array(q),Pe=0;Pe<q;Pe++)Te[Pe]=arguments[Pe];var Ye=Fe.tokenizer[Ee].apply(He,Te);return Ye===!1&&(Ye=ce.apply(He,Te)),Ye}};for(var nt in Fe.tokenizer)Je(nt);de.tokenizer=He}(),Fe.walkTokens){var qe=$e.defaults.walkTokens;de.walkTokens=function(He){Fe.walkTokens.call(Re,He),qe&&qe(He)}}we&&(de.extensions=be),$e.setOptions(de)})},$e.walkTokens=function(Re,ye){for(var Ce=function(){var we=de.value;switch(ye(we),we.type){case"table":{for(var Fe=I(we.header),qe;!(qe=Fe()).done;){var He=qe.value;$e.walkTokens(He.tokens,ye)}for(var Je=I(we.rows),nt;!(nt=Je()).done;)for(var ae=nt.value,Ee=I(ae),ce;!(ce=Ee()).done;){var q=ce.value;$e.walkTokens(q.tokens,ye)}break}case"list":{$e.walkTokens(we.items,ye);break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[we.type]?$e.defaults.extensions.childTokens[we.type].forEach(function(Te){$e.walkTokens(we[Te],ye)}):we.tokens&&$e.walkTokens(we.tokens,ye)}},ne=I(Re),de;!(de=ne()).done;)Ce()},$e.parseInline=function(Re,ye){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");ye=vt({},$e.defaults,ye||{}),Dt(ye);try{var Ce=te.lexInline(Re,ye);return ye.walkTokens&&$e.walkTokens(Ce,ye.walkTokens),pe.parseInline(Ce,ye)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ue(ne.message+"",!0)+"</pre>";throw ne}},$e.Parser=pe,$e.parser=pe.parse,$e.Renderer=tt,$e.TextRenderer=st,$e.Lexer=te,$e.lexer=te.lex,$e.Tokenizer=ze,$e.Slugger=lt,$e.parse=$e;var ot=$e;return ot}),define(me[77],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(R,k,D){return Math.min(Math.max(R,k),D)}e.clamp=m;function L(R,k){return(k+R%k)%k}e.rot=L;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Z(I){const C=[];typeof I=="number"&&C.push("code/timeOrigin",I);function R(D){C.push(D,Date.now())}function k(){const D=[];for(let A=0;A<C.length;A+=2)D.push({name:C[A],startTime:C[A+1]});return D}return{mark:R,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))C.push({name:R.name,startTime:Math.round(I+R.startTime)});return C}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function m(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(me[11],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,I=!1,C=!1,R=!1,k=!1,D=!1,A=!1,n,T=m,u,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const g=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=g&&c?.sandboxed,typeof navigator=="object"&&!g)h=navigator.userAgent,L=h.indexOf("Windows")>=0,I=h.indexOf("Macintosh")>=0,A=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=h.indexOf("Linux")>=0,D=!0,n=navigator.language,T=n;else if(typeof c=="object"){L=c.platform==="win32",I=c.platform==="darwin",C=c.platform==="linux",R=C&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,n=m,T=m;const s=c.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),l=i.availableLanguages["*"];n=i.locale,T=l||m,u=i._translationsConfigFile}catch(i){}k=!0}else console.error("Unable to resolve platform.");var _;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function P(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let E=0;I?E=1:L?E=3:C&&(E=2),e.isWindows=L,e.isMacintosh=I,e.isLinux=C,e.isLinuxSnap=R,e.isNative=k,e.isWeb=D,e.isIOS=A,e.platform=E,e.userAgent=h,e.language=T;var o;(function(s){function i(){return e.language}s.value=i;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function d(){return e.language==="en"}s.isDefault=d})(o=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=u,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let w=0,y=l.length;w<y;w++){const p=l[w];if(p.id===f.data.vscodeSetImmediateId){l.splice(w,1),p.callback();return}}});let d=0;return f=>{const w=++d;l.push({id:w,callback:f}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof c?.nextTick=="function")return c.nextTick.bind(c);const i=Promise.resolve();return l=>i.then(l)}();var a;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||A?2:L?1:3;let v=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,v=new Uint16Array(s.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=r}),define(me[34],ge([0,1,11]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const I=m.globals.vscode.process;L={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()},nextTick(C){return(0,m.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},nextTick(I){return(0,m.setImmediate)(I)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(me[8],ge([0,1,34]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,I=97,C=90,R=122,k=46,D=47,A=92,n=58,T=63;class u extends Error{constructor(a,v,t){let r;typeof v=="string"&&v.indexOf("not ")===0?(r="must not be",v=v.replace(/^not /,"")):r="must be";const s=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${s} ${r} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(o,a){if(typeof o!="string")throw new u(a,"string",o)}function c(o){return o===D||o===A}function g(o){return o===D}function _(o){return o>=L&&o<=C||o>=I&&o<=R}function P(o,a,v,t){let r="",s=0,i=-1,l=0,d=0;for(let f=0;f<=o.length;++f){if(f<o.length)d=o.charCodeAt(f);else{if(t(d))break;d=D}if(t(d)){if(!(i===f-1||l===1))if(l===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const w=r.lastIndexOf(v);w===-1?(r="",s=0):(r=r.slice(0,w),s=r.length-1-r.lastIndexOf(v)),i=f,l=0;continue}else if(r.length!==0){r="",s=0,i=f,l=0;continue}}a&&(r+=r.length>0?`${v}..`:"..",s=2)}else r.length>0?r+=`${v}${o.slice(i+1,f)}`:r=o.slice(i+1,f),s=f-i-1;i=f,l=0}else d===k&&l!==-1?++l:l=-1}return r}function E(o,a){if(a===null||typeof a!="object")throw new u("pathObject","Object",a);const v=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return v?v===a.root?`${v}${t}`:`${v}${o}${t}`:t}e.win32={resolve(...o){let a="",v="",t=!1;for(let r=o.length-1;r>=-1;r--){let s;if(r>=0){if(s=o[r],h(s,"path"),s.length===0)continue}else a.length===0?s=m.cwd():(s=m.env[`=${a}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===A)&&(s=`${a}\\`));const i=s.length;let l=0,d="",f=!1;const w=s.charCodeAt(0);if(i===1)c(w)&&(l=1,f=!0);else if(c(w))if(f=!0,c(s.charCodeAt(1))){let y=2,p=y;for(;y<i&&!c(s.charCodeAt(y));)y++;if(y<i&&y!==p){const S=s.slice(p,y);for(p=y;y<i&&c(s.charCodeAt(y));)y++;if(y<i&&y!==p){for(p=y;y<i&&!c(s.charCodeAt(y));)y++;(y===i||y!==p)&&(d=`\\\\${S}\\${s.slice(p,y)}`,l=y)}}}else l=1;else _(w)&&s.charCodeAt(1)===n&&(d=s.slice(0,2),l=2,i>2&&c(s.charCodeAt(2))&&(f=!0,l=3));if(d.length>0)if(a.length>0){if(d.toLowerCase()!==a.toLowerCase())continue}else a=d;if(t){if(a.length>0)break}else if(v=`${s.slice(l)}\\${v}`,t=f,f&&a.length>0)break}return v=P(v,!t,"\\",c),t?`${a}\\${v}`:`${a}${v}`||"."},normalize(o){h(o,"path");const a=o.length;if(a===0)return".";let v=0,t,r=!1;const s=o.charCodeAt(0);if(a===1)return g(s)?"\\":o;if(c(s))if(r=!0,c(o.charCodeAt(1))){let l=2,d=l;for(;l<a&&!c(o.charCodeAt(l));)l++;if(l<a&&l!==d){const f=o.slice(d,l);for(d=l;l<a&&c(o.charCodeAt(l));)l++;if(l<a&&l!==d){for(d=l;l<a&&!c(o.charCodeAt(l));)l++;if(l===a)return`\\\\${f}\\${o.slice(d)}\\`;l!==d&&(t=`\\\\${f}\\${o.slice(d,l)}`,v=l)}}}else v=1;else _(s)&&o.charCodeAt(1)===n&&(t=o.slice(0,2),v=2,a>2&&c(o.charCodeAt(2))&&(r=!0,v=3));let i=v<a?P(o.slice(v),!r,"\\",c):"";return i.length===0&&!r&&(i="."),i.length>0&&c(o.charCodeAt(a-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(o){h(o,"path");const a=o.length;if(a===0)return!1;const v=o.charCodeAt(0);return c(v)||a>2&&_(v)&&o.charCodeAt(1)===n&&c(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let a,v;for(let s=0;s<o.length;++s){const i=o[s];h(i,"path"),i.length>0&&(a===void 0?a=v=i:a+=`\\${i}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof v=="string"&&c(v.charCodeAt(0))){++r;const s=v.length;s>1&&c(v.charCodeAt(1))&&(++r,s>2&&(c(v.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&c(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(o,a){if(h(o,"from"),h(a,"to"),o===a)return"";const v=e.win32.resolve(o),t=e.win32.resolve(a);if(v===t||(o=v.toLowerCase(),a=t.toLowerCase(),o===a))return"";let r=0;for(;r<o.length&&o.charCodeAt(r)===A;)r++;let s=o.length;for(;s-1>r&&o.charCodeAt(s-1)===A;)s--;const i=s-r;let l=0;for(;l<a.length&&a.charCodeAt(l)===A;)l++;let d=a.length;for(;d-1>l&&a.charCodeAt(d-1)===A;)d--;const f=d-l,w=i<f?i:f;let y=-1,p=0;for(;p<w;p++){const b=o.charCodeAt(r+p);if(b!==a.charCodeAt(l+p))break;b===A&&(y=p)}if(p!==w){if(y===-1)return t}else{if(f>w){if(a.charCodeAt(l+p)===A)return t.slice(l+p+1);if(p===2)return t.slice(l+p)}i>w&&(o.charCodeAt(r+p)===A?y=p:p===2&&(y=3)),y===-1&&(y=0)}let S="";for(p=r+y+1;p<=s;++p)(p===s||o.charCodeAt(p)===A)&&(S+=S.length===0?"..":"\\..");return l+=y,S.length>0?`${S}${t.slice(l,d)}`:(t.charCodeAt(l)===A&&++l,t.slice(l,d))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const a=e.win32.resolve(o);if(a.length<=2)return o;if(a.charCodeAt(0)===A){if(a.charCodeAt(1)===A){const v=a.charCodeAt(2);if(v!==T&&v!==k)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(_(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===A)return`\\\\?\\${a}`;return o},dirname(o){h(o,"path");const a=o.length;if(a===0)return".";let v=-1,t=0;const r=o.charCodeAt(0);if(a===1)return c(r)?o:".";if(c(r)){if(v=t=1,c(o.charCodeAt(1))){let l=2,d=l;for(;l<a&&!c(o.charCodeAt(l));)l++;if(l<a&&l!==d){for(d=l;l<a&&c(o.charCodeAt(l));)l++;if(l<a&&l!==d){for(d=l;l<a&&!c(o.charCodeAt(l));)l++;if(l===a)return o;l!==d&&(v=t=l+1)}}}}else _(r)&&o.charCodeAt(1)===n&&(v=a>2&&c(o.charCodeAt(2))?3:2,t=v);let s=-1,i=!0;for(let l=a-1;l>=t;--l)if(c(o.charCodeAt(l))){if(!i){s=l;break}}else i=!1;if(s===-1){if(v===-1)return".";s=v}return o.slice(0,s)},basename(o,a){a!==void 0&&h(a,"ext"),h(o,"path");let v=0,t=-1,r=!0,s;if(o.length>=2&&_(o.charCodeAt(0))&&o.charCodeAt(1)===n&&(v=2),a!==void 0&&a.length>0&&a.length<=o.length){if(a===o)return"";let i=a.length-1,l=-1;for(s=o.length-1;s>=v;--s){const d=o.charCodeAt(s);if(c(d)){if(!r){v=s+1;break}}else l===-1&&(r=!1,l=s+1),i>=0&&(d===a.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=l))}return v===t?t=l:t===-1&&(t=o.length),o.slice(v,t)}for(s=o.length-1;s>=v;--s)if(c(o.charCodeAt(s))){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":o.slice(v,t)},extname(o){h(o,"path");let a=0,v=-1,t=0,r=-1,s=!0,i=0;o.length>=2&&o.charCodeAt(1)===n&&_(o.charCodeAt(0))&&(a=t=2);for(let l=o.length-1;l>=a;--l){const d=o.charCodeAt(l);if(c(d)){if(!s){t=l+1;break}continue}r===-1&&(s=!1,r=l+1),d===k?v===-1?v=l:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===t+1?"":o.slice(v,r)},format:E.bind(null,"\\"),parse(o){h(o,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return a;const v=o.length;let t=0,r=o.charCodeAt(0);if(v===1)return c(r)?(a.root=a.dir=o,a):(a.base=a.name=o,a);if(c(r)){if(t=1,c(o.charCodeAt(1))){let y=2,p=y;for(;y<v&&!c(o.charCodeAt(y));)y++;if(y<v&&y!==p){for(p=y;y<v&&c(o.charCodeAt(y));)y++;if(y<v&&y!==p){for(p=y;y<v&&!c(o.charCodeAt(y));)y++;y===v?t=y:y!==p&&(t=y+1)}}}}else if(_(r)&&o.charCodeAt(1)===n){if(v<=2)return a.root=a.dir=o,a;if(t=2,c(o.charCodeAt(2))){if(v===3)return a.root=a.dir=o,a;t=3}}t>0&&(a.root=o.slice(0,t));let s=-1,i=t,l=-1,d=!0,f=o.length-1,w=0;for(;f>=t;--f){if(r=o.charCodeAt(f),c(r)){if(!d){i=f+1;break}continue}l===-1&&(d=!1,l=f+1),r===k?s===-1?s=f:w!==1&&(w=1):s!==-1&&(w=-1)}return l!==-1&&(s===-1||w===0||w===1&&s===l-1&&s===i+1?a.base=a.name=o.slice(i,l):(a.name=o.slice(i,s),a.base=o.slice(i,l),a.ext=o.slice(s,l))),i>0&&i!==t?a.dir=o.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let a="",v=!1;for(let t=o.length-1;t>=-1&&!v;t--){const r=t>=0?o[t]:m.cwd();h(r,"path"),r.length!==0&&(a=`${r}/${a}`,v=r.charCodeAt(0)===D)}return a=P(a,!v,"/",g),v?`/${a}`:a.length>0?a:"."},normalize(o){if(h(o,"path"),o.length===0)return".";const a=o.charCodeAt(0)===D,v=o.charCodeAt(o.length-1)===D;return o=P(o,!a,"/",g),o.length===0?a?"/":v?"./":".":(v&&(o+="/"),a?`/${o}`:o)},isAbsolute(o){return h(o,"path"),o.length>0&&o.charCodeAt(0)===D},join(...o){if(o.length===0)return".";let a;for(let v=0;v<o.length;++v){const t=o[v];h(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(o,a){if(h(o,"from"),h(a,"to"),o===a||(o=e.posix.resolve(o),a=e.posix.resolve(a),o===a))return"";const v=1,t=o.length,r=t-v,s=1,i=a.length-s,l=r<i?r:i;let d=-1,f=0;for(;f<l;f++){const y=o.charCodeAt(v+f);if(y!==a.charCodeAt(s+f))break;y===D&&(d=f)}if(f===l)if(i>l){if(a.charCodeAt(s+f)===D)return a.slice(s+f+1);if(f===0)return a.slice(s+f)}else r>l&&(o.charCodeAt(v+f)===D?d=f:f===0&&(d=0));let w="";for(f=v+d+1;f<=t;++f)(f===t||o.charCodeAt(f)===D)&&(w+=w.length===0?"..":"/..");return`${w}${a.slice(s+d)}`},toNamespacedPath(o){return o},dirname(o){if(h(o,"path"),o.length===0)return".";const a=o.charCodeAt(0)===D;let v=-1,t=!0;for(let r=o.length-1;r>=1;--r)if(o.charCodeAt(r)===D){if(!t){v=r;break}}else t=!1;return v===-1?a?"/":".":a&&v===1?"//":o.slice(0,v)},basename(o,a){a!==void 0&&h(a,"ext"),h(o,"path");let v=0,t=-1,r=!0,s;if(a!==void 0&&a.length>0&&a.length<=o.length){if(a===o)return"";let i=a.length-1,l=-1;for(s=o.length-1;s>=0;--s){const d=o.charCodeAt(s);if(d===D){if(!r){v=s+1;break}}else l===-1&&(r=!1,l=s+1),i>=0&&(d===a.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=l))}return v===t?t=l:t===-1&&(t=o.length),o.slice(v,t)}for(s=o.length-1;s>=0;--s)if(o.charCodeAt(s)===D){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":o.slice(v,t)},extname(o){h(o,"path");let a=-1,v=0,t=-1,r=!0,s=0;for(let i=o.length-1;i>=0;--i){const l=o.charCodeAt(i);if(l===D){if(!r){v=i+1;break}continue}t===-1&&(r=!1,t=i+1),l===k?a===-1?a=i:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||t===-1||s===0||s===1&&a===t-1&&a===v+1?"":o.slice(a,t)},format:E.bind(null,"/"),parse(o){h(o,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return a;const v=o.charCodeAt(0)===D;let t;v?(a.root="/",t=1):t=0;let r=-1,s=0,i=-1,l=!0,d=o.length-1,f=0;for(;d>=t;--d){const w=o.charCodeAt(d);if(w===D){if(!l){s=d+1;break}continue}i===-1&&(l=!1,i=d+1),w===k?r===-1?r=d:f!==1&&(f=1):r!==-1&&(f=-1)}if(i!==-1){const w=s===0&&v?1:s;r===-1||f===0||f===1&&r===i-1&&r===s+1?a.base=a.name=o.slice(w,i):(a.name=o.slice(w,r),a.base=o.slice(w,i),a.ext=o.slice(r,i))}return s>0?a.dir=o.slice(0,s-1):v&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[141],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(C,...R){const k=R.reduce((n,T)=>(n[T]=!0,n),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(n=>!k[n]).forEach(n=>{for(let T=0;T<D.length;T++)if(n.search(D[T])!==-1){delete C[n];break}})}e.sanitizeProcessEnvironment=I}),define(me[46],ge([0,1,11]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class I{constructor(R){this._highResolution=L&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new I(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=I}),define(me[3],ge([0,1,16,74,6,95,46]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(o){o.None=()=>I.Disposable.None;function a(K){return(M,U=null,O)=>{let $=!1,B;return B=K(x=>{if(!$)return B?B.dispose():$=!0,M.call(U,x)},null,O),$&&B.dispose(),B}}o.once=a;function v(K,M){return d((U,O=null,$)=>K(B=>U.call(O,M(B)),null,$))}o.map=v;function t(K,M){return d((U,O=null,$)=>K(B=>{M(B),U.call(O,B)},null,$))}o.forEach=t;function r(K,M){return d((U,O=null,$)=>K(B=>M(B)&&U.call(O,B),null,$))}o.filter=r;function s(K){return K}o.signal=s;function i(...K){return(M,U=null,O)=>(0,I.combinedDisposable)(...K.map($=>$(B=>M.call(U,B),null,O)))}o.any=i;function l(K,M,U){let O=U;return v(K,$=>(O=M(O,$),O))}o.reduce=l;function d(K){let M;const U=new u({onFirstListenerAdd(){M=K(U.fire,U)},onLastListenerRemove(){M.dispose()}});return U.event}function f(K,M,U=100,O=!1,$){let B,x,j,H=0;const X=new u({leakWarningThreshold:$,onFirstListenerAdd(){B=K(J=>{H++,x=M(x,J),O&&!j&&(X.fire(x),x=void 0),clearTimeout(j),j=setTimeout(()=>{const fe=x;x=void 0,j=void 0,(!O||H>1)&&X.fire(fe),H=0},U)})},onLastListenerRemove(){B.dispose()}});return X.event}o.debounce=f;function w(K,M=(U,O)=>U===O){let U=!0,O;return r(K,$=>{const B=U||!M($,O);return U=!1,O=$,B})}o.latch=w;function y(K,M){return[o.filter(K,M),o.filter(K,U=>!M(U))]}o.split=y;function p(K,M=!1,U=[]){let O=U.slice(),$=K(j=>{O?O.push(j):x.fire(j)});const B=()=>{O&&O.forEach(j=>x.fire(j)),O=null},x=new u({onFirstListenerAdd(){$||($=K(j=>x.fire(j)))},onFirstListenerDidAdd(){O&&(M?setTimeout(B):B())},onLastListenerRemove(){$&&$.dispose(),$=null}});return x.event}o.buffer=p;class S{constructor(M){this.event=M}map(M){return new S(v(this.event,M))}forEach(M){return new S(t(this.event,M))}filter(M){return new S(r(this.event,M))}reduce(M,U){return new S(l(this.event,M,U))}latch(){return new S(w(this.event))}debounce(M,U=100,O=!1,$){return new S(f(this.event,M,U,O,$))}on(M,U,O){return this.event(M,U,O)}once(M,U,O){return a(this.event)(M,U,O)}}function b(K){return new S(K)}o.chain=b;function F(K,M,U=O=>O){const O=(...j)=>x.fire(U(...j)),$=()=>K.on(M,O),B=()=>K.removeListener(M,O),x=new u({onFirstListenerAdd:$,onLastListenerRemove:B});return x.event}o.fromNodeEventEmitter=F;function N(K,M,U=O=>O){const O=(...j)=>x.fire(U(...j)),$=()=>K.addEventListener(M,O),B=()=>K.removeEventListener(M,O),x=new u({onFirstListenerAdd:$,onLastListenerRemove:B});return x.event}o.fromDOMEventEmitter=N;function G(K){return new Promise(M=>a(K)(M))}o.toPromise=G})(k=e.Event||(e.Event={}));class D{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${D._idPool++}`}start(a){this._stopWatch=new R.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let A=-1;function n(o){const a=A;return A=o,{dispose(){A=a}}}e.setGlobalLeakWarningThreshold=n;class T{constructor(a,v=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let v=A;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||a<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let s,i=0;for(const[l,d]of this._stacks)(!s||i<d)&&(s=l,i=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${i}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class u{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=A>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(a,v,t)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(v?[a,v]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,v);const i=this._leakageMon?.check(this._listeners.size),l=(0,I.toDisposable)(()=>{i&&i(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof I.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(r){(0,m.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class h extends u{async fireAsync(a,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,a]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),i=[],l={...s,waitUntil:d=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(d=t(d,typeof r=="function"?r:r[0])),i.push(d)}};try{typeof r=="function"?r.call(void 0,l):r[0].call(r[1],l)}catch(d){(0,m.onUnexpectedError)(d);continue}Object.freeze(i),await Promise.allSettled(i).then(d=>{for(const f of d)f.status==="rejected"&&(0,m.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=h;class c extends u{constructor(a){super(a);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=c;class g extends c{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=g;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const v={event:a,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const r=this.events.indexOf(v);this.events.splice(r,1)};return(0,I.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(v=>this.emitter.fire(v))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class P{constructor(){this.buffers=[]}wrapEvent(a){return(v,t,r)=>a(s=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,s)):v.call(t,s)},void 0,r)}bufferEvents(a){const v=[];this.buffers.push(v);const t=a();return this.buffers.pop(),v.forEach(r=>r()),t}}e.EventBufferer=P;class E{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=I.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,D){const A=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(A)}}});var I;(function(k){function D(A){return A===k.None||A===k.Cancelled||A instanceof C?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(I=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=R}),define(me[47],ge([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(T){const u=this._icons.get(T.id);u?T.description?u.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new L;e.iconRegistry=I;function C(n,T){return new k(n,T)}e.registerCodicon=C;function R(n){return n?n.replace(/\$\((.*?)\)/g,(T,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=R;class k{constructor(T,u,h){this.id=T,this.definition=u,this.description=h,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(n,T){const u=["codicon","codicon-"+n];return T&&u.push("codicon-modifier-"+T),u}e.getClassNamesArray=D;var A;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function u(g){if(g instanceof k)return["codicon","codicon-"+g.id];const _=T.exec(g.id);if(!_)return u(k.error);let[,P,E]=_;const o=["codicon","codicon-"+P];return E&&o.push("codicon-modifier-"+E.substr(1)),o}n.asClassNameArray=u;function h(g){return u(g).join(" ")}n.asClassName=h;function c(g){return"."+u(g).join(".")}n.asCSSSelector=c})(A=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=I;function C(o){const a=o;return a?I(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function R(o,a){return new k(o,a)}e.newWriteableStream=R;class k{constructor(a,v){this.reducer=a,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(v=>v(a))}emitError(a){this.listeners.error.length===0?(0,m.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(v=>v(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,v){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(a,v){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(v);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(o,a){const v=[];let t;for(;(t=o.read())!==null;)v.push(t);return a(v)}e.consumeReadable=D;function A(o,a,v){const t=[];let r;for(;(r=o.read())!==null&&t.length<v;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return o.read()}}}e.peekReadable=A;function n(o,a){return new Promise((v,t)=>{const r=[];T(o,{onData:s=>{a&&r.push(s)},onError:s=>{a?t(s):v(void 0)},onEnd:()=>{v(a?a(r):void 0)}})})}e.consumeStream=n;function T(o,a){o.on("error",v=>a.onError(v)),o.on("end",()=>a.onEnd()),o.on("data",v=>a.onData(v))}e.listenStream=T;function u(o,a){return new Promise((v,t)=>{const r=new L.DisposableStore,s=[],i=f=>{if(s.push(f),s.length>a)return r.dispose(),o.pause(),v({stream:o,buffer:s,ended:!1})},l=f=>t(f),d=()=>v({stream:o,buffer:s,ended:!0});r.add((0,L.toDisposable)(()=>o.removeListener("error",l))),o.on("error",l),r.add((0,L.toDisposable)(()=>o.removeListener("end",d))),o.on("end",d),r.add((0,L.toDisposable)(()=>o.removeListener("data",i))),o.on("data",i)})}e.peekStream=u;function h(o,a){const v=R(a);return v.end(o),v}e.toStream=h;function c(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=c;function g(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.toReadable=g;function _(o,a,v){const t=R(v);return T(o,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function P(o,a,v){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?v([o,r]):o)}}}e.prefixedReadable=P;function E(o,a,v){let t=!1;const r=R(v);return T(a,{onData:s=>t?r.write(s):(t=!0,r.write(v([o,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(o)),r.end()}}),r}e.prefixedStream=E}),define(me[22],ge([0,1,96]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let I,C;class R{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new R(Buffer.allocUnsafe(i)):new R(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new R(i)}static fromString(i,l){return!(l?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(i)):(I||(I=new TextEncoder),new R(I.encode(i)))}static concat(i,l){if(typeof l=="undefined"){l=0;for(let w=0,y=i.length;w<y;w++)l+=i[w].byteLength}const d=R.alloc(l);let f=0;for(let w=0,y=i.length;w<y;w++){const p=i[w];d.set(p,f),f+=p.byteLength}return d}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,l){return new R(this.buffer.subarray(i,l))}set(i,l){i instanceof R?this.buffer.set(i.buffer,l):this.buffer.set(i,l)}readUInt32BE(i){return A(this.buffer,i)}writeUInt32BE(i,l){n(this.buffer,i,l)}readUInt32LE(i){return T(this.buffer,i)}writeUInt32LE(i,l){u(this.buffer,i,l)}readUInt8(i){return h(this.buffer,i)}writeUInt8(i,l){c(this.buffer,i,l)}}e.VSBuffer=R;function k(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0}e.readUInt16LE=k;function D(s,i,l){s[l+0]=i&255,i=i>>>8,s[l+1]=i&255}e.writeUInt16LE=D;function A(s,i){return s[i]*2**24+s[i+1]*2**16+s[i+2]*2**8+s[i+3]}e.readUInt32BE=A;function n(s,i,l){s[l+3]=i,i=i>>>8,s[l+2]=i,i=i>>>8,s[l+1]=i,i=i>>>8,s[l]=i}e.writeUInt32BE=n;function T(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0|s[i+2]<<16>>>0|s[i+3]<<24>>>0}e.readUInt32LE=T;function u(s,i,l){s[l+0]=i&255,i=i>>>8,s[l+1]=i&255,i=i>>>8,s[l+2]=i&255,i=i>>>8,s[l+3]=i&255}e.writeUInt32LE=u;function h(s,i){return s[i]}e.readUInt8=h;function c(s,i,l){s[l]=i}e.writeUInt8=c;function g(s){return m.consumeReadable(s,i=>R.concat(i))}e.readableToBuffer=g;function _(s){return m.toReadable(s)}e.bufferToReadable=_;function P(s){return m.consumeStream(s,i=>R.concat(i))}e.streamToBuffer=P;async function E(s){return s.ended?R.concat(s.buffer):R.concat([...s.buffer,await P(s.stream)])}e.bufferedStreamToBuffer=E;function o(s){return m.toStream(s,i=>R.concat(i))}e.bufferToStream=o;function a(s){return m.transform(s,{data:i=>typeof i=="string"?R.fromString(i):R.wrap(i)},i=>R.concat(i))}e.streamToBufferReadableStream=a;function v(s){return m.newWriteableStream(i=>R.concat(i),s)}e.newWriteableBufferStream=v;function t(s,i){return m.prefixedReadable(s,i,l=>R.concat(l))}e.prefixedBufferReadable=t;function r(s,i){return m.prefixedStream(s,i,l=>R.concat(l))}e.prefixedBufferStream=r}),define(me[9],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function I(ue,...Ie){return Ie.length===0?ue:ue.replace(L,function(Ue,Ge){const $e=parseInt(Ge,10);return isNaN($e)||$e<0||$e>=Ie.length?Ue:Ie[$e]})}e.format=I;const C=/{([^}]+)}/g;function R(ue,Ie){return ue.replace(C,(Ue,Ge)=>Ie[Ge]??Ue)}e.format2=R;function k(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=k;function D(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function A(ue,Ie){let Ue=0;const Ge=Ie.charCodeAt(0);for(let $e=ue.length-1;$e>=0;$e--)ue.charCodeAt($e)===Ge&&Ue++;return Ue}e.count=A;function n(ue,Ie,Ue="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Ue}`}e.truncate=n;function T(ue,Ie=" "){const Ue=u(ue,Ie);return h(Ue,Ie)}e.trim=T;function u(ue,Ie){if(!ue||!Ie)return ue;const Ue=Ie.length;if(Ue===0||ue.length===0)return ue;let Ge=0;for(;ue.indexOf(Ie,Ge)===Ge;)Ge=Ge+Ue;return ue.substring(Ge)}e.ltrim=u;function h(ue,Ie){if(!ue||!Ie)return ue;const Ue=Ie.length,Ge=ue.length;if(Ue===0||Ge===0)return ue;let $e=Ge,ot=-1;for(;ot=ue.lastIndexOf(Ie,$e-1),!(ot===-1||ot+Ue!==$e);){if(ot===0)return"";$e=ot}return ue.substring(0,$e)}e.rtrim=h;function c(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function g(ue){return ue.replace(/\*/g,"")}e.stripWildcards=g;function _(ue,Ie,Ue={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=D(ue)),Ue.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Ge="";return Ue.global&&(Ge+="g"),Ue.matchCase||(Ge+="i"),Ue.multiline&&(Ge+="m"),Ue.unicode&&(Ge+="u"),new RegExp(ue,Ge)}e.createRegExp=_;function P(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function E(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function o(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=o;function a(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=a;function v(ue){for(let Ie=0,Ue=ue.length;Ie<Ue;Ie++){const Ge=ue.charCodeAt(Ie);if(Ge!==32&&Ge!==9)return Ie}return-1}e.firstNonWhitespaceIndex=v;function t(ue,Ie=0,Ue=ue.length){for(let Ge=Ie;Ge<Ue;Ge++){const $e=ue.charCodeAt(Ge);if($e!==32&&$e!==9)return ue.substring(Ie,Ge)}return ue.substring(Ie,Ue)}e.getLeadingWhitespace=t;function r(ue,Ie=ue.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Ge=ue.charCodeAt(Ue);if(Ge!==32&&Ge!==9)return Ue}return-1}e.lastNonWhitespaceIndex=r;function s(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=s;function i(ue,Ie,Ue=0,Ge=ue.length,$e=0,ot=Ie.length){for(;Ue<Ge&&$e<ot;Ue++,$e++){let Ce=ue.charCodeAt(Ue),ne=Ie.charCodeAt($e);if(Ce<ne)return-1;if(Ce>ne)return 1}const Re=Ge-Ue,ye=ot-$e;return Re<ye?-1:Re>ye?1:0}e.compareSubstring=i;function l(ue,Ie){return d(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=l;function d(ue,Ie,Ue=0,Ge=ue.length,$e=0,ot=Ie.length){for(;Ue<Ge&&$e<ot;Ue++,$e++){let Ce=ue.charCodeAt(Ue),ne=Ie.charCodeAt($e);if(Ce===ne)continue;const de=Ce-ne;if(!(de===32&&w(ne))&&!(de===-32&&w(Ce)))return f(Ce)&&f(ne)?de:i(ue.toLowerCase(),Ie.toLowerCase(),Ue,Ge,$e,ot)}const Re=Ge-Ue,ye=ot-$e;return Re<ye?-1:Re>ye?1:0}e.compareSubstringIgnoreCase=d;function f(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=f;function w(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=w;function y(ue){return f(ue)||w(ue)}function p(ue,Ie){return ue.length===Ie.length&&S(ue,Ie)}e.equalsIgnoreCase=p;function S(ue,Ie,Ue=ue.length){for(let Ge=0;Ge<Ue;Ge++){const $e=ue.charCodeAt(Ge),ot=Ie.charCodeAt(Ge);if($e!==ot){if(y($e)&&y(ot)){const Re=Math.abs($e-ot);if(Re!==0&&Re!==32)return!1}else if(String.fromCharCode($e).toLowerCase()!==String.fromCharCode(ot).toLowerCase())return!1}}return!0}function b(ue,Ie){const Ue=Ie.length;return Ie.length>ue.length?!1:S(ue,Ie,Ue)}e.startsWithIgnoreCase=b;function F(ue,Ie){let Ue,Ge=Math.min(ue.length,Ie.length);for(Ue=0;Ue<Ge;Ue++)if(ue.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Ge}e.commonPrefixLength=F;function N(ue,Ie){let Ue,Ge=Math.min(ue.length,Ie.length);const $e=ue.length-1,ot=Ie.length-1;for(Ue=0;Ue<Ge;Ue++)if(ue.charCodeAt($e-Ue)!==Ie.charCodeAt(ot-Ue))return Ue;return Ge}e.commonSuffixLength=N;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function K(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=K;function M(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=M;function U(ue,Ie,Ue){const Ge=ue.charCodeAt(Ue);if(G(Ge)&&Ue+1<Ie){const $e=ue.charCodeAt(Ue+1);if(K($e))return M(Ge,$e)}return Ge}e.getNextCodePoint=U;function O(ue,Ie){const Ue=ue.charCodeAt(Ie-1);if(K(Ue)&&Ie>1){const Ge=ue.charCodeAt(Ie-2);if(G(Ge))return M(Ge,Ue)}return Ue}function $(ue,Ie){const Ue=pe.getInstance(),Ge=Ie,$e=ue.length,ot=U(ue,$e,Ie);Ie+=ot>=65536?2:1;let Re=Ue.getGraphemeBreakType(ot);for(;Ie<$e;){const ye=U(ue,$e,Ie),Ce=Ue.getGraphemeBreakType(ye);if(Q(Re,Ce))break;Ie+=ye>=65536?2:1,Re=Ce}return Ie-Ge}e.nextCharLength=$;function B(ue,Ie){const Ue=pe.getInstance(),Ge=Ie,$e=O(ue,Ie);Ie-=$e>=65536?2:1;let ot=Ue.getGraphemeBreakType($e);for(;Ie>0;){const Re=O(ue,Ie),ye=Ue.getGraphemeBreakType(Re);if(Q(ye,ot))break;Ie-=Re>=65536?2:1,ot=ye}return Ge-Ie}e.prevCharLength=B;function x(ue,Ie){const Ue=pe.getInstance(),Ge=ue.length,$e=Ie,ot=U(ue,Ge,Ie),Re=Ue.getGraphemeBreakType(ot);Ie+=ot>=65536?2:1;let ye=Re;for(;Ie<Ge;){const ne=U(ue,Ge,Ie),de=Ue.getGraphemeBreakType(ne);if(Q(ye,de))break;Ie+=ne>=65536?2:1,ye=de}const Ce=Ie;for(Ie=$e,ye=Re;Ie>0;){const ne=O(ue,Ie),de=Ue.getGraphemeBreakType(ne);if(Q(de,ye))break;Ie-=ne>=65536?2:1,ye=de}return[Ie,Ce]}function j(ue,Ie){return Ie>0&&K(ue.charCodeAt(Ie))?x(ue,Ie-1):x(ue,Ie)}e.getCharContainingOffset=j;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(ue){return H.test(ue)}e.containsRTL=X;const J=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function fe(ue){return J.test(ue)}e.containsEmoji=fe;const _e=/^[\t\n\r\x20-\x7E]*$/;function Se(ue){return _e.test(ue)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=Le;function We(ue){for(let Ie=0,Ue=ue.length;Ie<Ue;Ie++)if(Ne(ue.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=We;function Ne(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=Ne;function Ke(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129750}e.isEmojiImprecise=Ke;function z(ue,Ie){if(ue.length<Ie)return ue;const Ue=/\b/g;let Ge=0;for(;Ue.test(ue)&&!(ue.length-Ue.lastIndex<Ie);)Ge=Ue.lastIndex,Ue.lastIndex+=1;return ue.substring(Ge).replace(/^\s/,"")}e.lcut=z;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function Y(ue){return ue&&(ue=ue.replace(ee,""),ue=ue.replace(re,""),ue=ue.replace(le,"")),ue}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function ve(ue){return oe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ve;function Me(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Ue=Ie.length,Ge=ue.toLowerCase();let $e=0,ot=-1;for(;$e<Ue;){const Re=Ge.indexOf(Ie[$e],ot+1);if(Re<0)return!1;ot=Re,$e++}return!0}e.fuzzyContains=Me;function je(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=je;function Qe(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Qe;function et(ue,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=ue.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?ue:(ue[Ue-1]==="\r"&&Ue--,ue.substr(0,Ue))}e.getNLines=et;function ke(ue){const Ie=90-65+1;return ue=ue%(2*Ie),ue<Ie?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ie)}e.singleLetterHash=ke;function ct(ue){return pe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=ct;function Q(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}e.breakBetweenGraphemeBreakType=Q;var te;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=ze()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Ge=Ue.length/3;let $e=1;for(;$e<=Ge;)if(Ie<Ue[3*$e])$e=2*$e;else if(Ie>Ue[3*$e+1])$e=2*$e+1;else return Ue[3*$e+2];return 0}}pe._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(ue,Ie){if(ue===0)return 0;const Ue=st(ue,Ie);if(Ue!==void 0)return Ue;const Ge=O(Ie,ue);return ue-=lt(Ge),ue}e.getLeftDeleteOffset=tt;function st(ue,Ie){let Ue=O(Ie,ue);for(ue-=lt(Ue);vt(Ue)||Ue===65039||Ue===8419;){if(ue===0)return;Ue=O(Ie,ue),ue-=lt(Ue)}if(!!Ke(Ue)){if(ue>=0){const Ge=O(Ie,ue);Ge===8205&&(ue-=lt(Ge))}return ue}}function lt(ue){return ue>=65536?2:1}function vt(ue){return 127995<=ue&&ue<=127999}var Dt;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Dt||(Dt={}))}),define(me[58],ge([0,1,9]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(P){return I(P,0)}e.hash=L;function I(P,E){switch(typeof P){case"object":return P===null?C(349,E):Array.isArray(P)?D(P,E):A(P,E);case"string":return k(P,E);case"boolean":return R(P,E);case"number":return C(P,E);case"undefined":return C(937,E);default:return C(617,E)}}e.doHash=I;function C(P,E){return(E<<5)-E+P|0}function R(P,E){return C(P?433:863,E)}function k(P,E){E=C(149417,E);for(let o=0,a=P.length;o<a;o++)E=C(P.charCodeAt(o),E);return E}e.stringHash=k;function D(P,E){return E=C(104579,E),P.reduce((o,a)=>I(a,o),E)}function A(P,E){return E=C(181387,E),Object.keys(P).sort().reduce((o,a)=>(o=k(a,o),I(P[a],o)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=I(E,this._value),this._value}}e.Hasher=n;var T;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function u(P,E,o=32){const a=o-E,v=~((1<<a)-1);return(P<<E|(v&P)>>>a)>>>0}function h(P,E=0,o=P.byteLength,a=0){for(let v=0;v<o;v++)P[E+v]=a}function c(P,E,o="0"){for(;P.length<E;)P=o+P;return P}function g(P,E=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(o=>o.toString(16).padStart(2,"0")).join(""):c((P>>>0).toString(16),E/4)}e.toHexString=g;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const o=E.length;if(o===0)return;const a=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=E.charCodeAt(0),s=0);;){let i=r;if(m.isHighSurrogate(r))if(s+1<o){const l=E.charCodeAt(s+1);m.isLowSurrogate(l)?(s++,i=m.computeCodePoint(r,l)):i=65533}else{t=r;break}else m.isLowSurrogate(r)&&(i=65533);if(v=this._push(a,v,i),s++,s<o)r=E.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(E,o,a){return a<128?E[o++]=a:a<2048?(E[o++]=192|(a&1984)>>>6,E[o++]=128|(a&63)>>>0):a<65536?(E[o++]=224|(a&61440)>>>12,E[o++]=128|(a&4032)>>>6,E[o++]=128|(a&63)>>>0):(E[o++]=240|(a&1835008)>>>18,E[o++]=128|(a&258048)>>>12,E[o++]=128|(a&4032)>>>6,E[o++]=128|(a&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=_._bigBlock32,o=this._buffDV;for(let f=0;f<64;f+=4)E.setUint32(f,o.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)E.setUint32(f,u(E.getUint32(f-12,!1)^E.getUint32(f-32,!1)^E.getUint32(f-56,!1)^E.getUint32(f-64,!1),1),!1);let a=this._h0,v=this._h1,t=this._h2,r=this._h3,s=this._h4,i,l,d;for(let f=0;f<80;f++)f<20?(i=v&t|~v&r,l=1518500249):f<40?(i=v^t^r,l=1859775393):f<60?(i=v&t|v&r|t&r,l=2400959708):(i=v^t^r,l=3395469782),d=u(a,5)+i+s+l+E.getUint32(f*4,!1)&4294967295,s=r,r=t,t=u(v,30),v=a,a=d;this._h0=this._h0+a&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[48],ge([0,1,9]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(L||(L={})),function(I){const C="error",R="warning",k="warn",D="info",A="ignore";function n(u){return u?m.equalsIgnoreCase(C,u)?I.Error:m.equalsIgnoreCase(R,u)||m.equalsIgnoreCase(k,u)?I.Warning:m.equalsIgnoreCase(D,u)?I.Info:I.Ignore:I.Ignore}I.fromValue=n;function T(u){switch(u){case I.Error:return C;case I.Warning:return R;case I.Info:return D;default:return A}}I.toString=T}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(w){return Array.isArray(w)}e.isArray=m;function L(w){return typeof w=="string"}e.isString=L;function I(w){return Array.isArray(w)&&w.every(y=>L(y))}e.isStringArray=I;function C(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=C;function R(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=R;function k(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=k;function D(w){return w===!0||w===!1}e.isBoolean=D;function A(w){return typeof w=="undefined"}e.isUndefined=A;function n(w){return!T(w)}e.isDefined=n;function T(w){return A(w)||w===null}e.isUndefinedOrNull=T;function u(w,y){if(!w)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=u;function h(w){if(T(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=h;function c(...w){const y=[];for(let p=0;p<w.length;p++){const S=w[p];if(T(S))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);y.push(S)}return y}e.assertAllDefined=c;const g=Object.prototype.hasOwnProperty;function _(w){if(!C(w))return!1;for(let y in w)if(g.call(w,y))return!1;return!0}e.isEmptyObject=_;function P(w){return typeof w=="function"}e.isFunction=P;function E(...w){return w.length>0&&w.every(P)}e.areFunctions=E;function o(w,y){const p=Math.min(w.length,y.length);for(let S=0;S<p;S++)a(w[S],y[S])}e.validateConstraints=o;function a(w,y){if(L(y)){if(typeof w!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(P(y)){try{if(w instanceof y)return}catch{}if(!T(w)&&w.constructor===y||y.length===1&&y.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function v(w){let y=[],p=Object.getPrototypeOf(w);for(;Object.prototype!==p;)y=y.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return y}e.getAllPropertyNames=v;function t(w){const y=[];for(const p of v(w))typeof w[p]=="function"&&y.push(p);return y}e.getAllMethodNames=t;function r(w,y){const p=b=>function(){const F=Array.prototype.slice.call(arguments,0);return y(b,F)};let S={};for(const b of w)S[b]=p(b);return S}e.createProxyObject=r;function s(w){return w===null?void 0:w}e.withNullAsUndefined=s;function i(w){return typeof w=="undefined"?null:w}e.withUndefinedAsNull=i;function l(w){return class{constructor(){return new Proxy({},{get(y,p){if(y[p])return y[p];throw new Error(`Not Implemented: ${w}->${String(p)}`)}})}}}e.NotImplementedProxy=l;function d(w,y="Unreachable"){throw new Error(y)}e.assertNever=d;function f(w){return!!w&&typeof w.then=="function"&&typeof w.catch=="function"}e.isPromise=f}),define(me[29],ge([0,1,8,11,9,13]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(s){return s===47||s===92}e.isPathSeparator=R;function k(s){return s.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function D(s){return s.indexOf("/")===-1&&(s=k(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=D;function A(s,i=m.posix.sep){if(!s)return"";const l=s.length,d=s.charCodeAt(0);if(R(d)){if(R(s.charCodeAt(1))&&!R(s.charCodeAt(2))){let w=3;const y=w;for(;w<l&&!R(s.charCodeAt(w));w++);if(y!==w&&!R(s.charCodeAt(w+1))){for(w+=1;w<l;w++)if(R(s.charCodeAt(w)))return s.slice(0,w+1).replace(/[\\/]/g,i)}}return i}else if(P(d)&&s.charCodeAt(1)===58)return R(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<l;f++)if(R(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=A;function n(s){if(!L.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let l=2;const d=l;for(;l<s.length&&(i=s.charCodeAt(l),i!==92);l++);return!(d===l||(i=s.charCodeAt(l+1),isNaN(i)||i===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,i=L.isWindows){const l=i?T:u;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||i&&h.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function g(s,i,l){const d=s===i;return!l||d?d:!s||!i?!1:(0,I.equalsIgnoreCase)(s,i)}e.isEqual=g;function _(s,i,l,d=m.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(l){if(!(0,I.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let w=i.length;return i.charAt(i.length-1)===d&&w--,s.charAt(w)===d}return i.charAt(i.length-1)!==d&&(i+=d),s.indexOf(i)===0}e.isEqualOrParent=_;function P(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=P;function E(s,i){return L.isWindows&&s.endsWith(":")&&(s+=m.sep),(0,m.isAbsolute)(s)||(s=(0,m.join)(i,s)),s=(0,m.normalize)(s),L.isWindows?(s=(0,I.rtrim)(s,m.sep),s.endsWith(":")&&(s+=m.sep)):(s=(0,I.rtrim)(s,m.sep),s||(s=m.sep)),s}e.sanitizeFilePath=E;function o(s){const i=(0,m.normalize)(s);return L.isWindows?s.length>3?!1:a(i)&&(s.length===2||i.charCodeAt(2)===92):i===m.posix.sep}e.isRootOrDriveLetter=o;function a(s){return L.isWindows?P(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function v(s){return a(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,i,l){return i.length>s.length?-1:s===i?0:(l&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function r(s){const i=s.split(":");let l,d,f;if(i.forEach(w=>{const y=Number(w);(0,C.isNumber)(y)?d===void 0?d=y:f===void 0&&(f=y):l=l?[l,w].join(":"):w}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:d!==void 0?d:void 0,column:f!==void 0?f:d!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(me[25],ge([0,1,13]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const _=Array.isArray(g)?[]:{};return Object.keys(g).forEach(P=>{g[P]&&typeof g[P]=="object"?_[P]=L(g[P]):_[P]=g[P]}),_}e.deepClone=L;function I(g){if(!g||typeof g!="object")return g;const _=[g];for(;_.length>0;){const P=_.shift();Object.freeze(P);for(const E in P)if(C.call(P,E)){const o=P[E];typeof o=="object"&&!Object.isFrozen(o)&&_.push(o)}}return g}e.deepFreeze=I;const C=Object.prototype.hasOwnProperty;function R(g,_){return k(g,_,new Set)}e.cloneAndChange=R;function k(g,_,P){if((0,m.isUndefinedOrNull)(g))return g;const E=_(g);if(typeof E!="undefined")return E;if((0,m.isArray)(g)){const o=[];for(const a of g)o.push(k(a,_,P));return o}if((0,m.isObject)(g)){if(P.has(g))throw new Error("Cannot clone recursive data-structure");P.add(g);const o={};for(let a in g)C.call(g,a)&&(o[a]=k(g[a],_,P));return P.delete(g),o}return g}function D(g,_,P=!0){return(0,m.isObject)(g)?((0,m.isObject)(_)&&Object.keys(_).forEach(E=>{E in g?P&&((0,m.isObject)(g[E])&&(0,m.isObject)(_[E])?D(g[E],_[E],P):g[E]=_[E]):g[E]=_[E]}),g):_}e.mixin=D;function A(g,_){if(g===_)return!0;if(g==null||_===null||_===void 0||typeof g!=typeof _||typeof g!="object"||Array.isArray(g)!==Array.isArray(_))return!1;let P,E;if(Array.isArray(g)){if(g.length!==_.length)return!1;for(P=0;P<g.length;P++)if(!A(g[P],_[P]))return!1}else{const o=[];for(E in g)o.push(E);o.sort();const a=[];for(E in _)a.push(E);if(a.sort(),!A(o,a))return!1;for(P=0;P<o.length;P++)if(!A(g[o[P]],_[o[P]]))return!1}return!0}e.equals=A;function n(g){const _=new Set;return JSON.stringify(g,(P,E)=>{if((0,m.isObject)(E)||Array.isArray(E)){if(_.has(E))return"[Circular]";_.add(E)}return E})}e.safeStringify=n;function T(g,_,P){const E=_(g);return typeof E=="undefined"?P:E}e.getOrDefault=T;function u(g,_){const P=Object.create(null);return!g||!_||Object.keys(_).forEach(o=>{const a=g[o],v=_[o];A(a,v)||(P[o]=v)}),P}e.distinct=u;function h(g,_){const P=_.toLowerCase(),E=Object.keys(g).find(o=>o.toLowerCase()===P);return E?g[E]:g[_]}e.getCaseInsensitive=h;function c(g,_){const P=Object.create(null);for(const E of Object.keys(g))_(E,g[E])&&(P[E]=g[E]);return P}e.filter=c}),define(me[97],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function I(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=I}),define(me[2],ge([0,1,8,11]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,C=/^\//,R=/^\/\//;function k(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!C.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,i){return!s&&!i?"file":s}function A(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==T&&(i=T+i):i=T;break}return i}const n="",T="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,l,d,f,w,y=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=D(i,y),this.authority=l||n,this.path=A(this.scheme,d||n),this.query=f||n,this.fragment=w||n,k(this,y))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return o(this,!1)}with(i){if(!i)return this;let{scheme:l,authority:d,path:f,query:w,fragment:y}=i;return l===void 0?l=this.scheme:l===null&&(l=n),d===void 0?d=this.authority:d===null&&(d=n),f===void 0?f=this.path:f===null&&(f=n),w===void 0?w=this.query:w===null&&(w=n),y===void 0?y=this.fragment:y===null&&(y=n),l===this.scheme&&d===this.authority&&f===this.path&&w===this.query&&y===this.fragment?this:new g(l,d,f,w,y)}static parse(i,l=!1){const d=u.exec(i);return d?new g(d[2]||n,r(d[4]||n),r(d[5]||n),r(d[7]||n),r(d[9]||n),l):new g(n,n,n,n,n)}static file(i){let l=n;if(L.isWindows&&(i=i.replace(/\\/g,T)),i[0]===T&&i[1]===T){const d=i.indexOf(T,2);d===-1?(l=i.substring(2),i=T):(l=i.substring(2,d),i=i.substring(d)||T)}return new g("file",l,i,n,n)}static from(i){const l=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return k(l,!0),l}static joinPath(i,...l){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&i.scheme==="file"?d=h.file(m.win32.join(o(i,!0),...l)).path:d=m.posix.join(i.path,...l),i.with({path:d})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const l=new g(i);return l._formatted=i.external,l._fsPath=i._sep===c?i.fsPath:null,l}}else return i}}e.URI=h;const c=L.isWindows?1:void 0;class g extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=c),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(s,i){let l,d=-1;for(let f=0;f<s.length;f++){const w=s.charCodeAt(f);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||i&&w===47)d!==-1&&(l+=encodeURIComponent(s.substring(d,f)),d=-1),l!==void 0&&(l+=s.charAt(f));else{l===void 0&&(l=s.substr(0,f));const y=_[w];y!==void 0?(d!==-1&&(l+=encodeURIComponent(s.substring(d,f)),d=-1),l+=y):d===-1&&(d=f)}}return d!==-1&&(l+=encodeURIComponent(s.substring(d))),l!==void 0?l:s}function E(s){let i;for(let l=0;l<s.length;l++){const d=s.charCodeAt(l);d===35||d===63?(i===void 0&&(i=s.substr(0,l)),i+=_[d]):i!==void 0&&(i+=s[l])}return i!==void 0?i:s}function o(s,i){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=o;function a(s,i){const l=i?E:P;let d="",{scheme:f,authority:w,path:y,query:p,fragment:S}=s;if(f&&(d+=f,d+=":"),(w||f==="file")&&(d+=T,d+=T),w){let b=w.indexOf("@");if(b!==-1){const F=w.substr(0,b);w=w.substr(b+1),b=F.indexOf(":"),b===-1?d+=l(F,!1):(d+=l(F.substr(0,b),!1),d+=":",d+=l(F.substr(b+1),!1)),d+="@"}w=w.toLowerCase(),b=w.indexOf(":"),b===-1?d+=l(w,!1):(d+=l(w.substr(0,b),!1),d+=w.substr(b))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const b=y.charCodeAt(1);b>=65&&b<=90&&(y=`/${String.fromCharCode(b+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const b=y.charCodeAt(0);b>=65&&b<=90&&(y=`${String.fromCharCode(b+32)}:${y.substr(2)}`)}d+=l(y,!0)}return p&&(d+="?",d+=l(p,!1)),S&&(d+="#",d+=i?S:P(S,!1)),d}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,i=>v(i)):s}});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[23],ge([0,1,9,2]),function(Z,e,m,L){"use strict";var I,C,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(t,r,s){let i=t.get(r);return i===void 0&&(i=s,t.set(r,i)),i}e.getOrSet=k;function D(t){const r=[];return t.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=D;function A(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=A;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,m.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,m.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class u{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,m.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,m.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,m.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,m.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,m.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,m.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new c(r))}static forPaths(){return new _(new u)}static forStrings(){return new _(new n)}static forConfigKeys(){return new _(new T)}clear(){this._root=void 0}set(r,s){const i=this._iter.reset(r);let l;for(this._root||(this._root=new g,this._root.segment=i.value()),l=this._root;;){const f=i.cmp(l.segment);if(f>0)l.left||(l.left=new g,l.left.segment=i.value()),l=l.left;else if(f<0)l.right||(l.right=new g,l.right.segment=i.value()),l=l.right;else if(i.hasNext())i.next(),l.mid||(l.mid=new g,l.mid.segment=i.value()),l=l.mid;else break}const d=l.value;return l.value=s,l.key=r,d}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const l=s.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),l=[];let d=this._root;for(;d;){const f=i.cmp(d.segment);if(f>0)l.push([1,d]),d=d.left;else if(f<0)l.push([-1,d]),d=d.right;else if(i.hasNext())i.next(),l.push([0,d]),d=d.mid;else{for(s?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;l.length>0&&d.isEmpty();){let[w,y]=l.pop();switch(w){case 1:y.left=void 0;break;case 0:y.mid=void 0;break;case-1:y.right=void 0;break}d=y}break}}}findSubstr(r){const s=this._iter.reset(r);let i=this._root,l;for(;i;){const d=s.cmp(i.segment);if(d>0)i=i.left;else if(d<0)i=i.right;else if(s.hasNext())s.next(),l=i.value||l,i=i.mid;else break}return i&&i.value||l}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const l=s.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=_;class P{constructor(r,s){this[I]="ResourceMap",r instanceof P?(this.map=new Map(r.map),this.toKey=s??P.defaultToKey):(this.map=new Map,this.toKey=r??P.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[i,l]of this.map)r(l,L.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=P,P.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class o{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let l=this._map.get(r);if(l)l.value=s,i!==0&&this.touch(l,i);else{switch(l={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let l=this._head;for(;l;){if(s?r.bind(s)(l.value,l.key,this):r(l.value,l.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:i.key,done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return l}values(){const r=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:i.value,done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return l}entries(){const r=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:[i.key,i.value],done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(i.previous=l,l.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,l=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=l,l.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=o;class a extends o{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class v{constructor(r){R.set(this,void 0),rt(this,R,r,"f")}get size(){return Be(this,R,"f").size}forEach(r,s){Be(this,R,"f").forEach(r,s)}get(r){return Be(this,R,"f").get(r)}has(r){return Be(this,R,"f").has(r)}entries(){return Be(this,R,"f").entries()}keys(){return Be(this,R,"f").keys()}values(){return Be(this,R,"f").values()}[(R=new WeakMap,Symbol.iterator)](){return Be(this,R,"f").entries()}}e.ReadonlyMapView=v}),define(me[98],ge([0,1,23,9]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...Y){return function(oe,ve){for(let Me=0,je=Y.length;Me<je;Me++){const Qe=Y[Me](oe,ve);if(Qe)return Qe}return null}}e.or=I,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Y,oe,ve){if(!ve||ve.length<oe.length)return null;let Me;return Y?Me=L.startsWithIgnoreCase(ve,oe):Me=ve.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(Y,oe){const ve=oe.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=R;function k(Y,oe){return D(Y.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=k;function D(Y,oe,ve,Me){if(ve===Y.length)return[];if(Me===oe.length)return null;if(Y[ve]===oe[Me]){let je=null;return(je=D(Y,oe,ve+1,Me+1))?P({start:Me,end:Me+1},je):null}return D(Y,oe,ve,Me+1)}function A(Y){return 97<=Y&&Y<=122}function n(Y){return 65<=Y&&Y<=90}e.isUpper=n;function T(Y){return 48<=Y&&Y<=57}function u(Y){return Y===32||Y===9||Y===10||Y===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>h.add(Y.charCodeAt(0)));function c(Y){return u(Y)||h.has(Y)}function g(Y,oe){return Y===oe||c(Y)&&c(oe)}function _(Y){return A(Y)||n(Y)||T(Y)}function P(Y,oe){return oe.length===0?oe=[Y]:Y.end===oe[0].start?oe[0].start=Y.start:oe.unshift(Y),oe}function E(Y,oe){for(let ve=oe;ve<Y.length;ve++){const Me=Y.charCodeAt(ve);if(n(Me)||T(Me)||ve>0&&!_(Y.charCodeAt(ve-1)))return ve}return Y.length}function o(Y,oe,ve,Me){if(ve===Y.length)return[];if(Me===oe.length)return null;if(Y[ve]!==oe[Me].toLowerCase())return null;{let je=null,Qe=Me+1;for(je=o(Y,oe,ve+1,Me+1);!je&&(Qe=E(oe,Qe))<oe.length;)je=o(Y,oe,ve+1,Qe),Qe++;return je===null?null:P({start:Me,end:Me+1},je)}}function a(Y){let oe=0,ve=0,Me=0,je=0,Qe=0;for(let te=0;te<Y.length;te++)Qe=Y.charCodeAt(te),n(Qe)&&oe++,A(Qe)&&ve++,_(Qe)&&Me++,T(Qe)&&je++;const et=oe/Y.length,ke=ve/Y.length,ct=Me/Y.length,Q=je/Y.length;return{upperPercent:et,lowerPercent:ke,alphaPercent:ct,numericPercent:Q}}function v(Y){const{upperPercent:oe,lowerPercent:ve}=Y;return ve===0&&oe>.6}function t(Y){const{upperPercent:oe,lowerPercent:ve,alphaPercent:Me,numericPercent:je}=Y;return ve>.2&&oe<.8&&Me>.6&&je<.2}function r(Y){let oe=0,ve=0,Me=0,je=0;for(let Qe=0;Qe<Y.length;Qe++)Me=Y.charCodeAt(Qe),n(Me)&&oe++,A(Me)&&ve++,u(Me)&&je++;return(oe===0||ve===0)&&je===0?Y.length<=30:oe<=5}function s(Y,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(Y)||oe.length>60)return null;const ve=a(oe);if(!t(ve)){if(!v(ve))return null;oe=oe.toLowerCase()}let Me=null,je=0;for(Y=Y.toLowerCase();je<oe.length&&(Me=o(Y,oe,0,je))===null;)je=E(oe,je+1);return Me}e.matchesCamelCase=s;function i(Y,oe,ve=!1){if(!oe||oe.length===0)return null;let Me=null,je=0;for(Y=Y.toLowerCase(),oe=oe.toLowerCase();je<oe.length&&(Me=l(Y,oe,0,je,ve))===null;)je=d(oe,je+1);return Me}e.matchesWords=i;function l(Y,oe,ve,Me,je){if(ve===Y.length)return[];if(Me===oe.length)return null;if(g(Y.charCodeAt(ve),oe.charCodeAt(Me))){let Qe=null,et=Me+1;if(Qe=l(Y,oe,ve+1,Me+1,je),!je)for(;!Qe&&(et=d(oe,et))<oe.length;)Qe=l(Y,oe,ve+1,et,je),et++;return Qe===null?null:P({start:Me,end:Me+1},Qe)}else return null}function d(Y,oe){for(let ve=oe;ve<Y.length;ve++)if(c(Y.charCodeAt(ve))||ve>0&&c(Y.charCodeAt(ve-1)))return ve;return Y.length}const f=I(e.matchesPrefix,s,R),w=I(e.matchesPrefix,s,k),y=new m.LRUCache(1e4);function p(Y,oe,ve=!1){if(typeof Y!="string"||typeof oe!="string")return null;let Me=y.get(Y);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),y.set(Y,Me));const je=Me.exec(oe);return je?[{start:je.index,end:je.index+je[0].length}]:ve?w(Y,oe):f(Y,oe)}e.matchesFuzzy=p;function S(Y,oe){const ve=We(Y,Y.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return ve?F(ve):null}e.matchesFuzzy2=S;function b(Y,oe,ve,Me,je,Qe){const et=Math.min(13,Y.length);for(;ve<et;ve++){const ke=We(Y,oe,ve,Me,je,Qe,!1);if(ke)return ke}return[0,Qe]}e.anyScore=b;function F(Y){if(typeof Y=="undefined")return[];const oe=[],ve=Y[1];for(let Me=Y.length-1;Me>1;Me--){const je=Y[Me]+ve,Qe=oe[oe.length-1];Qe&&Qe.end===je?Qe.end=je+1:oe.push({start:je,end:je+1})}return oe}e.createMatches=F;const N=128;function G(){const Y=[],oe=[];for(let ve=0;ve<=N;ve++)oe[ve]=0;for(let ve=0;ve<=N;ve++)Y.push(oe.slice(0));return Y}function K(Y){const oe=[];for(let ve=0;ve<=Y;ve++)oe[ve]=0;return oe}const M=K(2*N),U=K(2*N),O=G(),$=G(),B=G(),x=!1;function j(Y,oe,ve,Me,je){function Qe(ke,ct,Q=" "){for(;ke.length<ct;)ke=Q+ke;return ke}let et=` |   |${Me.split("").map(ke=>Qe(ke,3)).join("|")}
`;for(let ke=0;ke<=ve;ke++)ke===0?et+=" |":et+=`${oe[ke-1]}|`,et+=Y[ke].slice(0,je+1).map(ct=>Qe(ct.toString(),3)).join("|")+`
`;return et}function H(Y,oe,ve,Me){Y=Y.substr(oe),ve=ve.substr(Me),console.log(j($,Y,Y.length,ve,ve.length)),console.log(j(B,Y,Y.length,ve,ve.length)),console.log(j(O,Y,Y.length,ve,ve.length))}function X(Y,oe){if(oe<0||oe>=Y.length)return!1;const ve=Y.codePointAt(oe);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function J(Y,oe){if(oe<0||oe>=Y.length)return!1;switch(Y.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function fe(Y,oe,ve){return oe[Y]!==ve[Y]}function _e(Y,oe,ve,Me,je,Qe,et=!1){for(;oe<ve&&je<Qe;)Y[oe]===Me[je]&&(et&&(M[oe]=je),oe+=1),je+=1;return oe===ve}e.isPatternInWord=_e;var Se;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Le;(function(Y){Y.Default=[-100,0];function oe(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=oe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function We(Y,oe,ve,Me,je,Qe,et){const ke=Y.length>N?N:Y.length,ct=Me.length>N?N:Me.length;if(ve>=ke||Qe>=ct||ke-ve>ct-Qe||!_e(oe,ve,ke,je,Qe,ct,!0))return;Ne(ke,ct,ve,Qe,oe,je);let Q=1,te=1,pe=ve,ze=Qe;const tt=[!1];for(Q=1,pe=ve;pe<ke;Q++,pe++){const ue=M[pe],Ie=U[pe],Ue=pe+1<ke?U[pe+1]:ct;for(te=ue-Qe+1,ze=ue;ze<Ue;te++,ze++){let Ge=Number.MIN_SAFE_INTEGER,$e=!1;ze<=Ie&&(Ge=Ke(Y,oe,pe,ve,Me,je,ze,ct,Qe,O[Q-1][te-1]===0,tt));let ot=0;Ge!==Number.MAX_SAFE_INTEGER&&($e=!0,ot=Ge+$[Q-1][te-1]);const Re=ze>ue,ye=Re?$[Q][te-1]+(O[Q][te-1]>0?-5:0):0,Ce=ze>ue+1&&O[Q][te-1]>0,ne=Ce?$[Q][te-2]+(O[Q][te-2]>0?-5:0):0;if(Ce&&(!Re||ne>=ye)&&(!$e||ne>=ot))$[Q][te]=ne,B[Q][te]=3,O[Q][te]=0;else if(Re&&(!$e||ye>=ot))$[Q][te]=ye,B[Q][te]=2,O[Q][te]=0;else if($e)$[Q][te]=ot,B[Q][te]=1,O[Q][te]=O[Q-1][te-1]+1;else throw new Error("not possible")}}if(x&&H(Y,ve,Me,Qe),!tt[0]&&!et)return;Q--,te--;const st=[$[Q][te],Qe];let lt=0,vt=0;for(;Q>=1;){let ue=te;do{const Ie=B[Q][ue];if(Ie===3)ue=ue-2;else if(Ie===2)ue=ue-1;else break}while(ue>=1);lt>1&&oe[ve+Q-1]===je[Qe+te-1]&&!fe(ue+Qe-1,Me,je)&&lt+1>O[Q][ue]&&(ue=te),ue===te?lt++:lt=1,vt||(vt=ue),Q--,te=ue-1,st.push(te)}ct===ke&&(st[0]+=2);const Dt=vt-ke;return st[0]-=Dt,st}e.fuzzyScore=We;function Ne(Y,oe,ve,Me,je,Qe){let et=Y-1,ke=oe-1;for(;et>=ve&&ke>=Me;)je[et]===Qe[ke]&&(U[et]=ke,et--),ke--}function Ke(Y,oe,ve,Me,je,Qe,et,ke,ct,Q,te){if(oe[ve]!==Qe[et])return Number.MIN_SAFE_INTEGER;let pe=1,ze=!1;return et===ve-Me?pe=Y[ve]===je[et]?7:5:fe(et,je,Qe)&&(et===0||!fe(et-1,je,Qe))?(pe=Y[ve]===je[et]?7:5,ze=!0):X(Qe,et)&&(et===0||!X(Qe,et-1))?pe=5:(X(Qe,et-1)||J(Qe,et-1))&&(pe=5,ze=!0),pe>1&&ve===Me&&(te[0]=!0),ze||(ze=fe(et,je,Qe)||X(Qe,et-1)||J(Qe,et-1)),ve===Me?et>ct&&(pe-=ze?3:5):Q?pe+=ze?2:0:pe+=ze?0:1,et+1===ke&&(pe-=ze?3:5),pe}function z(Y,oe,ve,Me,je,Qe,et){return re(Y,oe,ve,Me,je,Qe,!0,et)}e.fuzzyScoreGracefulAggressive=z;function ee(Y,oe,ve,Me,je,Qe,et){return re(Y,oe,ve,Me,je,Qe,!1,et)}e.fuzzyScoreGraceful=ee;function re(Y,oe,ve,Me,je,Qe,et,ke){let ct=We(Y,oe,ve,Me,je,Qe,ke);if(ct&&!et)return ct;if(Y.length>=3){const Q=Math.min(7,Y.length-1);for(let te=ve+1;te<Q;te++){const pe=le(Y,te);if(pe){const ze=We(pe,pe.toLowerCase(),ve,Me,je,Qe,ke);ze&&(ze[0]-=3,(!ct||ze[0]>ct[0])&&(ct=ze))}}}return ct}function le(Y,oe){if(oe+1>=Y.length)return;const ve=Y[oe],Me=Y[oe+1];if(ve!==Me)return Y.slice(0,oe)+Me+ve+Y.slice(oe+2)}}),define(me[142],ge([0,1,47,98,9]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${C.source}`,"g");function k(g){return g.replace(R,(_,P)=>P?_:`\\${_}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${C.source}`,"g");function A(g){return g.replace(D,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=A;const n=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function T(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(n,(_,P,E,o)=>E?_:P||o||"")}e.stripIcons=T;function u(g){const _=g.indexOf(e.iconStartMarker);return _===-1?{text:g}:h(g,_)}e.parseLabelWithIcons=u;function h(g,_){const P=[];let E="";function o(d){if(d){E+=d;for(const f of d)P.push(t)}}let a=-1,v="",t=0,r,s,i=_;const l=g.length;for(o(g.substr(0,_));i<l;)r=g[i],s=g[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(a=i,o(v),v=e.iconStartMarker,i++):r===")"&&a!==-1?(t+=i-a+1,a=-1,v=""):a!==-1?/^[a-z0-9\-]$/i.test(r)?v+=r:(o(v),a=-1,v=""):o(r),i++;return o(v),{text:E,iconOffsets:P}}function c(g,_,P=!1){const{text:E,iconOffsets:o}=_;if(!o||o.length===0)return(0,L.matchesFuzzy)(g,E,P);const a=(0,I.ltrim)(E," "),v=E.length-a.length,t=(0,L.matchesFuzzy)(g,a,P);if(t)for(const r of t){const s=o[r.start+v]+v;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=c}),define(me[99],ge([0,1,16,142]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(h="",c=!1){if(this.value=h,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1)}appendText(h,c=0){return this.value+=A(this.supportThemeIcons?(0,L.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,c){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=C;function R(u){return k(u)?!u.value:Array.isArray(u)?u.every(R):!0}e.isEmptyMarkdownString=R;function k(u){return u instanceof C?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function D(u,h){return u===h?!0:!u||!h?!1:u.value===h.value&&u.isTrusted===h.isTrusted&&u.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=D;function A(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function n(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function T(u){const h=[],c=u.split("|").map(_=>_.trim());u=c[0];const g=c[1];if(g){const _=/height=(\d+)/.exec(g),P=/width=(\d+)/.exec(g),E=_?_[1]:"",o=P?P[1]:"",a=isFinite(parseInt(o)),v=isFinite(parseInt(E));a&&h.push(`width="${o}"`),v&&h.push(`height="${E}"`)}return{href:u,dimensions:h}}e.parseHrefAndDimensions=T}),define(me[59],ge([0,1,22,9,2]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(n){return JSON.stringify(n,D)}e.stringify=C;function R(n){let T=JSON.parse(n);return T=A(T),T}e.parse=R;var k;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function D(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,L.regExpFlags)(T)}:T}function A(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return I.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let u=0;u<n.length;++u)n[u]=A(n[u],T+1);else for(const u in n)Object.hasOwnProperty.call(n,u)&&(n[u]=A(n[u],T+1))}return n}e.revive=A}),define(me[10],ge([0,1,11,2]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(I=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,A,n){this._hosts[D]=A,this._ports[D]=n}setConnectionToken(D,A){this._connectionTokens[D]=A}rewrite(D){if(this._delegate)return this._delegate(D);const A=D.authority;let n=this._hosts[A];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const T=this._ports[A],u=this._connectionTokens[A];let h=`path=${encodeURIComponent(D.path)}`;return typeof u=="string"&&(h+=`&tkn=${encodeURIComponent(u)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${n}:${T}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new C;class R{asBrowserUri(D,A){const n=this.toUri(D,A);return n.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===I.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${I.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?n.with({scheme:I.vscodeFileResource,authority:n.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(D,A){const n=this.toUri(D,A);return n.scheme===I.vscodeFileResource?n.with({scheme:I.file,authority:n.authority!==R.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(D,A){return L.URI.isUri(D)?D:L.URI.parse(A.toUrl(D))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(me[78],ge([0,1,23]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function I(A){return D(A,"NFC",L)}e.normalizeNFC=I;const C=new m.LRUCache(1e4);function R(A){return D(A,"NFD",C)}e.normalizeNFD=R;const k=/[^\u0000-\u0080]/;function D(A,n,T){if(!A)return A;const u=T.get(A);if(u)return u;let h;return k.test(A)?h=A.normalize(n):h=A,T.set(A,h),h}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(n){return R(n).replace(A,"")}}()}),define(me[24],ge([0,1,29,10,8,11,9,2]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,k.uriToFsPath)(h,!0)}e.originalFSPath=D;class A{constructor(c){this._ignorePathCasing=c}compare(c,g,_=!1){return c===g?0:(0,R.compare)(this.getComparisonKey(c,_),this.getComparisonKey(g,_))}isEqual(c,g,_=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,_)===this.getComparisonKey(g,_)}getComparisonKey(c,g=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,g,_=!1){if(c.scheme===g.scheme){if(c.scheme===L.Schemas.file)return m.isEqualOrParent(D(c),D(g),this._ignorePathCasing(c))&&c.query===g.query&&(_||c.fragment===g.fragment);if((0,e.isEqualAuthority)(c.authority,g.authority))return m.isEqualOrParent(c.path,g.path,this._ignorePathCasing(c),"/")&&c.query===g.query&&(_||c.fragment===g.fragment)}return!1}joinPath(c,...g){return k.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return I.posix.basename(c.path)}extname(c){const g=I.posix.extname(c.path),_=g.indexOf("?");return _!==-1?g.substr(0,_):g}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===L.Schemas.file?g=k.URI.file(I.dirname(D(c))).path:(g=I.posix.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===L.Schemas.file?g=k.URI.file(I.normalize(D(c))).path:g=I.posix.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.isEqualAuthority)(c.authority,g.authority))return;if(c.scheme===L.Schemas.file){const E=I.relative(D(c),D(g));return C.isWindows?m.toSlashes(E):E}let _=c.path||"/",P=g.path||"/";if(this._ignorePathCasing(c)){let E=0;for(const o=Math.min(_.length,P.length);E<o&&!(_.charCodeAt(E)!==P.charCodeAt(E)&&_.charAt(E).toLowerCase()!==P.charAt(E).toLowerCase());E++);_=P.substr(0,E)+_.substr(E)}return I.posix.relative(_,P)}resolvePath(c,g){if(c.scheme===L.Schemas.file){const _=k.URI.file(I.resolve(D(c),g));return c.with({authority:_.authority,path:_.path})}return g=m.toPosixPath(g),c.with({path:I.posix.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||(0,R.equalsIgnoreCase)(c,g)}hasTrailingPathSeparator(c,g=I.sep){if(c.scheme===L.Schemas.file){const _=D(c);return _.length>m.getRoot(_).length&&_[_.length-1]===g}else{const _=c.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=I.sep){return(0,e.hasTrailingPathSeparator)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=I.sep){let _=!1;if(c.scheme===L.Schemas.file){const P=D(c);_=P!==void 0&&P.length===m.getRoot(P).length&&P[P.length-1]===g}else{g="/";const P=c.path;_=P.length===1&&P.charCodeAt(P.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(c,g)?c.with({path:c.path+"/"}):c}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(h=>h.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new A(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,c){const g=[];for(let _=0;_<h.length;_++){const P=c(h[_]);h.some((E,o)=>o===_?!1:(0,e.isEqualOrParent)(P,c(E)))||g.push(h[_])}return g}e.distinctParents=n;var T;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(g){const _=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(o=>{const[a,v]=o.split(":");a&&v&&_.set(a,v)});const E=g.path.substring(0,g.path.indexOf(";"));return E&&_.set(h.META_DATA_MIME,E),_}h.parseMetaData=c})(T=e.DataUri||(e.DataUri={}));function u(h,c,g){if(c){let _=h.path;return _&&_[0]!==I.posix.sep&&(_=I.posix.sep+_),h.with({scheme:g,authority:c,path:_})}return h.with({scheme:g})}e.toLocalResource=u}),define(me[17],ge([0,1,21,16,3,6,24]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(U){return!!U&&typeof U.then=="function"}e.isThenable=k;function D(U){const O=new m.CancellationTokenSource,$=U(O.token),B=new Promise((x,j)=>{const H=O.token.onCancellationRequested(()=>{H.dispose(),O.dispose(),j((0,L.canceled)())});Promise.resolve($).then(X=>{H.dispose(),O.dispose(),x(X)},X=>{H.dispose(),O.dispose(),j(X)})});return new class{cancel(){O.cancel()}then(x,j){return B.then(x,j)}catch(x){return this.then(void 0,x)}finally(x){return B.finally(x)}}}e.createCancelablePromise=D;function A(U,O,$){return Promise.race([U,new Promise(B=>O.onCancellationRequested(()=>B($)))])}e.raceCancellation=A;async function n(U){let O=-1;const $=U.map((x,j)=>x.then(H=>(O=j,H))),B=await Promise.race($);return U.forEach((x,j)=>{j!==O&&x.cancel()}),B}e.raceCancellablePromises=n;function T(U,O,$){let B;const x=setTimeout(()=>{B?.(void 0),$?.()},O);return Promise.race([U.finally(()=>clearTimeout(x)),new Promise(j=>B=j)])}e.raceTimeout=T;function u(U){return new Promise((O,$)=>{const B=U();k(B)?B.then(O,$):O(B)})}e.asPromise=u;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then($,$).then(B)})}return new Promise(($,B)=>{this.queuedPromise.then($,B)})}return this.activePromise=O(),new Promise(($,B)=>{this.activePromise.then(x=>{this.activePromise=null,$(x)},x=>{this.activePromise=null,B(x)})})}}e.Throttler=h;class c{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=c;class g{constructor(){this.promiseMap=new Map}queue(O,$){const x=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(O)===x&&this.promiseMap.delete(O)});return this.promiseMap.set(O,x),x}}e.SequencerByKey=g;class _{constructor(O){this.defaultDelay=O,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,$=this.defaultDelay){return this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,x)=>{this.doResolve=B,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class P{constructor(O){this.delayer=new _(O),this.throttler=new h}trigger(O,$){return this.delayer.trigger(()=>this.throttler.queue(O),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class E{constructor(){this._isOpen=!1,this._promise=new Promise((O,$)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class o extends E{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function a(U,O){return O?new Promise(($,B)=>{const x=setTimeout(()=>{j.dispose(),$()},U),j=O.onCancellationRequested(()=>{clearTimeout(x),j.dispose(),B((0,L.canceled)())})}):D($=>a(U,$))}e.timeout=a;function v(U,O=0){const $=setTimeout(U,O);return(0,C.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=v;function t(U){const O=[];let $=0;const B=U.length;function x(){return $<B?U[$++]():null}function j(H){H!=null&&O.push(H);const X=x();return X?X.then(j):Promise.resolve(O)}return Promise.resolve(null).then(j)}e.sequence=t;function r(U,O=B=>!!B,$=null){let B=0;const x=U.length,j=()=>{if(B>=x)return Promise.resolve($);const H=U[B++];return Promise.resolve(H()).then(J=>O(J)?Promise.resolve(J):j())};return j()}e.first=r;function s(U,O=B=>!!B,$=null){if(U.length===0)return Promise.resolve($);let B=U.length;const x=()=>{B=-1;for(const j of U)j.cancel?.()};return new Promise((j,H)=>{for(const X of U)X.then(J=>{--B>=0&&O(J)?(x(),j(J)):B===0&&j($)}).catch(J=>{--B>=0&&(x(),H(J))})})}e.firstParallel=s;class i{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(O){return this._size++,new Promise(($,B)=>{this.outstandingPromises.push({factory:O,c:$,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const $=O.factory();$.then(O.c,O.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class l extends i{constructor(){super(1)}}e.Queue=l;class d{constructor(){this.queues=new Map}queueFor(O,$=R.extUri){const B=$.getComparisonKey(O);let x=this.queues.get(B);return x||(x=new l,I.Event.once(x.onFinished)(()=>{x?.dispose(),this.queues.delete(B)}),this.queues.set(B,x)),x}dispose(){this.queues.forEach(O=>O.dispose()),this.queues.clear()}}e.ResourceQueue=d;class f{constructor(O,$){this._token=-1,typeof O=="function"&&typeof $=="number"&&this.setIfNotSet(O,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},$)}setIfNotSet(O,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},$))}}e.TimeoutTimer=f;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,$){this.cancel(),this._token=setInterval(()=>{O()},$)}}e.IntervalTimer=w;class y{constructor(O,$){this.timeoutToken=-1,this.runner=O,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=y;class p extends y{constructor(O,$){super(O,$);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner&&this.runner(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=p;class S extends C.Disposable{constructor(O,$,B,x){super();this.maxWorkChunkSize=O,this.maxPendingWork=$,this.throttleDelay=B,this.handler=x,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.maxPendingWork)return!1}else if(this.pending+O.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new y(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=S,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=O=>{const $=setTimeout(()=>O(U));let B=!1;return{dispose(){B||(B=!0,clearTimeout($))}}}}else e.runWhenIdle=(U,O)=>{const $=requestIdleCallback(U,typeof O=="number"?{timeout:O}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback($))}}}}();class b{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=b;async function F(U,O,$){let B;for(let x=0;x<$;x++)try{return await U()}catch(j){B=j,await a(O)}throw B}e.retry=F;class N{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(O,$,B){return this._pending={taskId:O,cancel:()=>B?.(),promise:$},$.then(()=>this.donePending(O),()=>this.donePending(O)),$}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let $,B;const x=new Promise((j,H)=>{$=j,B=H});this._next={run:O,promise:x,promiseResolve:$,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=N;class G{constructor(O){this.interval=O,this.lastIncrementTime=0,this.value=0}increment(){const O=Date.now();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,$)=>{this.completeCallback=O,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise($=>{this.completeCallback(O),this.resolved=!0,$()})}error(O){return new Promise($=>{this.errorCallback(O),this.rejected=!0,$()})}cancel(){new Promise(O=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,O()})}}e.DeferredPromise=K;var M;(function(U){async function O($){let B;const x=await Promise.all($.map(j=>j.then(H=>H,H=>{B||(B=H)})));if(typeof B!="undefined")throw B;return x}U.settled=O})(M=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,17,8]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new m.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(y,p,S=!1){const b=y||"",F=p||"",N=I.value.collator.compare(b,F);return I.value.collatorIsNumeric&&N===0&&b!==F?b<F?-1:1:N}e.compareFileNames=k;function D(y,p){const S=C.value.collator;return y=y||"",p=p||"",v(S,y,p)}e.compareFileNamesDefault=D;function A(y,p){const S=C.value.collator;return y=y||"",p=p||"",i(y,p)||v(S,y,p)}e.compareFileNamesUpper=A;function n(y,p){const S=C.value.collator;return y=y||"",p=p||"",s(y,p)||v(S,y,p)}e.compareFileNamesLower=n;function T(y,p){return y=y||"",p=p||"",y===p?0:y<p?-1:1}e.compareFileNamesUnicode=T;function u(y,p,S=!1){S||(y=y&&y.toLowerCase(),p=p&&p.toLowerCase());const[b,F]=o(y),[N,G]=o(p);return b!==N?b<N?-1:1:F===G?0:F<G?-1:1}e.noIntlCompareFileNames=u;function h(y,p){const[S,b]=o(y),[F,N]=o(p);let G=I.value.collator.compare(b,N);if(G===0){if(I.value.collatorIsNumeric&&b!==N)return b<N?-1:1;if(G=I.value.collator.compare(S,F),I.value.collatorIsNumeric&&G===0&&S!==F)return S<F?-1:1}return G}e.compareFileExtensions=h;function c(y,p){y=y||"",p=p||"";const S=a(y),b=a(p),F=C.value.collator,N=R.value.collator;return v(N,S,b)||v(F,y,p)}e.compareFileExtensionsDefault=c;function g(y,p){y=y||"",p=p||"";const S=a(y),b=a(p),F=C.value.collator,N=R.value.collator;return v(N,S,b)||i(y,p)||v(F,y,p)}e.compareFileExtensionsUpper=g;function _(y,p){y=y||"",p=p||"";const S=a(y),b=a(p),F=C.value.collator,N=R.value.collator;return v(N,S,b)||s(y,p)||v(F,y,p)}e.compareFileExtensionsLower=_;function P(y,p){y=y||"",p=p||"";const S=a(y).toLowerCase(),b=a(p).toLowerCase();return S!==b?S<b?-1:1:y!==p?y<p?-1:1:0}e.compareFileExtensionsUnicode=P;const E=/^(.*?)(\.([^.]*))?$/;function o(y,p=!1){const S=y?E.exec(y):[];let b=[S&&S[1]||"",S&&S[3]||""];return p&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function a(y){const p=y?E.exec(y):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function v(y,p,S){let b=y.compare(p,S);return b!==0?b:p.length!==S.length?p.length<S.length?-1:1:0}function t(y){const p=y.charAt(0);return p.toLocaleUpperCase()!==p}function r(y){const p=y.charAt(0);return p.toLocaleLowerCase()!==p}function s(y,p){return t(y)&&r(p)?-1:r(y)&&t(p)?1:0}function i(y,p){return r(y)&&t(p)?-1:t(y)&&r(p)?1:0}function l(y,p,S=!1){return S||(y=y&&y.toLowerCase(),p=p&&p.toLowerCase()),y===p?0:y<p?-1:1}function d(y,p,S=!1){const b=y.split(L.sep),F=p.split(L.sep),N=b.length-1,G=F.length-1;let K,M;for(let U=0;;U++){if(K=N===U,M=G===U,K&&M)return k(b[U],F[U],S);if(K)return-1;if(M)return 1;const O=l(b[U],F[U],S);if(O!==0)return O}}e.comparePaths=d;function f(y,p,S){const b=y.toLowerCase(),F=p.toLowerCase(),N=w(y,p,S);if(N)return N;const G=b.endsWith(S),K=F.endsWith(S);if(G!==K)return G?-1:1;const M=k(b,F);return M!==0?M:b.localeCompare(F)}e.compareAnything=f;function w(y,p,S){const b=y.toLowerCase(),F=p.toLowerCase(),N=b.startsWith(S),G=F.startsWith(S);if(N!==G)return N?-1:1;if(N&&G){if(b.length<F.length)return-1;if(b.length>F.length)return 1}return 0}e.compareByPrefix=w}),define(me[101],ge([0,1,100,98,8,11,9]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,D=[k,[]];function A(M,U,O,$){if(!M||!U)return D;const B=M.length,x=U.length;if(B<x)return D;const j=M.toLowerCase();return n(U,O,x,M,j,B,$)}e.scoreFuzzy=A;function n(M,U,O,$,B,x,j){const H=[],X=[];for(let Se=0;Se<O;Se++){const Le=Se*x,We=Le-x,Ne=Se>0,Ke=M[Se],z=U[Se];for(let ee=0;ee<x;ee++){const re=ee>0,le=Le+ee,Y=le-1,oe=We+ee-1,ve=re?H[Y]:0,Me=Ne&&re?H[oe]:0,je=Ne&&re?X[oe]:0;let Qe;!Me&&Ne?Qe=0:Qe=T(Ke,z,$,B,ee,je),Qe&&Me+Qe>=ve&&(j||Ne||B.startsWith(U,ee))?(X[le]=je+1,H[le]=Me+Qe):(X[le]=k,H[le]=ve)}}const J=[];let fe=O-1,_e=x-1;for(;fe>=0&&_e>=0;){const Se=fe*x+_e;X[Se]===k||(J.push(_e),fe--),_e--}return[H[O*x-1],J.reverse()]}function T(M,U,O,$,B,x){let j=0;if(!u(U,$[B]))return j;if(j+=1,x>0&&(j+=x*5),M===O[B]&&(j+=1),B===0)j+=8;else{const H=h(O.charCodeAt(B-1));H?j+=H:(0,L.isUpper)(O.charCodeAt(B))&&(j+=2)}return j}function u(M,U){return M===U?!0:M==="/"||M==="\\"?U==="/"||U==="\\":!1}function h(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function g(M,U,O=0,$=0){const B=U;return B.values&&B.values.length>1?_(M,B.values,O,$):P(M,U,O,$)}e.scoreFuzzy2=g;function _(M,U,O,$){let B=0;const x=[];for(const j of U){const[H,X]=P(M,j,O,$);if(typeof H!="number")return c;B+=H,x.push(...X)}return[B,d(x)]}function P(M,U,O,$){const B=(0,L.fuzzyScore)(U.original,U.originalLowercase,O,M,M.toLowerCase(),$,!0);return B?[B[0],(0,L.createMatches)(B)]:c}const E=Object.freeze({score:0}),o=1<<18,a=1<<17,v=1<<16;function t(M,U,O,$,B){if(!M||!U.normalized)return E;const x=$.getItemLabel(M);if(!x)return E;const j=$.getItemDescription(M);let H;j?H=`${x}${j}${U.normalized}${Array.isArray(U.values)?U.values.length:""}${O}${U.expectContiguousMatch}`:H=`${x}${U.normalized}${Array.isArray(U.values)?U.values.length:""}${O}${U.expectContiguousMatch}`;const X=B[H];if(X)return X;const J=r(x,j,$.getItemPath(M),U,O);return B[H]=J,J}e.scoreItemFuzzy=t;function r(M,U,O,$,B){const x=!O||!$.containsPathSeparator;return O&&(C.isLinux?$.pathNormalized===O:(0,R.equalsIgnoreCase)($.pathNormalized,O))?{score:o,labelMatch:[{start:0,end:M.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:$.values&&$.values.length>1?s(M,U,O,$.values,x,B):i(M,U,O,$,x,B)}function s(M,U,O,$,B,x){let j=0;const H=[],X=[];for(const J of $){const{score:fe,labelMatch:_e,descriptionMatch:Se}=i(M,U,O,J,B,x);if(fe===k)return E;j+=fe,_e&&H.push(..._e),Se&&X.push(...Se)}return{score:j,labelMatch:d(H),descriptionMatch:d(X)}}function i(M,U,O,$,B,x){if(B||!U){const[j,H]=A(M,$.normalized,$.normalizedLowercase,x&&!$.expectContiguousMatch);if(j){const X=(0,L.matchesPrefix)($.normalized,M);let J;return X?(J=a,J+=Math.round($.normalized.length/M.length*100)):J=v,{score:J+j,labelMatch:X||l(H)}}}if(U){let j=U;O&&(j=`${U}${I.sep}`);const H=j.length,X=`${j}${M}`,[J,fe]=A(X,$.normalized,$.normalizedLowercase,x&&!$.expectContiguousMatch);if(J){const _e=l(fe),Se=[],Le=[];return _e.forEach(We=>{We.start<H&&We.end>H?(Se.push({start:0,end:We.end-H}),Le.push({start:We.start,end:H})):We.start>=H?Se.push({start:We.start-H,end:We.end-H}):Le.push(We)}),{score:J,labelMatch:Se,descriptionMatch:Le}}}return E}function l(M){const U=[];if(!M)return U;let O;for(const $ of M)O&&O.end===$?O.end+=1:(O={start:$,end:$+1},U.push(O));return U}function d(M){const U=M.sort((B,x)=>B.start-x.start),O=[];let $;for(const B of U)!$||!f($,B)?($=B,O.push(B)):($.start=Math.min($.start,B.start),$.end=Math.max($.end,B.end));return O}function f(M,U){return!(M.end<U.start||U.end<M.start)}function w(M,U,O,$,B,x){const j=t(M,O,$,B,x),H=t(U,O,$,B,x),X=j.score,J=H.score;if((X===o||J===o)&&X!==J)return X===o?-1:1;if(X>v||J>v){if(X!==J)return X>J?-1:1;if(X<a&&J<a){const Ke=p(j.labelMatch,H.labelMatch);if(Ke!==0)return Ke}const We=B.getItemLabel(M)||"",Ne=B.getItemLabel(U)||"";if(We.length!==Ne.length)return We.length-Ne.length}if(X!==J)return X>J?-1:1;const fe=Array.isArray(j.labelMatch)&&j.labelMatch.length>0,_e=Array.isArray(H.labelMatch)&&H.labelMatch.length>0;if(fe&&!_e)return-1;if(_e&&!fe)return 1;const Se=y(M,j,B),Le=y(U,H,B);return Se&&Le&&Se!==Le?Le>Se?-1:1:S(M,U,O,B)}e.compareItemsByFuzzyScore=w;function y(M,U,O){let $=-1,B=-1;if(U.descriptionMatch&&U.descriptionMatch.length?$=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&($=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(B=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const x=O.getItemDescription(M);x&&(B+=x.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(B=U.descriptionMatch[U.descriptionMatch.length-1].end);return B-$}function p(M,U){if(!M&&!U||(!M||!M.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!M||!M.length)return 1;const O=M[0].start,B=M[M.length-1].end-O,x=U[0].start,H=U[U.length-1].end-x;return B===H?0:H<B?1:-1}function S(M,U,O,$){const B=$.getItemLabel(M)||"",x=$.getItemLabel(U)||"",j=$.getItemDescription(M),H=$.getItemDescription(U),X=B.length+(j?j.length:0),J=x.length+(H?H.length:0);if(X!==J)return X-J;const fe=$.getItemPath(M),_e=$.getItemPath(U);return fe&&_e&&fe.length!==_e.length?fe.length-_e.length:B!==x?(0,m.compareAnything)(B,x,O.normalized):j&&H&&j!==H?(0,m.compareAnything)(j,H,O.normalized):fe&&_e&&fe!==_e?(0,m.compareAnything)(fe,_e,O.normalized):0}function b(M){return M.startsWith('"')&&M.endsWith('"')}const F=" ";function N(M){typeof M!="string"&&(M="");const U=M.toLowerCase(),{pathNormalized:O,normalized:$,normalizedLowercase:B}=G(M),x=O.indexOf(I.sep)>=0,j=b(M);let H;const X=M.split(F);if(X.length>1)for(const J of X){const fe=b(J),{pathNormalized:_e,normalized:Se,normalizedLowercase:Le}=G(J);Se&&(H||(H=[]),H.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:_e,normalized:Se,normalizedLowercase:Le,expectContiguousMatch:fe}))}return{original:M,originalLowercase:U,pathNormalized:O,normalized:$,normalizedLowercase:B,values:H,containsPathSeparator:x,expectContiguousMatch:j}}e.prepareQuery=N;function G(M){let U;C.isWindows?U=M.replace(/\//g,I.sep):U=M.replace(/\\/g,I.sep);const O=(0,R.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:O,normalizedLowercase:O.toLowerCase()}}function K(M){return Array.isArray(M)?N(M.map(U=>U.original).join(F)):N(M.original)}e.pieceToQuery=K}),define(me[30],ge([0,1,17,29,23,8,9]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",A="/",n="[/\\\\]",T="[^/\\\\]",u=/\//g;function h(x){switch(x){case 0:return"";case 1:return`${T}*?`;default:return`(?:${n}|${T}+${n}|${n}${T}+)*?`}}function c(x,j){if(!x)return[];const H=[];let X=!1,J=!1,fe="";for(const _e of x){switch(_e){case j:if(!X&&!J){H.push(fe),fe="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":J=!0;break;case"]":J=!1;break}fe+=_e}return fe&&H.push(fe),H}e.splitGlobAware=c;function g(x){if(!x)return"";let j="";const H=c(x,A);if(H.every(X=>X===D))j=".*";else{let X=!1;H.forEach((J,fe)=>{if(J===D){X||(j+=h(2),X=!0);return}let _e=!1,Se="",Le=!1,We="";for(const Ne of J){if(Ne!=="}"&&_e){Se+=Ne;continue}if(Le&&(Ne!=="]"||!We)){let Ke;Ne==="-"?Ke=Ne:(Ne==="^"||Ne==="!")&&!We?Ke="^":Ne===A?Ke="":Ke=R.escapeRegExpCharacters(Ne),We+=Ke;continue}switch(Ne){case"{":_e=!0;continue;case"[":Le=!0;continue;case"}":j+=`(?:${c(Se,",").map(ee=>g(ee)).join("|")})`,_e=!1,Se="";break;case"]":j+="["+We+"]",Le=!1,We="";break;case"?":j+=T;continue;case"*":j+=h(1);continue;default:j+=R.escapeRegExpCharacters(Ne)}}fe<H.length-1&&(H[fe+1]!==D||fe+2<H.length)&&(j+=n),X=!1})}return j}const _=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(x,j){if(!x)return s;let H;typeof x!="string"?H=x.pattern:H=x,H=H.trim();const X=`${H}_${!!j.trimForExclusions}`;let J=t.get(X);if(J)return l(J,x);let fe;if(_.test(H)){const _e=H.substr(4);J=function(Se,Le){return typeof Se=="string"&&Se.endsWith(_e)?H:null}}else(fe=P.exec(d(H,j)))?J=f(fe[1],H):(j.trimForExclusions?o:E).test(H)?J=w(H,j):(fe=a.exec(d(H,j)))?J=y(fe[1].substr(1),H,!0):(fe=v.exec(d(H,j)))?J=y(fe[1],H,!1):J=p(H);return t.set(X,J),l(J,x)}function l(x,j){return typeof j=="string"?x:function(H,X){return L.isEqualOrParent(H,j.base)?x(C.relative(j.base,H),X):null}}function d(x,j){return j.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function f(x,j){const H=`/${x}`,X=`\\${x}`,J=function(_e,Se){return typeof _e!="string"?null:Se?Se===x?j:null:_e===x||_e.endsWith(H)||_e.endsWith(X)?j:null},fe=[x];return J.basenames=fe,J.patterns=[j],J.allBasenames=fe,J}function w(x,j){const H=B(x.slice(1,-1).split(",").map(Se=>i(Se,j)).filter(Se=>Se!==s),x),X=H.length;if(!X)return s;if(X===1)return H[0];const J=function(Se,Le){for(let We=0,Ne=H.length;We<Ne;We++)if(H[We](Se,Le))return x;return null},fe=H.find(Se=>!!Se.allBasenames);fe&&(J.allBasenames=fe.allBasenames);const _e=H.reduce((Se,Le)=>Le.allPaths?Se.concat(Le.allPaths):Se,[]);return _e.length&&(J.allPaths=_e),J}function y(x,j,H){const X=C.sep===C.posix.sep,J=X?x:x.replace(u,C.sep),fe=C.sep+J,_e=C.posix.sep+x,Se=H?function(Le,We){return typeof Le=="string"&&(Le===J||Le.endsWith(fe)||!X&&(Le===x||Le.endsWith(_e)))?j:null}:function(Le,We){return typeof Le=="string"&&(Le===J||!X&&Le===x)?j:null};return Se.allPaths=[(H?"*/":"./")+x],Se}function p(x){try{const j=new RegExp(`^${g(x)}$`);return function(H){return j.lastIndex=0,typeof H=="string"&&j.test(H)?x:null}}catch(j){return s}}function S(x,j,H){return!x||typeof j!="string"?!1:b(x)(j,void 0,H)}e.match=S;function b(x,j={}){if(!x)return r;if(typeof x=="string"||K(x)){const H=i(x,j);if(H===s)return r;const X=function(J,fe){return!!H(J,fe)};return H.allBasenames&&(X.allBasenames=H.allBasenames),H.allPaths&&(X.allPaths=H.allPaths),X}return O(x,j)}e.parse=b;function F(x){if(!x)return;let j;return H=>(j||(j=(x()||Promise.resolve([])).then(X=>X?G(X):{})),j.then(X=>!!X[H]))}e.hasSiblingPromiseFn=F;function N(x){if(!x)return;let j;return H=>{if(!j){const X=x();j=X?G(X):{}}return!!j[H]}}e.hasSiblingFn=N;function G(x){const j={};for(const H of x)j[H]=!0;return j}function K(x){const j=x;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=K;function M(x){return x.allBasenames||[]}e.getBasenameTerms=M;function U(x){return x.allPaths||[]}e.getPathTerms=U;function O(x,j){const H=B(Object.getOwnPropertyNames(x).map(Se=>$(Se,x[Se],j)).filter(Se=>Se!==s)),X=H.length;if(!X)return s;if(!H.some(Se=>!!Se.requiresSiblings)){if(X===1)return H[0];const Se=function(Ne,Ke){for(let z=0,ee=H.length;z<ee;z++){const re=H[z](Ne,Ke);if(re)return re}return null},Le=H.find(Ne=>!!Ne.allBasenames);Le&&(Se.allBasenames=Le.allBasenames);const We=H.reduce((Ne,Ke)=>Ke.allPaths?Ne.concat(Ke.allPaths):Ne,[]);return We.length&&(Se.allPaths=We),Se}const J=function(Se,Le,We){let Ne;for(let Ke=0,z=H.length;Ke<z;Ke++){const ee=H[Ke];ee.requiresSiblings&&We&&(Le||(Le=C.basename(Se)),Ne||(Ne=Le.substr(0,Le.length-C.extname(Se).length)));const re=ee(Se,Le,Ne,We);if(re)return re}return null},fe=H.find(Se=>!!Se.allBasenames);fe&&(J.allBasenames=fe.allBasenames);const _e=H.reduce((Se,Le)=>Le.allPaths?Se.concat(Le.allPaths):Se,[]);return _e.length&&(J.allPaths=_e),J}function $(x,j,H){if(j===!1)return s;const X=i(x,H);if(X===s)return s;if(typeof j=="boolean")return X;if(j){const J=j.when;if(typeof J=="string"){const fe=(_e,Se,Le,We)=>{if(!We||!X(_e,Se))return null;const Ne=J.replace("$(basename)",Le),Ke=We(Ne);return(0,m.isThenable)(Ke)?Ke.then(z=>z?x:null):Ke?x:null};return fe.requiresSiblings=!0,fe}}return X}function B(x,j){const H=x.filter(Se=>!!Se.basenames);if(H.length<2)return x;const X=H.reduce((Se,Le)=>{const We=Le.basenames;return We?Se.concat(We):Se},[]);let J;if(j){J=[];for(let Se=0,Le=X.length;Se<Le;Se++)J.push(j)}else J=H.reduce((Se,Le)=>{const We=Le.patterns;return We?Se.concat(We):Se},[]);const fe=function(Se,Le){if(typeof Se!="string")return null;if(!Le){let Ne;for(Ne=Se.length;Ne>0;Ne--){const Ke=Se.charCodeAt(Ne-1);if(Ke===47||Ke===92)break}Le=Se.substr(Ne)}const We=X.indexOf(Le);return We!==-1?J[We]:null};fe.basenames=X,fe.patterns=J,fe.allBasenames=X;const _e=x.filter(Se=>!Se.basenames);return _e.push(fe),_e}}),define(me[79],ge([0,1,29,10,8,11,24,9,2]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(i,l,d){if(typeof i=="string"&&(i=D.URI.file(i)),d){const w=d.getWorkspaceFolder(i);if(w){const y=d.getWorkspace().folders.length>1;let p;if((0,R.isEqual)(w.uri,i)?p="":p=(0,R.relativePath)(w.uri,i),y){const S=w.name?w.name:(0,R.basename)(w.uri);p=p?S+" \u2022 "+p:S}return p}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(i.fsPath))return(0,I.normalize)(T(i.fsPath));let f=(0,I.normalize)(i.fsPath);return!C.isWindows&&l?.userHome&&(f=h(f,l.userHome.fsPath)),f}e.getPathLabel=A;function n(i){if(!i)return;typeof i=="string"&&(i=D.URI.file(i));const l=(0,R.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(l)?T(l):l}e.getBaseLabel=n;function T(i){return(0,m.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=T;let u=Object.create(null);function h(i,l){if(C.isWindows||!i||!l)return i;let d=u.original===l?u.normalized:void 0;return d||(d=`${(0,k.rtrim)(l,I.posix.sep)}${I.posix.sep}`,u={original:l,normalized:d}),(C.isLinux?i.startsWith(d):(0,k.startsWithIgnoreCase)(i,d))&&(i=`~/${i.substr(d.length)}`),i}e.tildify=h;function c(i,l){return i.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=c;const g="\u2026",_="\\\\",P="~";function E(i,l=I.sep){const d=new Array(i.length);let f=!1;for(let w=0;w<i.length;w++){let y=i[w];if(y===""){d[w]=`.${l}`;continue}if(!y){d[w]=y;continue}f=!0;let p="";y.indexOf(_)===0?(p=y.substr(0,y.indexOf(_)+_.length),y=y.substr(y.indexOf(_)+_.length)):y.indexOf(l)===0?(p=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(P)===0&&(p=y.substr(0,y.indexOf(P)+P.length),y=y.substr(y.indexOf(P)+P.length));const S=y.split(l);for(let b=1;f&&b<=S.length;b++)for(let F=S.length-b;f&&F>=0;F--){f=!1;let N=S.slice(F,F+b).join(l);for(let G=0;!f&&G<i.length;G++)if(G!==w&&i[G]&&i[G].indexOf(N)>-1){const K=F+b===S.length,M=F>0&&i[G].indexOf(l)>-1?l+N:N,U=i[G].endsWith(M);f=!K||U}if(!f){let G="";(S[0].endsWith(":")||p!=="")&&(F===1&&(F=0,b++,N=S[0]+l+N),F>0&&(G=S[0]+l),G=p+G),F>0&&(G=G+g+l),G=G+N,F+b<S.length&&(G=G+l+g),d[w]=G}}f&&(d[w]=y)}return d}e.shorten=E;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function a(i,l=Object.create(null)){const d=[];let f=!1,w="";for(const y of i)if(y==="$"||f&&y==="{")w&&d.push({value:w,type:o.TEXT}),w="",f=!0;else if(y==="}"&&f){const p=l[w];if(typeof p=="string")p.length&&d.push({value:p,type:o.VARIABLE});else if(p){const S=d[d.length-1];(!S||S.type!==o.SEPARATOR)&&d.push({value:p.label,type:o.SEPARATOR})}w="",f=!1}else w+=y;return w&&!f&&d.push({value:w,type:o.TEXT}),d.filter((y,p)=>{if(y.type===o.SEPARATOR){const S=d[p-1],b=d[p+1];return[S,b].every(F=>F&&(F.type===o.VARIABLE||F.type===o.TEXT)&&F.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=a;function v(i,l){return C.isMacintosh||l?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,l){return C.isMacintosh||l?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,d=>d==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const l=i.indexOf("/")!==-1?I.posix:I.win32,d=l.basename(i),f=l.dirname(i);return d.length?{name:d,parentPath:f}:{name:f,parentPath:""}}e.splitName=s}),define(me[102],ge([0,1,30,10,8,24,9]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(k=e.Mimes||(e.Mimes={}));let D=[],A=[],n=[];function T(i,l=!1){const d=u(i);D.push(d),d.userConfigured?n.push(d):A.push(d),l&&!d.userConfigured&&D.forEach(f=>{f.mime===d.mime||f.userConfigured||(d.extension&&f.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&f.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&f.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&f.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=T;function u(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,m.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(I.posix.sep)>=0:!1}}function h(i){i?(D=D.filter(l=>!l.userConfigured),n=[]):(D=[],A=[],n=[])}e.clearTextMimes=h;function c(i,l){let d;if(i)switch(i.scheme){case L.Schemas.file:d=i.fsPath;break;case L.Schemas.data:d=C.DataUri.parseMetaData(i).get(C.DataUri.META_DATA_LABEL);break;default:d=i.path}if(!d)return[k.unknown];d=d.toLowerCase();const f=(0,I.basename)(d),w=g(d,f,n);if(w)return[w,k.text];const y=g(d,f,A);if(y)return[y,k.text];if(l){const p=_(l);if(p)return[p,k.text]}return[k.unknown]}e.guessMimeTypes=c;function g(i,l,d){let f=null,w=null,y=null;for(let p=d.length-1;p>=0;p--){const S=d[p];if(l===S.filenameLowercase){f=S;break}if(S.filepattern&&(!w||S.filepattern.length>w.filepattern.length)){const b=S.filepatternOnPath?i:l;S.filepatternLowercase?.(b)&&(w=S)}S.extension&&(!y||S.extension.length>y.extension.length)&&l.endsWith(S.extensionLowercase)&&(y=S)}return f?f.mime:w?w.mime:y?y.mime:null}function _(i){if((0,R.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let l=D.length-1;l>=0;l--){const d=D[l];if(!d.firstline)continue;const f=i.match(d.firstline);if(f&&f.length>0)return d.mime}return null}function P(i){return i?typeof i=="string"?i===k.binary||i===k.text||i===k.unknown:i.length===1&&P(i[0]):!0}e.isUnspecific=P;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(i){const l=(0,I.extname)(i),d=E[l.toLowerCase()];return d!==void 0?d:v(i)}e.getMediaOrTextMime=a;function v(i){const l=(0,I.extname)(i);return o[l.toLowerCase()]}e.getMediaMime=v;function t(i){for(const l in o)if(o[l]===i)return l}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function s(i,l){const d=r.exec(i);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:l?void 0:i}e.normalizeMimeType=s}),define(me[103],ge([0,1,2]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class I{constructor(T){this._uriTransformer=T}transformIncoming(T){const u=this._uriTransformer.transformIncoming(T);return u===T?T:L(m.URI.from(u))}transformOutgoing(T){const u=this._uriTransformer.transformOutgoing(T);return u===T?T:L(m.URI.from(u))}transformOutgoingURI(T){const u=this._uriTransformer.transformOutgoing(T);return u===T?T:m.URI.from(u)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function C(n,T,u){if(!n||u>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return T.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const c=C(n[h],T,u+1);c!==null&&(n[h]=c)}}return null}function R(n,T){const u=C(n,T,0);return u===null?n:u}e.transformOutgoingURIs=R;function k(n,T,u,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return u?m.URI.revive(T.transformIncoming(n)):T.transformIncoming(n);for(let c in n)if(Object.hasOwnProperty.call(n,c)){const g=k(n[c],T,u,h+1);g!==null&&(n[c]=g)}}return null}function D(n,T){const u=k(n,T,!1,0);return u===null?n:u}e.transformIncomingURIs=D;function A(n,T){const u=k(n,T,!0,0);return u===null?n:u}e.transformAndReviveIncomingURIs=A}),define(me[32],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(D){return m.test(D)}e.isUUID=L;const I=new Uint8Array(16),C=[];for(let D=0;D<256;D++)C.push(D.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(D){for(let A=0;A<D.length;A++)D[A]=Math.floor(Math.random()*256);return D};function k(){R(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let D=0,A="";return A+=C[I[D++]],A+=C[I[D++]],A+=C[I[D++]],A+=C[I[D++]],A+="-",A+=C[I[D++]],A+=C[I[D++]],A+="-",A+=C[I[D++]],A+=C[I[D++]],A+="-",A+=C[I[D++]],A+=C[I[D++]],A+="-",A+=C[I[D++]],A+=C[I[D++]],A+=C[I[D++]],A+=C[I[D++]],A+=C[I[D++]],A+=C[I[D++]],A}e.generateUuid=k}),define(me[143],ge([0,1,104]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const R=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return R;let D=0,A,n=D;for(;n<k.length;)if(A=k.charCodeAt(n),A===13||A===10){if(R.push(k.substring(D,n)),n++,n<k.length){const T=A;A=k.charCodeAt(n),(T===13&&A===10||T===10&&A===13)&&n++}D=n}else n++;return this.remaining=D<k.length?k.substr(D):null,R}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,49,80,290,17,29,78,8,11,24,2,32]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var h;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(h=e.RimRafMode||(e.RimRafMode={}));async function c(M,U=h.UNLINK){if((0,R.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return U===h.UNLINK?_(M):g(M)}async function g(M){try{const U=(0,D.join)((0,L.tmpdir)(),(0,u.generateUuid)());try{await e.Promises.rename(M,U)}catch(O){return _(M)}_(U).catch(O=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function _(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function P(M){if((0,R.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(M,{recursive:!0})}e.rimrafSync=P;async function E(M,U){return v(await(U?o(M):(0,I.promisify)(m.readdir)(M)))}async function o(M){try{return await(0,I.promisify)(m.readdir)(M,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const U=[],O=await E(M);for(const $ of O){let B=!1,x=!1,j=!1;try{const H=await e.Promises.lstat((0,D.join)(M,$));B=H.isFile(),x=H.isDirectory(),j=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}U.push({name:$,isFile:()=>B,isDirectory:()=>x,isSymbolicLink:()=>j})}return U}function a(M){return v(m.readdirSync(M))}e.readdirSync=a;function v(M){return M.map(U=>typeof U=="string"?A.isMacintosh?(0,k.normalizeNFC)(U):U:(U.name=A.isMacintosh?(0,k.normalizeNFC)(U.name):U.name,U))}async function t(M){const U=await E(M),O=[];for(const $ of U)await s.existsDirectory((0,D.join)(M,$))&&O.push($);return O}function r(M,U=1e3){return new Promise(O=>{let $=!1;const B=setInterval(()=>{$||($=!0,m.access(M,x=>{$=!1,x&&(clearInterval(B),O(void 0))}))},U)})}e.whenDeleted=r;var s;(function(M){async function U(B){let x;try{if(x=await e.Promises.lstat(B),!x.isSymbolicLink())return{stat:x}}catch(j){}try{return{stat:await e.Promises.stat(B),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(A.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw H}throw j}}M.stat=U;async function O(B){try{const{stat:x,symbolicLink:j}=await M.stat(B);return x.isFile()&&j?.dangling!==!0}catch(x){}return!1}M.existsFile=O;async function $(B){try{const{stat:x,symbolicLink:j}=await M.stat(B);return x.isDirectory()&&j?.dangling!==!0}catch(x){}return!1}M.existsDirectory=$})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function l(M,U,O){return i.queueFor(T.URI.file(M),n.extUriBiasedIgnorePathCase).queue(()=>{const $=y(O);return new Promise((B,x)=>f(M,U,$,j=>j?x(j):B()))})}let d=!0;function f(M,U,O,$){if(!d)return m.writeFile(M,U,{mode:O.mode,flag:O.flag},$);m.open(M,O.flag,O.mode,(B,x)=>{if(B)return $(B);m.writeFile(x,U,j=>{if(j)return m.close(x,()=>$(j));m.fdatasync(x,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),d=!1),m.close(x,X=>$(X))))})})}function w(M,U,O){const $=y(O);if(!d)return m.writeFileSync(M,U,{mode:$.mode,flag:$.flag});const B=m.openSync(M,$.flag,$.mode);try{m.writeFileSync(B,U);try{m.fdatasyncSync(B)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),d=!1}}finally{m.closeSync(B)}}e.writeFileSync=w;function y(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function p(M,U){if(M===U)return;async function O($){try{const B=await e.Promises.lstat($);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes($,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(M,U),await O(U)}catch($){if(M.toLowerCase()!==U.toLowerCase()&&$.code==="EXDEV"||M.endsWith("."))await S(M,U,{preserveSymlinks:!1}),await c(M,h.MOVE),await O(U);else throw $}}async function S(M,U,O){return F(M,U,{root:{source:M,target:U},options:O,handledSourcePaths:new Set})}const b=511;async function F(M,U,O){if(O.handledSourcePaths.has(M))return;O.handledSourcePaths.add(M);const{stat:$,symbolicLink:B}=await s.stat(M);if(B){if(O.options.preserveSymlinks)try{return await K(M,U,O)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(B.dangling)return}return $.isDirectory()?N(M,U,$.mode&b,O):G(M,U,$.mode&b)}async function N(M,U,O,$){await e.Promises.mkdir(U,{recursive:!0,mode:O});const B=await E(M);for(const x of B)await F((0,D.join)(M,x),(0,D.join)(U,x),$)}async function G(M,U,O){await e.Promises.copyFile(M,U),await e.Promises.chmod(U,O)}async function K(M,U,O){let $=await e.Promises.readlink(M);(0,R.isEqualOrParent)($,O.root.source,!A.isLinux)&&($=(0,D.join)(O.root.target,$.substr(O.root.source.length+1))),await e.Promises.symlink($,U)}e.Promises=new class{get access(){return(0,I.promisify)(m.access)}get stat(){return(0,I.promisify)(m.stat)}get lstat(){return(0,I.promisify)(m.lstat)}get utimes(){return(0,I.promisify)(m.utimes)}get read(){return(0,I.promisify)(m.read)}get readFile(){return(0,I.promisify)(m.readFile)}get write(){return(0,I.promisify)(m.write)}get appendFile(){return(0,I.promisify)(m.appendFile)}get fdatasync(){return(0,I.promisify)(m.fdatasync)}get truncate(){return(0,I.promisify)(m.truncate)}get rename(){return(0,I.promisify)(m.rename)}get copyFile(){return(0,I.promisify)(m.copyFile)}get open(){return(0,I.promisify)(m.open)}get close(){return(0,I.promisify)(m.close)}get symlink(){return(0,I.promisify)(m.symlink)}get readlink(){return(0,I.promisify)(m.readlink)}get chmod(){return(0,I.promisify)(m.chmod)}get mkdir(){return(0,I.promisify)(m.mkdir)}get unlink(){return(0,I.promisify)(m.unlink)}get rmdir(){return(0,I.promisify)(m.rmdir)}get realpath(){return(0,I.promisify)(m.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return c}get move(){return p}get copy(){return S}}}),define(me[105],ge([0,1,49,8,9,28]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function R(n){const T=(0,L.dirname)(n);if(n===T)return n;const u=((0,L.basename)(n)||n).toLowerCase();try{const c=(0,C.readdirSync)(T).filter(g=>g.toLowerCase()===u);if(c.length===1){const g=R(T);if(g)return(0,L.join)(g,c[0])}else if(c.length>1){const g=c.indexOf(u);if(g>=0){const _=R(T);if(_)return(0,L.join)(_,c[g])}}}catch(h){}return null}e.realcaseSync=R;async function k(n){try{return await C.Promises.realpath(n)}catch(T){const u=A(n);return await C.Promises.access(u,m.constants.R_OK),u}}e.realpath=k;function D(n){try{return m.realpathSync(n)}catch(T){const u=A(n);return m.accessSync(u,m.constants.R_OK),u}}e.realpathSync=D;function A(n){return(0,I.rtrim)((0,L.normalize)(n),L.sep)}});var Ve=this&&this.__decorate||function(Z,e,m,L){var I=arguments.length,C=I<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Z,e,m,L);else for(var k=Z.length-1;k>=0;k--)(R=Z[k])&&(C=(I<3?R(C):I>3?R(e,m,C):R(e,m))||C);return I>3&&C&&Object.defineProperty(e,m,C),C};define(me[106],ge([0,1,20,17,22,21,56,16,3,6,59,9,13]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var h;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(h=e.RequestType||(e.RequestType={}));function c(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function _(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(P||(P={}));class E{constructor(x){this.buffer=x,this.pos=0}read(x){const j=this.buffer.slice(this.pos,this.pos+x);return this.pos+=j.byteLength,j}}class o{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var a;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(a||(a={}));function v(B){const x=I.VSBuffer.alloc(4);return x.writeUInt32BE(B,0),x}function t(B){return B.read(4).readUInt32BE(0)}function r(B){const x=I.VSBuffer.alloc(1);return x.writeUInt8(B,0),x}const s={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},i=typeof Buffer!="undefined";function l(B,x){if(typeof x=="undefined")B.write(s.Undefined);else if(typeof x=="string"){const j=I.VSBuffer.fromString(x);B.write(s.String),B.write(v(j.byteLength)),B.write(j)}else if(i&&Buffer.isBuffer(x)){const j=I.VSBuffer.wrap(x);B.write(s.Buffer),B.write(v(j.byteLength)),B.write(j)}else if(x instanceof I.VSBuffer)B.write(s.VSBuffer),B.write(v(x.byteLength)),B.write(x);else if(Array.isArray(x)){B.write(s.Array),B.write(v(x.length));for(const j of x)l(B,j)}else{const j=I.VSBuffer.fromString(JSON.stringify(x));B.write(s.Object),B.write(v(j.byteLength)),B.write(j)}}function d(B){switch(B.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return B.read(t(B)).toString();case a.Buffer:return B.read(t(B)).buffer;case a.VSBuffer:return B.read(t(B));case a.Array:{const j=t(B),H=[];for(let X=0;X<j;X++)H.push(d(B));return H}case a.Object:return JSON.parse(B.read(t(B)).toString())}}class f{constructor(x,j,H=null,X=1e3){this.protocol=x,this.ctx=j,this.logger=H,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(x,j){this.channels.set(x,j),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const j=this.send([x.type]);this.logger&&this.logger.logOutgoing(j,0,1,_(x.type));return}case 201:case 202:case 204:case 203:{const j=this.send([x.type,x.id],x.data);this.logger&&this.logger.logOutgoing(j,x.id,1,_(x.type),x.data);return}}}send(x,j=void 0){const H=new o;return l(H,x),l(H,j),this.sendBuffer(H.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch(j){return 0}}onRawMessage(x){const j=new E(x),H=d(j),X=d(j),J=H[0];switch(J){case 100:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],1,`${c(J)}: ${H[2]}.${H[3]}`,X),this.onPromise({type:J,id:H[1],channelName:H[2],name:H[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],1,`${c(J)}: ${H[2]}.${H[3]}`,X),this.onEventListen({type:J,id:H[1],channelName:H[2],name:H[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],1,`${c(J)}`),this.disposeActiveRequest({type:J,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],1,`${c(J)}`),this.disposeActiveRequest({type:J,id:H[1]})}}onPromise(x){const j=this.channels.get(x.channelName);if(!j){this.collectPendingRequest(x);return}const H=new C.CancellationTokenSource;let X;try{X=j.call(this.ctx,x.name,x.arg,H.token)}catch(_e){X=Promise.reject(_e)}const J=x.id;X.then(_e=>{this.sendResponse({id:J,data:_e,type:201}),this.activeRequests.delete(x.id)},_e=>{_e instanceof Error?this.sendResponse({id:J,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:J,data:_e,type:203}),this.activeRequests.delete(x.id)});const fe=(0,A.toDisposable)(()=>H.cancel());this.activeRequests.set(x.id,fe)}onEventListen(x){const j=this.channels.get(x.channelName);if(!j){this.collectPendingRequest(x);return}const H=x.id,J=j.listen(this.ctx,x.name,x.arg)(fe=>this.sendResponse({id:H,data:fe,type:204}));this.activeRequests.set(x.id,J)}disposeActiveRequest(x){const j=this.activeRequests.get(x.id);j&&(j.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let j=this.pendingRequests.get(x.channelName);j||(j=[],this.pendingRequests.set(x.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:x,timeoutTimer:H})}flushPendingRequests(x){const j=this.pendingRequests.get(x);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var w;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(x,j=null){this.protocol=x,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new D.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(x){const j=this;return{call(H,X,J){return j.isDisposed?Promise.reject(k.canceled()):j.requestPromise(x,H,X,J)},listen(H,X){return j.isDisposed?Promise.reject(k.canceled()):j.requestEvent(x,H,X)}}}requestPromise(x,j,H,X=C.CancellationToken.None){const J=this.lastRequestId++,_e={id:J,type:100,channelName:x,name:j,arg:H};if(X.isCancellationRequested)return Promise.reject(k.canceled());let Se;return new Promise((We,Ne)=>{if(X.isCancellationRequested)return Ne(k.canceled());const Ke=()=>{const le=Y=>{switch(Y.type){case 201:this.handlers.delete(J),We(Y.data);break;case 202:this.handlers.delete(J);const oe=new Error(Y.data.message);oe.stack=Y.data.stack,oe.name=Y.data.name,Ne(oe);break;case 203:this.handlers.delete(J),Ne(Y.data);break}};this.handlers.set(J,le),this.sendRequest(_e)};let z=null;this.state===P.Idle?Ke():(z=(0,L.createCancelablePromise)(le=>this.whenInitialized()),z.then(()=>{z=null,Ke()}));const ee=()=>{z?(z.cancel(),z=null):this.sendRequest({id:J,type:101}),Ne(k.canceled())},re=X.onCancellationRequested(ee);Se=(0,A.combinedDisposable)((0,A.toDisposable)(ee),re),this.activeRequests.add(Se)}).finally(()=>{this.activeRequests.delete(Se)})}requestEvent(x,j,H){const X=this.lastRequestId++,fe={id:X,type:102,channelName:x,name:j,arg:H};let _e=null;const Se=new D.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(We=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Se),this.sendRequest(fe)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Se),this.sendRequest({id:X,type:103}))}}),Le=We=>Se.fire(We.data);return this.handlers.set(X,Le),Se.event}sendRequest(x){switch(x.type){case 100:case 102:{const j=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger&&this.logger.logOutgoing(j,x.id,0,`${c(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const j=this.send([x.type,x.id]);this.logger&&this.logger.logOutgoing(j,x.id,0,c(x.type));return}}}send(x,j=void 0){const H=new o;return l(H,x),l(H,j),this.sendBuffer(H.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch(j){return 0}}onBuffer(x){const j=new E(x),H=d(j),X=d(j),J=H[0];switch(J){case 200:return this.logger&&this.logger.logIncoming(x.byteLength,0,0,_(J)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],0,_(J),X),this.onResponse({type:H[0],id:H[1],data:X})}}onResponse(x){if(x.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(x.id);j&&j(x)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}Ve([R.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class p{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new D.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new D.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:j,onDidClientDisconnect:H})=>{D.Event.once(j.onMessage)(J=>{const fe=new E(J),_e=d(fe),Se=new f(j,_e),Le=new y(j);this.channels.forEach((Ne,Ke)=>Se.registerChannel(Ke,Ne));const We={channelServer:Se,channelClient:Le,ctx:_e};this._connections.add(We),this._onDidAddConnection.fire(We),H(()=>{Se.dispose(),Le.dispose(),this._connections.delete(We),this._onDidRemoveConnection.fire(We)})})})}get connections(){const x=[];return this._connections.forEach(j=>x.push(j)),x}getChannel(x,j){const H=this;return{call(X,J,fe){let _e;if((0,u.isFunction)(j)){let Le=(0,m.getRandomElement)(H.connections.filter(j));_e=Le?Promise.resolve(Le):D.Event.toPromise(D.Event.filter(H.onDidAddConnection,j))}else _e=j.routeCall(H,X,J);const Se=_e.then(Le=>Le.channelClient.getChannel(x));return b(Se).call(X,J,fe)},listen(X,J){if((0,u.isFunction)(j))return H.getMulticastEvent(x,j,X,J);const fe=j.routeEvent(H,X,J).then(_e=>_e.channelClient.getChannel(x));return b(fe).listen(X,J)}}}getMulticastEvent(x,j,H,X){const J=this;let fe=new A.DisposableStore;const _e=new D.Emitter({onFirstListenerAdd:()=>{fe=new A.DisposableStore;const Se=new D.EventMultiplexer,Le=new Map,We=Ke=>{const ee=Ke.channelClient.getChannel(x).listen(H,X),re=Se.add(ee);Le.set(Ke,re)},Ne=Ke=>{const z=Le.get(Ke);!z||(z.dispose(),Le.delete(Ke))};J.connections.filter(j).forEach(We),D.Event.filter(J.onDidAddConnection,j)(We,void 0,fe),J.onDidRemoveConnection(Ne,void 0,fe),Se.event(_e.fire,_e,fe),fe.add(Se)},onLastListenerRemove:()=>{fe.dispose()}});return _e.event}registerChannel(x,j){this.channels.set(x,j),this._connections.forEach(H=>{H.channelServer.registerChannel(x,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=p;class S{constructor(x,j,H=null){const X=new o;l(X,j),x.send(X.buffer),this.channelClient=new y(x,H),this.channelServer=new f(x,j,H)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,j){this.channelServer.registerChannel(x,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=S;function b(B){return{call(x,j,H){return B.then(X=>X.call(x,j,H))},listen(x,j){const H=new D.Relay;return B.then(X=>H.input=X.listen(x,j)),H.event}}}e.getDelayedChannel=b;function F(B){let x=!1;return{call(j,H,X){return x?B.call(j,H,X):(0,L.timeout)(0).then(()=>x=!0).then(()=>B.call(j,H,X))},listen(j,H){if(x)return B.listen(j,H);const X=new D.Relay;return(0,L.timeout)(0).then(()=>x=!0).then(()=>X.input=B.listen(j,H)),X.event}}}e.getNextTickChannel=F;class N{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const j of x.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await D.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=N;var G;(function(B){function x(X,J){const fe=X,_e=J&&J.disableMarshalling,Se=new Map;for(const Le in fe)H(Le)&&Se.set(Le,D.Event.buffer(fe[Le],!0));return new class{listen(Le,We){const Ne=Se.get(We);if(Ne)return Ne;throw new Error(`Event not found: ${We}`)}call(Le,We,Ne){const Ke=fe[We];if(typeof Ke=="function"){if(!_e&&Array.isArray(Ne))for(let z=0;z<Ne.length;z++)Ne[z]=(0,n.revive)(Ne[z]);return Ke.apply(fe,Ne)}throw new Error(`Method not found: ${We}`)}}}B.fromService=x;function j(X,J){const fe=J&&J.disableMarshalling;return new Proxy({},{get(_e,Se){if(typeof Se=="string")return J?.properties?.has(Se)?J.properties.get(Se):H(Se)?X.listen(Se):async function(...Le){let We;J&&!(0,u.isUndefinedOrNull)(J.context)?We=[J.context,...Le]:We=Le;const Ne=await X.call(Se,We);return fe?Ne:(0,n.revive)(Ne)};throw new Error(`Property not found: ${String(Se)}`)}})}B.toService=j;function H(X){return X[0]==="o"&&X[1]==="n"&&T.isUpperAsciiLetter(X.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let x=B.toString();if(x!=="[object Object]")return x}return B}function U(B){return Array.isArray(B)?B.map(M):M(B)}function O(B,x,j,H,X,J,fe){fe=U(fe);const _e=K[X],Se=_e[H%_e.length];let Le=[`%c[${B}]%c[${String(x).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(J)?(Le=Le.concat(fe),Le.push(")")):Le.push(fe),console.log.apply(console,Le)}e.logWithColors=O;class ${constructor(x,j){this._outgoingPrefix=x,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,j,H,X,J){this._totalOutgoing+=x,O(this._outgoingPrefix,this._totalOutgoing,x,j,H,X,J)}logIncoming(x,j,H,X,J){this._totalIncoming+=x,O(this._incomingPrefix,this._totalIncoming,x,j,H,X,J)}}e.IPCLogger=$}),define(me[107],ge([0,1,22,3,6,11,34,106]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var D;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function n(){return A||(A=m.VSBuffer.alloc(0)),A}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,l){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const y=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=i),y}if(this._chunks[0].byteLength>i){const y=this._chunks[0].slice(0,i);return l&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),y}let d=m.VSBuffer.alloc(i),f=0,w=0;for(;i>0;){const y=this._chunks[w];if(y.byteLength>i){const p=y.slice(0,i);d.set(p,f),f+=i,l&&(this._chunks[w]=y.slice(i),this._totalLength-=i),i-=i}else d.set(y,f),f+=y.byteLength,l?(this._chunks.shift(),this._totalLength-=y.byteLength):w++,i-=y.byteLength}return d}}e.ChunkStream=T;var u;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(u||(u={}));var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(i,l,d,f){this.type=i,this.id=l,this.ack=d,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends I.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const d=this._state.messageType,f=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new c(d,f,w,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=m.VSBuffer.alloc(13);l.writeUInt8(i.type,0),l.writeUInt32BE(i.id,1),l.writeUInt32BE(i.ack,5),l.writeUInt32BE(i.data.byteLength,9),this._writeSoon(l,i.data)}_bufferAdd(i,l){const d=this._totalLength===0;return this._data.push(i,l),this._totalLength+=i.byteLength+l.byteLength,d}_bufferTake(){const i=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,l){this._bufferAdd(i,l)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends I.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new c(1,0,0,i))}}e.Protocol=P;class E extends k.IPCClient{constructor(i,l,d=null){super(i,l,d);this.protocol=i}static fromSocket(i,l){return new E(new P(i),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,R.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class a{constructor(i){this.data=i,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],l=0,d=this._first;for(;d;)i[l++]=d.data,d=d.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const l=new a(i);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let l=0;l<t._HISTORY_LENGTH;l++)this.lastRuns[l]=i-1e3*l;setInterval(()=>{for(let l=t._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),l=(1+t._HISTORY_LENGTH)*1e3;let d=0;for(let f=0;f<t._HISTORY_LENGTH;f++)i-this.lastRuns[f]<=l&&d++;return 1-d/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(i,l=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new c(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const l=new c(4,0,0,n());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,l){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let l=0,d=i.length;l<d;l++)this._socketWriter.write(i[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new c(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const l=this._outgoingUnackMsg.toArray();for(let d=0,f=l.length;d<f;d++)this._socketWriter.write(l[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new c(1,l,this._incomingAckId,i);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(i){const l=new c(2,0,0,i);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const i=this._outgoingUnackMsg.peek(),l=Date.now()-i.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new c(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(me[108],ge([0,1,97]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let D=(0,m.toUint8)(k);this._defaultValue=D,this._asciiMap=L._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){let D=new Uint8Array(256);for(let A=0;A<256;A++)D[A]=k;return D}set(k,D){let A=(0,m.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=A:this._map.set(k,A)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var I;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(I||(I={}));class C{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(me[144],ge([0,1,108]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends m.CharacterClassifier{constructor(k){super(0);for(let D=0,A=k.length;D<A;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function C(R){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=R(D)),k[D])}e.getMapForWordSeparators=C(R=>new I(R))}),define(me[50],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(I,C){this.lineNumber=I,this.column=C}with(I=this.lineNumber,C=this.column){return I===this.lineNumber&&C===this.column?this:new m(I,C)}delta(I=0,C=0){return this.with(this.lineNumber+I,this.column+C)}equals(I){return m.equals(this,I)}static equals(I,C){return!I&&!C?!0:!!I&&!!C&&I.lineNumber===C.lineNumber&&I.column===C.column}isBefore(I){return m.isBefore(this,I)}static isBefore(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<C.column}isBeforeOrEqual(I){return m.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<=C.column}static compare(I,C){let R=I.lineNumber|0,k=C.lineNumber|0;if(R===k){let D=I.column|0,A=C.column|0;return D-A}return R-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new m(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=m}),define(me[41],ge([0,1,50]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,R,k,D){C>k||C===k&&R>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=C,this.endColumn=R):(this.startLineNumber=C,this.startColumn=R,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,R){return!(R.lineNumber<C.startLineNumber||R.lineNumber>C.endLineNumber||R.lineNumber===C.startLineNumber&&R.column<C.startColumn||R.lineNumber===C.endLineNumber&&R.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<=C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,R){let k,D,A,n;return R.startLineNumber<C.startLineNumber?(k=R.startLineNumber,D=R.startColumn):R.startLineNumber===C.startLineNumber?(k=R.startLineNumber,D=Math.min(R.startColumn,C.startColumn)):(k=C.startLineNumber,D=C.startColumn),R.endLineNumber>C.endLineNumber?(A=R.endLineNumber,n=R.endColumn):R.endLineNumber===C.endLineNumber?(A=R.endLineNumber,n=Math.max(R.endColumn,C.endColumn)):(A=C.endLineNumber,n=C.endColumn),new L(k,D,A,n)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,R){let k=C.startLineNumber,D=C.startColumn,A=C.endLineNumber,n=C.endColumn,T=R.startLineNumber,u=R.startColumn,h=R.endLineNumber,c=R.endColumn;return k<T?(k=T,D=u):k===T&&(D=Math.max(D,u)),A>h?(A=h,n=c):A===h&&(n=Math.min(n,c)),k>A||k===A&&D>n?null:new L(k,D,A,n)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,R){return!!C&&!!R&&C.startLineNumber===R.startLineNumber&&C.startColumn===R.startColumn&&C.endLineNumber===R.endLineNumber&&C.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,R){return new L(this.startLineNumber,this.startColumn,C,R)}setStartPosition(C,R){return new L(C,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,R=C){return new L(C.lineNumber,C.column,R.lineNumber,R.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<C.startColumn)}static areIntersecting(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<=R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,R){if(C&&R){const A=C.startLineNumber|0,n=R.startLineNumber|0;if(A===n){const T=C.startColumn|0,u=R.startColumn|0;if(T===u){const h=C.endLineNumber|0,c=R.endLineNumber|0;if(h===c){const g=C.endColumn|0,_=R.endColumn|0;return g-_}return h-c}return T-u}return A-n}return(C?1:0)-(R?1:0)}static compareRangesUsingEnds(C,R){return C.endLineNumber===R.endLineNumber?C.endColumn===R.endColumn?C.startLineNumber===R.startLineNumber?C.startColumn-R.startColumn:C.startLineNumber-R.startLineNumber:C.endColumn-R.endColumn:C.endLineNumber-R.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(me[145],ge([0,1,50,41]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(k,D,A,n){super(k,D,A,n);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=A,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,D):new C(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,D){return this.getDirection()===0?new C(k,D,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new C(k.lineNumber,k.column,D.lineNumber,D.column)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let A=0,n=k.length;A<n;A++)if(!this.selectionsEqual(k[A],D[A]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,A,n,T){return T===0?new C(k,D,A,n):new C(A,n,k,D)}}e.Selection=C}),define(me[109],ge([0,1,25]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class A{constructor(_,P){this._findMatchBrand=void 0,this.range=_,this.matches=P}}e.FindMatch=A;var n;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None"})(T=e.PositionAffinity||(e.PositionAffinity={}));var u;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u=e.ModelConstants||(e.ModelConstants={}));class h{constructor(_,P,E,o,a,v){this.identifier=_,this.range=P,this.text=E,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=a,this._isTracked=v}}e.ValidAnnotatedEditOperation=h;class c{constructor(_,P,E){this.reverseEdits=_,this.changes=P,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=c}),define(me[146],ge([0,1,9,144,50,41,109]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(o,a,v,t){this.searchString=o,this.isRegex=a,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=A(this.searchString):o=this.searchString.indexOf(`
`)>=0;let a=null;try{a=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(t){return null}if(!a)return null;let v=!this.isRegex&&!o;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(a,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=D;function A(E){if(!E||E.length===0)return!1;for(let o=0,a=E.length;o<a;o++)if(E.charCodeAt(o)===92){if(o++,o>=a)break;const t=E.charCodeAt(o);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=A;class n{constructor(o,a,v){this.regex=o,this.wordSeparators=a,this.simpleSearch=v}}e.SearchData=n;function T(E,o,a){if(!a)return new R.FindMatch(E,null);let v=[];for(let t=0,r=o.length;t<r;t++)v[t]=o[t];return new R.FindMatch(E,v)}e.createFindMatch=T;class u{constructor(o){let a=[],v=0;for(let t=0,r=o.length;t<r;t++)o.charCodeAt(t)===10&&(a[v++]=t);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(o){const a=this._lineFeedsOffsets;let v=0,t=a.length-1;if(t===-1||o<=a[0])return 0;for(;v<t;){const r=v+((t-v)/2>>0);a[r]>=o?t=r-1:a[r+1]>=o?(v=r,t=r):v=r+1}return v+1}}class h{static findMatches(o,a,v,t,r){const s=a.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(o,v,new P(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(o,v,s,t,r):[]}static _getMultilineMatchRange(o,a,v,t,r,s){let i,l=0;t?(l=t.findLineFeedCountBeforeOffset(r),i=a+r+l):i=a+r;let d;if(t){let p=t.findLineFeedCountBeforeOffset(r+s.length)-l;d=i+s.length+p}else d=i+s.length;const f=o.getPositionAt(i),w=o.getPositionAt(d);return new C.Range(f.lineNumber,f.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(o,a,v,t,r){const s=o.getOffsetAt(a.getStartPosition()),i=o.getValueInRange(a,1),l=o.getEOL()===`\r
`?new u(i):null,d=[];let f=0,w;for(v.reset(0);w=v.next(i);)if(d[f++]=T(this._getMultilineMatchRange(o,s,i,l,w.index,w[0]),w,t),f>=r)return d;return d}static _doFindMatchesLineByLine(o,a,v,t,r){const s=[];let i=0;if(a.startLineNumber===a.endLineNumber){const d=o.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return i=this._findMatchesInLine(v,d,a.startLineNumber,a.startColumn-1,i,s,t,r),s}const l=o.getLineContent(a.startLineNumber).substring(a.startColumn-1);i=this._findMatchesInLine(v,l,a.startLineNumber,a.startColumn-1,i,s,t,r);for(let d=a.startLineNumber+1;d<a.endLineNumber&&i<r;d++)i=this._findMatchesInLine(v,o.getLineContent(d),d,0,i,s,t,r);if(i<r){const d=o.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);i=this._findMatchesInLine(v,d,a.endLineNumber,0,i,s,t,r)}return s}static _findMatchesInLine(o,a,v,t,r,s,i,l){const d=o.wordSeparators;if(!i&&o.simpleSearch){const y=o.simpleSearch,p=y.length,S=a.length;let b=-p;for(;(b=a.indexOf(y,b+p))!==-1;)if((!d||_(d,a,S,b,p))&&(s[r++]=new R.FindMatch(new C.Range(v,b+1+t,v,b+1+p+t),null),r>=l))return r;return r}const f=new P(o.wordSeparators,o.regex);let w;f.reset(0);do if(w=f.next(a),w&&(s[r++]=T(new C.Range(v,w.index+1+t,v,w.index+1+w[0].length+t),w,i),r>=l))return r;while(w);return r}static findNextMatch(o,a,v,t){const r=a.parseSearchRequest();if(!r)return null;const s=new P(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(o,v,s,t):this._doFindNextMatchLineByLine(o,v,s,t)}static _doFindNextMatchMultiline(o,a,v,t){const r=new I.Position(a.lineNumber,1),s=o.getOffsetAt(r),i=o.getLineCount(),l=o.getValueInRange(new C.Range(r.lineNumber,r.column,i,o.getLineMaxColumn(i)),1),d=o.getEOL()===`\r
`?new u(l):null;v.reset(a.column-1);let f=v.next(l);return f?T(this._getMultilineMatchRange(o,s,l,d,f.index,f[0]),f,t):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(o,new I.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(o,a,v,t){const r=o.getLineCount(),s=a.lineNumber,i=o.getLineContent(s),l=this._findFirstMatchInLine(v,i,s,a.column,t);if(l)return l;for(let d=1;d<=r;d++){const f=(s+d-1)%r,w=o.getLineContent(f+1),y=this._findFirstMatchInLine(v,w,f+1,1,t);if(y)return y}return null}static _findFirstMatchInLine(o,a,v,t,r){o.reset(t-1);const s=o.next(a);return s?T(new C.Range(v,s.index+1,v,s.index+1+s[0].length),s,r):null}static findPreviousMatch(o,a,v,t){const r=a.parseSearchRequest();if(!r)return null;const s=new P(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(o,v,s,t):this._doFindPreviousMatchLineByLine(o,v,s,t)}static _doFindPreviousMatchMultiline(o,a,v,t){const r=this._doFindMatchesMultiline(o,new C.Range(1,1,a.lineNumber,a.column),v,t,10*k);if(r.length>0)return r[r.length-1];const s=o.getLineCount();return a.lineNumber!==s||a.column!==o.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(o,new I.Position(s,o.getLineMaxColumn(s)),v,t):null}static _doFindPreviousMatchLineByLine(o,a,v,t){const r=o.getLineCount(),s=a.lineNumber,i=o.getLineContent(s).substring(0,a.column-1),l=this._findLastMatchInLine(v,i,s,t);if(l)return l;for(let d=1;d<=r;d++){const f=(r+s-d-1)%r,w=o.getLineContent(f+1),y=this._findLastMatchInLine(v,w,f+1,t);if(y)return y}return null}static _findLastMatchInLine(o,a,v,t){let r=null,s;for(o.reset(0);s=o.next(a);)r=T(new C.Range(v,s.index+1,v,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=h;function c(E,o,a,v,t){if(v===0)return!0;const r=o.charCodeAt(v-1);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=o.charCodeAt(v);if(E.get(s)!==0)return!0}return!1}function g(E,o,a,v,t){if(v+t===a)return!0;const r=o.charCodeAt(v+t);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=o.charCodeAt(v+t-1);if(E.get(s)!==0)return!0}return!1}function _(E,o,a,v,t){return c(E,o,a,v,t)&&g(E,o,a,v,t)}e.isValidMatch=_;class P{constructor(o,a){this._wordSeparators=o,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const a=o.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(v=this._searchRegex.exec(o),!v))return null;const t=v.index,r=v[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){m.getNextCodePoint(o,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,o,a,t,r))return v}while(v);return null}}e.Searcher=P}),define(me[110],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)k.indexOf(A)>=0||(D+="\\"+A);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=m();function L(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let A="g";k.ignoreCase&&(A+="i"),k.multiline&&(A+="m"),k.unicode&&(A+="u"),D=new RegExp(k.source,A)}return D.lastIndex=0,D}e.ensureValidWordDefinition=L;const I={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,D,A,n,T=I){if(A.length>T.maxLen){let _=k-T.maxLen/2;return _<0?_=0:n+=_,A=A.substring(_,k+T.maxLen/2),C(k,D,A,n,T)}const u=Date.now(),h=k-1-n;let c=-1,g=null;for(let _=1;!(Date.now()-u>=T.timeBudget);_++){const P=h-T.windowSize*_;D.lastIndex=Math.max(0,P);const E=R(D,A,h,c);if(!E&&g||(g=E,P<=0))break;c=P}if(g){let _={word:g[0],startColumn:n+1+g.index,endColumn:n+1+g.index+g[0].length};return D.lastIndex=0,_}return null}e.getWordAtText=C;function R(k,D,A,n){let T;for(;T=k.exec(D);){const u=T.index||0;if(u<=A&&k.lastIndex>=A)return T;if(n>0&&u>n)return null}return null}}),define(me[147],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,A=k.notIn.length;D<A;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=L;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)C(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),C(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),C(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),C(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&C(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=I;function C(R,k,D){R.has(k)?R.get(k).push(D):R.set(k,[D])}}),define(me[81],ge([0,1,30,8]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(C,R,k,D){if(Array.isArray(C)){let A=0;for(const n of C){const T=I(n,R,k,D);if(T===10)return T;T>A&&(A=T)}return A}else{if(typeof C=="string")return D?C==="*"?5:C===k?10:0:0;if(C){const{language:A,pattern:n,scheme:T,hasAccessToAllModels:u}=C;if(!D&&!u)return 0;let h=0;if(T)if(T===R.scheme)h=10;else if(T==="*")h=5;else return 0;if(A)if(A===k)h=10;else if(A==="*")h=Math.max(h,5);else return 0;if(n){let c;if(typeof n=="string"?c=n:c={...n,base:(0,L.normalize)(n.base)},c===R.fsPath||(0,m.match)(c,R.fsPath))h=10;else return 0}return h}else return 0}}e.score=I}),define(me[148],ge([0,1,108]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class I{constructor(c,g,_){const P=new Uint8Array(c*g);for(let E=0,o=c*g;E<o;E++)P[E]=_;this._data=P,this.rows=c,this.cols=g}get(c,g){return this._data[c*this.cols+g]}set(c,g,_){this._data[c*this.cols+g]=_}}e.Uint8Matrix=I;class C{constructor(c){let g=0,_=0;for(let E=0,o=c.length;E<o;E++){let[a,v,t]=c[E];v>g&&(g=v),a>_&&(_=a),t>_&&(_=t)}g++,_++;let P=new I(_,g,0);for(let E=0,o=c.length;E<o;E++){let[a,v,t]=c[E];P.set(a,v,t)}this._states=P,this._maxCharCode=g}nextState(c,g){return g<0||g>=this._maxCharCode?0:this._states.get(c,g)}}e.StateMachine=C;let R=null;function k(){return R===null&&(R=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var D;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let A=null;function n(){if(A===null){A=new m.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<h.length;g++)A.set(h.charCodeAt(g),1);const c=".,;";for(let g=0;g<c.length;g++)A.set(c.charCodeAt(g),2)}return A}class T{static _createLink(c,g,_,P,E){let o=E-1;do{const a=g.charCodeAt(o);if(c.get(a)!==2)break;o--}while(o>P);if(P>0){const a=g.charCodeAt(P-1),v=g.charCodeAt(o);(a===40&&v===41||a===91&&v===93||a===123&&v===125)&&o--}return{range:{startLineNumber:_,startColumn:P+1,endLineNumber:_,endColumn:o+2},url:g.substring(P,o+1)}}static computeLinks(c,g=k()){const _=n();let P=[];for(let E=1,o=c.getLineCount();E<=o;E++){const a=c.getLineContent(E),v=a.length;let t=0,r=0,s=0,i=1,l=!1,d=!1,f=!1,w=!1;for(;t<v;){let y=!1;const p=a.charCodeAt(t);if(i===13){let S;switch(p){case 40:l=!0,S=0;break;case 41:S=l?0:1;break;case 91:f=!0,d=!0,S=0;break;case 93:f=!1,S=d?0:1;break;case 123:w=!0,S=0;break;case 125:S=w?0:1;break;case 39:S=s===34||s===96?0:1;break;case 34:S=s===39||s===96?0:1;break;case 96:S=s===39||s===34?0:1;break;case 42:S=s===42?1:0;break;case 124:S=s===124?1:0;break;case 32:S=f?0:1;break;default:S=_.get(p)}S===1&&(P.push(T._createLink(_,a,E,r,t)),y=!0)}else if(i===12){let S;p===91?(d=!0,S=0):S=_.get(p),S===1?y=!0:i=13}else i=g.nextState(i,p),i===0&&(y=!0);y&&(i=1,l=!1,d=!1,w=!1,r=t+1,s=p),t++}i===13&&P.push(T._createLink(_,a,E,r,v))}return P}}e.LinkComputer=T;function u(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:T.computeLinks(h)}e.computeLinks=u}),define(me[149],ge([0,1,3,6]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,k){return this._map.set(R,k),this.fire([R]),(0,L.toDisposable)(()=>{this._map.get(R)===k&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,k){let D=null,A=!1;return this._promises.set(R,k.then(n=>{this._promises.delete(R),!(A||!n)&&(D=this.register(R,n))})),(0,L.toDisposable)(()=>{A=!0,D&&D.dispose()})}getPromise(R){const k=this.get(R);if(k)return Promise.resolve(k);const D=this._promises.get(R);return D?D.then(A=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(me[111],ge([0,1,22,11]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(I||(I={}));function C(T){for(let u=0,h=T.length;u<h;u+=4){const c=T[u+0],g=T[u+1],_=T[u+2],P=T[u+3];T[u+0]=P,T[u+1]=_,T[u+2]=g,T[u+3]=c}}function R(T){const u=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return L.isLittleEndian()||C(u),m.VSBuffer.wrap(u)}function k(T){const u=T.buffer;if(L.isLittleEndian()||C(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const h=new Uint8Array(u.byteLength);return h.set(u),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(T){const u=new Uint32Array(A(T));let h=0;if(u[h++]=T.id,T.type==="full")u[h++]=1,u[h++]=T.data.length,u.set(T.data,h),h+=T.data.length;else{u[h++]=2,u[h++]=T.deltas.length;for(const c of T.deltas)u[h++]=c.start,u[h++]=c.deleteCount,c.data?(u[h++]=c.data.length,u.set(c.data,h),h+=c.data.length):u[h++]=0}return R(u)}e.encodeSemanticTokensDto=D;function A(T){let u=0;if(u+=1+1,T.type==="full")u+=1+T.data.length;else{u+=1,u+=(1+1+1)*T.deltas.length;for(const h of T.deltas)h.data&&(u+=h.data.length)}return u}function n(T){const u=k(T);let h=0;const c=u[h++];if(u[h++]===1){const E=u[h++],o=u.subarray(h,h+E);return h+=E,{id:c,type:"full",data:o}}const _=u[h++];let P=[];for(let E=0;E<_;E++){const o=u[h++],a=u[h++],v=u[h++];let t;v>0&&(t=u.subarray(h,h+v),h+=v),P[E]={start:o,deleteCount:a,data:t}}return{id:c,type:"delta",deltas:P}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(R,k){this._prefixSumIndexOfResultBrand=void 0,this.index=R,this.remainder=k}}e.PrefixSumIndexOfResult=L;class I{constructor(R){this.values=R,this.prefixSum=new Uint32Array(R.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(R,k){R=(0,m.toUint32)(R);const D=this.values,A=this.prefixSum,n=k.length;return n===0?!1:(this.values=new Uint32Array(D.length+n),this.values.set(D.subarray(0,R),0),this.values.set(D.subarray(R),R+n),this.values.set(k,R),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(R,k){return R=(0,m.toUint32)(R),k=(0,m.toUint32)(k),this.values[R]===k?!1:(this.values[R]=k,R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),!0)}removeValues(R,k){R=(0,m.toUint32)(R),k=(0,m.toUint32)(k);const D=this.values,A=this.prefixSum;if(R>=D.length)return!1;let n=D.length-R;return k>=n&&(k=n),k===0?!1:(this.values=new Uint32Array(D.length-k),this.values.set(D.subarray(0,R),0),this.values.set(D.subarray(R+k),R),this.prefixSum=new Uint32Array(this.values.length),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(R){return R<0?0:(R=(0,m.toUint32)(R),this._getPrefixSum(R))}_getPrefixSum(R){if(R<=this.prefixSumValidIndex[0])return this.prefixSum[R];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),R>=this.values.length&&(R=this.values.length-1);for(let D=k;D<=R;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],R),this.prefixSum[R]}getIndexOf(R){R=Math.floor(R),this.getTotalSum();let k=0,D=this.values.length-1,A=0,n=0,T=0;for(;k<=D;)if(A=k+(D-k)/2|0,n=this.prefixSum[A],T=n-this.values[A],R<T)D=A-1;else if(R>=n)k=A+1;else break;return new L(A,R-T)}}e.PrefixSumComputer=I}),define(me[150],ge([0,1,9,50,112]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,D,A,n){this._uri=k,this._lines=D,this._eol=A,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const A of D)this._acceptDeleteRange(A.range),this._acceptInsertText(new L.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,A=new Uint32Array(D);for(let n=0;n<D;n++)A[n]=this._lines[n].length+k;this._lineStarts=new I.PrefixSumComputer(A)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length===0)return;let A=(0,m.splitLines)(D);if(A.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+A[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}A[A.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+A[0]);let n=new Uint32Array(A.length-1);for(let T=1;T<A.length;T++)this._lines.splice(k.lineNumber+T-1,0,A[T]),n[T-1]=A[T].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,n)}}e.MirrorTextModel=C}),define(me[151],ge([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(me[152],ge([0,1,151]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,I=L*60,C=I*24,R=C*7,k=C*30,D=C*365;function A(T,u){typeof T!="number"&&(T=T.getTime());const h=Math.round((new Date().getTime()-T)/1e3);if(h<-30)return(0,m.localize)(0,null,A(new Date().getTime()+h*1e3,!1));if(h<30)return(0,m.localize)(1,null);let c;return h<L?(c=h,u?c===1?(0,m.localize)(2,null,c):(0,m.localize)(3,null,c):c===1?(0,m.localize)(4,null,c):(0,m.localize)(5,null,c)):h<I?(c=Math.floor(h/L),u?c===1?(0,m.localize)(6,null,c):(0,m.localize)(7,null,c):c===1?(0,m.localize)(8,null,c):(0,m.localize)(9,null,c)):h<C?(c=Math.floor(h/I),u?c===1?(0,m.localize)(10,null,c):(0,m.localize)(11,null,c):c===1?(0,m.localize)(12,null,c):(0,m.localize)(13,null,c)):h<R?(c=Math.floor(h/C),u?c===1?(0,m.localize)(14,null,c):(0,m.localize)(15,null,c):c===1?(0,m.localize)(16,null,c):(0,m.localize)(17,null,c)):h<k?(c=Math.floor(h/R),u?c===1?(0,m.localize)(18,null,c):(0,m.localize)(19,null,c):c===1?(0,m.localize)(20,null,c):(0,m.localize)(21,null,c)):h<D?(c=Math.floor(h/k),u?c===1?(0,m.localize)(22,null,c):(0,m.localize)(23,null,c):c===1?(0,m.localize)(24,null,c):(0,m.localize)(25,null,c)):(c=Math.floor(h/D),u?c===1?(0,m.localize)(26,null,c):(0,m.localize)(27,null,c):c===1?(0,m.localize)(28,null,c):(0,m.localize)(29,null,c))}e.fromNow=A;function n(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[153],ge([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,20,13,153]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(A,n){return n&&(A.stack||A.stacktrace)?I.localize(0,null,k(A),R(A.stack)||R(A.stacktrace)):k(A)}function R(A){return Array.isArray(A)?A.join(`
`):A}function k(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?I.localize(1,null,A.message):A.message||I.localize(2,null)}function D(A=null,n=!1){if(!A)return I.localize(3,null);if(Array.isArray(A)){const T=m.coalesce(A),u=D(T[0],n);return T.length>1?I.localize(4,null,u,T.length):u}if(L.isString(A))return A;if(A.detail){const T=A.detail;if(T.error)return C(T.error,n);if(T.exception)return C(T.exception,n)}return A.stack?C(A,n):A.message?A.message:I.localize(5,null)}e.toErrorMessage=D}),define(me[154],ge([18,19]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,25,8,11,34,13,143,28,154]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function h(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(a,v){if(k.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};v&&(t.cwd=v);const r=m.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(s=>{r.once("error",i=>{s({success:!1,error:i})}),r.once("exit",(i,l)=>{s(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?h(t.status):1})}else if(k.isLinux||k.isMacintosh)try{const t=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(r=>{m.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(s,i,l)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function g(a=D.env){return a.comspec||"cmd.exe"}e.getWindowsShell=g;class _{constructor(v,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=v,this.args=t,this.shell=r,this.options=s;else{const i=v;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(D.env).forEach(l=>{i[l]=D.env[l]}),Object.keys(this.options.env).forEach(l=>{i[l]=this.options.env[l]}),this.options.env=i}}getSanitizedCommand(){let v=this.cmd.toLowerCase();const t=v.lastIndexOf(R.sep);return t!==-1&&(v=v.substring(t+1)),_.WellKnowCommands[v]?v:"other"}start(v){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(D.cwd()))?Promise.reject(new Error(u.localize(0,null))):this.useExec().then(t=>{let r,s;const i=new Promise((l,d)=>{r=l,s=d});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=m.exec(l,this.options,(d,f,w)=>{this.childProcess=null;const y=d;y&&y.killed?s({killed:this.terminateRequested,stdout:f.toString(),stderr:w.toString()}):this.handleExec(r,v,d,f,w)})}else{let l=null;const d=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,r,v,s);const w={terminated:this.terminateRequested};A.isNumber(f)&&(w.cmdCode=f),r(w)};if(this.shell&&k.isWindows){const f=C.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let w=!1,y=!1;const p=[];let S=this.ensureQuotes(this.cmd);p.push(S.value),w=S.quoted,this.args&&this.args.forEach(F=>{S=this.ensureQuotes(F),p.push(S.value),y=y&&S.quoted});const b=["/s","/c"];w?y?b.push('"'+p.join(" ")+'"'):p.length>1?b.push('"'+p[0]+'" '+p.slice(1).join(" ")):b.push('"'+p[0]+'"'):b.push(p.join(" ")),l=m.spawn(g(),b,f)}else this.cmd&&(l=m.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(A.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",f=>{this.childProcess=null,s({terminated:this.terminateRequested,error:f})}),l.pid&&(this.childProcess.on("close",d),this.handleSpawn(l,r,v,s,!0)))}return i})}handleClose(v,t,r,s){}ensureQuotes(v){return _.regexp.test(v)?{value:'"'+v+'"',quoted:!0}:{value:v,quoted:v.length>0&&v[0]==='"'&&v[v.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(v=>v.pid,v=>-1):new Promise(v=>{this.pidResolve=v})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(v=>(this.terminateRequested=!0,c(v,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),v=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(v=>{if(!this.shell||!k.isWindows)return v(!1);const t=m.spawn(g(),["/s","/c"]);t.on("error",r=>v(!0)),t.on("exit",r=>v(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class P extends _{constructor(v,t,r,s){super(v,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(v,t,r,s,i){[s,i].forEach((l,d)=>{const f=new n.LineDecoder;f.write(l).forEach(p=>{t({line:p,source:d===0?0:1})});const y=f.end();y&&t({line:y,source:d===0?0:1})}),v({terminated:this.terminateRequested,error:r})}handleSpawn(v,t,r,s,i){const l=new n.LineDecoder,d=new n.LineDecoder;v.stdout.on("data",f=>{l.write(f).forEach(y=>r({line:y,source:0}))}),v.stderr.on("data",f=>{d.write(f).forEach(y=>r({line:y,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=d}handleClose(v,t,r,s){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&r({line:l,source:1})}}e.LineProcess=P;function E(a){let v=[],t=!1;const r=function(s){if(t){v.push(s);return}(!a.send(s,l=>{if(l&&console.error(l),t=!1,v.length>0){const d=v.slice(0);v=[],d.forEach(f=>r(f))}})||k.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=E;var o;(function(a){async function v(t,r,s){if(R.isAbsolute(t))return t;if(r===void 0&&(r=D.cwd()),R.dirname(t)!=="."||(s===void 0&&A.isString(D.env.PATH)&&(s=D.env.PATH.split(R.delimiter)),s===void 0||s.length===0))return R.join(r,t);async function l(d){if(await T.Promises.exists(d)){let f;try{f=await T.Promises.stat(d)}catch(w){w.message.startsWith("EACCES")&&(f=await T.Promises.lstat(d))}return f?!f.isDirectory():!1}return!1}for(let d of s){let f;if(R.isAbsolute(d)?f=R.join(d,t):f=R.join(r,d,t),await l(f))return f;let w=f+".com";if(await l(w)||(w=f+".exe",await l(w)))return w}return R.join(r,t)}a.findExecutable=v})(o=e.win32||(e.win32={}))}),define(me[155],ge([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(me[156],ge([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[157],ge([18,19]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[158],ge([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[159],ge([18,19]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[160],ge([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(me[161],ge([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(me[162],ge([18,19]),function(Z,e){return Z.create("vs/platform/theme/common/iconRegistry",e)}),define(me[163],ge([18,19]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(me[164],ge([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[165],ge([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[166],ge([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(me[167],ge([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[168],ge([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[169],ge([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[170],ge([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[171],ge([18,19]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[172],ge([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(me[173],ge([18,19]),function(Z,e){return Z.create("vs/workbench/common/views",e)}),define(me[174],ge([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[175],ge([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[176],ge([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[177],ge([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[178],ge([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[179],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var I;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[180],ge([0,1,158]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=C;function R(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=u.match(L);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=R;function k(u){if(!u)return null;let h=u.majorBase,c=u.majorMustEqual,g=u.minorBase,_=u.minorMustEqual,P=u.patchBase,E=u.patchMustEqual;u.hasCaret&&(h===0||(_=!1),E=!1);let o=0;if(u.preRelease){const a=I.exec(u.preRelease);if(a){const[,v,t,r]=a;o=Date.UTC(Number(v),Number(t)-1,Number(r))}}return{majorBase:h,majorMustEqual:c,minorBase:g,minorMustEqual:_,patchBase:P,patchMustEqual:E,isMinimum:u.hasGreaterEquals,notBefore:o}}e.normalizeVersion=k;function D(u,h,c){let g;typeof u=="string"?g=k(R(u)):g=u;let _;h instanceof Date?_=h.getTime():typeof h=="string"&&(_=new Date(h).getTime());let P;if(typeof c=="string"?P=k(R(c)):P=c,!g||!P)return!1;let E=g.majorBase,o=g.minorBase,a=g.patchBase,v=P.majorBase,t=P.minorBase,r=P.patchBase,s=P.notBefore,i=P.majorMustEqual,l=P.minorMustEqual,d=P.patchMustEqual;return P.isMinimum?E>v?!0:E<v?!1:o>t?!0:o<t||_&&_<s?!1:a>=r:(E===1&&v===0&&(!i||!l||!d)&&(v=1,t=0,r=0,i=!0,l=!1,d=!1),E<v?!1:E>v?!i:o<t?!1:o>t?!l:a<r?!1:a>r?!d:!(_&&_<s))}e.isValidVersion=D;function A(u,h,c,g){return c.isBuiltin||typeof c.main=="undefined"?!0:T(u,h,c.engines.vscode,g)}e.isValidExtensionVersion=A;function n(u,h,c){return u==="*"||T(h,c,u)}e.isEngineValid=n;function T(u,h,c,g=[]){let _=k(R(c));if(!_)return g.push(m.localize(0,null,c)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return g.push(m.localize(1,null,c)),!1}else if(!_.majorMustEqual)return g.push(m.localize(2,null,c)),!1;return D(u,h,_)?!0:(g.push(m.localize(3,null,u,c)),!1)}}),define(me[114],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(I,C=[],R=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=m}),define(me[82],ge([0,1,114]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function I(R,k,D){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],D)),L.push([R,k])}e.registerSingleton=I;function C(){return L}e.getSingletonServiceDescriptors=C}),define(me[181],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let R of this._nodes.values())R.outgoing.size===0&&C.push(R);return C}insertEdge(C,R){const k=this.lookupOrInsertNode(C),D=this.lookupOrInsertNode(R);k.outgoing.set(this._hashFn(R),D),D.incoming.set(this._hashFn(C),k)}removeNode(C){const R=this._hashFn(C);this._nodes.delete(R);for(let k of this._nodes.values())k.outgoing.delete(R),k.incoming.delete(R)}lookupOrInsertNode(C){const R=this._hashFn(C);let k=this._nodes.get(R);return k||(k=new m(C),this._nodes.set(R,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[R,k]of this._nodes)C.push(`${R}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,R]of this._nodes){const k=new Set([C]),D=this._findCycle(R,k);if(D)return D}}_findCycle(C,R){for(let[k,D]of C.outgoing){if(R.has(k))return[...R,k].join(" -> ");R.add(k);const A=this._findCycle(D,R);if(A)return A;R.delete(k)}}}e.Graph=L}),define(me[4],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(A){return A[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(m=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function L(k,D,A,n){D[m.DI_TARGET]===D?D[m.DI_DEPENDENCIES].push({id:k,index:A,optional:n}):(D[m.DI_DEPENDENCIES]=[{id:k,index:A,optional:n}],D[m.DI_TARGET]=D)}function I(k){if(m.serviceIds.has(k))return m.serviceIds.get(k);const D=function(A,n,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(D,A,T,!1)};return D.toString=()=>k,m.serviceIds.set(k,D),D}e.createDecorator=I;function C(k){return k}e.refineServiceDecorator=C;function R(k){return function(D,A,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(k,D,n,!0)}}e.optional=R}),define(me[182],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[183],ge([0,1,3,58,6,23,77,81,182]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(A):!!g.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(_,P){let E={selector:_,provider:P,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(E){let o=this._entries.indexOf(E);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(_){return this.all(_).length>0}all(_){if(!_)return[];this._updateScores(_);const P=[];for(let E of this._entries)E._score>0&&P.push(E.provider);return P}ordered(_){const P=[];return this._orderedForEach(_,E=>P.push(E.provider)),P}orderedGroups(_){const P=[];let E,o;return this._orderedForEach(_,a=>{E&&o===a._score?E.push(a.provider):(o=a._score,E=[a.provider],P.push(E))}),P}_orderedForEach(_,P){if(!!_){this._updateScores(_);for(const E of this._entries)E._score>0&&P(E)}}_updateScores(_){let P={uri:_.uri.toString(),language:_.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let E of this._entries)if(E._score=(0,k.score)(E.selector,_.uri,_.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(_)),A(E.selector)&&E._score>0){for(let o of this._entries)o._score=0;E._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(_,P){return _._score<P._score?1:_._score>P._score?-1:_._time<P._time?1:_._time>P._time?-1:0}}e.LanguageFeatureRegistry=n;const T=new WeakMap;let u=0;function h(g){let _=T.get(g);return _===void 0&&(_=++u,T.set(g,_)),_}class c{constructor(_,P,E=Number.MAX_SAFE_INTEGER){this._registry=_,this.min=P,this.max=E,this._cache=new C.LRUCache(50,.7)}_key(_){return _.id+this._registry.all(_).reduce((P,E)=>(0,L.doHash)(h(E),P),0)}_clamp(_){return _===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(_*1.3)))}get(_){const P=this._key(_),E=this._cache.get(P);return this._clamp(E?.value)}update(_,P){const E=this._key(_);let o=this._cache.get(E);return o||(o=new R.MovingAverage,this._cache.set(E,o)),o.update(P),this.get(_)}}e.LanguageFeatureRequestDelays=c}),define(me[83],ge([0,1,2,41,183,149,47]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class D{constructor(S,b){this.language=S,this.id=b}}e.LanguageIdentifier=D;var A;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(A=e.FontStyle||(e.FontStyle={}));var n;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var T;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var u;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(u=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&1792)>>>8}static getFontStyle(S){return(S&14336)>>>11}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){let b=this.getForeground(S),F="mtk"+b,N=this.getFontStyle(S);return N&1&&(F+=" mtki"),N&2&&(F+=" mtkb"),N&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(S,b){const F=this.getForeground(S),N=this.getFontStyle(S);let G=`color: ${b[F]};`;return N&1&&(G+="font-style: italic;"),N&2&&(G+="font-weight: bold;"),N&4&&(G+="text-decoration: underline;"),G}}e.TokenMetadata=h;var c;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(S){const b=p[S];let F=b&&R.iconRegistry.get(b);return F||(console.info("No codicon found for CompletionItemKind "+S),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(S,b){let F=p[S];return typeof F=="undefined"&&!b&&(F=9),F}}();var g;(function(p){p[p.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var P;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(P=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(p){return p&&m.URI.isUri(p.uri)&&L.Range.isIRange(p.range)&&(L.Range.isIRange(p.originSelectionRange)||L.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=t;var r;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(p){p[p.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(p){const S=new Map;S.set("file",0),S.set("module",1),S.set("namespace",2),S.set("package",3),S.set("class",4),S.set("method",5),S.set("property",6),S.set("field",7),S.set("constructor",8),S.set("enum",9),S.set("interface",10),S.set("function",11),S.set("variable",12),S.set("constant",13),S.set("string",14),S.set("number",15),S.set("boolean",16),S.set("array",17),S.set("object",18),S.set("key",19),S.set("null",20),S.set("enum-member",21),S.set("struct",22),S.set("event",23),S.set("operator",24),S.set("type-parameter",25);const b=new Map;b.set(0,"file"),b.set(1,"module"),b.set(2,"namespace"),b.set(3,"package"),b.set(4,"class"),b.set(5,"method"),b.set(6,"property"),b.set(7,"field"),b.set(8,"constructor"),b.set(9,"enum"),b.set(10,"interface"),b.set(11,"function"),b.set(12,"variable"),b.set(13,"constant"),b.set(14,"string"),b.set(15,"number"),b.set(16,"boolean"),b.set(17,"array"),b.set(18,"object"),b.set(19,"key"),b.set(20,"null"),b.set(21,"enum-member"),b.set(22,"struct"),b.set(23,"event"),b.set(24,"operator"),b.set(25,"type-parameter");function F(K){return S.get(K)}p.fromString=F;function N(K){return b.get(K)}p.toString=N;function G(K,M){const U=b.get(K);let O=U&&R.iconRegistry.get("symbol-"+U);return O||(console.info("No codicon found for SymbolKind "+K),O=R.Codicon.symbolProperty),`${M?"inline":"block"} ${O.classNames}`}p.toCssClassName=G})(i=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(S){this.value=S}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var d;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var w;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var y;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[61],ge([0,1,11,9,4]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",m.isMacintosh),R.set("isLinux",m.isLinux),R.set("isWindows",m.isWindows),R.set("isWeb",m.isWeb),R.set("isMacNative",m.isMacintosh&&!m.isWeb),R.set("isEdge",C.indexOf("Edg/")>=0),R.set("isFirefox",C.indexOf("Firefox")>=0),R.set("isChrome",C.indexOf("Chrome")>=0),R.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return T.INSTANCE}static true(){return u.INSTANCE}static has(b){return h.create(b)}static equals(b,F){return c.create(b,F)}static notEquals(b,F){return P.create(b,F)}static regex(b,F){return r.create(b,F)}static in(b,F){return g.create(b,F)}static not(b){return E.create(b)}static and(...b){return i.create(b,null)}static or(...b){return l.create(b,null,!0)}static greater(b,F){return o.create(b,F)}static less(b,F){return v.create(b,F)}static deserialize(b,F=!1){if(!!b)return this._deserializeOrExpression(b,F)}static _deserializeOrExpression(b,F){let N=b.split("||");return l.create(N.map(G=>this._deserializeAndExpression(G,F)),null,!0)}static _deserializeAndExpression(b,F){let N=b.split("&&");return i.create(N.map(G=>this._deserializeOne(G,F)),null)}static _deserializeOne(b,F){if(b=b.trim(),b.indexOf("!=")>=0){let N=b.split("!=");return P.create(N[0].trim(),this._deserializeValue(N[1],F))}if(b.indexOf("==")>=0){let N=b.split("==");return c.create(N[0].trim(),this._deserializeValue(N[1],F))}if(b.indexOf("=~")>=0){let N=b.split("=~");return r.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(b.indexOf(" in ")>=0){let N=b.split(" in ");return g.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const N=b.split(">=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const N=b.split(">");return o.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const N=b.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const N=b.split("<");return v.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(b)?E.create(b.substr(1).trim()):h.create(b)}static _deserializeValue(b,F){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let N=/^'([^']*)'$/.exec(b);return N?N[1].trim():b}static _deserializeRegexValue(b,F){if((0,L.isFalsyOrWhitespace)(b)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=b.indexOf("/"),G=b.lastIndexOf("/");if(N===G||N<0){if(F)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let K=b.slice(N+1,G),M=b[G+1]==="i"?"i":"";try{return new RegExp(K,M)}catch(U){if(F)throw new Error(`bad regexp-value '${b}', parse error: ${U}`);return console.warn(`bad regexp-value '${b}', parse error: ${U}`),null}}}e.ContextKeyExpr=A;function n(S,b){return S.cmp(b)}class T{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class u{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class h{constructor(b,F){this.key=b,this.negated=F,this.type=2}static create(b,F=null){const N=R.get(b);return typeof N=="boolean"?N?u.INSTANCE:T.INSTANCE:new h(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:f(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class c{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=4}static create(b,F,N=null){if(typeof F=="boolean")return F?h.create(b,N):E.create(b,N);const G=R.get(b);return typeof G=="boolean"?F===(G?"true":"false")?u.INSTANCE:T.INSTANCE:new c(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class g{constructor(b,F){this.key=b,this.valueKey=F,this.type=10,this.negated=null}static create(b,F){return new g(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}evaluate(b){const F=b.getValue(this.valueKey),N=b.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?k.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=_.create(this)),this.negated}}e.ContextKeyInExpr=g;class _{constructor(b){this._actual=b,this.type=11}static create(b){return new _(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new _(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class P{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=5}static create(b,F,N=null){if(typeof F=="boolean")return F?E.create(b,N):h.create(b,N);const G=R.get(b);return typeof G=="boolean"?F===(G?"true":"false")?T.INSTANCE:u.INSTANCE:new P(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=P;class E{constructor(b,F){this.key=b,this.negated=F,this.type=3}static create(b,F=null){const N=R.get(b);return typeof N=="boolean"?N?T.INSTANCE:u.INSTANCE:new E(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:f(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;class o{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=12}static create(b,F,N=null){return new o(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class a{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=13}static create(b,F,N=null){return new a(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class v{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=14}static create(b,F,N=null){return new v(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=v;class t{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=15}static create(b,F,N=null){return new t(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(b,F){this.key=b,this.regexp=F,this.type=7,this.negated=null}static create(b,F){return new r(b,F)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const F=this.regexp?this.regexp.source:"",N=b.regexp?b.regexp.source:"";return F<N?-1:F>N?1:0}equals(b){if(b.type===this.type){const F=this.regexp?this.regexp.source:"",N=b.regexp?b.regexp.source:"";return this.key===b.key&&F===N}return!1}evaluate(b){let F=b.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(b){this._actual=b,this.type=8}static create(b){return new s(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new s(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(b,F){this.expr=b,this.negated=F,this.type=6}static create(b,F){return i._normalizeArr(b,F)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const G=n(this.expr[F],b.expr[F]);if(G!==0)return G}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}evaluate(b){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(b))return!1;return!0}static _normalizeArr(b,F){const N=[];let G=!1;for(const K of b)if(!!K){if(K.type===1){G=!0;continue}if(K.type===0)return T.INSTANCE;if(K.type===6){N.push(...K.expr);continue}N.push(K)}if(N.length===0&&G)return u.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(n);for(let K=1;K<N.length;K++)N[K-1].equals(N[K])&&(N.splice(K,1),K--);if(N.length===1)return N[0];for(;N.length>1;){const K=N[N.length-1];if(K.type!==9)break;N.pop();const M=N.pop(),U=N.length===0,O=l.create(K.expr.map($=>i.create([$,M],null)),null,U);O&&(N.push(O),N.sort(n))}return N.length===1?N[0]:new i(N,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let F of this.expr)b.push(...F.keys());return b}map(b){return new i(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.negated){const b=[];for(let F of this.expr)b.push(F.negate());this.negated=l.create(b,this,!0)}return this.negated}}class l{constructor(b,F){this.expr=b,this.negated=F,this.type=9}static create(b,F,N){return l._normalizeArr(b,F,N)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const G=n(this.expr[F],b.expr[F]);if(G!==0)return G}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}evaluate(b){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(b))return!0;return!1}static _normalizeArr(b,F,N){let G=[],K=!1;if(b){for(let M=0,U=b.length;M<U;M++){const O=b[M];if(!!O){if(O.type===0){K=!0;continue}if(O.type===1)return u.INSTANCE;if(O.type===9){G=G.concat(O.expr);continue}G.push(O)}}if(G.length===0&&K)return T.INSTANCE;G.sort(n)}if(G.length!==0){if(G.length===1)return G[0];for(let M=1;M<G.length;M++)G[M-1].equals(G[M])&&(G.splice(M,1),M--);if(G.length===1)return G[0];if(N){for(let M=0;M<G.length;M++)for(let U=M+1;U<G.length;U++)y(G[M],G[U])&&(G.splice(U,1),U--);if(G.length===1)return G[0]}return new l(G,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let F of this.expr)b.push(...F.keys());return b}map(b){return new l(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.negated){let b=[];for(let F of this.expr)b.push(F.negate());for(;b.length>1;){const F=b.shift(),N=b.shift(),G=[];for(const M of p(F))for(const U of p(N))G.push(i.create([M,U],null));const K=b.length===0;b.unshift(l.create(G,null,K))}this.negated=b[0]}return this.negated}}class d extends h{constructor(b,F,N){super(b,null);this._defaultValue=F,typeof N=="object"?d._info.push({...N,key:b}):N!==!0&&d._info.push({key:b,description:N,type:F!=null?typeof F:void 0})}static all(){return d._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return c.create(this.key,b)}notEqualsTo(b){return P.create(this.key,b)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(S,b){return S<b?-1:S>b?1:0}function w(S,b,F,N){return S<F?-1:S>F?1:b<N?-1:b>N?1:0}function y(S,b){if(b.type===6&&S.type!==9&&S.type!==6){for(const G of b.expr)if(S.equals(G))return!0}const F=S.negate(),N=p(F).concat(p(b));N.sort(n);for(let G=0;G<N.length;G++){const M=N[G].negate();for(let U=G+1;U<N.length;U++){const O=N[U];if(M.equals(O))return!0}}return!1}e.implies=y;function p(S){return S.type===9?S.expr:[S]}}),define(me[184],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(me[185],ge([0,1,10,11,34,157,4]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(P){P.WIN32_X64="win32-x64",P.WIN32_IA32="win32-ia32",P.WIN32_ARM64="win32-arm64",P.LINUX_X64="linux-x64",P.LINUX_ARM64="linux-arm64",P.LINUX_ARMHF="linux-armhf",P.DARWIN_X64="darwin-x64",P.DARWIN_ARM64="darwin-arm64",P.WEB="web",P.UNIVERSAL="universal",P.UNKNOWN="unknown",P.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function D(P){switch(P){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function A(P,E){let o;switch(P){case 1:o=3;break;case 3:o=2;break;case 2:o=1;break}return n(o,E)}e.getTargetPlatformFromOS=A;function n(P,E){switch(P){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=n,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":n(L.platform,I.arch);function T(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=T;var u;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(u=e.SortBy||(e.SortBy={}));var h;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var c;(function(P){P.Install="install",P.Uninstall="uninstall"})(c=e.StatisticType||(e.StatisticType={}));var g;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class _ extends Error{constructor(E,o){super(E);this.code=o,this.name=o}}e.ExtensionManagementError=_,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,C.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,C.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=I;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class k{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,u){if(typeof T=="undefined"||T===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof T=="string"||typeof u=="string"){let h=typeof T=="string"?T:T.value,c=typeof u=="string"?u:u.value;return m.equalsIgnoreCase(h,c)}return T._lower===u._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=k;function D(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function A(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=A,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[186],ge([0,1,9,26]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(c,g){return c.uuid&&g.uuid?c.uuid===g.uuid:c.id===g.id?!0:(0,m.compareIgnoreCase)(c.id,g.id)===0}e.areSameExtensions=I;class C{constructor(g,_){this.version=_,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof C?I(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=C;function R(c,g){return`${c}.${g}`}e.getExtensionId=R;function k(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(c,g){return k(R(c,g))}e.getGalleryExtensionId=D;function A(c,g){const _=[],P=E=>{for(const o of _)if(o.some(a=>I(g(a),g(E))))return o;return null};for(const E of c){const o=P(E);o?o.push(E):_.push([E])}return _}e.groupByExtension=A;function n(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function T(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function u(c){const g=new Set;for(const _ of c)_.malicious&&g.add(_.id.id);return g}e.getMaliciousExtensionsSet=u;function h(c,g){const _=[],P=g.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const E=P.shift();if(E&&_.every(o=>!I(o.identifier,{id:E}))){const o=c.filter(a=>I(a.identifier,{id:E}));o.length===1&&(_.push(o[0]),P.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=h}),define(me[187],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(me[188],ge([0,1,39,10,8,11,141,28,113,159,187]),function(Z,e,m,L,I,C,R,k,D,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=A.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends u{openTerminal(a,v){return this.spawnTerminal(m,a,D.getWindowsShell(),v)}spawnTerminal(a,v,t,r){const s=v.windowsExec||h.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=I.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),(i==="wt"||i==="wt.exe")&&l.push("-d ."),new Promise((d,f)=>{const w=_(process),y=a.spawn(t,l,{cwd:r,env:w});y.on("error",f),y.on("exit",()=>d())})}runInTerminal(a,v,t,r,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows();return new Promise((l,d)=>{const f=`"${v} - ${T}"`,w=`""${t.join('" "')}" & pause"`,y=["/c","start",f,"/wait",i,"/c",w],p=Object.assign({},_(process),r);Object.keys(p).filter(F=>p[F]===null).forEach(F=>delete p[F]);const S={cwd:v,env:p,windowsVerbatimArguments:!0};m.spawn(h.CMD,y,S).on("error",F=>{d(P(F))}),l(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h,h.CMD="cmd.exe";class c extends u{openTerminal(a,v){return this.spawnTerminal(m,a,v)}runInTerminal(a,v,t,r,s){const i=s.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((l,d)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const f=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,Z).fsPath,"-t",a||T,"-w",v];for(let b of t)y.push("-a"),y.push(b);if(r){const b=Object.assign({},_(process),r);for(let F in b){const N=b[F];N===null?(y.push("-u"),y.push(F)):(y.push("-e"),y.push(`${F}=${N}`))}}let p="";const S=m.spawn(c.OSASCRIPT,y);S.on("error",b=>{d(P(b))}),S.stderr.on("data",b=>{p+=b.toString()}),S.on("exit",b=>{if(b===0)l(void 0);else if(p){const F=p.split(`
`,1);d(new Error(F[0]))}else d(new Error(A.localize(1,null,f,b)))})}else d(new Error(A.localize(2,null,i)))})}spawnTerminal(a,v,t){const r=v.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const l=["-a",r];t&&l.push(t);const d=_(process),f=a.spawn("/usr/bin/open",l,{cwd:t,env:d});f.on("error",i),f.on("exit",()=>s())})}}e.MacExternalTerminalService=c,c.OSASCRIPT="/usr/bin/osascript";class g extends u{openTerminal(a,v){return this.spawnTerminal(m,a,v)}runInTerminal(a,v,t,r,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,d)=>{let f=[];i.then(w=>{w.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const y=`${E(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;f.push(`''${y}''`);const p=Object.assign({},_(process),r);Object.keys(p).filter(N=>p[N]===null).forEach(N=>delete p[N]);const S={cwd:v,env:p};let b="";const F=m.spawn(w,f,S);F.on("error",N=>{d(P(N))}),F.stderr.on("data",N=>{b+=N.toString()}),F.on("exit",N=>{if(N===0)l(void 0);else if(b){const G=b.split(`
`,1);d(new Error(G[0]))}else d(new Error(A.localize(4,null,w,N)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{C.isLinux?await k.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,v,t){const r=v.linuxExec?Promise.resolve(v.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{r.then(l=>{const d=_(process),f=a.spawn(l,[],{cwd:t,env:d});f.on("error",i),f.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=A.localize(3,null);function _(o){const a={...o.env};return(0,R.sanitizeProcessEnvironment)(a),a}function P(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(A.localize(5,null,o.path)):o}function E(o){let a="";for(let v of o)v.indexOf(" ")>=0?a+='"'+v+'"':a+=v,a+=" ";return a}}),define(me[42],ge([0,1,23,8,9,13,2,160,4]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function A(M){return M.create===!0}e.isFileOpenForWriteOptions=A;var n;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var T;(function(M){M[M.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var u;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=h;function c(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=c;function g(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function _(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=_;var P;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(U,O){super(U);this.code=O}}e.FileSystemProviderError=E;function o(M,U){const O=new E(M.toString(),U);return v(O,U),O}e.createFileSystemProviderError=o;function a(M){return M||o((0,k.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=a;function v(M,U){return M.name=U?`${U} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=v;function t(M){if(!M)return P.Unknown;if(M instanceof E)return M.code;const U=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!U)return P.Unknown;switch(U[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=t;function r(M){if(M instanceof w)return M.fileOperationResult;switch(t(M)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(U,O,$){this.resource=U,this.operation=O,this.target=$}isOperation(U){return this.operation===U}}e.FileOperationEvent=i;var l;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class d{constructor(U,O){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of U)switch($.type){case 1:this.added||(this.added=m.TernarySearchTree.forUris(()=>O)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=m.TernarySearchTree.forUris(()=>O)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=m.TernarySearchTree.forUris(()=>O)),this.deleted.set($.resource,$);break}}contains(U,...O){return this.doContains(U,{includeChildren:!1},...O)}affects(U,...O){return this.doContains(U,{includeChildren:!0},...O)}doContains(U,O,...$){if(!U)return!1;const B=$.length>0;return!!((!B||$.includes(1))&&(this.added?.get(U)||O.includeChildren&&this.added?.findSuperstr(U))||(!B||$.includes(0))&&(this.updated?.get(U)||O.includeChildren&&this.updated?.findSuperstr(U))||(!B||$.includes(2))&&(this.deleted?.findSubstr(U)||O.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function f(M,U,O){return!M||!U||M===U||U.length>M.length?!1:(U.charAt(U.length-1)!==L.sep&&(U+=L.sep),O?(0,I.startsWithIgnoreCase)(M,U):M.indexOf(U)===0)}e.isParent=f;class w extends Error{constructor(U,O,$){super(U);this.fileOperationResult=O,this.options=$}}e.FileOperationError=w;class y extends w{constructor(U,O,$){super(U,2,$);this.stat=O}}e.NotModifiedSinceFileOperationError=y;var p;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(p=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var S;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(S=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function b(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=b;async function F(M,U){if(!U.canHandleResource(R.URI.from({scheme:M.scheme})))return new Promise(O=>{const $=U.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===M.scheme&&B.added&&($.dispose(),O())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(U){return(0,C.isNumber)(U)||(U=0),U<N.KB?(0,k.localize)(1,null,U.toFixed(0)):U<N.MB?(0,k.localize)(2,null,(U/N.KB).toFixed(2)):U<N.GB?(0,k.localize)(3,null,(U/N.MB).toFixed(2)):U<N.TB?(0,k.localize)(4,null,(U/N.GB).toFixed(2)):(0,k.localize)(5,null,(U/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var G;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function K(M){return{maxFileSize:M===0?300*N.MB:16*N.GB,maxHeapSize:M===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=K}),define(me[84],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...I){this._entries=new Map;for(let[C,R]of I)this.set(C,R)}set(I,C){const R=this._entries.get(I);return this._entries.set(I,C),R}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=m}),define(me[189],ge([0,1,17,16,114,181,4,84]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class A extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class n{constructor(c=new k.ServiceCollection,g=!1,_){this._activeInstantiations=new Set,this._services=c,this._strict=g,this._parent=_,this._services.set(R.IInstantiationService,this)}createChild(c){return new n(c,this._strict,this)}invokeFunction(c,...g){let _=u.traceInvocation(c),P=!1;try{return c({get:(o,a)=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(o,_);if(!v&&a!==R.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return v}},...g)}finally{P=!0,_.stop()}}createInstance(c,...g){let _,P;return c instanceof I.SyncDescriptor?(_=u.traceCreation(c.ctor),P=this._createInstance(c.ctor,c.staticArguments.concat(g),_)):(_=u.traceCreation(c),P=this._createInstance(c,g,_)),_.stop(),P}_createInstance(c,g=[],_){let P=R._util.getServiceDependencies(c).sort((a,v)=>a.index-v.index),E=[];for(const a of P){let v=this._getOrCreateServiceInstance(a.id,_);if(!v&&this._strict&&!a.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${a.id}.`);E.push(v)}let o=P.length>0?P[0].index:g.length;if(g.length!==o){console.warn(`[createInstance] First service dependency of ${c.name} at position ${o+1} conflicts with ${g.length} static arguments`);let a=o-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,o)}return new c(...[...g,...E])}_setServiceInstance(c,g){if(this._services.get(c)instanceof I.SyncDescriptor)this._services.set(c,g);else if(this._parent)this._parent._setServiceInstance(c,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let g=this._services.get(c);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):g}_getOrCreateServiceInstance(c,g){let _=this._getServiceInstanceOrDescriptor(c);return _ instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,_,g.branch(c,!0)):(g.branch(c,!1),_)}_safeCreateAndCacheServiceInstance(c,g,_){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,g,_)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,g,_){const P=new C.Graph(a=>a.id.toString());let E=0;const o=[{id:c,desc:g,_trace:_}];for(;o.length;){const a=o.pop();if(P.lookupOrInsertNode(a),E++>1e3)throw new A(P);for(let v of R._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${c} depends on ${v.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const r={id:v.id,desc:t,_trace:a._trace.branch(v.id,!0)};P.insertEdge(a,r),o.push(r)}}}for(;;){const a=P.roots();if(a.length===0){if(!P.isEmpty())throw new A(P);break}for(const{data:v}of a){if(this._getServiceInstanceOrDescriptor(v.id)instanceof I.SyncDescriptor){const r=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,r)}P.removeNode(v)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,g,_=[],P,E){if(this._services.get(c)instanceof I.SyncDescriptor)return this._createServiceInstance(g,_,P,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,g,_,P,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(c,g=[],_,P){if(_){const E=new m.IdleValue(()=>this._createInstance(c,g,P));return new Proxy(Object.create(null),{get(o,a){if(a in o)return o[a];let v=E.value,t=v[a];return typeof t!="function"||(t=t.bind(v),o[a]=t),t},set(o,a,v){return E.value[a]=v,!0}})}else return this._createInstance(c,g,P)}}e.InstantiationService=n;var T;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(T||(T={}));class u{constructor(c,g){this.type=c,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return D?new u(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(c){return D?new u(0,c.name):u._None}branch(c,g){let _=new u(2,c.toString());return this._dep.push([c,g,_]),_}stop(){let c=Date.now()-this._start;u._totals+=c;let g=!1;function _(E,o){let a=[],v=new Array(E+1).join("	");for(const[t,r,s]of o._dep)if(r&&s){g=!0,a.push(`${v}CREATES -> ${t}`);let i=_(E+1,s);i&&a.push(i)}else a.push(`${v}uses -> ${t}`);return a.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(c>2||g)&&console.log(P.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(me[12],ge([0,1,60,3,6,11,4]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class A extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class n extends A{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(l){}r+=(s>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class T extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...r){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...r):console.log(`[main ${k()}]`,t,...r))}debug(t,...r){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...r):console.log(`[main ${k()}]`,t,...r))}info(t,...r){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...r):console.log(`[main ${k()}]`,t,...r))}warn(t,...r){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...r):console.warn(`[main ${k()}]`,t,...r))}error(t,...r){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...r):console.error(`[main ${k()}]`,t,...r))}critical(t,...r){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...r):console.error(`[main ${k()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class u extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=u;class h extends A{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,m.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class c extends A{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class g extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=g;class _ extends I.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?D.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class P{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=P;function E(v){if(v.verbose)return D.Trace;if(typeof v.logLevel=="string"){const t=o(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function o(v){switch(v){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=o;function a(v){switch(v){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=a}),define(me[115],ge([0,1,42,12]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function I(D,A,n,T){try{const u=await new Promise((h,c)=>{Z(["spdlog"],h,c)});return u.setFlushOn(L.LogLevel.Trace),u.createAsyncRotatingLogger(D,A,n,T)}catch(u){console.error(u)}return null}function C(D,A,n,T){const u=Z.__$__nodeRequire("spdlog");return u.setFlushOn(L.LogLevel.Trace),u.createRotatingLogger(D,A,n,T)}e.createRotatingLogger=C;function R(D,A,n){switch(A){case L.LogLevel.Trace:D.trace(n);break;case L.LogLevel.Debug:D.debug(n);break;case L.LogLevel.Info:D.info(n);break;case L.LogLevel.Warning:D.warn(n);break;case L.LogLevel.Error:D.error(n);break;case L.LogLevel.Critical:D.critical(n);break;default:throw new Error("Invalid log level")}}class k extends L.AbstractMessageLogger{constructor(A,n,T,u){super();this.name=A,this.filepath=n,this.rotating=T,this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}_createSpdLogLogger(){const A=this.rotating?6:1,n=30/A*m.ByteSize.MB;return I(this.name,this.filepath,n,A).then(T=>{if(T){this._logger=T,this._logger.setLevel(this.getLevel());for(const{level:u,message:h}of this.buffer)R(this._logger,u,h);this.buffer=[]}})}log(A,n){this._logger?R(this._logger,A,n):this.getLevel()<=A&&this.buffer.push({level:A,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(me[116],ge([0,1,48,161,4]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function A(c,g){return g-c}D.compare=A;const n=Object.create(null);n[D.Error]=(0,L.localize)(0,null),n[D.Warning]=(0,L.localize)(1,null),n[D.Info]=(0,L.localize)(2,null);function T(c){return n[c]||""}D.toString=T;function u(c){switch(c){case m.default.Error:return D.Error;case m.default.Warning:return D.Warning;case m.default.Info:return D.Info;case m.default.Ignore:return D.Hint}}D.fromSeverity=u;function h(c){switch(c){case D.Error:return m.default.Error;case D.Warning:return m.default.Warning;case D.Info:return m.default.Info;case D.Hint:return m.default.Ignore}}D.toSeverity=h}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const A="";function n(u){return T(u,!0)}D.makeKey=n;function T(u,h){let c=[A];return u.source?c.push(u.source.replace("\xA6","\\\xA6")):c.push(A),u.code?typeof u.code=="string"?c.push(u.code.replace("\xA6","\\\xA6")):c.push(u.code.value.replace("\xA6","\\\xA6")):c.push(A),u.severity!==void 0&&u.severity!==null?c.push(R.toString(u.severity)):c.push(A),u.message&&h?c.push(u.message.replace("\xA6","\\\xA6")):c.push(A),u.startLineNumber!==void 0&&u.startLineNumber!==null?c.push(u.startLineNumber.toString()):c.push(A),u.startColumn!==void 0&&u.startColumn!==null?c.push(u.startColumn.toString()):c.push(A),u.endLineNumber!==void 0&&u.endLineNumber!==null?c.push(u.endLineNumber.toString()):c.push(A),u.endColumn!==void 0&&u.endColumn!==null?c.push(u.endColumn.toString()):c.push(A),c.push(A),c.join("\xA6")}D.makeKeyOptionalMessage=T})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(me[190],ge([0,1,3,48,4]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,I.createDecorator)("notificationService");var C;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=D}),define(me[191],ge([0,1,6,9,2,4]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function R(k,D){return I.URI.isUri(k)?(0,L.equalsIgnoreCase)(k.scheme,D):(0,L.startsWithIgnoreCase)(k,D+":")}e.matchesScheme=R}),define(me[117],ge([0,1,10,11,34,24]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)R=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const k=(0,C.dirname)(m.FileAccess.asFileUri("",Z));R=Z.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const D=Z.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:D.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R}),define(me[118],ge([0,1,155,11,110,117]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var R;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(R=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=k;class D{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=D;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class n{constructor(te,pe,ze,tt){this.id=te,this.name=pe,this.defaultValue=ze,this.schema=tt}compute(te,pe,ze){return ze}}class T{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class u{constructor(te,pe,ze,tt){this.id=te,this.name=pe,this.defaultValue=ze,this.schema=tt}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,ze){return ze}}function h(Q,te){return typeof Q=="undefined"?te:Q==="false"?!1:Boolean(Q)}e.boolean=h;class c extends u{constructor(te,pe,ze,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=ze),super(te,pe,ze,tt)}validate(te){return h(te,this.defaultValue)}}class g extends u{constructor(te,pe,ze,tt,st,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=ze,lt.minimum=tt,lt.maximum=st),super(te,pe,ze,lt),this.minimum=tt,this.maximum=st}static clampedInt(te,pe,ze,tt){if(typeof te=="undefined")return pe;let st=parseInt(te,10);return isNaN(st)?pe:(st=Math.max(ze,st),st=Math.min(tt,st),st|0)}validate(te){return g.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class _ extends u{constructor(te,pe,ze,tt,st){typeof st!="undefined"&&(st.type="number",st.default=ze),super(te,pe,ze,st),this.validationFn=tt}static clamp(te,pe,ze){return te<pe?pe:te>ze?ze:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const ze=parseFloat(te);return isNaN(ze)?pe:ze}validate(te){return this.validationFn(_.float(te,this.defaultValue))}}class P extends u{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,ze,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=ze),super(te,pe,ze,tt)}validate(te){return P.string(te,this.defaultValue)}}function E(Q,te,pe){return typeof Q!="string"||pe.indexOf(Q)===-1?te:Q}e.stringSet=E;class o extends u{constructor(te,pe,ze,tt,st=void 0){typeof st!="undefined"&&(st.type="string",st.enum=tt,st.default=ze),super(te,pe,ze,st),this._allowedValues=tt}validate(te){return E(te,this.defaultValue,this._allowedValues)}}class a extends n{constructor(te,pe,ze,tt,st,lt,vt=void 0){typeof vt!="undefined"&&(vt.type="string",vt.enum=st,vt.default=tt),super(te,pe,ze,vt),this._allowedValues=st,this._convert=lt}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function v(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,ze){return ze===0?te.accessibilitySupport:ze}}class r extends n{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:m.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:h(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(Q){switch(Q){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function f(Q){switch(Q){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class w extends T{constructor(){super(127,[65,32])}compute(te,pe,ze){const tt=["monaco-editor"];return pe.get(32)&&tt.push(pe.get(32)),te.extraEditorClassName&&tt.push(te.extraEditorClassName),pe.get(65)==="default"?tt.push("mouse-default"):pe.get(65)==="copy"&&tt.push("mouse-copy"),pe.get(100)&&tt.push("showUnused"),pe.get(125)&&tt.push("showDeprecated"),tt.join(" ")}}class y extends c{constructor(){super(31,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(te,pe,ze){return ze&&te.emptySelectionClipboard}}class p extends n{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:m.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:h(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":E(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":E(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(pe.loop,this.defaultValue.loop)}}}class S extends n{constructor(){super(43,"fontLigatures",S.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?S.OFF:te==="true"?S.ON:te:Boolean(te)?S.ON:S.OFF}}e.EditorFontLigatures=S,S.OFF='"liga" off, "calt" off',S.ON='"liga" on, "calt" on';class b extends T{constructor(){super(42)}compute(te,pe,ze){return te.fontInfo}}class F extends u{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(te){let pe=_.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(pe,6,100)}compute(te,pe,ze){return te.fontInfo.fontSize}}class N extends n{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(g.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class G extends n{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:ze,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:ze,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:ze,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:ze,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:ze,description:m.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:E(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??E(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??E(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??E(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??E(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??E(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends n{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:m.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:h(pe.enabled,this.defaultValue.enabled),delay:g.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:h(pe.sticky,this.defaultValue.sticky)}}}var M;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class U extends T{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,ze){return U.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,ze=te.scrollBeyondLastLine?pe-1:0,tt=(te.viewLineCount+ze)/(te.pixelRatio*te.height),st=Math.floor(te.viewLineCount/tt);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:ze,desiredRatio:tt,minimapLineCount:st}}static _computeMinimapLayout(te,pe){const ze=te.outerWidth,tt=te.outerHeight,st=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const lt=pe.stableMinimapLayoutInput,vt=lt&&te.outerHeight===lt.outerHeight&&te.lineHeight===lt.lineHeight&&te.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&te.pixelRatio===lt.pixelRatio&&te.scrollBeyondLastLine===lt.scrollBeyondLastLine&&te.minimap.enabled===lt.minimap.enabled&&te.minimap.side===lt.minimap.side&&te.minimap.size===lt.minimap.size&&te.minimap.showSlider===lt.minimap.showSlider&&te.minimap.renderCharacters===lt.minimap.renderCharacters&&te.minimap.maxColumn===lt.minimap.maxColumn&&te.minimap.scale===lt.minimap.scale&&te.verticalScrollbarWidth===lt.verticalScrollbarWidth&&te.isViewportWrapping===lt.isViewportWrapping,Dt=te.lineHeight,ue=te.typicalHalfwidthCharacterWidth,Ie=te.scrollBeyondLastLine,Ue=te.minimap.renderCharacters;let Ge=st>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const $e=te.minimap.maxColumn,ot=te.minimap.size,Re=te.minimap.side,ye=te.verticalScrollbarWidth,Ce=te.viewLineCount,ne=te.remainingWidth,de=te.isViewportWrapping,be=Ue?2:3;let we=Math.floor(st*tt);const Fe=we/st;let qe=!1,He=!1,Je=be*Ge,nt=Ge/st,ae=1;if(ot==="fill"||ot==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeyondLastLine:at,desiredRatio:wt,minimapLineCount:_t}=U.computeContainedMinimapLineCount({viewLineCount:Ce,scrollBeyondLastLine:Ie,height:tt,lineHeight:Dt,pixelRatio:st});if(Ce/_t>1)qe=!0,He=!0,Ge=1,Je=1,nt=Ge/st;else{let gt=!1,ft=Ge+1;if(ot==="fit"){const Tt=Math.ceil((Ce+at)*Je);de&&vt&&ne<=pe.stableFitRemainingWidth?(gt=!0,ft=pe.stableFitMaxMinimapScale):gt=Tt>we}if(ot==="fill"||gt){qe=!0;const Tt=Ge;Je=Math.min(Dt*st,Math.max(1,Math.floor(1/wt))),de&&vt&&ne<=pe.stableFitRemainingWidth&&(ft=pe.stableFitMaxMinimapScale),Ge=Math.min(ft,Math.max(1,Math.floor(Je/be))),Ge>Tt&&(ae=Math.min(2,Ge/Tt)),nt=Ge/st/ae,we=Math.ceil(Math.max(Xe,Ce+at)*Je),de?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ne,pe.stableFitMaxMinimapScale=Ge):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Ee=Math.floor($e*nt),ce=Math.min(Ee,Math.max(0,Math.floor((ne-ye-2)*nt/(ue+nt)))+e.MINIMAP_GUTTER_WIDTH);let q=Math.floor(st*ce);const Te=q/st;q=Math.floor(q*ae);const Pe=Ue?1:2,Ye=Re==="left"?0:ze-ce-ye;return{renderMinimap:Pe,minimapLeft:Ye,minimapWidth:ce,minimapHeightIsEditorHeight:qe,minimapIsSampling:He,minimapScale:Ge,minimapLineHeight:Je,minimapCanvasInnerWidth:q,minimapCanvasInnerHeight:we,minimapCanvasOuterWidth:Te,minimapCanvasOuterHeight:Fe}}static computeLayout(te,pe){const ze=pe.outerWidth|0,tt=pe.outerHeight|0,st=pe.lineHeight|0,lt=pe.lineNumbersDigitCount|0,vt=pe.typicalHalfwidthCharacterWidth,Dt=pe.maxDigitWidth,ue=pe.pixelRatio,Ie=pe.viewLineCount,Ue=te.get(122),Ge=Ue==="inherit"?te.get(121):Ue,$e=Ge==="inherit"?te.get(117):Ge,ot=te.get(120),Re=te.get(2),ye=pe.isDominatedByLongLines,Ce=te.get(48),ne=te.get(59).renderType!==0,de=te.get(60),be=te.get(94),we=te.get(64),Fe=te.get(92),qe=Fe.verticalScrollbarSize,He=Fe.verticalHasArrows,Je=Fe.arrowSize,nt=Fe.horizontalScrollbarSize,ae=te.get(57),Ee=te.get(36);let ce;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const Bt=parseFloat(ae.substr(0,ae.length-2));ce=g.clampedInt(Bt*vt,0,0,1e3)}else ce=g.clampedInt(ae,0,0,1e3);Ee&&(ce+=16);let q=0;if(ne){const Bt=Math.max(lt,de);q=Math.round(Bt*Dt)}let Te=0;Ce&&(Te=st);let Pe=0,Ye=Pe+Te,Xe=Ye+q,at=Xe+ce;const wt=ze-Te-q-ce;let _t=!1,ht=!1,gt=-1;Re!==2&&(Ge==="inherit"&&ye?(_t=!0,ht=!0):$e==="on"||$e==="bounded"?ht=!0:$e==="wordWrapColumn"&&(gt=ot));const ft=U._computeMinimapLayout({outerWidth:ze,outerHeight:tt,lineHeight:st,typicalHalfwidthCharacterWidth:vt,pixelRatio:ue,scrollBeyondLastLine:be,minimap:we,verticalScrollbarWidth:qe,viewLineCount:Ie,remainingWidth:wt,isViewportWrapping:ht},pe.memory||new A);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Pe+=ft.minimapWidth,Ye+=ft.minimapWidth,Xe+=ft.minimapWidth,at+=ft.minimapWidth);const Tt=wt-ft.minimapWidth,yt=Math.max(1,Math.floor((Tt-qe-2)/vt)),xt=He?Je:0;return ht&&(gt=Math.max(1,yt),$e==="bounded"&&(gt=Math.min(gt,ot))),{width:ze,height:tt,glyphMarginLeft:Pe,glyphMarginWidth:Te,lineNumbersLeft:Ye,lineNumbersWidth:q,decorationsLeft:Xe,decorationsWidth:ce,contentLeft:at,contentWidth:Tt,minimap:ft,viewportColumn:yt,isWordWrapMinified:_t,isViewportWrapping:ht,wrappingColumn:gt,verticalScrollbarWidth:qe,horizontalScrollbarHeight:nt,overviewRuler:{top:xt,width:qe,height:tt-2*xt,right:0}}}}e.EditorLayoutInfoComputer=U;class O extends n{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:m.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:h(te.enabled,this.defaultValue.enabled)}}}class $ extends n{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:m.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:m.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:h(pe.enabled,this.defaultValue.enabled),fontSize:g.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class B extends _{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>_.clamp(te,0,150),{markdownDescription:m.localize(46,null)})}compute(te,pe,ze){return te.fontInfo.lineHeight}}class x extends n{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:m.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(48,null),m.localize(49,null),m.localize(50,null)],default:te.size,description:m.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:m.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:m.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:m.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:m.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:h(pe.enabled,this.defaultValue.enabled),size:E(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(pe.side,this.defaultValue.side,["right","left"]),showSlider:E(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(pe.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(pe.scale,1,1,3),maxColumn:g.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(Q){return Q==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class H extends n{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:g.clampedInt(pe.top,0,0,1e3),bottom:g.clampedInt(pe.bottom,0,0,1e3)}}}class X extends n{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:m.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:h(pe.enabled,this.defaultValue.enabled),cycle:h(pe.cycle,this.defaultValue.cycle)}}}class J extends T{constructor(){super(128)}compute(te,pe,ze){return te.pixelRatio}}class fe extends n{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:m.localize(61,null)},comments:{type:"boolean",default:te.comments,description:m.localize(62,null)},other:{type:"boolean",default:te.other,description:m.localize(63,null)}}}],default:te,description:m.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,ze={other:h(pe.other,this.defaultValue.other),comments:h(pe.comments,this.defaultValue.comments),strings:h(pe.strings,this.defaultValue.strings)};return ze.other&&ze.comments&&ze.strings?!0:!ze.other&&!ze.comments&&!ze.strings?!1:ze}return this.defaultValue}}var _e;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends n{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(65,null),m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:"on",description:m.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,ze=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,ze=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:ze}}}function Le(Q){const te=Q.get(87);return te==="editable"?Q.get(80):te!=="on"}e.filterValidationDecorations=Le;class We extends n{constructor(){const te=[],pe={type:"number",description:m.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(71,null),format:"color-hex"}}}]},default:te,description:m.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let ze of te)if(typeof ze=="number")pe.push({column:g.clampedInt(ze,0,0,1e4),color:null});else if(ze&&typeof ze=="object"){const tt=ze;pe.push({column:g.clampedInt(tt.column,0,0,1e4),color:tt.color})}return pe.sort((ze,tt)=>ze.column-tt.column),pe}return this.defaultValue}}function Ne(Q,te){if(typeof Q!="string")return te;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ke extends n{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(73,null),m.localize(74,null),m.localize(75,null)],default:"auto",description:m.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)],default:"auto",description:m.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:m.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:m.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,ze=g.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=g.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ne(pe.vertical,this.defaultValue.vertical),horizontal:Ne(pe.horizontal,this.defaultValue.horizontal),useShadows:h(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ze,horizontalSliderSize:g.clampedInt(pe.horizontalSliderSize,ze,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:g.clampedInt(pe.verticalSliderSize,tt,0,1e3),scrollByPage:h(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class z extends n{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:m.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)],default:te.mode,description:m.localize(88,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:h(pe.enabled,this.defaultValue.enabled),mode:E(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends n{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:m.localize(89,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:h(te.enabled,this.defaultValue.enabled)}}}class re extends n{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(90,null),m.localize(91,null)],default:te.insertMode,description:m.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:m.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:m.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:m.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:m.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:m.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:m.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:m.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(100,null),m.localize(101,null),m.localize(102,null)],default:te.previewMode,description:m.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:m.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:E(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(pe.showIcons,this.defaultValue.showIcons),showStatusBar:h(pe.showStatusBar,this.defaultValue.showStatusBar),preview:h(pe.preview,this.defaultValue.preview),previewMode:E(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(pe.showMethods,this.defaultValue.showMethods),showFunctions:h(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:h(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:h(pe.showFields,this.defaultValue.showFields),showVariables:h(pe.showVariables,this.defaultValue.showVariables),showClasses:h(pe.showClasses,this.defaultValue.showClasses),showStructs:h(pe.showStructs,this.defaultValue.showStructs),showInterfaces:h(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:h(pe.showModules,this.defaultValue.showModules),showProperties:h(pe.showProperties,this.defaultValue.showProperties),showEvents:h(pe.showEvents,this.defaultValue.showEvents),showOperators:h(pe.showOperators,this.defaultValue.showOperators),showUnits:h(pe.showUnits,this.defaultValue.showUnits),showValues:h(pe.showValues,this.defaultValue.showValues),showConstants:h(pe.showConstants,this.defaultValue.showConstants),showEnums:h(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:h(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(pe.showKeywords,this.defaultValue.showKeywords),showWords:h(pe.showWords,this.defaultValue.showWords),showColors:h(pe.showColors,this.defaultValue.showColors),showFiles:h(pe.showFiles,this.defaultValue.showFiles),showReferences:h(pe.showReferences,this.defaultValue.showReferences),showFolders:h(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:h(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(pe.showSnippets,this.defaultValue.showSnippets),showUsers:h(pe.showUsers,this.defaultValue.showUsers),showIssues:h(pe.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(136,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Y extends T{constructor(){super(129,[80])}compute(te,pe,ze){return pe.get(80)?!0:te.tabFocusMode}}var oe;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function ve(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Me extends T{constructor(){super(131,[130])}compute(te,pe,ze){const tt=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const je="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Qe:L.isLinux?et:je,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:C.default.quality!=="stable"}},e.editorOptionsRegistry=[];function ke(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var ct;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.codeLens=13]="codeLens",Q[Q.codeLensFontFamily=14]="codeLensFontFamily",Q[Q.codeLensFontSize=15]="codeLensFontSize",Q[Q.colorDecorators=16]="colorDecorators",Q[Q.columnSelection=17]="columnSelection",Q[Q.comments=18]="comments",Q[Q.contextmenu=19]="contextmenu",Q[Q.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=21]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=23]="cursorStyle",Q[Q.cursorSurroundingLines=24]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=26]="cursorWidth",Q[Q.disableLayerHinting=27]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",Q[Q.domReadOnly=29]="domReadOnly",Q[Q.dragAndDrop=30]="dragAndDrop",Q[Q.emptySelectionClipboard=31]="emptySelectionClipboard",Q[Q.extraEditorClassName=32]="extraEditorClassName",Q[Q.fastScrollSensitivity=33]="fastScrollSensitivity",Q[Q.find=34]="find",Q[Q.fixedOverflowWidgets=35]="fixedOverflowWidgets",Q[Q.folding=36]="folding",Q[Q.foldingStrategy=37]="foldingStrategy",Q[Q.foldingHighlight=38]="foldingHighlight",Q[Q.foldingImportsByDefault=39]="foldingImportsByDefault",Q[Q.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=41]="fontFamily",Q[Q.fontInfo=42]="fontInfo",Q[Q.fontLigatures=43]="fontLigatures",Q[Q.fontSize=44]="fontSize",Q[Q.fontWeight=45]="fontWeight",Q[Q.formatOnPaste=46]="formatOnPaste",Q[Q.formatOnType=47]="formatOnType",Q[Q.glyphMargin=48]="glyphMargin",Q[Q.gotoLocation=49]="gotoLocation",Q[Q.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",Q[Q.hover=52]="hover",Q[Q.inDiffEditor=53]="inDiffEditor",Q[Q.inlineSuggest=54]="inlineSuggest",Q[Q.letterSpacing=55]="letterSpacing",Q[Q.lightbulb=56]="lightbulb",Q[Q.lineDecorationsWidth=57]="lineDecorationsWidth",Q[Q.lineHeight=58]="lineHeight",Q[Q.lineNumbers=59]="lineNumbers",Q[Q.lineNumbersMinChars=60]="lineNumbersMinChars",Q[Q.linkedEditing=61]="linkedEditing",Q[Q.links=62]="links",Q[Q.matchBrackets=63]="matchBrackets",Q[Q.minimap=64]="minimap",Q[Q.mouseStyle=65]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=67]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=69]="multiCursorModifier",Q[Q.multiCursorPaste=70]="multiCursorPaste",Q[Q.occurrencesHighlight=71]="occurrencesHighlight",Q[Q.overviewRulerBorder=72]="overviewRulerBorder",Q[Q.overviewRulerLanes=73]="overviewRulerLanes",Q[Q.padding=74]="padding",Q[Q.parameterHints=75]="parameterHints",Q[Q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=78]="quickSuggestions",Q[Q.quickSuggestionsDelay=79]="quickSuggestionsDelay",Q[Q.readOnly=80]="readOnly",Q[Q.renameOnType=81]="renameOnType",Q[Q.renderControlCharacters=82]="renderControlCharacters",Q[Q.renderIndentGuides=83]="renderIndentGuides",Q[Q.renderFinalNewline=84]="renderFinalNewline",Q[Q.renderLineHighlight=85]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=87]="renderValidationDecorations",Q[Q.renderWhitespace=88]="renderWhitespace",Q[Q.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",Q[Q.roundedSelection=90]="roundedSelection",Q[Q.rulers=91]="rulers",Q[Q.scrollbar=92]="scrollbar",Q[Q.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=94]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=95]="scrollPredominantAxis",Q[Q.selectionClipboard=96]="selectionClipboard",Q[Q.selectionHighlight=97]="selectionHighlight",Q[Q.selectOnLineNumbers=98]="selectOnLineNumbers",Q[Q.showFoldingControls=99]="showFoldingControls",Q[Q.showUnused=100]="showUnused",Q[Q.snippetSuggestions=101]="snippetSuggestions",Q[Q.smartSelect=102]="smartSelect",Q[Q.smoothScrolling=103]="smoothScrolling",Q[Q.stickyTabStops=104]="stickyTabStops",Q[Q.stopRenderingLineAfter=105]="stopRenderingLineAfter",Q[Q.suggest=106]="suggest",Q[Q.suggestFontSize=107]="suggestFontSize",Q[Q.suggestLineHeight=108]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",Q[Q.suggestSelection=110]="suggestSelection",Q[Q.tabCompletion=111]="tabCompletion",Q[Q.tabIndex=112]="tabIndex",Q[Q.unusualLineTerminators=113]="unusualLineTerminators",Q[Q.useShadowDOM=114]="useShadowDOM",Q[Q.useTabStops=115]="useTabStops",Q[Q.wordSeparators=116]="wordSeparators",Q[Q.wordWrap=117]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=120]="wordWrapColumn",Q[Q.wordWrapOverride1=121]="wordWrapOverride1",Q[Q.wordWrapOverride2=122]="wordWrapOverride2",Q[Q.wrappingIndent=123]="wrappingIndent",Q[Q.wrappingStrategy=124]="wrappingStrategy",Q[Q.showDeprecated=125]="showDeprecated",Q[Q.inlayHints=126]="inlayHints",Q[Q.editorClassName=127]="editorClassName",Q[Q.pixelRatio=128]="pixelRatio",Q[Q.tabFocusMode=129]="tabFocusMode",Q[Q.layoutInfo=130]="layoutInfo",Q[Q.wrappingInfo=131]="wrappingInfo"})(ct=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(137,null)})),acceptSuggestionOnEnter:ke(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(138,null),""],markdownDescription:m.localize(139,null)})),accessibilitySupport:ke(new t),accessibilityPageSize:ke(new g(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(140,null)})),ariaLabel:ke(new P(4,"ariaLabel",m.localize(141,null))),autoClosingBrackets:ke(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(142,null),m.localize(143,null),""],description:m.localize(144,null)})),autoClosingDelete:ke(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(145,null),""],description:m.localize(146,null)})),autoClosingOvertype:ke(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(147,null),""],description:m.localize(148,null)})),autoClosingQuotes:ke(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(149,null),m.localize(150,null),""],description:m.localize(151,null)})),autoIndent:ke(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null),m.localize(156,null)],description:m.localize(157,null)})),automaticLayout:ke(new c(10,"automaticLayout",!1)),autoSurround:ke(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(158,null),m.localize(159,null),m.localize(160,null),""],description:m.localize(161,null)})),bracketPairColorization:ke(new ee),stickyTabStops:ke(new c(104,"stickyTabStops",!1,{description:m.localize(162,null)})),codeLens:ke(new c(13,"codeLens",!0,{description:m.localize(163,null)})),codeLensFontFamily:ke(new P(14,"codeLensFontFamily","",{description:m.localize(164,null)})),codeLensFontSize:ke(new g(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(165,null)})),colorDecorators:ke(new c(16,"colorDecorators",!0,{description:m.localize(166,null)})),columnSelection:ke(new c(17,"columnSelection",!1,{description:m.localize(167,null)})),comments:ke(new r),contextmenu:ke(new c(19,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new c(20,"copyWithSyntaxHighlighting",!0,{description:m.localize(168,null)})),cursorBlinking:ke(new a(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:m.localize(169,null)})),cursorSmoothCaretAnimation:ke(new c(22,"cursorSmoothCaretAnimation",!1,{description:m.localize(170,null)})),cursorStyle:ke(new a(23,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:m.localize(171,null)})),cursorSurroundingLines:ke(new g(24,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(172,null)})),cursorSurroundingLinesStyle:ke(new o(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(173,null),m.localize(174,null)],description:m.localize(175,null)})),cursorWidth:ke(new g(26,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(176,null)})),disableLayerHinting:ke(new c(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new c(28,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new c(29,"domReadOnly",!1)),dragAndDrop:ke(new c(30,"dragAndDrop",!0,{description:m.localize(177,null)})),emptySelectionClipboard:ke(new y),extraEditorClassName:ke(new P(32,"extraEditorClassName","")),fastScrollSensitivity:ke(new _(33,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:m.localize(178,null)})),find:ke(new p),fixedOverflowWidgets:ke(new c(35,"fixedOverflowWidgets",!1)),folding:ke(new c(36,"folding",!0,{description:m.localize(179,null)})),foldingStrategy:ke(new o(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(180,null),m.localize(181,null)],description:m.localize(182,null)})),foldingHighlight:ke(new c(38,"foldingHighlight",!0,{description:m.localize(183,null)})),foldingImportsByDefault:ke(new c(39,"foldingImportsByDefault",!1,{description:m.localize(184,null)})),unfoldOnClickAfterEndOfLine:ke(new c(40,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(185,null)})),fontFamily:ke(new P(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(186,null)})),fontInfo:ke(new b),fontLigatures2:ke(new S),fontSize:ke(new F),fontWeight:ke(new N),formatOnPaste:ke(new c(46,"formatOnPaste",!1,{description:m.localize(187,null)})),formatOnType:ke(new c(47,"formatOnType",!1,{description:m.localize(188,null)})),glyphMargin:ke(new c(48,"glyphMargin",!0,{description:m.localize(189,null)})),gotoLocation:ke(new G),hideCursorInOverviewRuler:ke(new c(50,"hideCursorInOverviewRuler",!1,{description:m.localize(190,null)})),highlightActiveIndentGuide:ke(new c(51,"highlightActiveIndentGuide",!0,{description:m.localize(191,null)})),hover:ke(new K),inDiffEditor:ke(new c(53,"inDiffEditor",!1)),letterSpacing:ke(new _(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>_.clamp(Q,-5,20),{description:m.localize(192,null)})),lightbulb:ke(new O),lineDecorationsWidth:ke(new u(57,"lineDecorationsWidth",10)),lineHeight:ke(new B),lineNumbers:ke(new Se),lineNumbersMinChars:ke(new g(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new c(61,"linkedEditing",!1,{description:m.localize(193,null)})),links:ke(new c(62,"links",!0,{description:m.localize(194,null)})),matchBrackets:ke(new o(63,"matchBrackets","always",["always","near","never"],{description:m.localize(195,null)})),minimap:ke(new x),mouseStyle:ke(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new _(66,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:m.localize(196,null)})),mouseWheelZoom:ke(new c(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(197,null)})),multiCursorMergeOverlapping:ke(new c(68,"multiCursorMergeOverlapping",!0,{description:m.localize(198,null)})),multiCursorModifier:ke(new a(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[m.localize(199,null),m.localize(200,null)],markdownDescription:m.localize(201,null)})),multiCursorPaste:ke(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(202,null),m.localize(203,null)],markdownDescription:m.localize(204,null)})),occurrencesHighlight:ke(new c(71,"occurrencesHighlight",!0,{description:m.localize(205,null)})),overviewRulerBorder:ke(new c(72,"overviewRulerBorder",!0,{description:m.localize(206,null)})),overviewRulerLanes:ke(new g(73,"overviewRulerLanes",3,0,3)),padding:ke(new H),parameterHints:ke(new X),peekWidgetDefaultFocus:ke(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(207,null),m.localize(208,null)],description:m.localize(209,null)})),definitionLinkOpensInPeek:ke(new c(77,"definitionLinkOpensInPeek",!1,{description:m.localize(210,null)})),quickSuggestions:ke(new fe),quickSuggestionsDelay:ke(new g(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(211,null)})),readOnly:ke(new c(80,"readOnly",!1)),renameOnType:ke(new c(81,"renameOnType",!1,{description:m.localize(212,null),markdownDeprecationMessage:m.localize(213,null)})),renderControlCharacters:ke(new c(82,"renderControlCharacters",!1,{description:m.localize(214,null)})),renderIndentGuides:ke(new c(83,"renderIndentGuides",!0,{description:m.localize(215,null)})),renderFinalNewline:ke(new c(84,"renderFinalNewline",!0,{description:m.localize(216,null)})),renderLineHighlight:ke(new o(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(217,null)],description:m.localize(218,null)})),renderLineHighlightOnlyWhenFocus:ke(new c(86,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(219,null)})),renderValidationDecorations:ke(new o(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new o(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),m.localize(222,null),""],description:m.localize(223,null)})),revealHorizontalRightPadding:ke(new g(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new c(90,"roundedSelection",!0,{description:m.localize(224,null)})),rulers:ke(new We),scrollbar:ke(new Ke),scrollBeyondLastColumn:ke(new g(93,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(225,null)})),scrollBeyondLastLine:ke(new c(94,"scrollBeyondLastLine",!0,{description:m.localize(226,null)})),scrollPredominantAxis:ke(new c(95,"scrollPredominantAxis",!0,{description:m.localize(227,null)})),selectionClipboard:ke(new c(96,"selectionClipboard",!0,{description:m.localize(228,null),included:L.isLinux})),selectionHighlight:ke(new c(97,"selectionHighlight",!0,{description:m.localize(229,null)})),selectOnLineNumbers:ke(new c(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new o(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(230,null),m.localize(231,null)],description:m.localize(232,null)})),showUnused:ke(new c(100,"showUnused",!0,{description:m.localize(233,null)})),showDeprecated:ke(new c(125,"showDeprecated",!0,{description:m.localize(234,null)})),inlayHints:ke(new $),snippetSuggestions:ke(new o(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(235,null),m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),smartSelect:ke(new le),smoothScrolling:ke(new c(103,"smoothScrolling",!1,{description:m.localize(240,null)})),stopRenderingLineAfter:ke(new g(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new re),inlineSuggest:ke(new z),suggestFontSize:ke(new g(107,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(241,null)})),suggestLineHeight:ke(new g(108,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(242,null)})),suggestOnTriggerCharacters:ke(new c(109,"suggestOnTriggerCharacters",!0,{description:m.localize(243,null)})),suggestSelection:ke(new o(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),tabCompletion:ke(new o(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(248,null),m.localize(249,null),m.localize(250,null)],description:m.localize(251,null)})),tabIndex:ke(new g(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ke(new o(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(252,null),m.localize(253,null),m.localize(254,null)],description:m.localize(255,null)})),useShadowDOM:ke(new c(114,"useShadowDOM",!0)),useTabStops:ke(new c(115,"useTabStops",!0,{description:m.localize(256,null)})),wordSeparators:ke(new P(116,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:m.localize(257,null)})),wordWrap:ke(new o(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(258,null),m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),wordWrapBreakAfterCharacters:ke(new P(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new P(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new g(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(263,null)})),wordWrapOverride1:ke(new o(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new o(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new a(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[m.localize(264,null),m.localize(265,null),m.localize(266,null),m.localize(267,null)],description:m.localize(268,null)})),wrappingStrategy:ke(new o(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(269,null),m.localize(270,null)],description:m.localize(271,null)})),editorClassName:ke(new w),pixelRatio:ke(new J),tabFocusMode:ke(new Y),layoutInfo:ke(new U),wrappingInfo:ke(new Me)}});var xe=this&&this.__param||function(Z,e){return function(m,L){e(m,L,Z)}};define(me[119],ge([0,1,17,21,6,4]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var R;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(T){this.callback=T}get value(){return this._value}report(T){this._value=T,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends I.Disposable{constructor(T,u){super();this.deferred=new m.DeferredPromise,u.withProgress(T,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(T){this.reporter?this.reporter.report(T):this.lastStep=T}};D=Ve([xe(1,e.IProgressService)],D),e.UnmanagedProgress=D;class A extends I.Disposable{constructor(T){super();this.progressIndicator=T,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(T){this.stop();const u=++this.currentOperationId,h=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},T),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:h.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(T){this.currentOperationId===T&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(me[35],ge([0,1,54,13]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(R,k){m.ok(L.isString(R)),m.ok(L.isObject(k)),m.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,k)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new I}),define(me[120],ge([0,1,3,35]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,A){this.schemasById[I(D)]=A,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new C;L.Registry.add(e.Extensions.JSONContribution,R)}),define(me[85],ge([0,1,3,13,156,120,35]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=R.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new m.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new m.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,o=!0){this.registerConfigurations([E],o)}registerConfigurations(E,o=!0){const a=[];E.forEach(v=>{a.push(...this.validateAndRegisterProperties(v,o,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(E){const o=[],a=v=>{if(v.properties)for(const t in v.properties)o.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>a(t))};for(const v of E){a(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(E){const o=[],a=[];for(const v of E)for(const t in v)if(o.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const r={type:"object",default:this.defaultValues[t],description:I.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};a.push(u(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=v[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(E){const o=[];for(const a of E)for(const v in a)if(o.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const o of E)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,o=!0,a,v=3){v=L.isUndefinedOrNull(E.scope)?v:E.scope;let t=[],r=E.properties;if(r)for(let i in r){if(o&&g(i)){delete r[i];continue}const l=r[i];if(this.updatePropertyDefaultValue(i,l),e.OVERRIDE_PROPERTY_PATTERN.test(i)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?v:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(i):l.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let s=E.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,o,a,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const o=a=>{let v=a.properties;if(v)for(const r in v)this.updateSchema(r,v[r]);let t=a.allOf;t&&t.forEach(o)};o(E)}updateSchema(E,o){switch(e.allSettings.properties[E]=o,o.scope){case 1:e.applicationSettings.properties[E]=o;break;case 2:e.machineSettings.properties[E]=o;break;case 6:e.machineOverridableSettings.properties[E]=o;break;case 3:e.windowSettings.properties[E]=o;break;case 4:e.resourceSettings.properties[E]=o;break;case 5:e.resourceSettings.properties[E]=o,this.resourceLanguageSettingsSchema.properties[E]=o;break}}removeFromSchema(E,o){switch(delete e.allSettings.properties[E],o.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const o=`[${E}]`,a={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,a),e.allSettings.properties[o]=a,e.applicationSettings.properties[o]=a,e.machineSettings.properties[o]=a,e.machineOverridableSettings.properties[o]=a,e.windowSettings.properties[o]=a,e.resourceSettings.properties[o]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,o){let a=this.defaultValues[E];L.isUndefined(a)&&(a=o.default),L.isUndefined(a)&&(a=h(o.type)),o.default=a}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function u(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=u;function h(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const c=new n;R.Registry.add(e.Extensions.Configuration,c);function g(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?I.localize(5,null,P):c.getConfigurationProperties()[P]!==void 0?I.localize(6,null,P):null:I.localize(4,null)}e.validateProperty=g;function _(){const P=[],E=c.getConfigurationProperties();for(const o of Object.keys(E))P.push([o,E[o].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=_}),define(me[121],ge([0,1,25,13,2,85,4,35]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function D(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof I.URI)}e.isConfigurationOverrides=D;var A;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function T(r,s){const i=s?r?s.keys.filter(S=>r.keys.indexOf(S)===-1):[...s.keys]:[],l=r?s?r.keys.filter(S=>s.keys.indexOf(S)===-1):[...r.keys]:[],d=[];if(s&&r){for(const S of r.keys)if(s.keys.indexOf(S)!==-1){const b=P(r.contents,S),F=P(s.contents,S);m.equals(b,F)||d.push(S)}}const f=[],w=S=>{const b={};for(const F of S)for(const N of F.identifiers)b[v(N)]=F;return b},y=s?w(s.overrides):{},p=r?w(r.overrides):{};if(Object.keys(y).length)for(const S of i){const b=y[S];b&&f.push([(0,C.overrideIdentifierFromKey)(S),b.keys])}if(Object.keys(p).length)for(const S of l){const b=p[S];b&&f.push([(0,C.overrideIdentifierFromKey)(S),b.keys])}if(Object.keys(y).length&&Object.keys(p).length)for(const S of d){const b=p[S],F=y[S];if(b&&F){const N=T({contents:b.contents,keys:b.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});f.push([(0,C.overrideIdentifierFromKey)(S),[...N.added,...N.removed,...N.updated]])}}return{added:i,removed:l,updated:d,overrides:f}}e.compare=T;function u(r,s){const i=[];for(const l of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(l)){const d={};for(const f in r[l])d[f]=r[l][f];i.push({identifiers:[(0,C.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(d),contents:h(d,s)})}return i}e.toOverrides=u;function h(r,s){const i=Object.create(null);for(let l in r)c(i,l,r[l],s);return i}e.toValuesTree=h;function c(r,s,i,l){const d=s.split("."),f=d.pop();let w=r;for(let y=0;y<d.length;y++){let p=d[y],S=w[p];switch(typeof S){case"undefined":S=w[p]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${d.slice(0,y+1).join(".")} is ${JSON.stringify(S)}`);return}w=S}if(typeof w=="object"&&w!==null)try{w[f]=i}catch(y){l(`Ignoring ${s} as ${d.join(".")} is ${JSON.stringify(w)}`)}else l(`Ignoring ${s} as ${d.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=c;function g(r,s){const i=s.split(".");_(r,i)}e.removeFromValueTree=g;function _(r,s){const i=s.shift();if(s.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const l=r[i];typeof l=="object"&&!Array.isArray(l)&&(_(l,s),Object.keys(l).length===0&&delete r[i])}}function P(r,s,i){function l(w,y){let p=w;for(const S of y){if(typeof p!="object"||p===null)return;p=p[S]}return p}const d=s.split("."),f=l(r,d);return typeof f=="undefined"?i:f}e.getConfigurationValue=P;function E(r,s,i){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in r?L.isObject(r[l])&&L.isObject(s[l])?E(r[l],s[l],i):i&&(r[l]=s[l]):r[l]=s[l])})}e.merge=E;function o(){const r=k.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=o;function a(){const r=Object.create(null),s=k.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in s){let l=s[i].default;c(r,i,l,d=>console.error(`Conflict in default settings: ${d}`))}return r}e.getDefaultValues=a;function v(r){return`[${r}]`}e.keyFromOverrideIdentifier=v;function t(r,s,i){const l=r.inspect(s),d=r.inspect(i);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:l.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,20,3,57,6,23,25,13,2,121,85,35]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,n.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const i of m.distinct([...Object.keys(this.contents),...Object.keys(r)])){let l=this.contents[i],d=r[i];d&&(typeof l=="object"&&typeof d=="object"?(l=k.deepClone(l),this.mergeContents(l,d)):l=d),s[i]=l}return new h(s,this.keys,this.overrides)}merge(...t){const r=k.deepClone(this.contents),s=k.deepClone(this.overrides),i=[...this.keys];for(const l of t){this.mergeContents(r,l.contents);for(const d of l.overrides){const[f]=s.filter(w=>m.equals(w.identifiers,d.identifiers));f?this.mergeContents(f.contents,d.contents):s.push(k.deepClone(d))}for(const d of l.keys)i.indexOf(d)===-1&&i.push(d)}return new h(r,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&D.isObject(t[s])&&D.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=k.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=h;class c extends h{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))T.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,T.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,r,s)}}e.DefaultConfigurationModel=c;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!D.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:i,overrides:l,restricted:d}=this.doParseRaw(t,r);this._configurationModel=new h(s,i,l),this._restrictedConfigurations=d||[]}doParseContent(t){let r={},s=null,i=[],l=[],d=[];function f(y){Array.isArray(i)?i.push(y):s!==null&&(i[s]=y)}let w={onObjectBegin:()=>{let y={};f(y),l.push(i),i=y,s=null},onObjectProperty:y=>{s=y},onObjectEnd:()=>{i=l.pop()},onArrayBegin:()=>{let y=[];f(y),l.push(i),i=y,s=null},onArrayEnd:()=>{i=l.pop()},onLiteralValue:f,onError:(y,p,S)=>{d.push({error:y,offset:p,length:S})}};if(t)try{I.visit(t,w),r=i[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return r}doParseRaw(t,r){const s=u.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,r);t=i.raw;const l=(0,n.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),d=Object.keys(t),f=(0,n.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:l,keys:d,overrides:f,restricted:i.restricted}}filter(t,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const l={},d=[];for(let f in t)if(T.OVERRIDE_PROPERTY_PATTERN.test(f)&&s){const w=this.filter(t[f],r,!1,i);l[f]=w.raw,d.push(...w.restricted)}else{const w=r[f],y=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&d.push(f),(y===void 0||i.scopes===void 0||i.scopes.includes(y))&&(i.skipRestricted&&w?.restricted||(l[f]=t[f]))}return{raw:l,restricted:d}}}e.ConfigurationModelParser=g;class _ extends C.Disposable{constructor(t,r,s,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class P{constructor(t,r,s=new h,i=new h,l=new R.ResourceMap,d=new h,f=new R.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=l,this._memoryConfiguration=d,this._memoryConfigurationByResource=f,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new h,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const i=this.getConsolidateConfigurationModel(r,s),l=this.getFolderConfigurationModelForResource(r.resource,s),d=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,f=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),p=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),S=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,b=l?r.overrideIdentifier?l.freeze().override(r.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,F=r.overrideIdentifier?d.override(r.overrideIdentifier).getValue(t):d.getValue(t),N=i.getValue(t),G=m.distinct(m.flatten(i.overrides.map(K=>K.identifiers))).filter(K=>i.getOverrideValue(t,K)!==void 0);return{defaultValue:f,userValue:w,userLocalValue:y,userRemoteValue:p,workspaceValue:S,workspaceFolderValue:b,memoryValue:F,value:N,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:S!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:b!==void 0?{value:l?.freeze().getValue(t),override:r.overrideIdentifier?l?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:d.getValue(t),override:r.overrideIdentifier?d.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(i=>T.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const l=(0,T.overrideIdentifierFromKey)(i),d=this._defaultConfiguration.getKeysForOverrideIdentifier(l),f=t.getKeysForOverrideIdentifier(l),w=[...f.filter(y=>d.indexOf(y)===-1),...d.filter(y=>f.indexOf(y)===-1),...d.filter(y=>!k.equals(this._defaultConfiguration.override(l).getValue(y),t.override(l).getValue(y)))];return[l,w]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:l}=(0,n.compare)(this.localUserConfiguration,t),d=[...r,...s,...i];return d.length&&this.updateLocalUserConfiguration(t),{keys:d,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:l}=(0,n.compare)(this.remoteUserConfiguration,t);let d=[...r,...s,...i];return d.length&&this.updateRemoteUserConfiguration(t),{keys:d,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:i,overrides:l}=(0,n.compare)(this.workspaceConfiguration,t);let d=[...r,...s,...i];return d.length&&this.updateWorkspaceConfiguration(t),{keys:d,overrides:l}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:i,updated:l,removed:d,overrides:f}=(0,n.compare)(s,r);let w=[...i,...l,...d];return(w.length||!s)&&this.updateFolderConfiguration(t,r),{keys:w,overrides:f}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:l,overrides:d}=(0,n.compare)(r,void 0);return{keys:[...s,...i,...l],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const l=this._memoryConfigurationByResource.get(t);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:i,keys:l}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:i,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((d,f)=>(d.set(A.URI.revive(f[0]),this.parseConfigurationModel(f[1])),d),new R.ResourceMap);return new P(r,s,new h,i,l,new h,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=P;function E(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,r=new Map;for(const i of v)i.keys.forEach(l=>t.add(l)),i.overrides.forEach(([l,d])=>{const f=(0,R.getOrSet)(r,l,new Set);d.forEach(w=>f.add(w))});const s=[];return r.forEach((i,l)=>s.push([l,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class o{constructor(t,r,s,i){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(f=>l.add(f)),t.overrides.forEach(([,f])=>f.forEach(w=>l.add(w))),this.affectedKeys=[...l.values()];const d=new h;this.affectedKeys.forEach(f=>d.setValue(f,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!k.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,n.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=o;class a extends o{constructor(t,r,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=a}),define(me[122],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(R,k=L.Unknown,D){super(R);this._message=R,this._code=k,this._detail=D,this.isHandled=k===L.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(R){return R instanceof I&&R._code===L.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof I&&R._code===L.NoResolverFound}static isHandled(R){return R instanceof I&&R.isHandled}}e.RemoteAuthorityResolverError=I}),define(me[86],ge([0,1,10]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(A){return A.scheme===m.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=L;function I(A){if(!A)return;const n=A.indexOf("+");return n<0?A:A.substr(0,n)}e.getRemoteName=I;function C(A){return A.scheme!==m.Schemas.file&&A.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function R(A){if(A.folders.length)return A.folders.every(n=>C(n.uri))?A.folders[0].uri:void 0;if(A.configuration&&C(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=R;function k(A){return R(A)?.scheme}e.getVirtualWorkspaceScheme=k;function D(A){return R(A)!==void 0}e.isVirtualWorkspace=D}),define(me[193],ge([0,1,3,11,4,12]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService");var R;(function(h){h.Http="http",h.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(k=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=n;function T(h,c){return c?c!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=T;let u=class{constructor(c){this.logService=c,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,g){return this._tunnelProvider=c,c?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async c=>{const g=[],_=Array.from(this._tunnels.values());for(let P of _){const E=Array.from(P.values());for(let o of E){const a=await o.value;a&&g.push(a)}}c(g)})}async dispose(){for(const c of this._tunnels.values()){for(const{value:g}of c.values())await g.then(_=>_?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,g,_,P,E=!1,o=!1,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${_} on local port ${P}.`),!c)return;g||(g="localhost");const v=this.retainOrCreateTunnel(c,g,_,P,E,o,a);return v?v.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==g||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,public:c.public,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const g=this._tunnels.get(c.tunnelRemoteHost);if(g){const _=g.get(c.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,_))}}}}async tryDisposeTunnel(c,g,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${g}.`);const P=_.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(g),P}}async closeTunnel(c,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${g} `);const _=this._tunnels.get(c);if(_&&_.has(g)){const P=_.get(g);P.refcount=0,await this.tryDisposeTunnel(c,g,P)}}addTunnelToMap(c,g,_){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(g,{refcount:1,value:_})}async removeEmptyTunnelFromMap(c,g){const _=this._tunnels.get(c);_&&(await _.get(g)||_.delete(g),_.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,g){let _=[c];A(c)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):n(c)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const P=_.map(E=>this._tunnels.get(E));for(const E of P){const o=E?.get(g);if(o)return o}}canTunnel(c){return!!D(c)}createWithProvider(c,g,_,P,E,o,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${_} on local port ${P}.`);const t={elevationRequired:E?T(P===void 0?_:P):!1},r={remoteAddress:{host:g,port:_},localAddressPort:P,public:o,protocol:a},s=c.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(g,_,s),s}};u=Ve([xe(0,C.ILogService)],u),e.AbstractTunnelService=u}),define(me[194],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((I,C)=>Z(["vsda"],I,C))}async sign(I){try{const C=await this.vsda(),R=new C.signer;if(R)return R.sign(I)}catch(C){}return I}}e.SignService=m}),define(me[195],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,C,R=5){let k;return k=C(D=>{const A=typeof D=="string"?D:D.data;let n=this._terminalBufferMap.get(I);if(n){n.data.push(A);return}const T=setTimeout(()=>this.flushBuffer(I),R);n={data:[A],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,n)}),k}stopBuffering(I){const C=this._terminalBufferMap.get(I);C&&C.dispose()}flushBuffer(I){const C=this._terminalBufferMap.get(I);C&&(this._terminalBufferMap.delete(I),this._callback(I,C.data.join("")))}}e.TerminalDataBufferer=m}),define(me[196],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(me[62],ge([0,1,47,3,6,4,35,196]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var D;(function(_){function P(E){return E&&typeof E=="object"&&typeof E.id=="string"}_.isThemeColor=P})(D=e.ThemeColor||(e.ThemeColor={}));function A(_){return{id:_}}e.themeColorFromId=A;var n;(function(_){function P(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||D.isThemeColor(r.color))}_.isThemeIcon=P;const E=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function o(r){const s=E.exec(r);if(!s)return;let[,i]=s;return{id:i}}_.fromString=o;function a(r,s){let i=r.id;const l=i.lastIndexOf("~");return l!==-1&&(i=i.substring(0,l)),s&&(i=`${i}~${s}`),{id:i}}_.modify=a;function v(r,s){return r.id===s.id&&r.color?.id===s.color?.id}_.isEqual=v;function t(r,s){return{id:r.id,color:s?A(s):void 0}}_.asThemeIcon=t,_.asClassNameArray=m.CSSIcon.asClassNameArray,_.asClassName=m.CSSIcon.asClassName,_.asCSSSelector=m.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function T(_){switch(_){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,I.toDisposable)(()=>{const E=this.themingParticipants.indexOf(P);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new u;R.Registry.add(e.Extensions.ThemingContribution,h);function c(_){return h.onColorThemeChange(_)}e.registerThemingParticipant=c;class g extends I.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,E){let o=this.theme.getColor(P);return o&&E&&(o=E(o,this.theme)),o?o.toString():null}}e.Themable=g}),define(me[197],ge([0,1,17,47,3,162,120,35,62]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class A{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(P,E,o,a){const v=this.iconsById[P];if(v){if(o&&!v.description){v.description=o,this.iconSchema.properties[P].markdownDescription=`${o} $(${P})`;const s=this.iconReferenceSchema.enum.indexOf(P);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=o),this._onDidChange.fire()}return v}let t={id:P,description:o,defaults:E,deprecationMessage:a};this.iconsById[P]=t;let r={$ref:"#/definitions/icons"};return a&&(r.deprecationMessage=a),o&&(r.markdownDescription=`${o}: $(${P})`),this.iconSchema.properties[P]=r,this.iconReferenceSchema.enum.push(P),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:P}}deregisterIcon(P){delete this.iconsById[P],delete this.iconSchema.properties[P];const E=this.iconReferenceSchema.enum.indexOf(P);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(P=>this.iconsById[P])}getIcon(P){return this.iconsById[P]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(P,E){const o=this.iconFontsById[P];if(o)return o;let a={id:P,definition:E};return this.iconFontsById[P]=a,this._onDidChange.fire(),a}deregisterIconFont(P){delete this.iconFontsById[P]}getIconFonts(){return Object.keys(this.iconFontsById).map(P=>this.iconFontsById[P])}getIconFont(P){return this.iconFontsById[P]}toString(){const P=(v,t)=>v.id.localeCompare(t.id),E=v=>{for(;D.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of a.filter(t=>!!t.description).sort(P))o.push(`|<i class="${E(v)}"></i>|${v.id}|${D.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const v of a.filter(t=>!D.ThemeIcon.isThemeIcon(t.defaults)).sort(P))o.push(`|<i class="${E(v)}"></i>|${v.id}|`);return o.join(`
`)}}const n=new A;k.Registry.add(e.Extensions.IconContribution,n);function T(_,P,E,o){return n.registerIcon(_,P,E,o)}e.registerIcon=T;function u(){return n}e.getIconRegistry=u;function h(){for(const _ of L.iconRegistry.all)n.registerIcon(_.id,_.definition,_.description);L.iconRegistry.onDidRegister(_=>n.registerIcon(_.id,_.definition,_.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let c=k.Registry.as(R.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,n.getIconSchema());const g=new m.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.widgetClose=T("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=T("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=T("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=D.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[43],ge([0,1,23,24,2,4]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var R;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function k(u){const h=u;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=k;function D(u){const h=u;return!!(h&&typeof h=="object"&&I.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class A{constructor(h,c,g,_){this._id=h,this._configuration=g,this._ignorePathCasing=_,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=A;class n{constructor(h,c){this.raw=c,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,L.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function T(u){return new n({uri:u,index:0,name:(0,L.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=T}),define(me[198],ge([0,1,29,57,139,79,10,8,11,24,2,163,4,86,43]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(M){return(typeof M=="string"?(0,k.extname)(M):(0,A.extname)(M))===g}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,u.createDecorator)("workspacesService");function P(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function E(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=E;function o(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=o;function a(M){const U=M;return typeof U?.id=="string"&&n.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=a;function v(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(M){const U=M;return typeof U?.id=="string"&&n.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function r(M){const U=M;if(U?.uri)return{id:U.id,uri:n.URI.revive(U.uri)};const O=M;if(O?.configPath)return{id:O.id,configPath:n.URI.revive(O.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=r;function s(M,U){return A.extUriBiasedIgnorePathCase.isEqualOrParent(M,U.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function i(M){return l(M)||d(M)}e.isStoredWorkspaceFolder=i;function l(M){const U=M;return typeof U?.path=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=l;function d(M){const U=M;return typeof U?.uri=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=d;function f(M,U,O,$,B=!D.isWindows,x){if(M.scheme!==$.scheme)return{name:O,uri:M.toString(!0)};let j=U?void 0:x.relativePath($,M);if(j!==void 0)j.length===0?j=".":D.isWindows&&M.scheme===R.Schemas.file&&!B&&(j=j.replace(/\//g,"\\"));else if(M.scheme===R.Schemas.file)j=M.fsPath,D.isWindows&&(j=(0,C.normalizeDriveLetter)(j),B&&(j=(0,m.toSlashes)(j)));else{if(!x.isEqualAuthority(M.authority,$.authority))return{name:O,uri:M.toString(!0)};j=M.path}return{name:O,path:j}}e.getStoredWorkspaceFolder=f;function w(M,U,O){let $=[],B=new Set;const x=O.dirname(U);for(let j of M){let H;if(l(j))j.path&&(H=O.resolvePath(x,j.path));else if(d(j))try{H=n.URI.parse(j.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(X){console.warn(X)}if(H){let X=O.getComparisonKey(H);if(!B.has(X)){B.add(X);const J=j.name||O.basenameOrAuthority(H);$.push(new c.WorkspaceFolder({uri:H,name:J,index:$.length},j))}}}return $}e.toWorkspaceFolders=w;function y(M,U,O,$,B){let x=p(U,M);const j=B.dirname(U),H=B.dirname($),X=[],J=S(x.folders);for(const Le of x.folders){const We=l(Le)?B.resolvePath(j,Le.path):n.URI.parse(Le.uri);let Ne;O?Ne=!1:Ne=!l(Le)||(0,k.isAbsolute)(Le.path),X.push(f(We,Ne,Le.name,H,J,B))}const fe={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},_e=I.setProperty(M,["folders"],X,fe);let Se=I.applyEdits(M,_e);return x.remoteAuthority===(0,h.getRemoteAuthority)($)&&(Se=I.applyEdits(Se,I.removeProperty(Se,["remoteAuthority"],fe))),Se}e.rewriteWorkspaceFileForNewLocation=y;function p(M,U){let O=L.parse(U);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter($=>i($));else throw new Error(`${M} looks like an invalid workspace file.`);return O}function S(M){return D.isWindows?M.some(U=>l(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=S;function b(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function F(M){return typeof M.folderUri=="string"}function N(M){return typeof M.fileUri=="string"}function G(M,U){const O={workspaces:[],files:[]};if(M){const $=function(x,j){for(let H=0;H<x.length;H++)try{j(x[H],H)}catch(X){U.warn(`Error restoring recent entry ${JSON.stringify(x[H])}: ${X.toString()}. Skip entry.`)}},B=M;if(Array.isArray(B.entries))$(B.entries,x=>{const j=x.label,H=x.remoteAuthority;b(x)?O.workspaces.push({label:j,remoteAuthority:H,workspace:{id:x.workspace.id,configPath:n.URI.parse(x.workspace.configPath)}}):F(x)?O.workspaces.push({label:j,remoteAuthority:H,folderUri:n.URI.parse(x.folderUri)}):N(x)&&O.files.push({label:j,remoteAuthority:H,fileUri:n.URI.parse(x.fileUri)})});else{const x=M;Array.isArray(x.workspaces3)&&$(x.workspaces3,(j,H)=>{const X=Array.isArray(x.workspaceLabels)&&x.workspaceLabels[H]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?O.workspaces.push({label:X,workspace:{id:j.id,configPath:n.URI.parse(j.configURIPath)}}):typeof j=="string"&&O.workspaces.push({label:X,folderUri:n.URI.parse(j)})}),Array.isArray(x.files2)&&$(x.files2,(j,H)=>{const X=Array.isArray(x.fileLabels)&&x.fileLabels[H]||void 0;typeof j=="string"&&O.files.push({label:X,fileUri:n.URI.parse(j)})})}}return O}e.restoreRecentlyOpened=G;function K(M){const U={entries:[]};for(const O of M.workspaces)E(O)?U.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):U.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of M.files)U.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return U}e.toStoreData=K}),define(me[87],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const C=this._idPool++;return this._data.set(C,I),this.logDebugInfo(),C}get(I,C){return this._data.has(I)?this._data.get(I)[C]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(me[51],ge([0,1,2,3,4]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class C{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(k){this._tabs=k.map(D=>({name:D.name,group:D.group,resource:m.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=C}),define(me[63],ge([0,1,10,4]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class I{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(R,k){k===null?this._providerInfo.delete(R):this._providerInfo.set(R,k)}isFreeScheme(R){return!this._providerInfo.has(R)&&!this._systemSchemes.has(R)}getCapabilities(R){return this._providerInfo.get(R)}}e.ExtHostFileSystemInfo=I,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(me[199],ge([0,1,17]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(R,k,D){this._deferredPromises=new Map,this._id=R,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of A.values())n.complete()}catch(n){for(const T of A.values())T.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,k){let D=this._value[R];return typeof D=="undefined"&&(D=k),D}update(R,k){this._value[R]=k;let D=this._deferredPromises.get(R);if(D!==void 0)return D.p;const A=new m.DeferredPromise;return this._deferredPromises.set(R,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class I extends L{constructor(R,k){super(R.identifier.value,!0,k);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=I}),define(me[200],ge([0,1,3,2,12]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,D){this._logService=k,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,D,A){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(D.value,A)}$acceptDirtyStateChanged(k,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(D)}$acceptModelSaved(k){const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(k,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,D);const A=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));A.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};C=Ve([xe(0,I.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(me[14],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[201],ge([0,1,26,3]),function(Z,e,m,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,D){I.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),rt(this,I,D,"f"),Be(this,I,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(k){return Be(this,I,"f").get(this._id,k)}store(k,D){return Be(this,I,"f").store(this._id,k,D)}delete(k){return Be(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=C,I=new WeakMap}),define(me[123],ge([0,1,4,3]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(me[88],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,I=(E,o)=>{const a={controllerId:o};return L.set(E,a),a};e.createPrivateApiFor=I;const C=E=>L.get(E);e.getPrivateApiFor=C;const R=(E,o,a,v)=>{let t=a;return{enumerable:!0,configurable:!1,get(){return t},set(r){if(!v(t,r)){const s=t;t=r,E.listener?.({op:3,key:o,value:r,previous:s})}}}},k=(E,o)=>E===o,D={range:(E,o)=>E===o?!0:!E||!o?!1:E.isEqual(o),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(E,o)=>!(E.length!==o.length||E.some(a=>!o.find(v=>a.id===v.id)))},A=Object.keys(D),n=(E,o)=>({range:R(E,"range",void 0,D.range),label:R(E,"label",o,D.label),description:R(E,"description",void 0,D.description),canResolveChildren:R(E,"canResolveChildren",!1,D.canResolveChildren),busy:R(E,"busy",!1,D.busy),error:R(E,"error",void 0,D.error),tags:R(E,"tags",[],D.tags)}),T=(E,o)=>{const a=new Map;for(const v of A)D[v](E[v],o[v])||a.set(v,o[v]);return a};e.diffTestItems=T;class u extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=u;class h extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class c extends Error{constructor(o,a,v){super(`TestItem with ID "${o}" is from controller "${a}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=c;const g=E=>{const o=(0,e.getPrivateApiFor)(E);let a=new Map;return{get size(){return a.size},forEach(v,t){for(const r of a.values())v.call(t,r,this)},replace(v){const t=new Map,r=new Set(a.keys()),s={op:4,ops:[]};for(const i of v){if(!(i instanceof _))throw new h(i.id);const l=(0,e.getPrivateApiFor)(i).controllerId;if(l!==o.controllerId)throw new c(i.id,l,o.controllerId);if(t.has(i.id))throw new u(i.id);t.set(i.id,i),r.delete(i.id),s.ops.push({op:0,item:i})}for(const i of r.keys())s.ops.push({op:1,id:i});o.listener?.(s),a=t},add(v){if(!(v instanceof _))throw new h(v.id);a.set(v.id,v),o.listener?.({op:0,item:v})},delete(v){a.delete(v)&&o.listener?.({op:1,id:v})},get(v){return a.get(v)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};class _{constructor(o,a,v,t){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const r=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof P?void 0:r.parent}},children:{value:g(this),enumerable:!0,writable:!1},...n(r,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class P extends _{constructor(o,a){super(o,o,a,void 0)}}e.TestItemRootImpl=P}),define(me[52],ge([0,1,4,3,14]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var C;(function(k){function D(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}k.fromApiTunnel=D;function A(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}k.fromServiceTunnel=A})(C=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let R=class{constructor(D){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,A){return{dispose:()=>{}}}async $providePortAttributes(D,A,n,T,u){return[]}async $forwardPort(D,A){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ve([xe(0,I.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[7],ge([0,1,20,16,99,23,102,13,2,32,42,122]),function(Z,e,m,L,I,C,R,k,D,A,n,T){"use strict";var u,h,c,g,_,P,E,o,a,v,t,r,s,i,l,d,f,w,y,p;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function S(V){function W(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(W,V),Object.setPrototypeOf(W.prototype,V.prototype),W}let b=_=class{constructor(W){u.set(this,void 0),rt(this,u,W,"f")}static from(...W){let se=W;return new _(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}dispose(){typeof Be(this,u,"f")=="function"&&(Be(this,u,"f").call(this),rt(this,u,void 0,"f"))}};u=new WeakMap,b=_=Ve([S],b),e.Disposable=b;let F=P=class{constructor(W,se){if(W<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=W,this._character=se}static Min(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let De=1;De<W.length;De++){const Ze=W[De];Ze.isBefore(se)&&(se=Ze)}return se}static Max(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let De=1;De<W.length;De++){const Ze=W[De];Ze.isAfter(se)&&(se=Ze)}return se}static isPosition(W){if(!W)return!1;if(W instanceof P)return!0;let{line:se,character:De}=W;return typeof se=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,se=0){if(W===null||se===null)throw(0,L.illegalArgument)();let De;return typeof W=="undefined"?De=0:typeof W=="number"?De=W:(De=typeof W.lineDelta=="number"?W.lineDelta:0,se=typeof W.characterDelta=="number"?W.characterDelta:0),De===0&&se===0?this:new P(this.line+De,this.character+se)}with(W,se=this.character){if(W===null||se===null)throw(0,L.illegalArgument)();let De;return typeof W=="undefined"?De=this.line:typeof W=="number"?De=W:(De=typeof W.line=="number"?W.line:this.line,se=typeof W.character=="number"?W.character:this.character),De===this.line&&se===this.character?this:new P(De,se)}toJSON(){return{line:this.line,character:this.character}}};F=P=Ve([S],F),e.Position=F;let N=E=class{constructor(W,se,De,Ze){let it,dt;if(typeof W=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ze=="number"?(it=new F(W,se),dt=new F(De,Ze)):W instanceof F&&se instanceof F&&(it=W,dt=se),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this._start=it,this._end=dt):(this._start=dt,this._end=it)}static isRange(W){return W instanceof E?!0:W?F.isPosition(W.start)&&F.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof E?this.contains(W._start)&&this.contains(W._end):W instanceof F?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const se=F.Max(W.start,this._start),De=F.Min(W.end,this._end);if(!se.isAfter(De))return new E(se,De)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const se=F.Min(W.start,this._start),De=F.Max(W.end,this.end);return new E(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,se=this.end){if(W===null||se===null)throw(0,L.illegalArgument)();let De;return W?F.isPosition(W)?De=W:(De=W.start||this.start,se=W.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new E(De,se)}toJSON(){return[this.start,this.end]}};N=E=Ve([S],N),e.Range=N;let G=o=class extends N{constructor(W,se,De,Ze){let it,dt;if(typeof W=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ze=="number"?(it=new F(W,se),dt=new F(De,Ze)):W instanceof F&&se instanceof F&&(it=W,dt=se),!it||!dt)throw new Error("Invalid arguments");super(it,dt);this._anchor=it,this._active=dt}static isSelection(W){return W instanceof o?!0:W?N.isRange(W)&&F.isPosition(W.anchor)&&F.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=o=Ve([S],G),e.Selection=G;class K{constructor(W,se,De){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,L.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=K;class M extends Error{constructor(W,se=T.RemoteAuthorityResolverErrorCode.Unknown,De){super(W);this._message=W,this._code=se,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static NotAvailable(W,se){return new M(W,T.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(W){return new M(W,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=M;var U;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var O;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(O=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=a=class{constructor(W,se){this._range=W,this._newText=se}static isTextEdit(W){return W instanceof a?!0:W?N.isRange(W)&&typeof W.newText=="string":!1}static replace(W,se){return new a(W,se)}static insert(W,se){return a.replace(new N(W,W),se)}static delete(W){return a.replace(W,"")}static setEndOfLine(W){const se=new a(new N(new F(0,0),new F(0,0)),"");return se.newEol=W,se}get range(){return this._range}set range(W){if(W&&!N.isRange(W))throw(0,L.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,L.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,L.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=a=Ve([S],$),e.TextEdit=$;var B;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let x=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,se,De,Ze){this._edits.push({_type:1,from:W,to:se,options:De,metadata:Ze})}createFile(W,se,De){this._edits.push({_type:1,from:void 0,to:W,options:se,metadata:De})}deleteFile(W,se,De){this._edits.push({_type:1,from:W,to:void 0,options:se,metadata:De})}replaceNotebookMetadata(W,se,De){this._edits.push({_type:3,metadata:De,uri:W,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(W,se,De,Ze,it){let dt,mt,Ct=[],At;if(Ht.isNotebookRange(se)&&Lt.isNotebookCellDataArray(De)&&!Lt.isNotebookCellDataArray(Ze)?(dt=se.start,mt=se.end,Ct=De,At=Ze):typeof se=="number"&&typeof De=="number"&&Lt.isNotebookCellDataArray(Ze)&&(dt=se,mt=De,Ct=Ze,At=it),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||Ct.length>0)&&this._edits.push({_type:5,uri:W,index:dt,count:mt-dt,cells:Ct,metadata:At})}replaceNotebookCellMetadata(W,se,De,Ze){this._edits.push({_type:3,metadata:Ze,uri:W,edit:{editType:8,index:se,metadata:De}})}replace(W,se,De,Ze){this._edits.push({_type:2,uri:W,edit:new $(se,De),metadata:Ze})}insert(W,se,De,Ze){this.replace(W,new N(se,se),De,Ze)}delete(W,se,De){this.replace(W,se,"",De)}has(W){return this._edits.some(se=>se._type===2&&se.uri.toString()===W.toString())}set(W,se){if(se)for(const De of se)De&&this._edits.push({_type:2,uri:W,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ze=this._edits[De];Ze._type===2&&Ze.uri.toString()===W.toString()&&(this._edits[De]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(W){const se=[];for(let De of this._edits)De._type===2&&De.uri.toString()===W.toString()&&se.push(De.edit);return se}entries(){const W=new C.ResourceMap;for(let se of this._edits)if(se._type===2){let De=W.get(se.uri);De||(De=[se.uri,[]],W.set(se.uri,De)),De[1].push(se.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};x=Ve([S],x),e.WorkspaceEdit=x;let j=v=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof v?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=v._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,se=this._tabstop++){if(typeof W=="function"){const De=new v;De._tabstop=this._tabstop,W(De),this._tabstop=De._tabstop,W=De.value}else W=v._escape(W);return this.value+="${",this.value+=se,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,se=this._tabstop++){const De=W.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(W,se){if(typeof se=="function"){const De=new v;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,se&&(this.value+=":",this.value+=se),this.value+="}",this}};j=v=Ve([S],j),e.SnippetString=j;var H;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(H=e.DiagnosticTag||(e.DiagnosticTag={}));var X;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(X=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let J=t=class{constructor(W,se){if(this.uri=W,se)if(se instanceof N)this.range=se;else if(se instanceof F)this.range=new N(se,se);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof t?!0:W?N.isRange(W.range)&&D.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};J=t=Ve([S],J),e.Location=J;let fe=class{constructor(W,se){this.location=W,this.message=se}static is(W){return W?typeof W.message=="string"&&W.location&&N.isRange(W.location.range)&&D.URI.isUri(W.location.uri):!1}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.location.range.isEqual(se.location.range)&&W.location.uri.toString()===se.location.uri.toString()}};fe=Ve([S],fe),e.DiagnosticRelatedInformation=fe;let _e=class{constructor(W,se,De=X.Error){if(!N.isRange(W))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=W,this.message=se,this.severity=De}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.severity===se.severity&&W.code===se.code&&W.severity===se.severity&&W.source===se.source&&W.range.isEqual(se.range)&&(0,m.equals)(W.tags,se.tags)&&(0,m.equals)(W.relatedInformation,se.relatedInformation,fe.isEqual)}};_e=Ve([S],_e),e.Diagnostic=_e;let Se=class{constructor(W,se){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=se}};Se=Ve([S],Se),e.Hover=Se;var Le;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(W,se=Le.Text){this.range=W,this.kind=se}toJSON(){return{range:this.range,kind:Le[this.kind]}}};We=Ve([S],We),e.DocumentHighlight=We;var Ne;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(V){V[V.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let z=r=class{constructor(W,se,De,Ze,it){this.name=W,this.kind=se,this.containerName=it,typeof De=="string"&&(this.containerName=De),Ze instanceof J?this.location=Ze:De instanceof N&&(this.location=new J(Ze,De)),r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};z=r=Ve([S],z),e.SymbolInformation=z;let ee=s=class{constructor(W,se,De,Ze,it){this.name=W,this.detail=se,this.kind=De,this.range=Ze,this.selectionRange=it,this.children=[],s.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(s.validate)}};ee=s=Ve([S],ee),e.DocumentSymbol=ee;var re;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(W,se){this.title=W,this.kind=se}};le=Ve([S],le),e.CodeAction=le;let Y=i=class{constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.sep)}};Y.sep=".",Y=i=Ve([S],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let oe=class{constructor(W,se){if(this.range=W,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ve([S],oe),e.SelectionRange=oe;class ve{constructor(W,se,De,Ze,it,dt){this.kind=W,this.name=se,this.detail=De,this.uri=Ze,this.range=it,this.selectionRange=dt}}e.CallHierarchyItem=ve;class Me{constructor(W,se){this.fromRanges=se,this.from=W}}e.CallHierarchyIncomingCall=Me;class je{constructor(W,se){this.fromRanges=se,this.to=W}}e.CallHierarchyOutgoingCall=je;var Qe;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(W,se){this.range=W,this.command=se}get isResolved(){return!!this.command}};et=Ve([S],et),e.CodeLens=et;let ke=l=class{constructor(W,se=!1){h.set(this,void 0),rt(this,h,new I.MarkdownString(W,{supportThemeIcons:se}),"f")}static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Be(this,h,"f").value}set value(W){Be(this,h,"f").value=W}get isTrusted(){return Be(this,h,"f").isTrusted}set isTrusted(W){Be(this,h,"f").isTrusted=W}get supportThemeIcons(){return Be(this,h,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,h,"f").supportThemeIcons=W}appendText(W){return Be(this,h,"f").appendText(W),this}appendMarkdown(W){return Be(this,h,"f").appendMarkdown(W),this}appendCodeblock(W,se){return Be(this,h,"f").appendCodeblock(se??"",W),this}};h=new WeakMap,ke=l=Ve([S],ke),e.MarkdownString=ke;let ct=class{constructor(W,se){this.label=W,this.documentation=se}};ct=Ve([S],ct),e.ParameterInformation=ct;let Q=class{constructor(W,se){this.label=W,this.documentation=se,this.parameters=[]}};Q=Ve([S],Q),e.SignatureInformation=Q;let te=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};te=Ve([S],te),e.SignatureHelp=te;var pe;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(pe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ze;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(ze=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(W,se,De){this.text=W,this.position=se,this.kind=De}};tt=Ve([S],tt),e.InlayHint=tt;var st;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var lt;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(lt=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(V){V[V.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let Dt=class{constructor(W,se){this.label=W,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&lt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Dt=Ve([S],Dt),e.CompletionItem=Dt;let ue=class{constructor(W=[],se=!1){this.items=W,this.isIncomplete=se}};ue=Ve([S],ue),e.CompletionList=ue;let Ie=class{constructor(W,se,De){this.text=W,this.range=se,this.command=De}};Ie=Ve([S],Ie),e.InlineSuggestion=Ie;let Ue=class{constructor(W){this.items=W}};Ue=Ve([S],Ue),e.InlineSuggestions=Ue;var Ge;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(Ge=e.ViewColumn||(e.ViewColumn={}));var $e;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})($e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ot;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(ot=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Re;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function W(se){switch(se){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=W}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor(W,se){if(se&&!D.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!N.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.target=se}};be=Ve([S],be),e.DocumentLink=be;let we=class{constructor(W,se,De,Ze){this.red=W,this.green=se,this.blue=De,this.alpha=Ze}};we=Ve([S],we),e.Color=we;let Fe=class{constructor(W,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!N.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.color=se}};Fe=Ve([S],Fe),e.ColorInformation=Fe;let qe=class{constructor(W){if(!W||typeof W!="string")throw(0,L.illegalArgument)("label");this.label=W}};qe=Ve([S],qe),e.ColorPresentation=qe;var He;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var Je;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class nt{constructor(W,se,De){if(this.startIndex=W,this.length=se,this.tooltip=De,typeof W!="number"||W<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=nt;var ae;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(ae=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(W){this.options=W,typeof W!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ce;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Te=d=class{constructor(W,se){if(this.label=se,typeof W!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Te.Clean=new d("clean","Clean"),Te.Build=new d("build","Build"),Te.Rebuild=new d("rebuild","Rebuild"),Te.Test=new d("test","Test"),Te=d=Ve([S],Te),e.TaskGroup=Te;function Pe(V){let W="";for(let se=0;se<V.length;se++)W+=V[se].replace(/,/g,",,")+",";return W}let Ye=class{constructor(W,se,De){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=W,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let se of this._args)W.push(se);return Pe(W)}};Ye=Ve([S],Ye),e.ProcessExecution=Ye;let Xe=class{constructor(W,se,De){if(this._args=[],Array.isArray(se)){if(!W)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W,this._args=se,this._options=De}else{if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W,this._options=se}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)W.push(typeof se=="string"?se:se.value);return Pe(W)}};Xe=Ve([S],Xe),e.ShellExecution=Xe;var at;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(at=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class _t{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=_t;let ht=f=class{constructor(W,se,De,Ze,it,dt){this.__deprecated=!1,this._definition=this.definition=W;let mt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=Ze,mt=it,this.__deprecated=!0):se===wt.Global||se===wt.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=Ze,this.execution=it,mt=dt):(this.target=se,this._name=this.name=De,this._source=this.source=Ze,this.execution=it,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ye?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const se=this._definition.type;(f.EmptyType===se||f.ProcessType===se||f.ShellType===se||f.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=f=Ve([S],ht),e.Task=ht;var gt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let ft=class{constructor(W,se=Tt.None){this.collapsibleState=se,D.URI.isUri(W)?this.resourceUri=W:this.label=W}};ft=Ve([S],ft),e.TreeItem=ft;var Tt;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(W,se){this.id=W,this.color=se}};yt=Ve([S],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let xt=class{constructor(W){this.id=W}};xt=Ve([S],xt),e.ThemeColor=xt;var Bt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Bt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(W,se){if(typeof W!="string"&&(!W||!D.URI.isUri(W)&&!D.URI.isUri(W.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=D.URI.file(W),this.base=W):D.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=se}};It=Ve([S],It),e.RelativePattern=It;let $t=class{constructor(W,se,De,Ze){this.enabled=typeof W=="boolean"?W:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};$t=Ve([S],$t),e.Breakpoint=$t;let tn=class extends $t{constructor(W,se,De,Ze,it){super(se,De,Ze,it);if(W===null)throw(0,L.illegalArgument)("location");this.location=W}};tn=Ve([S],tn),e.SourceBreakpoint=tn;let bt=class extends $t{constructor(W,se,De,Ze,it){super(se,De,Ze,it);this.functionName=W}};bt=Ve([S],bt),e.FunctionBreakpoint=bt;let Xt=class extends $t{constructor(W,se,De,Ze,it,dt,mt){super(Ze,it,dt,mt);if(!se)throw(0,L.illegalArgument)("dataId");this.label=W,this.dataId=se,this.canPersist=De}};Xt=Ve([S],Xt),e.DataBreakpoint=Xt;let zt=class{constructor(W,se,De){this.command=W,this.args=se||[],this.options=De}};zt=Ve([S],zt),e.DebugAdapterExecutable=zt;let nn=class{constructor(W,se){this.port=W,this.host=se}};nn=Ve([S],nn),e.DebugAdapterServer=nn;let rn=class{constructor(W){this.path=W}};rn=Ve([S],rn),e.DebugAdapterNamedPipeServer=rn;let Pt=class{constructor(W){this.implementation=W}};Pt=Ve([S],Pt),e.DebugAdapterInlineImplementation=Pt;let Jt=class{constructor(W,se){this.range=W,this.expression=se}};Jt=Ve([S],Jt),e.EvaluatableExpression=Jt;var wn;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(wn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(W,se){this.range=W,this.text=se}};Wt=Ve([S],Wt),e.InlineValueText=Wt;let pt=class{constructor(W,se,De=!0){this.range=W,this.variableName=se,this.caseSensitiveLookup=De}};pt=Ve([S],pt),e.InlineValueVariableLookup=pt;let sn=class{constructor(W,se){this.range=W,this.expression=se}};sn=Ve([S],sn),e.InlineValueEvaluatableExpression=sn;let Ft=class{constructor(W,se){this.frameId=W,this.stoppedLocation=se}};Ft=Ve([S],Ft),e.InlineValueContext=Ft;var Vt;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Yt=w=class extends Error{constructor(W,se=n.FileSystemProviderErrorCode.Unknown,De){super(D.URI.isUri(W)?W.toString(!0):W);this.code=De?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(W){return new w(W,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(W){return new w(W,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(W){return new w(W,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(W){return new w(W,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(W){return new w(W,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(W){return new w(W,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Yt=w=Ve([S],Yt),e.FileSystemError=Yt;let on=class{constructor(W,se,De){this.start=W,this.end=se,this.kind=De}};on=Ve([S],on),e.FoldingRange=on;var dn;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(dn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bn;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(bn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hn;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(hn=e.CommentMode||(e.CommentMode={}));class an{constructor(W,se=[]){this.tokenTypes=W,this.tokenModifiers=se}}e.SemanticTokensLegend=an;function En(V){return typeof V=="undefined"||(0,k.isStringArray)(V)}class jt{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let se=0,De=W.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set(W.tokenTypes[se],se);for(let se=0,De=W.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set(W.tokenModifiers[se],se)}}push(W,se,De,Ze,it){if(typeof W=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ze=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(W,se,De,Ze,it);if(N.isRange(W)&&typeof se=="string"&&En(De))return this._push(W,se,De);throw(0,L.illegalArgument)()}_push(W,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ze=W.start.line,it=W.start.character,dt=W.end.character-W.start.character,mt=this._tokenTypeStrToInt.get(se);let Ct=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(At);Ct|=1<<Mt>>>0}this._pushEncoded(Ze,it,dt,mt,Ct)}_pushEncoded(W,se,De,Ze,it){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Mt=0;for(let Ot=0;Ot<Ct;Ot++){let Nt=this._data[5*Ot],cn=this._data[5*Ot+1];Nt===0?(Nt=At,cn+=Mt):Nt+=At,this._data[5*Ot]=Nt,this._data[5*Ot+1]=cn,At=Nt,Mt=cn}}let dt=W,mt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=it,this._prevLine=W,this._prevChar=se}static _sortAndDeltaEncode(W){let se=[];const De=W.length/5|0;for(let mt=0;mt<De;mt++)se[mt]=mt;se.sort((mt,Ct)=>{const At=W[5*mt],Mt=W[5*Ct];if(At===Mt){const Ot=W[5*mt+1],Nt=W[5*Ct+1];return Ot-Nt}return At-Mt});const Ze=new Uint32Array(W.length);let it=0,dt=0;for(let mt=0;mt<De;mt++){const Ct=5*se[mt],At=W[Ct+0],Mt=W[Ct+1],Ot=W[Ct+2],Nt=W[Ct+3],cn=W[Ct+4],xn=At-it,Gn=xn===0?Mt-dt:Mt,un=5*mt;Ze[un+0]=xn,Ze[un+1]=Gn,Ze[un+2]=Ot,Ze[un+3]=Nt,Ze[un+4]=cn,it=At,dt=Mt}return Ze}build(W){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),W):new qt(jt._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=jt;class qt{constructor(W,se){this.resultId=se,this.data=W}}e.SemanticTokens=qt;class _n{constructor(W,se,De){this.start=W,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=_n;class Sn{constructor(W,se){this.resultId=se,this.edits=W}}e.SemanticTokensEdits=Sn;var Gt;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yn;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(yn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new yt("arrow-left")},Zt=Ve([S],Zt),e.QuickInputButtons=Zt;var Dn;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(W,se,De){this.badge=W,this.tooltip=se,this.color=De}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let Kt=class{constructor(W){this.kind=W}};Kt=Ve([S],Kt),e.ColorTheme=Kt;var fn;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(fn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(W,se){if(W<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");W<=se?(this._start=W,this._end=se):(this._start=se,this._end=W)}static isNotebookRange(W){return W instanceof Ht?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let se=this._start,De=this._end;return W.start!==void 0&&(se=W.start),W.end!==void 0&&(De=W.end),se===this._start&&De===this._end?this:new Ht(se,De)}}e.NotebookRange=Ht;class Lt{constructor(W,se,De,Ze,it,dt,mt){this.kind=W,this.value=se,this.languageId=De,this.mime=Ze,this.outputs=it??[],this.metadata=dt,this.executionSummary=mt,Lt.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(se=>Lt.isNotebookCellData(se))}static isNotebookCellData(W){return!0}}e.NotebookCellData=Lt;class Oe{constructor(W){this.cells=W}}e.NotebookData=Oe;class Rt{constructor(W,se){this.data=W,this.mime=se;const De=(0,R.normalizeMimeType)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(W){return W instanceof Rt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const se={name:W.name,message:W.message,stack:W.stack};return Rt.json(se,"application/vnd.code.notebook.error")}static stdout(W){return Rt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Rt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,se="application/octet-stream"){return new Rt(W,se)}static text(W,se=R.Mimes.text){const De=Be(Rt,c,"f",g).encode(String(W));return new Rt(De,se)}static json(W,se="application/json"){const De=JSON.stringify(W,void 0,"	");return Rt.text(De,se)}}e.NotebookCellOutputItem=Rt,c=Rt,g={value:new TextEncoder};class Qt{constructor(W,se,De){this.items=Qt.ensureUniqueMimeTypes(W,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,A.generateUuid)(),this.metadata=se??De)}static isNotebookCellOutput(W){return W instanceof Qt?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,k.isArray)(W.items)}static ensureUniqueMimeTypes(W,se=!1){const De=new Set,Ze=new Set;for(let it=0;it<W.length;it++){const dt=W[it],mt=(0,R.normalizeMimeType)(dt.mime);if(!De.has(mt)){De.add(mt);continue}Ze.add(it),se&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ze.size===0?W:W.filter((it,dt)=>!Ze.has(dt))}}e.NotebookCellOutput=Qt;var Et;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Et=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mn;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(mn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(W,se){this.text=W,this.alignment=se}}e.NotebookCellStatusBarItem=gn;var Pn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(W,se=[]){this.uri=W,this.provides=(0,m.asArray)(se)}}e.NotebookRendererScript=Tn;let ln=class{constructor(W,se){this.label=W,this.timestamp=se}};ln=Ve([S],ln),e.TimelineItem=ln;var An;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var pn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(pn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(W,se){this.ranges=W,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor(W,se){this._port=W,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor(W,se,De){this.include=W,this.exclude=se,this.profile=De}};ie=Ve([S],ie),e.TestRunRequest=ie;let he=y=class{constructor(W){this.message=W}static diff(W,se,De){const Ze=new y(W);return Ze.expectedOutput=se,Ze.actualOutput=De,Ze}};he=y=Ve([S],he),e.TestMessage=he;let Ae=class{constructor(W,se){if(this.id=W,this.label=se,/\s/.test(W))throw new Error(`Test tag ID "${W}" may not include whitespace`)}};Ae=Ve([S],Ae),e.TestTag=Ae;let ut=class{constructor(W,se){this.covered=W,this.total=se}};ut=Ve([S],ut),e.CoveredCount=ut;let St=p=class{constructor(W,se,De,Ze){this.uri=W,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=Ze}static fromDetails(W,se){const De=new ut(0,0),Ze=new ut(0,0),it=new ut(0,0);for(const mt of se)if("branches"in mt){De.total+=1,De.covered+=mt.executionCount>0?1:0;for(const Ct of mt.branches)Ze.total+=1,Ze.covered+=Ct.executionCount>0?1:0}else it.total+=1,it.covered+=mt.executionCount>0?1:0;const dt=new p(W,De,Ze.total>0?Ze:void 0,it.total>0?it:void 0);return dt.detailedCoverage=se,dt}};St=p=Ve([S],St),e.FileCoverage=St;let kt=class{constructor(W,se,De=[]){this.executionCount=W,this.location=se,this.branches=De}};kt=Ve([S],kt),e.StatementCoverage=kt;let Nn=class{constructor(W,se){this.executionCount=W,this.location=se}};Nn=Ve([S],Nn),e.BranchCoverage=Nn;let Un=class{constructor(W,se){this.executionCount=W,this.location=se}};Un=Ve([S],Un),e.FunctionCoverage=Un;var zn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(W,se,De,Ze,it,dt){this.kind=W,this.name=se,this.detail=De,this.uri=Ze,this.range=it,this.selectionRange=dt}}e.TypeHierarchyItem=qn}),define(me[124],ge([0,1,54,10,9,150,110,7,20]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function n(c,g){g?A.set(c,g):A.delete(c)}e.setWordDefinitionFor=n;function T(c){return A.get(c)}e.getWordDefinitionFor=T;class u extends C.MirrorTextModel{constructor(g,_,P,E,o,a,v,t){super(_,P,E,o);this._proxy=g,this._languageId=a,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,D.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===L.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(_){return _?g._getTextInRange(_):g.getText()},get eol(){return g._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(_){return g._lineAt(_)},offsetAt(_){return g._offsetAt(_)},positionAt(_){return g._positionAt(_)},validateRange(_){return g._validateRange(_)},validatePosition(_){return g._validatePosition(_)},getWordRangeAtPosition(_,P){return g._getWordRangeAtPosition(_,P)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,m.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,m.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const _=this._validateRange(g);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const P=this._eol,E=_.start.line,o=_.end.line,a=[];a.push(this._lines[E].substring(_.start.character));for(let v=E+1;v<o;v++)a.push(this._lines[v]);return a.push(this._lines[o].substring(0,_.end.character)),a.join(P)}_lineAt(g){let _;if(g instanceof k.Position?_=g.line:typeof g=="number"&&(_=g),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new h(_,this._lines[_],_===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(g),P=this._lines[_.index].length;return new k.Position(_.index,Math.min(_.remainder,P))}_validateRange(g){if(!(g instanceof k.Range))throw new Error("Invalid argument");const _=this._validatePosition(g.start),P=this._validatePosition(g.end);return _===g.start&&P===g.end?g:new k.Range(_.line,_.character,P.line,P.character)}_validatePosition(g){if(!(g instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:_,character:P}=g,E=!1;if(_<0)_=0,P=0,E=!0;else if(_>=this._lines.length)_=this._lines.length-1,P=this._lines[_].length,E=!0;else{const o=this._lines[_].length;P<0?(P=0,E=!0):P>o&&(P=o,E=!0)}return E?new k.Position(_,P):g}_getWordRangeAtPosition(g,_){const P=this._validatePosition(g);if(!_)_=T(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const E=(0,R.getWordAtText)(P.character+1,(0,R.ensureValidWordDefinition)(_),this._lines[P.line],0);if(E)return new k.Range(P.line,E.startColumn-1,P.line,E.endColumn-1)}}e.ExtHostDocumentData=u;class h{constructor(g,_,P){this._line=g,this._text=_,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(me[202],ge([0,1,7,3,112,6,81,23,2,32]),function(Z,e,m,L,I,C,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(u,h,c,g){this._notebook=c,this._selector=g,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(P=>{const E=this._cellUris.get(P.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(P=>_(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const u=[],h=[];for(const c of this._notebook.getCells())c.kind===m.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),u.push(c.document.getText().length+1),h.push(c.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(u){if(!u){let E="";for(const o of this._cells)E+=o.document.getText()+`
`;return E=E.slice(0,-1),E}if(u.isEmpty)return"";const h=this.locationAt(u.start),c=this.locationAt(u.end),g=this._cellUris.get(h.uri),_=this._cellUris.get(c.uri);if(g===void 0||_===void 0)return"";if(g===_)return this._cells[g].document.getText(new m.Range(h.range.start,c.range.end));const P=[this._cells[g].document.getText(new m.Range(h.range.start,new m.Position(this._cells[g].document.lineCount,0)))];for(let E=g+1;E<_;E++)P.push(this._cells[E].document.getText());return P.push(this._cells[_].document.getText(new m.Range(new m.Position(0,0),c.range.end))),P.join(`
`)}offsetAt(u){const h=this._cellLines.getIndexOf(u.line),c=this._cellLengths.getPrefixSum(h.index-1),g=this._cells[h.index].document.offsetAt(u.with(h.remainder));return c+g}positionAt(u){if(typeof u=="number"){const c=this._cellLengths.getIndexOf(u),g=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(g)}const h=this._cellUris.get(u.uri);if(h!==void 0){const c=this._cellLines.getPrefixSum(h-1);return new m.Position(c+u.range.start.line,u.range.start.character)}return new m.Position(0,0)}locationAt(u){m.Range.isRange(u)||(u=new m.Range(u,u));const h=this._cellLines.getIndexOf(u.start.line);let c=h;u.isEmpty||(c=this._cellLines.getIndexOf(u.end.line));const g=new m.Position(h.remainder,u.start.character),_=new m.Position(c.remainder,u.end.character),P=new m.Range(g,_),E=this._cells[h.index];return new m.Location(E.document.uri,E.document.validateRange(P))}contains(u){return this._cellUris.has(u)}validateRange(u){const h=this.validatePosition(u.start),c=this.validatePosition(u.end);return u.with(h,c)}validatePosition(u){const h=this._cellLines.getIndexOf(u.line),c=new m.Position(h.remainder,u.character),g=this._cells[h.index].document.validatePosition(c),_=this._cellLines.getPrefixSum(h.index-1);return new m.Position(_+g.line,g.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[203],ge([0,1,7,14,3]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([xe(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(me[64],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=L}),define(me[204],ge([0,1,22]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(D){let A=this.buffers.indexOf(D);return A<0&&(A=this.buffers.length,this.buffers.push(D)),A}}function I(k,D){if(D.serializeBuffersForPostMessage){const A=new L,n=(h,c)=>{if(c instanceof ArrayBuffer){const g=A.add(c);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(c)){const g=C(c);if(g){const _=A.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:g,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},T=JSON.stringify(k,n),u=A.buffers.map(h=>{const c=new Uint8Array(h);return m.VSBuffer.wrap(c)});return{message:T,buffers:u}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(k,D){const A=D.map(u=>{const h=new ArrayBuffer(u.byteLength);return new Uint8Array(h).set(u.buffer),h}),n=D.length?(u,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const c=h,{index:g}=c,_=A[g];if(c.view)switch(c.view.type){case 1:return new Int8Array(_,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return h}:void 0;return{message:JSON.parse(k,n),arrayBuffers:A}}e.deserializeWebviewMessage=R}),define(me[205],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function I(R){const k={items:new Map};return R.types.forEach((D,A)=>{k.items.set(D,{asString:async()=>R.items[A].asString})}),k}L.toITreeDataTransfer=I;async function C(R){const k={types:[],items:[]},D=Array.from(R.items.entries());for(const A of D)k.types.push(A[0]),k.items.push({asString:await A[1].asString()});return k}L.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[89],ge([0,1,10,2]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,D){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(D&&D.authority&&D.isRemote&&k.scheme===m.Schemas.file&&(k=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:D.authority,path:k.path})),L.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function C(k){return k.replace(/./g,D=>{const A=D.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?D:"-"+A.toString(16).padStart(4,"0")})}function R(k){return k.replace(/-([0-9a-f]{4})/g,(D,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=R}),define(me[206],ge([0,1,3,6,89]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,D,A){this._proxy=k,this._editors=D,this._initData=A,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const n=D.getVisibleTextEditors();for(const T of this._insets.values())n.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,D,A,n,T){let u;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===k){u=o;break}if(!u)throw new Error("not a visible editor");const h=this,c=this._handlePool++,g=new m.Emitter,_=new m.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,I.asWebviewUri)(o,h._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(o){this._options=o,h._proxy.$setOptions(c,o)}get options(){return this._options}set html(o){this._html=o,h._proxy.$setHtml(c,o)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(o){return h._proxy.$postMessage(c,o)}},E=new class{constructor(){this.editor=k,this.line=D,this.height=A,this.webview=P,this.onDidDispose=_.event}dispose(){h._insets.has(c)&&(h._insets.delete(c),h._proxy.$disposeEditorInset(c),_.fire(),_.dispose(),g.dispose())}};return this._proxy.$createEditorInset(c,u.id,u.value.document.uri,D+1,A,n||{},T.identifier,T.extensionLocation),this._insets.set(c,{editor:k,inset:E,onDidReceiveMessage:g}),E}$onDidDispose(k){const D=this._insets.get(k);D&&D.inset.dispose()}$onDidReceiveMessage(k,D){const A=this._insets.get(k);A&&A.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=C}),define(me[207],ge([0,1,172,13,2,6,4,61,35,20,10]),function(Z,e,m,L,I,C,R,k,D,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(12,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(13,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(14,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(15,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(17,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(18,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(19,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(20,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function T(p){return typeof p?.getViewState=="function"}e.isTextEditorPane=T;function u(p){if(o(p))return!1;const S=p;return I.URI.isUri(S?.resource)}e.isResourceEditorInput=u;function h(p){if(o(p))return!1;const S=p;return S?.original!==void 0&&S.modified!==void 0}e.isResourceDiffEditorInput=h;function c(p){if(o(p))return!1;const S=p;return S?S.resource===void 0||S.resource.scheme===n.Schemas.untitled||S.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var g;(function(p){p[p.SHORT=0]="SHORT",p[p.MEDIUM=1]="MEDIUM",p[p.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var _;(function(p){p[p.EXPLICIT=1]="EXPLICIT",p[p.AUTO=2]="AUTO",p[p.FOCUS_CHANGE=3]="FOCUS_CHANGE",p[p.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var P;(function(p){p[p.None=0]="None",p[p.Readonly=2]="Readonly",p[p.Untitled=4]="Untitled",p[p.Singleton=8]="Singleton",p[p.RequiresTrust=16]="RequiresTrust"})(P=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends C.Disposable{}e.AbstractEditorInput=E;function o(p){return p instanceof E}e.isEditorInput=o;function a(p){const S=p;return I.URI.isUri(S?.preferredResource)}function v(p){const S=p;return o(S?.primary)&&o(S?.secondary)}e.isSideBySideEditorInput=v;function t(p){return o(p?.editor)}e.isEditorInputWithOptions=t;function r(p){const S=p;return t(p)&&S?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(p){const S=p;return typeof S?.groupId=="number"&&o(S.editor)}e.isEditorIdentifier=s;var i;(function(p){p[p.PRIMARY=1]="PRIMARY",p[p.SECONDARY=2]="SECONDARY",p[p.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(S,b){if(!S)return;const F=v(S)?S.primary:h(S)?S.modified:void 0,N=v(S)?S.secondary:h(S)?S.original:void 0;if(b?.supportSideBySide&&F&&N){if(b?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(F,{filterByScheme:b.filterByScheme}),secondary:this.getOriginalUri(N,{filterByScheme:b.filterByScheme})};S=b.supportSideBySide===i.PRIMARY?F:N}if(h(S))return;const G=a(S)?S.preferredResource:S.resource;return!G||!b||!b.filterByScheme?G:this.filterUri(G,b.filterByScheme)}getCanonicalUri(S,b){if(!S)return;const F=v(S)?S.primary:h(S)?S.modified:void 0,N=v(S)?S.secondary:h(S)?S.original:void 0;if(b?.supportSideBySide&&F&&N){if(b?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(F,{filterByScheme:b.filterByScheme}),secondary:this.getCanonicalUri(N,{filterByScheme:b.filterByScheme})};S=b.supportSideBySide===i.PRIMARY?F:N}if(h(S))return;const G=S.resource;return!G||!b||!b.filterByScheme?G:this.filterUri(G,b.filterByScheme)}filterUri(S,b){if(Array.isArray(b)){if(b.some(F=>S.scheme===F))return S}else if(b===S.scheme)return S}}e.EditorResourceAccessor=new l;var d;(function(p){p[p.LEFT=0]="LEFT",p[p.RIGHT=1]="RIGHT"})(d=e.CloseDirection||(e.CloseDirection={}));class f{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(S){const b=this.instantiationService=S.get(R.IInstantiationService);for(const[F,N]of this.editorSerializerConstructors)this.createEditorSerializer(F,N,b);this.editorSerializerConstructors.clear()}createEditorSerializer(S,b,F){const N=F.createInstance(b);this.editorSerializerInstances.set(S,N)}registerFileEditorFactory(S){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=S}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(S,b){if(this.editorSerializerConstructors.has(S)||this.editorSerializerInstances.has(S))throw new Error(`A editor serializer with type ID '${S}' was already registered.`);return this.instantiationService?this.createEditorSerializer(S,b,this.instantiationService):this.editorSerializerConstructors.set(S,b),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(S),this.editorSerializerInstances.delete(S)})}getEditorSerializer(S){return this.editorSerializerInstances.get(typeof S=="string"?S:S.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new f);async function w(p,S){if(!p||!p.length)return[];const b=await Promise.all(p.map(async F=>{const N=I.URI.revive(F.fileUri);if(!N||(await S.activateProvider(N.scheme),!S.canHandleResource(N)))return;const G=typeof F.exists=="boolean"?F.exists:await S.exists(N);if(!G&&F.openOnlyIfExists)return;const K=G&&!(0,L.isUndefined)(F.selection)?{selection:F.selection,pinned:!0,override:F.editorOverrideId}:{pinned:!0,override:F.editorOverrideId};let M;return G?M={resource:N,options:K,forceFile:!0}:M={resource:N,options:K,forceUntitled:!0},M}));return(0,A.coalesce)(b)}e.pathsToEditors=w;var y;(function(p){p[p.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",p[p.SEQUENTIAL=1]="SEQUENTIAL"})(y=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[208],ge([0,1,3,61,173,4,6,23,35,20,55,25,47,197]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",u.Codicon.window,(0,I.localize)(0,null));var c;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(c=e.Extensions||(e.Extensions={}));var g;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function P(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=P;class E extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new m.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new m.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,A.flatten)([...this.viewContainers.values()])}registerViewContainer(d,f,w){const y=this.get(d.id);if(y)return y;const p=d;return p.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,k.getOrSet)(this.viewContainers,f,[]).push(p),w?.isDefault&&this.defaultViewContainers.push(p),this._onDidRegister.fire({viewContainer:p,viewContainerLocation:f}),p}deregisterViewContainer(d){for(const f of this.viewContainers.keys()){const w=this.viewContainers.get(f),y=w?.indexOf(d);if(y!==-1){w?.splice(y,1),w.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:d,viewContainerLocation:f});return}}}get(d){return this.all.filter(f=>f.id===d)[0]}getViewContainers(d){return[...this.viewContainers.get(d)||[]]}getViewContainerLocation(d){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(w=>w?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===d)}}D.Registry.add(c.ViewContainersRegistry,new E);var o;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function a(l,d){const f=l.group??o.More,w=d.group??o.More;return f!==w?f.localeCompare(w):(l.order??5)-(d.order??5)}class v extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new m.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new m.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new m.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new m.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(d,f){this.registerViews2([{views:d,viewContainer:f}])}registerViews2(d){d.forEach(({views:f,viewContainer:w})=>this.addViews(f,w)),this._onViewsRegistered.fire(d)}deregisterViews(d,f){const w=this.removeViews(d,f);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:f})}moveViews(d,f){for(const w of this._views.keys())if(w!==f){const y=this.removeViews(d,w);y.length&&(this.addViews(y,f),this._onDidChangeContainer.fire({views:y,from:w,to:f}))}}getViews(d){return this._views.get(d)||[]}getView(d){for(const f of this._viewContainers){const w=(this._views.get(f)||[]).filter(y=>y.id===d)[0];if(w)return w}return null}getViewContainer(d){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(y=>y.id===d)[0])return f;return null}registerViewWelcomeContent(d,f){return this._viewWelcomeContents.add(d,f),this._onDidChangeViewWelcomeContent.fire(d),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(d,f),this._onDidChangeViewWelcomeContent.fire(d)})}registerViewWelcomeContent2(d,f){const w=new Map;for(const[y,p]of f)this._viewWelcomeContents.add(d,p),w.set(y,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(d,p),this._onDidChangeViewWelcomeContent.fire(d)}));return this._onDidChangeViewWelcomeContent.fire(d),w}getViewWelcomeContent(d){const f=[];return this._viewWelcomeContents.forEach(d,w=>f.push(w)),f.sort(a)}addViews(d,f){let w=this._views.get(f);w||(w=[],this._views.set(f,w),this._viewContainers.push(f));for(const y of d){if(this.getView(y.id)!==null)throw new Error((0,I.localize)(1,null,y.id));w.push(y)}}removeViews(d,f){const w=this._views.get(f);if(!w)return[];const y=[],p=[];for(const S of w)d.includes(S)?y.push(S):p.push(S);return y.length&&(p.length?this._views.set(f,p):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),y}}D.Registry.add(c.ViewsRegistry,new v),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var r;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(d,f){this.resolved=!1,this._hasResolve=!1,(0,T.mixin)(this,d),this._hasResolve=!!f,this.resolve=async w=>{if(f&&!this.resolved){const y=await f(w);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[125],ge([0,1,3,17,174]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,A,n){const T={command:k};if(D&&Object.keys(D).length>0&&(T.arguments=D),this.internalSend("request",T),typeof n=="number"){const u=setTimeout(()=>{clearTimeout(u);const h=this.pendingRequests.get(T.seq);if(h){this.pendingRequests.delete(T.seq);const c={type:"response",seq:0,request_seq:T.seq,success:!1,command:k,message:(0,I.localize)(0,null,n,k)};h(c)}},n)}return A&&this.pendingRequests.set(T.seq,A),T.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,A=this.pendingRequests.get(D.request_seq);A&&(this.pendingRequests.delete(D.request_seq),A(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,A)=>k.set(A,D)),await(0,L.timeout)(500),k.forEach((D,A)=>{D({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(me[209],ge([0,1,9,2,8,25,10]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(s,i,l){return s.replace(k,function(d,f){return i&&f.length>0&&f[0]!=="_"?d:l&&l.hasOwnProperty(f)?l[f]:d})}e.formatPII=D;function A(s){const i={};for(const l of Object.keys(s))l.startsWith("!")||(i[l]=s[l]);return i}e.filterExceptionsFromTelemetry=A;function n(s){return s.configuration.request==="attach"&&!T(s)&&(!s.parentSession||n(s.parentSession))}e.isSessionAttach=n;function T(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(i,"extensionhost")||(0,m.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?T(s.parentSession):void 0}e.getExtensionHostDebugSession=T;function u(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=u;function h(s,i,l){let d,f=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,y=null;for(;y=w.exec(s);){let p=y.index+1,S=p+y[0].length;if(p<=i&&S>=l){d=y[0],f=p;break}}if(d){let p=/\w+/g,S=null;for(;(S=p.exec(d))&&!(S.index+1+f+S[0].length>=l););S&&(d=d.substring(0,p.lastIndex))}return d?{start:f,end:f+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(s){return!!(s&&s.match(c))}e.isUri=g;function _(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(g(s.path))return L.URI.parse(s.path);if((0,I.isAbsolute)(s.path))return L.URI.file(s.path)}return s.path}function P(s){if(typeof s.path=="object"){const i=L.URI.revive(s.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return s.path}function E(s,i){const l=i?_:P,d=(0,C.deepClone)(s);return a(d,(f,w)=>{f&&w&&(w.path=l(w))}),d}e.convertToDAPaths=E;function o(s,i){const l=i?_:P,d=(0,C.deepClone)(s);return a(d,(f,w)=>{!f&&w&&(w.path=l(w))}),d}e.convertToVSCPaths=o;function a(s,i){switch(s.type){case"event":const l=s;switch(l.event){case"output":i(!1,l.body.source);break;case"loadedSource":i(!1,l.body.source);break;case"breakpoint":i(!1,l.body.breakpoint.source);break;default:break}break;case"request":const d=s;switch(d.command){case"setBreakpoints":i(!0,d.arguments.source);break;case"breakpointLocations":i(!0,d.arguments.source);break;case"source":i(!0,d.arguments.source);break;case"gotoTargets":i(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(w=>i(!1,w));break;default:break}break;case"response":const f=s;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(w=>i(!1,w.source));break;case"loadedSources":f.body.sources.forEach(w=>i(!1,w));break;case"scopes":f.body.scopes.forEach(w=>i(!1,w.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(w=>i(!1,w.source));break;case"setBreakpoints":f.body.breakpoints.forEach(w=>i(!1,w.source));break;default:break}break}}function v(s){return s.filter(i=>!i.presentation?.hidden).sort((i,l)=>i.presentation?l.presentation?i.presentation.group?l.presentation.group?i.presentation.group!==l.presentation.group?i.presentation.group.localeCompare(l.presentation.group):t(i.presentation.order,l.presentation.order):-1:l.presentation.group?1:t(i.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function r(s,i){const l=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(l!=="none"&&(await i.saveAll(),l==="allEditorsInActiveGroup")){const d=i.activeEditorPane;d&&await i.save({editor:d.input,groupId:d.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(me[210],ge([0,1,28,39,175,126,8,9,25,11,185,125]),function(Z,e,m,L,I,C,R,k,D,A,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends T.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",a=>this.handleData(a))}sendMessage(E){if(this.outputStream){const o=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${u.TWO_CRLF}${o}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+o))}continue}}else{const o=this.rawData.indexOf(u.TWO_CRLF);if(o!==-1){const v=this.rawData.toString("utf8",0,o).split(u.HEADER_LINESEPARATOR);for(const t of v){const r=t.split(u.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(o+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class h extends u{startSession(){return new Promise((E,o)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",v=>{a?this._onError.fire(v):o(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=h;class c extends h{constructor(E){super();this.adapterServer=E}createConnection(E){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=c;class g extends h{constructor(E){super();this.adapterServer=E}createConnection(E){return C.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=g;class _ extends u{constructor(E,o,a){super();this.adapterExecutable=E,this.debugType=o,this.outputService=a}async startSession(){const E=this.adapterExecutable.command,o=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(E)if(R.isAbsolute(E)){if(!await m.Promises.exists(E))throw new Error(I.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let v=process.env;if(a.env&&Object.keys(a.env).length>0&&(v=D.mixin(D.deepClone(process.env),a.env)),E==="node")if(Array.isArray(o)&&o.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:v,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(s.cwd=a.cwd);const i=L.fork(o[0],o.slice(1),s);if(!i.pid)throw new Error(I.localize(2,null,o[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const r={env:v};a.cwd&&(r.cwd=a.cwd),this.serverProcess=L.spawn(E,o,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,s)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(r(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((E,o)=>{const a=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,r){if(v)return o(v)});a.on("exit",E),a.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,o){if(!E)return;const a=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?a.runtime=R.join(o,E.runtime):a.runtime=E.runtime),E.runtimeArgs&&(a.runtimeArgs=E.runtimeArgs),E.program&&(R.isAbsolute(E.program)?a.program=E.program:a.program=R.join(o,E.program)),E.args&&(a.args=E.args);const v=E;return v.win&&(a.win=_.extract(v.win,o)),v.winx86&&(a.winx86=_.extract(v.winx86,o)),v.windows&&(a.windows=_.extract(v.windows,o)),v.osx&&(a.osx=_.extract(v.osx,o)),v.linux&&(a.linux=_.extract(v.linux,o)),a}static platformAdapterExecutable(E,o){let a=Object.create(null);o=o.toLowerCase();for(const l of E)if(l.contributes){const d=l.contributes.debuggers;d&&d.length>0&&d.filter(f=>typeof f.type=="string"&&k.equalsIgnoreCase(f.type,o)).forEach(f=>{const w=_.extract(f,l.extensionLocation.fsPath);a=D.mixin(a,w,l.isBuiltin)})}let v;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=a.winx86||a.win||a.windows:A.isWindows?v=a.win||a.windows:A.isMacintosh?v=a.osx:A.isLinux&&(v=a.linux),v=v||a;let t=v.program||a.program;const r=v.args||a.args;let s=v.runtime||a.runtime;const i=v.runtimeArgs||a.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(me[211],ge([0,1,39,11,29,188]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(u,h){return new Promise((c,g)=>{let _="";const P=m.spawn(u,h);P.pid&&P.stdout.on("data",E=>{_+=E.toString()}),P.on("error",E=>{g(E)}),P.on("close",E=>{c(_)})})}let k;function D(u,h){if(!k)if(L.isWindows)k=new C.WindowsExternalTerminalService;else if(L.isMacintosh)k=new C.MacExternalTerminalService;else if(L.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=h.getConfiguration("terminal");return k.runInTerminal(u.title,u.cwd,u.args,u.env||{},c.external||{})}e.runInExternalTerminal=D;function A(u){return u?L.isWindows?new Promise(async h=>{(await new Promise((g,_)=>{Z(["windows-process-tree"],g,_)})).getProcessTree(u,g=>{h(g.children.length>0)})}):R("/usr/bin/pgrep",["-lP",String(u)]).then(h=>{const c=h.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},h=>!0):Promise.resolve(!0)}e.hasChildProcesses=A;var n;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(n||(n={}));function T(u,h,c,g){u=u.trim().toLowerCase();let _;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?_=1:u.indexOf("cmd.exe")>=0?_=0:u.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let P,E=" ";switch(_){case 1:if(P=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),c){const a=(0,I.getDriveLetter)(c);a&&(E+=`${a}:; `),E+=`cd ${P(c)}; `}if(g)for(let a in g){const v=g[a];v===null?E+=`Remove-Item env:${a}; `:E+=`\${env:${a}}='${v}'; `}if(h.length>0){const a=P(h.shift());E+=a[0]==="'"?`& ${a} `:`${a} `;for(let v of h)E+=`${P(v)} `}break;case 0:if(P=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),c){const a=(0,I.getDriveLetter)(c);a&&(E+=`${a}: && `),E+=`cd ${P(c)} && `}if(g){E+='cmd /C "';for(let a in g){let v=g[a];v===null?E+=`set "${a}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${a}=${v}" && `)}}for(let a of h)E+=`${P(a)} `;g&&(E+='"');break;case 2:P=a=>(a=a.replace(/(["'\\\$])/g,"\\$1"),a.indexOf(" ")>=0||a.indexOf(";")>=0||a.length===0?`"${a}"`:a);const o=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(c&&(E+=`cd ${P(c)} ; `),g){E+="/usr/bin/env";for(let a in g){const v=g[a];v===null?E+=` -u ${o(a)}`:E+=` ${o(`${a}=${v}`)}`}E+=" "}for(let a of h)E+=`${P(a)} `;break}return E}e.prepareCommand=T}),define(me[127],ge([0,1,30,102,10,8,11,61]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(p){p[p.Markup=1]="Markup",p[p.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(p){p[p.Running=1]="Running",p[p.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(p){p[p.Pending=2]="Pending",p[p.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(p){p[p.WithHardKernelDependency=0]="WithHardKernelDependency",p[p.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",p[p.Pure=2]="Pure",p[p.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(p){p.Always="always",p.Never="never",p.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(p){p[p.ModelChange=1]="ModelChange",p[p.Move=2]="Move",p[p.ChangeLanguage=5]="ChangeLanguage",p[p.Initialize=6]="Initialize",p[p.ChangeCellMetadata=7]="ChangeCellMetadata",p[p.Output=8]="Output",p[p.OutputItem=9]="OutputItem",p[p.ChangeCellContent=10]="ChangeCellContent",p[p.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",p[p.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",p[p.ChangeCellMime=13]="ChangeCellMime",p[p.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(p){p[p.Handle=0]="Handle",p[p.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(p){p[p.Replace=1]="Replace",p[p.Output=2]="Output",p[p.Metadata=3]="Metadata",p[p.CellLanguage=4]="CellLanguage",p[p.DocumentMetadata=5]="DocumentMetadata",p[p.Move=6]="Move",p[p.OutputItems=7]="OutputItems",p[p.PartialMetadata=8]="PartialMetadata",p[p.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var _;(function(p){p.scheme=I.Schemas.vscodeNotebookCell;const S=/^ch(\d{7,})/;function b(M,U){return M.with({scheme:p.scheme,fragment:`ch${U.toString().padStart(7,"0")}${M.scheme!==I.Schemas.file?M.scheme:""}`})}p.generate=b;function F(M){if(M.scheme!==p.scheme)return;const U=S.exec(M.fragment);return U?{handle:Number(U[1]),notebook:M.with({scheme:M.fragment.substr(U[0].length)||I.Schemas.file,fragment:null})}:void 0}p.parse=F;function N(M){if(M.scheme!==I.Schemas.vscodeNotebookCellMetadata)return;const U=S.exec(M.fragment);return U?{handle:Number(U[1]),notebook:M.with({scheme:M.fragment.substr(U[0].length)||I.Schemas.file,fragment:null})}:void 0}p.parseCellMetadataUri=N;function G(M,U,O){return M.with({scheme:O,fragment:`ch${U.toString().padStart(7,"0")}${M.scheme!==I.Schemas.file?M.scheme:""}`})}p.generateCellUri=G;function K(M,U){if(M.scheme!==U)return;const O=S.exec(M.fragment);return O?{handle:Number(O[1]),notebook:M.with({scheme:M.fragment.substr(O[0].length)||I.Schemas.file,fragment:null})}:void 0}p.parseCellUri=K})(_=e.CellUri||(e.CellUri={}));const P=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(p){return P.get(p)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function o(p){return P.get(p)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function a(p){return P.get(p)?.mergeable??!1}e.mimeTypeIsMergeable=a;function v(p,S){return R.isWindows&&(p=p.replace(/\//g,"\\"),S=S.replace(/\//g,"\\")),m.match(p,S)}function t(p,S,b){let F=0;for(let N=0;N<S.length;N++){if(v(S[N],p))return F;F++}for(let N=0;N<b.length;N++){if(v(b[N],p))return F;F++}return F}function r(p,S,b){return p.sort((F,N)=>t(F,S,b)-t(N,S,b))}e.sortMimeTypes=r;function s(p,S,b,F=(N,G)=>N===G){const N=[];function G(U,O,$){if(O===0&&$.length===0)return;const B=N[N.length-1];B&&B.start+B.deleteCount===U?(B.deleteCount+=O,B.toInsert.push(...$)):N.push({start:U,deleteCount:O,toInsert:$})}let K=0,M=0;for(;;){if(K===p.length){G(K,0,S.slice(M));break}if(M===S.length){G(K,p.length-K,[]);break}const U=p[K],O=S[M];if(F(U,O)){K+=1,M+=1;continue}b(O)?(G(K,1,[]),K+=1):(G(K,0,[O]),M+=1)}return N}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(p){p.default="default",p.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(p){const S=p;return!!((typeof S.include=="string"||m.isRelativePattern(S.include))&&(typeof S.exclude=="string"||m.isRelativePattern(S.exclude)))}e.isDocumentExcludePattern=l;function d(p,S,b){if(Array.isArray(p.viewType)&&p.viewType.indexOf(S)>=0||p.viewType===S)return!0;if(p.filenamePattern){let F=l(p.filenamePattern)?p.filenamePattern.include:p.filenamePattern,N=l(p.filenamePattern)?p.filenamePattern.exclude:void 0;if(m.match(F,(0,C.basename)(b.fsPath).toLowerCase()))return!(N&&m.match(N,(0,C.basename)(b.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class f{constructor(S){this.textModel=S}getElements(){const S=new Int32Array(this.textModel.cells.length);for(let b=0;b<this.textModel.cells.length;b++)S[b]=this.textModel.cells[b].getHashValue();return S}}e.CellSequence=f,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(S){return`${y._prefix}${S}`}static parse(S){if(S.startsWith(y._prefix))return S.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(me[212],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState",I[I.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(me[213],ge([0,1,177,4,61]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[214],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=m;function L(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=L}),define(me[128],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(T){T[T.Error=0]="Error",T[T.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var C;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(T,u)=>{u.expand!==void 0&&(T.expand=u.expand),u.item!==void 0&&(T.item=T.item?Object.assign(T.item,u.item):u.item)};e.applyTestItemUpdate=R;var k;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var D;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.Remove=2]="Remove",T[T.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",T[T.Retire=4]="Retire",T[T.AddTag=5]="AddTag",T[T.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(u){}update(u){}remove(u,h){}complete(){}}e.IncrementalChangeCollector=A;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(u){const h=this.createChangeCollector();for(const c of u)switch(c[0]){case 0:{const g=c[1];if(g.parent){if(this.items.has(g.parent)){const _=this.items.get(g.parent);_.children.add(g.item.extId);const P=this.createItem(g,_);this.items.set(g.item.extId,P),h.add(P)}}else{const _=this.createItem(g);this.roots.add(_),this.items.set(g.item.extId,_),h.add(_)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=c[1],_=this.items.get(g.extId);if(!_)break;g.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,g),h.update(_);break}case 2:{const g=this.items.get(c[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const _=[[c[1]]];for(;_.length;)for(const P of _.pop()){const E=this.items.get(P);E&&(_.push(E.children),this.items.delete(P),h.remove(E,E!==g),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(c[1]);break;case 3:this.updatePendingRoots(c[1]);break;case 5:this._tags.set(c[1].id,c[1]);break;case 6:this._tags.delete(c[1]);break}h.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=n}),define(me[90],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class I{constructor(R,k=R.length){if(this.path=R,this.viewEnd=k,R.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,k,D=R.parent){if(R.id===k)return new I([k]);let A=[R.id];for(let n=D;n&&n.id!==k;n=n.parent)A.push(n.id);return A.push(k),new I(A.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new I(R.split("\0"))}static join(R,k){return new I([...R.path,k])}static joinToString(R,k){return R.toString()+"\0"+k}static compare(R,k){return R===k?0:k.startsWith(R+"\0")?2:R.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let k=0;k<R.viewEnd&&k<this.viewEnd;k++)if(R.path[k]!==this.path[k])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=I}),define(me[215],ge([0,1,8,34,13,25,11,79,178]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(T,u,h){this._contributedVariables=new Map,this._context=T,this._labelService=u,h&&(this._envVariablesPromise=h.then(c=>this.prepareEnv(c)))}prepareEnv(T){if(R.isWindows){const u=Object.create(null);return Object.keys(T).forEach(h=>{u[h.toLowerCase()]=T[h]}),u}return T}resolveWithEnvironment(T,u,h){return this.recursiveResolve(this.prepareEnv(T),u?u.uri:void 0,h)}async resolveAsync(T,u){return this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,u)}async resolveAnyBase(T,u,h,c){const g=C.deepClone(u);return R.isWindows&&g.windows?Object.keys(g.windows).forEach(_=>g[_]=g.windows[_]):R.isMacintosh&&g.osx?Object.keys(g.osx).forEach(_=>g[_]=g.osx[_]):R.isLinux&&g.linux&&Object.keys(g.linux).forEach(_=>g[_]=g.linux[_]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,g,h,c)}async resolveAnyAsync(T,u,h){return this.resolveAnyBase(T,u,h)}async resolveAnyMap(T,u,h){const c=new Map;return{newConfig:await this.resolveAnyBase(T,u,h,c),resolvedVariables:c}}resolveWithInteractionReplace(T,u,h,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,u,h,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,u){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,u)}recursiveResolve(T,u,h,c,g){if(I.isString(h))return this.resolveString(T,u,h,c,g);if(I.isArray(h))return h.map(_=>this.recursiveResolve(T,u,_,c,g));if(I.isObject(h)){let _=Object.create(null);return Object.keys(h).forEach(P=>{const E=this.resolveString(T,u,P,c,g);_[E]=this.recursiveResolve(T,u,h[P],c,g)}),_}return h}resolveString(T,u,h,c,g){return h.replace(A.VARIABLE_REGEXP,(P,E)=>{if(E.includes(A.VARIABLE_LHS))return P;let o=this.evaluateSingleVariable(T,P,E,u,c);return g&&g.set(E,o),o!==P&&I.isString(o)&&o.match(A.VARIABLE_REGEXP)&&(o=this.resolveString(T,u,o,c,g)),o})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}evaluateSingleVariable(T,u,h,c,g){let _;const P=h.split(":");P.length>1&&(h=P[0],_=P[1]);const E=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,D.localize)(0,null,u))},o=()=>{const v=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,u,m.basename(v)))},a=()=>{if(_){const v=this._context.getFolderUri(_);if(v)return v;throw new Error((0,D.localize)(2,null,u,_))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,u)):new Error((0,D.localize)(4,null,u))};switch(h){case"env":if(_){if(T){const v=T[R.isWindows?_.toLowerCase():_];if(I.isString(v))return v}return""}throw new Error((0,D.localize)(5,null,u));case"config":if(_){const v=this._context.getConfigurationValue(c,_);if(I.isUndefinedOrNull(v))throw new Error((0,D.localize)(6,null,u,_));if(I.isObject(v))throw new Error((0,D.localize)(7,null,u,_));return v}throw new Error((0,D.localize)(8,null,u));case"command":return this.resolveFromMap(u,_,g,"command");case"input":return this.resolveFromMap(u,_,g,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(a()));case"cwd":return c||_?(0,k.normalizeDriveLetter)(this.fsPath(a())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(a()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,D.localize)(9,null,u));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,u));case"file":return E();case"fileWorkspaceFolder":return o();case"relativeFile":return c||_?m.relative(this.fsPath(a()),E()):E();case"relativeFileDirname":const r=m.dirname(E());if(c||_){const d=m.relative(this.fsPath(a()),r);return d.length===0?".":d}return r;case"fileDirname":return m.dirname(E());case"fileExtname":return m.extname(E());case"fileBasename":return m.basename(E());case"fileBasenameNoExtension":const s=m.basename(E());return s.slice(0,s.length-m.extname(s).length);case"fileDirnameBasename":return m.basename(m.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||u;case"execInstallFolder":const l=this._context.getAppRoot();return l||u;case"pathSeparator":return m.sep;default:try{const d=_?`${h}:${_}`:h;return this.resolveFromMap(u,d,g,void 0)}catch(d){return u}}}}resolveFromMap(T,u,h,c){if(u&&h){const g=c===void 0?h[u]:h[c+":"+u];if(typeof g=="string")return g;throw new Error((0,D.localize)(11,null,T))}return T}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[129],ge([0,1,4,207]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var C;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var k;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function A(g){const _=g;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=A;var n;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.GROUP_LOCKED=2]="GROUP_LOCKED",g[g.EDITOR_OPEN=3]="EDITOR_OPEN",g[g.EDITOR_CLOSE=4]="EDITOR_CLOSE",g[g.EDITOR_MOVE=5]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=7]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=9]="EDITOR_PIN",g[g.EDITOR_STICKY=10]="EDITOR_STICKY",g[g.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(T=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function h(g){const _=g;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=h;function c(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=c}),define(me[216],ge([0,1,4,129]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(C){const R=C;return typeof C=="number"||(0,L.isEditorGroup)(R)}e.isPreferredGroup=I}),define(me[15],ge([0,1,20,22,99,291,59,25,13,2,41,83,179,116,88,127,90,216,7]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ae){function Ee(q){const{selectionStartLineNumber:Te,selectionStartColumn:Pe,positionLineNumber:Ye,positionColumn:Xe}=q,at=new E.Position(Te-1,Pe-1),wt=new E.Position(Ye-1,Xe-1);return new E.Selection(at,wt)}ae.to=Ee;function ce(q){const{anchor:Te,active:Pe}=q;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ae.from=ce})(o=e.Selection||(e.Selection={}));var a;(function(ae){function Ee(q){if(!q)return;const{start:Te,end:Pe}=q;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ae.from=Ee;function ce(q){if(!q)return;const{startLineNumber:Te,startColumn:Pe,endLineNumber:Ye,endColumn:Xe}=q;return new E.Range(Te-1,Pe-1,Ye-1,Xe-1)}ae.to=ce})(a=e.Range||(e.Range={}));var v;(function(ae){function Ee(ce){switch(ce){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}ae.to=Ee})(v=e.TokenType||(e.TokenType={}));var t;(function(ae){function Ee(q){return new E.Position(q.lineNumber-1,q.column-1)}ae.to=Ee;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}ae.from=ce})(t=e.Position||(e.Position={}));var r;(function(ae){function Ee(q){switch(q){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}ae.from=Ee;function ce(q){switch(q){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}ae.to=ce})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(ae){function Ee(q){let Te;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Te=String(q.code):Te={value:String(q.code.value),target:q.code.target}),{...a.from(q.range),message:q.message,source:q.source,code:Te,severity:l.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(i.from),tags:Array.isArray(q.tags)?(0,m.coalesce)(q.tags.map(r.from)):void 0}}ae.from=Ee;function ce(q){const Te=new E.Diagnostic(a.to(q),q.message,l.to(q.severity));return Te.source=q.source,Te.code=(0,D.isString)(q.code)?q.code:q.code?.value,Te.relatedInformation=q.relatedInformation&&q.relatedInformation.map(i.to),Te.tags=q.tags&&(0,m.coalesce)(q.tags.map(r.to)),Te}ae.to=ce})(s=e.Diagnostic||(e.Diagnostic={}));var i;(function(ae){function Ee(q){return{...a.from(q.location.range),message:q.message,resource:q.location.uri}}ae.from=Ee;function ce(q){return new E.DiagnosticRelatedInformation(new E.Location(q.resource,a.to(q)),q.message)}ae.to=ce})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(ae){function Ee(q){switch(q){case E.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}ae.from=Ee;function ce(q){switch(q){case h.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}ae.to=ce})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(ae){function Ee(q){return typeof q=="number"&&q>=E.ViewColumn.One?q-1:q===E.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}ae.from=Ee;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ae.to=ce})(d=e.ViewColumn||(e.ViewColumn={}));function f(ae){return typeof ae.range!="undefined"}function w(ae){return ae.length===0?!0:!!f(ae[0])}e.isDecorationOptionsArr=w;var y;(function(ae){function Ee(Xe){return Xe.map(ae.from)}ae.fromMany=Ee;function ce(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let at;if(ce(Xe)){const{language:gt,value:ft}=Xe;at={value:"```"+gt+`
`+ft+"\n```\n"}}else E.MarkdownString.isMarkdownString(Xe)?at={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons}:typeof Xe=="string"?at={value:Xe}:at={value:""};const wt=Object.create(null);at.uris=wt;const _t=gt=>{try{let ft=A.URI.parse(gt,!0);ft=ft.with({query:Te(ft.query,wt)}),wt[gt]=ft}catch(ft){}return""},ht=new C.Renderer;return ht.link=_t,ht.image=gt=>_t(I.parseHrefAndDimensions(gt).href),C(at.value,{renderer:ht}),at}ae.from=q;function Te(Xe,at){if(!Xe)return Xe;let wt;try{wt=(0,R.parse)(Xe)}catch(ht){}if(!wt)return Xe;let _t=!1;return wt=(0,k.cloneAndChange)(wt,ht=>{if(A.URI.isUri(ht)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[gt]=ht,_t=!0,gt}else return}),_t?JSON.stringify(wt):Xe}function Pe(Xe){const at=new E.MarkdownString(Xe.value,Xe.supportThemeIcons);return at.isTrusted=Xe.isTrusted,at}ae.to=Pe;function Ye(Xe){if(!!Xe)return typeof Xe=="string"?Xe:ae.from(Xe)}ae.fromStrict=Ye})(y=e.MarkdownString||(e.MarkdownString={}));function p(ae){return w(ae)?ae.map(Ee=>({range:a.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?y.fromMany(Ee.hoverMessage):Ee.hoverMessage?y.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ae.map(Ee=>({range:a.from(Ee)}))}e.fromRangeOrRangeWithMessage=p;function S(ae){return typeof ae=="undefined"?ae:typeof ae=="string"?A.URI.file(ae):ae}e.pathOrURIToURI=S;var b;(function(ae){function Ee(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?S(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ae.from=Ee})(b=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ae){function Ee(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?S(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?b.from(ce.before):void 0,after:ce.after?b.from(ce.after):void 0}}ae.from=Ee})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var N;(function(ae){function Ee(ce){if(typeof ce=="undefined")return ce;switch(ce){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}ae.from=Ee})(N=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(ae){function Ee(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?N.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?S(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?b.from(ce.before):void 0,after:ce.after?b.from(ce.after):void 0}}ae.from=Ee})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(ae){function Ee(q){return{text:q.newText,eol:q.newEol&&te.from(q.newEol),range:a.from(q.range)}}ae.from=Ee;function ce(q){const Te=new E.TextEdit(a.to(q.range),q.text);return Te.newEol=typeof q.eol=="undefined"?void 0:te.to(q.eol),Te}ae.to=ce})(K=e.TextEdit||(e.TextEdit={}));var M;(function(ae){function Ee(q,Te,Pe){const Ye={edits:[]};if(q instanceof E.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)Ye.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const at=Te?.getDocument(Xe.uri);Ye.edits.push({_type:2,resource:Xe.uri,edit:K.from(Xe.edit),modelVersionId:at?.version,metadata:Xe.metadata})}else Xe._type===3?Ye.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ye.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Ge.from)}});return Ye}ae.from=Ee;function ce(q){const Te=new E.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Te.replace(A.URI.revive(Pe.resource),a.to(Pe.edit.range),Pe.edit.text):Te.renameFile(A.URI.revive(Pe.oldUri),A.URI.revive(Pe.newUri),Pe.options);return Te}ae.to=ce})(M=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(ae){const Ee=Object.create(null);Ee[E.SymbolKind.File]=0,Ee[E.SymbolKind.Module]=1,Ee[E.SymbolKind.Namespace]=2,Ee[E.SymbolKind.Package]=3,Ee[E.SymbolKind.Class]=4,Ee[E.SymbolKind.Method]=5,Ee[E.SymbolKind.Property]=6,Ee[E.SymbolKind.Field]=7,Ee[E.SymbolKind.Constructor]=8,Ee[E.SymbolKind.Enum]=9,Ee[E.SymbolKind.Interface]=10,Ee[E.SymbolKind.Function]=11,Ee[E.SymbolKind.Variable]=12,Ee[E.SymbolKind.Constant]=13,Ee[E.SymbolKind.String]=14,Ee[E.SymbolKind.Number]=15,Ee[E.SymbolKind.Boolean]=16,Ee[E.SymbolKind.Array]=17,Ee[E.SymbolKind.Object]=18,Ee[E.SymbolKind.Key]=19,Ee[E.SymbolKind.Null]=20,Ee[E.SymbolKind.EnumMember]=21,Ee[E.SymbolKind.Struct]=22,Ee[E.SymbolKind.Event]=23,Ee[E.SymbolKind.Operator]=24,Ee[E.SymbolKind.TypeParameter]=25;function ce(Te){return typeof Ee[Te]=="number"?Ee[Te]:6}ae.from=ce;function q(Te){for(const Pe in Ee)if(Ee[Pe]===Te)return Number(Pe);return E.SymbolKind.Property}ae.to=q})(U=e.SymbolKind||(e.SymbolKind={}));var O;(function(ae){function Ee(q){switch(q){case E.SymbolTag.Deprecated:return 1}}ae.from=Ee;function ce(q){switch(q){case 1:return E.SymbolTag.Deprecated}}ae.to=ce})(O=e.SymbolTag||(e.SymbolTag={}));var $;(function(ae){function Ee(q){return{name:q.name,kind:U.from(q.kind),tags:q.tags&&q.tags.map(O.from),containerName:q.containerName,location:X.from(q.location)}}ae.from=Ee;function ce(q){const Te=new E.SymbolInformation(q.name,U.to(q.kind),q.containerName,X.to(q.location));return Te.tags=q.tags&&q.tags.map(O.to),Te}ae.to=ce})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(ae){function Ee(q){const Te={name:q.name||"!!MISSING: name!!",detail:q.detail,range:a.from(q.range),selectionRange:a.from(q.selectionRange),kind:U.from(q.kind),tags:q.tags?.map(O.from)??[]};return q.children&&(Te.children=q.children.map(Ee)),Te}ae.from=Ee;function ce(q){const Te=new E.DocumentSymbol(q.name,q.detail,U.to(q.kind),a.to(q.range),a.to(q.selectionRange));return(0,m.isNonEmptyArray)(q.tags)&&(Te.tags=q.tags.map(O.to)),q.children&&(Te.children=q.children.map(ce)),Te}ae.to=ce})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var x;(function(ae){function Ee(q){const Te=new E.CallHierarchyItem(U.to(q.kind),q.name,q.detail||"",A.URI.revive(q.uri),a.to(q.range),a.to(q.selectionRange));return Te._sessionId=q._sessionId,Te._itemId=q._itemId,Te}ae.to=Ee;function ce(q,Te,Pe){if(Te=Te??q._sessionId,Pe=Pe??q._itemId,Te===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Pe,name:q.name,detail:q.detail,kind:U.from(q.kind),uri:q.uri,range:a.from(q.range),selectionRange:a.from(q.selectionRange),tags:q.tags?.map(O.from)}}ae.from=ce})(x=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(ae){function Ee(ce){return new E.CallHierarchyIncomingCall(x.to(ce.from),ce.fromRanges.map(q=>a.to(q)))}ae.to=Ee})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var H;(function(ae){function Ee(ce){return new E.CallHierarchyOutgoingCall(x.to(ce.to),ce.fromRanges.map(q=>a.to(q)))}ae.to=Ee})(H=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var X;(function(ae){function Ee(q){return{range:q.range&&a.from(q.range),uri:q.uri}}ae.from=Ee;function ce(q){return new E.Location(A.URI.revive(q.uri),a.to(q.range))}ae.to=ce})(X=e.location||(e.location={}));var J;(function(ae){function Ee(q){const Te=q,Pe=q;return{originSelectionRange:Te.originSelectionRange?a.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Pe.uri,range:a.from(Te.targetRange?Te.targetRange:Pe.range),targetSelectionRange:Te.targetSelectionRange?a.from(Te.targetSelectionRange):void 0}}ae.from=Ee;function ce(q){return{targetUri:A.URI.revive(q.uri),targetRange:a.to(q.range),targetSelectionRange:q.targetSelectionRange?a.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?a.to(q.originSelectionRange):void 0}}ae.to=ce})(J=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(ae){function Ee(q){return{range:a.from(q.range),contents:y.fromMany(q.contents)}}ae.from=Ee;function ce(q){return new E.Hover(q.contents.map(y.to),a.to(q.range))}ae.to=ce})(fe=e.Hover||(e.Hover={}));var _e;(function(ae){function Ee(q){return{range:a.from(q.range),expression:q.expression}}ae.from=Ee;function ce(q){return new E.EvaluatableExpression(a.to(q.range),q.expression)}ae.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(ae){function Ee(q){if(q instanceof E.InlineValueText)return{type:"text",range:a.from(q.range),text:q.text};if(q instanceof E.InlineValueVariableLookup)return{type:"variable",range:a.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ae.from=Ee;function ce(q){switch(q.type){case"text":return{range:a.to(q.range),text:q.text};case"variable":return{range:a.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:a.to(q.range),expression:q.expression}}}ae.to=ce})(Se=e.InlineValue||(e.InlineValue={}));var Le;(function(ae){function Ee(q){return{frameId:q.frameId,stoppedLocation:a.from(q.stoppedLocation)}}ae.from=Ee;function ce(q){return new E.InlineValueContext(q.frameId,a.to(q.stoppedLocation))}ae.to=ce})(Le=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(ae){function Ee(q){return{range:a.from(q.range),kind:q.kind}}ae.from=Ee;function ce(q){return new E.DocumentHighlight(a.to(q.range),q.kind)}ae.to=ce})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var Ne;(function(ae){function Ee(ce){switch(ce){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}ae.to=Ee})(Ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(ae){function Ee(ce){return{triggerKind:Ne.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ae.to=Ee})(Ke=e.CompletionContext||(e.CompletionContext={}));var z;(function(ae){function Ee(q){switch(q){case E.CompletionItemTag.Deprecated:return 1}}ae.from=Ee;function ce(q){switch(q){case 1:return E.CompletionItemTag.Deprecated}}ae.to=ce})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(ae){const Ee=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ce(Pe){return Ee.get(Pe)??9}ae.from=ce;const q=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Te(Pe){return q.get(Pe)??E.CompletionItemKind.Property}ae.to=Te})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(ae){function Ee(ce,q){const Te=new E.CompletionItem(ce.label);return Te.insertText=ce.insertText,Te.kind=ee.to(ce.kind),Te.tags=ce.tags?.map(z.to),Te.detail=ce.detail,Te.documentation=I.isMarkdownString(ce.documentation)?y.to(ce.documentation):ce.documentation,Te.sortText=ce.sortText,Te.filterText=ce.filterText,Te.preselect=ce.preselect,Te.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Te.range=a.to(ce.range):typeof ce.range=="object"&&(Te.range={inserting:a.to(ce.range.insert),replacing:a.to(ce.range.replace)}),Te.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Te.insertText=new E.SnippetString(ce.insertText):(Te.insertText=ce.insertText,Te.textEdit=Te.range instanceof E.Range?new E.TextEdit(Te.range,Te.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=ce.additionalTextEdits.map(Pe=>K.to(Pe))),Te.command=q&&ce.command?q.fromInternal(ce.command):void 0,Te}ae.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var le;(function(ae){function Ee(q){return{label:q.label,documentation:q.documentation?y.fromStrict(q.documentation):void 0}}ae.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?y.to(q.documentation):q.documentation}}ae.to=ce})(le=e.ParameterInformation||(e.ParameterInformation={}));var Y;(function(ae){function Ee(q){return{label:q.label,documentation:q.documentation?y.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(le.from):[],activeParameter:q.activeParameter}}ae.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?y.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(le.to):[],activeParameter:q.activeParameter}}ae.to=ce})(Y=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(ae){function Ee(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.from):[]}}ae.from=Ee;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.to):[]}}ae.to=ce})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(ae){function Ee(q){return{text:q.text,position:t.from(q.position),kind:Me.from(q.kind??E.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}ae.from=Ee;function ce(q){const Te=new E.InlayHint(q.text,t.to(q.position),Me.to(q.kind));return Te.whitespaceAfter=q.whitespaceAfter,Te.whitespaceBefore=q.whitespaceBefore,Te}ae.to=ce})(ve=e.InlayHint||(e.InlayHint={}));var Me;(function(ae){function Ee(q){return q}ae.from=Ee;function ce(q){return q}ae.to=ce})(Me=e.InlayHintKind||(e.InlayHintKind={}));var je;(function(ae){function Ee(q){return{range:a.from(q.range),url:q.target,tooltip:q.tooltip}}ae.from=Ee;function ce(q){let Te;if(q.url)try{Te=typeof q.url=="string"?A.URI.parse(q.url,!0):A.URI.revive(q.url)}catch(Pe){}return new E.DocumentLink(a.to(q.range),Te)}ae.to=ce})(je=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ae){function Ee(q){const Te=new E.ColorPresentation(q.label);return q.textEdit&&(Te.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Te.additionalTextEdits=q.additionalTextEdits.map(Pe=>K.to(Pe))),Te}ae.to=Ee;function ce(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Te=>K.from(Te)):void 0}}ae.from=ce})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ae){function Ee(q){return new E.Color(q[0],q[1],q[2],q[3])}ae.to=Ee;function ce(q){return[q.red,q.green,q.blue,q.alpha]}ae.from=ce})(et=e.Color||(e.Color={}));var ke;(function(ae){function Ee(q){return{range:a.from(q.range)}}ae.from=Ee;function ce(q){return new E.SelectionRange(a.to(q.range))}ae.to=ce})(ke=e.SelectionRange||(e.SelectionRange={}));var ct;(function(ae){function Ee(ce){switch(ce){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}ae.to=Ee})(ct=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(ae){function Ee(q){switch(q){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}ae.from=Ee;function ce(q){switch(q){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}ae.to=ce})(Q=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ae){function Ee(q){if(q===E.EndOfLine.CRLF)return 1;if(q===E.EndOfLine.LF)return 0}ae.from=Ee;function ce(q){if(q===1)return E.EndOfLine.CRLF;if(q===0)return E.EndOfLine.LF}ae.to=ce})(te=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ae){function Ee(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ae.from=Ee})(pe=e.ProgressLocation||(e.ProgressLocation={}));var ze;(function(ae){function Ee(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=tt.from(ce.kind)),q}ae.from=Ee})(ze=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ae){function Ee(ce){if(ce)switch(ce){case E.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}ae.from=Ee})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var st;(function(ae){function Ee(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?a.from(ce.selection):void 0,override:typeof ce.override=="boolean"?u.EditorResolution.DISABLED:void 0}}ae.from=Ee})(st=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var lt;(function(ae){function Ee(q){return q instanceof E.RelativePattern||typeof q=="string"?q:ce(q)?new E.RelativePattern(q.base,q.pattern):q}ae.from=Ee;function ce(q){const Te=q;return Te&&typeof Te.base=="string"&&typeof Te.pattern=="string"}})(lt=e.GlobPattern||(e.GlobPattern={}));var vt;(function(ae){function Ee(ce){if(ce){if(Array.isArray(ce))return ce.map(Ee);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:lt.from(q.pattern),exclusive:q.exclusive}}}else return}ae.from=Ee})(vt=e.LanguageSelector||(e.LanguageSelector={}));var Dt;(function(ae){function Ee(q){return{start:q.start,end:q.end}}ae.from=Ee;function ce(q){return new E.NotebookRange(q.start,q.end)}ae.to=ce})(Dt=e.NotebookRange||(e.NotebookRange={}));var ue;(function(ae){function Ee(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ae.to=Ee;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}ae.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(ae){function Ee(q){switch(q){case E.NotebookCellKind.Markup:return g.CellKind.Markup;case E.NotebookCellKind.Code:default:return g.CellKind.Code}}ae.from=Ee;function ce(q){switch(q){case g.CellKind.Markup:return E.NotebookCellKind.Markup;case g.CellKind.Code:default:return E.NotebookCellKind.Code}}ae.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Ue;(function(ae){function Ee(q){const Te={metadata:q.metadata??Object.create(null),cells:[]};for(let Pe of q.cells)E.NotebookCellData.validate(Pe),Te.cells.push(Ge.from(Pe));return Te}ae.from=Ee;function ce(q){const Te=new E.NotebookData(q.cells.map(Ge.to));return(0,D.isEmptyObject)(q.metadata)||(Te.metadata=q.metadata),Te}ae.to=ce})(Ue=e.NotebookData||(e.NotebookData={}));var Ge;(function(ae){function Ee(q){return{cellKind:Ie.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ue.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(ot.from):[]}}ae.from=Ee;function ce(q){return new E.NotebookCellData(Ie.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(ot.to):void 0,q.metadata,q.internalMetadata?ue.to(q.internalMetadata):void 0)}ae.to=ce})(Ge=e.NotebookCellData||(e.NotebookCellData={}));var $e;(function(ae){function Ee(q){return{mime:q.mime,valueBytes:L.VSBuffer.wrap(q.data)}}ae.from=Ee;function ce(q){return new E.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}ae.to=ce})($e=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ot;(function(ae){function Ee(q){return{outputId:q.id,items:q.items.map($e.from),metadata:q.metadata}}ae.from=Ee;function ce(q){const Te=q.items.map($e.to);return new E.NotebookCellOutput(Te,q.outputId,q.metadata)}ae.to=ce})(ot=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Re;(function(ae){function Ee(Pe){if(Pe!=null){if(Pe instanceof E.RelativePattern||typeof Pe=="string")return Pe;if(Te(Pe))return new E.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:lt.from(Pe.include)||void 0,exclude:lt.from(Pe.exclude)||void 0}}}ae.from=Ee;function ce(Pe){return typeof Pe=="string"?Pe:Te(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ae.to=ce;function q(Pe){const Ye=Pe,Xe=lt.from(Ye.include);if(!(Xe&&Xe instanceof E.RelativePattern||typeof Xe=="string"))return!1;const at=lt.from(Ye.exclude);return!!(at&&at instanceof E.RelativePattern||typeof at=="string")}function Te(Pe){const Ye=Pe;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Re=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ae){function Ee(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?b.from(ce.top):void 0}}ae.from=Ee})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ce;(function(ae){function Ee(ce,q,Te){const Pe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Te),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}ae.from=Ee})(Ce=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(ae){function Ee(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}ae.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(ae){function Ee(q){return{uri:q.uri,provides:q.provides}}ae.from=Ee;function ce(q){return new E.NotebookRendererScript(A.URI.revive(q.uri),q.provides)}ae.to=ce})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(ae){function Ee(q){return{message:y.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?X.from(q.location):void 0}}ae.from=Ee;function ce(q){const Te=new E.TestMessage(typeof q.message=="string"?q.message:y.to(q.message));return Te.actualOutput=q.actual,Te.expectedOutput=q.expected,Te}ae.to=ce})(be=e.TestMessage||(e.TestMessage={}));var we;(function(ae){let Ee;(function(ce){ce.Delimiter="\0"})(Ee||(Ee={})),ae.namespace=(ce,q)=>ce+"\0"+q,ae.denamespace=ce=>{const q=ce.indexOf("\0");return{ctrlId:ce.slice(0,q),tagId:ce.slice(q+1)}}})(we=e.TestTag||(e.TestTag={}));var Fe;(function(ae){function Ee(Pe){const Ye=(0,c.getPrivateApiFor)(Pe).controllerId;return{extId:_.TestId.fromExtHostTestItem(Pe,Ye).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Xe=>we.namespace(Ye,Xe.id)),range:a.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&y.fromStrict(Pe.error)||null}}ae.from=Ee;function ce(Pe){return{id:_.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:A.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ye=>{const{tagId:Xe}=we.denamespace(Ye);return new E.TestTag(Xe,Xe)}),range:a.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}ae.toPlain=ce;function q(Pe){const Ye=_.TestId.fromString(Pe.extId),Xe=new c.TestItemImpl(Ye.controllerId,Ye.localId,Pe.label,A.URI.revive(Pe.uri));return Xe.range=a.to(Pe.range||void 0),Xe.description=Pe.description||void 0,Xe}function Te(Pe){let Ye;for(const Xe of Pe.tests){const at=q(Xe.item);(0,c.getPrivateApiFor)(at).parent=Ye,Ye=at}return Ye}ae.toItemFromContext=Te})(Fe=e.TestItem||(e.TestItem={})),function(ae){function Ee(q){return{id:q.id,label:q.label}}ae.from=Ee;function ce(q){return new E.TestTag(q.id,q.label)}ae.to=ce}(we=e.TestTag||(e.TestTag={}));var qe;(function(ae){const Ee=(q,Te)=>{const Pe={...Fe.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:q.children.map(Ye=>Te.get(Ye)).filter(D.isDefined).map(Ye=>Ee(Ye,Te))};for(const Ye of Pe.children)Ye.parent=Pe;return Pe};function ce(q){const Te=[],Pe=new Map;for(const Ye of q.items)Pe.set(Ye.item.extId,Ye),q.request.targets.some(Xe=>Xe.controllerId===Ye.controllerId&&Xe.testIds.includes(Ye.item.extId))&&Te.push(Ye);return{completedAt:q.completedAt,results:Te.map(Ye=>Ee(Ye,Pe))}}ae.to=ce})(qe=e.TestResults||(e.TestResults={}));var He;(function(ae){function Ee(Pe){return{covered:Pe.covered,total:Pe.covered}}function ce(Pe){return"line"in Pe?t.from(Pe):a.from(Pe)}function q(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ce(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&ce(Ye.location)})):void 0}:{type:0,count:Pe.executionCount,location:ce(Pe.location)}}ae.fromDetailed=q;function Te(Pe){return{uri:Pe.uri,statement:Ee(Pe.statementCoverage),branch:Pe.branchCoverage&&Ee(Pe.branchCoverage),function:Pe.functionCoverage&&Ee(Pe.functionCoverage),details:Pe.detailedCoverage?.map(q)}}ae.fromFile=Te})(He=e.TestCoverage||(e.TestCoverage={}));var Je;(function(ae){function Ee(ce){switch(ce){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}ae.to=Ee})(Je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var nt;(function(ae){function Ee(q){const Te=new E.TypeHierarchyItem(U.to(q.kind),q.name,q.detail||"",A.URI.revive(q.uri),a.to(q.range),a.to(q.selectionRange));return Te._sessionId=q._sessionId,Te._itemId=q._itemId,Te}ae.to=Ee;function ce(q,Te,Pe){if(Te=Te??q._sessionId,Pe=Pe??q._itemId,Te===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Pe,kind:U.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:a.from(q.range),selectionRange:a.from(q.selectionRange),tags:q.tags?.map(O.from)}}ae.from=ce})(nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[217],ge([0,1,2,16,7,15,95]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(A,n,T,u={timeout:1500,errors:3}){this._logService=A,this._documents=n,this._mainThreadBulkEdits=T,this._thresholds=u,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(n,T,u)=>{const c={dispose:this._callbacks.push([n,T,A])};return Array.isArray(u)&&u.push(c),c}}async $participateInSave(A,n){const T=m.URI.revive(A);let u=!1;const h=setTimeout(()=>u=!0,this._thresholds.timeout),c=[];try{for(let g of[...this._callbacks]){if(u)break;const _=this._documents.getDocument(T),P=await this._deliverEventAsyncAndBlameBadListeners(g,{document:_,reason:C.TextDocumentSaveReason.to(n)});c.push(P)}}finally{clearTimeout(h)}return c}_deliverEventAsyncAndBlameBadListeners([A,n,T],u){const h=this._badListeners.get(A);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(T,A,n,u).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const g=this._badListeners.get(A);this._badListeners.set(A,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,n,T,u){const h=[],c=Date.now(),{document:g,reason:_}=u,{version:P}=g,E=Object.freeze({document:g,reason:_,waitUntil(o){if(Object.isFrozen(h))throw(0,L.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(o))}});try{n.apply(T,[E])}catch(o){return Promise.reject(o)}return Object.freeze(h),new Promise((o,a)=>{const v=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(v),o(t)}).catch(t=>{clearTimeout(v),a(t)})}).then(o=>{const a={edits:[]};for(const v of o)if(Array.isArray(v)&&v.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:r,range:s}of v)a.edits.push({_type:2,resource:g.uri,edit:{range:s&&C.Range.from(s),text:t,eol:r&&C.EndOfLine.from(r)}});if(a.edits.length!==0)return P===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(me[218],ge([0,1,3,30,2,15,7]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(n,T,u,h,c){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,u&&(this._config+=1),h&&(this._config+=2),c&&(this._config+=4);const g=(0,L.parse)(T),_=n(P=>{if(!u)for(let E of P.created){const o=I.URI.revive(E);g(o.fsPath)&&this._onDidCreate.fire(o)}if(!h)for(let E of P.changed){const o=I.URI.revive(E);g(o.fsPath)&&this._onDidChange.fire(o)}if(!c)for(let E of P.deleted){const o=I.URI.revive(E);g(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(n,T,u){this._logService=T,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,T,u,h){return new k(this._onFileSystemEvent.event,n,T,u,h)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,T){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(u=>({oldUri:I.URI.revive(u.source),newUri:I.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(u=>I.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:T.map(u=>I.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,T){return(u,h,c)=>{const g=function(P){u.call(h,P)};return g.extension=n,T.event(g,void 0,c)}}async $onWillRunFileOperation(n,T,u,h){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(c=>({oldUri:I.URI.revive(c.source),newUri:I.URI.revive(c.target)}))},u,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(c=>I.URI.revive(c.target))},u,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(c=>I.URI.revive(c.target))},u,h)}}async _fireWillEvent(n,T,u,h){const c=new Set,g=[];if(await n.fireAsync(T,h,async(P,E)=>{const o=Date.now(),a=await Promise.resolve(P);a instanceof R.WorkspaceEdit&&(g.push(a),c.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-o>u&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),h.isCancellationRequested||g.length===0)return;const _={edits:[]};for(let P of g){let{edits:E}=C.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(E)}return{edit:_,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=D}),define(me[219],ge([0,1,10,25,2,15,7,127]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(u,h,c,g){this.start=u,this.deletedCount=h,this.deletedItems=c,this.items=g}static asApiEvents(u){return u.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(c=>c.apiCell)}))}}class A{constructor(u,h,c){this.notebook=u,this._extHostDocument=h,this._cellData=c,this.handle=c.handle,this.uri=I.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=c.internalMetadata??{},this._metadata=Object.freeze(c.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c.internalMetadata??{}))}static asModelAddData(u,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return u._mime},set mime(c){u._mime=c},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(C.NotebookCellOutput.to)}setOutputItems(u,h,c){const g=c.map(C.NotebookCellOutputItem.to),_=this._outputs.find(P=>P.id===u);_&&(h||(_.items.length=0),_.items.push(...g))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=A;class n{constructor(u,h,c,g,_,P){this._proxy=u,this._textDocumentsAndEditors=h,this._textDocuments=c,this._emitter=g,this.uri=_,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===m.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(h){return h=u._validateIndex(h),u._cells[h].apiCell},getCells(h){return(h?u._getCells(h):u._cells).map(g=>g.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,h){this._versionId=u.versionId,this._isDirty=h;for(const c of u.rawEvents)c.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===k.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let h=u.start|0,c=u.end|0;return h<0&&(h=0),c>this._cells.length&&(c=this._cells.length),u.with({start:h,end:c})}_getCells(u){u=this._validateRange(u);const h=[];for(let c=u.start;c<u.end;c++)h.push(this._cells[c]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,h){if(this._disposed)return;const c=[],g=[],_=[];u.reverse().forEach(P=>{const o=P[2].map(t=>{const r=new A(this,this._textDocumentsAndEditors,t);return h||g.push(A.asModelAddData(this.apiNotebook,t)),r}),a=new D(P[0],P[1],[],o),v=this._cells.splice(P[0],P[1],...o);for(const t of v)_.push(t.uri),a.deletedItems.push(t.apiCell);c.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:_}),h||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(c)}))}_moveCell(u,h){const c=this._cells.splice(u,1);this._cells.splice(h,0,...c);const g=[new D(u,1,c.map(_=>_.apiCell),[]),new D(h,0,[],c)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(g)}))}_setCellOutputs(u,h){const c=this._cells[u];c.setOutputs(h),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(u,h,c,g){const _=this._cells[u];_.setOutputItems(h,c,g),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(u,h){const c=this._cells[u];c.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(c.uri,h)}_changeCellMime(u,h){const c=this._cells[u];c.apiCell.mime=h}_changeCellMetadata(u,h){const c=this._cells[u],g=c.apiCell.metadata;c.setMetadata(h);const _=c.apiCell.metadata;(0,L.equals)(g,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(u,h){const c=this._cells[u],g=c.internalMetadata;if(c.setInternalMetadata(h),g.runState!==h.runState){const _=h.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:c.apiCell,state:_}))}}getCellFromApiCell(u){return this._cells.find(h=>h.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(h=>h.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[130],ge([0,1,7,15,16]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:A})}replaceCells(D,A,n){this._throwIfFinalized(),!(D===A&&n.length===0)&&this._collectedEdits.push({editType:1,index:D,count:A-D,cells:n.map(L.NotebookCellData.from)})}}class R{constructor(D,A,n,T,u,h){this.id=D,this._proxy=A,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=T,this._viewColumn=h}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(A){if(!Array.isArray(A)||!A.every(m.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");D._selections=A,D._trySetSelections(A)},get visibleRanges(){return D._visibleRanges},revealRange(A,n){D._proxy.$tryRevealRange(D.id,L.NotebookRange.from(A),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(A){const n=new C(this.document.version);return A(n),D._applyEdit(n.finalize())},setDecorations(A,n){return D.setDecorations(A,n)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(L.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const A=[];let n=-1;for(let T=0;T<D.cellEdits.length;T++){if(n<0){A.push(D.cellEdits[T]),n++;continue}const h=A[n],c=D.cellEdits[T];if(h.editType===1&&c.editType===1&&h.index===c.index){h.cells.push(...D.cellEdits[T].cells),h.count+=D.cellEdits[T].count;continue}A.push(D.cellEdits[T]),n++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,A)}setDecorations(D,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return A.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(A),D.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(me[220],ge([0,1,15,119,166,21,56]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(T){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=T}withProgress(T,u,h){const c=this._handles++,{title:g,location:_,cancellable:P}=u,E={label:(0,I.localize)(0,null,T.displayName||T.name),id:T.identifier.value};return this._proxy.$startProgress(c,{location:m.ProgressLocation.from(_),title:g,source:E,cancellable:P},T),this._withProgress(c,h,!!P)}_withProgress(T,u,h){let c;h&&(c=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(T,c));const g=P=>{this._proxy.$progressEnd(P),this._mapHandleToCancellationSource.delete(P),c&&c.dispose()};let _;try{_=u(new A(this._proxy,T),h&&c?c.token:C.CancellationToken.None)}catch(P){throw g(T),P}return _.then(P=>g(T),P=>g(T)),_}$acceptProgressCanceled(T){const u=this._mapHandleToCancellationSource.get(T);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(T))}}e.ExtHostProgress=k;function D(n,T){return n.message=T.message,typeof T.increment=="number"&&(typeof n.increment=="number"?n.increment+=T.increment:n.increment=T.increment),n}class A extends L.Progress{constructor(T,u){super(h=>this.throttledReport(h));this._proxy=T,this._handle=u}throttledReport(T){this._proxy.$progressReport(this._handle,T)}}Ve([(0,R.throttle)(100,(n,T)=>D(n,T),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(me[131],ge([0,1,54,16,75,15,7]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(u,h,c){const g=k._Keys.nextId();u.$registerTextEditorDecorationType(h.identifier,g,C.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:g,dispose(){u.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class D{constructor(u,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,h){this._throwIfFinalized();let c=null;if(u instanceof R.Position)c=new R.Range(u,u);else if(u instanceof R.Range)c=u;else throw new Error("Unrecognized location");this._pushEdit(c,h,!1)}insert(u,h){this._throwIfFinalized(),this._pushEdit(new R.Range(u,u),h,!0)}delete(u){this._throwIfFinalized();let h=null;if(u instanceof R.Range)h=u;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(u,h,c){const g=this._document.validateRange(u);this._collectedEdits.push({range:g,text:h,forceMoveMarkers:c})}setEndOfLine(u){if(this._throwIfFinalized(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=D;class A{constructor(u,h,c,g){this._proxy=u,this._id=h,this._accept(c),this._logService=g;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(P){_._setTabSize(P)},get insertSpaces(){return _._insertSpaces},set insertSpaces(P){_._setInsertSpaces(P)},get cursorStyle(){return _._cursorStyle},set cursorStyle(P){_._setCursorStyle(P)},get lineNumbers(){return _._lineNumbers},set lineNumbers(P){_._setLineNumbers(P)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const h=Math.floor(u);return h>0?h:null}if(typeof u=="string"){const h=parseInt(u,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(u){const h=this._validateTabSize(u);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const h=this._validateInsertSpaces(u);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(u)})))}assign(u){const h={};let c=!1;if(typeof u.tabSize!="undefined"){const g=this._validateTabSize(u.tabSize);g==="auto"?(c=!0,h.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,c=!0,h.tabSize=g)}if(typeof u.insertSpaces!="undefined"){const g=this._validateInsertSpaces(u.insertSpaces);g==="auto"?(c=!0,h.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,c=!0,h.insertSpaces=g)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,c=!0,h.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,c=!0,h.lineNumbers=C.TextEditorLineNumbersStyle.from(u.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(u){u.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=A;class n{constructor(u,h,c,g,_,P,E,o){this.id=u,this._proxy=h,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new A(this._proxy,this.id,P,c),this._visibleRanges=E,this._viewColumn=o;const a=this;this.value=Object.freeze({get document(){return g.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(v){if(!(v instanceof R.Selection))throw(0,L.illegalArgument)("selection");a._selections=[v],a._trySetSelection()},get selections(){return a._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof R.Selection)))throw(0,L.illegalArgument)("selections");a._selections=v,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return a._options.value},set options(v){a._disposed||a._options.assign(v)},get viewColumn(){return a._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(g.getValue(),t);return v(r),a._applyEdit(r)},insertSnippet(v,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=a._selections.map(i=>C.Range.from(i));else if(t instanceof R.Position){const{lineNumber:i,column:l}=C.Position.from(t);s=[{startLineNumber:i,startColumn:l,endLineNumber:i,endColumn:l}]}else if(t instanceof R.Range)s=[C.Range.from(t)];else{s=[];for(const i of t)if(i instanceof R.Range)s.push(C.Range.from(i));else{const{lineNumber:l,column:d}=C.Position.from(i);s.push({startLineNumber:l,startColumn:d,endLineNumber:l,endColumn:d})}}return h.$tryInsertSnippet(u,v.value,s,r)},setDecorations(v,t){const r=t.length===0;r&&!a._hasDecorationsForKey.has(v.key)||(r?a._hasDecorationsForKey.delete(v.key):a._hasDecorationsForKey.add(v.key),a._runOnProxy(()=>{if(C.isDecorationOptionsArr(t))return h.$trySetDecorations(u,v.key,C.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,l=t.length;i<l;i++){const d=t[i];s[4*i]=d.start.line+1,s[4*i+1]=d.start.character+1,s[4*i+2]=d.end.line+1,s[4*i+3]=d.end.character+1}return h.$trySetDecorationsFast(u,v.key,s)}}))},revealRange(v,t){a._runOnProxy(()=>h.$tryRevealRange(u,C.Range.from(v),t||R.TextEditorRevealType.Default))},show(v){h.$tryShowEditor(u,C.ViewColumn.from(v))},hide(){h.$tryHideEditor(u)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,m.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,m.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,m.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,m.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const h=u.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const c=h.edits.map(_=>_.range);c.sort((_,P)=>_.end.line===P.end.line?_.end.character===P.end.character?_.start.line===P.start.line?_.start.character-P.start.character:_.start.line-P.start.line:_.end.character-P.end.character:_.end.line-P.end.line);for(let _=0,P=c.length-1;_<P;_++){const E=c[_].end;if(c[_+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=h.edits.map(_=>({range:C.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,g,{setEndOfLine:typeof h.setEndOfLine=="number"?C.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(me[221],ge([0,1,169,24,2,3,6,208,17,7,13,20,15,21,205]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(E,o){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let a;return Array.isArray(E.highlights)&&(a=E.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),a=a.length?a:void 0),{label:E.label,highlights:a}}}class _{constructor(o,a,v){this._proxy=o,this.commands=a,this.logService=v,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}a.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(o,a,v){const t=this.createTreeView(o,{treeDataProvider:a},v);return{dispose:()=>t.dispose()}}createTreeView(o,a,v){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=a.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(o,a,v);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,l)=>s.reveal(i,l),dispose:async()=>{await r,this.treeViews.delete(o),s.dispose()}}}$getChildren(o,a){const v=this.treeViews.get(o);return v?v.getChildren(a):Promise.reject(new Error((0,m.localize)(0,null,o)))}async $onDrop(o,a,v){const t=this.treeViews.get(o);if(!t)return Promise.reject(new Error((0,m.localize)(1,null,o)));const r=c.TreeDataTransferConverter.toITreeDataTransfer(a);if(r.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(l=>t.getExtensionElement(l)).filter(l=>!!l);i.length>0?r.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,v)}async $hasResolve(o){const a=this.treeViews.get(o);if(!a)throw new Error((0,m.localize)(2,null,o));return a.hasResolve}$resolve(o,a,v){const t=this.treeViews.get(o);if(!t)throw new Error((0,m.localize)(3,null,o));return t.resolveTreeItem(a,v)}$setExpanded(o,a,v){const t=this.treeViews.get(o);if(!t)throw new Error((0,m.localize)(4,null,o));t.setExpanded(a,v)}$setSelection(o,a){const v=this.treeViews.get(o);if(!v)throw new Error((0,m.localize)(5,null,o));v.setSelection(a)}$setVisible(o,a){const v=this.treeViews.get(o);if(!v)throw new Error((0,m.localize)(6,null,o));v.setVisible(a)}createExtHostTreeView(o,a,v){const t=new P(o,a,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(o,t),t}convertArgument(o){const a=this.treeViews.get(o.$treeViewId);return a?a.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=_;class P extends R.Disposable{constructor(o,a,v,t,r,s){super();if(this.viewId=o,this.proxy=v,this.commands=t,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,s.contributes&&s.contributes.views)for(const d in s.contributes.views)for(const f of s.contributes.views[d])f.id===o&&(this._title=f.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(d=>this._onDidChangeData.fire({message:!1,element:d}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(d=>this._onDidChangeData.fire({message:!1,element:d})));let i,l;this._register(C.Event.debounce(this._onDidChangeData.event,(d,f)=>(d||(d={message:!1,elements:[]}),f.element!==!1&&(i||(i=new Promise(w=>l=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(f.element)?d.elements.push(...f.element):d.elements.push(f.element)),f.message&&(d.message=!0),d),200,!0)(({message:d,elements:f})=>{f.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=l;return i=null,this.refresh(f).then(()=>w())})),d&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,n.isUndefinedOrNull)(o))}async getChildren(o){const a=o?this.getExtensionElement(o):void 0;if(o&&!a)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(o);return v||(v=await this.fetchChildrenNodes(a)),v?v.map(t=>t.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,a){a=a||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(a.select)?!0:a.select,t=(0,n.isUndefinedOrNull)(a.focus)?!1:a.focus,r=(0,n.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(s=>this.resolveTreeNode(o,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(l=>l.item)},{select:v,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:r})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,a){const v=this.getExtensionElement(o);v&&(a?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(o){(0,T.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,a){const v=this.getExtensionElement(a);if(!!v)return(0,D.asPromise)(()=>this.dndController?.onDrop(o,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,a){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(o);if(v){const t=this.nodes.get(v);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,v,a)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(a=>a?this.resolveUnknownParentChain(a).then(v=>this.resolveTreeNode(a,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(o){const a=this.nodes.get(o);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,a){const v=this.nodes.get(o);return v?Promise.resolve(v):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>this.createHandle(o,t,a,!0)).then(t=>this.getChildren(a?a.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(o){if(o){let a;if(typeof o=="string"){const v=this.getExtensionElement(o);a=v?this.nodes.get(v):void 0}else a=o;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const a=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=o?this.nodes.get(o):void 0,t=await this.dataProvider.getChildren(o);if(a.token.isCancellationRequested)return;const r=await Promise.all((0,T.coalesce)(t||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,v):null}));return a.token.isCancellationRequested?void 0:(0,T.coalesce)(r)}finally{a.dispose()}}refresh(o){if(o.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(o);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const a=new Set,v=o.map(r=>this.nodes.get(r));for(const r of v)if(r&&!a.has(r.item.handle)){let s=r;for(;s&&s.parent&&v.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&a.add(r.item.handle)}const t=[];return a.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!a.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(o){const a={};return Promise.all(o.map(v=>this.refreshNode(v).then(t=>{t&&(a[v]=t.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(o){const a=this.getExtensionElement(o);if(a){const v=this.nodes.get(a);if(v)return this.clearChildren(a),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>{if(t){const r=this.createTreeNode(a,t,v.parent);return this.updateNodeCache(a,r,v,v.parent),v.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,a,v){const t=this.createTreeNode(o,a,v);if(a.id&&this.elements.has(t.item.handle))throw new Error((0,m.localize)(7,null,a.id));return this.addNodeToCache(o,t),this.addNodeToParentCache(t,v),t}getTooltip(o){return A.MarkdownString.isMarkdownString(o)?u.MarkdownString.from(o):o}getCommand(o,a){return a?this.commands.toInternal(a,o):void 0}createTreeNode(o,a,v){const t=new R.DisposableStore,r=this.createHandle(o,a,v),s=this.getLightIconPath(a);return{item:{handle:r,parentHandle:v?v.item.handle:void 0,label:g(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(t,a.command),contextValue:a.contextValue,icon:s,iconDark:this.getDarkIconPath(a)||s,themeIcon:this.getThemeIcon(a),collapsibleState:(0,n.isUndefinedOrNull)(a.collapsibleState)?A.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation},extensionItem:a,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(o){return o.iconPath instanceof A.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:a,label:v,resourceUri:t},r,s){if(a)return`${P.ID_HANDLE_PREFIX}/${a}`;const i=g(v,this.extension),l=r?r.item.handle:P.LABEL_HANDLE_PREFIX;let d=i?i.label:t?(0,L.basename)(t):"";d=d.indexOf("/")!==-1?d.replace("/","//"):d;const f=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,w=this.getChildrenNodes(r)||[];let y,p=0;do{if(y=`${l}/${p}:${d}`,s||!this.elements.has(y)||f===y)break;p++}while(p<=w.length);return y}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof A.ThemeIcon))return typeof o.iconPath=="string"||I.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof A.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return I.URI.isUri(o)?o:I.URI.file(o)}addNodeToCache(o,a){this.elements.set(a.item.handle,o),this.nodes.set(o,a)}updateNodeCache(o,a,v,t){this.elements.delete(a.item.handle),this.nodes.delete(o),a.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(o,a);const r=this.getChildrenNodes(t)||[],s=r.filter(i=>i.item.handle===v.item.handle)[0];s&&r.splice(r.indexOf(s),1,a)}addNodeToParentCache(o,a){a?(a.children||(a.children=[]),a.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const a=this.nodes.get(o);if(a){if(a.children)for(const v of a.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}a.children=void 0}}else this.clearAll()}clear(o){const a=this.nodes.get(o);if(a){if(a.children)for(const v of a.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(o),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(me[222],ge([0,1,17,3,6,13,88,15,128,90]),function(Z,e,m,L,I,C,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends I.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const h=this.diff[this.diff.length-1];if(h&&u[0]===1){if(h[0]===1&&h[1].extId===u[1].extId){(0,D.applyTestItemUpdate)(h[1],u[1]);return}if(h[0]===0&&h[1].item.extId===u[1].extId){(0,D.applyTestItemUpdate)(h[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,h){const c=this.tree.get(u);if(!!c){if((c.expandLevels===void 0||h>c.expandLevels)&&(c.expandLevels=h),c.expand===1){const g=this.resolveChildren(c);return g.isOpen()?this.expandChildren(c,h-1):g.wait().then(()=>this.expandChildren(c,h-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,h-1)):this.expandChildren(c,h-1)}}dispose(){for(const u of this.tree.values())(0,R.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,h){switch(h.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(u.fullId,h.id));break;case 0:this.upsertItem(h.item,u);break;case 4:for(const E of h.ops)this.onTestItemEvent(u,E);break;case 3:const{key:c,value:g,previous:_}=h,P=u.fullId.toString();switch(c){case"canResolveChildren":this.updateExpandability(u);break;case"tags":this.diffTagRefs(g,_,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:k.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:k.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[c]:g??null}}]);break}break;default:(0,C.assertNever)(h)}}upsertItem(u,h){if(!(u instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const c=A.TestId.fromExtHostTestItem(u,this.root.id,h?.actual),g=(0,R.getPrivateApiFor)(u);g.parent&&g.parent!==h?.actual&&g.parent.children.delete(u.id);let _=this.tree.get(c.toString());if(!_){_={fullId:c,actual:u,parent:h?c.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},u.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(u,h),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:k.TestItem.from(u)}]),this.connectItemAndChildren(u,_,h);return}if(_.actual===u){this.connectItem(u,_,h);return}const P=_.actual.children,E=_.actual,o=(0,R.diffTestItems)(E,u);(0,R.getPrivateApiFor)(E).listener=void 0,_.actual=u,_.expand=0;for(const[a,v]of o)this.onTestItemEvent(_,{op:3,key:a,value:v,previous:E[a]});this.connectItemAndChildren(u,_,h);for(const a of P)u.children.get(a.id)||this.removeItem(A.TestId.joinToString(c,a.id))}diffTagRefs(u,h,c){const g=new Set(h.map(_=>_.id));for(const _ of u)g.delete(_.id)||this.incrementTagRefs(_);this.pushDiff([1,{extId:c,item:{tags:u.map(_=>k.TestTag.namespace(this.controllerId,_.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(u){const h=this.tags.get(u.id);h?h.refCount++:(this.tags.set(u.id,{label:u.label,refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,u.id),ctrlLabel:this.root.label,label:u.label}]))}decrementTagRefs(u){const h=this.tags.get(u);h&&!--h.refCount&&(this.tags.delete(u),this.pushDiff([6,k.TestTag.namespace(this.controllerId,u)]))}setItemParent(u,h){(0,R.getPrivateApiFor)(u).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(u,h,c){this.setItemParent(u,c);const g=(0,R.getPrivateApiFor)(u);g.parent=c?.actual,g.listener=_=>this.onTestItemEvent(h,_),this.updateExpandability(h)}connectItemAndChildren(u,h,c){this.connectItem(u,h,c);for(const g of u.children)this.upsertItem(g,h)}updateExpandability(u){let h;this._resolveHandler?u.resolveBarrier?h=u.resolveBarrier.isOpen()?3:2:h=u.actual.canResolveChildren?1:0:h=0,h!==u.expand&&(u.expand=h,this.pushDiff([1,{extId:u.fullId.toString(),expand:h}]),h===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,h){if(h<0)return;const c=[];for(const g of u.actual.children){const _=this.expand(A.TestId.joinToString(u.fullId,g.id),h);(0,m.isThenable)(_)&&c.push(_)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const _=new m.Barrier;return _.open(),_}u.expand=2,this.pushExpandStateUpdate(u);const h=u.resolveBarrier=new m.Barrier,c=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),u.actual!==this.root&&(u.actual.error=_.stack||_.message||String(_))};let g;try{g=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(_){c(_)}return(0,m.isThenable)(g)?g.catch(c).then(()=>{h.open(),this.updateExpandability(u)}):(h.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const h=this.tree.get(u);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const c=[h];for(;c.length;){const g=c.pop();if(!!g){(0,R.getPrivateApiFor)(g.actual).listener=void 0;for(const _ of g.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(g.fullId.toString());for(const _ of g.actual.children)c.push(this.tree.get(A.TestId.joinToString(g.fullId,_.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=n}),define(me[223],ge([0,1,4,184]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(me[224],ge([0,1,26,3,8]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=C;class R{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let T of n.activationEvents)T==="onUri"&&(T=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(T)||this._activationMap.set(T,[]),this._activationMap.get(T).push(n)}}keepOnly(n){const T=new Set;n.forEach(u=>T.add(m.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>T.has(m.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,T){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const u=R._findLoopingExtensions(this._extensionDescriptions);if(T=T.concat(u.map(h=>h.identifier)),T.length>0){const h=new Set;T.forEach(c=>h.add(m.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!h.has(m.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(u)}static _findLoopingExtensions(n){const T=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,P){this.addNode(_),this.addNode(P),this._arcs.has(_)?this._arcs.get(_).push(P):this._arcs.set(_,[P])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,P){const E=T.getArcs(_);for(let o=0;o<E.length;o++)if(!P.has(E[o]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let _ of n){const P=m.ExtensionIdentifier.toKey(_.identifier);if(u.set(P,_),_.extensionDependencies)for(let E of _.extensionDependencies){const o=m.ExtensionIdentifier.toKey(E);T.addArc(P,o)}}let h=new Set;T.getNodes().filter(_=>T.getArcs(_).length===0).forEach(_=>h.add(_));let c=T.getNodes().filter(_=>!h.has(_)),g;do{g=!1;for(let _=0;_<c.length;_++){const P=c[_];T.hasOnlyGoodArcs(P,h)&&(c.splice(_,1),_--,h.add(P),g=!0)}}while(g);return c.map(_=>u.get(_))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const T=this._activationMap.get(n);return T?T.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const T=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return T||void 0}}e.ExtensionDescriptionRegistry=R;var k;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(k||(k={}));function D(A,n){const T=A.isBuiltin?0:A.isUnderDevelopment?2:1,u=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(T!==u)return T-u;const h=I.posix.basename(A.extensionLocation.path),c=I.posix.basename(n.extensionLocation.path);return h<c?-1:h>c?1:0}}),define(me[225],ge([0,1,22]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function C(k){const D=m.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=C;function R(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=R}),define(me[36],ge([0,1,3,2,4,26,186]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(E){E[E.None=0]="None",E[E.LocalProcess=1]="LocalProcess",E[E.LocalWebWorker=2]="LocalWebWorker",E[E.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class D{constructor(o){this.dependency=o}}e.MissingExtensionDependency=D;var A;(function(E){E[E.LocalProcess=0]="LocalProcess",E[E.LocalWebWorker=1]="LocalWebWorker",E[E.Remote=2]="Remote"})(A=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(o,a,v,t){this.codeLoadingTime=o,this.activateCallTime=a,this.activateResolvedTime=v,this.activationReason=t}}e.ActivationTimes=n;class T{constructor(o,a){this.description=o,this.value=a}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var u;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(u=e.ActivationKind||(e.ActivationKind={}));function h(E){E.enableProposedApi||c(E)}e.checkProposedApiEnabled=h;function c(E){throw new Error(`[${E.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.throwProposedApiError=c;function g(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation}}e.toExtension=g;function _(E,o){return{identifier:new C.ExtensionIdentifier(E.identifier.id),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!o,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid}}e.toExtensionDescription=_;class P{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(o){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(o){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(o,a){return Promise.resolve()}_onWillActivateExtension(o){}_onDidActivateExtension(o,a,v,t,r){}_onDidActivateExtensionError(o,a){}_onExtensionRuntimeError(o,a){}_onExtensionHostExit(o){}}e.NullExtensionService=P}),define(me[226],ge([0,1,26,36,12]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class R{constructor(c,g,_,P){this.startup=c,this.codeLoadingTime=g,this.activateCallTime=_,this.activateResolvedTime=P}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class k{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,g){return c===-1||g===-1?-1:g-c}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class D{constructor(c,g,_,P,E,o){this.activationFailed=c,this.activationFailedError=g,this.activationTimes=_,this.module=P,this.exports=E,this.subscriptions=o}}e.ActivatedExtension=D;class A extends D{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class n extends D{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class T extends D{constructor(c){super(!0,c,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=T;let u=class{constructor(c,g,_,P,E){this._logService=E,this._registry=c,this._resolvedExtensionsSet=new Set,g.forEach(o=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,_.forEach(o=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(o),o)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const g=m.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(g)}getActivatedExtension(c){const g=m.ExtensionIdentifier.toKey(c),_=this._activatedExtensions.get(g);if(!_)throw new Error("Extension `"+c.value+"` is not known or not activated");return _}activateByEvent(c,g){if(this._alreadyActivatedEvents[c])return C;const _=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(_.map(P=>({id:P.identifier,reason:{startup:g,extensionId:P.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,g){const _=this._registry.getExtensionDescription(c);if(!_)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:_.identifier,reason:g}])}_handleActivateRequest(c,g,_){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(c.id))){g[m.ExtensionIdentifier.toKey(c.id)]=c;return}const P=this._registry.getExtensionDescription(c.id);if(!P){const a=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,a,new L.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(c.id),new T(a));return}const E=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let o=!0;for(let a=0,v=E.length;a<v;a++){const t=E[a];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const d=P.displayName||P.identifier.value,f=this._registry.getExtensionDescription(t),w=f&&f.displayName||t,y=new Error(`Cannot activate the '${d}' extension because its dependency '${w}' failed to activate`);y.detail=r.activationFailedError,this._host.onExtensionActivationError(P.identifier,y,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(P.identifier),new T(y));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){o=!1,g[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){o=!1,g[m.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const i=P.displayName||P.identifier.value,l=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(P.identifier,l,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(P.identifier),new T(l));return}o?g[m.ExtensionIdentifier.toKey(P.identifier)]=c:_.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(E=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(E.id))),c.length===0))return Promise.resolve(void 0);const g=Object.create(null),_=[];for(let E=0,o=c.length;E<o;E++)this._handleActivateRequest(c[E],g,_);for(let E=0,o=_.length;E<o;E++){const a=m.ExtensionIdentifier.toKey(_[E].id);g[a]&&delete g[a]}const P=Object.keys(g).map(E=>g[E]);return _.length===0?Promise.all(P.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(P).then(E=>this._activateExtensions(_))}_activateExtension(c,g){const _=m.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const P=this._activatingExtensions.get(_);if(P)return P;const E=this._host.actualActivateExtension(c,g).then(void 0,o=>{const a=new Error;return o&&o.name&&(a.name=o.name),o&&o.message?a.message=`Activating extension '${c.value}' failed: ${o.message}.`:a.message=`Activating extension '${c.value}' failed: ${o}.`,o&&o.stack&&(a.stack=o.stack),this._host.onExtensionActivationError(c,a,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(o),new T(o)}).then(o=>{this._activatedExtensions.set(_,o),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,E),E}};u=Ve([xe(4,I.ILogService)],u),e.ExtensionsActivator=u}),define(me[227],ge([0,1,12,36,27,10,115]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends m.LogService{constructor(A){if(A.logFile.scheme!==C.Schemas.file)throw new Error("Only file-logging supported");super(new R.SpdLogLogger(L.ExtensionHostLogFileName,A.logFile.fsPath,!0,A.logLevel))}$setLevel(A){this.setLevel(A)}};k=Ve([xe(0,I.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(me[228],ge([0,1,16]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,R)=>{this._actualOk=C,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,R){return this._ensureActual().then(C,R)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(me[65],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(A,n){this._proxyIdentifierBrand=void 0,this.isMain=A,this.sid=n,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function I(D){const A=new m(!0,D);return L[A.nid]=A,A}e.createMainContextProxyIdentifier=I;function C(D){const A=new m(!1,D);return L[A.nid]=A,A}e.createExtHostContextProxyIdentifier=C;function R(D){return L[D].sid}e.getStringIdentifierForProxy=R;class k{constructor(A){this.value=A}}e.SerializableObjectWithBuffers=k}),define(me[5],ge([0,1,59,2,65]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var R;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(o){o.name="$ident";function a(t,r){return Object.defineProperty(t,o.name,{value:r,enumerable:!0}),t}o.mixin=a;function v(t){return t[o.name]}o.of=v})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(a){return a._id=h._n++,a}}e.IdObject=h,h._n=0;var c;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(o){if(o&&o.edits)for(const a of o.edits)typeof a.resource=="object"?a.resource=L.URI.revive(a.resource):(a.newUri=L.URI.revive(a.newUri),a.oldUri=L.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,m.revive)(a.metadata));return o}e.reviveWorkspaceEditDto=P;var E;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[91],ge([0,1,5,3,4]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,A){return this._proxy.$setPassword(k,D,A)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(me[66],ge([0,1,4,12,5,14]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(D,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(I.MainContext.MainThreadTelemetry)}report(D,A,n){const T=this.getUsageKey(D,A);this._reportedUsages.has(T)||(this._reportedUsages.add(T),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:D}))}getUsageKey(D,A){return`${D}-${A.identifier.value}`}};R=Ve([xe(0,C.IExtHostRpcService),xe(1,L.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,A){}})}),define(me[229],ge([0,1,3,5,7,26]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,A,n,T={}){const u=C.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(u)||[],c=[...n].sort().join(" ");let g=h.find(_=>_.scopes===c);if(g)return g.result;{const _=this._getSession(D,u,A,n,T);g={scopes:c,result:_},h.push(g),this._inFlightRequests.set(u,h);try{await _}finally{const P=h.findIndex(E=>E.scopes===c);P>-1&&(h.splice(P),this._inFlightRequests.set(u,h))}return _}}async _getSession(D,A,n,T,u={}){await this._proxy.$ensureProvider(n);const h=D.displayName||D.name;return this._proxy.$getSession(n,T,A,h,u)}async removeSession(D,A){const n=this._authenticationProviders.get(D);return n?n.provider.removeSession(A):this._proxy.$removeSession(D,A)}registerAuthenticationProvider(D,A,n,T){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:A,provider:n,options:T??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===D)||this._providers.push({id:D,label:A});const u=n.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(D,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,A,T?.supportsMultipleAccounts??!1),new I.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(D);const h=this._providers.findIndex(c=>c.id===D);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,A){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,A){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,A){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,A){return this._onDidChangeSessions.fire({provider:{id:D,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(me[230],ge([0,1,5,14,15]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=I.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};C=Ve([xe(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(me[231],ge([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const R=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(k){return R.$writeText(k)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,13,7,15,25,5,20,12,59,41,50,2,6,4,14]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new P(this,s=>{const i=this._apiCommands.get(s);return i?.result===o.Void?i:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,A.revive)(s)}},{processArgument(s){return(0,C.cloneAndChange)(s,function(i){if(n.Range.isIRange(i))return I.Range.to(i);if(T.Position.isIPosition(i))return I.Position.to(i);if(n.Range.isIRange(i.range)&&u.URI.isUri(i.uri))return I.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((d,f)=>{if(!d.validate(s[f]))throw new Error(`Invalid argument '${d.name}' when running '${t.id}', received: ${s[f]}`);return d.convert(s[f])}),l=await this.executeCommand(t.internalId,...i);return t.result.convert(l,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,i,l){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:i,description:l}),t&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,C.cloneAndChange)(r,function(l){if(l instanceof L.Position)return I.Position.from(l);if(l instanceof L.Range)return I.Range.from(l);if(l instanceof L.Location)return I.location.from(l);if(L.NotebookRange.isNotebookRange(l))return I.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,i,s);return(0,A.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw l}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:l,description:d}=s;if(d)for(let f=0;f<d.args.length;f++)try{(0,m.validateConstraint)(r[f],d.args[f].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${d.args[f].name}' - ${d.args[f].description}`)}try{return await i.apply(l,r)}catch(f){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...r);w&&(t=w.command)}throw this._logService.error(f,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((i,l)=>l.processArgument(i),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:i}=s;i&&(t[r]=i)}return Promise.resolve(t)}};_=Ve([xe(0,g.IExtHostRpcService),xe(1,D.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class P{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((l,d)=>l.convert(t.arguments&&t.arguments[d]));else if((0,k.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),r.add((0,h.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),s.$ident=l,s.id=this.delegatingCommandId,s.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return s}fromInternal(t){const r=R.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=P;class E{constructor(t,r,s,i){this.name=t,this.description=r,this.validate=s,this.convert=i}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new E(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",v=>u.URI.isUri(v),v=>v),E.Position=new E("position","A position in a text document",v=>L.Position.isPosition(v),I.Position.from),E.Range=new E("range","A range in a text document",v=>L.Range.isRange(v),I.Range.from),E.Selection=new E("selection","A selection in a text document",v=>L.Selection.isSelection(v),I.Selection.from),E.Number=new E("number","",v=>typeof v=="number",v=>v),E.String=new E("string","",v=>typeof v=="string",v=>v),E.CallHierarchyItem=new E("item","A call hierarchy item",v=>v instanceof L.CallHierarchyItem,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",v=>v instanceof L.TypeHierarchyItem,I.TypeHierarchyItem.from);class o{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=o,o.Void=new o("no result",v=>v);class a{constructor(t,r,s,i,l){this.id=t,this.internalId=r,this.description=s,this.args=i,this.result=l}}e.ApiCommand=a}),define(me[232],ge([0,1,15,7,83,44,20,111]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,h)=>{if((0,R.isFalsyOrEmpty)(u))return;class c extends L.SymbolInformation{static to(_){const P=new c(_.name,m.SymbolKind.to(_.kind),_.containerName||"",new L.Location(h[0],m.Range.to(_.range)));return P.detail=_.detail,P.range=P.location.range,P.selectionRange=m.Range.to(_.selectionRange),P.children=_.children?_.children.map(c.to):[],P}}return u.map(c.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(h=>L.Position.isPosition(h)),u=>u.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(h=>{let c;for(const g of h.reverse())c=new L.SelectionRange(m.Range.to(g),c);return c}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const h=[];if(Array.isArray(u))for(let c of u)h.push(...c[1].map(m.WorkspaceSymbol.to));return h})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return m.WorkspaceEdit.to(u)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const h=(0,k.decodeSemanticTokensDto)(u);if(h.type==="full")return new L.SemanticTokens(h.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const h=(0,k.decodeSemanticTokensDto)(u);if(h.type==="full")return new L.SemanticTokens(h.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,h,c)=>{if(!u)return new L.CompletionList([]);const g=u.suggestions.map(_=>m.CompletionItem.to(_,c));return new L.CompletionList(g,u.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return m.SignatureHelp.to(u)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,h,c)=>n(g=>new L.CodeLens(m.Range.to(g.range),g.command&&c.fromInternal(g.command)))(u))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>L.Range.isRange(u),u=>L.Selection.isSelection(u)?m.Selection.from(u):m.Range.from(u)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,h,c)=>n(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(g.command)}else{const _=new L.CodeAction(g.title,g.kind?new L.CodeActionKind(g.kind):void 0);return g.edit&&(_.edit=m.WorkspaceEdit.to(g.edit)),g.command&&(_.command=c.fromInternal(g.command)),_.isPreferred=g.isPreferred,_}})(u))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(h=>new L.ColorInformation(m.Range.to(h.range),m.Color.to(h.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",u=>u instanceof L.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:m.Range.from(u.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(h=>m.NotebookExclusiveDocumentPattern.to(h))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to)))];class A{static register(h){D.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=A;function n(u){return h=>{if(Array.isArray(h))return h.map(u)}}function T(u){if(!Array.isArray(u))return;const h=[];for(const c of u)I.isLocationLink(c)?h.push(m.DefinitionLink.to(c)):h.push(m.location.to(c));return h}}),define(me[233],ge([0,1,17,56,3,6,2,83,26,15,7,5]),function(Z,e,m,L,I,C,R,k,D,A,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(h,c,g){const _=h.getProxy(T.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const l=this._commentControllers.get(i.handle);return l||i}else if(i&&i.$mid===7){const l=this._commentControllers.get(i.commentControlHandle);if(!l)return i;const d=l.getCommentThread(i.commentThreadHandle);return d||i}else if(i&&i.$mid===8){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const d=l.getCommentThread(i.thread.commentThreadHandle);return d?{thread:d,text:i.text}:i}else if(i&&i.$mid===9){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const d=l.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let f=i.commentUniqueId,w=d.getCommentByUniqueId(f);return w||i}else if(i&&i.$mid===10){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const d=l.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let f=i.text,w=i.commentUniqueId,y=d.getCommentByUniqueId(w);return y?(y.body=f,y):i}return i}})}createCommentController(i,l,d){const f=P.handlePool++,w=new o(i,f,l,d);this._commentControllers.set(w.handle,w);const y=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(i.identifier))||[];return y.push(w),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(i.identifier),y),w.value}$createCommentThreadTemplate(i,l,d){const f=this._commentControllers.get(i);!f||f.$createCommentThreadTemplate(l,d)}async $updateCommentThreadTemplate(i,l,d){const f=this._commentControllers.get(i);!f||f.$updateCommentThreadTemplate(l,d)}$deleteCommentThread(i,l){const d=this._commentControllers.get(i);d&&d.$deleteCommentThread(l)}$provideCommentingRanges(i,l,d){const f=this._commentControllers.get(i);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const w=g.getDocument(R.URI.revive(l));return(0,m.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(w,d)).then(y=>y?y.map(p=>A.Range.from(p)):void 0)}$toggleReaction(i,l,d,f,w){const y=this._commentControllers.get(i);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const p=y.getCommentThread(l);if(p){const S=p.getCommentByUniqueId(f.uniqueIdInThread);if(y!==void 0&&S&&y.reactionHandler)return y.reactionHandler(S,t(w))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class E{constructor(i,l,d,f,w,y,p){this._commentControllerHandle=l,this._id=d,this._uri=f,this._range=w,this._comments=y,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),_.$createCommentThread(l,this.handle,this._id,this._uri,A.Range.from(this._range),p),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(l,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(b){S.range=b},get comments(){return S.comments},set comments(b){S.comments=b},get collapsibleState(){return S.collapsibleState},set collapsibleState(b){S.collapsibleState=b},get canReply(){return S.canReply},set canReply(b){S.canReply=b},get contextValue(){return S.contextValue},set contextValue(b){S.contextValue=b},get label(){return S.label},set label(b){S.label=b},dispose:()=>{S.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const i=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),l={};i("range")&&(l.range=A.Range.from(this._range)),i("label")&&(l.label=this.label),i("contextValue")&&(l.contextValue=this.contextValue),i("comments")&&(l.comments=this._comments.map(d=>a(this,d,this._commentsMap))),i("collapsibleState")&&(l.collapseState=r(this._collapseState)),i("canReply")&&(l.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(i){for(let l of this._commentsMap){let d=l[0],f=l[1];if(i===f)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}E._handlePool=0,Ve([(0,L.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(i,l,d,f){this._extension=i,this._handle=l,this._id=d,this._label=f,this._threads=new Map,_.$registerCommentController(this.handle,d,f);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(y){w.options=y},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(y){w.commentingRangeProvider=y},get reactionHandler(){return w.reactionHandler},set reactionHandler(y){w.reactionHandler=y},createCommentThread(y,p,S){return w.createCommentThread(y,p,S).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,l,d,f){if(typeof i=="string"){const w=new E(this.id,this.handle,i,l,d,f,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new E(this.id,this.handle,void 0,i,l,d,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(i,l){const d=new E(this.id,this.handle,void 0,R.URI.revive(i),A.Range.to(l),[],this._extension.identifier);return d.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(i,l){let d=this._threads.get(i);d&&(d.range=A.Range.to(l))}$deleteCommentThread(i){let l=this._threads.get(i);l&&l.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function a(s,i,l){let d=l.get(i);d||(d=++s.commentHandle,l.set(i,d));const f=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:d,body:A.MarkdownString.from(i.body),userName:i.author.name,userIconPath:f,label:i.label,commentReactions:i.reactions?i.reactions.map(w=>v(w)):void 0}}function v(s){return{label:s.label,iconPath:s.iconPath?A.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?R.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case n.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=u}),define(me[132],ge([0,1,2,5,7,4,14,12,20,9,8]),function(Z,e,m,L,I,C,R,k,D,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class vn{constructor(h,c){this._logService=c,this._provider=new Map,this._proxy=h.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,c){const g=vn._handlePool++;this._provider.set(g,{provider:h,extensionId:c}),this._proxy.$registerDecorationProvider(g,c.value);const _=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(g,null);return}let E=(0,D.asArray)(P);if(E.length<=vn._maxEventSize){this._proxy.$onDidChange(g,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,E.length);const o=E.map(t=>({uri:t,rank:(0,A.count)(t.path,"/")})),a=(0,D.groupBy)(o,(t,r)=>t.rank-r.rank||(0,A.compare)(t.uri.path,r.uri.path));let v=[];e:for(let t of a){let r;for(let s of t){let i=(0,n.dirname)(s.uri.path);if(r!==i&&(r=i,v.push(s.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(g,v)});return new I.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(h,c,g){if(!this._provider.has(h))return Object.create(null);const _=Object.create(null),{provider:P,extensionId:E}=this._provider.get(h);return await Promise.all(c.map(async o=>{try{const{uri:a,id:v}=o,t=await Promise.resolve(P.provideFileDecoration(m.URI.revive(a),g));if(!t)return;try{I.FileDecoration.validate(t),_[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${E.value}': ${r}`)}}catch(a){this._logService.error(a)}})),_}};T._handlePool=0,T._maxEventSize=250,T=Ve([xe(0,R.IExtHostRpcService),xe(1,k.ILogService)],T),e.ExtHostDecorations=T,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")}),define(me[234],ge([0,1,164,116,2,5,7,15,3,12,23]),function(Z,e,m,L,I,C,R,k,D,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class T{constructor(c,g,_,P,E){this._name=c,this._owner=g,this._maxDiagnosticsPerFile=_,this._proxy=P,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,g){if(!c){this.clear();return}this._checkDisposed();let _=[];if(I.URI.isUri(c)){if(!g){this.delete(c);return}this._data.set(c,g.slice()),_=[c]}else if(Array.isArray(c)){_=[];let E;c=[...c].sort(T._compareIndexedTuplesByUri);for(const o of c){const[a,v]=o;if((!E||a.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=a,_.push(a),this._data.set(a,[])),v){const t=this._data.get(a);t&&t.push(...v)}else{const t=this._data.get(a);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const P=[];for(let E of _){let o=[];const a=this._data.get(E);if(a)if(a.length>this._maxDiagnosticsPerFile){o=[];const v=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of a)if(r.severity===v[t]&&o.push(k.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;o.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=a.map(v=>k.Diagnostic.from(v));P.push([E,o])}this._proxy.$changeMany(this._owner,P)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,g){this._checkDisposed();for(let _ of this._data.keys())c.apply(g,[_,this.get(_),this])}get(c){this._checkDisposed();const g=this._data.get(c);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,g){return c[0].toString()<g[0].toString()?-1:c[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=T;let u=class en{constructor(c,g){this._logService=g,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,en._mapper),this._proxy=c.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(c){const g=new n.ResourceMap;for(const _ of c)g.set(_,_);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(c,g){const{_collections:_,_proxy:P,_onDidChangeDiagnostics:E,_logService:o}=this,a=new class{$changeMany(r,s){P.$changeMany(r,s),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,r,s.length===0?"CLEARING":s)}$clear(r){P.$clear(r),o.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,r)}dispose(){P.dispose()}};let v;if(!g)g="_generated_diagnostic_collection_name_#"+en._idPool++,v=g;else if(!_.has(g))v=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do v=g+en._idPool++;while(_.has(v))}return new class extends T{constructor(){super(g,v,en._maxDiagnosticsPerFile,a,E);_.set(v,this)}dispose(){super.dispose(),_.delete(v)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const g=new Map,_=[];for(const P of this._collections.values())P.forEach((E,o)=>{let a=g.get(E.toString());typeof a=="undefined"&&(a=_.length,g.set(E.toString(),a),_.push([E,[]])),_[a][1]=_[a][1].concat(...o)});return _}}_getDiagnostics(c){let g=[];for(let _ of this._collections.values())_.has(c)&&(g=g.concat(_.get(c)));return g}$acceptMarkersChange(c){if(!this._mirrorCollection){const g="_generated_mirror",_=new T(g,g,en._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(g,_),this._mirrorCollection=_}for(const[g,_]of c)this._mirrorCollection.set(I.URI.revive(g),_.map(k.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=Ve([xe(1,A.ILogService)],u),e.ExtHostDiagnostics=u}),define(me[235],ge([0,1,2,5]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(R){this._proxy=R.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(k=>k?k.map(D=>m.URI.revive(D)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(me[236],ge([0,1,16,2,7,5,10,21,9]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(T,u,h){this._documentsAndEditors=u,this._logService=h,this._documentContentProviders=new Map,this._proxy=T.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,u){if(Object.keys(R.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const h=A._handlePool++;this._documentContentProviders.set(h,u),this._proxy.$registerTextContentProvider(h,T);let c;return typeof u.onDidChange=="function"&&(c=u.onDidChange(g=>{if(g.scheme!==T){this._logService.warn(`Provider for scheme '${T}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(h,g).then(_=>{if(!_&&typeof _!="string")return;const P=this._documentsAndEditors.getDocument(g);if(!P)return;const E=(0,D.splitLines)(_);if(!P.equalLines(E))return this._proxy.$onVirtualDocumentChange(g,_)},m.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(T,u){const h=this._documentContentProviders.get(T);return h?Promise.resolve(h.provideTextDocumentContent(L.URI.revive(u),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(me[237],ge([0,1,3,6,2,5,124,15,13,25,7]),function(Z,e,m,L,I,C,R,k,D,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(h,c){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=c,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const _ of g)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const _ of g)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const c=this._documentsAndEditors.getDocument(h);if(c)return c}getDocument(h){const c=this.getDocumentData(h);if(!c?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return c.document}ensureDocumentData(h){const c=this._documentsAndEditors.getDocument(h);if(c)return Promise.resolve(c);let g=this._documentLoader.get(h.toString());return g||(g=this._proxy.$tryOpenDocument(h).then(_=>{this._documentLoader.delete(h.toString());const P=I.URI.revive(_);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(P))},_=>(this._documentLoader.delete(h.toString()),Promise.reject(_))),this._documentLoader.set(h.toString(),g)),g}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(c=>I.URI.revive(c))}$acceptModelModeChanged(h,c){const g=I.URI.revive(h),_=this._documentsAndEditors.getDocument(g);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(c),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(h){const c=I.URI.revive(h),g=this._documentsAndEditors.getDocument(c);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(h,c){const g=I.URI.revive(h),_=this._documentsAndEditors.getDocument(g);if(!_)throw new Error("unknown document");_._acceptIsDirty(c),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,c,g){const _=I.URI.revive(h),P=this._documentsAndEditors.getDocument(_);if(!P)throw new Error("unknown document");P._acceptIsDirty(g),P.onEvents(c);let E;c.isUndoing?E=n.TextDocumentChangeReason.Undo:c.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:P.document,contentChanges:c.changes.map(o=>({range:k.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:E}))}setWordDefinitionFor(h,c){(0,R.setWordDefinitionFor)(h,c)}}e.ExtHostDocuments=T}),define(me[45],ge([0,1,54,3,6,2,4,5,124,14,131,15,12,23,10,76,140]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(a,v){this._extHostRpc=a,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const v=[],t=[],r=[];if(a.removedDocuments)for(const s of a.removedDocuments){const i=C.URI.revive(s),l=this._documents.get(i);l?.unref()&&(this._documents.delete(i),v.push(l.value))}if(a.addedDocuments)for(const s of a.addedDocuments){const i=C.URI.revive(s.uri);let l=this._documents.get(i);if(l&&i.scheme!==c.Schemas.vscodeNotebookCell&&i.scheme!==c.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);l||(l=new P(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,l),t.push(l.value)),l.ref()}if(a.removedEditors)for(const s of a.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(a.addedEditors)for(const s of a.addedEditors){const i=C.URI.revive(s.documentUri);m.ok(this._documents.has(i),`document '${i}' does not exist`),m.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const l=this._documents.get(i).value,d=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>l.document),s.selections.map(T.Selection.to),s.options,s.visibleRanges.map(f=>T.Range.to(f)),typeof s.editorPosition=="number"?T.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,d)}a.newActiveEditor!==void 0&&(m.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,I.dispose)(v),(0,I.dispose)(r),a.removedDocuments&&this._onDidRemoveDocuments.fire(v),a.addedDocuments&&this._onDidAddDocuments.fire(t),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return a?v:v?.value}allEditors(){return[...this._editors.values()]}};E=Ve([xe(0,A.IExtHostRpcService),xe(1,u.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[238],ge([0,1,2,5,6,7,15,148,9,22]),function(Z,e,m,L,I,C,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const c=this._schemes.indexOf(h);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),c=[];let g,_,P=14,E=14;for(const o of h){let a=g?(0,D.commonPrefixLength)(g,o):0;for(a===0?_=1:_=E;a<o.length;a++)a+1===o.length?(P=E,E=9):E+=1,c.push([_,o.toUpperCase().charCodeAt(a),E]),c.push([_,o.toLowerCase().charCodeAt(a),E]),_=E;g=o,E=P}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new k.StateMachine(c)}}provideDocumentLinks(h){this._initStateMachine();const c=[],g=k.LinkComputer.computeLinks({getLineContent(_){return h.lineAt(_-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const _ of g){const P=R.DocumentLink.to(_);P.target&&c.push(P)}return c}}class T{constructor(h,c){this._extHostLanguageFeatures=c,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,c,g,_={},P){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(E,g),this._enableProposedApi.set(E,P??!1);let o=2;_.isCaseSensitive&&(o+=1024),_.isReadonly&&(o+=2048),typeof g.copy=="function"&&(o+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&(o+=4),this._proxy.$registerFileSystemProvider(E,c,o).catch(v=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${c}`),console.error(v)});const a=g.onDidChangeFile(v=>{const t=[];for(const r of v){let{uri:s,type:i}=r;if(s.scheme!==c)continue;let l;switch(i){case C.FileChangeType.Changed:l=0;break;case C.FileChangeType.Created:l=1;break;case C.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:l})}this._proxy.$onFileSystemChange(E,t)});return(0,I.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(h,c){const{type:g,ctime:_,mtime:P,size:E,permissions:o}=h;return c?{type:g,ctime:_,mtime:P,size:E,permissions:o}:{type:g,ctime:_,mtime:P,size:E}}$stat(h,c){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(c))).then(g=>T._asIStat(g,this._enableProposedApi.get(h)??!1))}$readdir(h,c){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(c)))}$readFile(h,c){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(c))).then(g=>A.VSBuffer.wrap(g))}$writeFile(h,c,g,_){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(c),g.buffer,_))}$delete(h,c,g){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(c),g))}$rename(h,c,g,_){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(c),m.URI.revive(g),_))}$copy(h,c,g,_){const P=this._getFsProvider(h);if(!P.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(P.copy(m.URI.revive(c),m.URI.revive(g),_))}$mkdir(h,c){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(c)))}$watch(h,c,g,_){const P=this._getFsProvider(h).watch(m.URI.revive(g),_);this._watches.set(c,P)}$unwatch(h,c){const g=this._watches.get(c);g&&(g.dispose(),this._watches.delete(c))}$open(h,c,g){const _=this._getFsProvider(h);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(m.URI.revive(c),g))}$close(h,c){const g=this._getFsProvider(h);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(c))}$read(h,c,g,_){const P=this._getFsProvider(h);if(!P.read)throw new Error('FileSystemProvider does not implement "read"');const E=A.VSBuffer.alloc(_);return Promise.resolve(P.read(c,g,E.buffer,0,_)).then(o=>E.slice(0,o))}$write(h,c,g,_){const P=this._getFsProvider(h);if(!P.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(P.write(c,g,_.buffer,0,_.byteLength))}_getFsProvider(h){const c=this._fsProvider.get(h);if(!c){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return c}}e.ExtHostFileSystem=T}),define(me[92],ge([0,1,5,42,7,22,4,14,63]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Ut{constructor(T,u){const h=T.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return h.$stat(c).catch(Ut._handleError)},readDirectory(c){return h.$readdir(c).catch(Ut._handleError)},createDirectory(c){return h.$mkdir(c).catch(Ut._handleError)},async readFile(c){return h.$readFile(c).then(g=>g.buffer).catch(Ut._handleError)},writeFile(c,g){return h.$writeFile(c,C.VSBuffer.wrap(g)).catch(Ut._handleError)},delete(c,g){return h.$delete(c,{recursive:!1,useTrash:!1,...g}).catch(Ut._handleError)},rename(c,g,_){return h.$rename(c,g,{overwrite:!1,..._}).catch(Ut._handleError)},copy(c,g,_){return h.$copy(c,g,{overwrite:!1,..._}).catch(Ut._handleError)},isWritableFileSystem(c){const g=u.getCapabilities(c);if(typeof g=="number")return!(g&2048)}})}static _handleError(T){if(!(T instanceof Error))throw new I.FileSystemError(String(T));if(T.name==="ENOPRO")throw I.FileSystemError.Unavailable(T.message);switch(T.name){case L.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(T.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(T.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(T.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(T.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(T.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(T.message);default:throw new I.FileSystemError(T.message,T.name)}}};A=Ve([xe(0,k.IExtHostRpcService),xe(1,D.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(me[239],ge([0,1,2,44]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(R,k,D,A){this._extHostNotebooks=k,this._textDocumentsAndEditors=D,this._commands=A;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",T=>!0,T=>T),new L.ApiCommandArgument("resource","Interactive resource Uri",T=>!0,T=>T),new L.ApiCommandArgument("controllerId","Notebook controller Id",T=>!0,T=>T),new L.ApiCommandArgument("title","Interactive editor title",T=>!0,T=>T)],new L.ApiCommandResult("Notebook and input URI",T=>{if(T.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(T.notebookEditorId);return{notebookUri:m.URI.revive(T.notebookUri),inputUri:m.URI.revive(T.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:m.URI.revive(T.notebookUri),inputUri:m.URI.revive(T.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(R,k,D,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],modeId:D,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=I}),define(me[240],ge([0,1,6,5]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(R){this._handlePool=0,this._proxy=R.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,R),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(me[241],ge([0,1,2,25,15,7,5,9,41,20,13,145,6,111,75,87,46,16,3]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentSymbols(z,ee){const re=this._documents.getDocument(z),le=await this._provider.provideDocumentSymbols(re,ee);if(!(0,A.isFalsyOrEmpty)(le))return le[0]instanceof C.DocumentSymbol?le.map(I.DocumentSymbol.from):o._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((le,Y)=>{let oe=le.location.range.start.compareTo(Y.location.range.start);return oe===0&&(oe=Y.location.range.end.compareTo(le.location.range.end)),oe});const ee=[],re=[];for(const le of z){const Y={name:le.name||"!!MISSING: name!!",kind:I.SymbolKind.from(le.kind),tags:le.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:I.Range.from(le.location.range),selectionRange:I.Range.from(le.location.range),children:[]};for(;;){if(re.length===0){re.push(Y),ee.push(Y);break}const oe=re[re.length-1];if(D.Range.containsRange(oe.range,Y.range)&&!D.Range.equalsRange(oe.range,Y.range)){oe.children&&oe.children.push(Y),re.push(Y);break}re.pop()}}return ee}}class a{constructor(z,ee,re){this._documents=z,this._commands=ee,this._provider=re,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,ee){const re=this._documents.getDocument(z),le=await this._provider.provideCodeLenses(re,ee);if(!le||ee.isCancellationRequested)return;const Y=this._cache.add(le),oe=new u.DisposableStore;this._disposables.set(Y,oe);const ve={cacheId:Y,lenses:[]};for(let Me=0;Me<le.length;Me++)ve.lenses.push({cacheId:[Y,Me],range:I.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,oe)});return ve}async resolveCodeLens(z,ee){const re=z.cacheId&&this._cache.get(...z.cacheId);if(!re)return;let le;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?le=re:le=await this._provider.resolveCodeLens(re,ee),le||(le=re),ee.isCancellationRequested)return;const Y=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!Y)return z.command=this._commands.toInternal(le.command??a._badCmd,Y),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(Ke){return Array.isArray(Ke)?Ke.map(I.DefinitionLink.from):Ke?[I.DefinitionLink.from(Ke)]:[]}class t{constructor(z,ee){this._documents=z,this._provider=ee}async provideDefinition(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideDefinition(le,Y,re);return v(oe)}}class r{constructor(z,ee){this._documents=z,this._provider=ee}async provideDeclaration(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideDeclaration(le,Y,re);return v(oe)}}class s{constructor(z,ee){this._documents=z,this._provider=ee}async provideImplementation(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideImplementation(le,Y,re);return v(oe)}}class i{constructor(z,ee){this._documents=z,this._provider=ee}async provideTypeDefinition(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideTypeDefinition(le,Y,re);return v(oe)}}class l{constructor(z,ee){this._documents=z,this._provider=ee}async provideHover(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideHover(le,Y,re);if(!(!oe||(0,A.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=le.getWordRangeAtPosition(Y)),oe.range||(oe.range=new C.Range(Y,Y)),I.Hover.from(oe)}}class d{constructor(z,ee){this._documents=z,this._provider=ee}async provideEvaluatableExpression(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(le,Y,re);if(oe)return I.EvaluatableExpression.from(oe)}}class f{constructor(z,ee){this._documents=z,this._provider=ee}async provideInlineValues(z,ee,re,le){const Y=this._documents.getDocument(z),oe=await this._provider.provideInlineValues(Y,I.Range.to(ee),I.InlineValueContext.to(re),le);if(Array.isArray(oe))return oe.map(ve=>I.InlineValue.from(ve))}}class w{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentHighlights(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideDocumentHighlights(le,Y,re);if(Array.isArray(oe))return oe.map(I.DocumentHighlight.from)}}class y{constructor(z,ee){this._documents=z,this._provider=ee}async provideLinkedEditingRanges(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(le,Y,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,A.coalesce)(oe.ranges.map(I.Range.from)),wordPattern:oe.wordPattern}}}class p{constructor(z,ee){this._documents=z,this._provider=ee}async provideReferences(z,ee,re,le){const Y=this._documents.getDocument(z),oe=I.Position.to(ee),ve=await this._provider.provideReferences(Y,oe,re,le);if(Array.isArray(ve))return ve.map(I.location.from)}}class S{constructor(z,ee,re,le,Y,oe,ve){this._documents=z,this._commands=ee,this._diagnostics=re,this._provider=le,this._logService=Y,this._extension=oe,this._apiDeprecation=ve,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,ee,re,le){const Y=this._documents.getDocument(z),oe=T.Selection.isISelection(ee)?I.Selection.to(ee):I.Range.to(ee),ve=[];for(const ct of this._diagnostics.getDiagnostics(z))if(oe.intersection(ct.range)&&ve.push(ct)>S._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:I.CodeActionTriggerKind.to(re.trigger)},je=await this._provider.provideCodeActions(Y,oe,Me,le);if(!(0,A.isNonEmptyArray)(je)||le.isCancellationRequested)return;const Qe=this._cache.add(je),et=new u.DisposableStore;this._disposables.set(Qe,et);const ke=[];for(let ct=0;ct<je.length;ct++){const Q=je[ct];!Q||(S._isCommand(Q)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ke.push({_isSynthetic:!0,title:Q.title,command:this._commands.toInternal(Q,et)})):(Me.only&&(Q.kind?Me.only.contains(Q.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${Q.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ke.push({cacheId:[Qe,ct],title:Q.title,command:Q.command&&this._commands.toInternal(Q.command,et),diagnostics:Q.diagnostics&&Q.diagnostics.map(I.Diagnostic.from),edit:Q.edit&&I.WorkspaceEdit.from(Q.edit),kind:Q.kind&&Q.kind.value,isPreferred:Q.isPreferred,disabled:Q.disabled?.reason})))}return{cacheId:Qe,actions:ke}}async resolveCodeAction(z,ee){const[re,le]=z,Y=this._cache.get(re,le);if(!Y||S._isCommand(Y)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Y,ee)??Y;return oe?.edit?I.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}S._maxCodeActionsPerFile=1e3;class b{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentFormattingEdits(z,ee,re){const le=this._documents.getDocument(z),Y=await this._provider.provideDocumentFormattingEdits(le,ee,re);if(Array.isArray(Y))return Y.map(I.TextEdit.from)}}class F{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentRangeFormattingEdits(z,ee,re,le){const Y=this._documents.getDocument(z),oe=I.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(Y,oe,re,le);if(Array.isArray(ve))return ve.map(I.TextEdit.from)}}class N{constructor(z,ee){this._documents=z,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,ee,re,le,Y){const oe=this._documents.getDocument(z),ve=I.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,ve,re,le,Y);if(Array.isArray(Me))return Me.map(I.TextEdit.from)}}class G{constructor(z,ee){this._provider=z,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(z,ee){const re=R.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(z,ee);if((0,A.isNonEmptyArray)(le))for(const Y of le){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const oe=R.IdObject.mixin(I.WorkspaceSymbol.from(Y));this._symbolCache.set(oe._id,Y),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(z,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const re=this._symbolCache.get(z._id);if(re){const le=await this._provider.resolveWorkspaceSymbol(re,ee);return le&&(0,L.mixin)(z,I.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(z){const ee=this._resultCache.get(z);if(ee){for(let[re,le]=ee;re<=le;re++)this._symbolCache.delete(re);this._resultCache.delete(z)}}}class K{constructor(z,ee,re){this._documents=z,this._provider=ee,this._logService=re}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,ee,re,le){const Y=this._documents.getDocument(z),oe=I.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(Y,oe,re,le);return ve?I.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=K._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(z,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(z),Y=I.Position.to(ee);try{const oe=await this._provider.prepareRename(le,Y,re);let ve,Me;if(C.Range.isRange(oe)?(ve=oe,Me=le.getText(oe)):(0,n.isObject)(oe)&&(ve=oe.range,Me=oe.placeholder),!ve||!Me)return;if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ve),text:Me}}catch(oe){const ve=K._asMessage(oe);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class M{constructor(z,ee){this.resultId=z,this.tokens=ee}}class U{constructor(z,ee){this._documents=z,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,ee,re){const le=this._documents.getDocument(z),Y=ee!==0?this._previousResults.get(ee):null;let oe=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Y.resultId,re):await this._provider.provideDocumentSemanticTokens(le,re);return Y&&this._previousResults.delete(ee),oe?(oe=U._fixProvidedSemanticTokens(oe),this._send(U._convertToEdits(Y,oe),oe)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new C.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new C.SemanticTokensEdits(z.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const ee of z.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,ee){if(!U._isSemanticTokens(ee)||!z||!z.tokens)return ee;const re=z.tokens,le=re.length,Y=ee.data,oe=Y.length;let ve=0;const Me=Math.min(le,oe);for(;ve<Me&&re[ve]===Y[ve];)ve++;if(ve===le&&ve===oe)return new C.SemanticTokensEdits([],ee.resultId);let je=0;const Qe=Me-ve;for(;je<Qe&&re[le-je-1]===Y[oe-je-1];)je++;return new C.SemanticTokensEdits([{start:ve,deleteCount:le-ve-je,data:Y.subarray(ve,oe-je)}],ee.resultId)}_send(z,ee){if(U._isSemanticTokens(z)){const re=this._nextResultId++;return this._previousResults.set(re,new M(z.resultId,z.data)),(0,h.encodeSemanticTokensDto)({id:re,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const re=this._nextResultId++;return U._isSemanticTokens(ee)?this._previousResults.set(re,new M(ee.resultId,ee.data)):this._previousResults.set(re,new M(z.resultId)),(0,h.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(z.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class O{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentRangeSemanticTokens(z,ee,re){const le=this._documents.getDocument(z),Y=await this._provider.provideDocumentRangeSemanticTokens(le,I.Range.to(ee),re);return Y?this._send(Y):null}_send(z){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=O;class ${constructor(z,ee,re,le,Y){this._documents=z,this._commands=ee,this._provider=re,this._apiDeprecation=le,this._extension=Y,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,ee,re,le){const Y=this._documents.getDocument(z),oe=I.Position.to(ee),ve=Y.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=ve.with({end:oe}),je=new _.StopWatch(!0),Qe=await this._provider.provideCompletionItems(Y,oe,le,I.CompletionContext.to(re));if(!Qe||le.isCancellationRequested)return;const et=Array.isArray(Qe)?new C.CompletionList(Qe):Qe,ke=$.supportsResolving(this._provider)?this._cache.add(et.items):this._cache.add([]),ct=new u.DisposableStore;this._disposables.set(ke,ct);const Q=[],te={x:ke,b:Q,a:{replace:I.Range.from(ve),insert:I.Range.from(Me)},c:et.isIncomplete||void 0,d:je.elapsed()};for(let pe=0;pe<et.items.length;pe++){const ze=et.items[pe],tt=this._convertCompletionItem(ze,[ke,pe],Me,ve);Q.push(tt)}return te}async resolveCompletionItem(z,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...z);if(!re)return;const le=await this._provider.resolveCompletionItem(re,ee);if(!!le)return this._convertCompletionItem(le,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,ee,re,le){const Y=this._disposables.get(ee[0]);if(!Y)throw Error("DisposableStore is missing...");const oe={x:ee,a:z.label,b:z.kind!==void 0?I.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(I.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(z.command,Y)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=z.textEdit.newText):typeof z.insertText=="string"?oe.h=z.insertText:z.insertText instanceof C.SnippetString&&(oe.h=z.insertText.value,oe.i|=4);let ve;return z.textEdit?ve=z.textEdit.range:z.range&&(ve=z.range),C.Range.isRange(ve)?oe.j=I.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(oe.j={insert:I.Range.from(ve.inserting),replace:I.Range.from(ve.replacing)}),oe}}class B{constructor(z,ee,re){this._documents=z,this._provider=ee,this._commands=re,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,ee,re,le){const Y=this._documents.getDocument(z),oe=I.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(Y,oe,{selectedSuggestionInfo:re.selectedSuggestionInfo?{range:I.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},le);if(!ve||le.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,je=this._cache.add(Me.items);let Qe;return{pid:je,items:Me.items.map((et,ke)=>{let ct;return et.command&&(Qe||(Qe=new u.DisposableStore,this._disposables.set(je,Qe)),ct=this._commands.toInternal(et.command,Qe)),{text:et.text,range:et.range?I.Range.from(et.range):void 0,command:ct,idx:ke}})}}disposeCompletions(z){this._cache.delete(z);const ee=this._disposables.get(z);ee&&ee.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,ee){const re=this._cache.get(z,ee);re&&x.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class x{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let ee=x.map.get(z);return ee||(ee=new x,x.map.set(z,ee)),ee}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=x,x.map=new WeakMap;class j{constructor(z,ee){this._documents=z,this._provider=ee,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(z,ee,re,le){const Y=this._documents.getDocument(z),oe=I.Position.to(ee),ve=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Y,oe,le,ve);if(Me){const je=this._cache.add([Me]);return{...I.SignatureHelp.from(Me),id:je}}}reviveContext(z){let ee;if(z.activeSignatureHelp){const re=I.SignatureHelp.to(z.activeSignatureHelp),le=this._cache.get(z.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...z,activeSignatureHelp:ee}}releaseSignatureHelp(z){this._cache.delete(z)}}class H{constructor(z,ee){this._documents=z,this._provider=ee}async provideInlayHints(z,ee,re){const le=this._documents.getDocument(z),Y=await this._provider.provideInlayHints(le,I.Range.to(ee),re);return Y?{hints:Y.map(I.InlayHint.from)}:void 0}}class X{constructor(z,ee){this._documents=z,this._provider=ee,this._cache=new g.Cache("DocumentLink")}async provideLinks(z,ee){const re=this._documents.getDocument(z),le=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(X._validateLink).map(I.DocumentLink.from)};{const Y=this._cache.add(le),oe={links:[],id:Y};for(let ve=0;ve<le.length;ve++){if(!X._validateLink(le[ve]))continue;const Me=I.DocumentLink.from(le[ve]);Me.cacheId=[Y,ve],oe.links.push(Me)}return oe}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...z);if(!re)return;const le=await this._provider.resolveDocumentLink(re,ee);if(!(!le||!X._validateLink(le)))return I.DocumentLink.from(le)}releaseLinks(z){this._cache.delete(z)}}class J{constructor(z,ee){this._documents=z,this._provider=ee}async provideColors(z,ee){const re=this._documents.getDocument(z),le=await this._provider.provideDocumentColors(re,ee);return Array.isArray(le)?le.map(oe=>({color:I.Color.from(oe.color),range:I.Range.from(oe.range)})):[]}async provideColorPresentations(z,ee,re){const le=this._documents.getDocument(z),Y=I.Range.to(ee.range),oe=I.Color.to(ee.color),ve=await this._provider.provideColorPresentations(oe,{document:le,range:Y},re);if(!!Array.isArray(ve))return ve.map(I.ColorPresentation.from)}}class fe{constructor(z,ee){this._documents=z,this._provider=ee}async provideFoldingRanges(z,ee,re){const le=this._documents.getDocument(z),Y=await this._provider.provideFoldingRanges(le,ee,re);if(!!Array.isArray(Y))return Y.map(I.FoldingRange.from)}}class _e{constructor(z,ee,re){this._documents=z,this._provider=ee,this._logService=re}async provideSelectionRanges(z,ee,re){const le=this._documents.getDocument(z),Y=ee.map(I.Position.to),oe=await this._provider.provideSelectionRanges(le,Y,re);if(!(0,A.isNonEmptyArray)(oe))return[];if(oe.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Y.length;Me++){const je=[];ve.push(je);let Qe=Y[Me],et=oe[Me];for(;;){if(!et.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(I.SelectionRange.from(et)),!et.parent)break;Qe=et.range,et=et.parent}}return ve}}class Se{constructor(z,ee){this._documents=z,this._provider=ee,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.prepareCallHierarchy(le,Y,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideCallsTo(z,ee,re){const le=this._itemFromCache(z,ee);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(le,re);if(!!Y)return Y.map(oe=>({from:this._cacheAndConvertItem(z,oe.from),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}async provideCallsFrom(z,ee,re){const le=this._itemFromCache(z,ee);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(le,re);if(!!Y)return Y.map(oe=>({to:this._cacheAndConvertItem(z,oe.to),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,ee){const re=this._cache.get(z),le=I.CallHierarchyItem.from(ee,z,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(z,ee){return this._cache.get(z)?.get(ee)}}class Le{constructor(z,ee){this._documents=z,this._provider=ee,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(z,ee,re){const le=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(le,Y,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideSupertypes(z,ee,re){const le=this._itemFromCache(z,ee);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(le,re);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(z,oe))}async provideSubtypes(z,ee,re){const le=this._itemFromCache(z,ee);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(le,re);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(z,oe))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,ee){const re=this._cache.get(z),le=I.TypeHierarchyItem.from(ee,z,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(z,ee){return this._cache.get(z)?.get(ee)}}class We{constructor(z,ee){this.adapter=z,this.extension=ee}}class Ne{constructor(z,ee,re,le,Y,oe,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=z.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=le,this._diagnostics=Y,this._logService=oe,this._apiDeprecation=ve}_transformDocumentSelector(z){return(0,A.coalesce)((0,A.asArray)(z).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:I.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new C.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ne._handlePool++}_withAdapter(z,ee,re,le,Y=!1){const oe=this._adapter.get(z);if(!oe)return Promise.resolve(le);if(oe.adapter instanceof ee){let ve;oe.extension&&(ve=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),je=oe.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Qe=>{Y&&Qe instanceof P.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Qe))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,ee){const re=this._nextHandle();return this._adapter.set(re,new We(z,ee)),re}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,ee,re,le){const Y=this._addNewAdapter(new o(this._documents,re),z),oe=le&&le.label||Ne._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(ee),oe),this._createDisposable(Y)}$provideDocumentSymbols(z,ee,re){return this._withAdapter(z,o,le=>le.provideDocumentSymbols(m.URI.revive(ee),re),void 0)}registerCodeLensProvider(z,ee,re){const le=this._nextHandle(),Y=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new We(new a(this._documents,this._commands.converter,re),z)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Y);let oe=this._createDisposable(le);if(Y!==void 0){const ve=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Y));oe=C.Disposable.from(oe,ve)}return oe}$provideCodeLenses(z,ee,re){return this._withAdapter(z,a,le=>le.provideCodeLenses(m.URI.revive(ee),re),void 0)}$resolveCodeLens(z,ee,re){return this._withAdapter(z,a,le=>le.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(z,ee){this._withAdapter(z,a,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(z,ee,re){const le=this._addNewAdapter(new t(this._documents,re),z);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(z,ee,re,le){return this._withAdapter(z,t,Y=>Y.provideDefinition(m.URI.revive(ee),re,le),[])}registerDeclarationProvider(z,ee,re){const le=this._addNewAdapter(new r(this._documents,re),z);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(z,ee,re,le){return this._withAdapter(z,r,Y=>Y.provideDeclaration(m.URI.revive(ee),re,le),[])}registerImplementationProvider(z,ee,re){const le=this._addNewAdapter(new s(this._documents,re),z);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(z,ee,re,le){return this._withAdapter(z,s,Y=>Y.provideImplementation(m.URI.revive(ee),re,le),[])}registerTypeDefinitionProvider(z,ee,re){const le=this._addNewAdapter(new i(this._documents,re),z);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(z,ee,re,le){return this._withAdapter(z,i,Y=>Y.provideTypeDefinition(m.URI.revive(ee),re,le),[])}registerHoverProvider(z,ee,re,le){const Y=this._addNewAdapter(new l(this._documents,re),z);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(ee)),this._createDisposable(Y)}$provideHover(z,ee,re,le){return this._withAdapter(z,l,Y=>Y.provideHover(m.URI.revive(ee),re,le),void 0)}registerEvaluatableExpressionProvider(z,ee,re,le){const Y=this._addNewAdapter(new d(this._documents,re),z);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(ee)),this._createDisposable(Y)}$provideEvaluatableExpression(z,ee,re,le){return this._withAdapter(z,d,Y=>Y.provideEvaluatableExpression(m.URI.revive(ee),re,le),void 0)}registerInlineValuesProvider(z,ee,re,le){const Y=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new f(this._documents,re),z);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),Y);let ve=this._createDisposable(oe);if(Y!==void 0){const Me=re.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Y));ve=C.Disposable.from(ve,Me)}return ve}$provideInlineValues(z,ee,re,le,Y){return this._withAdapter(z,f,oe=>oe.provideInlineValues(m.URI.revive(ee),re,le,Y),void 0)}registerDocumentHighlightProvider(z,ee,re){const le=this._addNewAdapter(new w(this._documents,re),z);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(z,ee,re,le){return this._withAdapter(z,w,Y=>Y.provideDocumentHighlights(m.URI.revive(ee),re,le),void 0)}registerLinkedEditingRangeProvider(z,ee,re){const le=this._addNewAdapter(new y(this._documents,re),z);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(z,ee,re,le){return this._withAdapter(z,y,async Y=>{const oe=await Y.provideLinkedEditingRanges(m.URI.revive(ee),re,le);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Ne._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(z,ee,re){const le=this._addNewAdapter(new p(this._documents,re),z);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(z,ee,re,le,Y){return this._withAdapter(z,p,oe=>oe.provideReferences(m.URI.revive(ee),re,le,Y),void 0)}registerCodeActionProvider(z,ee,re,le){const Y=new u.DisposableStore,oe=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,re,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Y)}))},Ne._extLabel(z),Boolean(re.resolveCodeAction)),Y.add(this._createDisposable(oe)),Y}$provideCodeActions(z,ee,re,le,Y){return this._withAdapter(z,S,oe=>oe.provideCodeActions(m.URI.revive(ee),re,le,Y),void 0)}$resolveCodeAction(z,ee,re){return this._withAdapter(z,S,le=>le.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(z,ee){this._withAdapter(z,S,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(z,ee,re){const le=this._addNewAdapter(new b(this._documents,re),z);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentFormattingEdits(z,ee,re,le){return this._withAdapter(z,b,Y=>Y.provideDocumentFormattingEdits(m.URI.revive(ee),re,le),void 0)}registerDocumentRangeFormattingEditProvider(z,ee,re){const le=this._addNewAdapter(new F(this._documents,re),z);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(z,ee,re,le,Y){return this._withAdapter(z,F,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(ee),re,le,Y),void 0)}registerOnTypeFormattingEditProvider(z,ee,re,le){const Y=this._addNewAdapter(new N(this._documents,re),z);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(ee),le,z.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(z,ee,re,le,Y,oe){return this._withAdapter(z,N,ve=>ve.provideOnTypeFormattingEdits(m.URI.revive(ee),re,le,Y,oe),void 0)}registerWorkspaceSymbolProvider(z,ee){const re=this._addNewAdapter(new G(ee,this._logService),z);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(z,ee,re){return this._withAdapter(z,G,le=>le.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(z,ee,re){return this._withAdapter(z,G,le=>le.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(z,ee){this._withAdapter(z,G,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(z,ee,re){const le=this._addNewAdapter(new K(this._documents,re,this._logService),z);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),K.supportsResolving(re)),this._createDisposable(le)}$provideRenameEdits(z,ee,re,le,Y){return this._withAdapter(z,K,oe=>oe.provideRenameEdits(m.URI.revive(ee),re,le,Y),void 0)}$resolveRenameLocation(z,ee,re,le){return this._withAdapter(z,K,Y=>Y.resolveRenameLocation(m.URI.revive(ee),re,le),void 0)}registerDocumentSemanticTokensProvider(z,ee,re,le){const Y=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new We(new U(this._documents,re),z)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(ee),le,oe);let ve=this._createDisposable(Y);if(oe){const Me=re.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(oe));ve=C.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(z,ee,re,le){return this._withAdapter(z,U,Y=>Y.provideDocumentSemanticTokens(m.URI.revive(ee),re,le),null,!0)}$releaseDocumentSemanticTokens(z,ee){this._withAdapter(z,U,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(z,ee,re,le){const Y=this._addNewAdapter(new O(this._documents,re),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(ee),le),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(z,ee,re,le){return this._withAdapter(z,O,Y=>Y.provideDocumentRangeSemanticTokens(m.URI.revive(ee),re,le),null,!0)}registerCompletionItemProvider(z,ee,re,le){const Y=this._addNewAdapter(new $(this._documents,this._commands.converter,re,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(ee),le,$.supportsResolving(re),`${z.identifier.value}(${le.join("")})`),this._createDisposable(Y)}$provideCompletionItems(z,ee,re,le,Y){return this._withAdapter(z,$,oe=>oe.provideCompletionItems(m.URI.revive(ee),re,le,Y),void 0)}$resolveCompletionItem(z,ee,re){return this._withAdapter(z,$,le=>le.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(z,ee){this._withAdapter(z,$,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(z,ee,re){const le=this._addNewAdapter(new B(this._documents,re,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(z,ee,re,le,Y){return this._withAdapter(z,B,oe=>oe.provideInlineCompletions(m.URI.revive(ee),re,le,Y),void 0)}$handleInlineCompletionDidShow(z,ee,re){this._withAdapter(z,B,async le=>{le.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(z,ee){this._withAdapter(z,B,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(z,ee,re,le){const Y=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,oe=this._addNewAdapter(new j(this._documents,re),z);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),Y),this._createDisposable(oe)}$provideSignatureHelp(z,ee,re,le,Y){return this._withAdapter(z,j,oe=>oe.provideSignatureHelp(m.URI.revive(ee),re,le,Y),void 0)}$releaseSignatureHelp(z,ee){this._withAdapter(z,j,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(z,ee,re){const le=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new H(this._documents,re),z);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(ee),le);let oe=this._createDisposable(Y);if(le!==void 0){const ve=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));oe=C.Disposable.from(oe,ve)}return oe}$provideInlayHints(z,ee,re,le){return this._withAdapter(z,H,Y=>Y.provideInlayHints(m.URI.revive(ee),re,le),void 0)}registerDocumentLinkProvider(z,ee,re){const le=this._addNewAdapter(new X(this._documents,re),z);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(z,ee,re){return this._withAdapter(z,X,le=>le.provideLinks(m.URI.revive(ee),re),void 0)}$resolveDocumentLink(z,ee,re){return this._withAdapter(z,X,le=>le.resolveLink(ee,re),void 0)}$releaseDocumentLinks(z,ee){this._withAdapter(z,X,re=>re.releaseLinks(ee),void 0)}registerColorProvider(z,ee,re){const le=this._addNewAdapter(new J(this._documents,re),z);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(z,ee,re){return this._withAdapter(z,J,le=>le.provideColors(m.URI.revive(ee),re),[])}$provideColorPresentations(z,ee,re,le){return this._withAdapter(z,J,Y=>Y.provideColorPresentations(m.URI.revive(ee),re,le),void 0)}registerFoldingRangeProvider(z,ee,re){const le=this._nextHandle(),Y=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new We(new fe(this._documents,re),z)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Y);let oe=this._createDisposable(le);if(Y!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));oe=C.Disposable.from(oe,ve)}return oe}$provideFoldingRanges(z,ee,re,le){return this._withAdapter(z,fe,Y=>Y.provideFoldingRanges(m.URI.revive(ee),re,le),void 0)}registerSelectionRangeProvider(z,ee,re){const le=this._addNewAdapter(new _e(this._documents,re,this._logService),z);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(z,ee,re,le){return this._withAdapter(z,_e,Y=>Y.provideSelectionRanges(m.URI.revive(ee),re,le),[])}registerCallHierarchyProvider(z,ee,re){const le=this._addNewAdapter(new Se(this._documents,re),z);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(z,ee,re,le){return this._withAdapter(z,Se,Y=>Promise.resolve(Y.prepareSession(m.URI.revive(ee),re,le)),void 0)}$provideCallHierarchyIncomingCalls(z,ee,re,le){return this._withAdapter(z,Se,Y=>Y.provideCallsTo(ee,re,le),void 0)}$provideCallHierarchyOutgoingCalls(z,ee,re,le){return this._withAdapter(z,Se,Y=>Y.provideCallsFrom(ee,re,le),void 0)}$releaseCallHierarchy(z,ee){this._withAdapter(z,Se,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(z,ee,re){const le=this._addNewAdapter(new Le(this._documents,re),z);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(z,ee,re,le){return this._withAdapter(z,Le,Y=>Promise.resolve(Y.prepareSession(m.URI.revive(ee),re,le)),void 0)}$provideTypeHierarchySupertypes(z,ee,re,le){return this._withAdapter(z,Le,Y=>Y.provideSupertypes(ee,re,le),void 0)}$provideTypeHierarchySubtypes(z,ee,re,le){return this._withAdapter(z,Le,Y=>Y.provideSubtypes(ee,re,le),void 0)}$releaseTypeHierarchy(z,ee){this._withAdapter(z,Le,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,k.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ne._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ne._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ne._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ne._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ne._serializeRegExp(z.beforeText),afterText:z.afterText?Ne._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ne._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ne._serializeOnEnterRule)}setLanguageConfiguration(z,ee,re){let{wordPattern:le}=re;if(le&&(0,k.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const Y=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Ne._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Ne._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Ne._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,ee,oe),this._createDisposable(Y)}$setWordDefinitions(z){for(const ee of z)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=Ne,Ne._handlePool=0}),define(me[242],ge([0,1,5,15,7,48,17]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class k{constructor(A,n){this._handlePool=0,this._proxy=A.getProxy(m.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,n){await this._proxy.$changeLanguage(A,n);const T=this._documents.getDocumentData(A);if(!T)throw new Error(`document '${A.toString}' NOT found`);return T.document}async tokenAtPosition(A,n){const T=A.version,u=L.Position.from(n),h=await this._proxy.$tokensAtPosition(A.uri,u),c={type:I.StandardTokenType.Other,range:A.getWordRangeAtPosition(n)??new I.Range(n.line,n.character,n.line,n.character)};if(!h)return c;const g={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!g.range.contains(n)||T!==A.version?c:g}createLanguageStatusItem(A){const n=this._handlePool++,T=this._proxy,u={selector:A,text:"",detail:"",severity:I.LanguageStatusSeverity.Information};let h;const c=()=>{h?.dispose(),h=(0,R.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:u.selector,text:u.text,message:typeof u.detail=="string"?u.detail:L.MarkdownString.from(u.detail),severity:u.severity===I.LanguageStatusSeverity.Error?C.default.Error:u.severity===I.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info})},0)},g={get selector(){return u.selector},set selector(_){u.selector=_,c()},get text(){return u.text},set text(_){u.text=_,c()},get detail(){return u.detail},set detail(_){u.detail=_,c()},get severity(){return u.severity},set severity(_){u.severity=_,c()},dispose(){h?.dispose(),T.$removeLanguageStatus(n)}};return c(),g}}e.ExtHostLanguages=k}),define(me[243],ge([0,1,5,12,36]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let R=class{constructor(D,A){this._logService=A,this._proxy=D.getProxy(m.MainContext.MainThreadMessageService)}showMessage(D,A,n,T,u){const h={extension:D};let c;typeof T=="string"||C(T)?c=[T,...u]:(h.modal=T?.modal,h.useCustom=T?.useCustom,h.detail=T?.detail,c=u),h.useCustom&&(0,I.checkProposedApiEnabled)(D);const g=[];for(let _=0;_<c.length;_++){const P=c[_];if(typeof P=="string")g.push({title:P,handle:_,isCloseAffordance:!1});else if(typeof P=="object"){let{title:E,isCloseAffordance:o}=P;g.push({title:E,isCloseAffordance:!!o,handle:_})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(A,n,h,g).then(_=>{if(typeof _=="number")return c[_]})}};R=Ve([xe(1,L.ILogService)],R),e.ExtHostMessageService=R}),define(me[244],ge([0,1,22,3,58,6,23,9,13,2,87,5,15,7,65,219,130]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(o,a,v,t,r){this._textDocumentsAndEditors=v,this._textDocuments=t,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,l=s.cell.handle,f=this._documents.get(i)?.getCell(l);if(f)return f.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const a=this._editors.get(o);if(!a)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(o){for(const[a,v]of this._editors)if(v.apiEditor===o)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,a){const v=this._documents.get(o);if(!v&&!a)throw new Error(`NO notebook document for '${o}'`);return v}_getProviderData(o){const a=this._notebookContentProviders.get(o);if(!a)throw new Error(`NO provider for '${o}'`);return a}registerNotebookContentProvider(o,a,v,t,r){if((0,k.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:o,provider:v});let s;return v.onDidChangeNotebookContentOptions&&(s=v.onDidChangeNotebookContentOptions(()=>{const i=u.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(a,i)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},a,u.NotebookDocumentContentOptions.from(t),P._convertNotebookRegistrationData(o,r)),new h.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(o,a){if(!a)return;const v=a.filenamePattern.map(t=>u.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(a.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:a.displayName,filenamePattern:v,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,a,v){const t=P._notebookStatusBarItemProviderHandlePool++,r=typeof v.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,r,a);let s;return r!==void 0&&(s=v.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(r))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,r),s&&s.dispose()})}async createNotebookDocument(o){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&u.NotebookData.from(o.content)});return A.URI.revive(a)}async openNotebookDocument(o){const a=this._documents.get(o);if(a)return a.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(o),t=this._documents.get(A.URI.revive(v));return(0,D.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(o,a){A.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let v;typeof a=="object"?v={position:u.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(u.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:v={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,v),r=t&&this._editors.get(t)?.apiEditor;if(r)return r;throw t?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,a,v,t){const r=this._notebookStatusBarItemProviders.get(o),s=A.URI.revive(a),i=this._documents.get(s);if(!i||!r)return;const l=i.getCellFromIndex(v);if(!l)return;const d=await r.provideCellStatusBarItems(l.apiCell,t);if(!d)return;const f=new C.DisposableStore,w=this._statusBarCache.add([f]),p=(Array.isArray(d)?d:[d]).map(S=>u.NotebookStatusBarItem.from(S,this._commandsConverter,f));return{cacheId:w,items:p}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,a,v,t,r){if((0,k.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,v),this._notebookProxy.$registerNotebookSerializer(s,{id:o.identifier,location:o.extensionLocation},a,u.NotebookDocumentContentOptions.from(t),P._convertNotebookRegistrationData(o,r)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(o,a,v){const t=this._notebookSerializer.get(o);if(!t)throw new Error("NO serializer found");const r=await t.deserializeNotebook(a.buffer,v);return new c.SerializableObjectWithBuffers(u.NotebookData.from(r))}async $notebookToData(o,a,v){const t=this._notebookSerializer.get(o);if(!t)throw new Error("NO serializer found");const r=await t.serializeNotebook(u.NotebookData.to(a.value),v);return m.VSBuffer.wrap(r)}async $openNotebook(o,a,v,t,r){const{provider:s}=this._getProviderData(o),i=await s.openNotebook(A.URI.revive(a),{backupId:v,untitledDocumentData:t?.buffer},r);return new c.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(u.NotebookCellData.from)})}async $saveNotebook(o,a,v){const t=this.getNotebookDocument(A.URI.revive(a)),{provider:r}=this._getProviderData(o);return await r.saveNotebook(t.apiNotebook,v),!0}async $saveNotebookAs(o,a,v,t){const r=this.getNotebookDocument(A.URI.revive(a)),{provider:s}=this._getProviderData(o);return await s.saveNotebookAs(A.URI.revive(v),r.apiNotebook,t),!0}async $backupNotebook(o,a,v){const t=this.getNotebookDocument(A.URI.revive(a)),r=this._getProviderData(o),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),i=String((0,I.hash)([t.uri.toString(),this._backupIdPool++])),l=A.URI.joinPath(s,i),d=await r.provider.backupNotebook(t.apiNotebook,{destination:l},v);return t.updateBackup(d),d.id}_createExtHostEditor(o,a,v){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const t=new _.ExtHostNotebookEditor(a,this._notebookEditorsProxy,o,v.visibleRanges.map(u.NotebookRange.to),v.selections.map(u.NotebookRange.to),typeof v.viewColumn=="number"?u.ViewColumn.to(v.viewColumn):void 0);this._editors.set(a,t)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const v of o.value.removedDocuments){const t=A.URI.revive(v),r=this._documents.get(t);r&&(r.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===t.toString()&&this._editors.delete(s.id)}if(o.value.addedDocuments){const v=[];for(const t of o.value.addedDocuments){const r=A.URI.revive(t.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(l){s._onDidChangeNotebookCells.fire(l)},emitCellOutputsChange(l){s._onDidChangeCellOutputs.fire(l)},emitCellMetadataChange(l){s._onDidChangeCellMetadata.fire(l)},emitCellExecutionStateChange(l){s._onDidChangeCellExecutionState.fire(l)}},r,t);v.push(...t.cells.map(l=>g.ExtHostCell.asModelAddData(i.apiNotebook,l))),this._documents.get(r)?.dispose(),this._documents.set(r,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(o.value.addedEditors)for(const v of o.value.addedEditors){if(this._editors.has(v.id))return;const t=A.URI.revive(v.documentUri),r=this._documents.get(t);r&&this._createExtHostEditor(r,v.id,v)}const a=[];if(o.value.removedEditors)for(const v of o.value.removedEditors){const t=this._editors.get(v);t&&(this._editors.delete(v),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),a.push(t))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const v=new Set;this._visibleNotebookEditors.forEach(t=>v.add(t.id));for(const t of this._editors.values()){const r=v.has(t.id);t._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(me[245],ge([0,1,3,75,12,5,14,15]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(T,u){const h=D._Keys.nextId();T.$registerNotebookEditorDecorationType(h,k.NotebookDecorationRenderOptions.from(u)),this.value={key:h,dispose(){T.$removeNotebookEditorDecorationType(h)}}}}D._Keys=new L.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(T,u,h){this._logService=T,this._extHostRpc=u,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(T){return new D(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),T).value}$acceptEditorPropertiesChanged(T,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,u);const h=this._notebooksAndEditors.getEditorById(T);u.visibleRanges&&h._acceptVisibleRanges(u.visibleRanges.ranges.map(k.NotebookRange.to)),u.selections&&h._acceptSelections(u.selections.selections.map(k.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const u in T)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(k.ViewColumn.to(T[u]))}};A=Ve([xe(0,I.ILogService),xe(1,R.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(me[246],ge([0,1,20,17,21,3,6,23,2,26,12,5,15,7,89,212,36,65]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(r,s,i,l){this._initData=s,this._extHostNotebook=i,this._logService=l,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(T.MainContext.MainThreadNotebookKernels)}createNotebookController(r,s,i,l,d,f){for(let x of this._kernelData.values())if(x.controller.id===s&&A.ExtensionIdentifier.equals(r.identifier,x.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const w=this._handlePool++,y=this;this._logService.trace(`NotebookController[${w}], CREATED by ${r.identifier.value}, ${s}`);const p=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${r.identifier}'`);let S=!1;const b=new R.DisposableStore,F=new C.Emitter,N=new C.Emitter,G={id:`${r.identifier.value}/${s}`,notebookType:i,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:l||r.identifier.value,preloads:f?f.map(u.NotebookRendererScript.from):[]};let K=d??p,M;this._proxy.$addKernel(w,G).catch(x=>{console.log(x),S=!0});let U=0;const O=()=>{if(S)return;const x=++U;Promise.resolve().then(()=>{x===U&&this._proxy.$updateKernel(w,G)})},$=new k.ResourceMap,B={get id(){return s},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return G.label},set label(x){G.label=x??r.displayName??r.name,O()},get detail(){return G.detail??""},set detail(x){G.detail=x,O()},get description(){return G.description??""},set description(x){G.description=x,O()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(x){G.supportedLanguages=x,O()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(x){G.supportsExecutionOrder=x,O()},get rendererScripts(){return G.preloads?G.preloads.map(u.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(x){K=x??p},get interruptHandler(){return M},set interruptHandler(x){M=x,G.supportsInterrupt=Boolean(x),O()},createNotebookCellExecution(x){if(S)throw new Error("notebook controller is DISPOSED");if(!$.has(x.notebook.uri))throw y._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return y._createNotebookCellExecution(x)},dispose:()=>{S||(this._logService.trace(`NotebookController[${w}], DISPOSED`),S=!0,this._kernelData.delete(w),b.dispose(),F.dispose(),N.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(x,j){y._proxy.$updateNotebookPriority(w,x.uri,j)},onDidReceiveMessage:N.event,postMessage(x,j){return(0,_.checkProposedApiEnabled)(r),y._proxy.$postMessage(w,j&&y._extHostNotebook.getIdByEditor(j),x)},asWebviewUri(x){return(0,_.checkProposedApiEnabled)(r),(0,c.asWebviewUri)(x,y._initData.remote)}};return this._kernelData.set(w,{extensionId:r.identifier,controller:B,onDidReceiveMessage:N,onDidChangeSelection:F,associatedNotebooks:$}),B}$acceptNotebookAssociation(r,s,i){const l=this._kernelData.get(r);if(l){const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(s));i?l.associatedNotebooks.set(d.uri,!0):l.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,d.uri.toString(),i),l.onDidChangeSelection.fire({selected:i,notebook:d.apiNotebook})}}async $executeCells(r,s,i){const l=this._kernelData.get(r);if(!l)return;const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(s)),f=[];for(let w of i){const y=d.getCell(w);y&&f.push(y.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,d.uri.toString(),f.length),await l.controller.executeHandler.call(l.controller,f,d.apiNotebook,l.controller)}catch(w){this._logService.error(`NotebookController[${r}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(r,s,i){const l=this._kernelData.get(r);if(!l)return;const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(s));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,d.apiNotebook);else for(let f of i){const w=d.getCell(f);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,i){const l=this._kernelData.get(r);if(!l)return;const d=this._extHostNotebook.getEditorById(s);l.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:i}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const l=new a(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,l);const d=l.onDidChangeState(()=>{l.state===o.Resolved&&(l.dispose(),d.dispose(),this._activeExecutions.delete(i.uri))});return l.asApiObject()}};E=Ve([xe(3,n.ILogService)],E),e.ExtHostNotebookKernels=E;var o;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(o||(o={}));class a extends R.Disposable{constructor(r,s,i){super();this._document=r,this._cell=s,this._proxy=i,this._handle=a.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new v(10,l=>this.update(l)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new P.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const i=h.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return i===s.items?u.NotebookCellOutput.from(s):u.NotebookCellOutput.from({items:i,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,i){const l=this.cellIndexToHandle(s),d=this.validateAndConvertOutputs((0,m.asArray)(r));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:i,outputs:d})}async updateOutputItems(r,s,i){return r=h.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(r),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(u.NotebookCellOutputItem.from),outputId:s.id,append:i})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(i){r._executionOrder=i,r.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(i){if(r._state===o.Resolved||r._state===o.Started)throw new Error("Cannot call start again");r._state=o.Started,r._onDidChangeState.fire(),r.update({editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:i})},end(i,l){if(r._state===o.Resolved)throw new Error("Cannot call resolve twice");r._state=o.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:g.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:l,lastRunSuccess:i}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(i){return r.verifyStateForOutput(),r.updateOutputs([],i,!1)},appendOutput(i,l){return r.verifyStateForOutput(),r.updateOutputs(i,l,!0)},replaceOutput(i,l){return r.verifyStateForOutput(),r.updateOutputs(i,l,!1)},appendOutputItems(i,l){return r.verifyStateForOutput(),r.updateOutputItems(i,l,!0)},replaceOutputItems(i,l){return r.verifyStateForOutput(),r.updateOutputItems(i,l,!1)}})}}a.HANDLE=0;class v{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}}),define(me[247],ge([0,1,3,5,130]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(k,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,D,A){const n=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(D)?.fire({editor:n.apiEditor,message:A})}createRendererMessaging(k,D){if(!k.contributes?.notebookRenderer?.some(u=>u.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const A=!!k.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(u,h,c)=>{const g=A?u:_=>{const P={};n.set(P,_.editor),u({editor:P,message:_.message})};return this.getOrCreateEmitterFor(D).event(g,h,c)},postMessage:(u,h)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(u)&&([u,h]=[h,u]);const c=A?h:n.get(h),g=c&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(g?.id,D,u)}}}getOrCreateEmitterFor(k){let D=this._rendererMessageEmitters.get(k);return D||(D=new m.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,D),D)}}e.ExtHostNotebookRenderers=C}),define(me[67],ge([0,1,5,3,6,22,4,14]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends I.Disposable{constructor(c,g,_,P,E){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=E,this._id=E.$register(this.name,g,_,P),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?C.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(g=>this._proxy.$clear(g,c))}show(c,g){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof c=="boolean"?c:g)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class A extends D{constructor(c,g,_){super(c,!1,void 0,g,_)}append(c){super.append(c),this._id.then(g=>this._proxy.$append(g,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=A;class n extends D{constructor(c,g,_){super(c,!0,g,void 0,_)}append(c){throw new Error("Not supported")}}class T{constructor(c,g){this.name=c,this._channel=g}append(c){this._channel.then(g=>g.append(c))}appendLine(c){this._channel.then(g=>g.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,g){this._channel.then(_=>_.show(c,g))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=T;let u=class{constructor(c){this._proxy=c.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c,g){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new A(c,g.identifier.value,this._proxy)}createOutputChannelFromLogFile(c,g){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!g)throw new Error("illegal argument `file`. must not be falsy");return new n(c,g,this._proxy)}};u=Ve([xe(0,k.IExtHostRpcService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(me[248],ge([0,1,17,21,3,6,5,2,7,16,20,48,62]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(c,g,_){const P=c.getProxy(R.MainContext.MainThreadQuickOpen);class E{constructor(d,f){this._sessions=new Map,this._instances=0,this._workspace=d,this._commands=f}showQuickPick(d,f,w,y=L.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(d),S=++this._instances,b=P.$show(S,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},y),F={},N=b.then(()=>F);return Promise.race([N,p]).then(G=>{if(G!==F)return p.then(K=>{const M=[];for(let U=0;U<K.length;U++){const O=K[U];let $,B,x,j,H;typeof O=="string"?$=O:($=O.label,B=O.description,x=O.detail,j=O.picked,H=O.alwaysShow),M.push({label:$,description:B,handle:U,detail:x,picked:j,alwaysShow:H})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{w.onDidSelectItem(K[U])}),P.$setItems(S,M),b.then(U=>{if(typeof U=="number")return K[U];if(Array.isArray(U))return U.map(O=>K[O])})})}).then(void 0,G=>{if(!(0,A.isPromiseCanceledError)(G))return P.$setError(S,G),Promise.reject(G)})}$onItemSelected(d){this._onDidSelectItem&&this._onDidSelectItem(d)}showInput(d,f=L.CancellationToken.None){return this._validateInput=d?d.validateInput:void 0,P.$input(d,typeof this._validateInput=="function",f).then(void 0,w=>{if(!(0,A.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(d){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(d)):Promise.resolve(void 0)}async showWorkspaceFolderPick(d,f=L.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!w)return;const y=await this._workspace.getWorkspaceFolders2();if(!!y)return y.find(p=>p.uri.toString()===w.uri.toString())}createQuickPick(d,f){const w=new s(d,f,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(d){const f=new i(d,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(d,f){const w=this._sessions.get(d);w&&w._fireDidChangeValue(f)}$onDidAccept(d){const f=this._sessions.get(d);f&&f._fireDidAccept()}$onDidChangeActive(d,f){const w=this._sessions.get(d);w instanceof s&&w._fireDidChangeActive(f)}$onDidChangeSelection(d,f){const w=this._sessions.get(d);w instanceof s&&w._fireDidChangeSelection(f)}$onDidTriggerButton(d,f){const w=this._sessions.get(d);w&&w._fireDidTriggerButton(f)}$onDidTriggerItemButton(d,f,w){const y=this._sessions.get(d);y instanceof s&&y._fireDidTriggerItemButton(f,w)}$onDidHide(d){const f=this._sessions.get(d);f&&f._fireDidHide()}}class o{constructor(d,f){this._extensionId=d,this._onDidDispose=f,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(d){this._title=d,this.update({title:d})}get step(){return this._steps}set step(d){this._steps=d,this.update({step:d})}get totalSteps(){return this._totalSteps}set totalSteps(d){this._totalSteps=d,this.update({totalSteps:d})}get enabled(){return this._enabled}set enabled(d){this._enabled=d,this.update({enabled:d})}get busy(){return this._busy}set busy(d){this._busy=d,this.update({busy:d})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(d){this._ignoreFocusOut=d,this.update({ignoreFocusOut:d})}get value(){return this._value}set value(d){this._value=d,this.update({value:d})}get placeholder(){return this._placeholder}set placeholder(d){this._placeholder=d,this.update({placeholder:d})}get buttons(){return this._buttons}set buttons(d){this._buttons=d.slice(),this._handlesToButtons.clear(),d.forEach((f,w)=>{const y=f===D.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(y,f)}),this.update({buttons:d.map((f,w)=>({...r(f),tooltip:f.tooltip,handle:f===D.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(d){this._value=d,this._onDidChangeValueEmitter.fire(d)}_fireDidTriggerButton(d){const f=this._handlesToButtons.get(d);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(d){if(!this._disposed){for(const f of Object.keys(d)){const w=d[f];this._pendingUpdate[f]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function a(l){if(l instanceof D.ThemeIcon)return{id:l.id};const d=t(l),f=v(l);return{dark:typeof d=="string"?k.URI.file(d):d,light:typeof f=="string"?k.URI.file(f):f}}function v(l){return typeof l=="object"&&"light"in l?l.light:l}function t(l){return typeof l=="object"&&"dark"in l?l.dark:l}function r(l){const d=a(l.iconPath);let f,w;return"id"in d?w=u.ThemeIcon.asClassName(d):f=d,{iconPath:f,iconClass:w}}class s extends o{constructor(d,f,w){super(d,w);this.enableProposedApi=f,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(d){this._items=d.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),d.forEach((f,w)=>{this._handlesToItems.set(w,f),this._itemsToHandles.set(f,w)}),this.update({items:d.map((f,w)=>({label:f.label,description:f.description,handle:w,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,buttons:f.buttons&&this.enableProposedApi?f.buttons.map((y,p)=>({...r(y),tooltip:y.tooltip,handle:p})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(d){this._canSelectMany=d,this.update({canSelectMany:d})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(d){this._matchOnDescription=d,this.update({matchOnDescription:d})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(d){this._matchOnDetail=d,this.update({matchOnDetail:d})}get sortByLabel(){return this._sortByLabel}set sortByLabel(d){this._sortByLabel=d,this.update({sortByLabel:d})}get activeItems(){return this._activeItems}set activeItems(d){this._activeItems=d.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(d){this._selectedItems=d.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(d){const f=(0,n.coalesce)(d.map(w=>this._handlesToItems.get(w)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(d){const f=(0,n.coalesce)(d.map(w=>this._handlesToItems.get(w)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(d,f){const w=this._handlesToItems.get(d);if(!w||!w.buttons||!w.buttons.length)return;const y=w.buttons[f];y&&this._onDidTriggerItemButtonEmitter.fire({button:y,item:w})}}class i extends o{constructor(d,f){super(d,f);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(d){this._password=d,this.update({password:d})}get prompt(){return this._prompt}set prompt(d){this._prompt=d,this.update({prompt:d})}get validationMessage(){return this._validationMessage}set validationMessage(d){this._validationMessage=d,this.update({validationMessage:d,severity:d?T.default.Error:T.default.Ignore})}}return new E(g,_)}e.createExtHostQuickOpen=h}),define(me[249],ge([0,1,2,3,56,6,17,5,20,100,12,26,36,62,15]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(d){if(d)return typeof d.iconPath=="string"?m.URI.file(d.iconPath):m.URI.isUri(d.iconPath)||h.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function _(d,f){if(!d.iconPath&&!f.iconPath)return 0;if(d.iconPath){if(!f.iconPath)return 1}else return-1;const w=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,y=typeof f.iconPath=="string"?f.iconPath:m.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,A.comparePaths)(w,y)}function P(d,f){let w=0;if(d.strikeThrough!==f.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==f.faded)return d.faded?1:-1;if(d.tooltip!==f.tooltip)return(d.tooltip||"").localeCompare(f.tooltip||"");if(w=_(d,f),w!==0)return w;if(d.light&&f.light)w=_(d.light,f.light);else{if(d.light)return 1;if(f.light)return-1}if(w!==0)return w;if(d.dark&&f.dark)w=_(d.dark,f.dark);else{if(d.dark)return 1;if(f.dark)return-1}return w}function E(d,f){if(d.command!==f.command)return d.command<f.command?-1:1;if(d.title!==f.title)return d.title<f.title?-1:1;if(d.tooltip!==f.tooltip){if(d.tooltip!==void 0&&f.tooltip!==void 0)return d.tooltip<f.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(d.arguments===f.arguments)return 0;if(d.arguments)if(f.arguments){if(d.arguments.length!==f.arguments.length)return d.arguments.length-f.arguments.length}else return 1;else return-1;for(let w=0;w<d.arguments.length;w++){const y=d.arguments[w],p=f.arguments[w];if(y!==p)return y<p?-1:1}return 0}function o(d,f){let w=(0,A.comparePaths)(d.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(w!==0)return w;if(d.command&&f.command)w=E(d.command,f.command);else{if(d.command)return 1;if(f.command)return-1}if(w!==0)return w;if(d.decorations&&f.decorations)w=P(d.decorations,f.decorations);else{if(d.decorations)return 1;if(f.decorations)return-1}return w}function a(d,f){for(let w=0;w<d.length;w++)if(d[w]!==f[w])return!1;return!0}function v(d,f){return d.command===f.command&&d.title===f.title&&d.tooltip===f.tooltip&&(d.arguments&&f.arguments?a(d.arguments,f.arguments):d.arguments===f.arguments)}function t(d,f){return(0,D.equals)(d,f,v)}class r{constructor(f,w,y){this._extension=f,this._proxy=w,this._sourceControlHandle=y,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(f){this._proxy.$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,u.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(f){if((0,u.checkProposedApiEnabled)(this._extension),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,f))}focus(){(0,u.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(f,w){(0,u.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,f,w)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=r;class s{constructor(f,w,y,p,S){this._proxy=f,this._commands=w,this._sourceControlHandle=y,this._id=p,this._label=S,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,w){const y=this._resourceStatesCommandsMap.get(f);return y?(0,R.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(o),y=(0,D.sortedDiff)(this._resourceSnapshot,f,o).map(b=>{const F=b.toInsert.map(N=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,N);const K=N.resourceUri;let M;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const fe=new C.DisposableStore;M=this._commands.converter.toInternal(N.command,fe),this._resourceStatesDisposablesMap.set(G,fe)}else this._resourceStatesCommandsMap.set(G,N.command);const U=g(N.decorations),O=N.decorations&&g(N.decorations.light)||U,$=N.decorations&&g(N.decorations.dark)||U,B=[O,$],x=N.decorations&&N.decorations.tooltip||"",j=N.decorations&&!!N.decorations.strikeThrough,H=N.decorations&&!!N.decorations.faded,X=N.contextValue||"";return{rawResource:[G,K,B,x,j,H,X,M],handle:G}});return{start:b.start,deleteCount:b.deleteCount,toInsert:F}}),p=y.map(({start:b,deleteCount:F,toInsert:N})=>[b,F,N.map(G=>G.rawResource)]),S=y.reverse();for(const{start:b,deleteCount:F,toInsert:N}of S){const G=N.map(M=>M.handle),K=this._handlesSnapshot.splice(b,F,...G);for(const M of K)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=f,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class i{constructor(f,w,y,p,S,b){this._proxy=w,this._commands=y,this._id=p,this._label=S,this._rootUri=b,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(f,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,p,S,b)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,this._proxy.$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,this._proxy.$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=f;const w=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&t(this._statusBarCommands,f))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=f;const w=(f||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(f,w){const y=new s(this._proxy,this._commands,this.handle,f,w),p=L.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,p),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const f=[],w=[];for(const[y,p]of this.createdResourceGroups){p.dispose();const S=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});L.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),S.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),f.push([y.handle,y.id,y.label,y.features]);const b=y._takeResourceStateSnapshot();b.length>0&&w.push([y.handle,b]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,f,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(w=>{const y=w._takeResourceStateSnapshot();y.length!==0&&f.push([w.handle,y])}),f.length>0&&this._proxy.$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let l=class Bn{constructor(f,w,y){this._commands=w,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=f.getProxy(k.MainContext.MainThreadSCM),this._telemetry=f.getProxy(k.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===3){const S=this._sourceControls.get(p.sourceControlHandle);if(!S)return p;const b=S.getResourceGroup(p.groupHandle);return b?b.getResourceState(p.handle):p}else if(p&&p.$mid===4){const S=this._sourceControls.get(p.sourceControlHandle);return S?S.getResourceGroup(p.groupHandle):p}else if(p&&p.$mid===5){const S=this._sourceControls.get(p.handle);return S||p}return p}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,w,y,p){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,w,y,p),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const S=Bn._handlePool++,b=new i(f,this._proxy,this._commands,w,y,p);this._sourceControls.set(S,b);const F=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(b),this._sourceControlsByExtension.set(T.ExtensionIdentifier.toKey(f.identifier),F),b}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const w=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(f.identifier)),y=w&&w[w.length-1];return y&&y.inputBox}$provideOriginalResource(f,w,y){const p=m.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,p.toString());const S=this._sourceControls.get(f);return!S||!S.quickDiffProvider||!S.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>S.quickDiffProvider.provideOriginalResource(p,y)).then(b=>b||null)}$onInputBoxValueChange(f,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const y=this._sourceControls.get(f);return y&&y.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(f,w,y,p){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,w,y);const S=this._sourceControls.get(f);if(!S)return Promise.resolve(void 0);const b=S.getResourceGroup(w);return b?b.$executeResourceCommand(y,p):Promise.resolve(void 0)}$validateInput(f,w,y){this.logService.trace("ExtHostSCM#$validateInput",f);const p=this._sourceControls.get(f);return!p||!p.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>p.inputBox.validateInput(w,y)).then(S=>{if(!S)return Promise.resolve(void 0);const b=c.MarkdownString.fromStrict(S.message);return b?Promise.resolve([b,S.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};l._handlePool=0,l=Ve([xe(2,n.ILogService)],l),e.ExtHostSCM=l});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[250],ge([0,1,7,5,167,6,15]),function(Z,e,m,L,I,C,R){"use strict";var k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(h,c,g,_,P=m.StatusBarAlignment.Left,E){k.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,rt(this,k,h,"f"),rt(this,D,c,"f"),this._entryId=A.ID_GEN++,this._extension=g,this._id=_,this._alignment=P,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!A.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Be(this,D,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Be(this,D,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,k,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let c;this._name?c=this._name:c=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Be(this,k,"f").$setEntry(this._entryId,h,c,this._text,_,this._command?.internal,g,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,k=new WeakMap,D=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const c={message:h};return this._messages.unshift(c),this._update(),new m.Disposable(()=>{const g=this._messages.indexOf(c);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(h,c){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new n(this)}createStatusBarEntry(h,c,g,_){return new A(this._proxy,this._commands,h,c,g,_)}setStatusBarMessage(h,c){const g=this._statusMessage.setMessage(h);let _;return typeof c=="number"?_=setTimeout(()=>g.dispose(),c):typeof c!="undefined"&&c.then(()=>g.dispose(),()=>g.dispose()),new m.Disposable(()=>{g.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=T}),define(me[93],ge([0,1,5,3,4]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,A){return this._proxy.$getValue(k,D).then(n=>n||A)}setValue(k,D,A){return this._proxy.$setValue(k,D,A)}$acceptValue(k,D,A){this._onDidChangeStorage.fire({shared:k,key:D,value:A})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(me[68],ge([0,1,4,27,12,92,2]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(A,n,T){this._logService=n,this._extHostFileSystem=T,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(A){return R.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,n=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(T){this._logService.error("[ExtHostStorage]",T);return}}workspaceValue(A){if(this._value)return R.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return R.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([xe(0,L.IExtHostInitDataService),xe(1,I.ILogService),xe(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(me[33],ge([0,1,3,5,4,2,14,6,7,168,16,214,21,32,195,62,13]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class P{constructor(l,d,f,w){this._proxy=l,this._id=d,this._creationOptions=f,this._name=w,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(p=>this._pidPromiseComplete=p);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(p,S=!0){y._checkDisposed(),y._proxy.$sendText(y._id,p,S)},show(p){y._checkDisposed(),y._proxy.$show(y._id,p)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(l,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,_.withNullAsUndefined)(l.shellPath),shellArgs:(0,_.withNullAsUndefined)(l.shellArgs),cwd:(0,_.withNullAsUndefined)(l.cwd),env:(0,_.withNullAsUndefined)(l.env),icon:(0,_.withNullAsUndefined)(r(l.iconPath)),color:g.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,_.withNullAsUndefined)(l.message),strictEnv:(0,_.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(l.location,d?.resolvedExtHostIdentifier,d?.location)})}async createExtensionTerminal(l,d,f,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:g.ThemeColor.isThemeColor(w)?w.id:void 0,location:this._serializeParentTerminal(l,d)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,d,f){return typeof l=="object"&&"parentTerminal"in l?d?{parentTerminal:d}:void 0:(f&&(l=f),l)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,d){return l===this._cols&&d===this._rows||l===0||d===0?!1:(this._cols=l,this._rows=d,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=P;class E{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,d){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:d})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let o=1,a=class extends k.Disposable{constructor(l,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[f,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,d){const f=new P(this._proxy,(0,h.generateUuid)(),l,l.name),w=new E(l.pty);return f.createExtensionTerminal(this._resolveLocation(l.location),d?.resolvedExtHostIdentifier,r(l.iconPath),s(l.color)).then(y=>{const p=this._setupExtHostProcessListeners(y,w);this._terminalProcessDisposables[y]=p}),this._terminals.push(f),f.value}_resolveLocation(l){if(!(typeof l=="object"&&"parentTerminal"in l))return l}attachPtyToTerminal(l,d){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const w=new E(d),y=this._setupExtHostProcessListeners(l,w);this._terminalProcessDisposables[l]=y}async $acceptActiveTerminalChanged(l){const d=this._activeTerminal;if(l===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(l);f&&(this._activeTerminal=f,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,d){const f=this._getTerminalById(l);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:d})}async $acceptTerminalDimensions(l,d,f){const w=this._getTerminalById(l);w&&w.setDimensions(d,f)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(l,d,f){this._terminalProcesses.get(l)?.resize(d,f)}async $acceptTerminalTitleChange(l,d){const f=this._getTerminalById(l);f&&(f.name=d)}async $acceptTerminalClosed(l,d){const f=this._getTerminalObjectIndexById(this._terminals,l);if(f!==null){const w=this._terminals.splice(f,1)[0];w.setExitCode(d),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(l,d,f,w){if(d){const S=this._getTerminalObjectIndexById(this._terminals,d);if(S!==null){this._terminals[S]._id=l,this._onDidOpenTerminal.fire(this.terminals[S]),this._terminals[S].isOpen=!0;return}}const y={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:C.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},p=new P(this._proxy,l,y,f);this._terminals.push(p),this._onDidOpenTerminal.fire(p.value),p.isOpen=!0}async $acceptTerminalProcessId(l,d){const f=this._getTerminalById(l);f&&f._setProcessId(d)}async $startExtensionTerminal(l,d){const f=this._getTerminalById(l);if(!f)return{message:(0,A.localize)(0,null,l)};f.isOpen||await new Promise(y=>{const p=this.onDidOpenTerminal(async S=>{S===f.value&&(p.dispose(),y())})});const w=this._terminalProcesses.get(l);w?w.startSendingEvents(d):this._extensionTerminalAwaitingStart[l]={initialDimensions:d}}_setupExtHostProcessListeners(l,d){const f=new k.DisposableStore;f.add(d.onProcessReady(y=>this._proxy.$sendProcessReady(l,y.pid,y.cwd))),f.add(d.onProcessTitleChanged(y=>this._proxy.$sendProcessTitle(l,y))),this._bufferer.startBuffering(l,d.onProcessData),f.add(d.onProcessExit(y=>this._onProcessExit(l,y))),d.onProcessOverrideDimensions&&f.add(d.onProcessOverrideDimensions(y=>this._proxy.$sendOverrideDimensions(l,y))),this._terminalProcesses.set(l,d);const w=this._extensionTerminalAwaitingStart[l];return w&&d instanceof E&&(d.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),f}$acceptProcessAckDataEvent(l,d){this._terminalProcesses.get(l)?.acknowledgeDataEvent(d)}$acceptProcessInput(l,d){this._terminalProcesses.get(l)?.input(d)}$acceptTerminalInteraction(l){const d=this._getTerminalById(l);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(l,d,f){try{this._terminalProcesses.get(l)?.resize(d,f)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(l,d){this._terminalProcesses.get(l)?.shutdown(d)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(l,d))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(d=>this._proxy.$sendProcessCwd(l,d))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,d,f){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,f),this._proxy.$registerProfileProvider(d,l.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(l,d){const f=new u.CancellationTokenSource().token,w=await this._profileProviders.get(l)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,d);return}this.createTerminalFromOptions(w.options,d)}}async $provideLinks(l,d){const f=this._getTerminalById(l);if(!f)return[];this._terminalLinkCache.delete(l);const w=this._terminalLinkCancellationSource.get(l);w&&w.dispose(!0);const y=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,y);const p=[],S={terminal:f.value,line:d},b=[];for(const G of this._linkProviders)b.push(new Promise(async K=>{y.token.onCancellationRequested(()=>K({provider:G,links:[]}));const M=await G.provideTerminalLinks(S,y.token)||[];y.token.isCancellationRequested||K({provider:G,links:M})}));const F=await Promise.all(b);if(y.token.isCancellationRequested)return[];const N=new Map;for(const G of F)G&&G.links.length>0&&p.push(...G.links.map(K=>{const M={id:o++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return N.set(M.id,{provider:G.provider,link:K}),M}));return this._terminalLinkCache.set(l,N),p}$activateLink(l,d){const f=this._terminalLinkCache.get(l)?.get(d);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(l,d){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const f=this._terminalProcessDisposables[l];f&&(f.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,d)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,d){const f=this._getTerminalObjectIndexById(l,d);return f!==null?l[f]:null}_getTerminalObjectIndexById(l,d){let f=null;return l.some((w,y)=>w._id===d?(f=y,!0):!1),f}getEnvironmentVariableCollection(l){let d=this._environmentVariableCollections.get(l.identifier.value);return d||(d=new v,this._setEnvironmentVariableCollection(l.identifier.value,d)),d}_syncEnvironmentVariableCollection(l,d){const f=(0,T.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(l,d.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(l){l.forEach(d=>{const f=d[0],w=new v(d[1]);this._setEnvironmentVariableCollection(f,w)})}$acceptDefaultProfile(l,d){this._defaultProfile=l,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(l,d){this._environmentVariableCollections.set(l,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,d)})}};a=Ve([xe(1,R.IExtHostRpcService)],a),e.BaseExtHostTerminalService=a;class v{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,d){this._setIfDiffers(l,{value:d,type:D.EnvironmentVariableMutatorType.Replace})}append(l,d){this._setIfDiffers(l,{value:d,type:D.EnvironmentVariableMutatorType.Append})}prepend(l,d){this._setIfDiffers(l,{value:d,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,d){const f=this.map.get(l);(!f||f.value!==d.value||f.type!==d.type)&&(this.map.set(l,d),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,d){this.map.forEach((f,w)=>l.call(d,w,f,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends a{constructor(l){super(!1,l)}createTerminal(l,d,f){throw new n.NotSupportedError}createTerminalFromOptions(l,d){throw new n.NotSupportedError}};t=Ve([xe(0,R.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function s(i){return g.ThemeColor.isThemeColor(i)?i:void 0}});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[251],ge([0,1,22,21,3,74,58,76,6,25,13,32,5,14,88,15,7,222,128,90]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(b,F){this.resultsChangedEmitter=new I.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=b.getProxy(u.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new r(this.proxy),F.registerArgumentProcessor({processArgument:N=>N?.$mid===13?g.TestItem.toItemFromContext(N):N})}createTestController(b,F){if(this.controllers.has(b))throw new Error(`Attempt to insert a duplicate controller with ID "${b}"`);const N=new D.DisposableStore,G=N.add(new P.SingleUseTestCollection(b));G.root.label=F;const K=new Map,M=this.proxy,U={items:G.root.children,get label(){return F},set label($){F=$,G.root.label=$,M.$updateControllerLabel(b,F)},get id(){return b},createRunProfile:($,B,x,j,H)=>{let X=(0,R.hash)($);for(;K.has(X);)X++;const J=new y(this.proxy,b,X,$,B,x,j,H);return K.set(X,J),J},createTestItem($,B,x){return new c.TestItemImpl(b,$,B,x)},createTestRun:($,B,x=!0)=>this.runTracker.createTestRun(b,G,$,B,x),set resolveHandler($){G.resolveHandler=$},get resolveHandler(){return G.resolveHandler},dispose:()=>{N.dispose()}};U.createRunConfiguration=U.createRunProfile,M.$registerTestController(b,F),N.add((0,D.toDisposable)(()=>M.$unregisterTestController(b)));const O={controller:U,collection:G,profiles:K};return this.controllers.set(b,O),N.add((0,D.toDisposable)(()=>this.controllers.delete(b))),N.add(G.onDidGenerateDiff($=>M.$publishDiff(b,$))),U}createTestObserver(){return this.observer.checkout()}async runTests(b,F=L.CancellationToken.None){const N=s(b);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const G=this.controllers.get(N.controllerId);if(!G)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:b.include?.map(K=>K.id)??[G.collection.root.id],profileGroup:p[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:b.exclude?.map(K=>K.id)},F)}$provideFileCoverage(b,F,N){return k.Iterable.find(this.runTracker.trackers,G=>G.id===b)?.getCoverage(F)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(b,F,N,G){return k.Iterable.find(this.runTracker.trackers,K=>K.id===b)?.getCoverage(F)?.resolveFileCoverage(N,G)??Promise.resolve([])}$configureRunProfile(b,F){this.controllers.get(b)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(b){this.results=Object.freeze(b.map(F=>(0,A.deepFreeze)(g.TestResults.to(F))).concat(this.results).sort((F,N)=>N.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(b,F){const N=this.controllers.get(o.TestId.fromString(b).controllerId)?.collection;N&&(await N.expand(b,F<0?Infinity:F),N.flushDiff())}$acceptDiff(b){this.observer.applyDiff(b)}async $runControllerTests(b,F){const N=this.controllers.get(b.controllerId);if(!N)return;const{collection:G,profiles:K}=N,M=K.get(b.profileId);if(!M)return;const U=b.testIds.map(x=>G.tree.get(x)).filter(n.isDefined),O=b.excludeExtIds.map(x=>N.collection.tree.get(x)).filter(n.isDefined).filter(x=>U.some(j=>j.fullId.compare(x.fullId)===2));if(!U.length)return;const $=new _.TestRunRequest(U.some(x=>x.actual instanceof c.TestItemRootImpl)?void 0:U.map(x=>x.actual),O.map(x=>x.actual),M),B=this.runTracker.prepareForMainThreadTestRun($,i.fromInternal(b,N.collection),F);try{await M.runHandler($,F)}finally{B.isRunning&&!F.isCancellationRequested&&await I.Event.toPromise(B.onEnd),this.runTracker.cancelRunById(b.runId)}}$cancelExtensionTestRun(b){b===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(b)}};v=Ve([xe(0,h.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends D.Disposable{constructor(b,F,N){super();this.dto=b,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new I.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:G}of this.tasks.values())G.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(b){return this.tasks.get(b)?.coverage}createRun(b){const F=this.dto.id,N=this.dto.controllerId,G=(0,T.generateUuid)(),K=new l(this.proxy,F,G),M=$=>(B,...x)=>{if(U){console.warn(`Setting the state of test "${B.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(B)||(this.ensureTestIsKnown(B),$(B,...x))};let U=!1;const O={isPersisted:this.dto.isPersisted,token:this.cts.token,name:b,get coverageProvider(){return K.coverageProvider},set coverageProvider($){K.coverageProvider=$},enqueued:M($=>{this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem($,N).toString(),1)}),skipped:M($=>{this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem($,N).toString(),5)}),started:M($=>{this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem($,N).toString(),2)}),errored:M(($,B,x)=>{this.proxy.$appendTestMessagesInRun(F,G,o.TestId.fromExtHostTestItem($,N).toString(),B instanceof Array?B.map(g.TestMessage.from):[g.TestMessage.from(B)]),this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem($,N).toString(),6,x)}),failed:M(($,B,x)=>{this.proxy.$appendTestMessagesInRun(F,G,o.TestId.fromExtHostTestItem($,N).toString(),B instanceof Array?B.map(g.TestMessage.from):[g.TestMessage.from(B)]),this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem($,N).toString(),4,x)}),passed:M(($,B)=>{this.proxy.$updateTestStateInRun(F,G,o.TestId.fromExtHostTestItem($,this.dto.controllerId).toString(),3,B)}),appendOutput:($,B,x)=>{U||(x&&(this.dto.isIncluded(x)?this.ensureTestIsKnown(x):x=void 0),this.proxy.$appendOutputToRun(F,G,m.VSBuffer.fromString($),B&&g.location.from(B),x&&o.TestId.fromExtHostTestItem(x,N).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(F,G),this.tasks.delete(G),this.isRunning||this.dispose())}};return this.tasks.set(G,{run:O,coverage:K}),this.proxy.$startedTestRunTask(F,{id:G,name:b,running:!0}),O}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(b){if(!(b instanceof c.TestItemImpl))throw new c.InvalidTestItemError(b.id);if(this.sharedTestIds.has(b.id))return;const F=[];for(;F.unshift(g.TestItem.from(b)),!(this.sharedTestIds.has(b.id)||(this.sharedTestIds.add(b.id),!b.parent));)b=b.parent;const N=this.dto.colllection.root;this.sharedTestIds.has(N.id)||(this.sharedTestIds.add(N.id),F.unshift(g.TestItem.from(N))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class r{constructor(b){this.proxy=b,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(b,F,N){return this.getTracker(b,F,N)}cancelRunById(b){for(const F of this.tracked.values())if(F.id===b){F.dispose();return}}cancelAllRuns(){for(const b of this.tracked.values())b.dispose()}createTestRun(b,F,N,G,K){const M=this.tracked.get(N);if(M)return M.createRun(G);const U=i.fromPublic(b,F,N,K),O=s(N);this.proxy.$startedExtensionTestRun({controllerId:b,profile:O&&{group:p[O.kind],id:O.profileId},exclude:N.exclude?.map(B=>B.id)??[],id:U.id,include:N.include?.map(B=>B.id)??[F.root.id],persist:K});const $=this.getTracker(N,U);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),$.createRun(G)}getTracker(b,F,N){const G=new t(F,this.proxy,N);return this.tracked.set(b,G),G.onEnd(()=>this.tracked.delete(b)),G}}e.TestRunCoordinator=r;const s=S=>{if(!!S.profile){if(!(S.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class i{constructor(b,F,N,G,K,M){this.controllerId=b,this.id=F,this.isPersisted=K,this.colllection=M,this.includePrefix=N.map(U=>U+"\0"),this.excludePrefix=G.map(U=>U+"\0")}static fromPublic(b,F,N,G){return new i(b,(0,T.generateUuid)(),N.include?.map(K=>o.TestId.fromExtHostTestItem(K,b).toString())??[b],N.exclude?.map(K=>o.TestId.fromExtHostTestItem(K,b).toString())??[],G,F)}static fromInternal(b,F){return new i(b.controllerId,b.runId,b.testIds,b.excludeExtIds,!0,F)}isIncluded(b){const F=o.TestId.fromExtHostTestItem(b,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(F===N||F.startsWith(N))return!1;for(const N of this.includePrefix)if(F===N||F.startsWith(N))return!0;return!1}}e.TestRunDto=i;class l{constructor(b,F,N){this.proxy=b,this.runId=F,this.taskId=N}set coverageProvider(b){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!b||(this._coverageProvider=b,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(b){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(b))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(b,F){const N=await this.fileCoverage;let G=N?.[b];return!this._coverageProvider||!N||!G?[]:(G.detailedCoverage||(G=N[b]=await this._coverageProvider.resolveFileCoverage?.(G,F)??G),G.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class d extends E.IncrementalChangeCollector{constructor(b){super();this.emitter=b,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(b){this.added.add(b)}update(b){Object.assign(b.revived,g.TestItem.toPlain(b.item)),this.added.has(b)||this.updated.add(b)}remove(b){if(this.added.has(b)){this.added.delete(b);return}if(this.updated.delete(b),b.parent&&this.alreadyRemoved.has(b.parent)){this.alreadyRemoved.add(b.item.extId);return}this.removed.add(b)}getChangeEvent(){const{added:b,updated:F,removed:N}=this;return{get added(){return[...b].map(G=>G.revived)},get updated(){return[...F].map(G=>G.revived)},get removed(){return[...N].map(G=>G.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class f extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new I.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(b){return this.items.get(b)}getMirroredTestDataByReference(b){return this.items.get(b.id)}createItem(b,F){return{...b,revived:g.TestItem.toPlain(b.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=f;class w{constructor(b){this.proxy=b}checkout(){this.current||(this.current=this.createObserverData());const b=this.current;return b.observers++,{onDidChangeTest:b.tests.onDidChangeTests,get tests(){return[...b.tests.rootTests].map(F=>F.revived)},dispose:(0,C.once)(()=>{--b.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(b){return this.current?.tests.getMirroredTestDataByReference(b)}applyDiff(b){this.current?.tests.apply(b)}createObserverData(){const b=new f;return this.proxy.$subscribeToDiffs(),{observers:0,tests:b}}}class y{constructor(b,F,N,G,K,M,U=!1,O=void 0){this.controllerId=F,this.profileId=N,this._label=G,this.kind=K,this.runHandler=M,this._isDefault=U,this._tag=O,a.set(this,void 0),rt(this,a,b,"f");const $=p[K];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Be(this,a,"f").$publishTestRunProfile({profileId:N,controllerId:F,tag:O?g.TestTag.namespace(this.controllerId,O.id):null,label:G,group:$,isDefault:U,hasConfigurationHandler:!1})}get label(){return this._label}set label(b){b!==this._label&&(this._label=b,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:b}))}get isDefault(){return this._isDefault}set isDefault(b){b!==this._isDefault&&(this._isDefault=b,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:b}))}get tag(){return this._tag}set tag(b){b?.id!==this._tag?.id&&(this._tag=b,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:b?g.TestTag.namespace(this.controllerId,b.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(b){b!==this._configureHandler&&(this._configureHandler=b,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!b}))}dispose(){Be(this,a,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=y,a=new WeakMap;const p={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[252],ge([0,1,3,20,5,131,15,7]),function(Z,e,m,L,I,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(n,T){this._extHostDocumentsAndEditors=T,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const T=this._extHostDocumentsAndEditors.allEditors();return n?T:T.map(u=>u.value)}async showTextDocument(n,T,u){let h;typeof T=="number"?h={position:R.ViewColumn.from(T),preserveFocus:u}:typeof T=="object"?h={position:R.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?R.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:h={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(n.uri,h),g=c&&this._extHostDocumentsAndEditors.getEditor(c);if(g)return g.value;throw c?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,T){return new C.TextEditorDecorationType(this._proxy,n,T).value}$acceptEditorPropertiesChanged(n,T){const u=this._extHostDocumentsAndEditors.getEditor(n);if(!u)throw new Error("unknown text editor");if(T.options&&u._acceptOptions(T.options),T.selections){const h=T.selections.selections.map(R.Selection.to);u._acceptSelections(h)}if(T.visibleRanges){const h=L.coalesce(T.visibleRanges.map(R.Range.to));u._acceptVisibleRanges(h)}if(T.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...T.options,lineNumbers:R.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const h=k.TextEditorSelectionChangeKind.fromValue(T.selections.source),c=T.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:c,kind:h})}if(T.visibleRanges){const h=L.coalesce(T.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const T in n){const u=this._extHostDocumentsAndEditors.getEditor(T);if(!u)throw new Error("Unknown text editor");const h=R.ViewColumn.to(n[T]);u.value.viewColumn!==h&&(u._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=D}),define(me[253],ge([0,1,2,4,5,6,7]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(n,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(I.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const h=u.uri===void 0?void 0:m.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(D(h))?.get(u.handle)}return u}})}async $getTimeline(n,T,u,h,c){return this._providers.get(n)?.provideTimeline(m.URI.revive(T),u,h,c)}registerTimelineProvider(n,T,u,h){const c=new C.DisposableStore,g=this.convertTimelineItem(T.id,h,c).bind(this);let _;T.onDidChange&&(_=T.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:T.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:n,onDidChange:void 0,async provideTimeline(E,o,a,v){v?.resetCache&&(c.clear(),P.get(T.id)?.clear());const t=await T.provideTimeline(E,o,a);if(t==null)return;const r=g(E,v);return{...t,source:T.id,items:t.items.map(r)}},dispose(){for(const E of P.values())E.get(T.id)?.clear();_?.dispose(),c.dispose()}})}convertTimelineItem(n,T,u){return(h,c)=>{let g;if(c?.cacheResults){let _=this._itemsBySourceAndUriMap.get(n);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(n,_));const P=D(h);g=_.get(P),g===void 0&&(g=new Map,_.set(P,g))}return _=>{const{iconPath:P,...E}=_,o=`${n}|${_.id??_.timestamp}`;g?.set(o,_);let a,v,t;return _.iconPath&&(P instanceof R.ThemeIcon?t={id:P.id,color:P.color}:m.URI.isUri(P)?(a=P,v=P):{light:a,dark:v}=P),{...E,id:E.id??void 0,handle:o,source:n,command:_.command?T.toInternal(_.command,u):void 0,icon:a,iconDark:v,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,C.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=k;function D(A){return A?.toString()}}),define(me[254],ge([0,1,6,10,2,5]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(D){this._openers=new Map,this._proxy=D.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,A,n,T){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const u=T.schemes.find(h=>!R.supportedSchemes.has(h));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,n),this._proxy.$registerUriOpener(A,T.schemes,D,T.label),(0,m.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(D,A,n){const T=this._openers.get(D);if(!T)throw new Error(`Unknown opener with id: ${D}`);const u=I.URI.revive(A);return T.canOpenExternalUri(u,n)}async $openUri(D,A,n){const T=this._openers.get(D);if(!T)throw new Error(`Unknown opener id: '${D}'`);return T.openExternalUri(I.URI.revive(A.resolvedUri),{sourceUri:I.URI.revive(A.sourceUri)},n)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[255],ge([0,1,5,2,6,16,26]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(A,n){if(this.handles.has(R.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const T=k.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(A)),this.handlers.set(T,n),this._proxy.$registerUriHandler(T,A),(0,I.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(A)),this.handlers.delete(T),this._proxy.$unregisterUriHandler(T)})}$handleExternalUri(A,n){const T=this.handlers.get(A);if(!T)return Promise.resolve(void 0);try{T.handleUri(L.URI.revive(n))}catch(u){(0,C.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(A){return L.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=k,k.HandlePool=0});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[69],ge([0,1,3,2,180,204,89,5]),function(Z,e,m,L,I,C,R,k){"use strict";var D,A,n,T,u,h,c,g,_,P,E,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(f,w,y,p,S,b,F){D.set(this,void 0),A.set(this,void 0),n.set(this,void 0),T.set(this,void 0),u.set(this,void 0),h.set(this,void 0),c.set(this,""),g.set(this,void 0),_.set(this,!1),P.set(this,!1),E.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new m.Emitter),this._onDidDispose=Be(this,o,"f").event,rt(this,D,f,"f"),rt(this,A,w,"f"),rt(this,g,y,"f"),rt(this,T,p,"f"),rt(this,u,S,"f"),rt(this,h,b,"f"),rt(this,E,v(b),"f"),rt(this,n,F,"f")}dispose(){rt(this,_,!0,"f"),Be(this,o,"f").fire(),Be(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return rt(this,P,!0,"f"),(0,R.asWebviewUri)(f,Be(this,T,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,c,"f")}set html(f){this.assertNotDisposed(),Be(this,c,"f")!==f&&(rt(this,c,f,"f"),!Be(this,P,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(rt(this,P,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,A,"f").$setHtml(Be(this,D,"f"),f))}get options(){return this.assertNotDisposed(),Be(this,g,"f")}set options(f){this.assertNotDisposed(),Be(this,A,"f").$setOptions(Be(this,D,"f"),s(Be(this,h,"f"),Be(this,u,"f"),f)),rt(this,g,f,"f")}async postMessage(f){if(Be(this,_,"f"))return!1;const w=(0,C.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Be(this,E,"f")});return Be(this,A,"f").$postMessage(Be(this,D,"f"),w.message,...w.buffers)}assertNotDisposed(){if(Be(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=a,D=new WeakMap,A=new WeakMap,n=new WeakMap,T=new WeakMap,u=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap,_=new WeakMap,P=new WeakMap,E=new WeakMap,o=new WeakMap;function v(d){try{const f=(0,I.normalizeVersion)((0,I.parseVersion)(d.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(f,w,y,p,S){this.initData=w,this.workspace=y,this._logService=p,this._deprecationService=S,this._webviews=new Map,this._webviewProxy=f.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(f,w,...y){const p=this.getWebview(f);if(p){const{message:S}=(0,C.deserializeWebviewMessage)(w,y);p._onMessageEmitter.fire(S)}}$onMissingCsp(f,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,w,y){const p=new a(f,this._webviewProxy,i(w),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(f,p),p._onDidDispose(()=>{this._webviews.delete(f)}),p}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=t;function r(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=r;function s(d,f,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||l(d,f)}}e.serializeWebviewOptions=s;function i(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(f=>L.URI.from(f))}}e.reviveOptions=i;function l(d,f){return[...(f?.getWorkspaceFolders()||[]).map(w=>w.uri),d.extensionLocation]}}),define(me[256],ge([0,1,21,58,6,10,24,2,15,69,87,5,7]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=a(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class c{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const l=new h(r,s);return this._documents.set(i,l),l}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var g;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(g||(g={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:i}),new u.Disposable(()=>this._providers.delete(r))}}class P{constructor(t,r,s,i,l){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=l,this._editorProviders=new _,this._documents=new c,this._proxy=t.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,i){const l=new I.DisposableStore;return E(s)?(l.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&l.add(s.onDidChangeCustomDocument(d=>{const f=this.getCustomDocumentEntry(r,d.document.uri);if(o(d)){const w=f.addEdit(d);this._proxy.$onDidEdit(d.document.uri,r,w,d.label)}else this._proxy.$onContentChange(d.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(t))),u.Disposable.from(l,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,i,l){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${r}'`);const f=k.URI.revive(t),w=await d.provider.openCustomDocument(f,{backupId:s,untitledDocumentData:i?.buffer},l);let y;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(r,w,y),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=k.URI.revive(t),{document:l}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,l),l.dispose()}async $resolveWebviewEditor(t,r,s,i,l,d){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);const w=D.ViewColumn.to(l),y=this._extHostWebview.createNewWebview(r,i.webviewOptions,f.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(r,s,i.title,w,i.panelOptions,y),S=k.URI.revive(t);switch(f.type){case 1:{const{document:b}=this.getCustomDocumentEntry(s,S);return f.provider.resolveCustomEditor(b,p,d)}case 0:{const b=this._extHostDocuments.getDocument(S);return f.provider.resolveCustomTextEditor(b,p,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const d=k.URI.revive(r),f=this._extHostDocuments.getDocument(d);await i.provider.moveCustomTextEditor(f,l,m.CancellationToken.None)}async $undo(t,r,s,i){return this.getCustomDocumentEntry(r,t).undo(s,i)}async $redo(t,r,s,i){return this.getCustomDocumentEntry(r,t).redo(s,i)}async $revert(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,r,s,i){const l=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(l.document,k.URI.revive(s),i)}async $backup(t,r,s){const i=this.getCustomDocumentEntry(r,t),d=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(d),d.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,k.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function E(v){return typeof v.resolveCustomTextEditor=="function"}function o(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function a(v){const t=v.scheme===C.Schemas.file||v.scheme===C.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(t)+""}});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[257],ge([0,1,3,6,2,32,15,69,5,7]),function(Z,e,m,L,I,C,R,k,D,A){"use strict";var n,T,u,h,c,g,_,P,E,o,a,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends L.Disposable{constructor(d,f,w,y,p,S,b){super();n.set(this,void 0),T.set(this,void 0),u.set(this,void 0),h.set(this,void 0),c.set(this,void 0),g.set(this,void 0),_.set(this,void 0),P.set(this,void 0),E.set(this,!0),o.set(this,!0),a.set(this,!1),v.set(this,this._register(new m.Emitter)),this.onDidDispose=Be(this,v,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,rt(this,n,d,"f"),rt(this,T,f,"f"),rt(this,u,w,"f"),rt(this,c,S,"f"),rt(this,P,p,"f"),rt(this,g,y,"f"),rt(this,h,b,"f")}dispose(){Be(this,a,"f")||(rt(this,a,!0,"f"),Be(this,v,"f").fire(),Be(this,T,"f").$disposeWebview(Be(this,n,"f")),Be(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,h,"f")}get viewType(){return this.assertNotDisposed(),Be(this,u,"f")}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(d){this.assertNotDisposed(),Be(this,g,"f")!==d&&(rt(this,g,d,"f"),Be(this,T,"f").$setTitle(Be(this,n,"f"),d))}get iconPath(){return this.assertNotDisposed(),Be(this,_,"f")}set iconPath(d){this.assertNotDisposed(),Be(this,_,"f")!==d&&(rt(this,_,d,"f"),Be(this,T,"f").$setIconPath(Be(this,n,"f"),I.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Be(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,P,"f")=="number"&&Be(this,P,"f")<0))return Be(this,P,"f")}get active(){return this.assertNotDisposed(),Be(this,o,"f")}get visible(){return this.assertNotDisposed(),Be(this,E,"f")}_updateViewState(d){Be(this,a,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(rt(this,o,d.active,"f"),rt(this,E,d.visible,"f"),rt(this,P,d.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(d,f){this.assertNotDisposed(),Be(this,T,"f").$reveal(Be(this,n,"f"),{viewColumn:d?R.ViewColumn.from(d):void 0,preserveFocus:!!f})}assertNotDisposed(){if(Be(this,a,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,T=new WeakMap,u=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap,_=new WeakMap,P=new WeakMap,E=new WeakMap,o=new WeakMap,a=new WeakMap,v=new WeakMap,t=new WeakMap;class s{constructor(d,f,w){this.webviews=f,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,f,w,y,p={}){const S=typeof y=="object"?y.viewColumn:y,b={viewColumn:R.ViewColumn.from(S),preserveFocus:typeof y=="object"&&!!y.preserveFocus},F=(0,k.shouldSerializeBuffersForPostMessage)(d),N=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(d),N,f,{title:w,panelOptions:i(p),webviewOptions:(0,k.serializeWebviewOptions)(d,this.workspace,p),serializeBuffersForPostMessage:F},b);const G=this.webviews.createNewWebview(N,p,d);return this.createNewWebviewPanel(N,f,w,S,p,G)}$onDidChangeWebviewPanelViewStates(d){const f=Object.keys(d);f.sort((w,y)=>{const p=d[w],S=d[y];return p.active?1:S.active?-1:+p.visible-+S.visible});for(const w of f){const y=this.getWebviewPanel(w);if(!y)continue;const p=d[w];y._updateViewState({active:p.active,visible:p.visible,viewColumn:R.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,f,w){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:w,extension:d}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(d)}),new A.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(d,f,w,y){const p=this._serializers.get(f);if(!p)throw new Error(`No serializer found for '${f}'`);const{serializer:S,extension:b}=p,F=this.webviews.createNewWebview(d,w.webviewOptions,b),N=this.createNewWebviewPanel(d,f,w.title,y,w.panelOptions,F);await S.deserializeWebviewPanel(N,w.state)}createNewWebviewPanel(d,f,w,y,p,S){const b=new r(d,this._proxy,f,w,y,p,S);return this._webviewPanels.set(d,b),b}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=s;function i(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[258],ge([0,1,3,6,69,5,7]),function(Z,e,m,L,I,C,R){"use strict";var k,D,A,n,T,u,h,c,g,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(a,v,t,r,s,i){super();k.set(this,void 0),D.set(this,void 0),A.set(this,void 0),n.set(this,void 0),T.set(this,!1),u.set(this,void 0),h.set(this,void 0),c.set(this,void 0),g.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Be(this,g,"f").event,_.set(this,this._register(new m.Emitter)),this.onDidDispose=Be(this,_,"f").event,rt(this,A,t,"f"),rt(this,h,r,"f"),rt(this,k,a,"f"),rt(this,D,v,"f"),rt(this,n,s,"f"),rt(this,u,i,"f")}dispose(){Be(this,T,"f")||(rt(this,T,!0,"f"),Be(this,_,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(a){this.assertNotDisposed(),Be(this,h,"f")!==a&&(rt(this,h,a,"f"),Be(this,D,"f").$setWebviewViewTitle(Be(this,k,"f"),a))}get description(){return this.assertNotDisposed(),Be(this,c,"f")}set description(a){this.assertNotDisposed(),Be(this,c,"f")!==a&&(rt(this,c,a,"f"),Be(this,D,"f").$setWebviewViewDescription(Be(this,k,"f"),a))}get visible(){return Be(this,u,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,A,"f")}_setVisible(a){a===Be(this,u,"f")||Be(this,T,"f")||(rt(this,u,a,"f"),Be(this,g,"f").fire())}show(a){this.assertNotDisposed(),Be(this,D,"f").$show(Be(this,k,"f"),!!a)}assertNotDisposed(){if(Be(this,T,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,A=new WeakMap,n=new WeakMap,T=new WeakMap,u=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap,_=new WeakMap;class E{constructor(a,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,v,t,r){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:a}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(a),v,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(a,v,t,r,s){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:l,extension:d}=i,f=this._extHostWebview.createNewWebview(a,{},d),w=new P(a,this._proxy,v,t,f,!0);this._webviewViews.set(a,w),await l.resolveWebviewView(w,{state:r},s)}async $onDidChangeWebviewViewVisibility(a,v){this.getWebviewView(a)._setVisible(v)}async $disposeWebviewView(a){const v=this.getWebviewView(a);this._webviewViews.delete(a),v.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const v=this._webviewViews.get(a);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=E}),define(me[133],ge([0,1,3,5,2,10,9,4,14]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class $n{constructor(T){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=T.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(T){T!==this._state.focused&&(this._state={...this._state,focused:T},this._onDidChangeWindowState.fire(this._state))}openUri(T,u){let h;if(typeof T=="string"){h=T;try{T=I.URI.parse(T)}catch(c){return Promise.reject(`Invalid uri - '${T}'`)}}return(0,R.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this._proxy.$openUri(T,h,u)}async asExternalUri(T,u){if((0,R.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(T,u);return I.URI.from(h)}};A.InitialState={focused:!0},A=Ve([xe(0,D.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(me[259],ge([0,1,8,80,32,44,6,5,2,14]),function(Z,e,m,L,I,C,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends R.Disposable{constructor(u,h){super();const c=u.getProxy(k.MainContext.MainThreadDownloadService);h.registerCommand(!1,"_workbench.downloadResource",async g=>{const _=D.URI.file((0,m.join)((0,L.tmpdir)(),(0,I.generateUuid)()));return await c.$download(g,_),_})}};n=Ve([xe(0,A.IExtHostRpcService),xe(1,C.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[260],ge([0,1,2,8,152,28,67,27,14,6,12,115,42]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class h{constructor(P,E,o){this.name=P,this.file=E,this.appender=o}static async create(P,E){const o=await(0,T.createRotatingLogger)(P,E,30*u.ByteSize.MB,1);return o.clearFormatters(),new h(P,E,o)}append(P){this.appender.critical(P)}flush(){this.appender.flush()}}class c extends R.AbstractExtHostOutputChannel{constructor(P,E,o,a){super(P,!1,m.URI.file(E.file),o,a);this._appender=E}append(P){super.append(P),this._appender.append(P),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(P,E){this._appender.flush(),super.show(P,E)}clear(){this._appender.flush(),super.clear()}}let g=class extends R.ExtHostOutputService{constructor(P,E,o){super(P);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new A.MutableDisposable,this._logsLocation=o.logsLocation}$setVisibleChannel(P){if(P){const E=this._channels.get(P);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(P,E){if(P=P.trim(),!P)throw new Error("illegal argument `name`. must not be falsy");const o=this._doCreateOutChannel(P,E);return o.then(a=>a._id.then(v=>this._channels.set(v,a))),new R.LazyOutputChannel(P,o)}async _doCreateOutChannel(P,E){try{const o=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await C.SymlinkSupport.existsDirectory(o)||await C.Promises.mkdir(o,{recursive:!0});const v=`${this._namePool++}-${P.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=m.URI.file((0,L.join)(o,`${v}.log`)),r=await h.create(v,t.fsPath);return new c(P,r,E.identifier.value,this._proxy)}catch(o){return this.logService.error(o),new R.ExtHostPushOutputChannel(P,E.identifier.value,this._proxy)}}};g=Ve([xe(0,D.IExtHostRpcService),xe(1,n.ILogService),xe(2,k.IExtHostInitDataService)],g),e.ExtHostOutputService2=g}),define(me[261],ge([0,1,49,292,2,68,6,10,17]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(v){const t=await super._getWorkspaceStorageURI(v);if(t.scheme!==k.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const r=t.fsPath;let s=0;do{let i;s===0?i=r:i=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await n(i);const l=L.join(i,"vscode.lock"),d=await c(this._logService,l,!1);if(d)return this._workspaceStorageLock=d,process.on("exit",()=>{d.dispose()}),I.URI.file(i);s++}while(s<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function n(a){try{await m.promises.stat(a);return}catch{}try{await m.promises.mkdir(a,{recursive:!0})}catch{}}const T=1e3,u=10*60*1e3;class h extends R.Disposable{constructor(v,t){super();this.logService=v,this.filename=t,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await g(v,t);(!r||r.pid!==process.pid)&&(v.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await m.promises.utimes(t,new Date,new Date)}catch(s){v.error(s),v.info(`Lock '${t}': Could not update mtime.`)}},T)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(v){}}async setWillRelease(v){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${v} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+v};await m.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function c(a,v,t){try{const s={pid:process.pid,willReleaseAt:0};await m.promises.writeFile(v,JSON.stringify(s),{flag:"wx"})}catch(s){a.error(s)}const r=await g(a,v);return!r||r.pid!==process.pid?t?(a.info(`Lock '${v}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${v}': Could not acquire lock, checking if the file is stale.`),E(a,v)):(a.info(`Lock '${v}': Lock acquired.`),new h(a,v))}async function g(a,v){let t;try{t=await m.promises.readFile(v)}catch(r){return a.error(r),null}try{return JSON.parse(String(t))}catch(r){return a.error(r),null}}async function _(a,v){let t;try{t=await m.promises.stat(v)}catch(r){return a.error(r),0}return t.mtime.getTime()}function P(a){try{return process.kill(a,0),!0}catch(v){return!1}}async function E(a,v){const t=await g(a,v);if(!t)return a.info(`Lock '${v}': Could not read pid of lock holder.`),o(a,v);if(t.willReleaseAt){let d=t.willReleaseAt-Date.now();if(d<5e3){for(d>0?a.info(`Lock '${v}': The lockfile is scheduled to be released in ${d} ms.`):a.info(`Lock '${v}': The lockfile is scheduled to have been released.`);d>0;){if(await(0,D.timeout)(Math.min(100,d)),await _(a,v)===0)return o(a,v);d=t.willReleaseAt-Date.now()}return o(a,v)}}if(!P(t.pid))return a.info(`Lock '${v}': The pid ${t.pid} appears to be gone.`),o(a,v);const r=await _(a,v),s=Date.now()-r;if(s<=u)return a.info(`Lock '${v}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;a.info(`Lock '${v}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const i=await _(a,v),l=Date.now()-i;return l<=u?(a.info(`Lock '${v}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(a.info(`Lock '${v}': The lock looks stale even after waiting for 2s.`),o(a,v))}async function o(a,v){a.info(`Lock '${v}': Deleting a stale lock.`);try{await m.promises.unlink(v)}catch(t){}return c(a,v,!0)}}),define(me[262],ge([0,1,32,14,33]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,D,A){return this.createTerminalFromOptions({name:k,shellPath:D,shellArgs:A})}createTerminalFromOptions(k,D){const A=new I.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(A),A.create(k,this._serializeParentTerminal(k,D)),A.value}_serializeParentTerminal(k,D){if(D=D||{},k.location&&typeof k.location=="object"&&"parentTerminal"in k.location){const A=k.location.parentTerminal;if(A){const n=this._terminals.find(T=>T.value===A);n&&(D.resolvedExtHostIdentifier=n._id)}}else k.location&&typeof k.location!="object"?D.location=k.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}};C=Ve([xe(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(me[263],ge([0,1,5,14,6,27,2,39,24,28,7,11,52,3,193,77,12]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class P{constructor(f,w,y){this.remoteAddress=f,this.localAddress=w,this._dispose=y,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(d){const f=d.trim().split(`
`),w=[];return f.forEach(p=>{const S=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(p);S&&S.length>=3&&w.push({pid:parseInt(S[1],10),socket:parseInt(S[2],10)})}),w.reduce((p,S)=>(p[S.socket]=S,p),{})}e.getSockets=E;function o(...d){const f=[].concat(...d.map(v));return[...new Map(f.filter(w=>w.st==="0A").map(w=>{const y=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:a(y[0]),port:parseInt(y[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=o;function a(d){let f="";if(d.length===8)for(let w=d.length-2;w>=0;w-=2)f+=parseInt(d.substr(w,2),16),w!==0&&(f+=".");else for(let w=d.length-4;w>=0;w-=4)f+=parseInt(d.substr(w,4),16).toString(16),w!==0&&(f+=":");return f}e.parseIpAddress=a;function v(d){const f=d.trim().split(`
`),w=f.shift().trim().split(/\s+/).filter(p=>p!=="rx_queue"&&p!=="tm->when");return f.map(p=>p.trim().split(/\s+/).reduce((S,b,F)=>(S[w[F]||F]=b,S),{}))}e.loadConnectionTable=v;function t(d){return!!d.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||d.indexOf("out/vs/server/main.js")!==-1||d.indexOf("_productName=VSCode")!==-1}function r(d){const f=d.trim().split(`
`),w=[];return f.forEach(y=>{const p=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);p&&p.length>=4&&w.push({pid:parseInt(p[1],10),ppid:parseInt(p[2]),cmd:p[3]})}),w}e.getRootProcesses=r;async function s(d,f,w){const y=w.reduce((S,b)=>(S[b.pid]=b,S),{}),p=[];return d.forEach(({socket:S,ip:b,port:F})=>{const N=f[S]?f[S].pid:void 0,G=N?y[N]?.cmd:void 0;N&&G&&!t(G)&&p.push({host:b,port:F,detail:G,pid:N})}),p}e.findPorts=s;function i(d,f,w){const y=new Map,p=r(f);for(const S of d){const b=w.get(S.port);if(b){y.set(S.port,b);continue}const F=p.find(N=>N.cmd.includes(`${S.port}`));if(F){let N=F,G;do G=p.find(K=>K.ppid===N.pid),G&&(N=G);while(G);y.set(S.port,{host:S.ip,port:S.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else y.set(S.port,{host:S.ip,port:S.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=i;let l=class extends I.Disposable{constructor(f,w,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(m.MainContext.MainThreadTunnelService),T.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(w,f.displayName);if(y){const p=new P(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(p),p}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,w){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:f,provider:w}),this._proxy.$registerPortsAttributesProvider(f,y),new n.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(f,w,y,p,S){const b=[];for(const N of f){const G=this._portAttributesProviders.get(N);if(!G)return[];b.push(...await Promise.all(w.map(async K=>G.provider.providePortAttributes(K,y,p,S))))}const F=b.filter(N=>!!N);return F.length>0?F.map(N=>({autoForwardAction:N.autoForwardAction,port:N.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let w=new g.MovingAverage,y;for(;this._candidateFindingEnabled;){const p=new Date().getTime(),S=(await this.findCandidatePorts()).filter(F=>(0,c.isLocalhost)(F.host)||(0,c.isAllInterfaces)(F.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${S.map(F=>F.port).join(", ")}`);const b=new Date().getTime()-p;w.update(b),(!y||JSON.stringify(y)!==JSON.stringify(S))&&(y=S,await this._proxy.$onFoundNewCandidates(y)),await new Promise(F=>setTimeout(()=>F(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(f){return f?(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory&&(this._forwardPortProvider=f.tunnelFactory,this._proxy.$setTunnelProvider(f.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,w){if(this._extensionTunnels.has(f.host)){const y=this._extensionTunnels.get(f.host);y.has(f.port)&&(w&&y.get(f.port).disposeListener.dispose(),await y.get(f.port).tunnel.dispose(),y.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(f,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const p=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const S=this._register(p.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(p.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:p,disposeListener:S}),u.TunnelDto.fromApiTunnel(p)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(y){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const w=await Promise.all(f.map(p=>this._showCandidatePort(p.host,p.port,p.detail??""))),y=f.filter((p,S)=>w[S]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(p=>p.port).join(", ")} to ${y.map(p=>p.port).join(", ")}`),y}async findCandidatePorts(){let f="",w="";try{f=await A.Promises.readFile("/proc/net/tcp","utf8"),w=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const y=o(f,w),p=await new Promise(U=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,$,B)=>{U($)})}),S=E(p),b=await A.Promises.readdir("/proc"),F=[];for(let U of b)try{const O=Number(U),$=D.joinPath(R.URI.file("/proc"),U);if((await A.Promises.stat($.fsPath)).isDirectory()&&!isNaN(O)){const x=await A.Promises.readlink(D.joinPath($,"cwd").fsPath),j=await A.Promises.readFile(D.joinPath($,"cmdline").fsPath,"utf8");F.push({pid:O,cwd:x,cmd:j})}}catch(O){}const N=[],G=y.filter(U=>{const O=S[U.socket];return O||N.push(U),O}),K=s(G,S,F);let M;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const U=await new Promise(O=>{(0,k.exec)("ps -F -A -l | grep root",($,B,x)=>{O(B)})});this._foundRootPorts=i(N,U,this._foundRootPorts),M=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${M.join(", ")}`)}return K.then(U=>M?U.concat(M):U)}};l=Ve([xe(0,L.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,_.ILogService)],l),e.ExtHostTunnelService=l}),define(me[264],ge([0,1,17,22,21,16,3,6,103,228,65]),function(Z,e,m,L,I,C,R,k,D,A,n){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(p,S){try{return JSON.stringify(p,S)}catch(b){return"null"}}const h="$$ref$$",c={[h]:-1};class g{constructor(S,b){this.jsonString=S,this.referencedBuffers=b}}function _(p,S=null,b=!1){const F=[];return{jsonString:(b?u:JSON.stringify)(p,(G,K)=>{if(typeof K=="undefined")return c;if(typeof K=="object"){if(K instanceof L.VSBuffer){const M=F.push(K)-1;return{[h]:M}}if(S)return S(G,K)}return K}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=_;function P(p,S,b){return JSON.parse(p,(F,N)=>{if(N){const G=N[h];if(typeof G=="number")return S[G];if(b&&N.$mid===1)return b.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=P;function E(p,S){return JSON.stringify(p,S)}function o(p){return p?(S,b)=>b&&b.$mid===1?p.transformOutgoing(b):b:null}var a;(function(p){p[p.LocalSide=0]="LocalSide",p[p.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(p){p[p.Responsive=0]="Responsive",p[p.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(S,b=null,F=null){super();this[T]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=S,this._logger=b,this._uriTransformer=F,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,G=n.ProxyIdentifier.count;N<G;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(S=>{this._pendingRPCReplies[S].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(S){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(S){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(S){this._responsiveState!==S&&(this._responsiveState=S,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(S){return this._uriTransformer?(0,D.transformIncomingURIs)(S,this._uriTransformer):S}getProxy(S){const{nid:b,sid:F}=S;return this._proxies[b]||(this._proxies[b]=this._createProxy(b,F)),this._proxies[b]}_createProxy(S,b){let F={get:(N,G)=>(typeof G=="string"&&!N[G]&&G.charCodeAt(0)===36&&(N[G]=(...K)=>this._remoteCall(S,G,K)),G===s?b:N[G])};return new Proxy(Object.create(null),F)}set(S,b){return this._locals[S.nid]=b,b}assertRegistered(S){for(let b=0,F=S.length;b<F;b++){const N=S[b];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(S){if(this._isDisposed)return;const b=S.byteLength,F=l.read(S,0),N=F.readUInt8(),G=F.readUInt32();switch(N){case 1:case 2:{let{rpcId:K,method:M,args:U}=f.deserializeRequestJSONArgs(F);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(b,G,K,M,U,N===2);break}case 3:case 4:{let{rpcId:K,method:M,args:U}=f.deserializeRequestMixedArgs(F);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(b,G,K,M,U,N===4);break}case 5:{this._logger&&this._logger.logIncoming(b,G,0,"ack"),this._onDidReceiveAcknowledge(G);break}case 6:{this._receiveCancel(b,G);break}case 7:{this._receiveReply(b,G,void 0);break}case 9:{let K=f.deserializeReplyOKJSON(F);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(b,G,K);break}case 10:{const K=f.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(b,G,K);break}case 8:{let K=f.deserializeReplyOKVSBuffer(F);this._receiveReply(b,G,K);break}case 11:{let K=f.deserializeReplyErrError(F);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(b,G,K);break}case 12:{this._receiveReplyErr(b,G,void 0);break}default:console.error("received unexpected message"),console.error(S)}}_receiveRequest(S,b,F,N,G,K){this._logger&&this._logger.logIncoming(S,b,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(F)}.${N}(`,G);const M=String(b);let U,O;if(K){const B=new I.CancellationTokenSource;G.push(B.token),U=this._invokeHandler(F,N,G),O=()=>B.cancel()}else U=this._invokeHandler(F,N,G),O=t;this._cancelInvokedHandlers[M]=O;const $=f.serializeAcknowledged(b);this._logger&&this._logger.logOutgoing($.byteLength,b,1,"ack"),this._protocol.send($),U.then(B=>{delete this._cancelInvokedHandlers[M];const x=f.serializeReplyOK(b,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,b,1,"reply:",B),this._protocol.send(x)},B=>{delete this._cancelInvokedHandlers[M];const x=f.serializeReplyErr(b,B);this._logger&&this._logger.logOutgoing(x.byteLength,b,1,"replyErr:",B),this._protocol.send(x)})}_receiveCancel(S,b){this._logger&&this._logger.logIncoming(S,b,1,"receiveCancel");const F=String(b);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(S,b,F){this._logger&&this._logger.logIncoming(S,b,0,"receiveReply:",F);const N=String(b);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const G=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],G.resolveOk(F)}_receiveReplyErr(S,b,F){this._logger&&this._logger.logIncoming(S,b,0,"receiveReplyErr:",F);const N=String(b);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const G=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let K;F&&(F.$isError?(K=new Error,K.name=F.name,K.message=F.message,K.stack=F.stack):K=F),G.resolveErr(K)}_invokeHandler(S,b,F){try{return Promise.resolve(this._doInvokeHandler(S,b,F))}catch(N){return Promise.reject(N)}}_doInvokeHandler(S,b,F){const N=this._locals[S];if(!N)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(S));let G=N[b];if(typeof G!="function")throw new Error("Unknown method "+b+" on actor "+(0,n.getStringIdentifierForProxy)(S));return G.apply(N,F)}_remoteCall(S,b,F){if(this._isDisposed)return Promise.reject(C.canceled());let N=null;if(F.length>0&&I.CancellationToken.isCancellationToken(F[F.length-1])&&(N=F.pop()),N&&N.isCancellationRequested)return Promise.reject(C.canceled());const G=f.serializeRequestArguments(F,this._uriReplacer),K=++this._lastMessageId,M=String(K),U=new A.LazyPromise;N&&N.onCancellationRequested(()=>{const $=f.serializeCancel(K);this._logger&&this._logger.logOutgoing($.byteLength,K,0,"cancel"),this._protocol.send(f.serializeCancel(K))}),this._pendingRPCReplies[M]=U,this._onWillSendRequest(K);const O=f.serializeRequest(K,S,b,G,!!N);return this._logger&&this._logger.logOutgoing(O.byteLength,K,0,`request: ${(0,n.getStringIdentifierForProxy)(S)}.${b}(`,F),this._protocol.send(O),U}}e.RPCProtocol=i,T=r,i.UNRESPONSIVE_TIME=3*1e3;class l{constructor(S,b){this._buff=S,this._offset=b}static alloc(S,b,F){let N=new l(L.VSBuffer.alloc(F+1+4),0);return N.writeUInt8(S),N.writeUInt32(b),N}static read(S,b){return new l(S,b)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(S){this._buff.writeUInt8(S,this._offset),this._offset+=1}readUInt8(){const S=this._buff.readUInt8(this._offset);return this._offset+=1,S}writeUInt32(S){this._buff.writeUInt32BE(S,this._offset),this._offset+=4}readUInt32(){const S=this._buff.readUInt32BE(this._offset);return this._offset+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this._buff.writeUInt8(S.byteLength,this._offset),this._offset+=1,this._buff.set(S,this._offset),this._offset+=S.byteLength}readShortString(){const S=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,F}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readLongString(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,F}writeBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readVSBuffer(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+S);return this._offset+=S,b}static sizeMixedArray(S){let b=0;b+=1;for(let F=0,N=S.length;F<N;F++){const G=S[F];switch(b+=1,G.type){case 1:b+=this.sizeLongString(G.value);break;case 2:b+=this.sizeVSBuffer(G.value);break;case 3:b+=this.sizeUInt8(),b+=this.sizeLongString(G.value);for(let K=0;K<G.buffers.length;++K)b+=this.sizeVSBuffer(G.buffers[K]);break;case 4:break}}return b}writeMixedArray(S){this._buff.writeUInt8(S.length,this._offset),this._offset+=1;for(let b=0,F=S.length;b<F;b++){const N=S[b];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt8(N.buffers.length),this.writeLongString(N.value);for(let G=0;G<N.buffers.length;++G)this.writeBuffer(N.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this._buff.readUInt8(this._offset);this._offset+=1;let b=new Array(S);for(let F=0;F<S;F++)switch(this.readUInt8()){case 1:b[F]=this.readLongString();break;case 2:b[F]=this.readVSBuffer();break;case 3:const G=this.readUInt8(),K=this.readLongString(),M=[];for(let U=0;U<G;++U)M.push(this.readVSBuffer());b[F]=new n.SerializableObjectWithBuffers(P(K,M,null));break;case 4:b[F]=void 0;break}return b}}var d;(function(p){p[p.Simple=0]="Simple",p[p.Mixed=1]="Mixed"})(d||(d={}));class f{static _useMixedArgSerialization(S){for(let b=0,F=S.length;b<F;b++)if(S[b]instanceof L.VSBuffer||S[b]instanceof n.SerializableObjectWithBuffers||typeof S[b]=="undefined")return!0;return!1}static serializeRequestArguments(S,b){if(this._useMixedArgSerialization(S)){const F=[];for(let N=0,G=S.length;N<G;N++){const K=S[N];if(K instanceof L.VSBuffer)F[N]={type:2,value:K};else if(typeof K=="undefined")F[N]={type:4};else if(K instanceof n.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:U}=_(K.value,b);F[N]={type:3,value:L.VSBuffer.fromString(M),buffers:U}}else F[N]={type:1,value:L.VSBuffer.fromString(E(K,b))}}return{type:1,args:F}}return{type:0,args:E(S,b)}}static serializeRequest(S,b,F,N,G){switch(N.type){case 0:return this._requestJSONArgs(S,b,F,N.args,G);case 1:return this._requestMixedArgs(S,b,F,N.args,G)}}static _requestJSONArgs(S,b,F,N,G){const K=L.VSBuffer.fromString(F),M=L.VSBuffer.fromString(N);let U=0;U+=l.sizeUInt8(),U+=l.sizeShortString(K),U+=l.sizeLongString(M);let O=l.alloc(G?2:1,S,U);return O.writeUInt8(b),O.writeShortString(K),O.writeLongString(M),O.buffer}static deserializeRequestJSONArgs(S){const b=S.readUInt8(),F=S.readShortString(),N=S.readLongString();return{rpcId:b,method:F,args:JSON.parse(N)}}static _requestMixedArgs(S,b,F,N,G){const K=L.VSBuffer.fromString(F);let M=0;M+=l.sizeUInt8(),M+=l.sizeShortString(K),M+=l.sizeMixedArray(N);let U=l.alloc(G?4:3,S,M);return U.writeUInt8(b),U.writeShortString(K),U.writeMixedArray(N),U.buffer}static deserializeRequestMixedArgs(S){const b=S.readUInt8(),F=S.readShortString(),N=S.readMixedArray(),G=new Array(N.length);for(let K=0,M=N.length;K<M;K++){const U=N[K];typeof U=="string"?G[K]=JSON.parse(U):G[K]=U}return{rpcId:b,method:F,args:G}}static serializeAcknowledged(S){return l.alloc(5,S,0).buffer}static serializeCancel(S){return l.alloc(6,S,0).buffer}static serializeReplyOK(S,b,F){if(typeof b=="undefined")return this._serializeReplyOKEmpty(S);if(b instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(S,b);if(b instanceof n.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:G}=_(b.value,F,!0);return this._serializeReplyOKJSONWithBuffers(S,N,G)}else return this._serializeReplyOKJSON(S,u(b,F))}static _serializeReplyOKEmpty(S){return l.alloc(7,S,0).buffer}static _serializeReplyOKVSBuffer(S,b){let F=0;F+=l.sizeVSBuffer(b);let N=l.alloc(8,S,F);return N.writeVSBuffer(b),N.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static _serializeReplyOKJSON(S,b){const F=L.VSBuffer.fromString(b);let N=0;N+=l.sizeLongString(F);let G=l.alloc(9,S,N);return G.writeLongString(F),G.buffer}static _serializeReplyOKJSONWithBuffers(S,b,F){const N=L.VSBuffer.fromString(b);let G=0;G+=l.sizeUInt8(),G+=l.sizeLongString(N);for(const M of F)G+=l.sizeVSBuffer(M);let K=l.alloc(10,S,G);K.writeUInt8(F.length),K.writeLongString(N);for(const M of F)K.writeBuffer(M);return K.buffer}static deserializeReplyOKJSON(S){const b=S.readLongString();return JSON.parse(b)}static deserializeReplyOKJSONWithBuffers(S,b){const F=S.readUInt8(),N=S.readLongString(),G=[];for(let K=0;K<F;++K)G.push(S.readVSBuffer());return new n.SerializableObjectWithBuffers(P(N,G,b))}static serializeReplyErr(S,b){return b?this._serializeReplyErrEror(S,b):this._serializeReplyErrEmpty(S)}static _serializeReplyErrEror(S,b){const F=L.VSBuffer.fromString(u(C.transformErrorForSerialization(b),null));let N=0;N+=l.sizeLongString(F);let G=l.alloc(11,S,N);return G.writeLongString(F),G.buffer}static deserializeReplyErrError(S){const b=S.readLongString();return JSON.parse(b)}static _serializeReplyErrEmpty(S){return l.alloc(12,S,0).buffer}}var w;(function(p){p[p.RequestJSONArgs=1]="RequestJSONArgs",p[p.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",p[p.RequestMixedArgs=3]="RequestMixedArgs",p[p.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",p[p.Acknowledged=5]="Acknowledged",p[p.Cancel=6]="Cancel",p[p.ReplyOKEmpty=7]="ReplyOKEmpty",p[p.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",p[p.ReplyOKJSON=9]="ReplyOKJSON",p[p.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",p[p.ReplyErrError=11]="ReplyErrError",p[p.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var y;(function(p){p[p.String=1]="String",p[p.VSBuffer=2]="VSBuffer",p[p.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",p[p.Undefined=4]="Undefined"})(y||(y={}))}),define(me[265],ge([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(me[266],ge([0,1,10,8,11,2,4,86,43,223,265]),function(Z,e,m,L,I,C,R,k,D,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let T=class Wn{constructor(h,c,g,_){this.localUserHome=h,this.remoteAgentService=c,this.environmentService=g,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||I.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||h})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,c){if(h.remoteAuthority)return m.Schemas.vscodeRemote;const g=(0,k.getVirtualWorkspaceScheme)(c.getWorkspace());if(g)return g;const _=c.getWorkspace().folders[0];if(_)return _.uri.scheme;const P=c.getWorkspace().configuration;return P?P.scheme:m.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?L.win32:L.posix)}async fileURI(h){let c="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const _=h.indexOf("/",2);_===-1?(c=h.substring(2),h="/"):(c=h.substring(2,_),h=h.substring(_)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:c,path:h,query:"",fragment:""})}};T=Ve([xe(1,n.IRemoteAgentService),xe(2,A.IWorkbenchEnvironmentService),xe(3,D.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(me[70],ge([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(R,k){this.line=R,this.character=k}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,k){return new m(0,0)}with(R){return new m(0,0)}}e.Position=m;class L{constructor(R,k,D,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(R,k),this.end=new m(D,A)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.Range=L;var I;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,20,30,25,29,9,4,8,16,70,13]),function(Z,e,m,L,I,C,R,k,D,A,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",h=" characters skipped \u27EB",c=(u.length+h.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var g;(function($){$[$.file=0]="file",$[$.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var _;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(_=e.QueryType||(e.QueryType={}));function P($){return!!$.preview}e.resultIsMatch=P;function E($){return!!$.resource}e.isFileMatch=E;function o($){return!!$.message}e.isProgressMessage=o;var a;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=v;class t{constructor(B,x,j){this.ranges=x;const H=Array.isArray(x)?x:[x];if(j&&j.matchLines===1&&r(H)){B=(0,R.getNLines)(B,j.matchLines);let X="",J=0,fe=0;const _e=Math.floor(j.charsPerLine/5),Se=[];for(const Le of H){const We=Math.max(Le.startColumn-_e,0),Ne=Le.startColumn+j.charsPerLine;if(We>fe+_e+c){const Ke=u+(We-fe)+h;X+=Ke+B.slice(We,Ne),J+=We-(fe+Ke.length)}else X+=B.slice(fe,Ne);Se.push(new i(0,Le.startColumn-J,Le.endColumn-J)),fe=Ne}this.preview={text:X,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const X=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:B,matches:(0,m.mapArrayOrNot)(x,J=>new s(J.startLineNumber-X,J.startColumn,J.endLineNumber-X,J.endColumn))}}}}e.TextSearchMatch=t;function r($){const B=$[0].startLineNumber;for(const x of $)if(x.startLineNumber!==B||x.endLineNumber!==B)return!1;return!0}class s{constructor(B,x,j,H){this.startLineNumber=B,this.startColumn=x,this.endLineNumber=j,this.endColumn=H}}e.SearchRange=s;class i extends s{constructor(B,x,j){super(B,x,B,j)}}e.OneLineRange=i;var l;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function d($,B=!0){const x=$&&$.files&&$.files.exclude,j=B&&$&&$.search&&$.search.exclude;if(!x&&!j)return;if(!x||!j)return x||j;let H=Object.create(null);return H=I.mixin(H,I.deepClone(x)),H=I.mixin(H,I.deepClone(j),!0),H}e.getExcludes=d;function f($,B){return $.excludePattern&&L.match($.excludePattern,B)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&L.match($.includePattern,B)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(x=>{const j=x.folder.fsPath;if(C.isEqualOrParent(B,j)){const H=D.relative(j,B);return!x.includePattern||!!L.match(x.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var w;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(B,x){super(B);this.code=x}}e.SearchError=y;function p($){const B=$.message;if((0,A.isPromiseCanceledError)($))return new y(B,w.canceled);try{const x=JSON.parse(B);return new y(x.message,x.code)}catch(x){return new y(B,w.other)}}e.deserializeSearchError=p;function S($){const B={message:$.message,code:$.code};return new Error(JSON.stringify(B))}e.serializeSearchError=S;function b($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=b;function F($){return $.type==="success"}e.isSerializedSearchSuccess=F;function N($){return!!$.path}e.isSerializedFileMatch=N;function G($,B){const x=$.searchPath?$.searchPath:$.relativePath;return(0,R.fuzzyContains)(x,B)}e.isFilePatternMatch=G;class K{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function M($,B){const x={...$||{},...B||{}};return Object.keys(x).filter(j=>{const H=x[j];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class U{constructor(B,x){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...x.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let j=B.includePattern;x.includePattern&&(j?j={...j,...x.includePattern}:j=x.includePattern),j&&(this._parsedIncludeExpression=L.parse(j))}includedInQuerySync(B,x,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,x,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,x,j))}includedInQuery(B,x,j){const H=this._parsedExcludeExpression(B,x,j),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,x,j):!0;return(0,T.isPromise)(H)?H.then(J=>J?!1:X()):X()}hasSiblingExcludeClauses(){return O(this._excludeExpression)}}e.QueryGlobTester=U;function O($){for(const B in $)if(typeof $[B]!="boolean")return!0;return!1}}),define(me[37],ge([0,1,20,17,21,3,23,10,77,24,9,13,2,170,4,12,190,43,63,27,14,7,31,5]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o,a,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(S,b,F){return new A.ExtUri(N=>f(N,F)).isEqual(S,b)}function i(S,b,F){return s(S.uri,b.uri,F)?0:(0,n.compare)(S.uri.toString(),b.uri.toString())}function l(S,b,F){return S.index!==b.index?S.index<b.index?-1:1:s(S.uri,b.uri,F)?(0,n.compare)(S.name,b.name):(0,n.compare)(S.uri.toString(),b.uri.toString())}function d(S,b,F,N){const G=S.slice(0).sort((M,U)=>F(M,U,N)),K=b.slice(0).sort((M,U)=>F(M,U,N));return(0,m.delta)(G,K,(M,U)=>F(M,U,N))}function f(S,b){const F=b.getCapabilities(S.scheme);return!(F&&F&1024)}class w extends P.Workspace{constructor(b,F,N,G,K,M){super(b,N.map(U=>new P.WorkspaceFolder(U)),G,M);this._name=F,this._isUntitled=K,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(M),N.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(b,F,N,G){if(!b)return{workspace:null,added:[],removed:[]};const{id:K,name:M,folders:U,configuration:O,isUntitled:$}=b,B=[],x=F;F?U.forEach((J,fe)=>{const _e=u.URI.revive(J.uri),Se=w._findFolder(N||F,_e,G);Se?(Se.name=J.name,Se.index=J.index,B.push(Se)):B.push({uri:_e,name:J.name,index:fe})}):B.push(...U.map(({uri:J,name:fe,index:_e})=>({uri:u.URI.revive(J),name:fe,index:_e}))),B.sort((J,fe)=>J.index<fe.index?-1:1);const j=new w(K,M,B,O?u.URI.revive(O):null,!!$,J=>f(J,G)),{added:H,removed:X}=d(x?x.workspaceFolders:[],j.workspaceFolders,i,G);return{workspace:j,added:H,removed:X}}static _findFolder(b,F,N){for(let G=0;G<b.folders.length;G++){const K=b.workspaceFolders[G];if(s(K.uri,F,N))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(b,F){return F&&this._structure.get(b)&&(b=(0,A.dirname)(b)),this._structure.findSubstr(b)}resolveWorkspaceFolder(b){return this._structure.get(b)}}let y=class{constructor(b,F,N,G){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=G,this._extHostFileSystemInfo=N,this._requestIdProvider=new D.Counter,this._barrier=new L.Barrier,this._proxy=b.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=b.getProxy(r.MainContext.MainThreadMessageService);const K=F.workspace;this._confirmedWorkspace=K?new w(K.id,K.name,[],K.configuration?u.URI.revive(K.configuration):null,!!K.isUntitled,M=>f(M,N)):void 0}$initializeWorkspace(b,F){this._trusted=F,this.$acceptWorkspaceData(b),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:k.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(b,F,N,...G){const K=[];if(Array.isArray(G)&&G.forEach(B=>{u.URI.isUri(B.uri)&&!K.some(x=>s(x.uri,B.uri,this._extHostFileSystemInfo))&&K.push({uri:B.uri,name:B.name||(0,A.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[F,N].some(B=>typeof B!="number"||B<0)||N===0&&K.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+N>M.length)return!1;const U=M.slice(0);U.splice(F,N,...K.map(B=>({uri:B.uri,name:B.name||(0,A.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<U.length;B++){const x=U[B];if(U.some((j,H)=>H!==B&&s(x.uri,j.uri,this._extHostFileSystemInfo)))return!1}U.forEach((B,x)=>B.index=x);const{added:O,removed:$}=d(M,U,l,this._extHostFileSystemInfo);if(O.length===0&&$.length===0)return!1;if(this._proxy){const B=b.displayName||b.name;this._proxy.$updateWorkspaceFolders(B,F,N,K).then(void 0,x=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,h.localize)(0,null,B,x.toString()),{extension:b},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(b,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(b,F)}async getWorkspaceFolder2(b,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(b,F)}async resolveWorkspaceFolder(b){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(b)}getPath(){if(!this._actualWorkspace)return;const{folders:b}=this._actualWorkspace;if(b.length!==0)return b[0].uri.fsPath}getRelativePath(b,F){let N,G="";if(typeof b=="string"?(N=u.URI.file(b),G=b):typeof b!="undefined"&&(N=b,G=b.fsPath),!N)return G;const K=this.getWorkspaceFolder(N,!0);if(!K)return G;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let M=(0,A.relativePath)(K.uri,N);return F&&K.name&&(M=`${K.name}/${M}`),M}trySetWorkspaceFolders(b){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:b,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(b){const{workspace:F,added:N,removed:G}=w.toExtHostWorkspace(b,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:G}))}findFiles(b,F,N,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let M;if(F===null?M=!1:F&&(typeof F=="string"?M=F:M=F.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:O}=p(b);return this._proxy.$startFileSearch((0,T.withUndefinedAsNull)(U),(0,T.withUndefinedAsNull)(O),(0,T.withUndefinedAsNull)(M),(0,T.withUndefinedAsNull)(N),K).then($=>Array.isArray($)?$.map(B=>u.URI.revive(B)):[])}async findTextInFiles(b,F,N,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),U=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:O,folder:$}=p(F.include),B=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,x={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:U,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:O,excludePattern:B},j=!1;if(this._activeSearchCallbacks[M]=H=>{if(j)return;const X=u.URI.revive(H.resource);H.results.forEach(J=>{(0,t.resultIsMatch)(J)?N({uri:X,preview:{text:J.preview.text,matches:(0,m.mapArrayOrNot)(J.preview.matches,fe=>new v.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,m.mapArrayOrNot)(J.ranges,fe=>new v.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):N({uri:X,text:J.text,lineNumber:J.lineNumber})})},K.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(b,(0,T.withUndefinedAsNull)($),x,M,K);return delete this._activeSearchCallbacks[M],H||{}}catch(H){throw delete this._activeSearchCallbacks[M],H}}$handleTextSearchResult(b,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](b)}saveAll(b){return this._proxy.$saveAll(b)}resolveProxy(b){return this._proxy.$resolveProxy(b)}get trusted(){return this._trusted}requestWorkspaceTrust(b){return this._proxy.$requestWorkspaceTrust(b)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ve([xe(0,a.IExtHostRpcService),xe(1,o.IExtHostInitDataService),xe(2,E.IExtHostFileSystemInfo),xe(3,g.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function p(S){let b,F;return S&&(typeof S=="string"?b=S:(b=S.pattern,F=S.baseFolder||u.URI.file(S.base))),{includePattern:b,folder:F}}}),define(me[38],ge([0,1,25,3,37,5,7,192,85,13,17,4,14,12,2]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(r,s){if(s){const i=s.split(".");let l=r;for(let d=0;l&&d<i.length;d++)l=l[i[d]];return l}}function _(r){return r instanceof c.URI}function P(r){return r&&r.uri instanceof c.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function o(r){return r&&r.uri instanceof c.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function a(r){if(_(r))return{resource:r};if(P(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(o(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(s,i,l){this._proxy=s.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=l,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,i))}};v=Ve([xe(0,u.IExtHostRpcService),xe(1,I.IExtHostWorkspace),xe(2,h.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(s,i,l,d){this._onDidChangeConfiguration=new L.Emitter,this._proxy=s,this._logService=d,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,l))}getConfiguration(s,i,l){const d=a(i)||{},f=this._toReadonlyValue(s?g(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,d,l?.identifier);function w(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(p){return typeof g(f,p)!="undefined"},get:(p,S)=>{this._validateConfigurationAccess(s?`${s}.${p}`:p,d,l?.identifier);let b=g(f,p);if(typeof b=="undefined")b=S;else{let F;const N=(G,K)=>{let M;const U=()=>{F=F||(0,m.deepClone)(f),M=M||g(F,K)};return(0,A.isObject)(G)?new Proxy(G,{get:(O,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return U(),()=>M;if(F)return M=M||g(F,K),M[$];const B=O[$];return typeof $=="string"?N(B,`${K}.${$}`):B},set:(O,$,B)=>(U(),M&&(M[$]=B),!0),deleteProperty:(O,$)=>(U(),M&&delete M[$],!0),defineProperty:(O,$,B)=>(U(),M&&Object.defineProperty(M,$,B),!0)}):G};b=N(b,p)}return b},update:(p,S,b,F)=>{p=s?`${s}.${p}`:p;const N=w(b);return S!==void 0?this._proxy.$updateConfigurationOption(N,p,S,d,F):this._proxy.$removeConfigurationOption(N,p,d,F)},inspect:p=>{p=s?`${s}.${p}`:p;const S=(0,m.deepClone)(this._configuration.inspect(p,d,this._extHostWorkspace.workspace));if(S)return{key:p,defaultValue:S.default?.value,globalValue:S.user?.value,workspaceValue:S.workspace?.value,workspaceFolderValue:S.workspaceFolder?.value,defaultLanguageValue:S.default?.override,globalLanguageValue:S.user?.override,workspaceLanguageValue:S.workspace?.override,workspaceFolderLanguageValue:S.workspaceFolder?.override,languageIds:S.overrideIdentifiers}}};return typeof f=="object"&&(0,m.mixin)(y,f,!1),Object.freeze(y)}_toReadonlyValue(s){const i=l=>(0,A.isObject)(l)?new Proxy(l,{get:(d,f)=>i(d[f]),set:(d,f,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(d,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(d,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return i(s)}_validateConfigurationAccess(s,i,l){const d=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),f=l?`[${l.value}] `:"";if(d===4){typeof i?.resource=="undefined"&&this._logService.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){i?.resource&&this._logService.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const l=new k.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,f)=>l.affectsConfiguration(d,a(f))})}_toMap(s){return s.reduce((i,l)=>(i.set(l[0],l[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[71],ge([0,1,2,17,3,5,7,37,45,38,21,33,14,27,4,10,11,12,66,213,16]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function M(O){if(O!=null)return O}K.from=M;function U(O){if(O!=null)return O}K.to=U})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(K){function M(O){if(O!=null)return O}K.from=M;function U(O){if(O!=null)return O}K.to=U})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(K){function M(O){if(O!=null)return O}K.from=M;function U(O){if(O!=null)return O}K.to=U})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(K){function M($){if($){const B=$;return B&&!!B.process}else return!1}K.is=M;function U($){if($==null)return;const B={process:$.process,args:$.args};return $.options&&(B.options=s.from($.options)),B}K.from=U;function O($){if($!=null)return new R.ProcessExecution($.process,$.args,$.options)}K.to=O})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(K){function M(O){if(O!=null)return O}K.from=M;function U(O){if(O!=null)return O}K.to=U})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(K){function M($){if($){const B=$;return B&&(!!B.commandLine||!!B.command)}else return!1}K.is=M;function U($){if($==null)return;const B={};return $.commandLine!==void 0?B.commandLine=$.commandLine:(B.command=$.command,B.args=$.args),$.options&&(B.options=l.from($.options)),B}K.from=U;function O($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new R.ShellExecution($.commandLine,$.options):new R.ShellExecution($.command,$.args?$.args:[],$.options)}K.to=O})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var f;(function(K){function M($){if($){let B=$;return B&&B.customExecution==="customExecution"}else return!1}K.is=M;function U($){return{customExecution:"customExecution"}}K.from=U;function O($,B){return B.get($)}K.to=O})(f=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(K){function M(U,O){let $;return U.scope!==void 0&&typeof U.scope!="number"?$=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&O&&O.workspaceFile?$=O.workspaceFile:$=o.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:$}}K.from=M})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(K){function M(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}K.from=M})(y=e.TaskGroupDTO||(e.TaskGroupDTO={}));var p;(function(K){function M($,B){if($==null)return[];const x=[];for(let j of $){const H=U(j,B);H&&x.push(H)}return x}K.fromMany=M;function U($,B){if($==null)return;let x;$.execution instanceof R.ProcessExecution?x=i.from($.execution):$.execution instanceof R.ShellExecution?x=d.from($.execution):$.execution&&$.execution instanceof R.CustomExecution&&(x=f.from($.execution));const j=t.from($.definition);let H;return $.scope?typeof $.scope=="number"?H=$.scope:H=$.scope.uri:H=R.TaskScope.Workspace,!j||!H?void 0:{_id:$._id,definition:j,name:$.name,source:{extensionId:B.identifier.value,label:$.source,scope:H},execution:x,isBackground:$.isBackground,group:y.from($.group),presentationOptions:r.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}K.from=U;async function O($,B,x){if($==null)return;let j;i.is($.execution)?j=i.to($.execution):d.is($.execution)?j=d.to($.execution):f.is($.execution)&&(j=f.to($._id,x));const H=t.to($.definition);let X;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?X=$.source.scope:X=await B.resolveWorkspaceFolder(m.URI.revive($.source.scope)):X=R.TaskScope.Workspace),!H||!X)return;const J=new R.Task(H,X,$.name,$.source.label,j,$.problemMatchers);return $.isBackground!==void 0&&(J.isBackground=$.isBackground),$.group!==void 0&&(J.group=R.TaskGroup.from($.group._id),J.group&&(J.group=new R.TaskGroup(J.group.id,J.group.label),$.group.isDefault&&(J.group.isDefault=$.group.isDefault))),$.presentationOptions&&(J.presentationOptions=r.to($.presentationOptions)),$._id&&(J._id=$._id),$.detail&&(J.detail=$.detail),J}K.to=O})(p=e.TaskDTO||(e.TaskDTO={}));var S;(function(K){function M(O){return O}K.from=M;function U(O){if(!!O)return Object.assign(Object.create(null),O)}K.to=U})(S=e.TaskFilterDTO||(e.TaskFilterDTO={}));class b{constructor(M,U,O){this._id=U,this._task=O,v.set(this,void 0),rt(this,v,M,"f")}get task(){return this._task}terminate(){Be(this,v,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}v=new WeakMap;var F;(function(K){function M(U){return{id:U._id,task:void 0}}K.from=M})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(M,U,O,$,B,x,j,H){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=$,this._configurationService=B,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,U,O){if(!O)return new R.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:U,provider:O,extension:M}),this._proxy.$registerTaskProvider($,U),new R.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(M,U){this._proxy.$registerTaskSystem(M,U)}fetchTasks(M){return this._proxy.$fetchTasks(S.from(M)).then(async U=>{const O=[];for(let $ of U){const B=await p.to($,this._workspaceProvider,this._providedCustomExecutions2);B&&O.push(B)}return O})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(U=>M.push(U)),M}terminateTask(M){if(!(M instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,U,O){const $=this._providedCustomExecutions2.get(M.id);if($){if(this._activeCustomExecutions2.get(M.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(M.id,$),this._terminalService.attachPtyToTerminal(U,await $.callback(O))}this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const U=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const U=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:U,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const U=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:M.exitCode})}$provideTasks(M,U){const O=this._handlers.get(M);if(!O)return Promise.reject(new Error("no handler found"));const $=[],B=(0,L.asPromise)(()=>O.provider.provideTasks(n.CancellationToken.None)).then(x=>this.provideTasksInternal(U,$,O,x));return new Promise(x=>{B.then(j=>{Promise.all($).then(()=>{x(j)})})})}async $resolveTask(M,U){const O=this._handlers.get(M);if(!O)return Promise.reject(new Error("no handler found"));if(U.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${O.type}].`);const $=await p.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask($,n.CancellationToken.None);if(!B)return;this.checkDeprecation(B,O);const x=p.from(B,O.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(x.execution)&&await this.addCustomExecution(x,B,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,U,O){const $=await this._proxy.$createTaskId(M);!O&&!this._providedCustomExecutions2.has($)&&this._notProvidedCustomExecutions.add($),this._providedCustomExecutions2.set($,U.execution)}async getTaskExecution(M,U){if(typeof M=="string"){const B=this._taskExecutionPromises.get(M);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let O=this._taskExecutionPromises.get(M.id);if(O)return O;const $=new Promise(async(B,x)=>{const j=U||await p.to(M.task,this._workspaceProvider,this._providedCustomExecutions2);j?B(new b(this,M.id,j)):x("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(M.id,$),$.then(B=>(this._taskExecutions.set(M.id,B),B),B=>Promise.reject(B))}checkDeprecation(M,U){M._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let O=this._notProvidedCustomExecutions.values(),$=O.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=O.next()}};N=Ve([xe(0,u.IExtHostRpcService),xe(1,h.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,T.IExtHostTerminalService),xe(6,P.ILogService),xe(7,E.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let G=class extends N{constructor(M,U,O,$,B,x,j,H){super(M,U,O,$,B,x,j,H);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(M,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const O=p.from(U,M);if(O===void 0)throw new Error("Task is not valid");if(f.is(O.execution))await this.addCustomExecution(O,U,!1);else throw new a.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),U);return this._proxy.$executeTask(O).catch(B=>{throw new Error(B)}),$}provideTasksInternal(M,U,O,$){const B=[];if($)for(let x of $){this.checkDeprecation(x,O),(!x.definition||!M[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const j=p.from(x,O.extension);j&&f.is(j.execution)?(B.push(j),U.push(this.addCustomExecution(j,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async resolveTaskInternal(M){if(f.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,U,O){}};G=Ve([xe(0,u.IExtHostRpcService),xe(1,h.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,T.IExtHostTerminalService),xe(6,P.ILogService),xe(7,E.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,c.createDecorator)("IExtHostTask")}),define(me[267],ge([0,1,20,55,30,79,23,10,8,24,9,13,2,146,176,121,43,129,266,31]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(w,y,p,S){this.configurationService=w,this.workspaceContextService=y,this.editorGroupsService=p,this.pathService=S}text(w,y,p={}){w=this.getContentPattern(w,p);const S=this.configurationService.getValue(),b=y&&y.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(y?.map(_.toWorkspaceFolder),p),type:2,contentPattern:w,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:S.search.usePCRE2||b||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles}}getContentPattern(w,y){const p=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const S={...w,wordSeparators:p.editor.wordSeparators};return this.isCaseSensitive(w,y)&&(S.isCaseSensitive=!0),this.isMultiline(w)&&(S.isMultiline=!0),S}file(w,y={}){return{...this.commonQuery(w,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(w,y){return w?(w=Array.isArray(w)?w.map(i):i(w),y?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],y={}){const p=this.handleIncludeExclude(y.includePattern,y.expandPatterns),S=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),b=w.length>1,F=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,y,S)):w.map(K=>this.getFolderQueryForRoot(K,y,S,b))).filter(K=>!!K),N={_reason:y._reason,folderQueries:F,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:S.pattern,includePattern:p.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const M=m.coalesce(m.flatten(this.editorGroupsService.groups.map(O=>O.editors.map($=>$.resource)))).filter(O=>(0,o.pathIncludedInQuery)(N,O.fsPath)),U=this.commonQueryFromFileList(M);return{...N,...U}}const G=y.extraFileResources&&y.extraFileResources.filter(K=>(0,o.pathIncludedInQuery)(N,K.fsPath));return N.extraFileResources=G&&G.length?G:void 0,N}commonQueryFromFileList(w){const y=[],p=new R.ResourceMap,S={};let b=!1;return w.forEach(F=>{if(F.scheme===k.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(F)){const G=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:D.dirname(F.fsPath)});let K=p.get(G);K||(b=!0,K={folder:G,includePattern:{}},y.push(K),p.set(G,K));const M=D.relative(G.fsPath,F.fsPath);(0,T.assertIsDefined)(K.includePattern)[M.replace(/\\/g,"/")]=!0}else F.fsPath&&(b=!0,S[F.fsPath]=!0)}),{folderQueries:y,includePattern:S,usingSearchPaths:!0,excludePattern:b?void 0:{"**/*":!0}}}isCaseSensitive(w,y){if(y.isSmartCase){if(w.isRegExp){if(n.containsUppercaseCharacter(w.pattern,!0))return!0}else if(n.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,h.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const y=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),S=(Array.isArray(w)?w:r(w)).map(U=>{const O=this.pathService.resolvedUserHome;return O?(0,C.untildify)(U,O.scheme===k.Schemas.file?O.fsPath:O.path):U}),b=L.groupBy(S,U=>y(U)?"searchPaths":"exprSegments"),F=(b.exprSegments||[]).map(U=>n.rtrim(U,"/")).map(U=>n.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),s(U))),N={},G=this.expandSearchPathPatterns(b.searchPaths||[]);G&&G.length&&(N.searchPaths=G);const K=m.flatten(F),M=t(...K);return M&&(N.pattern=M),N}getExcludesForFolder(w,y){return y.disregardExcludeSettings?void 0:(0,o.getExcludes)(w,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const y=m.flatten(w.map(S=>{let{pathPortion:b,globPortion:F}=v(S);F&&(F=l(F));const N=this.expandOneSearchPath(b);return m.flatten(N.map(G=>this.resolveOneSearchPathPattern(G,F)))})),p=new Map;return y.forEach(S=>{const b=S.searchPath.toString(),F=p.get(b);F?S.pattern&&(F.pattern=F.pattern||{},F.pattern[S.pattern]=!0):p.set(b,{searchPath:S.searchPath,pattern:S.pattern?t(S.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(w){if(D.isAbsolute(w)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==k.Schemas.file?[{searchPath:y[0].uri.with({path:w})}]:[{searchPath:u.URI.file(D.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=i(w),w.startsWith("../")||w===".."){const S=D.posix.resolve(y.path,w);return[{searchPath:y.with({path:S})}]}const p=l(w);return[{searchPath:y,pattern:p}]}else{if(w==="./"||w===".\\")return[];{const y=w.replace(/^\.[\/\\]/,""),S=this.workspaceContextService.getWorkspace().folders.map(b=>{const F=y.match(new RegExp(`^${n.escapeRegExpCharacters(b.name)}(?:/(.*)|$)`));return F?{match:F,folder:b}:null}).filter(T.isDefined);if(S.length)return S.map(b=>{const F=b.match[1];return{searchPath:b.folder.uri,pattern:F&&l(F)}});{const b=w.match(/\.[\/\\](.+)[\/\\]?/),F=b?b[1]:w,N=c.localize(0,null,F);throw new Error(N)}}}}resolveOneSearchPathPattern(w,y){const p=w.pattern&&y?`${w.pattern}/${y}`:w.pattern||y,S=[{searchPath:w.searchPath,pattern:p}];return p&&!p.endsWith("**")&&S.push({searchPath:w.searchPath,pattern:p+"/**"}),S}getFolderQueryForSearchPath(w,y,p){const S=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(w.searchPath),y,p,!1);return S?{...S,includePattern:w.pattern}:null}getFolderQueryForRoot(w,y,p,S){let b;const F=u.URI.isUri(w)?w:w.uri;if(p.searchPaths){const U=p.searchPaths.filter(O=>(0,A.isEqual)(O.searchPath,F))[0];if(U&&!U.pattern)return null;U&&(b=U.pattern)}const N=this.configurationService.getValue({resource:F}),K={...this.getExcludesForFolder(N,y)||{},...b||{}},M=u.URI.isUri(w)?(0,A.basename)(w):w.name;return{folder:F,folderName:S?M:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!N.search.followSymlinks}}};a=Ve([xe(0,g.IConfigurationService),xe(1,_.IWorkspaceContextService),xe(2,P.IEditorGroupsService),xe(3,E.IPathService)],a),e.QueryBuilder=a;function v(f){const w=f.match(/[\*\{\}\(\)\[\]\?]/);if(w){const y=w.index,p=f.substr(0,y).match(/[/|\\][^/\\]*$/);if(p){let S=f.substr(0,p.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:f.substr((p.index||0)+1)}}}return{pathPortion:f}}function t(...f){return f.length?f.reduce((w,y)=>(w[y]=!0,w),Object.create(null)):void 0}function r(f){return I.splitGlobAware(f,",").map(w=>w.trim()).filter(w=>!!w.length)}function s(f){return[`**/${f}/**`,`**/${f}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(f){return f.replace(/\\/g,"/")}function l(f){return i(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(f,w){f=m.distinct(f,S=>S.toString());const y=[],p=w.getWorkspace();return f&&f.forEach(S=>{let b;if(w.getWorkbenchState()===2)b=(0,A.relativePath)(p.folders[0].uri,S),b&&b!=="."&&(b="./"+b);else{const F=w.getWorkspaceFolder(S);if(F){const N=F.name;if(p.folders.filter(K=>K.name===N).length===1){const K=(0,A.relativePath)(F.uri,S);K===""?b=`./${F.name}`:b=`./${F.name}/${K}`}else b=S.fsPath}}b&&y.push(b)}),y}e.resolveResourcesForSearchIncludes=d}),define(me[268],ge([0,1,24,2,21,16,4,267,31,43]),function(Z,e,m,L,I,C,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function T(g,_){const P=_.activationEvents;if(!P)return Promise.resolve(void 0);const E=[],o=[];for(const i of P)if(/^workspaceContains:/.test(i)){const l=i.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||g.forceUsingSearch?o.push(l):E.push(l)}if(E.length===0&&o.length===0)return Promise.resolve(void 0);let a;const v=new Promise((i,l)=>{a=i}),t=i=>a({activationEvent:i}),r=Promise.all(E.map(i=>u(g,i,t))).then(()=>{}),s=h(g,_.identifier,o,t);return Promise.all([r,s]).then(()=>{a(void 0)}),v}e.checkActivateWorkspaceContainsExtension=T;async function u(g,_,P){for(const E of g.folders)if(await g.exists(m.joinPath(L.URI.revive(E),_))){P(`workspaceContains:${_}`);return}}async function h(g,_,P,E){if(P.length===0)return Promise.resolve(void 0);const o=new I.CancellationTokenSource,a=g.checkExists(g.folders,P,o.token),v=setTimeout(async()=>{o.cancel(),E(`workspaceContainsTimeout:${P.join(",")}`)},n);let t=!1;try{t=await a}catch(r){C.isPromiseCanceledError(r)||C.onUnexpectedError(r)}o.dispose(),clearTimeout(v),t&&E(`workspaceContains:${P.join(",")}`)}function c(g,_,P,E){const o=g.get(R.IInstantiationService),a=g.get(D.ISearchService),t=o.createInstance(k.QueryBuilder).file(_.map(r=>(0,A.toWorkspaceFolder)(L.URI.revive(r))),{_reason:"checkExists",includePattern:P,exists:!0});return a.fileSearch(t,E).then(r=>!!r.limitHit,r=>C.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=c});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(Z,m):I?I.value=m:e.set(Z,m),m},Be=this&&this.__classPrivateFieldGet||function(Z,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Z):L?L.value:e.get(Z)};define(me[40],ge([0,1,165,8,72,24,17,6,23,2,12,5,38,226,93,37,36,224,16,26,22,199,7,122,4,27,68,14,84,52,33,3,268,91,201]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o,a,v,t,r,s,i,l,d,f,w,y,p,S,b,F){"use strict";var N,G,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let M=class Hn extends k.Disposable{constructor(B,x,j,H,X,J,fe,_e,Se,Le){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=x,this._extHostContext=j,this._initData=fe,this._extHostWorkspace=H,this._extHostConfiguration=X,this._logService=J,this._extHostTunnelService=Se,this._extHostTerminalService=Le,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(T.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(T.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(T.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new b.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=B.createChild(new f.ServiceCollection([c.IExtHostStorage,this._storage],[b.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(Ne=>We.add(o.ExtensionIdentifier.toKey(Ne))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ne,Ke,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ne,E.transformErrorForSerialization(Ke),z)},actualActivateExtension:async(Ne,Ke)=>{if(We.has(o.ExtensionIdentifier.toKey(Ne)))return await this._mainThreadExtensionsProxy.$activateExtension(Ne,Ke),new h.HostExtension;const z=this._registry.getExtensionDescription(Ne);return this._activateExtension(z,Ke)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){E.onUnexpectedError(B)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._registry.getAllExtensionDescriptions().map(X=>X.identifier).filter(X=>this.isActivated(X)).map(X=>this._deactivate(X))}catch(x){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,x){return this._activator.activateByEvent(B,x)}_activateById(B,x){return this._activator.activateById(B,x)}activateByIdWithErrors(B,x){return this._activateById(B,x).then(()=>{const j=this._activator.getActivatedExtension(B);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=D.TernarySearchTree.forPaths(),x=this._registry.getAllExtensionDescriptions().map(j=>{if(!!this._getEntryPoint(j))return this._hostUtils.realpath(j.extensionLocation.fsPath).then(H=>B.set(A.URI.file(H).fsPath,j))});this._extensionPathIndex=Promise.all(x).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let x=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return x;const j=this._activator.getActivatedExtension(B);if(!j)return x;try{typeof j.module.deactivate=="function"&&(x=Promise.resolve(j.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,k.dispose)(j.subscriptions)}catch(H){this._logService.error(H)}return x}async _activateExtension(B,x){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,x).then(j=>{const H=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,x),this._logExtensionActivationTimes(B,x,"success",H),j},j=>{throw this._logExtensionActivationTimes(B,x,"failure"),j})}_logExtensionActivationTimes(B,x,j,H){const X=U(B,x);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...X,...H||{},outcome:j})}_doActivateExtension(B,x){const j=U(B,x);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const H=this._getEntryPoint(B);if(!H)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(x)}`),this._logService.flush();const X=new h.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this._loadCommonJSModule(B.identifier,(0,C.joinPath)(B.extensionLocation,H),X),this._loadExtensionContext(B)]).then(J=>(I.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Hn._callActivate(this._logService,B.identifier,J[0],J[1],X))).then(J=>(I.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),J))}_loadExtensionContext(B){const x=new v.ExtensionGlobalMemento(B,this._storage),j=new v.ExtensionMemento(B.identifier.value,!1,this._storage),H=new F.ExtensionSecrets(B,this._secretState),X=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,J=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([x.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let _e;return Object.freeze({globalState:x,workspaceState:j,secrets:H,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Se){return L.join(B.extensionLocation.fsPath,Se)},get storagePath(){return fe._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(B).fsPath},get logPath(){return L.join(fe._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return A.URI.joinPath(fe._initData.logsLocation,B.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(B)},get globalStorageUri(){return fe._storagePath.globalValue(B)},get extensionMode(){return X},get extension(){return _e===void 0&&(_e=new O(fe,B.identifier,B,J)),_e},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(B),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,x,j,H,X){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,x,j,H,X).then(J=>new h.ActivatedExtension(!1,null,X.build(),j,J,H.subscriptions))}static _callActivateOptional(B,x,j,H,X){if(typeof j.activate=="function")try{X.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${x.value}`);const J=typeof global=="object"?global:self,fe=j.activate.apply(J,[H]);return X.activateCallStop(),X.activateResolveStart(),Promise.resolve(fe).then(_e=>(X.activateResolveStop(),_e))}catch(J){return Promise.reject(J)}else return Promise.resolve(j)}_activateOneStartupFinished(B,x){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:x}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const x of B.activationEvents)x==="onStartupFinished"&&this._activateOneStartupFinished(B,x)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,X=>{this._logService.error(X)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(X=>this._handleWorkspaceContainsEagerExtensions(X.added)));const x=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(x),H=Promise.all([B,j]).then(()=>{});return Promise.race([H,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(x=>this._handleWorkspaceContainsEagerExtension(B,x))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,x){if(this.isActivated(x.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={folders:B.map(J=>J.uri),forceUsingSearch:j,exists:J=>this._hostUtils.exists(J.fsPath),checkExists:(J,fe,_e)=>this._mainThreadWorkspaceProxy.$checkExists(J,fe,_e)},X=await(0,S.checkActivateWorkspaceContainsExtension)(H,x);if(!!X)return this._activateById(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:X.activationEvent}).then(void 0,J=>this._logService.error(J))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:x}=this._initData.environment;if(!B||!x)throw new Error(m.localize(0,null));const j=await this._loadCommonJSModule(null,x,new h.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(m.localize(1,null,x.toString()));return new Promise((H,X)=>{const J=(Se,Le)=>{Se?X(Se):H(typeof Le=="number"&&Le>0?1:0)},fe=(0,C.originalFSPath)(x),_e=j.run(fe,J);_e&&_e.then&&_e.then(()=>{H(0)}).catch(Se=>{X(Se.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,x){return this._resolvers[B]=x,(0,k.toDisposable)(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const x=B.indexOf("+");if(x===-1)throw new Error("Not an authority that can be resolved!");const j=B.substr(0,x);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(B,x){const{authorityPrefix:j,resolver:H}=await this._activateAndGetResolver(B);if(!H)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),I.mark(`code/extHost/willResolveAuthority/${j}`);const X=await H.resolve(B,{resolveAttempt:x});I.mark(`code/extHost/didResolveAuthorityOK/${j}`);const J={authority:B,host:X.host,port:X.port,connectionToken:X.connectionToken},fe={extensionHostEnv:X.extensionHostEnv,isTrusted:X.isTrusted};return{type:"ok",value:{authority:J,options:fe,tunnelInformation:{environmentTunnels:X.environmentTunnels}}}}catch(X){if(I.mark(`code/extHost/didResolveAuthorityError/${j}`),X instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X}}async $getCanonicalURI(B,x){const{authorityPrefix:j,resolver:H}=await this._activateAndGetResolver(B);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const X=A.URI.revive(x);if(typeof H.getCanonicalURI=="undefined")return X;const J=await(0,R.asPromise)(()=>H.getCanonicalURI(X));return J||X}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,x){return x===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(B,!1))}async $activate(B,x){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,x),!0):!1}async $deltaExtensions(B,x){B.forEach(H=>H.extensionLocation=A.URI.revive(H.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(x.map(async H=>{const X=this._registry.getExtensionDescription(H);if(!X)return;const J=await this._hostUtils.realpath(X.extensionLocation.fsPath);j.delete(A.URI.file(J).fsPath)})),await Promise.all(B.map(async H=>{const X=await this._hostUtils.realpath(H.extensionLocation.fsPath);j.set(A.URI.file(X).fsPath,H)})),this._registry.deltaExtensions(B,x),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let x=a.VSBuffer.alloc(B),j=Math.random()%256;for(let H=0;H<B;H++)x.writeUInt8(j,H);return x}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};M=Ve([xe(0,s.IInstantiationService),xe(1,e.IHostUtils),xe(2,d.IExtHostRpcService),xe(3,g.IExtHostWorkspace),xe(4,u.IExtHostConfiguration),xe(5,n.ILogService),xe(6,i.IExtHostInitDataService),xe(7,l.IExtensionStoragePaths),xe(8,w.IExtHostTunnelService),xe(9,y.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function U($,B){return{id:$.identifier.value,name:$.name,extensionVersion:$.version,publisherDisplayName:$.publisher,activationEvents:$.activationEvents?$.activationEvents.join(","):null,isBuiltin:$.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class O{constructor(B,x,j,H){N.set(this,void 0),G.set(this,void 0),K.set(this,void 0),rt(this,N,B,"f"),rt(this,G,x,"f"),rt(this,K,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=H}get isActive(){return Be(this,N,"f").isActivated(Be(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,N,"f").getExtensionExports(Be(this,K,"f"))}activate(){return Be(this,N,"f").activateByIdWithErrors(Be(this,K,"f"),{startup:!1,extensionId:Be(this,G,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=O,N=new WeakMap,G=new WeakMap,K=new WeakMap}),define(me[53],ge([0,1,8,2,3,17,5,7,125,37,40,45,215,38,209,14,4,13,34,51]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let a=class{constructor(f,w,y,p,S,b){this._workspaceService=w,this._extensionService=y,this._editorsService=p,this._configurationService=S,this._editorTabs=b,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=f.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(N=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,w){const y=f;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let p=`debug:${encodeURIComponent(y.path||"")}`,S="?";return w&&(p+=`${S}session=${encodeURIComponent(w.id)}`,S="&"),p+=`${S}ref=${y.sourceReference}`,L.URI.parse(p)}else{if(y.path)return L.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const w=[];for(const y of f.getAllExtensionDescriptions())if(y.contributes){const p=y.contributes.debuggers;if(p&&p.length>0)for(const S of p)(0,c.isDebuggerMainContribution)(S)&&w.push(S.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(w=>f.push(w)),f}addBreakpoints(f){this.startBreakpoints();const w=f.filter(S=>{const b=S.id;return this._breakpoints.has(b)?!1:(this._breakpoints.set(b,S),!0)});this.fireBreakpointChanges(w,[],[]);const y=[],p=new Map;for(const S of w)if(S instanceof k.SourceBreakpoint){let b=p.get(S.location.uri.toString());b||(b={type:"sourceMulti",uri:S.location.uri,lines:[]},p.set(S.location.uri.toString(),b),y.push(b)),b.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character})}else S instanceof k.FunctionBreakpoint&&y.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(f){this.startBreakpoints();const w=f.filter(b=>this._breakpoints.delete(b.id));this.fireBreakpointChanges([],w,[]);const y=w.filter(b=>b instanceof k.SourceBreakpoint).map(b=>b.id),p=w.filter(b=>b instanceof k.FunctionBreakpoint).map(b=>b.id),S=w.filter(b=>b instanceof k.DataBreakpoint).map(b=>b.id);return this._debugServiceProxy.$unregisterBreakpoints(y,p,S)}startDebugging(f,w,y){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,w,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,debugUI:y.debugUI})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,w,y){if(!w)return new k.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:p,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,y,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,p),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(f,w,y){if(!y)return new k.Disposable(()=>{});if(!this.definesDebugType(f,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:p,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,p),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(f,w){if(!w)return new k.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:y,factory:w}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==w)})}async $runInTerminal(f,w){return Promise.resolve(void 0)}async $substituteVariables(f,w){if(!this._variableResolver){const[S,b]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(S||[],this._editorsService,b)}let y;const p=await this.getFolder(f);return p&&(y={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,w)}createDebugAdapter(f,w){if(f.type==="implementation")return new i(f.implementation)}createSignService(){}async $startDASession(f,w){const y=this,p=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const b=this.convertToDto(S),F=this.createDebugAdapter(b,p);if(!F)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const N=F;return this._debugAdapters.set(f,N),this.getDebugAdapterTrackers(p).then(G=>(G&&this._debugAdaptersTrackers.set(f,G),N.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const M=K,U={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(M.arguments.value);U.body={signature:O},N.sendResponse(U)}else throw new Error("no signer")}catch(O){U.success=!1,U.message=O.message,N.sendResponse(U)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(K),K=(0,c.convertToVSCPaths)(K,!0),y._debugServiceProxy.$acceptDAMessage(f,K)}),N.onError(K=>{G&&G.onError&&G.onError(K),this._debugServiceProxy.$acceptDAError(f,K.name,K.message,K.stack)}),N.onExit(K=>{G&&G.onExit&&G.onExit((0,P.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,P.withNullAsUndefined)(K),void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),N.startSession()))})}$sendDAMessage(f,w){w=(0,c.convertToDAPaths)(w,!1);const y=this._debugAdaptersTrackers.get(f);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(w);const p=this._debugAdapters.get(f);p&&p.sendMessage(w)}$stopDASession(f){const w=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),w&&w.onWillStopSession&&w.onWillStopSession();const y=this._debugAdapters.get(f);return this._debugAdapters.delete(f),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const w=[],y=[],p=[];if(f.added)for(const S of f.added){const b=S.id;if(b&&!this._breakpoints.has(b)){let F;if(S.type==="function")F=new k.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage);else if(S.type==="data")F=new k.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage);else{const N=L.URI.revive(S.uri);F=new k.SourceBreakpoint(new k.Location(N,new k.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage)}F._id=b,this._breakpoints.set(b,F),w.push(F)}}if(f.removed)for(const S of f.removed){const b=this._breakpoints.get(S);b&&(this._breakpoints.delete(S),y.push(b))}if(f.changed){for(const S of f.changed)if(S.id){const b=this._breakpoints.get(S.id);if(b){if(b instanceof k.FunctionBreakpoint&&S.type==="function"){const F=b;F.enabled=S.enabled,F.condition=S.condition,F.hitCondition=S.hitCondition,F.logMessage=S.logMessage,F.functionName=S.functionName}else if(b instanceof k.SourceBreakpoint&&S.type==="source"){const F=b;F.enabled=S.enabled,F.condition=S.condition,F.hitCondition=S.hitCondition,F.logMessage=S.logMessage,F.location=new k.Location(L.URI.revive(S.uri),new k.Position(S.line,S.character))}p.push(b)}}}this.fireBreakpointChanges(w,y,p)}$provideDebugConfigurations(f,w,y){return(0,C.asPromise)(async()=>{const p=this.getConfigProviderByHandle(f);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(w);return p.provideDebugConfigurations(S,y)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(f,w,y,p){return(0,C.asPromise)(async()=>{const S=this.getConfigProviderByHandle(f);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const b=await this.getFolder(w);return S.resolveDebugConfiguration(b,y,p)})}$resolveDebugConfigurationWithSubstitutedVariables(f,w,y,p){return(0,C.asPromise)(async()=>{const S=this.getConfigProviderByHandle(f);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const b=await this.getFolder(w);return S.resolveDebugConfigurationWithSubstitutedVariables(b,y,p)})}async $provideDebugAdapter(f,w){const y=this.getAdapterDescriptorFactoryByHandle(f);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(w);return this.getAdapterDescriptor(y,p).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(f){const w=await this.getSession(f);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(f){const w=await this.getSession(f);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,w){const y=await this.getSession(f);y&&y._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(f,w){const p={session:await this.getSession(f),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(f){if(f instanceof k.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof k.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const w=this._adapterFactories.filter(y=>y.type===f);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(f){const w=this._adapterFactories.filter(y=>y.handle===f);if(w.length>0)return w[0].factory}getConfigProviderByHandle(f){const w=this._configProviders.filter(y=>y.handle===f);if(w.length>0)return w[0].provider}definesDebugType(f,w){if(f.contributes){const y=f.contributes.debuggers;if(y&&y.length>0){for(const p of y)if(p.label&&p.type&&p.type===w)return!0}}return!1}getDebugAdapterTrackers(f){const y=f.configuration.type,p=this._trackerFactories.filter(S=>S.type===y||S.type==="*").map(S=>(0,C.asPromise)(()=>S.factory.createDebugAdapterTracker(f)).then(b=>b,b=>null));return Promise.race([Promise.all(p).then(S=>{const b=S.filter(F=>!!F);if(b.length>0)return new s(b)}),new Promise((S,b)=>{const F=setTimeout(()=>{clearTimeout(F),b(new Error("timeout"))},1e3)})]).catch(S=>{})}async getAdapterDescriptor(f,w){const y=w.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new k.DebugAdapterServer(y));if(f){const S=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>f.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,S))).then(b=>{if(b)return b})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,p))}daExecutableFromPackage(f,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,w,y){(f.length>0||w.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:w,changed:y}))}async getSession(f){if(f)if(typeof f=="string"){const w=this._debugSessions.get(f);if(w)return w}else{let w=this._debugSessions.get(f.id);if(!w){const y=await this.getFolder(f.folderUri),p=f.parent?this._debugSessions.get(f.parent):void 0;w=new v(this._debugServiceProxy,f.id,f.type,f.name,y,f.configuration,p),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(f){if(f){const w=L.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};a=Ve([xe(0,g.IExtHostRpcService),xe(1,A.IExtHostWorkspace),xe(2,n.IExtHostExtensionService),xe(3,T.IExtHostDocumentsAndEditors),xe(4,h.IExtHostConfiguration),xe(5,o.IExtHostEditorTabs)],a),e.ExtHostDebugServiceBase=a;class v{constructor(f,w,y,p,S,b,F){this._debugServiceProxy=f,this._id=w,this._type=y,this._name=p,this._workspaceFolder=S,this._configuration=b,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}get parentSession(){return this._parentSession}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,w)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=v;class t{constructor(f){this.value=Object.freeze({append(w){f.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class r extends u.AbstractVariableResolverService{constructor(f,w,y,p,S){function b(){if(w){const F=w.activeEditor();if(F)return F.document.uri;const N=p.tabs.filter(G=>G.isActive);if(N.length>0)return N[0].resource}}super({getFolderUri:F=>{const N=f.filter(G=>G.name===F);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(F,N)=>y.getConfiguration(void 0,F).get(N),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=b();if(F)return m.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const F=b();if(F){const N=S.getWorkspaceFolder(F);if(N)return m.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(w){const F=w.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(w){const F=w.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=r;class s{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(w=>w.onError?w.onError(f):void 0)}onExit(f,w){this.trackers.forEach(y=>y.onExit?y.onExit(f,w):void 0)}}class i extends D.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends a{constructor(f,w,y,p,S,b){super(f,w,y,p,S,b)}createVariableResolver(f,w,y){return new r(f,w,y,this._editorTabs)}};l=Ve([xe(0,g.IExtHostRpcService),xe(1,A.IExtHostWorkspace),xe(2,n.IExtHostExtensionService),xe(3,T.IExtHostDocumentsAndEditors),xe(4,h.IExtHostConfiguration),xe(5,o.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(me[269],ge([0,1,72,2,5,38,36,26,14,27,4,40,34,12]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(o,a,v,t,r,s,i){this._apiFactory=o,this._extensionRegistry=a,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,a,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,a,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let a of o.nodeModuleName)this._factories.set(a,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(a=>o.alternativeModuleName(a))}};c=Ve([xe(2,n.IInstantiationService),xe(3,C.IExtHostConfiguration),xe(4,T.IExtHostExtensionService),xe(5,A.IExtHostInitDataService),xe(6,h.ILogService)],c),e.RequireInterceptor=c;class g{constructor(o,a,v,t,r){this._apiFactory=o,this._extensionPaths=a,this._extensionRegistry=v,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,a){const v=this._extensionPaths.findSubstr(a.fsPath);if(v){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(o,a){this.nodeModuleName="keytar";const{environment:v}=a,t=o.getProxy(I.MainContext.MainThreadKeytar);if(v.appRoot){let r=v.appRoot.fsPath;u.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,i)=>t.$setPassword(r,s,i),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(o,a){return this._impl}alternativeModuleName(o){const a=o.length;if(a<=7||!this.alternativeNames)return;const v=a-7;if((o.charAt(v)==="/"||o.charAt(v)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};_=Ve([xe(0,D.IExtHostRpcService),xe(1,A.IExtHostInitDataService)],_);let P=class{constructor(o,a,v){this._extensionPaths=o,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(I.MainContext.MainThreadTelemetry);const t=v.getProxy(I.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=L.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,s)}}load(o,a,v){const t=this._extensionPaths.findSubstr(a.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(o),this._impl}callOriginal(o,a){return this.sendNoForwardTelemetry(),this._original(o,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([xe(2,D.IExtHostRpcService)],P)}),define(me[270],ge([0,1,171,11,7,210,37,40,45,38,33,14,53,194,17,211,51]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends u.ExtHostDebugServiceBase{constructor(a,v,t,r,s,i,l){super(a,v,t,r,s,l);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(a,v){switch(a.type){case"server":return new C.SocketDebugAdapter(a);case"pipeServer":return new C.NamedPipeDebugAdapter(a);case"executable":return new C.ExecutableDebugAdapter(a,v.type)}return super.createDebugAdapter(a,v)}daExecutableFromPackage(a,v){const t=C.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),a.type);if(t)return new I.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new h.SignService}async $runInTerminal(a,v){if(a.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(b=>{this._integratedTerminalInstances.onTerminalClosed(b)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),i=a.title||m.localize(0,null),l=JSON.stringify({shell:r,shellArgs:s});let d=await this._integratedTerminalInstances.checkout(l,i),f,w=!1;if(d)f=a.cwd;else{const b={shellPath:r,shellArgs:s,cwd:a.cwd,name:i,iconPath:new I.ThemeIcon("debug")};w=!0,d=this._terminalService.createTerminalFromOptions(b,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,l)}d.show(!0);const y=await d.processId;w?await new Promise(b=>setTimeout(b,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?d.sendText("cls"):r.indexOf("bash")>=0?d.sendText("clear"):L.isWindows?d.sendText("cls"):d.sendText("clear"));const p=(0,g.prepareCommand)(r,a.args,f,a.env);d.sendText(p);const S=this.onDidTerminateDebugSession(b=>{b.id===v&&(this._integratedTerminalInstances.free(d),S.dispose())});return y}else if(a.kind==="external")return(0,g.runInExternalTerminal)(a,await this._configurationService.getConfigProvider());return super.$runInTerminal(a,v)}createVariableResolver(a,v,t){return new u.ExtHostVariableResolverService(a,v,t,this._editorTabs,this._workspaceService)}};P=Ve([xe(0,T.IExtHostRpcService),xe(1,R.IExtHostWorkspace),xe(2,k.IExtHostExtensionService),xe(3,D.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,n.IExtHostTerminalService),xe(6,_.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class E{constructor(){this._terminalInstances=new Map}async checkout(a,v){const r=[...this._terminalInstances.entries()].map(([s,i])=>(0,c.createCancelablePromise)(async l=>{if(s.name!==v||i.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await s.processId))return null;const d=Date.now();return i.lastUsedAt+E.minUseDelay>d||l.isCancellationRequested||i.config!==a?null:(i.lastUsedAt=d,s)}));return await(0,c.firstParallel)(r,s=>!!s)}insert(a,v){this._terminalInstances.set(a,{lastUsedAt:Date.now(),config:v})}free(a){const v=this._terminalInstances.get(a);v&&(v.lastUsedAt=-1)}onTerminalClosed(a){this._terminalInstances.delete(a)}}E.minUseDelay=1e3}),define(me[271],ge([0,1,8,2,113,37,53,45,38,43,33,14,27,71,10,12,66,51,24,80]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let a=class extends h.ExtHostTaskBase{constructor(t,r,s,i,l,d,f,w,y){super(t,r,s,i,l,d,f,w);this.workspaceService=s,this.editorTabs=y,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(c.Schemas.file,{scheme:c.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,r){const s=r;if(!r.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const i=h.TaskHandleDTO.from(s,this.workspaceService),l=await this._proxy.$getTaskExecution(i);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(l,r);return this._proxy.$executeTask(i).catch(()=>{}),d}else{const i=h.TaskDTO.from(r,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));h.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,r,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),r);return this._proxy.$executeTask(i).catch(()=>{}),l}}provideTasksInternal(t,r,s,i){const l=[];if(i)for(let d of i){this.checkDeprecation(d,s),(!d.definition||!t[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const f=h.TaskDTO.from(d,s.extension);f&&(l.push(f),h.CustomExecutionDTO.is(f.execution)&&r.push(this.addCustomExecution(f,d,!0)))}return{tasks:l,extension:s.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const r=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(t,this._editorService,r,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let r=t&&t.length>0?t[0]:void 0;if(!r){const s=L.URI.file((0,o.homedir)());r=new A.WorkspaceFolder({uri:s,name:E.basename(s),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,r){const s=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(s),d=await this._workspaceProvider.getWorkspaceFolders2()??[],f=await this.getVariableResolver(d),w=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let y of r.variables)i.variables[y]=await f.resolveAsync(w,y);if(r.process!==void 0){let y;if(r.process.path!==void 0){y=r.process.path.split(m.delimiter);for(let p=0;p<y.length;p++)y[p]=await f.resolveAsync(w,y[p])}i.process=await I.win32.findExecutable(await f.resolveAsync(w,r.process.name),r.process.cwd!==void 0?await f.resolveAsync(w,r.process.cwd):void 0,y)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,r,s){return I.win32.findExecutable(t,r,s)}};a=Ve([xe(0,T.IExtHostRpcService),xe(1,u.IExtHostInitDataService),xe(2,C.IExtHostWorkspace),xe(3,k.IExtHostDocumentsAndEditors),xe(4,D.IExtHostConfiguration),xe(5,n.IExtHostTerminalService),xe(6,g.ILogService),xe(7,_.IExtHostApiDeprecationService),xe(8,P.IExtHostEditorTabs)],a),e.ExtHostTask=a}),define(me[272],ge([0,1,17,16,72,6,2,5,264,12,82,84,27,189,14,64,40,33]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(a,v,t,r){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(a,null,r),v=E._transform(v,this._rpcProtocol);const s=new T.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...v}),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(g.IURITransformerService,new g.URITransformerService(r)),s.set(_.IHostUtils,t);const i=new h.InstantiationService(s,!0),l=i.invokeFunction(y=>y.get(P.IExtHostTerminalService));this._disposables.add(l),this._logService=i.invokeFunction(y=>y.get(A.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(y=>y.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const d=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(p,S)=>{let b="",F,N;for(const G of S)b+=`
	at ${G.toString()}`,N=G.getFileName(),!F&&N&&(F=y.findSubstr(N));return d.set(p,F),`${p.name||"Error"}: ${p.message||""}${b}`}});const f=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(y=>{const p=L.transformErrorForSerialization(y),S=d.get(y);S?f.$onExtensionRuntimeError(S.identifier,p):w.$onUnexpectedError(p)})}terminate(a){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${a}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(a,v){a.extensions.forEach(r=>r.extensionLocation=R.URI.revive(v.transformIncomingURIs(r.extensionLocation))),a.environment.appRoot=R.URI.revive(v.transformIncomingURIs(a.environment.appRoot));const t=a.environment.extensionDevelopmentLocationURI;return t&&(a.environment.extensionDevelopmentLocationURI=t.map(r=>R.URI.revive(v.transformIncomingURIs(r)))),a.environment.extensionTestsLocationURI=R.URI.revive(v.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=R.URI.revive(v.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=R.URI.revive(v.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=R.URI.revive(v.transformIncomingURIs(a.logsLocation)),a.logFile=R.URI.revive(v.transformIncomingURIs(a.logFile)),a.workspace=v.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=E}),define(me[273],ge([0,1,8,21,60,30,24,46,31]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(u,h,c){this.config=u,this.provider=h,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&C.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&C.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const h=this.config.folderQueries||[];return new Promise((c,g)=>{const _=P=>{this.resultCount++,u(P)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const E=P.toString(),o=m.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,o)||this.matchFile(_,{base:P,basename:o})}),Promise.all(h.map(P=>this.searchInFolder(P,_))).then(P=>{c({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{g(new Error((0,I.toErrorMessage)(P)))})})}async searchInFolder(u,h){const c=new L.CancellationTokenSource,g=this.getSearchOptionsForFolder(u),_=this.initDirectoryTree(),P=new D.QueryGlobTester(this.config,u),E=!P.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(c),o=k.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,c.token),v=o.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(r=>{const s=m.posix.relative(u.folder.path,r.path);if(E){const i=m.basename(r.path);this.matchFile(h,{base:u.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(_,u.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,P,h),{providerTime:v,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(u){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),c=(0,D.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:c,includes:h,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},h,c,g){if(c===this.filePattern){const P=m.basename(this.filePattern);this.matchFile(g,{base:h,relativePath:this.filePattern,basename:P})}function _(P){const E=m.basename(P),o=m.dirname(P);let a=u[o];a||(a=u[o]=[],_(o)),a.push({base:h,relativePath:P,basename:E})}_(c)}matchDirectoryTree({rootEntries:u,pathToEntries:h},c,g){const _=this,P=this.filePattern;function E(o){const a=C.hasSiblingFn(()=>o.map(v=>v.basename));for(let v=0,t=o.length;v<t;v++){const r=o[v],{relativePath:s,basename:i}=r;if(!c.includedInQuerySync(s,i,P!==i?a:void 0))continue;const l=h[s];if(l)E(l);else{if(s===P)continue;_.matchFile(g,r)}if(_.isLimitHit)break}}E(u)}matchFile(u,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(h))}}class n{constructor(){this.sessions=new Map}fileSearch(u,h,c,g){const _=this.getSessionTokenSource(u.cacheKey),P=new A(u,h,_&&_.token);let E=0;const o=a=>{E+=a.length,c(a.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(P,n.BATCH_SIZE,o,g).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:a.stats}}))}clearCache(u){const h=this.getSessionTokenSource(u);h&&h.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new L.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:R.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,h,c,g){g.onCancellationRequested(()=>{u.cancel()});const _=E=>{E&&(P.push(E),h>0&&P.length>=h&&(c(P),P=[]))};let P=[];return u.search(_).then(E=>(P.length&&c(P),E),E=>(P.length&&c(P),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[134],ge([0,1,20,21,60,30,10,8,24,13,2,31]),function(Z,e,m,L,I,C,R,k,D,A,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(o,a,v,t){this.query=o,this.provider=a,this.fileUtils=v,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,a){const v=this.query.folderQueries||[],t=new L.CancellationTokenSource;return a.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new c(o);let i=!1;const l=(d,f)=>{if(!i&&!this.isLimitHit){const w=this.resultSize(d);_(d)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const y=this.resultSize(d);this.resultCount+=y,(y>0||!_(d))&&this.collector.add(d,f)}};Promise.all(v.map((d,f)=>this.searchInFolder(d,w=>l(w,f),t.token))).then(d=>{t.dispose(),this.collector.flush();const f=d.some(w=>!!w&&!!w.limitHit);r({limitHit:this.isLimitHit||f,messages:(0,m.flatten)(d.map(w=>w?.message?(0,A.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},d=>{t.dispose();const f=(0,I.toErrorMessage)(d);s(new Error(f))})})}resultSize(o){return _(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,a){const v=Array.isArray(o.ranges)?o.ranges:[o.ranges],t=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:v.slice(0,a),preview:{matches:t.slice(0,a),text:o.preview.text},uri:o.uri}}async searchInFolder(o,a,v){const t=new T.QueryGlobTester(this.query,o),r=[],s={report:d=>{if(!this.validateProviderResult(d))return;const f=o.folder.scheme===R.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(d.uri))):void 0,w=D.relativePath(o.folder,d.uri);if(w){const y=t.includedInQuery(w,k.basename(w),f);(0,A.isPromise)(y)?r.push(y.then(p=>{p&&a(d)})):y&&a(d)}}},i=this.getSearchOptionsForFolder(o),l=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,s,v);return r.length&&await Promise.all(r),l}validateProviderResult(o){if(_(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const a=(0,T.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),v=(0,T.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),t={folder:n.URI.from(o.folder),excludes:v,includes:a,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=u;function h(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class c{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,a=>this.sendItems(a))}add(o,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!D.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(g(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=c;function g(E){return _(E)?{preview:{matches:(0,m.mapArrayOrNot)(E.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:E.preview.text},ranges:(0,m.mapArrayOrNot)(E.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function _(E){return!!E.preview}e.extensionResultIsMatch=_;class P{constructor(o,a){this.maxBatchSize=o,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,a){!o||this.addItemToBatch(o,a)}addItems(o,a){!o||this.addItemsToBatch(o,a)}addItemToBatch(o,a){this.batch.push(o),this.batchSize+=a,this.onUpdate()}addItemsToBatch(o,a){this.batch=this.batch.concat(o),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(me[73],ge([0,1,6,5,4,273,14,64,12,2,134]),function(Z,e,m,L,I,C,R,k,D,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let T=class{constructor(g,_,P){this.extHostRpc=g,this._uriTransformer=_,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,_){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const P=this._handlePool++;return this._textSearchProvider.set(P,_),this._proxy.$registerTextSearchProvider(P,this._transformScheme(g)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(g,_){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const P=this._handlePool++;return this._fileSearchProvider.set(P,_),this._proxy.$registerFileSearchProvider(P,this._transformScheme(g)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(g,_,P,E){const o=u(P),a=this._fileSearchProvider.get(g);if(a)return this._fileSearchManager.fileSearch(o,a,v=>{this._proxy.$handleFileMatch(g,_,v.map(t=>t.resource))},E);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,_,P,E){const o=this._textSearchProvider.get(g);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const a=u(P);return this.createTextSearchManager(a,o).search(t=>this._proxy.$handleTextMatch(g,_,t),E)}$enableExtensionHostSearch(){}createTextSearchManager(g,_){return new n.TextSearchManager(g,_,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};T=Ve([xe(0,R.IExtHostRpcService),xe(1,k.IURITransformerService),xe(2,D.ILogService)],T),e.ExtHostSearch=T;function u(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(h),extraFileResources:c.extraFileResources&&c.extraFileResources.map(g=>A.URI.revive(g))}}e.reviveQuery=u;function h(c){return{...c,folder:A.URI.revive(c.folder)}}}),define(me[274],ge([0,1,21,16,3,48,2,118,109,147,81,42,5,232,231,44,233,38,234,235,236,217,237,45,40,238,218,241,242,243,67,220,248,249,250,93,33,252,221,15,7,255,69,133,37,36,55,206,240,86,132,71,53,73,12,64,14,27,244,203,52,66,229,253,202,68,92,258,256,257,230,63,251,254,91,51,123,246,70,247,10,191,245,200,239]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o,a,v,t,r,s,i,l,d,f,w,y,p,S,b,F,N,G,K,M,U,O,$,B,x,j,H,X,J,fe,_e,Se,Le,We,Ne,Ke,z,ee,re,le,Y,oe,ve,Me,je,Qe,et,ke,ct,Q,te,pe,ze,tt,st,lt,vt,Dt,ue,Ie,Ue,Ge,$e,ot,Re,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(ze.IExtHostFileSystemInfo),we=ne.get(ke.IExtHostConsumerFileSystem),Fe=ne.get(s.IExtHostExtensionService),qe=ne.get(j.IExtHostWorkspace),He=ne.get(Dt.IExtHostTelemetry),Je=ne.get(P.IExtHostConfiguration),nt=ne.get(z.IURITransformerService),ae=ne.get(ee.IExtHostRpcService),Ee=ne.get(N.IExtHostStorage),ce=ne.get(et.IExtensionStoragePaths),q=ne.get(Ke.ILogService),Te=ne.get(oe.IExtHostTunnelService),Pe=ne.get(ve.IExtHostApiDeprecationService),Ye=ne.get(x.IExtHostWindow),Xe=ne.get(lt.IExtHostSecretState),at=ne.get(vt.IExtHostEditorTabs);ae.set(u.ExtHostContext.ExtHostFileSystemInfo,be),ae.set(u.ExtHostContext.ExtHostLogService,q),ae.set(u.ExtHostContext.ExtHostWorkspace,qe),ae.set(u.ExtHostContext.ExtHostConfiguration,Je),ae.set(u.ExtHostContext.ExtHostExtensionService,Fe),ae.set(u.ExtHostContext.ExtHostStorage,Ee),ae.set(u.ExtHostContext.ExtHostTunnelService,Te),ae.set(u.ExtHostContext.ExtHostWindow,Ye),ae.set(u.ExtHostContext.ExtHostSecretState,Xe),ae.set(u.ExtHostContext.ExtHostTelemetry,He),ae.set(u.ExtHostContext.ExtHostEditorTabs,at);const wt=ae.set(u.ExtHostContext.ExtHostDecorations,ne.get(Se.IExtHostDecorations)),_t=ae.set(u.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(r.IExtHostDocumentsAndEditors)),ht=ae.set(u.ExtHostContext.ExtHostCommands,ne.get(g.IExtHostCommands)),gt=ae.set(u.ExtHostContext.ExtHostTerminalService,ne.get(G.IExtHostTerminalService)),ft=ae.set(u.ExtHostContext.ExtHostDebugService,ne.get(We.IExtHostDebugService)),Tt=ae.set(u.ExtHostContext.ExtHostSearch,ne.get(Ne.IExtHostSearch)),yt=ae.set(u.ExtHostContext.ExtHostTask,ne.get(Le.IExtHostTask)),xt=ae.set(u.ExtHostContext.ExtHostOutputService,ne.get(y.IExtHostOutputService)),Bt=ae.set(u.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(ae)),It=ae.set(u.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ae,_t)),$t=ae.set(u.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(ae,_t,q)),tn=ae.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(q,It,ae.getProxy(u.MainContext.MainThreadBulkEdits))),bt=ae.set(u.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(ae,ht,_t,It,ce)),Xt=ae.set(u.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(q,bt)),zt=ae.set(u.ExtHostContext.ExtHostNotebookEditors,new ot.ExtHostNotebookEditors(q,ae,bt)),nn=ae.set(u.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(ae,de,bt,q)),rn=ae.set(u.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(ae,bt)),Pt=ae.set(u.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(ae,_t)),Jt=ae.set(u.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(ae.getProxy(u.MainContext.MainThreadTreeViews),ht,q)),wn=ae.set(u.ExtHostContext.ExtHostEditorInsets,new J.ExtHostEditorInsets(ae.getProxy(u.MainContext.MainThreadEditorInsets),Pt,de)),Wt=ae.set(u.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(ae,q)),pt=ae.set(u.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(ae,nt,It,ht,Wt,q,Pe)),sn=ae.set(u.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ae,pt)),Ft=ae.set(u.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(ae,q,_t)),Vt=ae.set(u.ExtHostContext.ExtHostQuickOpen,(0,S.createExtHostQuickOpen)(ae,qe,ht)),Yt=ae.set(u.ExtHostContext.ExtHostSCM,new b.ExtHostSCM(ae,ht,q)),on=ae.set(u.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(ae,ht,It)),dn=ae.set(u.ExtHostContext.ExtHostProgress,new p.ExtHostProgress(ae.getProxy(u.MainContext.MainThreadProgress))),bn=ae.set(u.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(ae)),hn=ae.set(u.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(ae)),an=ae.set(u.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(ae)),En=ae.set(u.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(ae,ht)),jt=ae.set(u.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(ae,{remote:de.remote},qe,q,Pe)),qt=ae.set(u.ExtHostContext.ExtHostWebviewPanels,new te.ExtHostWebviewPanels(ae,jt,qe)),_n=ae.set(u.ExtHostContext.ExtHostCustomEditors,new Q.ExtHostCustomEditors(ae,It,ce,jt,qt)),Sn=ae.set(u.ExtHostContext.ExtHostWebviewViews,new ct.ExtHostWebviewViews(ae,jt)),Gt=ae.set(u.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ae,ht)),yn=ae.set(u.ExtHostContext.ExtHostUriOpeners,new st.ExtHostUriOpeners(ae));ae.set(u.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ae,bt,_t,ht));const Zt=(0,X.values)(u.ExtHostContext);ae.assertRegistered(Zt);const Dn=new pe.ExtHostBulkEdits(ae,_t),Cn=new c.ExtHostClipboard(ae),Kt=new w.ExtHostMessageService(ae,q),fn=new o.ExtHostDialogs(ae),Ht=new F.ExtHostStatusBar(ae,ht.converter),Lt=new f.ExtHostLanguages(ae,It);return h.ExtHostApiCommands.register(ht),function(Oe,Rt,Qt){const Et=function(){let ie=!Oe.isUnderDevelopment;function he(Ae){ie||(q.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Ae(ut){if(Array.isArray(ut))ut.forEach(Ae);else if(typeof ut=="string")he(ut);else{const St=ut;typeof St.scheme=="undefined"&&he(ut),!Oe.enableProposedApi&&typeof St.exclusive=="boolean"&&(0,H.throwProposedApiError)(Oe)}return ut}}(),kn={getSession(ie,he,Ae){return Ae?.forceNewSession&&(0,H.checkProposedApiEnabled)(Oe),an.getSession(Oe,ie,he,Ae)},get onDidChangeSessions(){return an.onDidChangeSessions},registerAuthenticationProvider(ie,he,Ae,ut){return an.registerAuthenticationProvider(ie,he,Ae,ut)}},In={registerCommand(ie,he,Ae){return ht.registerCommand(!0,ie,he,Ae)},registerTextEditorCommand(ie,he,Ae){return ht.registerCommand(!0,ie,(...ut)=>{const St=Pt.getActiveTextEditor();if(!St){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}return St.edit(kt=>{he.apply(Ae,[St,kt,...ut])}).then(kt=>{kt||q.warn("Edits from command "+ie+" were not applied.")},kt=>{q.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,he,Ae)=>((0,H.checkProposedApiEnabled)(Oe),ht.registerCommand(!0,ie,async(...ut)=>{const St=_t.activeEditor(!0);if(!St){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(St.id);he.apply(Ae,[kt,...ut])})),executeCommand(ie,...he){return ht.executeCommand(ie,...he)},getCommands(ie=!1){return ht.getCommands(ie)}},mn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return Cn.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return He.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return He.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return Ye.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return Bt.createAppUri(ie);try{return await Ye.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(he){if((0,$e.matchesScheme)(ie,Ge.Schemas.http)||(0,$e.matchesScheme)(ie,Ge.Schemas.https))return ie;throw he}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=de.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Pn={createTestController(ie,he){return Gt.createTestController(ie,he)},createTestObserver(){return(0,H.checkProposedApiEnabled)(Oe),Gt.createTestObserver()},runTests(ie){return(0,H.checkProposedApiEnabled)(Oe),Gt.runTests(ie)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Oe),Gt.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Oe),Gt.results}},Tn={getExtension(ie){const he=Rt.getExtensionDescription(ie);if(he)return new s.Extension(Fe,Oe.identifier,he,gn)},get all(){return Rt.getAllExtensionDescriptions().map(ie=>new s.Extension(Fe,Oe.identifier,ie,gn))},get onDidChange(){return Rt.onDidChange}},ln={createDiagnosticCollection(ie){return Wt.createDiagnosticCollection(Oe.identifier,ie)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:ie=>Wt.getDiagnostics(ie),getLanguages(){return Lt.getLanguages()},setTextDocumentLanguage(ie,he){return Lt.changeLanguage(ie.uri,he)},match(ie,he){return(0,n.score)(U.LanguageSelector.from(ie),he.uri,he.languageId,!0)},registerCodeActionsProvider(ie,he,Ae){return pt.registerCodeActionProvider(Oe,Et(ie),he,Ae)},registerCodeLensProvider(ie,he){return pt.registerCodeLensProvider(Oe,Et(ie),he)},registerDefinitionProvider(ie,he){return pt.registerDefinitionProvider(Oe,Et(ie),he)},registerDeclarationProvider(ie,he){return pt.registerDeclarationProvider(Oe,Et(ie),he)},registerImplementationProvider(ie,he){return pt.registerImplementationProvider(Oe,Et(ie),he)},registerTypeDefinitionProvider(ie,he){return pt.registerTypeDefinitionProvider(Oe,Et(ie),he)},registerHoverProvider(ie,he){return pt.registerHoverProvider(Oe,Et(ie),he,Oe.identifier)},registerEvaluatableExpressionProvider(ie,he){return pt.registerEvaluatableExpressionProvider(Oe,Et(ie),he,Oe.identifier)},registerInlineValuesProvider(ie,he){return pt.registerInlineValuesProvider(Oe,Et(ie),he,Oe.identifier)},registerDocumentHighlightProvider(ie,he){return pt.registerDocumentHighlightProvider(Oe,Et(ie),he)},registerLinkedEditingRangeProvider(ie,he){return pt.registerLinkedEditingRangeProvider(Oe,Et(ie),he)},registerReferenceProvider(ie,he){return pt.registerReferenceProvider(Oe,Et(ie),he)},registerRenameProvider(ie,he){return pt.registerRenameProvider(Oe,Et(ie),he)},registerDocumentSymbolProvider(ie,he,Ae){return pt.registerDocumentSymbolProvider(Oe,Et(ie),he,Ae)},registerWorkspaceSymbolProvider(ie){return pt.registerWorkspaceSymbolProvider(Oe,ie)},registerDocumentFormattingEditProvider(ie,he){return pt.registerDocumentFormattingEditProvider(Oe,Et(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return pt.registerDocumentRangeFormattingEditProvider(Oe,Et(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Ae,...ut){return pt.registerOnTypeFormattingEditProvider(Oe,Et(ie),he,[Ae].concat(ut))},registerDocumentSemanticTokensProvider(ie,he,Ae){return pt.registerDocumentSemanticTokensProvider(Oe,Et(ie),he,Ae)},registerDocumentRangeSemanticTokensProvider(ie,he,Ae){return pt.registerDocumentRangeSemanticTokensProvider(Oe,Et(ie),he,Ae)},registerSignatureHelpProvider(ie,he,Ae,...ut){return typeof Ae=="object"?pt.registerSignatureHelpProvider(Oe,Et(ie),he,Ae):pt.registerSignatureHelpProvider(Oe,Et(ie),he,typeof Ae=="undefined"?[]:[Ae,...ut])},registerCompletionItemProvider(ie,he,...Ae){return pt.registerCompletionItemProvider(Oe,Et(ie),he,Ae)},registerInlineCompletionItemProvider(ie,he){return(0,H.checkProposedApiEnabled)(Oe),pt.registerInlineCompletionsProvider(Oe,Et(ie),he)},registerDocumentLinkProvider(ie,he){return pt.registerDocumentLinkProvider(Oe,Et(ie),he)},registerColorProvider(ie,he){return pt.registerColorProvider(Oe,Et(ie),he)},registerFoldingRangeProvider(ie,he){return pt.registerFoldingRangeProvider(Oe,Et(ie),he)},registerSelectionRangeProvider(ie,he){return pt.registerSelectionRangeProvider(Oe,ie,he)},registerCallHierarchyProvider(ie,he){return pt.registerCallHierarchyProvider(Oe,ie,he)},setLanguageConfiguration:(ie,he)=>pt.setLanguageConfiguration(Oe,ie,he),getTokenInformationAtPosition(ie,he){return(0,H.checkProposedApiEnabled)(Oe),Lt.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return(0,H.checkProposedApiEnabled)(Oe),pt.registerInlayHintsProvider(Oe,ie,he)},registerTypeHierarchyProvider(ie,he){return(0,H.checkProposedApiEnabled)(Oe),pt.registerTypeHierarchyProvider(Oe,ie,he)},createLanguageStatusItem(ie){return(0,H.checkProposedApiEnabled)(Oe),Lt.createLanguageStatusItem(ie)}},An={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ie,he,Ae){const ut=await(R.URI.isUri(ie)?Promise.resolve(pn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(ut,he,Ae)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Oe,ie)},onDidChangeActiveTextEditor(ie,he,Ae){return Pt.onDidChangeActiveTextEditor(ie,he,Ae)},onDidChangeVisibleTextEditors(ie,he,Ae){return Pt.onDidChangeVisibleTextEditors(ie,he,Ae)},onDidChangeTextEditorSelection(ie,he,Ae){return Pt.onDidChangeTextEditorSelection(ie,he,Ae)},onDidChangeTextEditorOptions(ie,he,Ae){return Pt.onDidChangeTextEditorOptions(ie,he,Ae)},onDidChangeTextEditorVisibleRanges(ie,he,Ae){return Pt.onDidChangeTextEditorVisibleRanges(ie,he,Ae)},onDidChangeTextEditorViewColumn(ie,he,Ae){return Pt.onDidChangeTextEditorViewColumn(ie,he,Ae)},onDidCloseTerminal(ie,he,Ae){return gt.onDidCloseTerminal(ie,he,Ae)},onDidOpenTerminal(ie,he,Ae){return gt.onDidOpenTerminal(ie,he,Ae)},onDidChangeActiveTerminal(ie,he,Ae){return gt.onDidChangeActiveTerminal(ie,he,Ae)},onDidChangeTerminalDimensions(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),gt.onDidChangeTerminalDimensions(ie,he,Ae)},onDidChangeTerminalState(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),gt.onDidChangeTerminalState(ie,he,Ae)},onDidWriteTerminalData(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),gt.onDidWriteTerminalData(ie,he,Ae)},get state(){return Ye.state},onDidChangeWindowState(ie,he,Ae){return Ye.onDidChangeWindowState(ie,he,Ae)},showInformationMessage(ie,...he){return Kt.showMessage(Oe,C.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return Kt.showMessage(Oe,C.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return Kt.showMessage(Oe,C.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Ae){return Vt.showQuickPick(ie,!!Oe.enableProposedApi,he,Ae)},showWorkspaceFolderPick(ie){return Vt.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Vt.showInput(ie,he)},showOpenDialog(ie){return fn.showOpenDialog(ie)},showSaveDialog(ie){return fn.showSaveDialog(ie)},createStatusBarItem(ie,he,Ae){let ut,St,kt;return typeof ie=="string"?(ut=ie,St=he,kt=Ae):(St=ie,kt=he),Ht.createStatusBarEntry(Oe,ut,St,kt)},setStatusBarMessage(ie,he){return Ht.setStatusBarMessage(ie,he)},withScmProgress(ie){return Pe.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),dn.withProgress(Oe,{location:O.ProgressLocation.SourceControl},(he,Ae)=>ie({report(ut){}}))},withProgress(ie,he){return dn.withProgress(Oe,ie,he)},createOutputChannel(ie){return xt.createOutputChannel(ie,Oe)},createWebviewPanel(ie,he,Ae,ut){return qt.createWebviewPanel(Oe,ie,he,Ae,ut)},createWebviewTextEditorInset(ie,he,Ae,ut){return(0,H.checkProposedApiEnabled)(Oe),wn.createWebviewEditorInset(ie,he,Ae,ut,Oe)},createTerminal(ie,he,Ae){return typeof ie=="object"?("location"in ie&&(0,H.checkProposedApiEnabled)(Oe),"pty"in ie?gt.createExtensionTerminal(ie):gt.createTerminalFromOptions(ie)):gt.createTerminal(ie,he,Ae)},registerTerminalLinkProvider(ie){return gt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return gt.registerProfileProvider(Oe,ie,he)},registerTreeDataProvider(ie,he){return Jt.registerTreeDataProvider(ie,he,Oe)},createTreeView(ie,he){return Jt.createTreeView(ie,he,Oe)},registerWebviewPanelSerializer:(ie,he)=>qt.registerWebviewPanelSerializer(Oe,ie,he),registerCustomEditorProvider:(ie,he,Ae={})=>_n.registerCustomEditorProvider(Oe,ie,he,Ae),registerFileDecorationProvider(ie){return wt.registerFileDecorationProvider(ie,Oe.identifier)},registerUriHandler(ie){return Bt.registerUriHandler(Oe.identifier,ie)},createQuickPick(){return Vt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Oe.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Ae){return hn.onDidChangeActiveColorTheme(ie,he,Ae)},registerWebviewViewProvider(ie,he,Ae){return Sn.registerWebviewViewProvider(Oe,ie,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Oe),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),bt.onDidChangeActiveNotebookEditor(ie,he,Ae)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Oe),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Oe),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorSelection(ie,he,Ae)},onDidChangeNotebookEditorVisibleRanges(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorVisibleRanges(ie,he,Ae)},showNotebookDocument(ie,he){return(0,H.checkProposedApiEnabled)(Oe),bt.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),yn.registerExternalUriOpener(Oe.identifier,ie,he,Ae)},get openEditors(){return(0,H.checkProposedApiEnabled)(Oe),at.tabs},get onDidChangeOpenEditors(){return(0,H.checkProposedApiEnabled)(Oe),at.onDidChangeTabs},getInlineCompletionItemController(ie){return(0,H.checkProposedApiEnabled)(Oe),d.InlineCompletionController.get(ie)}},pn={get rootPath(){return Pe.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return qe.getWorkspaceFolder(ie)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(ie){throw L.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,he,...Ae)=>qe.updateWorkspaceFolders(Oe,ie,he||0,...Ae),onDidChangeWorkspaceFolders:function(ie,he,Ae){return qe.onDidChangeWorkspace(ie,he,Ae)},asRelativePath:(ie,he)=>qe.getRelativePath(ie,he),findFiles:(ie,he,Ae,ut)=>qe.findFiles(U.GlobPattern.from(ie),U.GlobPattern.from(he),Ae,Oe.identifier,ut),findTextInFiles:(ie,he,Ae,ut)=>{let St,kt;return typeof he=="object"?(St=he,kt=Ae):(St={},kt=he,ut=Ae),qe.findTextInFiles(ie,St||{},kt,Oe.identifier,ut)},saveAll:ie=>qe.saveAll(ie),applyEdit(ie){return Dn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Ae,ut)=>Ft.createFileSystemWatcher(U.GlobPattern.from(ie),he,Ae,ut),get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let he;const Ae=ie;if(typeof ie=="string")he=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))he=Promise.resolve(ie);else if(!Ae||typeof Ae=="object")he=It.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ut=>It.ensureDocumentData(ut).then(St=>St.document))},onDidOpenTextDocument:(ie,he,Ae)=>It.onDidAddDocument(ie,he,Ae),onDidCloseTextDocument:(ie,he,Ae)=>It.onDidRemoveDocument(ie,he,Ae),onDidChangeTextDocument:(ie,he,Ae)=>It.onDidChangeDocument(ie,he,Ae),onDidSaveTextDocument:(ie,he,Ae)=>It.onDidSaveDocument(ie,he,Ae),onWillSaveTextDocument:(ie,he,Ae)=>tn.getOnWillSaveTextDocumentEvent(Oe)(ie,he,Ae),get notebookDocuments(){return bt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Ae;if(R.URI.isUri(ie))Ae=ie,await bt.openNotebookDocument(ie);else if(typeof ie=="string")Ae=R.URI.revive(await bt.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Ae,ut){return bt.registerNotebookSerializer(Oe,ie,he,Ae,Oe.enableProposedApi?ut:void 0)},registerNotebookContentProvider:(ie,he,Ae,ut)=>((0,H.checkProposedApiEnabled)(Oe),bt.registerNotebookContentProvider(Oe,ie,he,Ae,Oe.enableProposedApi?ut:void 0)),onDidChangeConfiguration:(ie,he,Ae)=>Qt.onDidChangeConfiguration(ie,he,Ae),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,Qt.getConfiguration(ie,he,Oe)},registerTextDocumentContentProvider(ie,he){return $t.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Pe.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Oe,ie,he)),registerFileSystemProvider(ie,he,Ae){return sn.registerFileSystemProvider(Oe.identifier,ie,he,Ae,Oe.enableProposedApi)},get fs(){return we.value},registerFileSearchProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),Tt.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),Tt.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),Fe.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,H.checkProposedApiEnabled)(Oe),bn.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Ae)=>Ft.onDidCreateFile(ie,he,Ae),onDidDeleteFiles:(ie,he,Ae)=>Ft.onDidDeleteFile(ie,he,Ae),onDidRenameFiles:(ie,he,Ae)=>Ft.onDidRenameFile(ie,he,Ae),onWillCreateFiles:(ie,he,Ae)=>Ft.getOnWillCreateFileEvent(Oe)(ie,he,Ae),onWillDeleteFiles:(ie,he,Ae)=>Ft.getOnWillDeleteFileEvent(Oe)(ie,he,Ae),onWillRenameFiles:(ie,he,Ae)=>Ft.getOnWillRenameFileEvent(Oe)(ie,he,Ae),openTunnel:ie=>((0,H.checkProposedApiEnabled)(Oe),Te.openTunnel(Oe,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,H.checkProposedApiEnabled)(Oe),Te.getTunnels()},onDidChangeTunnels:(ie,he,Ae)=>((0,H.checkProposedApiEnabled)(Oe),Te.onDidChangeTunnels(ie,he,Ae)),registerPortAttributesProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),Te.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),En.registerTimelineProvider(ie,he,Oe.identifier,ht.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:ie=>((0,H.checkProposedApiEnabled)(Oe),qe.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Ae)=>qe.onDidGrantWorkspaceTrust(ie,he,Ae)},Rn={get inputBox(){return Pe.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Oe)},createSourceControl(ie,he,Ae){return Yt.createSourceControl(Oe,ie,he,Ae)}},Ln={createCommentController(ie,he){return on.createCommentController(Oe,ie,he)}},Fn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(ie,he,Ae){return ft.onDidStartDebugSession(ie,he,Ae)},onDidTerminateDebugSession(ie,he,Ae){return ft.onDidTerminateDebugSession(ie,he,Ae)},onDidChangeActiveDebugSession(ie,he,Ae){return ft.onDidChangeActiveDebugSession(ie,he,Ae)},onDidReceiveDebugSessionCustomEvent(ie,he,Ae){return ft.onDidReceiveDebugSessionCustomEvent(ie,he,Ae)},onDidChangeBreakpoints(ie,he,Ae){return ft.onDidChangeBreakpoints(ie,he,Ae)},registerDebugConfigurationProvider(ie,he,Ae){return ft.registerDebugConfigurationProvider(ie,he,Ae||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return ft.registerDebugAdapterDescriptorFactory(Oe,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return ft.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ft.startDebugging(ie,he,{parentSession:Ae}):ft.startDebugging(ie,he,Ae||{})},stopDebugging(ie){return ft.stopDebugging(ie)},addBreakpoints(ie){return ft.addBreakpoints(ie)},removeBreakpoints(ie){return ft.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return ft.asDebugSourceUri(ie,he)}},Mn={registerTaskProvider:(ie,he)=>yt.registerTaskProvider(Oe,ie,he),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Oe,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,he,Ae)=>yt.onDidStartTask(ie,he,Ae),onDidEndTask:(ie,he,Ae)=>yt.onDidEndTask(ie,he,Ae),onDidStartTaskProcess:(ie,he,Ae)=>yt.onDidStartTaskProcess(ie,he,Ae),onDidEndTaskProcess:(ie,he,Ae)=>yt.onDidEndTaskProcess(ie,he,Ae)},On={createNotebookController(ie,he,Ae,ut,St){return nn.createNotebookController(Oe,ie,he,Ae,ut,Oe.enableProposedApi?St:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>bt.registerNotebookCellStatusBarItemProvider(Oe,ie,he),get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Oe),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,H.checkProposedApiEnabled)(Oe),zt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return rn.createRendererMessaging(Oe,ie)},onDidChangeNotebookDocumentMetadata(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),Xt.onDidChangeNotebookDocumentMetadata(ie,he,Ae)},onDidChangeNotebookCells(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),bt.onDidChangeNotebookCells(ie,he,Ae)},onDidChangeNotebookCellExecutionState(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),bt.onDidChangeNotebookCellExecutionState(ie,he,Ae)},onDidChangeCellOutputs(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),bt.onDidChangeCellOutputs(ie,he,Ae)},onDidChangeCellMetadata(ie,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),bt.onDidChangeCellMetadata(ie,he,Ae)},createConcatTextDocument(ie,he){return(0,H.checkProposedApiEnabled)(Oe),new Qe.ExtHostNotebookConcatDocument(bt,It,ie,he)}};return{version:de.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:mn,extensions:Tn,languages:ln,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:An,workspace:pn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionList:O.InlineSuggestions,Hover:O.Hover,IndentAction:A.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:u.UIKind,Uri:R.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(me[275],ge([0,1,82,67,37,132,38,44,45,33,71,53,73,93,52,66,133,92,63,91,123,51]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,m.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,m.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,m.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,m.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,m.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,m.registerSingleton)(c.IExtHostTunnelService,c.ExtHostTunnelService),(0,m.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,m.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,m.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,m.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,m.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(me[94],ge([0,1,20,12,31,70]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=R;function k(T,u,h,c){const g=(0,m.mapArrayOrNot)(h,D),_=new I.TextSearchMatch(u,g,c),P=_.preview.matches;return{ranges:(0,m.mapArrayOrNot)(g,A),uri:T,preview:{text:_.preview.text,matches:(0,m.mapArrayOrNot)(P,A)}}}e.createTextSearchResult=k;function D(T){return new I.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function A(T){return new C.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let n=class{constructor(u,h){this.prefix=u,this.logService=h}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};n=Ve([xe(1,L.ILogService)],n),e.OutputChannel=n}),define(me[276],ge([0,1,96,22]),function(Z,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,R=512,k=512*8,D=512*128;class A{constructor(r){this.iconvLiteDecoder=r}static async create(r){let s;if(r!==e.UTF8)s=(await new Promise((l,d)=>{Z(["iconv-lite-umd"],l,d)})).getDecoder(h(r));else{const i=new TextDecoder;s={write(l){return i.decode(l,{stream:!0})},end(){return i.decode()}}}return new A(s)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function n(t,r){const s=r.minBytesRequiredForDetection??r.guessEncoding?k:R;return new Promise((i,l)=>{const d=(0,m.newWriteableStream)(S=>S.join("")),f=[];let w=0,y;const p=async()=>{try{const S=await v({buffer:L.VSBuffer.concat(f),bytesRead:w},r.guessEncoding);S.encoding=await r.overwriteEncoding(S.encoding),y=await A.create(S.encoding);const b=y.write(L.VSBuffer.concat(f).buffer);d.write(b),f.length=0,w=0,i({stream:d,detected:S})}catch(S){l(S)}};(0,m.listenStream)(t,{onData:async S=>{y?d.write(y.write(S.buffer)):(f.push(S),w+=S.byteLength,w>=s&&(t.pause(),await p(),setTimeout(()=>t.resume())))},onError:S=>d.error(S),onEnd:async()=>{y||await p(),d.end(y?.end())}})})}e.toDecodeStream=n;async function T(t,r,s){const l=(await new Promise((w,y)=>{Z(["iconv-lite-umd"],w,y)})).getEncoder(h(r),s);let d=!1,f=!1;return{read(){if(f)return null;const w=t.read();if(typeof w!="string"){if(f=!0,!d&&s?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=l.end();return y&&y.length>0?(d=!0,L.VSBuffer.wrap(y)):null}return d=!0,L.VSBuffer.wrap(l.write(w))}}}e.toEncodeReadable=T;async function u(t){return(await new Promise((s,i)=>{Z(["iconv-lite-umd"],s,i)})).encodingExists(h(t))}e.encodingExists=u;function h(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=h;function c(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),i=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return s===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const g=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((f,w)=>{Z(["jschardet"],f,w)}),s=t.slice(0,D),i=o(s.buffer),l=r.detect(i);if(!l||!l.encoding)return null;const d=l.encoding.toLowerCase();return 0<=g.indexOf(d)?null:E(l.encoding)}const P={ibm866:"cp866",big5:"cp950"};function E(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[r]||r}function o(t){let r="";for(let s=0;s<t.length;s++)r+=String.fromCharCode(t[s]);return r}function a(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=a;function v({buffer:t,bytesRead:r},s){let i=c(t,r),l=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let d=!0,f=!0,w=!1;for(let y=0;y<r&&y<C;y++){const p=y%2==1,S=t.readUInt8(y)===0;if(S&&(w=!0),d&&(p&&!S||!p&&S)&&(d=!1),f&&(p&&S||!p&&!S)&&(f=!1),S&&!d&&!f)break}w&&(d?i=e.UTF16le:f?i=e.UTF16be:l=!0)}return s&&!l&&!i&&t?_(t.slice(0,r)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:l,encoding:i}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[135],ge([0,1,276,28,134]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends I.TextSearchManager{constructor(k,D,A=L,n="searchProcess"){super(k,D,{readdir:T=>A.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,m.toCanonicalName)(T)},n)}}e.NativeTextSearchManager=C}),define(me[277],ge([0,1,278,293,294,2,295]),function(Z,e,m,L,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(T,u,h,c,g,_){const P=_.environment.useHostProxy,E=typeof P=="boolean"?P:!_.remote.isRemote,o=(0,R.createProxyResolver)({resolveProxy:v=>T.resolveProxy(v),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(v,t,...r)=>{switch(v){case R.LogLevel.Trace:c.trace(t,...r);break;case R.LogLevel.Debug:c.debug(t,...r);break;case R.LogLevel.Info:c.info(t,...r);break;case R.LogLevel.Warning:c.warn(t,...r);break;case R.LogLevel.Error:c.error(t,...r);break;case R.LogLevel.Critical:c.critical(t,...r);break;case R.LogLevel.Off:break;default:s(v,t,r);break}function s(i,l,...d){c.error("Unknown log level",i),c.error(l,...d)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:v=>{g.$publicLog2("resolveProxy",v)},useHostProxy:E,env:process.env}),a=D(u,o);return n(h,a)}e.connectProxyResolver=k;function D(T,u){const h={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(g=>{h.config=T.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(g=>{c.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"off"},c,!0)),on:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"on"},c,!0)),override:Object.assign({},m,(0,R.createHttpPatch)(m,u,{config:"override"},c,!0)),onRequest:Object.assign({},m,(0,R.createHttpPatch)(m,u,h,c,!0)),default:Object.assign(m,(0,R.createHttpPatch)(m,u,h,c,!1))},https:{off:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"off"},c,!0)),on:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"on"},c,!0)),override:Object.assign({},L,(0,R.createHttpPatch)(L,u,{config:"override"},c,!0)),onRequest:Object.assign({},L,(0,R.createHttpPatch)(L,u,h,c,!0)),default:Object.assign(L,(0,R.createHttpPatch)(L,u,h,c,!1))},tls:Object.assign(I,(0,R.createTlsPatch)(I))}}const A=new Map;function n(T,u){return T.getExtensionPathIndex().then(h=>{const c=Z.__$__nodeRequire("module"),g=c._load;c._load=function(P,E,o){if(P==="tls")return u.tls;if(P!=="http"&&P!=="https")return g.apply(this,arguments);const a=u[P],v=h.findSubstr(C.URI.file(E.filename).fsPath);let t=A.get(v);if(t||A.set(v,t={}),!t[P]){let r=a.default;v&&v.enableProposedApi&&(r=a[v.proxySupport]||a.onRequest),t[P]={...r}}return t[P]}})}}),define(me[279],ge([0,1,39,8,78,29,11,9,94,280]),function(Z,e,m,L,I,C,R,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(o,a,v,t){const r=u(o,a,v,t),s=a.folder.fsPath;return{cmd:m.spawn(n,r.args,{cwd:s}),rgDiskPath:n,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.spawnRipgrepCmd=T;function u(o,a,v,t){const r=["--files","--hidden","--case-sensitive"];c([a],v,!1).forEach(i=>{const l=(0,D.anchorGlob)(i);if(r.push("-g",l),R.isMacintosh){const d=(0,I.normalizeNFD)(l);d!==l&&r.push("-g",d)}});const s=h([a],t,void 0,!1);return s.globArgs.forEach(i=>{const l=`!${(0,D.anchorGlob)(i)}`;if(r.push("-g",l),R.isMacintosh){const d=(0,I.normalizeNFD)(l);d!==l&&r.push("-g",d)}}),a.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),a.ignoreSymlinks||r.push("--follow"),o.exists&&r.push("--quiet"),r.push("--no-config"),a.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function h(o,a,v,t=!0){const r=[];let s={};return o.forEach(i=>{const l=Object.assign({},i.excludePattern||{},a||{}),d=g(l,t?i.folder.fsPath:void 0,v);r.push(...d.globArgs),d.siblingClauses&&(s=Object.assign(s,d.siblingClauses))}),{globArgs:r,siblingClauses:s}}e.foldersToRgExcludeGlobs=h;function c(o,a,v=!0){const t=[];return o.forEach(r=>{const s=Object.assign({},a||{},r.includePattern||{}),i=g(s,v?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=c;function g(o,a,v){const t=[],r={};return Object.keys(o).forEach(s=>{if(v&&v.has(s)||!s)return;const i=o[s];s=P(a?_(a,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(E(s))):i&&i.when&&(r[s]=i)}),{globArgs:t,siblingClauses:r}}function _(o,a){return L.isAbsolute(a)?a:L.join(o,a)}e.getAbsoluteGlob=_;function P(o){return o=k.rtrim(o,"\\"),k.rtrim(o,"/")}function E(o){return C.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=E}),define(me[281],ge([0,1,39,49,8,104,20,60,30,78,29,11,46,9,13,28,31,279,101]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(s=>s())});class a{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(l=>{const d=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),f=l.folder.fsPath;i.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==f).forEach(w=>{(0,n.isEqualOrParent)(w,f)&&(d[I.relative(f,w)]=!0)}),this.folderExcludePatterns.set(f,new t(d,f))})}cancel(){this.isCanceled=!0}walk(i,l,d,f,w){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);l.forEach(y=>{const p=I.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,p)||this.matchFile(d,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(i,(y,p)=>{this.call(this.cmdTraversal,this,y,d,f,S=>{if(S){const b=(0,k.toErrorMessage)(S);console.error(b),this.errors.push(b),p(S,void 0)}else p(null,void 0)})},(y,p)=>{this.fileWalkSW.stop();const S=y?R.coalesce(y)[0]:null;w(S,this.isLimitHit)})}parallel(i,l,d){const f=new Array(i.length),w=new Array(i.length);let y=!1,p=0;if(i.length===0)return d(null,[]);i.forEach((S,b)=>{l(S,(F,N)=>{if(F?(y=!0,f[b]=null,w[b]=F):(f[b]=N,w[b]=null),++p===i.length)return d(y?w:null,f)})})}call(i,l,...d){try{i.apply(l,d)}catch(f){d[d.length-1](f)}}cmdTraversal(i,l,d,f){const w=i.folder.fsPath,y=T.isMacintosh;let p;const S=()=>p&&p.kill();o.add(S);let b=O=>{o.delete(S),b=()=>{},f(O)},F="";const N=this.initDirectoryTree();let G;const K=(0,P.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);p=K.cmd,G=!Object.keys(K.siblingClauses).length;const M=K.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let U=`${K.rgDiskPath} ${M}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),d({message:U}),this.cmdResultCount=0,this.collectStdout(p,"utf8",d,(O,$,B)=>{if(O){b(O);return}if(this.isLimitHit){b();return}const j=(F+(y?A.normalizeNFC($||""):$)).split(`
`);if(B){const H=j.length;j[H-1]=j[H-1].trim(),j[H-1]||j.pop()}else F=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,G){for(const H of j)if(this.matchFile(l,{base:w,relativePath:H,searchPath:this.getSearchPath(i,H)}),this.isLimitHit){S();break}(B||this.isLimitHit)&&b();return}this.addDirectoryEntries(i,N,w,j,l),B&&(this.matchDirectoryTree(N,w,l),b())})}spawnFindCmd(i){const l=this.folderExcludePatterns.get(i.folder.fsPath),d=l.getBasenameTerms(),f=l.getPathTerms(),w=["-L","."];if(d.length||f.length){w.push("-not","(","(");for(const y of d)w.push("-name",y),w.push("-o");for(const y of f)w.push("-path",y),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),m.spawn("find",w,{cwd:i.folder.fsPath})}readStdout(i,l,d){let f="";this.collectStdout(i,l,()=>{},(w,y,p)=>{if(w){d(w);return}f+=y,p&&d(null,f)})}collectStdout(i,l,d,f){let w=(S,b,F)=>{(S||F)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),f(S,b,F)},y=!1;i.stdout?(this.forwardData(i.stdout,l,w),i.stdout.once("data",()=>y=!0)):d({message:"stdout is null"});let p;i.stderr?p=this.collectData(i.stderr):d({message:"stderr is null"}),i.on("error",S=>{w(S)}),i.on("close",S=>{let b;!y&&(b=this.decodeData(p,l))&&r(b)?w(new Error(`command failed with error code ${S}: ${this.decodeData(p,l)}`)):(this.exists&&S===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(i,l,d){const f=new C.StringDecoder(l);return i.on("data",w=>{d(null,f.write(w))}),f}collectData(i){const l=[];return i.on("data",d=>{l.push(d)}),l}decodeData(i,l){const d=new C.StringDecoder(l);return i.map(f=>d.write(f)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:l},d,f,w){f.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const y=p=>{const S=I.basename(p),b=I.dirname(p);let F=l[b];F||(F=l[b]=[],y(b)),F.push({base:d,relativePath:p,basename:S,searchPath:this.getSearchPath(i,p)})};f.forEach(y)}matchDirectoryTree({rootEntries:i,pathToEntries:l},d,f){const w=this,y=this.folderExcludePatterns.get(d),p=this.filePattern;function S(b){w.directoriesWalked++;const F=D.hasSiblingFn(()=>b.map(N=>N.basename));for(let N=0,G=b.length;N<G;N++){const K=b[N],{relativePath:M,basename:U}=K;if(y.test(M,U,p!==U?F:void 0))continue;const O=l[M];if(O)S(O);else{if(w.filesWalked++,M===p)continue;w.matchFile(f,K)}if(w.isLimitHit)break}}S(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,l,d,f,w){const y=i.folder,p=D.hasSiblingFn(()=>d);this.parallel(d,(S,b)=>{if(this.isCanceled||this.isLimitHit)return b(null);const F=l?[l,S].join(I.sep):S;if(this.folderExcludePatterns.get(i.folder.fsPath).test(F,S,this.config.filePattern!==S?p:void 0))return b(null);const N=[y.fsPath,F].join(I.sep);L.lstat(N,(G,K)=>{if(G||this.isCanceled||this.isLimitHit)return b(null);this.statLinkIfNeeded(N,K,(M,U)=>M||this.isCanceled||this.isLimitHit?b(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,K,(O,$)=>O||this.isCanceled||this.isLimitHit||($=$||"",this.walkedPaths[$])?b(null):(this.walkedPaths[$]=!0,g.Promises.readdir(N).then(B=>{if(this.isCanceled||this.isLimitHit)return b(null);this.doWalk(i,F,B,f,x=>b(x||null))},B=>{b(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&c.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(f,{base:y.fsPath,relativePath:F,searchPath:this.getSearchPath(i,F)}),b(null,void 0)))})},S=>{const b=S&&R.coalesce(S);return w(b&&b.length>0?b[0]:void 0)})}matchFile(i,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,I.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(l))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,l,d){return l.isSymbolicLink()?L.stat(i,d):d(null,l)}realPathIfNeeded(i,l,d){return l.isSymbolicLink()?L.realpath(i,(f,w)=>f?d(f):d(null,w)):d(null,i)}getSearchPath(i,l){return i.folderName?I.join(i.folderName,l):l}}e.FileWalker=a;class v{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new a(i)}search(i,l,d){this.walker.walk(this.folderQueries,this.extraFiles,i,l,(f,w)=>{d(f,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(i,l){this.expression=i,this.root=l,this.init(i)}init(i){let l,d;Object.keys(i).filter(f=>i[f]).forEach(f=>{I.isAbsolute(f)?(l=l||D.getEmptyExpression(),l[f]=i[f]):(d=d||D.getEmptyExpression(),d[f]=i[f])}),this.absoluteParsedExpr=l&&D.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=d&&D.parse(d,{trimForExclusions:!0})}test(i,l,d){return this.relativeParsedExpr&&this.relativeParsedExpr(i,l,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),l,d)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function r(s){const i=s.trim().split(`
`),l=i[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return h.uppercaseFirstLetter(i[i.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=r}),define(me[136],ge([0,1,39,296,104,20,55,30,8,9,2,31,70,297,280,94]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(y){this.outputChannel=y}provideTextSearchResults(y,p,S,b){return this.outputChannel.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((F,N)=>{b.onCancellationRequested(()=>x());const G=r(y,p),K=p.folder.fsPath,M=G.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${_} ${M}
 - cwd: ${K}`);let U=m.spawn(_,G,{cwd:K});U.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),N((0,T.serializeSearchError)(new T.SearchError(fe&&fe.message,T.SearchErrorCode.rgProcessError)))});let O=!1;const $=new a(p.maxResults,K,p.previewOptions);$.on("result",fe=>{O=!0,H="",S.report(fe)});let B=!1;const x=()=>{B=!0,U&&U.kill(),$&&$.cancel()};let j=!1;$.on("hitLimit",()=>{j=!0,x()});let H="";U.stdout.on("data",fe=>{$.handleData(fe),O||(H+=fe)});let X=!1;U.stdout.once("data",()=>X=!0);let J="";U.stderr.on("data",fe=>{const _e=fe.toString();this.outputChannel.appendLine(_e),J+=_e}),U.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(O?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),B)F({limitHit:j});else{$.flush(),U=null;let fe;J&&!X&&(fe=E(J))?N((0,T.serializeSearchError)(new T.SearchError(fe.message,fe.code))):F({limitHit:j})}})})}}e.RipgrepTextSearchEngine=P;function E(w){const y=w.split(`
`),p=y[0].trim();if(y.some(b=>b.startsWith("regex parse error")))return new T.SearchError(o(y),T.SearchErrorCode.regexParseError);const S=p.match(/grep config error: unknown encoding: (.*)/);if(S)return new T.SearchError(`Unknown encoding: ${S[1]}`,T.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new T.SearchError(p.charAt(0).toUpperCase()+p.substr(1),T.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new T.SearchError(p.charAt(0).toUpperCase()+p.substr(1),T.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(p,T.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function o(w){const y=["Regex parse error"],p=w.filter(S=>S.startsWith("PCRE2:"));if(p.length>=1){const S=p[0].replace("PCRE2:","");if(S.indexOf(":")!==-1&&S.split(":").length>=2){const b=S.split(":")[1];y.push(":"+b)}}return y.join("")}e.buildRegexParseError=o;class a extends L.EventEmitter{constructor(y,p,S){super();this.maxResults=y,this.rootFolder=p,this.previewOptions=S,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(y,p){return super.on(y,p),this}handleData(y){if(this.isDone)return;const p=typeof y=="string"?y:this.stringDecoder.write(y);this.handleDecodedData(p)}handleDecodedData(y){let p=y.indexOf(`
`);const S=this.remainder+y;if(p>=0)p+=this.remainder.length;else{this.remainder=S;return}let b=0;for(;p>=0;)this.handleLine(S.substring(b,p).trim()),b=p+1,p=S.indexOf(`
`,b);this.remainder=S.substring(b)}handleLine(y){if(this.isDone||!y)return;let p;try{p=JSON.parse(y)}catch(S){throw new Error(`malformed line from rg: ${y}`)}if(p.type==="match"){const S=v(p.data.path),b=n.URI.file(D.join(this.rootFolder,S)),F=this.createTextSearchMatch(p.data,b);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const S=v(p.data.path),b=n.URI.file(D.join(this.rootFolder,S));this.createTextSearchContext(p.data,b).forEach(N=>this.onResult(N))}}createTextSearchMatch(y,p){const S=y.line_number-1,b=v(y.lines),F=Buffer.from(b);let N=0,G=0,K=S;y.submatches.length===0&&y.submatches.push(b.length?{start:0,end:1,match:{text:b[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(y.submatches.map((U,O)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const $=v(U.match),B=F.slice(N,U.start).toString().length,x=G+B,j=t($),H=K,X=j.numLines+H,J=j.numLines>0?j.lastLineLength:j.lastLineLength+x;return N=U.end,G=J,K=X,new u.Range(H,x,X,J)}));return(0,g.createTextSearchResult)(p,b,M,this.previewOptions)}createTextSearchContext(y,p){const S=v(y.lines),b=y.line_number;return S.replace(/\r?\n$/,"").split(`
`).map((F,N)=>({text:F,uri:p,lineNumber:b+N}))}onResult(y){this.emit("result",y)}}e.RipgrepParser=a;function v(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const y=/\n/g;let p=0,S=-1,b;for(;b=y.exec(w);)p++,S=b.index;const F=S>=0?w.length-S-1:w.length;return{numLines:p,lastLineLength:F}}function r(w,y){const p=["--hidden"];p.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:S,otherIncludes:b}=(0,R.groupBy)(y.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(b&&b.length){const N=new Set;b.forEach(G=>{N.add(G)}),p.push("-g","!*"),N.forEach(G=>{s(G).map(g.anchorGlob).forEach(K=>{p.push("-g",K)})})}S&&S.length&&S.forEach(N=>{p.push("-g",N)}),y.excludes.map(g.anchorGlob).forEach(N=>p.push("-g",`!${N}`)),y.maxFileSize&&p.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?p.push("--no-ignore-parent"):p.push("--no-ignore"),y.followSymlinks&&p.push("--follow"),y.encoding&&y.encoding!=="utf8"&&p.push("--encoding",y.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,A.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),y.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),w.isRegExp&&(w.pattern=i(w.pattern),p.push("--auto-hybrid-regex"));let F;if(w.isWordMatch){const G=(0,A.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",G)}else if(w.isRegExp){let N=d(w.pattern);N=f(N),p.push("--regexp",N)}else F=w.pattern,p.push("--fixed-strings");return p.push("--no-config"),y.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),w.isMultiline&&p.push("--multiline"),y.beforeContext&&p.push("--before-context",y.beforeContext+""),y.afterContext&&p.push("--after-context",y.afterContext+""),p.push("--"),F&&p.push(F),p.push("."),p}function s(w){const y=(0,k.splitGlobAware)(w,"/");return y.map((p,S)=>y.slice(0,S+1).join("/"))}e.spreadGlobComponents=s;function i(w){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(y);)w=w.replace(y,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(p);)w=w.replace(p,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=i;const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function d(w){let y;try{y=new h.RegExpParser().parsePattern(w)}catch{return w}let p="",S=0;const b=(G,K,M)=>{p+=w.slice(S,G)+M,S=K},F=[];return new h.RegExpVisitor({onCharacterEnter(G){if(G.raw!=="\\n")return;const K=F[0];if(!K)b(G.start,G.end,"\\r?\\n");else if(!F.some(l))if(K.type==="CharacterClass")if(K.negate){const M=w.slice(K.start+2,G.start)+w.slice(G.end,K.end-1);b(K.start,K.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=w.slice(K.start+1,G.start)+w.slice(G.end,K.end-1);b(K.start,K.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else K.type==="Quantifier"&&b(G.start,G.end,"(?:\\r?\\n)")},onQuantifierEnter(G){F.unshift(G)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(G){F.unshift(G)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(G){F.unshift(G)},onCharacterClassLeave(){F.shift()},onAssertionEnter(G){l(G)&&F.push(G)},onAssertionLeave(G){F[0]===G&&F.shift()}}).visit(y),p+=w.slice(S),p}e.fixRegexNewline=d;function f(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=f}),define(me[282],ge([0,1,21,136,119,10]),function(Z,e,m,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,n,T,u){const h=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===C.Schemas.userData){const c={...n,folder:n.folder.with({scheme:C.Schemas.file})},g=new I.Progress(_=>T.report({..._,uri:_.uri.with({scheme:n.folder.scheme})}));return this.withToken(u,_=>h.provideTextSearchResults(A,c,g,_))}else return this.withToken(u,c=>h.provideTextSearchResults(A,n,T,c))}async withToken(A,n){const T=k(A);this.inProgress.add(T);const u=await n(T.token);return this.inProgress.delete(T),u}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=R;function k(D){const A=new m.CancellationTokenSource;return D.onCancellationRequested(()=>A.cancel()),A}}),define(me[283],ge([0,1,28,136,135]),function(Z,e,m,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(D){this.query=D}search(D,A,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(h){n({message:h})}},u=new I.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(T),m);return new Promise((h,c)=>u.search(g=>{A(g.map(R))},D).then(g=>h({limitHit:g.limitHit,type:"success",stats:g.stats}),c))}}e.TextSearchEngineAdapter=C;function R(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,A)=>{if(A.ranges){const n=A;return D+(Array.isArray(n.ranges)?n.ranges.length:1)}else return D+1},0)}}}),define(me[284],ge([0,1,49,298,20,17,16,3,101,8,46,2,42,31,281,283]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(m);class _{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let r;const s=o(t),i=new k.Emitter({onFirstListenerDidAdd:()=>{r=(0,C.createCancelablePromise)(l=>this.doFileSearchWithEngine(c.Engine,s,d=>i.fire(d),l)),r.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}textSearch(t){let r;const s=o(t),i=new k.Emitter({onFirstListenerDidAdd:()=>{r=(0,C.createCancelablePromise)(l=>this.ripgrepTextSearch(s,d=>i.fire(d),l)),r.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}ripgrepTextSearch(t,r,s){return t.maxFileSize=(0,u.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new g.TextSearchEngineAdapter(t).search(s,r,r)}doFileSearch(t,r,s){return this.doFileSearchWithEngine(c.Engine,t,r,s)}doFileSearchWithEngine(t,r,s,i,l=_.BATCH_SIZE){let d=0;const f=y=>{Array.isArray(y)?(d+=y.length,s(y.map(p=>this.rawMatchToSearchItem(p)))):y.relativePath?(d++,s(this.rawMatchToSearchItem(y))):s(y)};if(r.sortByScore){let y=this.trySortedSearchFromCache(r,f,i);if(!y){const p=r.maxResults?Object.assign({},r,{maxResults:null}):r,S=new t(p);y=this.doSortedSearch(S,r,s,f,i)}return new Promise((p,S)=>{y.then(([b,F])=>{const N=F.map(G=>this.rawMatchToSearchItem(G));this.sendProgress(N,s,l),p(b)},S)})}const w=new t(r);return this.doSearch(w,f,l,i).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.processType,fromCache:!1,resultCount:d,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,A.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,s,i,l){const d=new k.Emitter;let f=(0,C.createCancelablePromise)(y=>{let p=[];const S=b=>{Array.isArray(b)?p=b:(i(b),d.fire(b))};return this.doSearch(t,S,-1,y).then(b=>[b,p])}),w;if(r.cacheKey){w=this.getOrCreateCache(r.cacheKey);const y={promise:f,event:d.event,resolved:!1};w.resultsToSearchCache[r.filePattern||""]=y,f.then(()=>{y.resolved=!0},p=>{delete w.resultsToSearchCache[r.filePattern||""]}),f=this.preventCancellation(f)}return f.then(([y,p])=>{const S=w?w.scorerCache:Object.create(null),b=(typeof r.maxResults!="number"||r.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(r,p,S,l).then(F=>{const N=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:r.folderQueries.length,resultCount:F.length},messages:y.messages,limitHit:y.limitHit||typeof r.maxResults=="number"&&p.length>r.maxResults},F]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new P)}trySortedSearchFromCache(t,r,s){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const l=this.getResultsFromCache(i,t.filePattern||"",r,s);if(l)return l.then(([d,f,w])=>{const y=n.StopWatch.create(!1);return this.sortResults(t,f,i.scorerCache,s).then(p=>{const S=y.elapsed(),b={fromCache:!0,detailStats:w,type:this.processType,resultCount:f.length,sortingTime:S};return[{type:"success",limitHit:d.limitHit||typeof t.maxResults=="number"&&f.length>t.maxResults,stats:b},p]})})}sortResults(t,r,s,i){const l=(0,D.prepareQuery)(t.filePattern||""),d=(w,y)=>(0,D.compareItemsByFuzzyScore)(w,y,l,!0,E,s),f=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return I.topAsync(r,d,f,1e4,i)}sendProgress(t,r,s){if(s&&s>0)for(let i=0;i<t.length;i+=s)r(t.slice(i,i+s));else r(t)}getResultsFromCache(t,r,s,i){const l=n.StopWatch.create(!1),d=r.indexOf(A.sep)>=0;let f;for(const S in t.resultsToSearchCache)if(r.startsWith(S)){if(d&&S.indexOf(A.sep)<0&&S!=="")continue;const b=t.resultsToSearchCache[S];f={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!f)return null;const w=l.elapsed(),y=n.StopWatch.create(!1),p=f.event(s);return i&&i.onCancellationRequested(()=>{p.dispose()}),f.promise.then(([S,b])=>{if(i&&i.isCancellationRequested)throw(0,R.canceled)();const F=[],N=(0,D.prepareQuery)(r).normalizedLowercase;for(const G of b)!(0,h.isFilePatternMatch)(G,N)||F.push(G);return[S,F,{cacheWasResolved:f.resolved,cacheLookupTime:w,cacheFilterTime:y.elapsed(),cacheEntryCount:b.length}]})}doSearch(t,r,s,i){return new Promise((l,d)=>{let f=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(s?(f.push(w),s>0&&f.length>=s&&(r(f),f=[])):r(w))},w=>{r(w)},(w,y)=>{f.length&&r(f),w?d(w):l(y)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,s){return t.then(r,s)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class P{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(v){return(0,A.basename)(v.relativePath)}getItemDescription(v){return(0,A.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function o(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(a),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>T.URI.revive(t))}}function a(v){return{...v,folder:T.URI.revive(v.folder)}}}),define(me[285],ge([0,1,6,10,2,28,12,27,14,73,64,31,284,282,94,135]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends A.ExtHostSearch{constructor(E,o,a,v){super(E,a,v);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new c.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new h.RipgrepSearchProvider(t)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new c.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new h.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(L.Schemas.file,new u.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,o){const a=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(E)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(E,o,a,v){const t=(0,A.reviveQuery)(a);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,o,t,v):super.$provideFileSearchResults(E,o,a,v)}doInternalFileSearch(E,o,a,v){const t=r=>{if((0,T.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(E,o,r.map(s=>I.URI.file(s.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,t,v)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,o){return new g.NativeTextSearchManager(E,o,void 0,"textSearchProvider")}};_=Ve([xe(0,D.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,n.IURITransformerService),xe(3,R.ILogService)],_),e.NativeExtHostSearch=_}),define(me[137],ge([0,1,299,126,80,22,16,3,6,8,11,32,106,107,300]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(f){this.socket=f,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const w=y=>f(C.VSBuffer.wrap(y));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(f){const w=y=>{f({type:0,hadError:y,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((f,w)=>{if(this.socket.bufferSize===0){f();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),f()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=g;var _;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var P;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(P||(P={}));class E extends D.Disposable{constructor(f,w,y,p){super();this._onDidZlibFlush=this._register(new k.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=p,w?(this._zlibInflate=c.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",S=>{console.error(S),(0,R.onUnexpectedError)(S),this._onClose.fire({type:0,hadError:!0,error:S})}),this._zlibInflate.on("data",S=>{this._pendingInflateData.push(S)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=c.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",S=>{console.error(S),(0,R.onUnexpectedError)(S),this._onClose.fire({type:0,hadError:!0,error:S})}),this._zlibDeflate.on("data",S=>{this._pendingDeflateData.push(S)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new h.ChunkStream,this._register(this.socket.onData(S=>this._acceptChunk(S))),this._register(this.socket.onClose(S=>this._onClose.fire(S)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(C.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,w){let y=2;f.byteLength<126?y+=0:f.byteLength<2**16?y+=2:y+=8;const p=C.VSBuffer.alloc(y);if(w?p.writeUInt8(194,0):p.writeUInt8(130,0),f.byteLength<126)p.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){p.writeUInt8(126,1);let S=1;p.writeUInt8(f.byteLength>>>8&255,++S),p.writeUInt8(f.byteLength>>>0&255,++S)}else{p.writeUInt8(127,1);let S=1;p.writeUInt8(0,++S),p.writeUInt8(0,++S),p.writeUInt8(0,++S),p.writeUInt8(0,++S),p.writeUInt8(f.byteLength>>>24&255,++S),p.writeUInt8(f.byteLength>>>16&255,++S),p.writeUInt8(f.byteLength>>>8&255,++S),p.writeUInt8(f.byteLength>>>0&255,++S)}this._totalOutgoingWireBytes+=p.byteLength+f.byteLength,this.socket.write(C.VSBuffer.concat([p,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),p=(w.readUInt8(0)&128)>>>7,S=w.readUInt8(1),b=(S&128)>>>7,F=S&127;this._state.state=2,this._state.readLen=2+(b?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=p,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),y=w.readUInt8(1),p=(y&128)>>>7;let S=y&127,b=1;S===126?S=w.readUInt8(++b)*2**8+w.readUInt8(++b):S===127&&(S=w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*2**24+w.readUInt8(++b)*2**16+w.readUInt8(++b)*2**8+w.readUInt8(++b));let F=0;p&&(F=w.readUInt8(++b)*2**24+w.readUInt8(++b)*2**16+w.readUInt8(++b)*2**8+w.readUInt8(++b)),this._state.state=3,this._state.readLen=S,this._state.mask=F}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);o(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(C.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await k.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function o(d,f){if(f===0)return;let w=d.byteLength>>>2;for(let N=0;N<w;N++){const G=d.readUInt32BE(N*4);d.writeUInt32BE(G^f,N*4)}let y=w*4,p=d.byteLength-y;const S=f>>>24&255,b=f>>>16&255,F=f>>>8&255;p>=1&&d.writeUInt8(d.readUInt8(y)^S,y),p>=2&&d.writeUInt8(d.readUInt8(y+1)^b,y+1),p>=3&&d.writeUInt8(d.readUInt8(y+2)^F,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function v(){const d=(0,T.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let f;return e.XDG_RUNTIME_DIR?f=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):f=(0,A.join)((0,I.tmpdir)(),`vscode-ipc-${d}.sock`),r(f),f}e.createRandomIPCHandle=v;function t(d,f,w){const y=(0,m.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${w}-${f}-sock`;let p;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?p=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${w}-${f}.sock`):p=(0,A.join)(d,`${w}-${f}.sock`),r(p),p}e.createStaticIPCHandle=t;function r(d){const f=a[n.platform];typeof f=="number"&&d.length>=f&&console.warn(`WARNING: IPC handle "${d}" is longer than ${f} chars, try a shorter --user-data-dir`)}class s extends u.IPCServer{constructor(f){super(s.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const w=k.Event.fromNodeEventEmitter(f,"connection");return k.Event.map(w,y=>({protocol:new h.Protocol(new g(y)),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(d){return new Promise((f,w)=>{const y=(0,L.createServer)();y.on("error",w),y.listen(d,()=>{y.removeListener("error",w),f(new s(y))})})}e.serve=i;function l(d,f){return new Promise((w,y)=>{const p=(0,L.createConnection)(d,()=>{p.removeListener("error",y),w(h.Client.fromSocket(new g(p),f))});p.once("error",y)})}e.connect=l}),define(me[286],ge([0,1,137,278,49,44,2,198,12]),function(Z,e,m,L,I,C,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(u,h,c){this._commands=u,this.logService=h,this._ipcHandlePath=c,this._server=L.createServer((g,_)=>this.onRequest(g,_)),this.setup().catch(g=>(h.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,h){const c=[];u.setEncoding("utf8"),u.on("data",g=>c.push(g)),u.on("end",()=>{const g=JSON.parse(c.join(""));switch(g.type){case"open":this.open(g,h);break;case"openExternal":this.openExternal(g,h);break;case"status":this.getStatus(g,h);break;case"extensionManagement":this.manageExtensions(g,h).catch(this.logService.error);break;default:h.writeHead(404),h.write(`Unknown message type: ${g.type}`,_=>{_&&this.logService.error(_)}),h.end();break}})}open(u,h){let{fileURIs:c,folderURIs:g,forceNewWindow:_,diffMode:P,addMode:E,forceReuseWindow:o,gotoLineMode:a,waitMarkerFilePath:v}=u;const t=[];if(Array.isArray(g))for(const r of g)try{t.push({folderUri:R.URI.parse(r)})}catch(s){}if(Array.isArray(c))for(const r of c)try{(0,k.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:R.URI.parse(r)}):t.push({fileUri:R.URI.parse(r)})}catch(s){}if(t.length){const r=v?R.URI.file(v):void 0,i={forceNewWindow:_,diffMode:P,addMode:E,gotoLineMode:a,forceReuseWindow:o,preferNewWindow:!o&&!r&&!E,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}h.writeHead(200),h.end()}async openExternal(u,h){for(const c of u.uris){const g=R.URI.parse(c),_=g.scheme==="file"?g:c;await this._commands.executeCommand("_remoteCLI.openExternal",_)}h.writeHead(200),h.end()}async manageExtensions(u,h){try{const c=P=>P?.map(E=>/\.vsix$/i.test(E)?R.URI.parse(E):E),g={list:u.list,install:c(u.install),uninstall:c(u.uninstall),force:u.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",g);h.writeHead(200),h.write(_)}catch(c){h.writeHead(500),h.write(String(c),g=>{g&&this.logService.error(g)})}h.end()}async getStatus(u,h){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");h.writeHead(200),h.write(c),h.end()}catch(c){h.writeHead(500),h.write(String(c),g=>{g&&this.logService.error(g)}),h.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let n=class extends A{constructor(u,h){super(u,h,(0,m.createRandomIPCHandle)())}};n=Ve([xe(0,C.IExtHostCommands),xe(1,D.ILogService)],n),e.CLIServer=n}),define(me[287],ge([0,1,72,274,269,5,277,40,259,2,10,7,286,105]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends I.RequireInterceptor{_installInterceptor(){const P=this,E=Z.__$__nodeRequire("module"),o=E._load;E._load=function(v,t,r){for(let s of P._alternatives){let i=s(v);if(i){v=i;break}}return P._factories.has(v)?P._factories.get(v).load(v,A.URI.file((0,h.realpathSync)(t.filename)),s=>o.apply(this,[s,t,r])):o.apply(this,arguments)}}}class g extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,P,this._registry).install(),m.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const a=process.send,v=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?a.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,E,o){if(E.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{P&&m.mark(`code/extHost/willLoadExtensionCode/${P.value}`),a=Z.__$__nodeRequire(E.fsPath)}catch(v){return Promise.reject(v)}finally{P&&m.mark(`code/extHost/didLoadExtensionCode/${P.value}`),o.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const E in P){const o=P[E];o===null?delete process.env[E]:process.env[E]=o}}}e.ExtHostExtensionService=g}),define(me[288],ge([0,1,82,260,262,271,270,285,287,227,263,53,40,67,73,71,33,52,12,68,261]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_,P,E,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(u.IExtHostExtensionService,D.ExtHostExtensionService),(0,m.registerSingleton)(E.ILogService,A.ExtHostLogService),(0,m.registerSingleton)(o.IExtensionStoragePaths,a.ExtensionStoragePaths),(0,m.registerSingleton)(T.IExtHostDebugService,R.ExtHostDebugService),(0,m.registerSingleton)(h.IExtHostOutputService,L.ExtHostOutputService2),(0,m.registerSingleton)(c.IExtHostSearch,k.NativeExtHostSearch),(0,m.registerSingleton)(g.IExtHostTask,C.ExtHostTask),(0,m.registerSingleton)(_.IExtHostTerminalService,I.ExtHostTerminalService),(0,m.registerSingleton)(P.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[289],ge([0,1,126,301,72,16,107,137,117,225,272,22,103,28,105,17,118,275,288]),function(Z,e,m,L,I,C,R,k,D,A,n,T,u,h,c,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=Z.__$__nodeRequire("module"),l=i._load;i._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return l.apply(this,arguments)}})();const E=process.exit.bind(process);function o(i){process.exit=function(l){if(i)E(l);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)}}let a=function(i){E()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,l)=>{let d=null,f=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,y=3e5,p=new g.RunOnceScheduler(()=>a("renderer disconnected for too long (1)"),w),S=new g.RunOnceScheduler(()=>a("renderer disconnected for too long (2)"),y);process.on("message",(F,N)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=T.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let K;if(F.skipWebSocketFrames)K=new k.NodeSocket(N);else{const M=T.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));K=new k.WebSocketNodeSocket(new k.NodeSocket(N),F.permessageDeflate,M,!1)}d?(p.cancel(),S.cancel(),d.beginAcceptReconnection(K,G),d.endAcceptReconnection()):(clearTimeout(f),d=new R.PersistentProtocol(K,G),d.onDidDispose(()=>a("renderer disconnected")),i(d),d.onSocketClose(()=>{p.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(S.isScheduled())return;p.isScheduled()&&S.schedule()}});const b={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(b)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((l,d)=>{const f=m.createConnection(i,()=>{f.removeListener("error",d),l(new R.PersistentProtocol(new k.NodeSocket(f)))});f.once("error",d),f.on("close",()=>{a("renderer closed the socket")})})}}async function t(){const i=await v();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(l=>{(0,A.isMessageOfType)(l,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||i.send(l)}drain(){return i.drain()}}}function r(i){return new Promise(l=>{const d=i.onMessage(f=>{d.dispose();const w=JSON.parse(f.toString()),y=w.commit,p=D.default.commit;y&&p&&y!==p&&E(55);const S=[];process.on("unhandledRejection",(N,G)=>{S.push(G),setTimeout(()=>{const K=S.indexOf(G);K>=0&&G.catch(M=>{S.splice(K,1),(0,C.isPromiseCanceledError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),(0,C.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const G=S.indexOf(N);G>=0&&S.splice(G,1)}),process.on("uncaughtException",function(N){(0,C.onUnexpectedError)(N)});let b=0;setInterval(function(){try{process.kill(w.parentPid,0),b=0}catch(N){N&&N.code==="EPERM"?(b++,b>=3&&a(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):a(`parent process ${w.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let F;try{F=Z.__$__nodeRequire("native-watchdog"),F.start(w.parentPid)}catch(N){(0,C.onUnexpectedError)(N)}i.send((0,A.createMessageOfType)(0)),l({protocol:i,initData:w})});i.send((0,A.createMessageOfType)(1))})}async function s(){I.mark("code/extHost/willConnectToRenderer");const i=await t();I.mark("code/extHost/didConnectToRenderer");const l=await r(i);I.mark("code/extHost/didWaitForInitData");const{initData:d}=l;o(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,_.boolean)(P.skipWorkspaceStorageLock,!1);const f=new class{exit(S){E(S)}exists(S){return h.Promises.exists(S)}realpath(S){return(0,c.realpath)(S)}};let w=null;if(d.remote.authority&&P.uriTransformerPath)try{const S=Z.__$__nodeRequire(P.uriTransformerPath)(d.remote.authority);w=new u.URITransformer(S)}catch(p){console.error(p)}const y=new n.ExtensionHostMain(l.protocol,d,f,w);a=p=>y.terminate(p)}e.startExtensionHostProcess=s}),define(me[302],ge([0,1,289]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5f19eee5dc9588ca96192f89587b5878b7d7180d/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
