/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/iterator","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(ne){for(var e=[],c=0,F=ne.length;c<F;c++)e[c]=ve[ne[c]];return e};define(ve[39],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(F,_){if(!F)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=c}),define(ve[50],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function F(t){const y=[];for(let n in t)c.call(t,n)&&y.push(t[n]);return y}e.values=F;function _(t,y){for(let n in t)if(c.call(t,n)&&y({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=_;function A(t,y){const n=Object.create(null);for(const d of t){const o=y(d);let a=n[o];a||(a=n[o]=[]),a.push(d)}return n}e.groupBy=A;function T(t){const y=Object.create(null);return t&&t.forEach((n,d)=>{y[d]=n}),y}e.fromMap=T;function I(t,y){const n=[],d=[];for(let o of t)y.has(o)||n.push(o);for(let o of y)t.has(o)||d.push(o);return{removed:n,added:d}}e.diffSets=I;function S(t,y){const n=[],d=[];for(let[o,a]of t)y.has(o)||n.push(a);for(let[o,a]of y)t.has(o)||d.push(a);return{removed:n,added:d}}e.diffMaps=S;class P{constructor(){this.map=new Map}add(y,n){let d=this.map.get(y);d||(d=new Set,this.map.set(y,d)),d.add(n)}delete(y,n){const d=this.map.get(y);!d||(d.delete(n),d.size===0&&this.map.delete(y))}forEach(y,n){const d=this.map.get(y);!d||d.forEach(n)}}e.SetMap=P}),define(ve[51],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(T){return(I,S,P)=>{let t=null,y=null;if(typeof P.value=="function"?(t="value",y=P.value):typeof P.get=="function"&&(t="get",y=P.get),!y)throw new Error("not supported");P[t]=T(y,S)}}e.createDecorator=c;function F(T,I,S){let P=null,t=null;if(typeof S.value=="function"?(P="value",t=S.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(P="get",t=S.get),!t)throw new Error("not supported");const y=`$memoize$${I}`;S[P]=function(...n){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[y]}}e.memoize=F;function _(T,I,S){return c((P,t)=>{const y=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...d){this[n]||(this[n]=S?S():void 0),clearTimeout(this[y]),I&&(this[n]=I(this[n],...d),d=[this[n]]),this[y]=setTimeout(()=>{P.apply(this,d),this[n]=S?S():void 0},T)}})}e.debounce=_;function A(T,I,S){return c((P,t)=>{const y=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,d=`$throttle$lastRun$${t}`,o=`$throttle$pending$${t}`;return function(...a){if(this[n]||(this[n]=S?S():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[n]=I(this[n],...a)),this[o])return;const g=this[d]+T;g<=Date.now()?(this[d]=Date.now(),P.apply(this,[this[n]]),this[n]=S?S():void 0):(this[o]=!0,this[y]=setTimeout(()=>{this[o]=!1,this[d]=Date.now(),P.apply(this,[this[n]]),this[n]=S?S():void 0},g-Date.now()))}})}e.throttle=A}),define(ve[16],we([0,1,15]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(G,ue=0){return G[G.length-(1+ue)]}e.tail=F;function _(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.tail2=_;function A(G,ue,oe=(be,Ae)=>be===Ae){if(G===ue)return!0;if(!G||!ue||G.length!==ue.length)return!1;for(let be=0,Ae=G.length;be<Ae;be++)if(!oe(G[be],ue[be]))return!1;return!0}e.equals=A;function T(G,ue,oe){let be=0,Ae=G.length-1;for(;be<=Ae;){const Re=(be+Ae)/2|0,Oe=oe(G[Re],ue);if(Oe<0)be=Re+1;else if(Oe>0)Ae=Re-1;else return Re}return-(be+1)}e.binarySearch=T;function I(G,ue){let oe=0,be=G.length;if(be===0)return 0;for(;oe<be;){const Ae=Math.floor((oe+be)/2);ue(G[Ae])?be=Ae:oe=Ae+1}return oe}e.findFirstInSorted=I;function S(G,ue,oe){if(G=G|0,G>=ue.length)throw new TypeError("invalid index");let be=ue[Math.floor(ue.length*Math.random())],Ae=[],Re=[],Oe=[];for(let Qe of ue){const He=oe(Qe,be);He<0?Ae.push(Qe):He>0?Re.push(Qe):Oe.push(Qe)}return G<Ae.length?S(G,Ae,oe):G<Ae.length+Oe.length?Oe[0]:S(G-(Ae.length+Oe.length),Re,oe)}e.quickSelect=S;function P(G,ue){const oe=[];let be;for(const Ae of G.slice(0).sort(ue))!be||ue(be[0],Ae)!==0?(be=[Ae],oe.push(be)):be.push(Ae);return oe}e.groupBy=P;function t(G,ue,oe){const be=[];function Ae(Qe,He,je){if(He===0&&je.length===0)return;const U=be[be.length-1];U&&U.start+U.deleteCount===Qe?(U.deleteCount+=He,U.toInsert.push(...je)):be.push({start:Qe,deleteCount:He,toInsert:je})}let Re=0,Oe=0;for(;;){if(Re===G.length){Ae(Re,0,ue.slice(Oe));break}if(Oe===ue.length){Ae(Re,G.length-Re,[]);break}const Qe=G[Re],He=ue[Oe],je=oe(Qe,He);je===0?(Re+=1,Oe+=1):je<0?(Ae(Re,1,[]),Re+=1):je>0&&(Ae(Re,0,[He]),Oe+=1)}return be}e.sortedDiff=t;function y(G,ue,oe){const be=t(G,ue,oe),Ae=[],Re=[];for(const Oe of be)Ae.push(...G.slice(Oe.start,Oe.start+Oe.deleteCount)),Re.push(...Oe.toInsert);return{removed:Ae,added:Re}}e.delta=y;function n(G,ue,oe){if(oe===0)return[];const be=G.slice(0,oe).sort(ue);return o(G,ue,be,oe,G.length),be}e.top=n;function d(G,ue,oe,be,Ae){return oe===0?Promise.resolve([]):new Promise((Re,Oe)=>{(async()=>{const Qe=G.length,He=G.slice(0,oe).sort(ue);for(let je=oe,U=Math.min(oe+be,Qe);je<Qe;je=U,U=Math.min(U+be,Qe)){if(je>oe&&await new Promise(K=>setTimeout(K)),Ae&&Ae.isCancellationRequested)throw(0,c.canceled)();o(G,ue,He,je,U)}return He})().then(Re,Oe)})}e.topAsync=d;function o(G,ue,oe,be,Ae){for(const Re=oe.length;be<Ae;be++){const Oe=G[be];if(ue(Oe,oe[Re-1])<0){oe.pop();const Qe=I(oe,He=>ue(Oe,He)<0);oe.splice(Qe,0,Oe)}}}function a(G){return G.filter(ue=>!!ue)}e.coalesce=a;function g(G){let ue=0;for(let oe=0;oe<G.length;oe++)G[oe]&&(G[ue]=G[oe],ue+=1);G.length=ue}e.coalesceInPlace=g;function k(G,ue,oe){G.splice(oe,0,G.splice(ue,1)[0])}e.move=k;function b(G){return!Array.isArray(G)||G.length===0}e.isFalsyOrEmpty=b;function u(G){return Array.isArray(G)&&G.length>0}e.isNonEmptyArray=u;function p(G,ue){if(!ue)return G.filter((be,Ae)=>G.indexOf(be)===Ae);const oe=Object.create(null);return G.filter(be=>{const Ae=ue(be);return oe[Ae]?!1:(oe[Ae]=!0,!0)})}e.distinct=p;function D(G){const ue=new Set;return G.filter(oe=>ue.has(oe)?!1:(ue.add(oe),!0))}e.distinctES6=D;function i(G){const ue=Object.create(null);return oe=>{const be=G(oe);return ue[be]?!1:(ue[be]=!0,!0)}}e.uniqueFilter=i;function r(G,ue){for(let oe=G.length-1;oe>=0;oe--){const be=G[oe];if(ue(be))return oe}return-1}e.lastIndex=r;function l(G,ue){return G.length>0?G[0]:ue}e.firstOrDefault=l;function s(G,ue,oe=(be,Ae)=>be===Ae){let be=0;for(let Ae=0,Re=Math.min(G.length,ue.length);Ae<Re&&oe(G[Ae],ue[Ae]);Ae++)be++;return be}e.commonPrefixLength=s;function m(G){return[].concat(...G)}e.flatten=m;function v(G,ue){let oe=typeof ue=="number"?G:0;typeof ue=="number"?oe=G:(oe=0,ue=G);const be=[];if(oe<=ue)for(let Ae=oe;Ae<ue;Ae++)be.push(Ae);else for(let Ae=oe;Ae>ue;Ae--)be.push(Ae);return be}e.range=v;function w(G,ue,oe){return G.reduce((be,Ae)=>(be[ue(Ae)]=oe?oe(Ae):Ae,be),Object.create(null))}e.index=w;function C(G,ue){return G.push(ue),()=>R(G,ue)}e.insert=C;function R(G,ue){const oe=G.indexOf(ue);if(oe>-1)return G.splice(oe,1),ue}e.remove=R;function f(G,ue,oe){const be=G.slice(0,ue),Ae=G.slice(ue);return be.concat(oe,Ae)}e.arrayInsert=f;function E(G,ue){let oe;if(typeof ue=="number"){let be=ue;oe=()=>{const Ae=Math.sin(be++)*179426549;return Ae-Math.floor(Ae)}}else oe=Math.random;for(let be=G.length-1;be>0;be-=1){const Ae=Math.floor(oe()*(be+1)),Re=G[be];G[be]=G[Ae],G[Ae]=Re}}e.shuffle=E;function h(G,ue){const oe=G.indexOf(ue);oe>-1&&(G.splice(oe,1),G.unshift(ue))}e.pushToStart=h;function M(G,ue){const oe=G.indexOf(ue);oe>-1&&(G.splice(oe,1),G.push(ue))}e.pushToEnd=M;function O(G,ue){return Array.isArray(G)?G.map(ue):ue(G)}e.mapArrayOrNot=O;function q(G){return Array.isArray(G)?G:[G]}e.asArray=q;function Q(G){return G[Math.floor(Math.random()*G.length)]}e.getRandomElement=Q;function $(G,ue){for(const oe of G){const be=ue(oe);if(be!==void 0)return be}}e.mapFind=$;function z(G,ue,oe){const be=W(G,ue),Ae=G.length,Re=oe.length;G.length=Ae+Re;for(let Oe=Ae-1;Oe>=be;Oe--)G[Oe+Re]=G[Oe];for(let Oe=0;Oe<Re;Oe++)G[Oe+be]=oe[Oe]}e.insertInto=z;function N(G,ue,oe,be){const Ae=W(G,ue),Re=G.splice(Ae,oe);return z(G,Ae,be),Re}e.splice=N;function W(G,ue){return ue<0?Math.max(ue+G.length,0):Math.min(ue,G.length)}function j(G,ue){let oe=Number.MAX_SAFE_INTEGER,be=0;return G.forEach((Ae,Re)=>{const Oe=ue(Ae);Oe<oe&&(oe=Oe,be=Re)}),be}e.minIndex=j;function Y(G,ue){let oe=Number.MIN_SAFE_INTEGER,be=0;return G.forEach((Ae,Re)=>{const Oe=ue(Ae);Oe>oe&&(oe=Oe,be=Re)}),be}e.maxIndex=Y;class de{constructor(ue){this.items=ue,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ue){let oe=this.firstIdx;for(;oe<this.items.length&&ue(this.items[oe]);)oe++;const be=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,be}takeFromEndWhile(ue){let oe=this.lastIdx;for(;oe>=0&&ue(this.items[oe]);)oe--;const be=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,be}}e.ArrayQueue=de}),define(ve[52],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(ve[102],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(i,r=!1){let l=0,s=i.length,m="",v=0,w=16,C=0;function R(Q){let $=0,z=0;for(;$<Q;){const N=i.charCodeAt(l);if(N>=48&&N<=57)z=z*16+N-48;else if(N>=65&&N<=70)z=z*16+N-65+10;else if(N>=97&&N<=102)z=z*16+N-97+10;else break;l++,$++}return $<Q&&(z=-1),z}function f(Q){l=Q,m="",v=0,w=16,C=0}function E(){const Q=l;if(i.charCodeAt(l)===48)l++;else for(l++;l<i.length&&P(i.charCodeAt(l));)l++;if(l<i.length&&i.charCodeAt(l)===46)if(l++,l<i.length&&P(i.charCodeAt(l)))for(l++;l<i.length&&P(i.charCodeAt(l));)l++;else return C=3,i.substring(Q,l);let $=l;if(l<i.length&&(i.charCodeAt(l)===69||i.charCodeAt(l)===101))if(l++,(l<i.length&&i.charCodeAt(l)===43||i.charCodeAt(l)===45)&&l++,l<i.length&&P(i.charCodeAt(l))){for(l++;l<i.length&&P(i.charCodeAt(l));)l++;$=l}else C=3;return i.substring(Q,$)}function h(){let Q="",$=l;for(;;){if(l>=s){Q+=i.substring($,l),C=2;break}const z=i.charCodeAt(l);if(z===34){Q+=i.substring($,l),l++;break}if(z===92){if(Q+=i.substring($,l),l++,l>=s){C=2;break}switch(i.charCodeAt(l++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const W=R(4);W>=0?Q+=String.fromCharCode(W):C=4;break;default:C=5}$=l;continue}if(z>=0&&z<=31)if(S(z)){Q+=i.substring($,l),C=2;break}else C=6;l++}return Q}function M(){if(m="",C=0,v=l,l>=s)return v=s,w=17;let Q=i.charCodeAt(l);if(I(Q)){do l++,m+=String.fromCharCode(Q),Q=i.charCodeAt(l);while(I(Q));return w=15}if(S(Q))return l++,m+=String.fromCharCode(Q),Q===13&&i.charCodeAt(l)===10&&(l++,m+=`
`),w=14;switch(Q){case 123:return l++,w=1;case 125:return l++,w=2;case 91:return l++,w=3;case 93:return l++,w=4;case 58:return l++,w=6;case 44:return l++,w=5;case 34:return l++,m=h(),w=10;case 47:const $=l-1;if(i.charCodeAt(l+1)===47){for(l+=2;l<s&&!S(i.charCodeAt(l));)l++;return m=i.substring($,l),w=12}if(i.charCodeAt(l+1)===42){l+=2;const z=s-1;let N=!1;for(;l<z;){if(i.charCodeAt(l)===42&&i.charCodeAt(l+1)===47){l+=2,N=!0;break}l++}return N||(l++,C=1),m=i.substring($,l),w=13}return m+=String.fromCharCode(Q),l++,w=16;case 45:if(m+=String.fromCharCode(Q),l++,l===s||!P(i.charCodeAt(l)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=E(),w=11;default:for(;l<s&&O(Q);)l++,Q=i.charCodeAt(l);if(v!==l){switch(m=i.substring(v,l),m){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return m+=String.fromCharCode(Q),l++,w=16}}function O(Q){if(I(Q)||S(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let Q;do Q=M();while(Q>=12&&Q<=15);return Q}return{setPosition:f,getPosition:()=>l,scan:r?q:M,getToken:()=>w,getTokenValue:()=>m,getTokenOffset:()=>v,getTokenLength:()=>l-v,getTokenError:()=>C}}e.createScanner=T;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function y(i,r){const l=[],s=new Object;let m;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function C(R,f,E,h){v.value=R,v.offset=f,v.length=E,v.type=h,v.colonOffset=void 0,m=v}try{u(i,{onObjectBegin:(R,f)=>{if(r<=R)throw s;m=void 0,w=r>R,l.push("")},onObjectProperty:(R,f,E)=>{if(r<f||(C(R,f,E,"property"),l[l.length-1]=R,r<=f+E))throw s},onObjectEnd:(R,f)=>{if(r<=R)throw s;m=void 0,l.pop()},onArrayBegin:(R,f)=>{if(r<=R)throw s;m=void 0,l.push(0)},onArrayEnd:(R,f)=>{if(r<=R)throw s;m=void 0,l.pop()},onLiteralValue:(R,f,E)=>{if(r<f||(C(R,f,E,D(R)),r<=f+E))throw s},onSeparator:(R,f,E)=>{if(r<=f)throw s;if(R===":"&&m&&m.type==="property")m.colonOffset=f,w=!1,m=void 0;else if(R===","){const h=l[l.length-1];typeof h=="number"?l[l.length-1]=h+1:(w=!0,l[l.length-1]=""),m=void 0}}})}catch(R){if(R!==s)throw R}return{path:l,previousNode:m,isAtPropertyKey:w,matches:R=>{let f=0;for(let E=0;f<R.length&&E<l.length;E++)if(R[f]===l[E]||R[f]==="*")f++;else if(R[f]!=="**")return!1;return f===R.length}}}e.getLocation=y;function n(i,r=[],l=A.DEFAULT){let s=null,m=[];const v=[];function w(R){Array.isArray(m)?m.push(R):s!==null&&(m[s]=R)}return u(i,{onObjectBegin:()=>{const R={};w(R),v.push(m),m=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{m=v.pop()},onArrayBegin:()=>{const R=[];w(R),v.push(m),m=R,s=null},onArrayEnd:()=>{m=v.pop()},onLiteralValue:w,onError:(R,f,E)=>{r.push({error:R,offset:f,length:E})}},l),m[0]}e.parse=n;function d(i,r=[],l=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function v(R){return s.children.push(R),R}u(i,{onObjectBegin:R=>{s=v({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,f,E)=>{s=v({type:"property",offset:f,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:f,length:E,parent:s})},onObjectEnd:(R,f)=>{s.length=R+f-s.offset,s=s.parent,m(R+f)},onArrayBegin:(R,f)=>{s=v({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,f)=>{s.length=R+f-s.offset,s=s.parent,m(R+f)},onLiteralValue:(R,f,E)=>{v({type:D(R),offset:f,length:E,parent:s,value:R}),m(f+E)},onSeparator:(R,f,E)=>{s.type==="property"&&(R===":"?s.colonOffset=f:R===","&&m(f))},onError:(R,f,E)=>{r.push({error:R,offset:f,length:E})}},l);const C=s.children[0];return C&&delete C.parent,C}e.parseTree=d;function o(i,r){if(!i)return;let l=i;for(let s of r)if(typeof s=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let m=!1;for(const v of l.children)if(Array.isArray(v.children)&&v.children[0].value===s){l=v.children[1],m=!0;break}if(!m)return}else{const m=s;if(l.type!=="array"||m<0||!Array.isArray(l.children)||m>=l.children.length)return;l=l.children[m]}return l}e.findNodeAtLocation=o;function a(i){if(!i.parent||!i.parent.children)return[];const r=a(i.parent);if(i.parent.type==="property"){const l=i.parent.children[0].value;r.push(l)}else if(i.parent.type==="array"){const l=i.parent.children.indexOf(i);l!==-1&&r.push(l)}return r}e.getNodePath=a;function g(i){switch(i.type){case"array":return i.children.map(g);case"object":const r=Object.create(null);for(let l of i.children){const s=l.children[1];s&&(r[l.children[0].value]=g(s))}return r;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=g;function k(i,r,l=!1){return r>=i.offset&&r<i.offset+i.length||l&&r===i.offset+i.length}e.contains=k;function b(i,r,l=!1){if(k(i,r,l)){const s=i.children;if(Array.isArray(s))for(let m=0;m<s.length&&s[m].offset<=r;m++){const v=b(s[m],r,l);if(v)return v}return i}}e.findNodeAtOffset=b;function u(i,r,l=A.DEFAULT){const s=T(i,!1);function m(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function v(oe){return oe?be=>oe(be,s.getTokenOffset(),s.getTokenLength()):()=>!0}const w=m(r.onObjectBegin),C=v(r.onObjectProperty),R=m(r.onObjectEnd),f=m(r.onArrayBegin),E=m(r.onArrayEnd),h=v(r.onLiteralValue),M=v(r.onSeparator),O=m(r.onComment),q=v(r.onError),Q=l&&l.disallowComments,$=l&&l.allowTrailingComma;function z(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:Q||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(oe){case 12:case 13:Q?N(10):O();break;case 16:N(1);break;case 15:case 14:break;default:return oe}}}function N(oe,be=[],Ae=[]){if(q(oe),be.length+Ae.length>0){let Re=s.getToken();for(;Re!==17;){if(be.indexOf(Re)!==-1){z();break}else if(Ae.indexOf(Re)!==-1)break;Re=z()}}}function W(oe){const be=s.getTokenValue();return oe?h(be):C(be),z(),!0}function j(){switch(s.getToken()){case 11:let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&(N(2),oe=0)}catch(be){N(2)}h(oe);break;case 7:h(null);break;case 8:h(!0);break;case 9:h(!1);break;default:return!1}return z(),!0}function Y(){return s.getToken()!==10?(N(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(M(":"),z(),ue()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function de(){w(),z();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||N(4,[],[]),M(","),z(),s.getToken()===2&&$)break}else oe&&N(6,[],[]);Y()||N(4,[],[2,5]),oe=!0}return R(),s.getToken()!==2?N(7,[2],[]):z(),!0}function G(){f(),z();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||N(4,[],[]),M(","),z(),s.getToken()===4&&$)break}else oe&&N(6,[],[]);ue()||N(4,[],[4,5]),oe=!0}return E(),s.getToken()!==4?N(8,[4],[]):z(),!0}function ue(){switch(s.getToken()){case 3:return G();case 1:return de();case 10:return W(!0);default:return j()}}return z(),s.getToken()===17?l.allowEmptyContent?!0:(N(4,[],[]),!1):ue()?(s.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=u;function p(i,r){let l=T(i),s=[],m,v=0,w;do switch(w=l.getPosition(),m=l.scan(),m){case 12:case 13:case 17:v!==w&&s.push(i.substring(v,w)),r!==void 0&&s.push(l.getTokenValue().replace(/[^\r\n]/g,r)),v=l.getPosition();break}while(m!==17);return s.join("")}e.stripComments=p;function D(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(ve[103],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(_){this.executor=_,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(_){return new c(()=>_(this.getValue()))}}e.Lazy=c}),function(ne,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ne=typeof globalThis!="undefined"?globalThis:ne||self,ne.marked=e())}(this,function(){"use strict";function ne(Pe,ye){for(var De=0;De<ye.length;De++){var Z=ye[De];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Pe,Z.key,Z)}}function e(Pe,ye,De){return ye&&ne(Pe.prototype,ye),De&&ne(Pe,De),Pe}function c(Pe,ye){if(!!Pe){if(typeof Pe=="string")return F(Pe,ye);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return F(Pe,ye)}}function F(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var De=0,Z=new Array(ye);De<ye;De++)Z[De]=Pe[De];return Z}function _(Pe,ye){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=c(Pe))||ye&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var Z=0;return function(){return Z>=Pe.length?{done:!0}:{done:!1,value:Pe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Pe){A.exports.defaults=Pe}A.exports={defaults:T(),getDefaults:T,changeDefaults:I};var S=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ye){return n[ye]};function o(Pe,ye){if(ye){if(S.test(Pe))return Pe.replace(P,d)}else if(t.test(Pe))return Pe.replace(y,d);return Pe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Pe){return Pe.replace(a,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var k=/(^|[^\[])\^/g;function b(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var De={replace:function(le,ge){return ge=ge.source||ge,ge=ge.replace(k,"$1"),Pe=Pe.replace(le,ge),De},getRegex:function(){return new RegExp(Pe,ye)}};return De}var u=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(Pe,ye,De){if(Pe){var Z;try{Z=decodeURIComponent(g(De)).replace(u,"").toLowerCase()}catch(le){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!p.test(De)&&(De=m(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(le){return null}return De}var i={},r=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Pe,ye){i[" "+Pe]||(r.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=R(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Pe.replace(l,"$1")+ye:ye.charAt(0)==="/"?De?ye:Pe.replace(s,"$1")+ye:Pe+ye}var v={exec:function(){}};function w(Pe){for(var ye=1,De,Z;ye<arguments.length;ye++){De=arguments[ye];for(Z in De)Object.prototype.hasOwnProperty.call(De,Z)&&(Pe[Z]=De[Z])}return Pe}function C(Pe,ye){var De=Pe.replace(/\|/g,function(ge,fe,Ie){for(var xe=!1,Le=fe;--Le>=0&&Ie[Le]==="\\";)xe=!xe;return xe?"|":" |"}),Z=De.split(/ \|/),le=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;le<Z.length;le++)Z[le]=Z[le].trim().replace(/\\\|/g,"|");return Z}function R(Pe,ye,De){var Z=Pe.length;if(Z===0)return"";for(var le=0;le<Z;){var ge=Pe.charAt(Z-le-1);if(ge===ye&&!De)le++;else if(ge!==ye&&De)le++;else break}return Pe.substr(0,Z-le)}function f(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var De=Pe.length,Z=0,le=0;le<De;le++)if(Pe[le]==="\\")le++;else if(Pe[le]===ye[0])Z++;else if(Pe[le]===ye[1]&&(Z--,Z<0))return le;return-1}function E(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function h(Pe,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Pe),ye>>=1,Pe+=Pe;return De+Pe}var M={escape:o,unescape:g,edit:b,cleanUrl:D,resolveUrl:m,noopTest:v,merge:w,splitCells:C,rtrim:R,findClosingBracket:f,checkSanitizeDeprecation:E,repeatString:h},O=A.exports.defaults,q=M.rtrim,Q=M.splitCells,$=M.escape,z=M.findClosingBracket;function N(Pe,ye,De,Z){var le=ye.href,ge=ye.title?$(ye.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");return Pe[0].charAt(0)!=="!"?(Z.state.inLink=!0,{type:"link",raw:De,href:le,title:ge,text:fe,tokens:Z.inlineTokens(fe,[])}):{type:"image",raw:De,href:le,title:ge,text:$(fe)}}function W(Pe,ye){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return ye;var Z=De[1];return ye.split(`
`).map(function(le){var ge=le.match(/^\s+/);if(ge===null)return le;var fe=ge[0];return fe.length>=Z.length?le.slice(Z.length):le}).join(`
`)}var j=function(){function Pe(De){this.options=De||O}var ye=Pe.prototype;return ye.space=function(Z){var le=this.rules.block.newline.exec(Z);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},ye.code=function(Z){var le=this.rules.block.code.exec(Z);if(le){var ge=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:q(ge,`
`)}}},ye.fences=function(Z){var le=this.rules.block.fences.exec(Z);if(le){var ge=le[0],fe=W(ge,le[3]||"");return{type:"code",raw:ge,lang:le[2]?le[2].trim():le[2],text:fe}}},ye.heading=function(Z){var le=this.rules.block.heading.exec(Z);if(le){var ge=le[2].trim();if(/#$/.test(ge)){var fe=q(ge,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ge=fe.trim())}var Ie={type:"heading",raw:le[0],depth:le[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(Z){var le=this.rules.block.hr.exec(Z);if(le)return{type:"hr",raw:le[0]}},ye.blockquote=function(Z){var le=this.rules.block.blockquote.exec(Z);if(le){var ge=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(Z){var le=this.rules.block.list.exec(Z);if(le){var ge,fe,Ie,xe,Le,Ve,Xe,ie,pe,re,B=le[1].trim(),Ce=B.length>1,Se={type:"list",raw:"",ordered:Ce,start:Ce?+B.slice(0,-1):"",loose:!1,items:[]};B=Ce?"\\d{1,9}\\"+B.slice(-1):"\\"+B,this.options.pedantic&&(B=Ce?B:"[*+-]");for(var qe=new RegExp("^( {0,3}"+B+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(le=qe.exec(Z)));){pe=le[2].split(`
`),this.options.pedantic?(xe=2,re=pe[0].trimLeft()):(xe=le[2].search(/[^ ]/),xe=le[1].length+(xe>4?1:xe),re=pe[0].slice(xe-le[1].length)),Ve=!1,ge=le[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=le[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<pe.length;Le++){if(ie=pe[Le],this.options.pedantic&&(ie=ie.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(ie)){ge=le[1]+pe.slice(0,Le).join(`
`)+`
`;break}if(!Ve){ie.trim()||(Ve=!0),ie.search(/[^ ]/)>=xe?re+=`
`+ie.slice(xe):re+=`
`+ie;continue}if(ie.search(/[^ ]/)>=xe||!ie.trim()){re+=`
`+ie.slice(xe);continue}else{ge=le[1]+pe.slice(0,Le).join(`
`)+`
`;break}}Se.loose||(Xe?Se.loose=!0:/\n *\n *$/.test(ge)&&(Xe=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(re),fe&&(Ie=fe[0]!=="[ ] ",re=re.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!fe,checked:Ie,loose:!1,text:re}),Se.raw+=ge,Z=Z.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=re.trimRight(),Se.raw=Se.raw.trimRight();var it=Se.items.length;for(Le=0;Le<it;Le++)this.lexer.state.top=!1,Se.items[Le].tokens=this.lexer.blockTokens(Se.items[Le].text,[]),Se.items[Le].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Le].loose=!0);return Se}},ye.html=function(Z){var le=this.rules.block.html.exec(Z);if(le){var ge={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(Z){var le=this.rules.block.def.exec(Z);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ge=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:le[0],href:le[2],title:le[3]}}},ye.table=function(Z){var le=this.rules.block.table.exec(Z);if(le){var ge={type:"table",header:Q(le[1]).map(function(Xe){return{text:Xe}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=le[0];var fe=ge.align.length,Ie,xe,Le,Ve;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(fe=ge.rows.length,Ie=0;Ie<fe;Ie++)ge.rows[Ie]=Q(ge.rows[Ie],ge.header.length).map(function(Xe){return{text:Xe}});for(fe=ge.header.length,xe=0;xe<fe;xe++)ge.header[xe].tokens=[],this.lexer.inlineTokens(ge.header[xe].text,ge.header[xe].tokens);for(fe=ge.rows.length,xe=0;xe<fe;xe++)for(Ve=ge.rows[xe],Le=0;Le<Ve.length;Le++)Ve[Le].tokens=[],this.lexer.inlineTokens(Ve[Le].text,Ve[Le].tokens);return ge}}},ye.lheading=function(Z){var le=this.rules.block.lheading.exec(Z);if(le){var ge={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(Z){var le=this.rules.block.paragraph.exec(Z);if(le){var ge={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(Z){var le=this.rules.block.text.exec(Z);if(le){var ge={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(Z){var le=this.rules.inline.escape.exec(Z);if(le)return{type:"escape",raw:le[0],text:$(le[1])}},ye.tag=function(Z){var le=this.rules.inline.tag.exec(Z);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]}},ye.link=function(Z){var le=this.rules.inline.link.exec(Z);if(le){var ge=le[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var fe=q(ge.slice(0,-1),"\\");if((ge.length-fe.length)%2==0)return}else{var Ie=z(le[2],"()");if(Ie>-1){var xe=le[0].indexOf("!")===0?5:4,Le=xe+le[1].length+Ie;le[2]=le[2].substring(0,Ie),le[0]=le[0].substring(0,Le).trim(),le[3]=""}}var Ve=le[2],Xe="";if(this.options.pedantic){var ie=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);ie&&(Ve=ie[1],Xe=ie[3])}else Xe=le[3]?le[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(ge)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),N(le,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ye.reflink=function(Z,le){var ge;if((ge=this.rules.inline.reflink.exec(Z))||(ge=this.rules.inline.nolink.exec(Z))){var fe=(ge[2]||ge[1]).replace(/\s+/g," ");if(fe=le[fe.toLowerCase()],!fe||!fe.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return N(ge,fe,ge[0],this.lexer)}},ye.emStrong=function(Z,le,ge){ge===void 0&&(ge="");var fe=this.rules.inline.emStrong.lDelim.exec(Z);if(!!fe&&!(fe[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var xe=fe[0].length-1,Le,Ve,Xe=xe,ie=0,pe=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,le=le.slice(-1*Z.length+xe);(fe=pe.exec(le))!=null;)if(Le=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Le){if(Ve=Le.length,fe[3]||fe[4]){Xe+=Ve;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+Ve)%3)){ie+=Ve;continue}if(Xe-=Ve,!(Xe>0)){if(Ve=Math.min(Ve,Ve+Xe+ie),Math.min(xe,Ve)%2){var re=Z.slice(1,xe+fe.index+Ve);return{type:"em",raw:Z.slice(0,xe+fe.index+Ve+1),text:re,tokens:this.lexer.inlineTokens(re,[])}}var B=Z.slice(2,xe+fe.index+Ve-1);return{type:"strong",raw:Z.slice(0,xe+fe.index+Ve+1),text:B,tokens:this.lexer.inlineTokens(B,[])}}}}}},ye.codespan=function(Z){var le=this.rules.inline.code.exec(Z);if(le){var ge=le[2].replace(/\n/g," "),fe=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return fe&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=$(ge,!0),{type:"codespan",raw:le[0],text:ge}}},ye.br=function(Z){var le=this.rules.inline.br.exec(Z);if(le)return{type:"br",raw:le[0]}},ye.del=function(Z){var le=this.rules.inline.del.exec(Z);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},ye.autolink=function(Z,le){var ge=this.rules.inline.autolink.exec(Z);if(ge){var fe,Ie;return ge[2]==="@"?(fe=$(this.options.mangle?le(ge[1]):ge[1]),Ie="mailto:"+fe):(fe=$(ge[1]),Ie=fe),{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.url=function(Z,le){var ge;if(ge=this.rules.inline.url.exec(Z)){var fe,Ie;if(ge[2]==="@")fe=$(this.options.mangle?le(ge[0]):ge[0]),Ie="mailto:"+fe;else{var xe;do xe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(xe!==ge[0]);fe=$(ge[0]),ge[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.inlineText=function(Z,le){var ge=this.rules.inline.text.exec(Z);if(ge){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):$(ge[0]):ge[0]:fe=$(this.options.smartypants?le(ge[0]):ge[0]),{type:"text",raw:ge[0],text:fe}}},Pe}(),Y=M.noopTest,de=M.edit,G=M.merge,ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=de(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=de(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=de(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=de(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=de(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=de(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=G({},ue),ue.gfm=G({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=de(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=G({},ue.normal,{html:de(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Y,paragraph:de(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=de(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=de(ue._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=de(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=de(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=de(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=de(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=de(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=de(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=de(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=de(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=G({},oe),oe.pedantic=G({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:de(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:de(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=G({},oe.normal,{escape:de(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=de(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=G({},oe.gfm,{br:de(oe.br).replace("{2,}","*").getRegex(),text:de(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var be={block:ue,inline:oe},Ae=j,Re=A.exports.defaults,Oe=be.block,Qe=be.inline,He=M.repeatString;function je(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(Pe){var ye="",De,Z,le=Pe.length;for(De=0;De<le;De++)Z=Pe.charCodeAt(De),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var K=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Re,this.options.tokenizer=this.options.tokenizer||new Ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Oe.normal,inline:Qe.normal};this.options.pedantic?(Z.block=Oe.pedantic,Z.inline=Qe.pedantic):this.options.gfm&&(Z.block=Oe.gfm,this.options.breaks?Z.inline=Qe.breaks:Z.inline=Qe.gfm),this.tokenizer.rules=Z}Pe.lex=function(Z,le){var ge=new Pe(le);return ge.lex(Z)},Pe.lexInline=function(Z,le){var ge=new Pe(le);return ge.inlineTokens(Z)};var ye=Pe.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ye.blockTokens=function(Z,le){var ge=this;le===void 0&&(le=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var fe,Ie,xe,Le;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Xe){return(fe=Xe.call({lexer:ge},Z,le))?(Z=Z.substring(fe.raw.length),le.push(fe),!0):!1}))){if(fe=this.tokenizer.space(Z)){Z=Z.substring(fe.raw.length),fe.type&&le.push(fe);continue}if(fe=this.tokenizer.code(Z)){Z=Z.substring(fe.raw.length),Ie=le[le.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):le.push(fe);continue}if(fe=this.tokenizer.fences(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.heading(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.hr(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.blockquote(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.list(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.html(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.def(Z)){Z=Z.substring(fe.raw.length),Ie=le[le.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.lheading(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(xe=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Xe=Infinity,ie=Z.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(re){pe=re.call({lexer:this},ie),typeof pe=="number"&&pe>=0&&(Xe=Math.min(Xe,pe))}),Xe<Infinity&&Xe>=0&&(xe=Z.substring(0,Xe+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Ie=le[le.length-1],Le&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):le.push(fe),Le=xe.length!==Z.length,Z=Z.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(Z)){Z=Z.substring(fe.raw.length),Ie=le[le.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):le.push(fe);continue}if(Z){var Ve="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return this.state.top=!0,le},ye.inline=function(Z,le){this.inlineQueue.push({src:Z,tokens:le})},ye.inlineTokens=function(Z,le){var ge=this;le===void 0&&(le=[]);var fe,Ie,xe,Le=Z,Ve,Xe,ie;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)pe.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ve.index)+"["+He("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"["+He("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Xe||(ie=""),Xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(B){return(fe=B.call({lexer:ge},Z,le))?(Z=Z.substring(fe.raw.length),le.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.tag(Z)){Z=Z.substring(fe.raw.length),Ie=le[le.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):le.push(fe);continue}if(fe=this.tokenizer.link(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(fe.raw.length),Ie=le[le.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):le.push(fe);continue}if(fe=this.tokenizer.emStrong(Z,Le,ie)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.codespan(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.br(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.del(Z)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.autolink(Z,U)){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(Z,U))){Z=Z.substring(fe.raw.length),le.push(fe);continue}if(xe=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var B=Infinity,Ce=Z.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(qe){Se=qe.call({lexer:this},Ce),typeof Se=="number"&&Se>=0&&(B=Math.min(B,Se))}),B<Infinity&&B>=0&&(xe=Z.substring(0,B+1))}(),fe=this.tokenizer.inlineText(xe,je)){Z=Z.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(ie=fe.raw.slice(-1)),Xe=!0,Ie=le[le.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):le.push(fe);continue}if(Z){var re="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return le},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Qe}}}]),Pe}(),ee=A.exports.defaults,ae=M.cleanUrl,V=M.escape,se=function(){function Pe(De){this.options=De||ee}var ye=Pe.prototype;return ye.code=function(Z,le,ge){var fe=(le||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(Z,fe);Ie!=null&&Ie!==Z&&(ge=!0,Z=Ie)}return Z=Z.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+V(fe,!0)+'">'+(ge?Z:V(Z,!0))+`</code></pre>
`:"<pre><code>"+(ge?Z:V(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,le,ge,fe){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+fe.slug(ge)+'">'+Z+"</h"+le+`>
`:"<h"+le+">"+Z+"</h"+le+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,le,ge){var fe=le?"ol":"ul",Ie=le&&ge!==1?' start="'+ge+'"':"";return"<"+fe+Ie+`>
`+Z+"</"+fe+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+le+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,le){var ge=le.header?"th":"td",fe=le.align?"<"+ge+' align="'+le.align+'">':"<"+ge+">";return fe+Z+"</"+ge+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,le,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var fe='<a href="'+V(Z)+'"';return le&&(fe+=' title="'+le+'"'),fe+=">"+ge+"</a>",fe},ye.image=function(Z,le,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var fe='<img src="'+Z+'" alt="'+ge+'"';return le&&(fe+=' title="'+le+'"'),fe+=this.options.xhtml?"/>":">",fe},ye.text=function(Z){return Z},Pe}(),he=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,le,ge){return""+ge},ye.image=function(Z,le,ge){return""+ge},ye.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,le){var ge=Z,fe=0;if(this.seen.hasOwnProperty(ge)){fe=this.seen[Z];do fe++,ge=Z+"-"+fe;while(this.seen.hasOwnProperty(ge))}return le||(this.seen[Z]=fe,this.seen[ge]=0),ge},ye.slug=function(Z,le){le===void 0&&(le={});var ge=this.serialize(Z);return this.getNextSafeSlug(ge,le.dryrun)},Pe}(),Ue=se,$e=he,Ke=Te,_e=A.exports.defaults,rt=M.unescape,H=function(){function Pe(De){this.options=De||_e,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new Ke}Pe.parse=function(Z,le){var ge=new Pe(le);return ge.parse(Z)},Pe.parseInline=function(Z,le){var ge=new Pe(le);return ge.parseInline(Z)};var ye=Pe.prototype;return ye.parse=function(Z,le){le===void 0&&(le=!0);var ge="",fe,Ie,xe,Le,Ve,Xe,ie,pe,re,B,Ce,Se,qe,We,it,mt,wt,ot,ct,lt=Z.length;for(fe=0;fe<lt;fe++){if(B=Z[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(ct=this.options.extensions.renderers[B.type].call({parser:this},B),ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(B.type))){ge+=ct||"";continue}switch(B.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(B.tokens),B.depth,rt(this.parseInline(B.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(B.text,B.lang,B.escaped);continue}case"table":{for(pe="",ie="",Le=B.header.length,Ie=0;Ie<Le;Ie++)ie+=this.renderer.tablecell(this.parseInline(B.header[Ie].tokens),{header:!0,align:B.align[Ie]});for(pe+=this.renderer.tablerow(ie),re="",Le=B.rows.length,Ie=0;Ie<Le;Ie++){for(Xe=B.rows[Ie],ie="",Ve=Xe.length,xe=0;xe<Ve;xe++)ie+=this.renderer.tablecell(this.parseInline(Xe[xe].tokens),{header:!1,align:B.align[xe]});re+=this.renderer.tablerow(ie)}ge+=this.renderer.table(pe,re);continue}case"blockquote":{re=this.parse(B.tokens),ge+=this.renderer.blockquote(re);continue}case"list":{for(Ce=B.ordered,Se=B.start,qe=B.loose,Le=B.items.length,re="",Ie=0;Ie<Le;Ie++)it=B.items[Ie],mt=it.checked,wt=it.task,We="",it.task&&(ot=this.renderer.checkbox(mt),qe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=ot+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=ot+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:ot}):We+=ot),We+=this.parse(it.tokens,qe),re+=this.renderer.listitem(We,wt,mt);ge+=this.renderer.list(re,Ce,Se);continue}case"html":{ge+=this.renderer.html(B.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(B.tokens));continue}case"text":{for(re=B.tokens?this.parseInline(B.tokens):B.text;fe+1<lt&&Z[fe+1].type==="text";)B=Z[++fe],re+=`
`+(B.tokens?this.parseInline(B.tokens):B.text);ge+=le?this.renderer.paragraph(re):re;continue}default:{var Tt='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Tt);return}else throw new Error(Tt)}}}return ge},ye.parseInline=function(Z,le){le=le||this.renderer;var ge="",fe,Ie,xe,Le=Z.length;for(fe=0;fe<Le;fe++){if(Ie=Z[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(xe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=xe||"";continue}switch(Ie.type){case"escape":{ge+=le.text(Ie.text);break}case"html":{ge+=le.html(Ie.text);break}case"link":{ge+=le.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,le));break}case"image":{ge+=le.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=le.strong(this.parseInline(Ie.tokens,le));break}case"em":{ge+=le.em(this.parseInline(Ie.tokens,le));break}case"codespan":{ge+=le.codespan(Ie.text);break}case"br":{ge+=le.br();break}case"del":{ge+=le.del(this.parseInline(Ie.tokens,le));break}case"text":{ge+=le.text(Ie.text);break}default:{var Ve='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return ge},Pe}(),J=K,me=H,Ne=j,Ye=se,tt=he,at=Te,vt=M.merge,kt=M.checkSanitizeDeprecation,ht=M.escape,yt=A.exports.getDefaults,It=A.exports.changeDefaults,ft=A.exports.defaults;function Je(Pe,ye,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=vt({},Je.defaults,ye||{}),kt(ye),De){var Z=ye.highlight,le;try{le=J.lex(Pe,ye)}catch(xe){return De(xe)}var ge=function(Le){var Ve;if(!Le)try{ye.walkTokens&&Je.walkTokens(le,ye.walkTokens),Ve=me.parse(le,ye)}catch(Xe){Le=Xe}return ye.highlight=Z,Le?De(Le):De(null,Ve)};if(!Z||Z.length<3||(delete ye.highlight,!le.length))return ge();var fe=0;Je.walkTokens(le,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){Z(xe.text,xe.lang,function(Le,Ve){if(Le)return ge(Le);Ve!=null&&Ve!==xe.text&&(xe.text=Ve,xe.escaped=!0),fe--,fe===0&&ge()})},0))}),fe===0&&ge();return}try{var Ie=J.lex(Pe,ye);return ye.walkTokens&&Je.walkTokens(Ie,ye.walkTokens),me.parse(Ie,ye)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(xe.message+"",!0)+"</pre>";throw xe}}Je.options=Je.setOptions=function(Pe){return vt(Je.defaults,Pe),It(Je.defaults),Je},Je.getDefaults=yt,Je.defaults=ft,Je.use=function(){for(var Pe=this,ye=arguments.length,De=new Array(ye),Z=0;Z<ye;Z++)De[Z]=arguments[Z];var le=vt.apply(void 0,[{}].concat(De)),ge=Je.defaults.extensions||{renderers:{},childTokens:{}},fe;De.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ve=ge.renderers?ge.renderers[Le.name]:null;Ve?ge.renderers[Le.name]=function(){for(var Xe=arguments.length,ie=new Array(Xe),pe=0;pe<Xe;pe++)ie[pe]=arguments[pe];var re=Le.renderer.apply(this,ie);return re===!1&&(re=Ve.apply(this,ie)),re}:ge.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Le.level]?ge[Le.level].unshift(Le.tokenizer):ge[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ge.startBlock?ge.startBlock.push(Le.start):ge.startBlock=[Le.start]:Le.level==="inline"&&(ge.startInline?ge.startInline.push(Le.start):ge.startInline=[Le.start]))}Le.childTokens&&(ge.childTokens[Le.name]=Le.childTokens)})),Ie.renderer&&function(){var Le=Je.defaults.renderer||new Ye,Ve=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,Ce=new Array(B),Se=0;Se<B;Se++)Ce[Se]=arguments[Se];var qe=Ie.renderer[pe].apply(Le,Ce);return qe===!1&&(qe=re.apply(Le,Ce)),qe}};for(var Xe in Ie.renderer)Ve(Xe);le.renderer=Le}(),Ie.tokenizer&&function(){var Le=Je.defaults.tokenizer||new Ne,Ve=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,Ce=new Array(B),Se=0;Se<B;Se++)Ce[Se]=arguments[Se];var qe=Ie.tokenizer[pe].apply(Le,Ce);return qe===!1&&(qe=re.apply(Le,Ce)),qe}};for(var Xe in Ie.tokenizer)Ve(Xe);le.tokenizer=Le}(),Ie.walkTokens){var xe=Je.defaults.walkTokens;le.walkTokens=function(Le){Ie.walkTokens.call(Pe,Le),xe&&xe(Le)}}fe&&(le.extensions=ge),Je.setOptions(le)})},Je.walkTokens=function(Pe,ye){for(var De=function(){var fe=le.value;switch(ye(fe),fe.type){case"table":{for(var Ie=_(fe.header),xe;!(xe=Ie()).done;){var Le=xe.value;Je.walkTokens(Le.tokens,ye)}for(var Ve=_(fe.rows),Xe;!(Xe=Ve()).done;)for(var ie=Xe.value,pe=_(ie),re;!(re=pe()).done;){var B=re.value;Je.walkTokens(B.tokens,ye)}break}case"list":{Je.walkTokens(fe.items,ye);break}default:Je.defaults.extensions&&Je.defaults.extensions.childTokens&&Je.defaults.extensions.childTokens[fe.type]?Je.defaults.extensions.childTokens[fe.type].forEach(function(Ce){Je.walkTokens(fe[Ce],ye)}):fe.tokens&&Je.walkTokens(fe.tokens,ye)}},Z=_(Pe),le;!(le=Z()).done;)De()},Je.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=vt({},Je.defaults,ye||{}),kt(ye);try{var De=J.lexInline(Pe,ye);return ye.walkTokens&&Je.walkTokens(De,ye.walkTokens),me.parseInline(De,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(Z.message+"",!0)+"</pre>";throw Z}},Je.Parser=me,Je.parser=me.parse,Je.Renderer=Ye,Je.TextRenderer=tt,Je.Lexer=J,Je.lexer=J.lex,Je.Tokenizer=Ne,Je.Slugger=at,Je.parse=Je;var Et=Je;return Et}),define(ve[76],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(T,I,S){return Math.min(Math.max(T,I),S)}e.clamp=c;function F(T,I){return(I+T%I)%I}e.rot=F;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class A{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function ne(_){const A=[];typeof _=="number"&&A.push("code/timeOrigin",_);function T(S){A.push(S,Date.now())}function I(){const S=[];for(let P=0;P<A.length;P+=2)S.push({name:A[P],startTime:A[P+1]});return S}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(_+T.startTime)});return A}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function c(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=c(F))}(),define(ve[34],we([0,1,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(y){const n=this._icons.get(y.id);n?y.description?n.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const _=new F;e.iconRegistry=_;function A(t,y){return new I(t,y)}e.registerCodicon=A;function T(t){return t?t.replace(/\$\((.*?)\)/g,(y,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=T;class I{constructor(y,n,d){this.id=y,this.definition=n,this.description=d,_.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function S(t,y){const n=["codicon","codicon-"+t];return y&&n.push("codicon-modifier-"+y),n}e.getClassNamesArray=S;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(a){if(a instanceof I)return["codicon","codicon-"+a.id];const g=y.exec(a.id);if(!g)return n(I.error);let[,k,b]=g;const u=["codicon","codicon-"+k];return b&&u.push("codicon-modifier-"+b.substr(1)),u}t.asClassNameArray=n;function d(a){return n(a).join(" ")}t.asClassName=d;function o(a){return"."+n(a).join(".")}t.asCSSSelector=o})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(ve[104],we([0,1,15,7]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(u){const p=u;return p?[p.on,p.pause,p.resume,p.destroy].every(D=>typeof D=="function"):!1}e.isReadableStream=_;function A(u){const p=u;return p?_(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=A;function T(u,p){return new I(u,p)}e.newWriteableStream=T;class I{constructor(p,D){this.reducer=p,this.options=D,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(D=>D(p))}emitError(p){this.listeners.error.length===0?(0,c.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(D=>D(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,D){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(D),this.resume();break;case"end":this.listeners.end.push(D),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(D),this.state.flowing&&this.flowErrors();break}}removeListener(p,D){if(this.state.destroyed)return;let i;switch(p){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const r=i.indexOf(D);r>=0&&i.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const D=[...this.pendingWritePromises];this.pendingWritePromises.length=0,D.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(u,p){const D=[];let i;for(;(i=u.read())!==null;)D.push(i);return p(D)}e.consumeReadable=S;function P(u,p,D){const i=[];let r;for(;(r=u.read())!==null&&i.length<D;)i.push(r);return r===null&&i.length>0?p(i):{read:()=>{if(i.length>0)return i.shift();if(typeof r!="undefined"){const l=r;return r=void 0,l}return u.read()}}}e.peekReadable=P;function t(u,p){return new Promise((D,i)=>{const r=[];y(u,{onData:l=>{p&&r.push(l)},onError:l=>{p?i(l):D(void 0)},onEnd:()=>{D(p?p(r):void 0)}})})}e.consumeStream=t;function y(u,p){u.on("error",D=>p.onError(D)),u.on("end",()=>p.onEnd()),u.on("data",D=>p.onData(D))}e.listenStream=y;function n(u,p){return new Promise((D,i)=>{const r=new F.DisposableStore,l=[],s=w=>{if(l.push(w),l.length>p)return r.dispose(),u.pause(),D({stream:u,buffer:l,ended:!1})},m=w=>i(w),v=()=>D({stream:u,buffer:l,ended:!0});r.add((0,F.toDisposable)(()=>u.removeListener("error",m))),u.on("error",m),r.add((0,F.toDisposable)(()=>u.removeListener("end",v))),u.on("end",v),r.add((0,F.toDisposable)(()=>u.removeListener("data",s))),u.on("data",s)})}e.peekStream=n;function d(u,p){const D=T(p);return D.end(u),D}e.toStream=d;function o(){const u=T(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=o;function a(u){let p=!1;return{read:()=>p?null:(p=!0,u)}}e.toReadable=a;function g(u,p,D){const i=T(D);return y(u,{onData:r=>i.write(p.data(r)),onError:r=>i.error(p.error?p.error(r):r),onEnd:()=>i.end()}),i}e.transform=g;function k(u,p,D){let i=!1;return{read:()=>{const r=p.read();return i?r:(i=!0,r!==null?D([u,r]):u)}}}e.prefixedReadable=k;function b(u,p,D){let i=!1;const r=T(D);return y(p,{onData:l=>i?r.write(l):(i=!0,r.write(D([u,l]))),onError:l=>r.error(l),onEnd:()=>{i||(i=!0,r.write(u)),r.end()}}),r}e.prefixedStream=b}),define(ve[23],we([0,1,104]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let _,A;class T{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return F?new T(Buffer.allocUnsafe(s)):new T(new Uint8Array(s))}static wrap(s){return F&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new T(s)}static fromString(s,m){return!(m?.dontUseNodeBuffer||!1)&&F?new T(Buffer.from(s)):(_||(_=new TextEncoder),new T(_.encode(s)))}static concat(s,m){if(typeof m=="undefined"){m=0;for(let C=0,R=s.length;C<R;C++)m+=s[C].byteLength}const v=T.alloc(m);let w=0;for(let C=0,R=s.length;C<R;C++){const f=s[C];v.set(f,w),w+=f.byteLength}return v}toString(){return F?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(s,m){return new T(this.buffer.subarray(s,m))}set(s,m){s instanceof T?this.buffer.set(s.buffer,m):this.buffer.set(s,m)}readUInt32BE(s){return P(this.buffer,s)}writeUInt32BE(s,m){t(this.buffer,s,m)}readUInt32LE(s){return y(this.buffer,s)}writeUInt32LE(s,m){n(this.buffer,s,m)}readUInt8(s){return d(this.buffer,s)}writeUInt8(s,m){o(this.buffer,s,m)}}e.VSBuffer=T;function I(l,s){return l[s+0]<<0>>>0|l[s+1]<<8>>>0}e.readUInt16LE=I;function S(l,s,m){l[m+0]=s&255,s=s>>>8,l[m+1]=s&255}e.writeUInt16LE=S;function P(l,s){return l[s]*2**24+l[s+1]*2**16+l[s+2]*2**8+l[s+3]}e.readUInt32BE=P;function t(l,s,m){l[m+3]=s,s=s>>>8,l[m+2]=s,s=s>>>8,l[m+1]=s,s=s>>>8,l[m]=s}e.writeUInt32BE=t;function y(l,s){return l[s+0]<<0>>>0|l[s+1]<<8>>>0|l[s+2]<<16>>>0|l[s+3]<<24>>>0}e.readUInt32LE=y;function n(l,s,m){l[m+0]=s&255,s=s>>>8,l[m+1]=s&255,s=s>>>8,l[m+2]=s&255,s=s>>>8,l[m+3]=s&255}e.writeUInt32LE=n;function d(l,s){return l[s]}e.readUInt8=d;function o(l,s,m){l[m]=s}e.writeUInt8=o;function a(l){return c.consumeReadable(l,s=>T.concat(s))}e.readableToBuffer=a;function g(l){return c.toReadable(l)}e.bufferToReadable=g;function k(l){return c.consumeStream(l,s=>T.concat(s))}e.streamToBuffer=k;async function b(l){return l.ended?T.concat(l.buffer):T.concat([...l.buffer,await k(l.stream)])}e.bufferedStreamToBuffer=b;function u(l){return c.toStream(l,s=>T.concat(s))}e.bufferToStream=u;function p(l){return c.transform(l,{data:s=>typeof s=="string"?T.fromString(s):T.wrap(s)},s=>T.concat(s))}e.streamToBufferReadableStream=p;function D(l){return c.newWriteableStream(s=>T.concat(s),l)}e.newWriteableBufferStream=D;function i(l,s){return c.prefixedReadable(l,s,m=>T.concat(m))}e.prefixedBufferReadable=i;function r(l,s){return c.prefixedStream(l,s,m=>T.concat(m))}e.prefixedBufferStream=r}),define(ve[35],we([0,1,9]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(F||(F={})),function(_){const A="error",T="warning",I="warn",S="info",P="ignore";function t(n){return n?c.equalsIgnoreCase(A,n)?_.Error:c.equalsIgnoreCase(T,n)||c.equalsIgnoreCase(I,n)?_.Warning:c.equalsIgnoreCase(S,n)?_.Info:_.Ignore:_.Ignore}_.fromValue=t;function y(n){switch(n){case _.Error:return A;case _.Warning:return T;case _.Info:return S;default:return P}}_.toString=y}(F||(F={})),e.default=F}),define(ve[40],we([0,1,17,25,9,10]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(l){return l===47||l===92}e.isPathSeparator=T;function I(l){return l.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=I;function S(l){return l.indexOf("/")===-1&&(l=I(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=S;function P(l,s=c.posix.sep){if(!l)return"";const m=l.length,v=l.charCodeAt(0);if(T(v)){if(T(l.charCodeAt(1))&&!T(l.charCodeAt(2))){let C=3;const R=C;for(;C<m&&!T(l.charCodeAt(C));C++);if(R!==C&&!T(l.charCodeAt(C+1))){for(C+=1;C<m;C++)if(T(l.charCodeAt(C)))return l.slice(0,C+1).replace(/[\\/]/g,s)}}return s}else if(k(v)&&l.charCodeAt(1)===58)return T(l.charCodeAt(2))?l.slice(0,2)+s:l.slice(0,2);let w=l.indexOf("://");if(w!==-1){for(w+=3;w<m;w++)if(T(l.charCodeAt(w)))return l.slice(0,w+1)}return""}e.getRoot=P;function t(l){if(!F.isWindows||!l||l.length<5)return!1;let s=l.charCodeAt(0);if(s!==92||(s=l.charCodeAt(1),s!==92))return!1;let m=2;const v=m;for(;m<l.length&&(s=l.charCodeAt(m),s!==92);m++);return!(v===m||(s=l.charCodeAt(m+1),isNaN(s)||s===92))}e.isUNC=t;const y=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(l,s=F.isWindows){const m=s?y:n;return!(!l||l.length===0||/^\s+$/.test(l)||(m.lastIndex=0,m.test(l))||s&&d.test(l)||l==="."||l===".."||s&&l[l.length-1]==="."||s&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=o;function a(l,s,m){const v=l===s;return!m||v?v:!l||!s?!1:(0,_.equalsIgnoreCase)(l,s)}e.isEqual=a;function g(l,s,m,v=c.sep){if(l===s)return!0;if(!l||!s||s.length>l.length)return!1;if(m){if(!(0,_.startsWithIgnoreCase)(l,s))return!1;if(s.length===l.length)return!0;let C=s.length;return s.charAt(s.length-1)===v&&C--,l.charAt(C)===v}return s.charAt(s.length-1)!==v&&(s+=v),l.indexOf(s)===0}e.isEqualOrParent=g;function k(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=k;function b(l,s){return F.isWindows&&l.endsWith(":")&&(l+=c.sep),(0,c.isAbsolute)(l)||(l=(0,c.join)(s,l)),l=(0,c.normalize)(l),F.isWindows?(l=(0,_.rtrim)(l,c.sep),l.endsWith(":")&&(l+=c.sep)):(l=(0,_.rtrim)(l,c.sep),l||(l=c.sep)),l}e.sanitizeFilePath=b;function u(l){const s=(0,c.normalize)(l);return F.isWindows?l.length>3?!1:p(s)&&(l.length===2||s.charCodeAt(2)===92):s===c.posix.sep}e.isRootOrDriveLetter=u;function p(l){return F.isWindows?k(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function D(l){return p(l)?l[0]:void 0}e.getDriveLetter=D;function i(l,s,m){return s.length>l.length?-1:l===s?0:(m&&(l=l.toLowerCase(),s=s.toLowerCase()),l.indexOf(s))}e.indexOfPath=i;function r(l){const s=l.split(":");let m,v,w;if(s.forEach(C=>{const R=Number(C);(0,A.isNumber)(R)?v===void 0?v=R:w===void 0&&(w=R):m=m?[m,C].join(":"):C}),!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:v!==void 0?v:void 0,column:w!==void 0?w:v!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(ve[22],we([0,1,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const g=Array.isArray(a)?[]:{};return Object.keys(a).forEach(k=>{a[k]&&typeof a[k]=="object"?g[k]=F(a[k]):g[k]=a[k]}),g}e.deepClone=F;function _(a){if(!a||typeof a!="object")return a;const g=[a];for(;g.length>0;){const k=g.shift();Object.freeze(k);for(const b in k)if(A.call(k,b)){const u=k[b];typeof u=="object"&&!Object.isFrozen(u)&&g.push(u)}}return a}e.deepFreeze=_;const A=Object.prototype.hasOwnProperty;function T(a,g){return I(a,g,new Set)}e.cloneAndChange=T;function I(a,g,k){if((0,c.isUndefinedOrNull)(a))return a;const b=g(a);if(typeof b!="undefined")return b;if((0,c.isArray)(a)){const u=[];for(const p of a)u.push(I(p,g,k));return u}if((0,c.isObject)(a)){if(k.has(a))throw new Error("Cannot clone recursive data-structure");k.add(a);const u={};for(let p in a)A.call(a,p)&&(u[p]=I(a[p],g,k));return k.delete(a),u}return a}function S(a,g,k=!0){return(0,c.isObject)(a)?((0,c.isObject)(g)&&Object.keys(g).forEach(b=>{b in a?k&&((0,c.isObject)(a[b])&&(0,c.isObject)(g[b])?S(a[b],g[b],k):a[b]=g[b]):a[b]=g[b]}),a):g}e.mixin=S;function P(a,g){if(a===g)return!0;if(a==null||g===null||g===void 0||typeof a!=typeof g||typeof a!="object"||Array.isArray(a)!==Array.isArray(g))return!1;let k,b;if(Array.isArray(a)){if(a.length!==g.length)return!1;for(k=0;k<a.length;k++)if(!P(a[k],g[k]))return!1}else{const u=[];for(b in a)u.push(b);u.sort();const p=[];for(b in g)p.push(b);if(p.sort(),!P(u,p))return!1;for(k=0;k<u.length;k++)if(!P(a[u[k]],g[u[k]]))return!1}return!0}e.equals=P;function t(a){const g=new Set;return JSON.stringify(a,(k,b)=>{if((0,c.isObject)(b)||Array.isArray(b)){if(g.has(b))return"[Circular]";g.add(b)}return b})}e.safeStringify=t;function y(a,g,k){const b=g(a);return typeof b=="undefined"?k:b}e.getOrDefault=y;function n(a,g){const k=Object.create(null);return!a||!g||Object.keys(g).forEach(u=>{const p=a[u],D=g[u];P(p,D)||(k[u]=D)}),k}e.distinct=n;function d(a,g){const k=g.toLowerCase(),b=Object.keys(a).find(u=>u.toLowerCase()===k);return b?a[b]:a[g]}e.getCaseInsensitive=d;function o(a,g){const k=Object.create(null);for(const b of Object.keys(a))g(b,a[b])&&(k[b]=a[b]);return k}e.filter=o});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[20],we([0,1,9,2]),function(ne,e,c,F){"use strict";var _,A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(i,r,l){let s=i.get(r);return s===void 0&&(s=l,i.set(r,s)),s}e.getOrSet=I;function S(i){const r=[];return i.forEach((l,s)=>{r.push(`${s} => ${l}`)}),`Map(${i.size}) {${r.join(", ")}}`}e.mapToString=S;function P(i){const r=[];return i.forEach(l=>{r.push(l)}),`Set(${i.size}) {${r.join(", ")}}`}e.setToString=P;class t{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const l=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return l-s}value(){return this._value[this._pos]}}e.StringIterator=t;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,c.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,c.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class n{constructor(r=!0,l=!0){this._splitOnBackslash=r,this._caseSensitive=l}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,c.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,c.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var d;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(d||(d={}));class o{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,c.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,c.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,c.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,c.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class g{constructor(r){this._iter=r}static forUris(r=()=>!1){return new g(new o(r))}static forPaths(){return new g(new n)}static forStrings(){return new g(new t)}static forConfigKeys(){return new g(new y)}clear(){this._root=void 0}set(r,l){const s=this._iter.reset(r);let m;for(this._root||(this._root=new a,this._root.segment=s.value()),m=this._root;;){const w=s.cmp(m.segment);if(w>0)m.left||(m.left=new a,m.left.segment=s.value()),m=m.left;else if(w<0)m.right||(m.right=new a,m.right.segment=s.value()),m=m.right;else if(s.hasNext())s.next(),m.mid||(m.mid=new a,m.mid.segment=s.value()),m=m.mid;else break}const v=m.value;return m.value=l,m.key=r,v}get(r){return this._getNode(r)?.value}_getNode(r){const l=this._iter.reset(r);let s=this._root;for(;s;){const m=l.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(l.hasNext())l.next(),s=s.mid;else break}return s}has(r){const l=this._getNode(r);return!(l?.value===void 0&&l?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,l){const s=this._iter.reset(r),m=[];let v=this._root;for(;v;){const w=s.cmp(v.segment);if(w>0)m.push([1,v]),v=v.left;else if(w<0)m.push([-1,v]),v=v.right;else if(s.hasNext())s.next(),m.push([0,v]),v=v.mid;else{for(l?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;m.length>0&&v.isEmpty();){let[C,R]=m.pop();switch(C){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}v=R}break}}}findSubstr(r){const l=this._iter.reset(r);let s=this._root,m;for(;s;){const v=l.cmp(s.segment);if(v>0)s=s.left;else if(v<0)s=s.right;else if(l.hasNext())l.next(),m=s.value||m,s=s.mid;else break}return s&&s.value||m}findSuperstr(r){const l=this._iter.reset(r);let s=this._root;for(;s;){const m=l.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(l.hasNext())l.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[l,s]of this)r(s,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const l=[r];for(;l.length>0;){const s=l.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&l.push(s.left),s.mid&&l.push(s.mid),s.right&&l.push(s.right))}}}e.TernarySearchTree=g;class k{constructor(r,l){this[_]="ResourceMap",r instanceof k?(this.map=new Map(r.map),this.toKey=l??k.defaultToKey):(this.map=new Map,this.toKey=r??k.defaultToKey)}set(r,l){return this.map.set(this.toKey(r),l),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,l){typeof l!="undefined"&&(r=r.bind(l));for(let[s,m]of this.map)r(m,F.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield F.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[F.URI.parse(r[0]),r[1]]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[F.URI.parse(r[0]),r[1]]}}e.ResourceMap=k,k.defaultToKey=i=>i.toString();var b;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class u{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,l=0){const s=this._map.get(r);if(!!s)return l!==0&&this.touch(s,l),s.value}set(r,l,s=0){let m=this._map.get(r);if(m)m.value=l,s!==0&&this.touch(m,s);else{switch(m={key:r,value:l,next:void 0,previous:void 0},s){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const l=this._map.get(r);if(!!l)return this._map.delete(r),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,l){const s=this._state;let m=this._head;for(;m;){if(l?r.bind(l)(m.value,m.key,this):r(m.value,m.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,l=this._state;let s=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.key,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return m}values(){const r=this,l=this._state;let s=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.value,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return m}entries(){const r=this,l=this._state;let s=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:[s.key,s.value],done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return m}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let l=this._head,s=this.size;for(;l&&s>r;)this._map.delete(l.key),l=l.next,s--;this._head=l,this._size=s,l&&(l.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const l=r.next,s=r.previous;if(!l||!s)throw new Error("Invalid list");l.previous=s,s.next=l}r.next=void 0,r.previous=void 0,this._state++}touch(r,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(r===this._head)return;const s=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(s.previous=m,m.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(l===2){if(r===this._tail)return;const s=r.next,m=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=m,m.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((l,s)=>{r.push([s,l])}),r}fromJSON(r){this.clear();for(const[l,s]of r)this.set(l,s)}}e.LinkedMap=u;class p extends u{constructor(r,l=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,l=2){return super.get(r,l)}peek(r){return super.get(r,0)}set(r,l){return super.set(r,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class D{constructor(r){T.set(this,void 0),et(this,T,r,"f")}get size(){return Me(this,T,"f").size}forEach(r,l){Me(this,T,"f").forEach(r,l)}get(r){return Me(this,T,"f").get(r)}has(r){return Me(this,T,"f").has(r)}entries(){return Me(this,T,"f").entries()}keys(){return Me(this,T,"f").keys()}values(){return Me(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Me(this,T,"f").entries()}}e.ReadonlyMapView=D}),define(ve[105],we([0,1,20,9]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...V){return function(se,he){for(let Te=0,Ue=V.length;Te<Ue;Te++){const $e=V[Te](se,he);if($e)return $e}return null}}e.or=_,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(V,se,he){if(!he||he.length<se.length)return null;let Te;return V?Te=F.startsWithIgnoreCase(he,se):Te=he.indexOf(se)===0,Te?se.length>0?[{start:0,end:se.length}]:[]:null}function T(V,se){const he=se.toLowerCase().indexOf(V.toLowerCase());return he===-1?null:[{start:he,end:he+V.length}]}e.matchesContiguousSubString=T;function I(V,se){return S(V.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=I;function S(V,se,he,Te){if(he===V.length)return[];if(Te===se.length)return null;if(V[he]===se[Te]){let Ue=null;return(Ue=S(V,se,he+1,Te+1))?k({start:Te,end:Te+1},Ue):null}return S(V,se,he,Te+1)}function P(V){return 97<=V&&V<=122}function t(V){return 65<=V&&V<=90}e.isUpper=t;function y(V){return 48<=V&&V<=57}function n(V){return V===32||V===9||V===10||V===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(V=>d.add(V.charCodeAt(0)));function o(V){return n(V)||d.has(V)}function a(V,se){return V===se||o(V)&&o(se)}function g(V){return P(V)||t(V)||y(V)}function k(V,se){return se.length===0?se=[V]:V.end===se[0].start?se[0].start=V.start:se.unshift(V),se}function b(V,se){for(let he=se;he<V.length;he++){const Te=V.charCodeAt(he);if(t(Te)||y(Te)||he>0&&!g(V.charCodeAt(he-1)))return he}return V.length}function u(V,se,he,Te){if(he===V.length)return[];if(Te===se.length)return null;if(V[he]!==se[Te].toLowerCase())return null;{let Ue=null,$e=Te+1;for(Ue=u(V,se,he+1,Te+1);!Ue&&($e=b(se,$e))<se.length;)Ue=u(V,se,he+1,$e),$e++;return Ue===null?null:k({start:Te,end:Te+1},Ue)}}function p(V){let se=0,he=0,Te=0,Ue=0,$e=0;for(let J=0;J<V.length;J++)$e=V.charCodeAt(J),t($e)&&se++,P($e)&&he++,g($e)&&Te++,y($e)&&Ue++;const Ke=se/V.length,_e=he/V.length,rt=Te/V.length,H=Ue/V.length;return{upperPercent:Ke,lowerPercent:_e,alphaPercent:rt,numericPercent:H}}function D(V){const{upperPercent:se,lowerPercent:he}=V;return he===0&&se>.6}function i(V){const{upperPercent:se,lowerPercent:he,alphaPercent:Te,numericPercent:Ue}=V;return he>.2&&se<.8&&Te>.6&&Ue<.2}function r(V){let se=0,he=0,Te=0,Ue=0;for(let $e=0;$e<V.length;$e++)Te=V.charCodeAt($e),t(Te)&&se++,P(Te)&&he++,n(Te)&&Ue++;return(se===0||he===0)&&Ue===0?V.length<=30:se<=5}function l(V,se){if(!se||(se=se.trim(),se.length===0)||!r(V)||se.length>60)return null;const he=p(se);if(!i(he)){if(!D(he))return null;se=se.toLowerCase()}let Te=null,Ue=0;for(V=V.toLowerCase();Ue<se.length&&(Te=u(V,se,0,Ue))===null;)Ue=b(se,Ue+1);return Te}e.matchesCamelCase=l;function s(V,se,he=!1){if(!se||se.length===0)return null;let Te=null,Ue=0;for(V=V.toLowerCase(),se=se.toLowerCase();Ue<se.length&&(Te=m(V,se,0,Ue,he))===null;)Ue=v(se,Ue+1);return Te}e.matchesWords=s;function m(V,se,he,Te,Ue){if(he===V.length)return[];if(Te===se.length)return null;if(a(V.charCodeAt(he),se.charCodeAt(Te))){let $e=null,Ke=Te+1;if($e=m(V,se,he+1,Te+1,Ue),!Ue)for(;!$e&&(Ke=v(se,Ke))<se.length;)$e=m(V,se,he+1,Ke,Ue),Ke++;return $e===null?null:k({start:Te,end:Te+1},$e)}else return null}function v(V,se){for(let he=se;he<V.length;he++)if(o(V.charCodeAt(he))||he>0&&o(V.charCodeAt(he-1)))return he;return V.length}const w=_(e.matchesPrefix,l,T),C=_(e.matchesPrefix,l,I),R=new c.LRUCache(1e4);function f(V,se,he=!1){if(typeof V!="string"||typeof se!="string")return null;let Te=R.get(V);Te||(Te=new RegExp(F.convertSimple2RegExpPattern(V),"i"),R.set(V,Te));const Ue=Te.exec(se);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?C(V,se):w(V,se)}e.matchesFuzzy=f;function E(V,se){const he=Qe(V,V.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?M(he):null}e.matchesFuzzy2=E;function h(V,se,he,Te,Ue,$e){const Ke=Math.min(13,V.length);for(;he<Ke;he++){const _e=Qe(V,se,he,Te,Ue,$e,!1);if(_e)return _e}return[0,$e]}e.anyScore=h;function M(V){if(typeof V=="undefined")return[];const se=[],he=V[1];for(let Te=V.length-1;Te>1;Te--){const Ue=V[Te]+he,$e=se[se.length-1];$e&&$e.end===Ue?$e.end=Ue+1:se.push({start:Ue,end:Ue+1})}return se}e.createMatches=M;const O=128;function q(){const V=[],se=[];for(let he=0;he<=O;he++)se[he]=0;for(let he=0;he<=O;he++)V.push(se.slice(0));return V}function Q(V){const se=[];for(let he=0;he<=V;he++)se[he]=0;return se}const $=Q(2*O),z=Q(2*O),N=q(),W=q(),j=q(),Y=!1;function de(V,se,he,Te,Ue){function $e(_e,rt,H=" "){for(;_e.length<rt;)_e=H+_e;return _e}let Ke=` |   |${Te.split("").map(_e=>$e(_e,3)).join("|")}
`;for(let _e=0;_e<=he;_e++)_e===0?Ke+=" |":Ke+=`${se[_e-1]}|`,Ke+=V[_e].slice(0,Ue+1).map(rt=>$e(rt.toString(),3)).join("|")+`
`;return Ke}function G(V,se,he,Te){V=V.substr(se),he=he.substr(Te),console.log(de(W,V,V.length,he,he.length)),console.log(de(j,V,V.length,he,he.length)),console.log(de(N,V,V.length,he,he.length))}function ue(V,se){if(se<0||se>=V.length)return!1;const he=V.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(he)}}function oe(V,se){if(se<0||se>=V.length)return!1;switch(V.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function be(V,se,he){return se[V]!==he[V]}function Ae(V,se,he,Te,Ue,$e,Ke=!1){for(;se<he&&Ue<$e;)V[se]===Te[Ue]&&(Ke&&($[se]=Ue),se+=1),Ue+=1;return se===he}e.isPatternInWord=Ae;var Re;(function(V){V[V.Diag=1]="Diag",V[V.Left=2]="Left",V[V.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var Oe;(function(V){V.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}V.isDefault=se})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Qe(V,se,he,Te,Ue,$e,Ke){const _e=V.length>O?O:V.length,rt=Te.length>O?O:Te.length;if(he>=_e||$e>=rt||_e-he>rt-$e||!Ae(se,he,_e,Ue,$e,rt,!0))return;He(_e,rt,he,$e,se,Ue);let H=1,J=1,me=he,Ne=$e;const Ye=[!1];for(H=1,me=he;me<_e;H++,me++){const ht=$[me],yt=z[me],It=me+1<_e?z[me+1]:rt;for(J=ht-$e+1,Ne=ht;Ne<It;J++,Ne++){let ft=Number.MIN_SAFE_INTEGER,Je=!1;Ne<=yt&&(ft=je(V,se,me,he,Te,Ue,Ne,rt,$e,N[H-1][J-1]===0,Ye));let Et=0;ft!==Number.MAX_SAFE_INTEGER&&(Je=!0,Et=ft+W[H-1][J-1]);const Pe=Ne>ht,ye=Pe?W[H][J-1]+(N[H][J-1]>0?-5:0):0,De=Ne>ht+1&&N[H][J-1]>0,Z=De?W[H][J-2]+(N[H][J-2]>0?-5:0):0;if(De&&(!Pe||Z>=ye)&&(!Je||Z>=Et))W[H][J]=Z,j[H][J]=3,N[H][J]=0;else if(Pe&&(!Je||ye>=Et))W[H][J]=ye,j[H][J]=2,N[H][J]=0;else if(Je)W[H][J]=Et,j[H][J]=1,N[H][J]=N[H-1][J-1]+1;else throw new Error("not possible")}}if(Y&&G(V,he,Te,$e),!Ye[0]&&!Ke)return;H--,J--;const tt=[W[H][J],$e];let at=0,vt=0;for(;H>=1;){let ht=J;do{const yt=j[H][ht];if(yt===3)ht=ht-2;else if(yt===2)ht=ht-1;else break}while(ht>=1);at>1&&se[he+H-1]===Ue[$e+J-1]&&!be(ht+$e-1,Te,Ue)&&at+1>N[H][ht]&&(ht=J),ht===J?at++:at=1,vt||(vt=ht),H--,J=ht-1,tt.push(J)}rt===_e&&(tt[0]+=2);const kt=vt-_e;return tt[0]-=kt,tt}e.fuzzyScore=Qe;function He(V,se,he,Te,Ue,$e){let Ke=V-1,_e=se-1;for(;Ke>=he&&_e>=Te;)Ue[Ke]===$e[_e]&&(z[Ke]=_e,Ke--),_e--}function je(V,se,he,Te,Ue,$e,Ke,_e,rt,H,J){if(se[he]!==$e[Ke])return Number.MIN_SAFE_INTEGER;let me=1,Ne=!1;return Ke===he-Te?me=V[he]===Ue[Ke]?7:5:be(Ke,Ue,$e)&&(Ke===0||!be(Ke-1,Ue,$e))?(me=V[he]===Ue[Ke]?7:5,Ne=!0):ue($e,Ke)&&(Ke===0||!ue($e,Ke-1))?me=5:(ue($e,Ke-1)||oe($e,Ke-1))&&(me=5,Ne=!0),me>1&&he===Te&&(J[0]=!0),Ne||(Ne=be(Ke,Ue,$e)||ue($e,Ke-1)||oe($e,Ke-1)),he===Te?Ke>rt&&(me-=Ne?3:5):H?me+=Ne?2:0:me+=Ne?0:1,Ke+1===_e&&(me-=Ne?3:5),me}function U(V,se,he,Te,Ue,$e,Ke){return ee(V,se,he,Te,Ue,$e,!0,Ke)}e.fuzzyScoreGracefulAggressive=U;function K(V,se,he,Te,Ue,$e,Ke){return ee(V,se,he,Te,Ue,$e,!1,Ke)}e.fuzzyScoreGraceful=K;function ee(V,se,he,Te,Ue,$e,Ke,_e){let rt=Qe(V,se,he,Te,Ue,$e,_e);if(rt&&!Ke)return rt;if(V.length>=3){const H=Math.min(7,V.length-1);for(let J=he+1;J<H;J++){const me=ae(V,J);if(me){const Ne=Qe(me,me.toLowerCase(),he,Te,Ue,$e,_e);Ne&&(Ne[0]-=3,(!rt||Ne[0]>rt[0])&&(rt=Ne))}}}return rt}function ae(V,se){if(se+1>=V.length)return;const he=V[se],Te=V[se+1];if(he!==Te)return V.slice(0,se)+Te+he+V.slice(se+2)}}),define(ve[106],we([0,1,34,105,9]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function I(a){return a.replace(T,(g,k)=>k?g:`\\${g}`)}e.escapeIcons=I;const S=new RegExp(`\\\\${A.source}`,"g");function P(a){return a.replace(S,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function y(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(t,(g,k,b,u)=>b?g:k||u||"")}e.stripIcons=y;function n(a){const g=a.indexOf(e.iconStartMarker);return g===-1?{text:a}:d(a,g)}e.parseLabelWithIcons=n;function d(a,g){const k=[];let b="";function u(v){if(v){b+=v;for(const w of v)k.push(i)}}let p=-1,D="",i=0,r,l,s=g;const m=a.length;for(u(a.substr(0,g));s<m;)r=a[s],l=a[s+1],r===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(p=s,u(D),D=e.iconStartMarker,s++):r===")"&&p!==-1?(i+=s-p+1,p=-1,D=""):p!==-1?/^[a-z0-9\-]$/i.test(r)?D+=r:(u(D),p=-1,D=""):u(r),s++;return u(D),{text:b,iconOffsets:k}}function o(a,g,k=!1){const{text:b,iconOffsets:u}=g;if(!u||u.length===0)return(0,F.matchesFuzzy)(a,b,k);const p=(0,_.ltrim)(b," "),D=b.length-p.length,i=(0,F.matchesFuzzy)(a,p,k);if(i)for(const r of i){const l=u[r.start+D]+D;r.start+=l,r.end+=l}return i}e.matchesFuzzyIconAware=o}),define(ve[77],we([0,1,15,106]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(d="",o=!1){if(this.value=d,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1)}appendText(d,o=0){return this.value+=P(this.supportThemeIcons?(0,F.escapeIcons)(d):d).replace(/([ \t]+)/g,(a,g)=>"&nbsp;".repeat(g.length)).replace(/^>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,o){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=A;function T(n){return I(n)?!n.value:Array.isArray(n)?n.every(T):!0}e.isEmptyMarkdownString=T;function I(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function S(n,d){return n===d?!0:!n||!d?!1:n.value===d.value&&n.isTrusted===d.isTrusted&&n.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=S;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function y(n){const d=[],o=n.split("|").map(g=>g.trim());n=o[0];const a=o[1];if(a){const g=/height=(\d+)/.exec(a),k=/width=(\d+)/.exec(a),b=g?g[1]:"",u=k?k[1]:"",p=isFinite(parseInt(u)),D=isFinite(parseInt(b));p&&d.push(`width="${u}"`),D&&d.push(`height="${b}"`)}return{href:n,dimensions:d}}e.parseHrefAndDimensions=y}),define(ve[53],we([0,1,23,9,2]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,S)}e.stringify=A;function T(t){let y=JSON.parse(t);return y=P(y),y}e.parse=T;var I;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function S(t,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,F.regExpFlags)(y)}:y}function P(t,y=0){if(!t||y>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return _.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof c.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],y+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],y+1))}return t}e.revive=P}),define(ve[11],we([0,1,25,2]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var _;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(_=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,P,t){this._hosts[S]=P,this._ports[S]=t}setConnectionToken(S,P){this._connectionTokens[S]=P}rewrite(S){if(this._delegate)return this._delegate(S);const P=S.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const y=this._ports[P],n=this._connectionTokens[P];let d=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(d+=`&tkn=${encodeURIComponent(n)}`),F.URI.from({scheme:c.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${t}:${y}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new A;class T{asBrowserUri(S,P){const t=this.toUri(S,P);return t.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===_.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${_.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?t.with({scheme:_.vscodeFileResource,authority:t.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(S,P){const t=this.toUri(S,P);return t.scheme===_.vscodeFileResource?t.with({scheme:_.file,authority:t.authority!==T.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(S,P){return F.URI.isUri(S)?S:F.URI.parse(P.toUrl(S))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ve[24],we([0,1,40,11,17,25,9,2]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(d){return(0,I.uriToFsPath)(d,!0)}e.originalFSPath=S;class P{constructor(o){this._ignorePathCasing=o}compare(o,a,g=!1){return o===a?0:(0,T.compare)(this.getComparisonKey(o,g),this.getComparisonKey(a,g))}isEqual(o,a,g=!1){return o===a?!0:!o||!a?!1:this.getComparisonKey(o,g)===this.getComparisonKey(a,g)}getComparisonKey(o,a=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,a,g=!1){if(o.scheme===a.scheme){if(o.scheme===F.Schemas.file)return c.isEqualOrParent(S(o),S(a),this._ignorePathCasing(o))&&o.query===a.query&&(g||o.fragment===a.fragment);if((0,e.isEqualAuthority)(o.authority,a.authority))return c.isEqualOrParent(o.path,a.path,this._ignorePathCasing(o),"/")&&o.query===a.query&&(g||o.fragment===a.fragment)}return!1}joinPath(o,...a){return I.URI.joinPath(o,...a)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return _.posix.basename(o.path)}extname(o){const a=_.posix.extname(o.path),g=a.indexOf("?");return g!==-1?a.substr(0,g):a}dirname(o){if(o.path.length===0)return o;let a;return o.scheme===F.Schemas.file?a=I.URI.file(_.dirname(S(o))).path:(a=_.posix.dirname(o.path),o.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),a="/")),o.with({path:a})}normalizePath(o){if(!o.path.length)return o;let a;return o.scheme===F.Schemas.file?a=I.URI.file(_.normalize(S(o))).path:a=_.posix.normalize(o.path),o.with({path:a})}relativePath(o,a){if(o.scheme!==a.scheme||!(0,e.isEqualAuthority)(o.authority,a.authority))return;if(o.scheme===F.Schemas.file){const b=_.relative(S(o),S(a));return A.isWindows?c.toSlashes(b):b}let g=o.path||"/",k=a.path||"/";if(this._ignorePathCasing(o)){let b=0;for(const u=Math.min(g.length,k.length);b<u&&!(g.charCodeAt(b)!==k.charCodeAt(b)&&g.charAt(b).toLowerCase()!==k.charAt(b).toLowerCase());b++);g=k.substr(0,b)+g.substr(b)}return _.posix.relative(g,k)}resolvePath(o,a){if(o.scheme===F.Schemas.file){const g=I.URI.file(_.resolve(S(o),a));return o.with({authority:g.authority,path:g.path})}return a=c.toPosixPath(a),o.with({path:_.posix.resolve(o.path,a)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,a){return o===a||(0,T.equalsIgnoreCase)(o,a)}hasTrailingPathSeparator(o,a=_.sep){if(o.scheme===F.Schemas.file){const g=S(o);return g.length>c.getRoot(g).length&&g[g.length-1]===a}else{const g=o.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,a=_.sep){return(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,a=_.sep){let g=!1;if(o.scheme===F.Schemas.file){const k=S(o);g=k!==void 0&&k.length===c.getRoot(k).length&&k[k.length-1]===a}else{a="/";const k=o.path;g=k.length===1&&k.charCodeAt(k.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path+"/"}):o}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(d=>d.scheme===F.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(d,o){const a=[];for(let g=0;g<d.length;g++){const k=o(d[g]);d.some((b,u)=>u===g?!1:(0,e.isEqualOrParent)(k,o(b)))||a.push(d[g])}return a}e.distinctParents=t;var y;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function o(a){const g=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(u=>{const[p,D]=u.split(":");p&&D&&g.set(p,D)});const b=a.path.substring(0,a.path.indexOf(";"));return b&&g.set(d.META_DATA_MIME,b),g}d.parseMetaData=o})(y=e.DataUri||(e.DataUri={}));function n(d,o,a){if(o){let g=d.path;return g&&g[0]!==_.posix.sep&&(g=_.posix.sep+g),d.with({scheme:a,authority:o,path:g})}return d.with({scheme:a})}e.toLocalResource=n}),define(ve[13],we([0,1,21,15,3,7,24]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(z){return!!z&&typeof z.then=="function"}e.isThenable=I;function S(z){const N=new c.CancellationTokenSource,W=z(N.token),j=new Promise((Y,de)=>{const G=N.token.onCancellationRequested(()=>{G.dispose(),N.dispose(),de((0,F.canceled)())});Promise.resolve(W).then(ue=>{G.dispose(),N.dispose(),Y(ue)},ue=>{G.dispose(),N.dispose(),de(ue)})});return new class{cancel(){N.cancel()}then(Y,de){return j.then(Y,de)}catch(Y){return this.then(void 0,Y)}finally(Y){return j.finally(Y)}}}e.createCancelablePromise=S;function P(z,N,W){return Promise.race([z,new Promise(j=>N.onCancellationRequested(()=>j(W)))])}e.raceCancellation=P;async function t(z){let N=-1;const W=z.map((Y,de)=>Y.then(G=>(N=de,G))),j=await Promise.race(W);return z.forEach((Y,de)=>{de!==N&&Y.cancel()}),j}e.raceCancellablePromises=t;function y(z,N,W){let j;const Y=setTimeout(()=>{j?.(void 0),W?.()},N);return Promise.race([z.finally(()=>clearTimeout(Y)),new Promise(de=>j=de)])}e.raceTimeout=y;function n(z){return new Promise((N,W)=>{const j=z();I(j)?j.then(N,W):N(j)})}e.asPromise=n;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(W,W).then(j)})}return new Promise((W,j)=>{this.queuedPromise.then(W,j)})}return this.activePromise=N(),new Promise((W,j)=>{this.activePromise.then(Y=>{this.activePromise=null,W(Y)},Y=>{this.activePromise=null,j(Y)})})}}e.Throttler=d;class o{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=o;class a{constructor(){this.promiseMap=new Map}queue(N,W){const Y=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(N)===Y&&this.promiseMap.delete(N)});return this.promiseMap.set(N,Y),Y}}e.SequencerByKey=a;class g{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,W=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Y)=>{this.doResolve=j,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class k{constructor(N){this.delayer=new g(N),this.throttler=new d}trigger(N,W){return this.delayer.trigger(()=>this.throttler.queue(N),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=k;class b{constructor(){this._isOpen=!1,this._promise=new Promise((N,W)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class u extends b{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function p(z,N){return N?new Promise((W,j)=>{const Y=setTimeout(()=>{de.dispose(),W()},z),de=N.onCancellationRequested(()=>{clearTimeout(Y),de.dispose(),j((0,F.canceled)())})}):S(W=>p(z,W))}e.timeout=p;function D(z,N=0){const W=setTimeout(z,N);return(0,A.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=D;function i(z){const N=[];let W=0;const j=z.length;function Y(){return W<j?z[W++]():null}function de(G){G!=null&&N.push(G);const ue=Y();return ue?ue.then(de):Promise.resolve(N)}return Promise.resolve(null).then(de)}e.sequence=i;function r(z,N=j=>!!j,W=null){let j=0;const Y=z.length,de=()=>{if(j>=Y)return Promise.resolve(W);const G=z[j++];return Promise.resolve(G()).then(oe=>N(oe)?Promise.resolve(oe):de())};return de()}e.first=r;function l(z,N=j=>!!j,W=null){if(z.length===0)return Promise.resolve(W);let j=z.length;const Y=()=>{j=-1;for(const de of z)de.cancel?.()};return new Promise((de,G)=>{for(const ue of z)ue.then(oe=>{--j>=0&&N(oe)?(Y(),de(oe)):j===0&&de(W)}).catch(oe=>{--j>=0&&(Y(),G(oe))})})}e.firstParallel=l;class s{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((W,j)=>{this.outstandingPromises.push({factory:N,c:W,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const W=N.factory();W.then(N.c,N.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class m extends s{constructor(){super(1)}}e.Queue=m;class v{constructor(){this.queues=new Map}queueFor(N,W=T.extUri){const j=W.getComparisonKey(N);let Y=this.queues.get(j);return Y||(Y=new m,_.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(j)}),this.queues.set(j,Y)),Y}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=v;class w{constructor(N,W){this._token=-1,typeof N=="function"&&typeof W=="number"&&this.setIfNotSet(N,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},W)}setIfNotSet(N,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},W))}}e.TimeoutTimer=w;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setInterval(()=>{N()},W)}}e.IntervalTimer=C;class R{constructor(N,W){this.timeoutToken=-1,this.runner=N,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class f extends R{constructor(N,W){super(N,W);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=f;class E extends A.Disposable{constructor(N,W,j,Y){super();this.maxWorkChunkSize=N,this.maxPendingWork=W,this.throttleDelay=j,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=E,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const W=setTimeout(()=>N(z));let j=!1;return{dispose(){j||(j=!0,clearTimeout(W))}}}}else e.runWhenIdle=(z,N)=>{const W=requestIdleCallback(z,typeof N=="number"?{timeout:N}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(W))}}}}();class h{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=h;async function M(z,N,W){let j;for(let Y=0;Y<W;Y++)try{return await z()}catch(de){j=de,await p(N)}throw j}e.retry=M;class O{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,W,j){return this._pending={taskId:N,cancel:()=>j?.(),promise:W},W.then(()=>this.donePending(N),()=>this.donePending(N)),W}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let W,j;const Y=new Promise((de,G)=>{W=de,j=G});this._next={run:N,promise:Y,promiseResolve:W,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=O;class q{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,W)=>{this.completeCallback=N,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(W=>{this.completeCallback(N),this.resolved=!0,W()})}error(N){return new Promise(W=>{this.errorCallback(N),this.rejected=!0,W()})}cancel(){new Promise(N=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=Q;var $;(function(z){async function N(W){let j;const Y=await Promise.all(W.map(de=>de.then(G=>G,G=>{j||(j=G)})));if(typeof j!="undefined")throw j;return Y}z.settled=N})($=e.Promises||(e.Promises={}))}),define(ve[107],we([0,1,13,17]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new c.IdleValue(()=>{const R=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:R,collatorIsNumeric:R.resolvedOptions().numeric}}),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(R,f,E=!1){const h=R||"",M=f||"",O=_.value.collator.compare(h,M);return _.value.collatorIsNumeric&&O===0&&h!==M?h<M?-1:1:O}e.compareFileNames=I;function S(R,f){const E=A.value.collator;return R=R||"",f=f||"",D(E,R,f)}e.compareFileNamesDefault=S;function P(R,f){const E=A.value.collator;return R=R||"",f=f||"",s(R,f)||D(E,R,f)}e.compareFileNamesUpper=P;function t(R,f){const E=A.value.collator;return R=R||"",f=f||"",l(R,f)||D(E,R,f)}e.compareFileNamesLower=t;function y(R,f){return R=R||"",f=f||"",R===f?0:R<f?-1:1}e.compareFileNamesUnicode=y;function n(R,f,E=!1){E||(R=R&&R.toLowerCase(),f=f&&f.toLowerCase());const[h,M]=u(R),[O,q]=u(f);return h!==O?h<O?-1:1:M===q?0:M<q?-1:1}e.noIntlCompareFileNames=n;function d(R,f){const[E,h]=u(R),[M,O]=u(f);let q=_.value.collator.compare(h,O);if(q===0){if(_.value.collatorIsNumeric&&h!==O)return h<O?-1:1;if(q=_.value.collator.compare(E,M),_.value.collatorIsNumeric&&q===0&&E!==M)return E<M?-1:1}return q}e.compareFileExtensions=d;function o(R,f){R=R||"",f=f||"";const E=p(R),h=p(f),M=A.value.collator,O=T.value.collator;return D(O,E,h)||D(M,R,f)}e.compareFileExtensionsDefault=o;function a(R,f){R=R||"",f=f||"";const E=p(R),h=p(f),M=A.value.collator,O=T.value.collator;return D(O,E,h)||s(R,f)||D(M,R,f)}e.compareFileExtensionsUpper=a;function g(R,f){R=R||"",f=f||"";const E=p(R),h=p(f),M=A.value.collator,O=T.value.collator;return D(O,E,h)||l(R,f)||D(M,R,f)}e.compareFileExtensionsLower=g;function k(R,f){R=R||"",f=f||"";const E=p(R).toLowerCase(),h=p(f).toLowerCase();return E!==h?E<h?-1:1:R!==f?R<f?-1:1:0}e.compareFileExtensionsUnicode=k;const b=/^(.*?)(\.([^.]*))?$/;function u(R,f=!1){const E=R?b.exec(R):[];let h=[E&&E[1]||"",E&&E[3]||""];return f&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function p(R){const f=R?b.exec(R):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function D(R,f,E){let h=R.compare(f,E);return h!==0?h:f.length!==E.length?f.length<E.length?-1:1:0}function i(R){const f=R.charAt(0);return f.toLocaleUpperCase()!==f}function r(R){const f=R.charAt(0);return f.toLocaleLowerCase()!==f}function l(R,f){return i(R)&&r(f)?-1:r(R)&&i(f)?1:0}function s(R,f){return r(R)&&i(f)?-1:i(R)&&r(f)?1:0}function m(R,f,E=!1){return E||(R=R&&R.toLowerCase(),f=f&&f.toLowerCase()),R===f?0:R<f?-1:1}function v(R,f,E=!1){const h=R.split(F.sep),M=f.split(F.sep),O=h.length-1,q=M.length-1;let Q,$;for(let z=0;;z++){if(Q=O===z,$=q===z,Q&&$)return I(h[z],M[z],E);if(Q)return-1;if($)return 1;const N=m(h[z],M[z],E);if(N!==0)return N}}e.comparePaths=v;function w(R,f,E){const h=R.toLowerCase(),M=f.toLowerCase(),O=C(R,f,E);if(O)return O;const q=h.endsWith(E),Q=M.endsWith(E);if(q!==Q)return q?-1:1;const $=I(h,M);return $!==0?$:h.localeCompare(M)}e.compareAnything=w;function C(R,f,E){const h=R.toLowerCase(),M=f.toLowerCase(),O=h.startsWith(E),q=M.startsWith(E);if(O!==q)return O?-1:1;if(O&&q){if(h.length<M.length)return-1;if(h.length>M.length)return 1}return 0}e.compareByPrefix=C}),define(ve[27],we([0,1,13,40,20,17,9]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const S="**",P="/",t="[/\\\\]",y="[^/\\\\]",n=/\//g;function d(Y){switch(Y){case 0:return"";case 1:return`${y}*?`;default:return`(?:${t}|${y}+${t}|${t}${y}+)*?`}}function o(Y,de){if(!Y)return[];const G=[];let ue=!1,oe=!1,be="";for(const Ae of Y){switch(Ae){case de:if(!ue&&!oe){G.push(be),be="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}be+=Ae}return be&&G.push(be),G}e.splitGlobAware=o;function a(Y){if(!Y)return"";let de="";const G=o(Y,P);if(G.every(ue=>ue===S))de=".*";else{let ue=!1;G.forEach((oe,be)=>{if(oe===S){ue||(de+=d(2),ue=!0);return}let Ae=!1,Re="",Oe=!1,Qe="";for(const He of oe){if(He!=="}"&&Ae){Re+=He;continue}if(Oe&&(He!=="]"||!Qe)){let je;He==="-"?je=He:(He==="^"||He==="!")&&!Qe?je="^":He===P?je="":je=T.escapeRegExpCharacters(He),Qe+=je;continue}switch(He){case"{":Ae=!0;continue;case"[":Oe=!0;continue;case"}":de+=`(?:${o(Re,",").map(K=>a(K)).join("|")})`,Ae=!1,Re="";break;case"]":de+="["+Qe+"]",Oe=!1,Qe="";break;case"?":de+=y;continue;case"*":de+=d(1);continue;default:de+=T.escapeRegExpCharacters(He)}}be<G.length-1&&(G[be+1]!==S||be+2<G.length)&&(de+=t),ue=!1})}return de}const g=/^\*\*\/\*\.[\w\.-]+$/,k=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new _.LRUCache(1e4),r=function(){return!1},l=function(){return null};function s(Y,de){if(!Y)return l;let G;typeof Y!="string"?G=Y.pattern:G=Y,G=G.trim();const ue=`${G}_${!!de.trimForExclusions}`;let oe=i.get(ue);if(oe)return m(oe,Y);let be;if(g.test(G)){const Ae=G.substr(4);oe=function(Re,Oe){return typeof Re=="string"&&Re.endsWith(Ae)?G:null}}else(be=k.exec(v(G,de)))?oe=w(be[1],G):(de.trimForExclusions?u:b).test(G)?oe=C(G,de):(be=p.exec(v(G,de)))?oe=R(be[1].substr(1),G,!0):(be=D.exec(v(G,de)))?oe=R(be[1],G,!1):oe=f(G);return i.set(ue,oe),m(oe,Y)}function m(Y,de){return typeof de=="string"?Y:function(G,ue){return F.isEqualOrParent(G,de.base)?Y(A.relative(de.base,G),ue):null}}function v(Y,de){return de.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function w(Y,de){const G=`/${Y}`,ue=`\\${Y}`,oe=function(Ae,Re){return typeof Ae!="string"?null:Re?Re===Y?de:null:Ae===Y||Ae.endsWith(G)||Ae.endsWith(ue)?de:null},be=[Y];return oe.basenames=be,oe.patterns=[de],oe.allBasenames=be,oe}function C(Y,de){const G=j(Y.slice(1,-1).split(",").map(Re=>s(Re,de)).filter(Re=>Re!==l),Y),ue=G.length;if(!ue)return l;if(ue===1)return G[0];const oe=function(Re,Oe){for(let Qe=0,He=G.length;Qe<He;Qe++)if(G[Qe](Re,Oe))return Y;return null},be=G.find(Re=>!!Re.allBasenames);be&&(oe.allBasenames=be.allBasenames);const Ae=G.reduce((Re,Oe)=>Oe.allPaths?Re.concat(Oe.allPaths):Re,[]);return Ae.length&&(oe.allPaths=Ae),oe}function R(Y,de,G){const ue=A.sep===A.posix.sep,oe=ue?Y:Y.replace(n,A.sep),be=A.sep+oe,Ae=A.posix.sep+Y,Re=G?function(Oe,Qe){return typeof Oe=="string"&&(Oe===oe||Oe.endsWith(be)||!ue&&(Oe===Y||Oe.endsWith(Ae)))?de:null}:function(Oe,Qe){return typeof Oe=="string"&&(Oe===oe||!ue&&Oe===Y)?de:null};return Re.allPaths=[(G?"*/":"./")+Y],Re}function f(Y){try{const de=new RegExp(`^${a(Y)}$`);return function(G){return de.lastIndex=0,typeof G=="string"&&de.test(G)?Y:null}}catch(de){return l}}function E(Y,de,G){return!Y||typeof de!="string"?!1:h(Y)(de,void 0,G)}e.match=E;function h(Y,de={}){if(!Y)return r;if(typeof Y=="string"||Q(Y)){const G=s(Y,de);if(G===l)return r;const ue=function(oe,be){return!!G(oe,be)};return G.allBasenames&&(ue.allBasenames=G.allBasenames),G.allPaths&&(ue.allPaths=G.allPaths),ue}return N(Y,de)}e.parse=h;function M(Y){if(!Y)return;let de;return G=>(de||(de=(Y()||Promise.resolve([])).then(ue=>ue?q(ue):{})),de.then(ue=>!!ue[G]))}e.hasSiblingPromiseFn=M;function O(Y){if(!Y)return;let de;return G=>{if(!de){const ue=Y();de=ue?q(ue):{}}return!!de[G]}}e.hasSiblingFn=O;function q(Y){const de={};for(const G of Y)de[G]=!0;return de}function Q(Y){const de=Y;return de&&typeof de.base=="string"&&typeof de.pattern=="string"}e.isRelativePattern=Q;function $(Y){return Y.allBasenames||[]}e.getBasenameTerms=$;function z(Y){return Y.allPaths||[]}e.getPathTerms=z;function N(Y,de){const G=j(Object.getOwnPropertyNames(Y).map(Re=>W(Re,Y[Re],de)).filter(Re=>Re!==l)),ue=G.length;if(!ue)return l;if(!G.some(Re=>!!Re.requiresSiblings)){if(ue===1)return G[0];const Re=function(He,je){for(let U=0,K=G.length;U<K;U++){const ee=G[U](He,je);if(ee)return ee}return null},Oe=G.find(He=>!!He.allBasenames);Oe&&(Re.allBasenames=Oe.allBasenames);const Qe=G.reduce((He,je)=>je.allPaths?He.concat(je.allPaths):He,[]);return Qe.length&&(Re.allPaths=Qe),Re}const oe=function(Re,Oe,Qe){let He;for(let je=0,U=G.length;je<U;je++){const K=G[je];K.requiresSiblings&&Qe&&(Oe||(Oe=A.basename(Re)),He||(He=Oe.substr(0,Oe.length-A.extname(Re).length)));const ee=K(Re,Oe,He,Qe);if(ee)return ee}return null},be=G.find(Re=>!!Re.allBasenames);be&&(oe.allBasenames=be.allBasenames);const Ae=G.reduce((Re,Oe)=>Oe.allPaths?Re.concat(Oe.allPaths):Re,[]);return Ae.length&&(oe.allPaths=Ae),oe}function W(Y,de,G){if(de===!1)return l;const ue=s(Y,G);if(ue===l)return l;if(typeof de=="boolean")return ue;if(de){const oe=de.when;if(typeof oe=="string"){const be=(Ae,Re,Oe,Qe)=>{if(!Qe||!ue(Ae,Re))return null;const He=oe.replace("$(basename)",Oe),je=Qe(He);return(0,c.isThenable)(je)?je.then(U=>U?Y:null):je?Y:null};return be.requiresSiblings=!0,be}}return ue}function j(Y,de){const G=Y.filter(Re=>!!Re.basenames);if(G.length<2)return Y;const ue=G.reduce((Re,Oe)=>{const Qe=Oe.basenames;return Qe?Re.concat(Qe):Re},[]);let oe;if(de){oe=[];for(let Re=0,Oe=ue.length;Re<Oe;Re++)oe.push(de)}else oe=G.reduce((Re,Oe)=>{const Qe=Oe.patterns;return Qe?Re.concat(Qe):Re},[]);const be=function(Re,Oe){if(typeof Re!="string")return null;if(!Oe){let He;for(He=Re.length;He>0;He--){const je=Re.charCodeAt(He-1);if(je===47||je===92)break}Oe=Re.substr(He)}const Qe=ue.indexOf(Oe);return Qe!==-1?oe[Qe]:null};be.basenames=ue,be.patterns=oe,be.allBasenames=ue;const Ae=Y.filter(Re=>!Re.basenames);return Ae.push(be),Ae}}),define(ve[78],we([0,1,40,11,17,25,24,9,2]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(s,m,v){if(typeof s=="string"&&(s=S.URI.file(s)),v){const C=v.getWorkspaceFolder(s);if(C){const R=v.getWorkspace().folders.length>1;let f;if((0,T.isEqual)(C.uri,s)?f="":f=(0,T.relativePath)(C.uri,s),R){const E=C.name?C.name:(0,T.basename)(C.uri);f=f?E+" \u2022 "+f:E}return f}}if(s.scheme!==F.Schemas.file&&s.scheme!==F.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(s.fsPath))return(0,_.normalize)(y(s.fsPath));let w=(0,_.normalize)(s.fsPath);return!A.isWindows&&m?.userHome&&(w=d(w,m.userHome.fsPath)),w}e.getPathLabel=P;function t(s){if(!s)return;typeof s=="string"&&(s=S.URI.file(s));const m=(0,T.basename)(s)||(s.scheme===F.Schemas.file?s.fsPath:s.path);return A.isWindows&&(0,c.isRootOrDriveLetter)(m)?y(m):m}e.getBaseLabel=t;function y(s){return(0,c.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=y;let n=Object.create(null);function d(s,m){if(A.isWindows||!s||!m)return s;let v=n.original===m?n.normalized:void 0;return v||(v=`${(0,I.rtrim)(m,_.posix.sep)}${_.posix.sep}`,n={original:m,normalized:v}),(A.isLinux?s.startsWith(v):(0,I.startsWithIgnoreCase)(s,v))&&(s=`~/${s.substr(v.length)}`),s}e.tildify=d;function o(s,m){return s.replace(/^~($|\/|\\)/,`${m}$1`)}e.untildify=o;const a="\u2026",g="\\\\",k="~";function b(s,m=_.sep){const v=new Array(s.length);let w=!1;for(let C=0;C<s.length;C++){let R=s[C];if(R===""){v[C]=`.${m}`;continue}if(!R){v[C]=R;continue}w=!0;let f="";R.indexOf(g)===0?(f=R.substr(0,R.indexOf(g)+g.length),R=R.substr(R.indexOf(g)+g.length)):R.indexOf(m)===0?(f=R.substr(0,R.indexOf(m)+m.length),R=R.substr(R.indexOf(m)+m.length)):R.indexOf(k)===0&&(f=R.substr(0,R.indexOf(k)+k.length),R=R.substr(R.indexOf(k)+k.length));const E=R.split(m);for(let h=1;w&&h<=E.length;h++)for(let M=E.length-h;w&&M>=0;M--){w=!1;let O=E.slice(M,M+h).join(m);for(let q=0;!w&&q<s.length;q++)if(q!==C&&s[q]&&s[q].indexOf(O)>-1){const Q=M+h===E.length,$=M>0&&s[q].indexOf(m)>-1?m+O:O,z=s[q].endsWith($);w=!Q||z}if(!w){let q="";(E[0].endsWith(":")||f!=="")&&(M===1&&(M=0,h++,O=E[0]+m+O),M>0&&(q=E[0]+m),q=f+q),M>0&&(q=q+a+m),q=q+O,M+h<E.length&&(q=q+m+a),v[C]=q}}w&&(v[C]=R)}return v}e.shorten=b;var u;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function p(s,m=Object.create(null)){const v=[];let w=!1,C="";for(const R of s)if(R==="$"||w&&R==="{")C&&v.push({value:C,type:u.TEXT}),C="",w=!0;else if(R==="}"&&w){const f=m[C];if(typeof f=="string")f.length&&v.push({value:f,type:u.VARIABLE});else if(f){const E=v[v.length-1];(!E||E.type!==u.SEPARATOR)&&v.push({value:f.label,type:u.SEPARATOR})}C="",w=!1}else C+=R;return C&&!w&&v.push({value:C,type:u.TEXT}),v.filter((R,f)=>{if(R.type===u.SEPARATOR){const E=v[f-1],h=v[f+1];return[E,h].every(M=>M&&(M.type===u.VARIABLE||M.type===u.TEXT)&&M.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=p;function D(s,m){return A.isMacintosh||m?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):s.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function i(s,m){return A.isMacintosh||m?s.replace(/\(&&\w\)|&&/g,""):A.isWindows?s.replace(/&&|&/g,v=>v==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function r(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=r;function l(s){const m=s.indexOf("/")!==-1?_.posix:_.win32,v=m.basename(s),w=m.dirname(s);return v.length?{name:v,parentPath:w}:{name:w,parentPath:""}}e.splitName=l}),define(ve[79],we([0,1,27,11,17,24,9]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let S=[],P=[],t=[];function y(s,m=!1){const v=n(s);S.push(v),v.userConfigured?t.push(v):P.push(v),m&&!v.userConfigured&&S.forEach(w=>{w.mime===v.mime||w.userConfigured||(v.extension&&w.extension===v.extension&&console.warn(`Overwriting extension <<${v.extension}>> to now point to mime <<${v.mime}>>`),v.filename&&w.filename===v.filename&&console.warn(`Overwriting filename <<${v.filename}>> to now point to mime <<${v.mime}>>`),v.filepattern&&w.filepattern===v.filepattern&&console.warn(`Overwriting filepattern <<${v.filepattern}>> to now point to mime <<${v.mime}>>`),v.firstline&&w.firstline===v.firstline&&console.warn(`Overwriting firstline <<${v.firstline}>> to now point to mime <<${v.mime}>>`))})}e.registerTextMime=y;function n(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,c.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(_.posix.sep)>=0:!1}}function d(s){s?(S=S.filter(m=>!m.userConfigured),t=[]):(S=[],P=[],t=[])}e.clearTextMimes=d;function o(s,m){let v;if(s)switch(s.scheme){case F.Schemas.file:v=s.fsPath;break;case F.Schemas.data:v=A.DataUri.parseMetaData(s).get(A.DataUri.META_DATA_LABEL);break;default:v=s.path}if(!v)return[I.unknown];v=v.toLowerCase();const w=(0,_.basename)(v),C=a(v,w,t);if(C)return[C,I.text];const R=a(v,w,P);if(R)return[R,I.text];if(m){const f=g(m);if(f)return[f,I.text]}return[I.unknown]}e.guessMimeTypes=o;function a(s,m,v){let w=null,C=null,R=null;for(let f=v.length-1;f>=0;f--){const E=v[f];if(m===E.filenameLowercase){w=E;break}if(E.filepattern&&(!C||E.filepattern.length>C.filepattern.length)){const h=E.filepatternOnPath?s:m;E.filepatternLowercase?.(h)&&(C=E)}E.extension&&(!R||E.extension.length>R.extension.length)&&m.endsWith(E.extensionLowercase)&&(R=E)}return w?w.mime:C?C.mime:R?R.mime:null}function g(s){if((0,T.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let m=S.length-1;m>=0;m--){const v=S[m];if(!v.firstline)continue;const w=s.match(v.firstline);if(w&&w.length>0)return v.mime}return null}function k(s){return s?typeof s=="string"?s===I.binary||s===I.text||s===I.unknown:s.length===1&&k(s[0]):!0}e.isUnspecific=k;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(s){const m=(0,_.extname)(s),v=b[m.toLowerCase()];return v!==void 0?v:D(s)}e.getMediaOrTextMime=p;function D(s){const m=(0,_.extname)(s);return u[m.toLowerCase()]}e.getMediaMime=D;function i(s){for(const m in u)if(u[m]===s)return m}e.getExtensionForMimeType=i;const r=/^(.+)\/(.+?)(;.+)?$/;function l(s,m){const v=r.exec(s);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:m?void 0:s}e.normalizeMimeType=l}),define(ve[108],we([0,1,2]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(t){return t.toJSON()}class _{constructor(y){this._uriTransformer=y}transformIncoming(y){const n=this._uriTransformer.transformIncoming(y);return n===y?y:F(c.URI.from(n))}transformOutgoing(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:F(c.URI.from(n))}transformOutgoingURI(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:c.URI.from(n)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,y,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof c.URI)return y.transformOutgoing(t);for(let d in t)if(Object.hasOwnProperty.call(t,d)){const o=A(t[d],y,n+1);o!==null&&(t[d]=o)}}return null}function T(t,y){const n=A(t,y,0);return n===null?t:n}e.transformOutgoingURIs=T;function I(t,y,n,d){if(!t||d>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?c.URI.revive(y.transformIncoming(t)):y.transformIncoming(t);for(let o in t)if(Object.hasOwnProperty.call(t,o)){const a=I(t[o],y,n,d+1);a!==null&&(t[o]=a)}}return null}function S(t,y){const n=I(t,y,!1,0);return n===null?t:n}e.transformIncomingURIs=S;function P(t,y){const n=I(t,y,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(ve[36],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return c.test(S)}e.isUUID=F;const _=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(S){for(let P=0;P<S.length;P++)S[P]=Math.floor(Math.random()*256);return S};function I(){T(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let S=0,P="";return P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+="-",P+=A[_[S++]],P+=A[_[S++]],P+="-",P+=A[_[S++]],P+=A[_[S++]],P+="-",P+=A[_[S++]],P+=A[_[S++]],P+="-",P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P+=A[_[S++]],P}e.generateUuid=I}),define(ve[109],we([0,1,227]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class _ extends c.CharacterClassifier{constructor(I){super(0);for(let S=0,P=I.length;S<P;S++)this.set(I.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=_;function A(T){let I={};return S=>(I.hasOwnProperty(S)||(I[S]=T(S)),I[S])}e.getMapForWordSeparators=A(T=>new _(T))}),define(ve[80],we([0,1,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var _;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(_=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),this.indentSize=g.tabSize|0,this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace),this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class P{constructor(g,k){this._findMatchBrand=void 0,this.range=g,this.matches=k}}e.FindMatch=P;var t;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None"})(y=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class d{constructor(g,k,b,u,p,D){this.identifier=g,this.range=k,this.text=b,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=p,this._isTracked=D}}e.ValidAnnotatedEditOperation=d;class o{constructor(g,k,b){this.reverseEdits=g,this.changes=k,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=o}),define(ve[110],we([0,1,9,109,111,41,80]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class S{constructor(u,p,D,i){this.searchString=u,this.isRegex=p,this.matchCase=D,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=P(this.searchString):u=this.searchString.indexOf(`
`)>=0;let p=null;try{p=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(i){return null}if(!p)return null;let D=!this.isRegex&&!u;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new t(p,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=S;function P(b){if(!b||b.length===0)return!1;for(let u=0,p=b.length;u<p;u++)if(b.charCodeAt(u)===92){if(u++,u>=p)break;const i=b.charCodeAt(u);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(u,p,D){this.regex=u,this.wordSeparators=p,this.simpleSearch=D}}e.SearchData=t;function y(b,u,p){if(!p)return new T.FindMatch(b,null);let D=[];for(let i=0,r=u.length;i<r;i++)D[i]=u[i];return new T.FindMatch(b,D)}e.createFindMatch=y;class n{constructor(u){let p=[],D=0;for(let i=0,r=u.length;i<r;i++)u.charCodeAt(i)===10&&(p[D++]=i);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(u){const p=this._lineFeedsOffsets;let D=0,i=p.length-1;if(i===-1||u<=p[0])return 0;for(;D<i;){const r=D+((i-D)/2>>0);p[r]>=u?i=r-1:p[r+1]>=u?(D=r,i=r):D=r+1}return D+1}}class d{static findMatches(u,p,D,i,r){const l=p.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(u,D,new k(l.wordSeparators,l.regex),i,r):this._doFindMatchesLineByLine(u,D,l,i,r):[]}static _getMultilineMatchRange(u,p,D,i,r,l){let s,m=0;i?(m=i.findLineFeedCountBeforeOffset(r),s=p+r+m):s=p+r;let v;if(i){let f=i.findLineFeedCountBeforeOffset(r+l.length)-m;v=s+l.length+f}else v=s+l.length;const w=u.getPositionAt(s),C=u.getPositionAt(v);return new A.Range(w.lineNumber,w.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(u,p,D,i,r){const l=u.getOffsetAt(p.getStartPosition()),s=u.getValueInRange(p,1),m=u.getEOL()===`\r
`?new n(s):null,v=[];let w=0,C;for(D.reset(0);C=D.next(s);)if(v[w++]=y(this._getMultilineMatchRange(u,l,s,m,C.index,C[0]),C,i),w>=r)return v;return v}static _doFindMatchesLineByLine(u,p,D,i,r){const l=[];let s=0;if(p.startLineNumber===p.endLineNumber){const v=u.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return s=this._findMatchesInLine(D,v,p.startLineNumber,p.startColumn-1,s,l,i,r),l}const m=u.getLineContent(p.startLineNumber).substring(p.startColumn-1);s=this._findMatchesInLine(D,m,p.startLineNumber,p.startColumn-1,s,l,i,r);for(let v=p.startLineNumber+1;v<p.endLineNumber&&s<r;v++)s=this._findMatchesInLine(D,u.getLineContent(v),v,0,s,l,i,r);if(s<r){const v=u.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);s=this._findMatchesInLine(D,v,p.endLineNumber,0,s,l,i,r)}return l}static _findMatchesInLine(u,p,D,i,r,l,s,m){const v=u.wordSeparators;if(!s&&u.simpleSearch){const R=u.simpleSearch,f=R.length,E=p.length;let h=-f;for(;(h=p.indexOf(R,h+f))!==-1;)if((!v||g(v,p,E,h,f))&&(l[r++]=new T.FindMatch(new A.Range(D,h+1+i,D,h+1+f+i),null),r>=m))return r;return r}const w=new k(u.wordSeparators,u.regex);let C;w.reset(0);do if(C=w.next(p),C&&(l[r++]=y(new A.Range(D,C.index+1+i,D,C.index+1+C[0].length+i),C,s),r>=m))return r;while(C);return r}static findNextMatch(u,p,D,i){const r=p.parseSearchRequest();if(!r)return null;const l=new k(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(u,D,l,i):this._doFindNextMatchLineByLine(u,D,l,i)}static _doFindNextMatchMultiline(u,p,D,i){const r=new _.Position(p.lineNumber,1),l=u.getOffsetAt(r),s=u.getLineCount(),m=u.getValueInRange(new A.Range(r.lineNumber,r.column,s,u.getLineMaxColumn(s)),1),v=u.getEOL()===`\r
`?new n(m):null;D.reset(p.column-1);let w=D.next(m);return w?y(this._getMultilineMatchRange(u,l,m,v,w.index,w[0]),w,i):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(u,new _.Position(1,1),D,i):null}static _doFindNextMatchLineByLine(u,p,D,i){const r=u.getLineCount(),l=p.lineNumber,s=u.getLineContent(l),m=this._findFirstMatchInLine(D,s,l,p.column,i);if(m)return m;for(let v=1;v<=r;v++){const w=(l+v-1)%r,C=u.getLineContent(w+1),R=this._findFirstMatchInLine(D,C,w+1,1,i);if(R)return R}return null}static _findFirstMatchInLine(u,p,D,i,r){u.reset(i-1);const l=u.next(p);return l?y(new A.Range(D,l.index+1,D,l.index+1+l[0].length),l,r):null}static findPreviousMatch(u,p,D,i){const r=p.parseSearchRequest();if(!r)return null;const l=new k(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(u,D,l,i):this._doFindPreviousMatchLineByLine(u,D,l,i)}static _doFindPreviousMatchMultiline(u,p,D,i){const r=this._doFindMatchesMultiline(u,new A.Range(1,1,p.lineNumber,p.column),D,i,10*I);if(r.length>0)return r[r.length-1];const l=u.getLineCount();return p.lineNumber!==l||p.column!==u.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(u,new _.Position(l,u.getLineMaxColumn(l)),D,i):null}static _doFindPreviousMatchLineByLine(u,p,D,i){const r=u.getLineCount(),l=p.lineNumber,s=u.getLineContent(l).substring(0,p.column-1),m=this._findLastMatchInLine(D,s,l,i);if(m)return m;for(let v=1;v<=r;v++){const w=(r+l-v-1)%r,C=u.getLineContent(w+1),R=this._findLastMatchInLine(D,C,w+1,i);if(R)return R}return null}static _findLastMatchInLine(u,p,D,i){let r=null,l;for(u.reset(0);l=u.next(p);)r=y(new A.Range(D,l.index+1,D,l.index+1+l[0].length),l,i);return r}}e.TextModelSearch=d;function o(b,u,p,D,i){if(D===0)return!0;const r=u.charCodeAt(D-1);if(b.get(r)!==0||r===13||r===10)return!0;if(i>0){const l=u.charCodeAt(D);if(b.get(l)!==0)return!0}return!1}function a(b,u,p,D,i){if(D+i===p)return!0;const r=u.charCodeAt(D+i);if(b.get(r)!==0||r===13||r===10)return!0;if(i>0){const l=u.charCodeAt(D+i-1);if(b.get(l)!==0)return!0}return!1}function g(b,u,p,D,i){return o(b,u,p,D,i)&&a(b,u,p,D,i)}e.isValidMatch=g;class k{constructor(u,p){this._wordSeparators=u,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const p=u.length;let D;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(D=this._searchRegex.exec(u),!D))return null;const i=D.index,r=D[0].length;if(i===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){c.getNextCodePoint(u,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=r,!this._wordSeparators||g(this._wordSeparators,u,p,i,r))return D}while(D);return null}}e.Searcher=k}),define(ve[112],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class F{constructor(I){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let S=0,P=I.notIn.length;S<P;S++)switch(I.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=F;class _{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of I)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=_;function A(T,I,S){T.has(I)?T.get(I).push(S):T.set(I,[S])}}),define(ve[54],we([0,1,27,17]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(A,T,I,S){if(Array.isArray(A)){let P=0;for(const t of A){const y=_(t,T,I,S);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===I?10:0:0;if(A){const{language:P,pattern:t,scheme:y,hasAccessToAllModels:n}=A;if(!S&&!n)return 0;let d=0;if(y)if(y===T.scheme)d=10;else if(y==="*")d=5;else return 0;if(P)if(P===I)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(t){let o;if(typeof t=="string"?o=t:o={...t,base:(0,F.normalize)(t.base)},o===T.fsPath||(0,c.match)(o,T.fsPath))d=10;else return 0}return d}else return 0}}e.score=_}),define(ve[113],we([0,1,3,7]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class _{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,I){return this._map.set(T,I),this.fire([T]),(0,F.toDisposable)(()=>{this._map.get(T)===I&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,I){let S=null,P=!1;return this._promises.set(T,I.then(t=>{this._promises.delete(T),!(P||!t)&&(S=this.register(T,t))})),(0,F.toDisposable)(()=>{P=!0,S&&S.dispose()})}getPromise(T){const I=this.get(T);if(I)return Promise.resolve(I);const S=this._promises.get(T);return S?S.then(P=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=_}),define(ve[81],we([0,1,23,25]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(_||(_={}));function A(y){for(let n=0,d=y.length;n<d;n+=4){const o=y[n+0],a=y[n+1],g=y[n+2],k=y[n+3];y[n+0]=k,y[n+1]=g,y[n+2]=a,y[n+3]=o}}function T(y){const n=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return F.isLittleEndian()||A(n),c.VSBuffer.wrap(n)}function I(y){const n=y.buffer;if(F.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const d=new Uint8Array(n.byteLength);return d.set(n),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function S(y){const n=new Uint32Array(P(y));let d=0;if(n[d++]=y.id,y.type==="full")n[d++]=1,n[d++]=y.data.length,n.set(y.data,d),d+=y.data.length;else{n[d++]=2,n[d++]=y.deltas.length;for(const o of y.deltas)n[d++]=o.start,n[d++]=o.deleteCount,o.data?(n[d++]=o.data.length,n.set(o.data,d),d+=o.data.length):n[d++]=0}return T(n)}e.encodeSemanticTokensDto=S;function P(y){let n=0;if(n+=1+1,y.type==="full")n+=1+y.data.length;else{n+=1,n+=(1+1+1)*y.deltas.length;for(const d of y.deltas)d.data&&(n+=d.data.length)}return n}function t(y){const n=I(y);let d=0;const o=n[d++];if(n[d++]===1){const b=n[d++],u=n.subarray(d,d+b);return d+=b,{id:o,type:"full",data:u}}const g=n[d++];let k=[];for(let b=0;b<g;b++){const u=n[d++],p=n[d++],D=n[d++];let i;D>0&&(i=n.subarray(d,d+D),d+=D),k[b]={start:u,deleteCount:p,data:i}}return{id:o,type:"delta",deltas:k}}e.decodeSemanticTokensDto=t}),define(ve[114],we([18,19]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ve[55],we([0,1,16,10,114]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,t){return t&&(P.stack||P.stacktrace)?_.localize(0,null,I(P),T(P.stack)||T(P.stacktrace)):I(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?_.localize(1,null,P.message):P.message||_.localize(2,null)}function S(P=null,t=!1){if(!P)return _.localize(3,null);if(Array.isArray(P)){const y=c.coalesce(P),n=S(y[0],t);return y.length>1?_.localize(4,null,n,y.length):n}if(F.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return A(y.error,t);if(y.exception)return A(y.exception,t)}return P.stack?A(P,t):P.message?P.message:_.localize(5,null)}e.toErrorMessage=S}),define(ve[115],we([18,19]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ve[116],we([18,19]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[117],we([18,19]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[118],we([18,19]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ve[119],we([18,19]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ve[120],we([18,19]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[121],we([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[122],we([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[123],we([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[124],we([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[125],we([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[126],we([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[127],we([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[128],we([18,19]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ve[129],we([18,19]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(ve[130],we([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[131],we([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[132],we([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[133],we([18,19]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[134],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var F;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var _;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[135],we([0,1,117]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||F.test(n)}e.isValidVersionStr=A;function T(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=n.match(F);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=T;function I(n){if(!n)return null;let d=n.majorBase,o=n.majorMustEqual,a=n.minorBase,g=n.minorMustEqual,k=n.patchBase,b=n.patchMustEqual;n.hasCaret&&(d===0||(g=!1),b=!1);let u=0;if(n.preRelease){const p=_.exec(n.preRelease);if(p){const[,D,i,r]=p;u=Date.UTC(Number(D),Number(i)-1,Number(r))}}return{majorBase:d,majorMustEqual:o,minorBase:a,minorMustEqual:g,patchBase:k,patchMustEqual:b,isMinimum:n.hasGreaterEquals,notBefore:u}}e.normalizeVersion=I;function S(n,d,o){let a;typeof n=="string"?a=I(T(n)):a=n;let g;d instanceof Date?g=d.getTime():typeof d=="string"&&(g=new Date(d).getTime());let k;if(typeof o=="string"?k=I(T(o)):k=o,!a||!k)return!1;let b=a.majorBase,u=a.minorBase,p=a.patchBase,D=k.majorBase,i=k.minorBase,r=k.patchBase,l=k.notBefore,s=k.majorMustEqual,m=k.minorMustEqual,v=k.patchMustEqual;return k.isMinimum?b>D?!0:b<D?!1:u>i?!0:u<i||g&&g<l?!1:p>=r:(b===1&&D===0&&(!s||!m||!v)&&(D=1,i=0,r=0,s=!0,m=!1,v=!1),b<D?!1:b>D?!s:u<i?!1:u>i?!m:p<r?!1:p>r?!v:!(g&&g<l))}e.isValidVersion=S;function P(n,d,o,a){return o.isBuiltin||typeof o.main=="undefined"?!0:y(n,d,o.engines.vscode,a)}e.isValidExtensionVersion=P;function t(n,d,o){return n==="*"||y(d,o,n)}e.isEngineValid=t;function y(n,d,o,a=[]){let g=I(T(o));if(!g)return a.push(c.localize(0,null,o)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return a.push(c.localize(1,null,o)),!1}else if(!g.majorMustEqual)return a.push(c.localize(2,null,o)),!1;return S(n,d,g)?!0:(a.push(c.localize(3,null,n,o)),!1)}}),define(ve[82],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(_,A=[],T=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=c}),define(ve[56],we([0,1,82]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function _(T,I,S){I instanceof c.SyncDescriptor||(I=new c.SyncDescriptor(I,[],S)),F.push([T,I])}e.registerSingleton=_;function A(){return F}e.getSingletonServiceDescriptors=A}),define(ve[136],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=c;class F{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const I=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(T);I.outgoing.set(this._hashFn(T),S),S.incoming.set(this._hashFn(A),I)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(let I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let I=this._nodes.get(T);return I||(I=new c(A),this._nodes.set(T,I)),I}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[T,I]of this._nodes)A.push(`${T}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,T]of this._nodes){const I=new Set([A]),S=this._findCycle(T,I);if(S)return S}}_findCycle(A,T){for(let[I,S]of A.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const P=this._findCycle(S,T);if(P)return P;T.delete(I)}}}e.Graph=F}),define(ve[4],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function S(P){return P[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=S})(c=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function F(I,S,P,t){S[c.DI_TARGET]===S?S[c.DI_DEPENDENCIES].push({id:I,index:P,optional:t}):(S[c.DI_DEPENDENCIES]=[{id:I,index:P,optional:t}],S[c.DI_TARGET]=S)}function _(I){if(c.serviceIds.has(I))return c.serviceIds.get(I);const S=function(P,t,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(S,P,y,!1)};return S.toString=()=>I,c.serviceIds.set(I,S),S}e.createDecorator=_;function A(I){return I}e.refineServiceDecorator=A;function T(I){return function(S,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(I,S,t,!0)}}e.optional=T}),define(ve[137],we([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function F(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(ve[138],we([0,1,3,57,7,20,76,54,137]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(a){return typeof a=="string"?!1:Array.isArray(a)?a.every(P):!!a.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(g,k){let b={selector:g,provider:k,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,_.toDisposable)(()=>{if(b){let u=this._entries.indexOf(b);u>=0&&(this._entries.splice(u,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const k=[];for(let b of this._entries)b._score>0&&k.push(b.provider);return k}ordered(g){const k=[];return this._orderedForEach(g,b=>k.push(b.provider)),k}orderedGroups(g){const k=[];let b,u;return this._orderedForEach(g,p=>{b&&u===p._score?b.push(p.provider):(u=p._score,b=[p.provider],k.push(b))}),k}_orderedForEach(g,k){if(!!g){this._updateScores(g);for(const b of this._entries)b._score>0&&k(b)}}_updateScores(g){let k={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===k.language&&this._lastCandidate.uri===k.uri)){this._lastCandidate=k;for(let b of this._entries)if(b._score=(0,I.score)(b.selector,g.uri,g.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(g)),P(b.selector)&&b._score>0){for(let u of this._entries)u._score=0;b._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(g,k){return g._score<k._score?1:g._score>k._score?-1:g._time<k._time?1:g._time>k._time?-1:0}}e.LanguageFeatureRegistry=t;const y=new WeakMap;let n=0;function d(a){let g=y.get(a);return g===void 0&&(g=++n,y.set(a,g)),g}class o{constructor(g,k,b=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=k,this.max=b,this._cache=new A.LRUCache(50,.7)}_key(g){return g.id+this._registry.all(g).reduce((k,b)=>(0,F.doHash)(d(b),k),0)}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const k=this._key(g),b=this._cache.get(k);return this._clamp(b?.value)}update(g,k){const b=this._key(g);let u=this._cache.get(b);return u||(u=new T.MovingAverage,this._cache.set(b,u)),u.update(k),this.get(g)}}e.LanguageFeatureRequestDelays=o}),define(ve[58],we([0,1,2,41,138,113,34]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class S{constructor(E,h){this.language=E,this.id=h}}e.LanguageIdentifier=S;var P;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var y;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(y=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let h=this.getForeground(E),M="mtk"+h,O=this.getFontStyle(E);return O&1&&(M+=" mtki"),O&2&&(M+=" mtkb"),O&4&&(M+=" mtku"),M}static getInlineStyleFromMetadata(E,h){const M=this.getForeground(E),O=this.getFontStyle(E);let q=`color: ${h[M]};`;return O&1&&(q+="font-style: italic;"),O&2&&(q+="font-weight: bold;"),O&4&&(q+="text-decoration: underline;"),q}}e.TokenMetadata=d;var o;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(E){const h=f[E];let M=h&&T.iconRegistry.get(h);return M||(console.info("No codicon found for CompletionItemKind "+E),M=T.Codicon.symbolProperty),M.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(E,h){let M=f[E];return typeof M=="undefined"&&!h&&(M=9),M}}();var a;(function(f){f[f.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(f){f[f.Automatic=0]="Automatic",f[f.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var D;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(f){return f&&c.URI.isUri(f.uri)&&F.Range.isIRange(f.range)&&(F.Range.isIRange(f.originSelectionRange)||F.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=i;var r;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var l;(function(f){f[f.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var s;(function(f){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const h=new Map;h.set(0,"file"),h.set(1,"module"),h.set(2,"namespace"),h.set(3,"package"),h.set(4,"class"),h.set(5,"method"),h.set(6,"property"),h.set(7,"field"),h.set(8,"constructor"),h.set(9,"enum"),h.set(10,"interface"),h.set(11,"function"),h.set(12,"variable"),h.set(13,"constant"),h.set(14,"string"),h.set(15,"number"),h.set(16,"boolean"),h.set(17,"array"),h.set(18,"object"),h.set(19,"key"),h.set(20,"null"),h.set(21,"enum-member"),h.set(22,"struct"),h.set(23,"event"),h.set(24,"operator"),h.set(25,"type-parameter");function M(Q){return E.get(Q)}f.fromString=M;function O(Q){return h.get(Q)}f.toString=O;function q(Q,$){const z=h.get(Q);let N=z&&T.iconRegistry.get("symbol-"+z);return N||(console.info("No codicon found for SymbolKind "+Q),N=T.Codicon.symbolProperty),`${$?"inline":"block"} ${N.classNames}`}f.toCssClassName=q})(s=e.SymbolKinds||(e.SymbolKinds={}));class m{constructor(E){this.value=E}}e.FoldingRangeKind=m,m.Comment=new m("comment"),m.Imports=new m("imports"),m.Region=new m("region");var v;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var C;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(C=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new _.LanguageFeatureRegistry,e.RenameProviderRegistry=new _.LanguageFeatureRegistry,e.CompletionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new _.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new _.LanguageFeatureRegistry,e.HoverProviderRegistry=new _.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new _.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new _.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new _.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new _.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new _.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.LinkProviderRegistry=new _.LanguageFeatureRegistry,e.ColorProviderRegistry=new _.LanguageFeatureRegistry,e.SelectionRangeRegistry=new _.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var R;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[42],we([0,1,25,9,4]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=c.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",c.isMacintosh),T.set("isLinux",c.isLinux),T.set("isWindows",c.isWindows),T.set("isWeb",c.isWeb),T.set("isMacNative",c.isMacintosh&&!c.isWeb),T.set("isEdge",A.indexOf("Edg/")>=0),T.set("isFirefox",A.indexOf("Firefox")>=0),T.set("isChrome",A.indexOf("Chrome")>=0),T.set("isSafari",A.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return y.INSTANCE}static true(){return n.INSTANCE}static has(h){return d.create(h)}static equals(h,M){return o.create(h,M)}static notEquals(h,M){return k.create(h,M)}static regex(h,M){return r.create(h,M)}static in(h,M){return a.create(h,M)}static not(h){return b.create(h)}static and(...h){return s.create(h,null)}static or(...h){return m.create(h,null,!0)}static greater(h,M){return u.create(h,M)}static less(h,M){return D.create(h,M)}static deserialize(h,M=!1){if(!!h)return this._deserializeOrExpression(h,M)}static _deserializeOrExpression(h,M){let O=h.split("||");return m.create(O.map(q=>this._deserializeAndExpression(q,M)),null,!0)}static _deserializeAndExpression(h,M){let O=h.split("&&");return s.create(O.map(q=>this._deserializeOne(q,M)),null)}static _deserializeOne(h,M){if(h=h.trim(),h.indexOf("!=")>=0){let O=h.split("!=");return k.create(O[0].trim(),this._deserializeValue(O[1],M))}if(h.indexOf("==")>=0){let O=h.split("==");return o.create(O[0].trim(),this._deserializeValue(O[1],M))}if(h.indexOf("=~")>=0){let O=h.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],M))}if(h.indexOf(" in ")>=0){let O=h.split(" in ");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const O=h.split(">=");return p.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const O=h.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const O=h.split("<=");return i.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const O=h.split("<");return D.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(h)?b.create(h.substr(1).trim()):d.create(h)}static _deserializeValue(h,M){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let O=/^'([^']*)'$/.exec(h);return O?O[1].trim():h}static _deserializeRegexValue(h,M){if((0,F.isFalsyOrWhitespace)(h)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=h.indexOf("/"),q=h.lastIndexOf("/");if(O===q||O<0){if(M)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let Q=h.slice(O+1,q),$=h[q+1]==="i"?"i":"";try{return new RegExp(Q,$)}catch(z){if(M)throw new Error(`bad regexp-value '${h}', parse error: ${z}`);return console.warn(`bad regexp-value '${h}', parse error: ${z}`),null}}}e.ContextKeyExpr=P;function t(E,h){return E.cmp(h)}class y{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class n{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class d{constructor(h,M){this.key=h,this.negated=M,this.type=2}static create(h,M=null){const O=T.get(h);return typeof O=="boolean"?O?n.INSTANCE:y.INSTANCE:new d(h,M)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class o{constructor(h,M,O){this.key=h,this.value=M,this.negated=O,this.type=4}static create(h,M,O=null){if(typeof M=="boolean")return M?d.create(h,O):b.create(h,O);const q=T.get(h);return typeof q=="boolean"?M===(q?"true":"false")?n.INSTANCE:y.INSTANCE:new o(h,M,O)}cmp(h){return h.type!==this.type?this.type-h.type:C(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=o;class a{constructor(h,M){this.key=h,this.valueKey=M,this.type=10,this.negated=null}static create(h,M){return new a(h,M)}cmp(h){return h.type!==this.type?this.type-h.type:C(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const M=h.getValue(this.valueKey),O=h.getValue(this.key);return Array.isArray(M)?M.indexOf(O)>=0:typeof O=="string"&&typeof M=="object"&&M!==null?I.call(M,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=a;class g{constructor(h){this._actual=h,this.type=11}static create(h){return new g(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new g(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class k{constructor(h,M,O){this.key=h,this.value=M,this.negated=O,this.type=5}static create(h,M,O=null){if(typeof M=="boolean")return M?b.create(h,O):d.create(h,O);const q=T.get(h);return typeof q=="boolean"?M===(q?"true":"false")?y.INSTANCE:n.INSTANCE:new k(h,M,O)}cmp(h){return h.type!==this.type?this.type-h.type:C(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class b{constructor(h,M){this.key=h,this.negated=M,this.type=3}static create(h,M=null){const O=T.get(h);return typeof O=="boolean"?O?y.INSTANCE:n.INSTANCE:new b(h,M)}cmp(h){return h.type!==this.type?this.type-h.type:w(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;class u{constructor(h,M,O){this.key=h,this.value=M,this.negated=O,this.type=12}static create(h,M,O=null){return new u(h,M,O)}cmp(h){return h.type!==this.type?this.type-h.type:C(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class p{constructor(h,M,O){this.key=h,this.value=M,this.negated=O,this.type=13}static create(h,M,O=null){return new p(h,M,O)}cmp(h){return h.type!==this.type?this.type-h.type:C(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=p;class D{constructor(h,M,O){this.key=h,this.value=M,this.negated=O,this.type=14}static create(h,M,O=null){return new D(h,M,O)}cmp(h){return h.type!==this.type?this.type-h.type:C(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=D;class i{constructor(h,M,O){this.key=h,this.value=M,this.negated=O,this.type=15}static create(h,M,O=null){return new i(h,M,O)}cmp(h){return h.type!==this.type?this.type-h.type:C(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class r{constructor(h,M){this.key=h,this.regexp=M,this.type=7,this.negated=null}static create(h,M){return new r(h,M)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const M=this.regexp?this.regexp.source:"",O=h.regexp?h.regexp.source:"";return M<O?-1:M>O?1:0}equals(h){if(h.type===this.type){const M=this.regexp?this.regexp.source:"",O=h.regexp?h.regexp.source:"";return this.key===h.key&&M===O}return!1}evaluate(h){let M=h.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class l{constructor(h){this._actual=h,this.type=8}static create(h){return new l(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new l(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;class s{constructor(h,M){this.expr=h,this.negated=M,this.type=6}static create(h,M){return s._normalizeArr(h,M)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let M=0,O=this.expr.length;M<O;M++){const q=t(this.expr[M],h.expr[M]);if(q!==0)return q}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let M=0,O=this.expr.length;M<O;M++)if(!this.expr[M].equals(h.expr[M]))return!1;return!0}return!1}evaluate(h){for(let M=0,O=this.expr.length;M<O;M++)if(!this.expr[M].evaluate(h))return!1;return!0}static _normalizeArr(h,M){const O=[];let q=!1;for(const Q of h)if(!!Q){if(Q.type===1){q=!0;continue}if(Q.type===0)return y.INSTANCE;if(Q.type===6){O.push(...Q.expr);continue}O.push(Q)}if(O.length===0&&q)return n.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(t);for(let Q=1;Q<O.length;Q++)O[Q-1].equals(O[Q])&&(O.splice(Q,1),Q--);if(O.length===1)return O[0];for(;O.length>1;){const Q=O[O.length-1];if(Q.type!==9)break;O.pop();const $=O.pop(),z=O.length===0,N=m.create(Q.expr.map(W=>s.create([W,$],null)),null,z);N&&(O.push(N),O.sort(t))}return O.length===1?O[0]:new s(O,M)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let M of this.expr)h.push(...M.keys());return h}map(h){return new s(this.expr.map(M=>M.map(h)),null)}negate(){if(!this.negated){const h=[];for(let M of this.expr)h.push(M.negate());this.negated=m.create(h,this,!0)}return this.negated}}class m{constructor(h,M){this.expr=h,this.negated=M,this.type=9}static create(h,M,O){return m._normalizeArr(h,M,O)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let M=0,O=this.expr.length;M<O;M++){const q=t(this.expr[M],h.expr[M]);if(q!==0)return q}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let M=0,O=this.expr.length;M<O;M++)if(!this.expr[M].equals(h.expr[M]))return!1;return!0}return!1}evaluate(h){for(let M=0,O=this.expr.length;M<O;M++)if(this.expr[M].evaluate(h))return!0;return!1}static _normalizeArr(h,M,O){let q=[],Q=!1;if(h){for(let $=0,z=h.length;$<z;$++){const N=h[$];if(!!N){if(N.type===0){Q=!0;continue}if(N.type===1)return n.INSTANCE;if(N.type===9){q=q.concat(N.expr);continue}q.push(N)}}if(q.length===0&&Q)return y.INSTANCE;q.sort(t)}if(q.length!==0){if(q.length===1)return q[0];for(let $=1;$<q.length;$++)q[$-1].equals(q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0];if(O){for(let $=0;$<q.length;$++)for(let z=$+1;z<q.length;z++)R(q[$],q[z])&&(q.splice(z,1),z--);if(q.length===1)return q[0]}return new m(q,M)}}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let M of this.expr)h.push(...M.keys());return h}map(h){return new m(this.expr.map(M=>M.map(h)),null)}negate(){if(!this.negated){let h=[];for(let M of this.expr)h.push(M.negate());for(;h.length>1;){const M=h.shift(),O=h.shift(),q=[];for(const $ of f(M))for(const z of f(O))q.push(s.create([$,z],null));const Q=h.length===0;h.unshift(m.create(q,null,Q))}this.negated=h[0]}return this.negated}}class v extends d{constructor(h,M,O){super(h,null);this._defaultValue=M,typeof O=="object"?v._info.push({...O,key:h}):O!==!0&&v._info.push({key:h,description:O,type:M!=null?typeof M:void 0})}static all(){return v._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(h){return o.create(this.key,h)}notEqualsTo(h){return k.create(this.key,h)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(E,h){return E<h?-1:E>h?1:0}function C(E,h,M,O){return E<M?-1:E>M?1:h<O?-1:h>O?1:0}function R(E,h){if(h.type===6&&E.type!==9&&E.type!==6){for(const q of h.expr)if(E.equals(q))return!0}const M=E.negate(),O=f(M).concat(f(h));O.sort(t);for(let q=0;q<O.length;q++){const $=O[q].negate();for(let z=q+1;z<O.length;z++){const N=O[z];if($.equals(N))return!0}}return!1}e.implies=R;function f(E){return E.type===9?E.expr:[E]}}),define(ve[139],we([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[26],we([0,1,9,4]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=_;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class I{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,n){if(typeof y=="undefined"||y===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof y=="string"||typeof n=="string"){let d=typeof y=="string"?y:y.value,o=typeof n=="string"?n:n.value;return c.equalsIgnoreCase(d,o)}return y._lower===n._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=I;function S(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[140],we([0,1,9,26]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(o,a){return o.uuid&&a.uuid?o.uuid===a.uuid:o.id===a.id?!0:(0,c.compareIgnoreCase)(o.id,a.id)===0}e.areSameExtensions=_;class A{constructor(a,g){this.version=g,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof A?_(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=A;function T(o,a){return`${o}.${a}`}e.getExtensionId=T;function I(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function S(o,a){return I(T(o,a))}e.getGalleryExtensionId=S;function P(o,a){const g=[],k=b=>{for(const u of g)if(u.some(p=>_(a(p),a(b))))return u;return null};for(const b of o){const u=k(b);u?u.push(b):g.push([b])}return g}e.groupByExtension=P;function t(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function y(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function n(o){const a=new Set;for(const g of o)g.malicious&&a.add(g.id.id);return a}e.getMaliciousExtensionsSet=n;function d(o,a){const g=[],k=a.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const b=k.shift();if(b&&g.every(u=>!_(u.identifier,{id:b}))){const u=o.filter(p=>_(p.identifier,{id:b}));u.length===1&&(g.push(u[0]),k.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=d}),define(ve[59],we([0,1,20,17,9,10,2,118,4]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function P($){return $.create===!0}e.isFileOpenForWriteOptions=P;var t;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var y;(function($){$[$.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var n;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d($){return!!($.capabilities&2)}e.hasReadWriteCapability=d;function o($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=o;function a($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function g($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=g;var k;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,N){super(z);this.code=N}}e.FileSystemProviderError=b;function u($,z){const N=new b($.toString(),z);return D(N,z),N}e.createFileSystemProviderError=u;function p($){return $||u((0,I.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=p;function D($,z){return $.name=z?`${z} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=D;function i($){if(!$)return k.Unknown;if($ instanceof b)return $.code;const z=/^(.+) \(FileSystemError\)$/.exec($.name);if(!z)return k.Unknown;switch(z[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=i;function r($){if($ instanceof C)return $.fileOperationResult;switch(i($)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var l;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(l=e.FileOperation||(e.FileOperation={}));class s{constructor(z,N,W){this.resource=z,this.operation=N,this.target=W}isOperation(z){return this.operation===z}}e.FileOperationEvent=s;var m;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class v{constructor(z,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const W of z)switch(W.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(()=>N)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(()=>N)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(()=>N)),this.deleted.set(W.resource,W);break}}contains(z,...N){return this.doContains(z,{includeChildren:!1},...N)}affects(z,...N){return this.doContains(z,{includeChildren:!0},...N)}doContains(z,N,...W){if(!z)return!1;const j=W.length>0;return!!((!j||W.includes(1))&&(this.added?.get(z)||N.includeChildren&&this.added?.findSuperstr(z))||(!j||W.includes(0))&&(this.updated?.get(z)||N.includeChildren&&this.updated?.findSuperstr(z))||(!j||W.includes(2))&&(this.deleted?.findSubstr(z)||N.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function w($,z,N){return!$||!z||$===z||z.length>$.length?!1:(z.charAt(z.length-1)!==F.sep&&(z+=F.sep),N?(0,_.startsWithIgnoreCase)($,z):$.indexOf(z)===0)}e.isParent=w;class C extends Error{constructor(z,N,W){super(z);this.fileOperationResult=N,this.options=W}}e.FileOperationError=C;class R extends C{constructor(z,N,W){super(z,2,W);this.stat=N}}e.NotModifiedSinceFileOperationError=R;var f;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(f=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var E;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(E=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=h;async function M($,z){if(!z.canHandleResource(T.URI.from({scheme:$.scheme})))return new Promise(N=>{const W=z.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===$.scheme&&j.added&&(W.dispose(),N())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(z){return(0,A.isNumber)(z)||(z=0),z<O.KB?(0,I.localize)(1,null,z.toFixed(0)):z<O.MB?(0,I.localize)(2,null,(z/O.KB).toFixed(2)):z<O.GB?(0,I.localize)(3,null,(z/O.MB).toFixed(2)):z<O.TB?(0,I.localize)(4,null,(z/O.GB).toFixed(2)):(0,I.localize)(5,null,(z/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var q;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function Q($){return{maxFileSize:$===0?300*O.MB:16*O.GB,maxHeapSize:$===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=Q}),define(ve[60],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(..._){this._entries=new Map;for(let[A,T]of _)this.set(A,T)}set(_,A){const T=this._entries.get(_);return this._entries.set(_,A),T}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=c}),define(ve[141],we([0,1,13,15,82,136,4,60]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class P extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class t{constructor(o=new I.ServiceCollection,a=!1,g){this._activeInstantiations=new Set,this._services=o,this._strict=a,this._parent=g,this._services.set(T.IInstantiationService,this)}createChild(o){return new t(o,this._strict,this)}invokeFunction(o,...a){let g=n.traceInvocation(o),k=!1;try{return o({get:(u,p)=>{if(k)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const D=this._getOrCreateServiceInstance(u,g);if(!D&&p!==T.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return D}},...a)}finally{k=!0,g.stop()}}createInstance(o,...a){let g,k;return o instanceof _.SyncDescriptor?(g=n.traceCreation(o.ctor),k=this._createInstance(o.ctor,o.staticArguments.concat(a),g)):(g=n.traceCreation(o),k=this._createInstance(o,a,g)),g.stop(),k}_createInstance(o,a=[],g){let k=T._util.getServiceDependencies(o).sort((p,D)=>p.index-D.index),b=[];for(const p of k){let D=this._getOrCreateServiceInstance(p.id,g);if(!D&&this._strict&&!p.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${p.id}.`);b.push(D)}let u=k.length>0?k[0].index:a.length;if(a.length!==u){console.warn(`[createInstance] First service dependency of ${o.name} at position ${u+1} conflicts with ${a.length} static arguments`);let p=u-a.length;p>0?a=a.concat(new Array(p)):a=a.slice(0,u)}return new o(...[...a,...b])}_setServiceInstance(o,a){if(this._services.get(o)instanceof _.SyncDescriptor)this._services.set(o,a);else if(this._parent)this._parent._setServiceInstance(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let a=this._services.get(o);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):a}_getOrCreateServiceInstance(o,a){let g=this._getServiceInstanceOrDescriptor(o);return g instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,g,a.branch(o,!0)):(a.branch(o,!1),g)}_safeCreateAndCacheServiceInstance(o,a,g){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,a,g)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,a,g){const k=new A.Graph(p=>p.id.toString());let b=0;const u=[{id:o,desc:a,_trace:g}];for(;u.length;){const p=u.pop();if(k.lookupOrInsertNode(p),b++>1e3)throw new P(k);for(let D of T._util.getServiceDependencies(p.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(D.id);if(!i&&!D.optional&&console.warn(`[createInstance] ${o} depends on ${D.id} which is NOT registered.`),i instanceof _.SyncDescriptor){const r={id:D.id,desc:i,_trace:p._trace.branch(D.id,!0)};k.insertEdge(p,r),u.push(r)}}}for(;;){const p=k.roots();if(p.length===0){if(!k.isEmpty())throw new P(k);break}for(const{data:D}of p){if(this._getServiceInstanceOrDescriptor(D.id)instanceof _.SyncDescriptor){const r=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,r)}k.removeNode(D)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,a,g=[],k,b){if(this._services.get(o)instanceof _.SyncDescriptor)return this._createServiceInstance(a,g,k,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,a,g,k,b);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(o,a=[],g,k){if(g){const b=new c.IdleValue(()=>this._createInstance(o,a,k));return new Proxy(Object.create(null),{get(u,p){if(p in u)return u[p];let D=b.value,i=D[p];return typeof i!="function"||(i=i.bind(D),u[p]=i),i},set(u,p,D){return b.value[p]=D,!0}})}else return this._createInstance(o,a,k)}}e.InstantiationService=t;var y;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(y||(y={}));class n{constructor(o,a){this.type=o,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return S?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return S?new n(0,o.name):n._None}branch(o,a){let g=new n(2,o.toString());return this._dep.push([o,a,g]),g}stop(){let o=Date.now()-this._start;n._totals+=o;let a=!1;function g(b,u){let p=[],D=new Array(b+1).join("	");for(const[i,r,l]of u._dep)if(r&&l){a=!0,p.push(`${D}CREATES -> ${i}`);let s=g(b+1,l);s&&p.push(s)}else p.push(`${D}uses -> ${i}`);return p.join(`
`)}let k=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||a)&&console.log(k.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(ve[14],we([0,1,55,3,7,25,4]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function I(){return new Date().toISOString()}var S;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class P extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([i,...r]))}debug(i,...r){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([i,...r]))}info(i,...r){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([i,...r]))}warn(i,...r){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([i,...r]))}error(i,...r){if(this.checkLogLevel(S.Error))if(i instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=i.stack,this.log(S.Error,this.format(l))}else this.log(S.Error,this.format([i,...r]))}critical(i,...r){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([i,...r]))}flush(){}format(i){let r="";for(let l=0;l<i.length;l++){let s=i[l];if(typeof s=="object")try{s=JSON.stringify(s)}catch(m){}r+=(l>0?" ":"")+s}return r}}e.AbstractMessageLogger=t;class y extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...r){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...r):console.log(`[main ${I()}]`,i,...r))}debug(i,...r){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...r):console.log(`[main ${I()}]`,i,...r))}info(i,...r){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...r):console.log(`[main ${I()}]`,i,...r))}warn(i,...r){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...r):console.warn(`[main ${I()}]`,i,...r))}error(i,...r){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...r):console.error(`[main ${I()}]`,i,...r))}critical(i,...r){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...r):console.error(`[main ${I()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...r){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=n;class d extends P{constructor(i,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,c.toErrorMessage)(i,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class o extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const l of this.logServices)l.trace(i,...r)}debug(i,...r){for(const l of this.logServices)l.debug(i,...r)}info(i,...r){for(const l of this.logServices)l.info(i,...r)}warn(i,...r){for(const l of this.logServices)l.warn(i,...r)}error(i,...r){for(const l of this.logServices)l.error(i,...r)}critical(i,...r){for(const l of this.logServices)l.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=o;class a extends _.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=a;class g extends _.Disposable{constructor(i,r){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(l=>{this.logLevel=l,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(l))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let l=this.loggers.get(i.toString());return l||(l=this.doCreateLogger(i,r?.always?S.Trace:this.logLevel,r),this.loggers.set(i.toString(),l),r?.always||this.logLevelChangeableLoggers.push(l)),l}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class k{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(i){}getLevel(){return S.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=k;function b(D){if(D.verbose)return S.Trace;if(typeof D.logLevel=="string"){const i=u(D.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function u(D){switch(D){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=u;function p(D){switch(D){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=p}),define(ve[83],we([0,1,35,119,4]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var T;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function P(o,a){return a-o}S.compare=P;const t=Object.create(null);t[S.Error]=(0,F.localize)(0,null),t[S.Warning]=(0,F.localize)(1,null),t[S.Info]=(0,F.localize)(2,null);function y(o){return t[o]||""}S.toString=y;function n(o){switch(o){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=n;function d(o){switch(o){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=d}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(S){const P="";function t(n){return y(n,!0)}S.makeKey=t;function y(n,d){let o=[P];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(P),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(P),n.severity!==void 0&&n.severity!==null?o.push(T.toString(n.severity)):o.push(P),n.message&&d?o.push(n.message.replace("\xA6","\\\xA6")):o.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(P),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(P),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(P),o.push(P),o.join("\xA6")}S.makeKeyOptionalMessage=y})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ve[142],we([0,1,3,35,4]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,_.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=I;class S{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=S}),define(ve[143],we([0,1,7,9,2,4]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function T(I,S){return _.URI.isUri(I)?(0,F.equalsIgnoreCase)(I.scheme,S):(0,F.startsWithIgnoreCase)(I,S+":")}e.matchesScheme=T}),define(ve[144],we([0,1,11,25,61,24]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof F.globals.vscode!="undefined"&&typeof F.globals.vscode.context!="undefined"){const I=F.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ne?.__$__nodeRequire=="function"){const I=(0,A.dirname)(c.FileAccess.asFileUri("",ne));T=ne.__$__nodeRequire((0,A.joinPath)(I,"product.json").fsPath);const S=ne.__$__nodeRequire((0,A.joinPath)(I,"package.json").fsPath);_.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:S.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.60.0-dev",nameShort:F.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:F.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(ve[145],we([0,1,115,25,146,144]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=I;class S{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,me){this._values[J]=me}}e.ValidatedEditorOptions=S;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class t{constructor(J,me,Ne,Ye){this.id=J,this.name=me,this.defaultValue=Ne,this.schema=Ye}compute(J,me,Ne){return Ne}}class y{constructor(J,me=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(J){return this.defaultValue}}class n{constructor(J,me,Ne,Ye){this.id=J,this.name=me,this.defaultValue=Ne,this.schema=Ye}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,me,Ne){return Ne}}function d(H,J){return typeof H=="undefined"?J:H==="false"?!1:Boolean(H)}e.boolean=d;class o extends n{constructor(J,me,Ne,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ne),super(J,me,Ne,Ye)}validate(J){return d(J,this.defaultValue)}}class a extends n{constructor(J,me,Ne,Ye,tt,at=void 0){typeof at!="undefined"&&(at.type="integer",at.default=Ne,at.minimum=Ye,at.maximum=tt),super(J,me,Ne,at),this.minimum=Ye,this.maximum=tt}static clampedInt(J,me,Ne,Ye){if(typeof J=="undefined")return me;let tt=parseInt(J,10);return isNaN(tt)?me:(tt=Math.max(Ne,tt),tt=Math.min(Ye,tt),tt|0)}validate(J){return a.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class g extends n{constructor(J,me,Ne,Ye,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Ne),super(J,me,Ne,tt),this.validationFn=Ye}static clamp(J,me,Ne){return J<me?me:J>Ne?Ne:J}static float(J,me){if(typeof J=="number")return J;if(typeof J=="undefined")return me;const Ne=parseFloat(J);return isNaN(Ne)?me:Ne}validate(J){return this.validationFn(g.float(J,this.defaultValue))}}class k extends n{static string(J,me){return typeof J!="string"?me:J}constructor(J,me,Ne,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ne),super(J,me,Ne,Ye)}validate(J){return k.string(J,this.defaultValue)}}function b(H,J,me){return typeof H!="string"||me.indexOf(H)===-1?J:H}e.stringSet=b;class u extends n{constructor(J,me,Ne,Ye,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ye,tt.default=Ne),super(J,me,Ne,tt),this._allowedValues=Ye}validate(J){return b(J,this.defaultValue,this._allowedValues)}}class p extends t{constructor(J,me,Ne,Ye,tt,at,vt=void 0){typeof vt!="undefined"&&(vt.type="string",vt.enum=tt,vt.default=Ye),super(J,me,Ne,vt),this._allowedValues=tt,this._convert=at}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function D(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends t{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,me,Ne){return Ne===0?J.accessibilitySupport:Ne}}class r extends t{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertSpace:d(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function v(H){switch(H){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function w(H){switch(H){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class C extends y{constructor(){super(127,[65,32])}compute(J,me,Ne){const Ye=["monaco-editor"];return me.get(32)&&Ye.push(me.get(32)),J.extraEditorClassName&&Ye.push(J.extraEditorClassName),me.get(65)==="default"?Ye.push("mouse-default"):me.get(65)==="copy"&&Ye.push("mouse-copy"),me.get(100)&&Ye.push("showUnused"),me.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class R extends o{constructor(){super(31,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,me,Ne){return Ne&&J.emptySelectionClipboard}}class f extends t{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{cursorMoveOnType:d(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":b(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(me.loop,this.defaultValue.loop)}}}class E extends t{constructor(){super(43,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?E.OFF:J==="true"?E.ON:J:Boolean(J)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class h extends y{constructor(){super(42)}compute(J,me,Ne){return J.fontInfo}}class M extends n{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let me=g.float(J,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(me,6,100)}compute(J,me,Ne){return J.fontInfo.fontSize}}class O extends t{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.MINIMUM_VALUE,maximum:O.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(a.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,O.MINIMUM_VALUE,O.MAXIMUM_VALUE))}}O.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],O.MINIMUM_VALUE=1,O.MAXIMUM_VALUE=1e3;class q extends t{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ne,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ne,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ne,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ne,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ne,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{multiple:b(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??b(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??b(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??b(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??b(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??b(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:k.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:k.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:k.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:k.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:k.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Q extends t{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:d(me.enabled,this.defaultValue.enabled),delay:a.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:d(me.sticky,this.defaultValue.sticky)}}}var $;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})($=e.RenderMinimap||(e.RenderMinimap={}));class z extends y{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(J,me,Ne){return z.computeLayout(me,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const me=J.height/J.lineHeight,Ne=J.scrollBeyondLastLine?me-1:0,Ye=(J.viewLineCount+Ne)/(J.pixelRatio*J.height),tt=Math.floor(J.viewLineCount/Ye);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Ne,desiredRatio:Ye,minimapLineCount:tt}}static _computeMinimapLayout(J,me){const Ne=J.outerWidth,Ye=J.outerHeight,tt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const at=me.stableMinimapLayoutInput,vt=at&&J.outerHeight===at.outerHeight&&J.lineHeight===at.lineHeight&&J.typicalHalfwidthCharacterWidth===at.typicalHalfwidthCharacterWidth&&J.pixelRatio===at.pixelRatio&&J.scrollBeyondLastLine===at.scrollBeyondLastLine&&J.minimap.enabled===at.minimap.enabled&&J.minimap.side===at.minimap.side&&J.minimap.size===at.minimap.size&&J.minimap.showSlider===at.minimap.showSlider&&J.minimap.renderCharacters===at.minimap.renderCharacters&&J.minimap.maxColumn===at.minimap.maxColumn&&J.minimap.scale===at.minimap.scale&&J.verticalScrollbarWidth===at.verticalScrollbarWidth&&J.isViewportWrapping===at.isViewportWrapping,kt=J.lineHeight,ht=J.typicalHalfwidthCharacterWidth,yt=J.scrollBeyondLastLine,It=J.minimap.renderCharacters;let ft=tt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Je=J.minimap.maxColumn,Et=J.minimap.size,Pe=J.minimap.side,ye=J.verticalScrollbarWidth,De=J.viewLineCount,Z=J.remainingWidth,le=J.isViewportWrapping,ge=It?2:3;let fe=Math.floor(tt*Ye);const Ie=fe/tt;let xe=!1,Le=!1,Ve=ge*ft,Xe=ft/tt,ie=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:We,extraLinesBeyondLastLine:it,desiredRatio:mt,minimapLineCount:wt}=z.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:yt,height:Ye,lineHeight:kt,pixelRatio:tt});if(De/wt>1)xe=!0,Le=!0,ft=1,Ve=1,Xe=ft/tt;else{let ct=!1,lt=ft+1;if(Et==="fit"){const Tt=Math.ceil((De+it)*Ve);le&&vt&&Z<=me.stableFitRemainingWidth?(ct=!0,lt=me.stableFitMaxMinimapScale):ct=Tt>fe}if(Et==="fill"||ct){xe=!0;const Tt=ft;Ve=Math.min(kt*tt,Math.max(1,Math.floor(1/mt))),le&&vt&&Z<=me.stableFitRemainingWidth&&(lt=me.stableFitMaxMinimapScale),ft=Math.min(lt,Math.max(1,Math.floor(Ve/ge))),ft>Tt&&(ie=Math.min(2,ft/Tt)),Xe=ft/tt/ie,fe=Math.ceil(Math.max(We,De+it)*Ve),le?(me.stableMinimapLayoutInput=J,me.stableFitRemainingWidth=Z,me.stableFitMaxMinimapScale=ft):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const pe=Math.floor(Je*Xe),re=Math.min(pe,Math.max(0,Math.floor((Z-ye-2)*Xe/(ht+Xe)))+e.MINIMAP_GUTTER_WIDTH);let B=Math.floor(tt*re);const Ce=B/tt;B=Math.floor(B*ie);const Se=It?1:2,qe=Pe==="left"?0:Ne-re-ye;return{renderMinimap:Se,minimapLeft:qe,minimapWidth:re,minimapHeightIsEditorHeight:xe,minimapIsSampling:Le,minimapScale:ft,minimapLineHeight:Ve,minimapCanvasInnerWidth:B,minimapCanvasInnerHeight:fe,minimapCanvasOuterWidth:Ce,minimapCanvasOuterHeight:Ie}}static computeLayout(J,me){const Ne=me.outerWidth|0,Ye=me.outerHeight|0,tt=me.lineHeight|0,at=me.lineNumbersDigitCount|0,vt=me.typicalHalfwidthCharacterWidth,kt=me.maxDigitWidth,ht=me.pixelRatio,yt=me.viewLineCount,It=J.get(122),ft=It==="inherit"?J.get(121):It,Je=ft==="inherit"?J.get(117):ft,Et=J.get(120),Pe=J.get(2),ye=me.isDominatedByLongLines,De=J.get(48),Z=J.get(59).renderType!==0,le=J.get(60),ge=J.get(94),fe=J.get(64),Ie=J.get(92),xe=Ie.verticalScrollbarSize,Le=Ie.verticalHasArrows,Ve=Ie.arrowSize,Xe=Ie.horizontalScrollbarSize,ie=J.get(57),pe=J.get(36);let re;if(typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)){const Bt=parseFloat(ie.substr(0,ie.length-2));re=a.clampedInt(Bt*vt,0,0,1e3)}else re=a.clampedInt(ie,0,0,1e3);pe&&(re+=16);let B=0;if(Z){const Bt=Math.max(at,le);B=Math.round(Bt*kt)}let Ce=0;De&&(Ce=tt);let Se=0,qe=Se+Ce,We=qe+B,it=We+re;const mt=Ne-Ce-B-re;let wt=!1,ot=!1,ct=-1;Pe!==2&&(ft==="inherit"&&ye?(wt=!0,ot=!0):Je==="on"||Je==="bounded"?ot=!0:Je==="wordWrapColumn"&&(ct=Et));const lt=z._computeMinimapLayout({outerWidth:Ne,outerHeight:Ye,lineHeight:tt,typicalHalfwidthCharacterWidth:vt,pixelRatio:ht,scrollBeyondLastLine:ge,minimap:fe,verticalScrollbarWidth:xe,viewLineCount:yt,remainingWidth:mt,isViewportWrapping:ot},me.memory||new P);lt.renderMinimap!==0&&lt.minimapLeft===0&&(Se+=lt.minimapWidth,qe+=lt.minimapWidth,We+=lt.minimapWidth,it+=lt.minimapWidth);const Tt=mt-lt.minimapWidth,_t=Math.max(1,Math.floor((Tt-xe-2)/vt)),Ut=Le?Ve:0;return ot&&(ct=Math.max(1,_t),Je==="bounded"&&(ct=Math.min(ct,Et))),{width:Ne,height:Ye,glyphMarginLeft:Se,glyphMarginWidth:Ce,lineNumbersLeft:qe,lineNumbersWidth:B,decorationsLeft:We,decorationsWidth:re,contentLeft:it,contentWidth:Tt,minimap:lt,viewportColumn:_t,isWordWrapMinified:wt,isViewportWrapping:ot,wrappingColumn:ct,verticalScrollbarWidth:xe,horizontalScrollbarHeight:Xe,overviewRuler:{top:Ut,width:xe,height:Ye-2*Ut,right:0}}}}e.EditorLayoutInfoComputer=z;class N extends t{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:d(J.enabled,this.defaultValue.enabled)}}}class W extends t{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,description:c.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:d(me.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:k.string(me.fontFamily,this.defaultValue.fontFamily)}}}class j extends g{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>g.clamp(J,0,150),{markdownDescription:c.localize(46,null)})}compute(J,me,Ne){return J.fontInfo.lineHeight}}class Y extends t{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(48,null),c.localize(49,null),c.localize(50,null)],default:J.size,description:c.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:d(me.enabled,this.defaultValue.enabled),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(me.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(me.scale,1,1,3),maxColumn:a.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(H){return H==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends t{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{top:a.clampedInt(me.top,0,0,1e3),bottom:a.clampedInt(me.bottom,0,0,1e3)}}}class ue extends t{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:d(me.enabled,this.defaultValue.enabled),cycle:d(me.cycle,this.defaultValue.cycle)}}}class oe extends y{constructor(){super(128)}compute(J,me,Ne){return J.pixelRatio}}class be extends t{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(61,null)},comments:{type:"boolean",default:J.comments,description:c.localize(62,null)},other:{type:"boolean",default:J.other,description:c.localize(63,null)}}}],default:J,description:c.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const me=J,Ne={other:d(me.other,this.defaultValue.other),comments:d(me.comments,this.defaultValue.comments),strings:d(me.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Ae;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends t{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(65,null),c.localize(66,null),c.localize(67,null),c.localize(68,null)],default:"on",description:c.localize(69,null)})}validate(J){let me=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(me=4,Ne=J):J==="interval"?me=3:J==="relative"?me=2:J==="on"?me=1:me=0),{renderType:me,renderFn:Ne}}}function Oe(H){const J=H.get(87);return J==="editable"?H.get(80):J!=="on"}e.filterValidationDecorations=Oe;class Qe extends t{constructor(){const J=[],me={type:"number",description:c.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:c.localize(71,null),format:"color-hex"}}}]},default:J,description:c.localize(72,null)})}validate(J){if(Array.isArray(J)){let me=[];for(let Ne of J)if(typeof Ne=="number")me.push({column:a.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ye=Ne;me.push({column:a.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return me.sort((Ne,Ye)=>Ne.column-Ye.column),me}return this.defaultValue}}function He(H,J){if(typeof H!="string")return J;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class je extends t{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)],default:"auto",description:c.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)],default:"auto",description:c.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J,Ne=a.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=a.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:He(me.vertical,this.defaultValue.vertical),horizontal:He(me.horizontal,this.defaultValue.horizontal),useShadows:d(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:a.clampedInt(me.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:a.clampedInt(me.verticalSliderSize,Ye,0,1e3),scrollByPage:d(me.scrollByPage,this.defaultValue.scrollByPage)}}}class U extends t{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[c.localize(85,null),c.localize(86,null),c.localize(87,null)],default:J.mode,description:c.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:d(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends t{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(89,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:d(J.enabled,this.defaultValue.enabled)}}}class ee extends t{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(90,null),c.localize(91,null)],default:J.insertMode,description:c.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[c.localize(100,null),c.localize(101,null),c.localize(102,null)],default:J.previewMode,description:c.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(me.showIcons,this.defaultValue.showIcons),showStatusBar:d(me.showStatusBar,this.defaultValue.showStatusBar),preview:d(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(me.showMethods,this.defaultValue.showMethods),showFunctions:d(me.showFunctions,this.defaultValue.showFunctions),showConstructors:d(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(me.showDeprecated,this.defaultValue.showDeprecated),showFields:d(me.showFields,this.defaultValue.showFields),showVariables:d(me.showVariables,this.defaultValue.showVariables),showClasses:d(me.showClasses,this.defaultValue.showClasses),showStructs:d(me.showStructs,this.defaultValue.showStructs),showInterfaces:d(me.showInterfaces,this.defaultValue.showInterfaces),showModules:d(me.showModules,this.defaultValue.showModules),showProperties:d(me.showProperties,this.defaultValue.showProperties),showEvents:d(me.showEvents,this.defaultValue.showEvents),showOperators:d(me.showOperators,this.defaultValue.showOperators),showUnits:d(me.showUnits,this.defaultValue.showUnits),showValues:d(me.showValues,this.defaultValue.showValues),showConstants:d(me.showConstants,this.defaultValue.showConstants),showEnums:d(me.showEnums,this.defaultValue.showEnums),showEnumMembers:d(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(me.showKeywords,this.defaultValue.showKeywords),showWords:d(me.showWords,this.defaultValue.showWords),showColors:d(me.showColors,this.defaultValue.showColors),showFiles:d(me.showFiles,this.defaultValue.showFiles),showReferences:d(me.showReferences,this.defaultValue.showReferences),showFolders:d(me.showFolders,this.defaultValue.showFolders),showTypeParameters:d(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(me.showSnippets,this.defaultValue.showSnippets),showUsers:d(me.showUsers,this.defaultValue.showUsers),showIssues:d(me.showIssues,this.defaultValue.showIssues)}}}class ae extends t{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(136,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class V extends y{constructor(){super(129,[80])}compute(J,me,Ne){return me.get(80)?!0:J.tabFocusMode}}var se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(se=e.WrappingIndent||(e.WrappingIndent={}));function he(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Te extends y{constructor(){super(131,[130])}compute(J,me,Ne){const Ye=me.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",$e="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?$e:F.isLinux?Ke:Ue,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:A.default.quality!=="stable"}},e.editorOptionsRegistry=[];function _e(H){return e.editorOptionsRegistry[H.id]=H,H}var rt;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.bracketPairColorization=12]="bracketPairColorization",H[H.codeLens=13]="codeLens",H[H.codeLensFontFamily=14]="codeLensFontFamily",H[H.codeLensFontSize=15]="codeLensFontSize",H[H.colorDecorators=16]="colorDecorators",H[H.columnSelection=17]="columnSelection",H[H.comments=18]="comments",H[H.contextmenu=19]="contextmenu",H[H.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",H[H.cursorBlinking=21]="cursorBlinking",H[H.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",H[H.cursorStyle=23]="cursorStyle",H[H.cursorSurroundingLines=24]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",H[H.cursorWidth=26]="cursorWidth",H[H.disableLayerHinting=27]="disableLayerHinting",H[H.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",H[H.domReadOnly=29]="domReadOnly",H[H.dragAndDrop=30]="dragAndDrop",H[H.emptySelectionClipboard=31]="emptySelectionClipboard",H[H.extraEditorClassName=32]="extraEditorClassName",H[H.fastScrollSensitivity=33]="fastScrollSensitivity",H[H.find=34]="find",H[H.fixedOverflowWidgets=35]="fixedOverflowWidgets",H[H.folding=36]="folding",H[H.foldingStrategy=37]="foldingStrategy",H[H.foldingHighlight=38]="foldingHighlight",H[H.foldingImportsByDefault=39]="foldingImportsByDefault",H[H.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=41]="fontFamily",H[H.fontInfo=42]="fontInfo",H[H.fontLigatures=43]="fontLigatures",H[H.fontSize=44]="fontSize",H[H.fontWeight=45]="fontWeight",H[H.formatOnPaste=46]="formatOnPaste",H[H.formatOnType=47]="formatOnType",H[H.glyphMargin=48]="glyphMargin",H[H.gotoLocation=49]="gotoLocation",H[H.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",H[H.hover=52]="hover",H[H.inDiffEditor=53]="inDiffEditor",H[H.inlineSuggest=54]="inlineSuggest",H[H.letterSpacing=55]="letterSpacing",H[H.lightbulb=56]="lightbulb",H[H.lineDecorationsWidth=57]="lineDecorationsWidth",H[H.lineHeight=58]="lineHeight",H[H.lineNumbers=59]="lineNumbers",H[H.lineNumbersMinChars=60]="lineNumbersMinChars",H[H.linkedEditing=61]="linkedEditing",H[H.links=62]="links",H[H.matchBrackets=63]="matchBrackets",H[H.minimap=64]="minimap",H[H.mouseStyle=65]="mouseStyle",H[H.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=67]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",H[H.multiCursorModifier=69]="multiCursorModifier",H[H.multiCursorPaste=70]="multiCursorPaste",H[H.occurrencesHighlight=71]="occurrencesHighlight",H[H.overviewRulerBorder=72]="overviewRulerBorder",H[H.overviewRulerLanes=73]="overviewRulerLanes",H[H.padding=74]="padding",H[H.parameterHints=75]="parameterHints",H[H.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",H[H.quickSuggestions=78]="quickSuggestions",H[H.quickSuggestionsDelay=79]="quickSuggestionsDelay",H[H.readOnly=80]="readOnly",H[H.renameOnType=81]="renameOnType",H[H.renderControlCharacters=82]="renderControlCharacters",H[H.renderIndentGuides=83]="renderIndentGuides",H[H.renderFinalNewline=84]="renderFinalNewline",H[H.renderLineHighlight=85]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=87]="renderValidationDecorations",H[H.renderWhitespace=88]="renderWhitespace",H[H.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",H[H.roundedSelection=90]="roundedSelection",H[H.rulers=91]="rulers",H[H.scrollbar=92]="scrollbar",H[H.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=94]="scrollBeyondLastLine",H[H.scrollPredominantAxis=95]="scrollPredominantAxis",H[H.selectionClipboard=96]="selectionClipboard",H[H.selectionHighlight=97]="selectionHighlight",H[H.selectOnLineNumbers=98]="selectOnLineNumbers",H[H.showFoldingControls=99]="showFoldingControls",H[H.showUnused=100]="showUnused",H[H.snippetSuggestions=101]="snippetSuggestions",H[H.smartSelect=102]="smartSelect",H[H.smoothScrolling=103]="smoothScrolling",H[H.stickyTabStops=104]="stickyTabStops",H[H.stopRenderingLineAfter=105]="stopRenderingLineAfter",H[H.suggest=106]="suggest",H[H.suggestFontSize=107]="suggestFontSize",H[H.suggestLineHeight=108]="suggestLineHeight",H[H.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",H[H.suggestSelection=110]="suggestSelection",H[H.tabCompletion=111]="tabCompletion",H[H.tabIndex=112]="tabIndex",H[H.unusualLineTerminators=113]="unusualLineTerminators",H[H.useShadowDOM=114]="useShadowDOM",H[H.useTabStops=115]="useTabStops",H[H.wordSeparators=116]="wordSeparators",H[H.wordWrap=117]="wordWrap",H[H.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=120]="wordWrapColumn",H[H.wordWrapOverride1=121]="wordWrapOverride1",H[H.wordWrapOverride2=122]="wordWrapOverride2",H[H.wrappingIndent=123]="wrappingIndent",H[H.wrappingStrategy=124]="wrappingStrategy",H[H.showDeprecated=125]="showDeprecated",H[H.inlayHints=126]="inlayHints",H[H.editorClassName=127]="editorClassName",H[H.pixelRatio=128]="pixelRatio",H[H.tabFocusMode=129]="tabFocusMode",H[H.layoutInfo=130]="layoutInfo",H[H.wrappingInfo=131]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(137,null)})),acceptSuggestionOnEnter:_e(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(138,null),""],markdownDescription:c.localize(139,null)})),accessibilitySupport:_e(new i),accessibilityPageSize:_e(new a(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(140,null)})),ariaLabel:_e(new k(4,"ariaLabel",c.localize(141,null))),autoClosingBrackets:_e(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(142,null),c.localize(143,null),""],description:c.localize(144,null)})),autoClosingDelete:_e(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(145,null),""],description:c.localize(146,null)})),autoClosingOvertype:_e(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(147,null),""],description:c.localize(148,null)})),autoClosingQuotes:_e(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(149,null),c.localize(150,null),""],description:c.localize(151,null)})),autoIndent:_e(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[c.localize(152,null),c.localize(153,null),c.localize(154,null),c.localize(155,null),c.localize(156,null)],description:c.localize(157,null)})),automaticLayout:_e(new o(10,"automaticLayout",!1)),autoSurround:_e(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(158,null),c.localize(159,null),c.localize(160,null),""],description:c.localize(161,null)})),bracketPairColorization:_e(new K),stickyTabStops:_e(new o(104,"stickyTabStops",!1,{description:c.localize(162,null)})),codeLens:_e(new o(13,"codeLens",!0,{description:c.localize(163,null)})),codeLensFontFamily:_e(new k(14,"codeLensFontFamily","",{description:c.localize(164,null)})),codeLensFontSize:_e(new a(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(165,null)})),colorDecorators:_e(new o(16,"colorDecorators",!0,{description:c.localize(166,null)})),columnSelection:_e(new o(17,"columnSelection",!1,{description:c.localize(167,null)})),comments:_e(new r),contextmenu:_e(new o(19,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new o(20,"copyWithSyntaxHighlighting",!0,{description:c.localize(168,null)})),cursorBlinking:_e(new p(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:c.localize(169,null)})),cursorSmoothCaretAnimation:_e(new o(22,"cursorSmoothCaretAnimation",!1,{description:c.localize(170,null)})),cursorStyle:_e(new p(23,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:c.localize(171,null)})),cursorSurroundingLines:_e(new a(24,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(172,null)})),cursorSurroundingLinesStyle:_e(new u(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(173,null),c.localize(174,null)],description:c.localize(175,null)})),cursorWidth:_e(new a(26,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(176,null)})),disableLayerHinting:_e(new o(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new o(28,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new o(29,"domReadOnly",!1)),dragAndDrop:_e(new o(30,"dragAndDrop",!0,{description:c.localize(177,null)})),emptySelectionClipboard:_e(new R),extraEditorClassName:_e(new k(32,"extraEditorClassName","")),fastScrollSensitivity:_e(new g(33,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:c.localize(178,null)})),find:_e(new f),fixedOverflowWidgets:_e(new o(35,"fixedOverflowWidgets",!1)),folding:_e(new o(36,"folding",!0,{description:c.localize(179,null)})),foldingStrategy:_e(new u(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(180,null),c.localize(181,null)],description:c.localize(182,null)})),foldingHighlight:_e(new o(38,"foldingHighlight",!0,{description:c.localize(183,null)})),foldingImportsByDefault:_e(new o(39,"foldingImportsByDefault",!1,{description:c.localize(184,null)})),unfoldOnClickAfterEndOfLine:_e(new o(40,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(185,null)})),fontFamily:_e(new k(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(186,null)})),fontInfo:_e(new h),fontLigatures2:_e(new E),fontSize:_e(new M),fontWeight:_e(new O),formatOnPaste:_e(new o(46,"formatOnPaste",!1,{description:c.localize(187,null)})),formatOnType:_e(new o(47,"formatOnType",!1,{description:c.localize(188,null)})),glyphMargin:_e(new o(48,"glyphMargin",!0,{description:c.localize(189,null)})),gotoLocation:_e(new q),hideCursorInOverviewRuler:_e(new o(50,"hideCursorInOverviewRuler",!1,{description:c.localize(190,null)})),highlightActiveIndentGuide:_e(new o(51,"highlightActiveIndentGuide",!0,{description:c.localize(191,null)})),hover:_e(new Q),inDiffEditor:_e(new o(53,"inDiffEditor",!1)),letterSpacing:_e(new g(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>g.clamp(H,-5,20),{description:c.localize(192,null)})),lightbulb:_e(new N),lineDecorationsWidth:_e(new n(57,"lineDecorationsWidth",10)),lineHeight:_e(new j),lineNumbers:_e(new Re),lineNumbersMinChars:_e(new a(60,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new o(61,"linkedEditing",!1,{description:c.localize(193,null)})),links:_e(new o(62,"links",!0,{description:c.localize(194,null)})),matchBrackets:_e(new u(63,"matchBrackets","always",["always","near","never"],{description:c.localize(195,null)})),minimap:_e(new Y),mouseStyle:_e(new u(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new g(66,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:c.localize(196,null)})),mouseWheelZoom:_e(new o(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(197,null)})),multiCursorMergeOverlapping:_e(new o(68,"multiCursorMergeOverlapping",!0,{description:c.localize(198,null)})),multiCursorModifier:_e(new p(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[c.localize(199,null),c.localize(200,null)],markdownDescription:c.localize(201,null)})),multiCursorPaste:_e(new u(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(202,null),c.localize(203,null)],markdownDescription:c.localize(204,null)})),occurrencesHighlight:_e(new o(71,"occurrencesHighlight",!0,{description:c.localize(205,null)})),overviewRulerBorder:_e(new o(72,"overviewRulerBorder",!0,{description:c.localize(206,null)})),overviewRulerLanes:_e(new a(73,"overviewRulerLanes",3,0,3)),padding:_e(new G),parameterHints:_e(new ue),peekWidgetDefaultFocus:_e(new u(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(207,null),c.localize(208,null)],description:c.localize(209,null)})),definitionLinkOpensInPeek:_e(new o(77,"definitionLinkOpensInPeek",!1,{description:c.localize(210,null)})),quickSuggestions:_e(new be),quickSuggestionsDelay:_e(new a(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(211,null)})),readOnly:_e(new o(80,"readOnly",!1)),renameOnType:_e(new o(81,"renameOnType",!1,{description:c.localize(212,null),markdownDeprecationMessage:c.localize(213,null)})),renderControlCharacters:_e(new o(82,"renderControlCharacters",!1,{description:c.localize(214,null)})),renderIndentGuides:_e(new o(83,"renderIndentGuides",!0,{description:c.localize(215,null)})),renderFinalNewline:_e(new o(84,"renderFinalNewline",!0,{description:c.localize(216,null)})),renderLineHighlight:_e(new u(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(217,null)],description:c.localize(218,null)})),renderLineHighlightOnlyWhenFocus:_e(new o(86,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(219,null)})),renderValidationDecorations:_e(new u(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new u(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(220,null),c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),revealHorizontalRightPadding:_e(new a(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new o(90,"roundedSelection",!0,{description:c.localize(224,null)})),rulers:_e(new Qe),scrollbar:_e(new je),scrollBeyondLastColumn:_e(new a(93,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(225,null)})),scrollBeyondLastLine:_e(new o(94,"scrollBeyondLastLine",!0,{description:c.localize(226,null)})),scrollPredominantAxis:_e(new o(95,"scrollPredominantAxis",!0,{description:c.localize(227,null)})),selectionClipboard:_e(new o(96,"selectionClipboard",!0,{description:c.localize(228,null),included:F.isLinux})),selectionHighlight:_e(new o(97,"selectionHighlight",!0,{description:c.localize(229,null)})),selectOnLineNumbers:_e(new o(98,"selectOnLineNumbers",!0)),showFoldingControls:_e(new u(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),showUnused:_e(new o(100,"showUnused",!0,{description:c.localize(233,null)})),showDeprecated:_e(new o(125,"showDeprecated",!0,{description:c.localize(234,null)})),inlayHints:_e(new W),snippetSuggestions:_e(new u(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),smartSelect:_e(new ae),smoothScrolling:_e(new o(103,"smoothScrolling",!1,{description:c.localize(240,null)})),stopRenderingLineAfter:_e(new a(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ee),inlineSuggest:_e(new U),suggestFontSize:_e(new a(107,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(241,null)})),suggestLineHeight:_e(new a(108,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(242,null)})),suggestOnTriggerCharacters:_e(new o(109,"suggestOnTriggerCharacters",!0,{description:c.localize(243,null)})),suggestSelection:_e(new u(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(244,null),c.localize(245,null),c.localize(246,null)],description:c.localize(247,null)})),tabCompletion:_e(new u(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(248,null),c.localize(249,null),c.localize(250,null)],description:c.localize(251,null)})),tabIndex:_e(new a(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new u(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(252,null),c.localize(253,null),c.localize(254,null)],description:c.localize(255,null)})),useShadowDOM:_e(new o(114,"useShadowDOM",!0)),useTabStops:_e(new o(115,"useTabStops",!0,{description:c.localize(256,null)})),wordSeparators:_e(new k(116,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:c.localize(257,null)})),wordWrap:_e(new u(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(258,null),c.localize(259,null),c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),wordWrapBreakAfterCharacters:_e(new k(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new k(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new a(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(263,null)})),wordWrapOverride1:_e(new u(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new u(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new p(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],he,{enumDescriptions:[c.localize(264,null),c.localize(265,null),c.localize(266,null),c.localize(267,null)],description:c.localize(268,null)})),wrappingStrategy:_e(new u(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),editorClassName:_e(new C),pixelRatio:_e(new oe),tabFocusMode:_e(new V),layoutInfo:_e(new z),wrappingInfo:_e(new Te)}});var Be=this&&this.__decorate||function(ne,e,c,F){var _=arguments.length,A=_<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,c):F,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,c,F);else for(var I=ne.length-1;I>=0;I--)(T=ne[I])&&(A=(_<3?T(A):_>3?T(e,c,A):T(e,c))||A);return _>3&&A&&Object.defineProperty(e,c,A),A},ze=this&&this.__param||function(ne,e){return function(c,F){e(c,F,ne)}};define(ve[147],we([0,1,13,21,7,4]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var T;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let S=class extends _.Disposable{constructor(y,n){super();this.deferred=new c.DeferredPromise,n.withProgress(y,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};S=Be([ze(1,e.IProgressService)],S),e.UnmanagedProgress=S;class P extends _.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(y){this.stop();const n=++this.currentOperationId,d=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:d.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ve[28],we([0,1,39,10]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(T,I){c.ok(F.isString(T)),c.ok(F.isObject(I)),c.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new _}),define(ve[84],we([0,1,3,28]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,P){this.schemasById[_(S)]=P,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;F.Registry.add(e.Extensions.JSONContribution,T)}),define(ve[62],we([0,1,3,10,116,84,28]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=T.Registry.as(A.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new c.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new c.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,u=!0){this.registerConfigurations([b],u)}registerConfigurations(b,u=!0){const p=[];b.forEach(D=>{p.push(...this.validateAndRegisterProperties(D,u,D.extensionInfo)),this.configurationContributors.push(D),this.registerJSONConfiguration(D)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(b){const u=[],p=D=>{if(D.properties)for(const i in D.properties)u.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,D.properties[i]);D.allOf&&D.allOf.forEach(i=>p(i))};for(const D of b){p(D);const i=this.configurationContributors.indexOf(D);i!==-1&&this.configurationContributors.splice(i,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}registerDefaultConfigurations(b){const u=[],p=[];for(const D of b)for(const i in D)if(u.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...D[i]};const r={type:"object",default:this.defaultValues[i],description:_.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};p.push(n(i)),this.configurationProperties[i]=r,this.defaultLanguageConfigurationOverridesNode.properties[i]=r}else{this.defaultValues[i]=D[i];const r=this.configurationProperties[i];r&&(this.updatePropertyDefaultValue(i,r),this.updateSchema(i,r))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterDefaultConfigurations(b){const u=[];for(const p of b)for(const D in p)if(u.push(D),delete this.defaultValues[D],e.OVERRIDE_PROPERTY_PATTERN.test(D))delete this.configurationProperties[D],delete this.defaultLanguageConfigurationOverridesNode.properties[D];else{const i=this.configurationProperties[D];i&&(this.updatePropertyDefaultValue(D,i),this.updateSchema(D,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const u of b)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,u=!0,p,D=3){D=F.isUndefinedOrNull(b.scope)?D:b.scope;let i=[],r=b.properties;if(r)for(let s in r){if(u&&a(s)){delete r[s];continue}const m=r[s];if(this.updatePropertyDefaultValue(s,m),e.OVERRIDE_PROPERTY_PATTERN.test(s)?m.scope=void 0:(m.scope=F.isUndefinedOrNull(m.scope)?D:m.scope,m.restricted=F.isUndefinedOrNull(m.restricted)?!!p?.restrictedConfigurations?.includes(s):m.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),i.push(s)}let l=b.allOf;if(l)for(let s of l)i.push(...this.validateAndRegisterProperties(s,u,p,D));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const u=p=>{let D=p.properties;if(D)for(const r in D)this.updateSchema(r,D[r]);let i=p.allOf;i&&i.forEach(u)};u(b)}updateSchema(b,u){switch(e.allSettings.properties[b]=u,u.scope){case 1:e.applicationSettings.properties[b]=u;break;case 2:e.machineSettings.properties[b]=u;break;case 6:e.machineOverridableSettings.properties[b]=u;break;case 3:e.windowSettings.properties[b]=u;break;case 4:e.resourceSettings.properties[b]=u;break;case 5:e.resourceSettings.properties[b]=u,this.resourceLanguageSettingsSchema.properties[b]=u;break}}removeFromSchema(b,u){switch(delete e.allSettings.properties[b],u.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const u=`[${b}]`,p={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,p),e.allSettings.properties[u]=p,e.applicationSettings.properties[u]=p,e.machineSettings.properties[u]=p,e.machineOverridableSettings.properties[u]=p,e.windowSettings.properties[u]=p,e.resourceSettings.properties[u]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,u){let p=this.defaultValues[b];F.isUndefined(p)&&(p=u.default),F.isUndefined(p)&&(p=d(u.type)),u.default=p}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function n(k){return k.substring(1,k.length-1)}e.overrideIdentifierFromKey=n;function d(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const o=new t;T.Registry.add(e.Extensions.Configuration,o);function a(k){return k.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(k)?_.localize(5,null,k):o.getConfigurationProperties()[k]!==void 0?_.localize(6,null,k):null:_.localize(4,null)}e.validateProperty=a;function g(){const k=[],b=o.getConfigurationProperties();for(const u of Object.keys(b))k.push([u,b[u].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=g}),define(ve[85],we([0,1,22,10,2,62,4,28]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof _.URI)}e.isConfigurationOverrides=S;var P;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function y(r,l){const s=l?r?l.keys.filter(E=>r.keys.indexOf(E)===-1):[...l.keys]:[],m=r?l?r.keys.filter(E=>l.keys.indexOf(E)===-1):[...r.keys]:[],v=[];if(l&&r){for(const E of r.keys)if(l.keys.indexOf(E)!==-1){const h=k(r.contents,E),M=k(l.contents,E);c.equals(h,M)||v.push(E)}}const w=[],C=E=>{const h={};for(const M of E)for(const O of M.identifiers)h[D(O)]=M;return h},R=l?C(l.overrides):{},f=r?C(r.overrides):{};if(Object.keys(R).length)for(const E of s){const h=R[E];h&&w.push([(0,A.overrideIdentifierFromKey)(E),h.keys])}if(Object.keys(f).length)for(const E of m){const h=f[E];h&&w.push([(0,A.overrideIdentifierFromKey)(E),h.keys])}if(Object.keys(R).length&&Object.keys(f).length)for(const E of v){const h=f[E],M=R[E];if(h&&M){const O=y({contents:h.contents,keys:h.keys,overrides:[]},{contents:M.contents,keys:M.keys,overrides:[]});w.push([(0,A.overrideIdentifierFromKey)(E),[...O.added,...O.removed,...O.updated]])}}return{added:s,removed:m,updated:v,overrides:w}}e.compare=y;function n(r,l){const s=[];for(const m of Object.keys(r))if(A.OVERRIDE_PROPERTY_PATTERN.test(m)){const v={};for(const w in r[m])v[w]=r[m][w];s.push({identifiers:[(0,A.overrideIdentifierFromKey)(m).trim()],keys:Object.keys(v),contents:d(v,l)})}return s}e.toOverrides=n;function d(r,l){const s=Object.create(null);for(let m in r)o(s,m,r[m],l);return s}e.toValuesTree=d;function o(r,l,s,m){const v=l.split("."),w=v.pop();let C=r;for(let R=0;R<v.length;R++){let f=v[R],E=C[f];switch(typeof E){case"undefined":E=C[f]=Object.create(null);break;case"object":break;default:m(`Ignoring ${l} as ${v.slice(0,R+1).join(".")} is ${JSON.stringify(E)}`);return}C=E}if(typeof C=="object"&&C!==null)try{C[w]=s}catch(R){m(`Ignoring ${l} as ${v.join(".")} is ${JSON.stringify(C)}`)}else m(`Ignoring ${l} as ${v.join(".")} is ${JSON.stringify(C)}`)}e.addToValueTree=o;function a(r,l){const s=l.split(".");g(r,s)}e.removeFromValueTree=a;function g(r,l){const s=l.shift();if(l.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const m=r[s];typeof m=="object"&&!Array.isArray(m)&&(g(m,l),Object.keys(m).length===0&&delete r[s])}}function k(r,l,s){function m(C,R){let f=C;for(const E of R){if(typeof f!="object"||f===null)return;f=f[E]}return f}const v=l.split("."),w=m(r,v);return typeof w=="undefined"?s:w}e.getConfigurationValue=k;function b(r,l,s){Object.keys(l).forEach(m=>{m!=="__proto__"&&(m in r?F.isObject(r[m])&&F.isObject(l[m])?b(r[m],l[m],s):s&&(r[m]=l[m]):r[m]=l[m])})}e.merge=b;function u(){const r=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function p(){const r=Object.create(null),l=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let s in l){let m=l[s].default;o(r,s,m,v=>console.error(`Conflict in default settings: ${v}`))}return r}e.getDefaultValues=p;function D(r){return`[${r}]`}e.keyFromOverrideIdentifier=D;function i(r,l,s){const m=r.inspect(l),v=r.inspect(s);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:m.defaultValue}e.getMigratedSettingValue=i}),define(ve[148],we([0,1,16,3,102,7,20,22,10,2,85,62,28]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(i={},r=[],l=[]){this._contents=i,this._keys=r,this._overrides=l,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,r){const l=this.getContentsForOverrideIdentifer(r);return l?i?(0,t.getConfigurationValue)(l,i):l:void 0}getKeysForOverrideIdentifier(i){for(const r of this.overrides)if(r.identifiers.indexOf(i)!==-1)return r.keys;return[]}override(i){const r=this.getContentsForOverrideIdentifer(i);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let l={};for(const s of c.distinct([...Object.keys(this.contents),...Object.keys(r)])){let m=this.contents[s],v=r[s];v&&(typeof m=="object"&&typeof v=="object"?(m=I.deepClone(m),this.mergeContents(m,v)):m=v),l[s]=m}return new d(l,this.keys,this.overrides)}merge(...i){const r=I.deepClone(this.contents),l=I.deepClone(this.overrides),s=[...this.keys];for(const m of i){this.mergeContents(r,m.contents);for(const v of m.overrides){const[w]=l.filter(C=>c.equals(C.identifiers,v.identifiers));w?this.mergeContents(w.contents,v.contents):l.push(I.deepClone(v))}for(const v of m.keys)s.indexOf(v)===-1&&s.push(v)}return new d(r,s,l)}freeze(){return this.isFrozen=!0,this}mergeContents(i,r){for(const l of Object.keys(r)){if(l in i&&S.isObject(i[l])&&S.isObject(r[l])){this.mergeContents(i[l],r[l]);continue}i[l]=I.deepClone(r[l])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const r of this.overrides)if(r.identifiers.indexOf(i)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,r){this.addKey(i),(0,t.addToValueTree)(this.contents,i,r,l=>{throw new Error(l)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let r=this.keys.length;for(let l=0;l<r;l++)i.indexOf(this.keys[l])===0&&(r=l);this.keys.splice(r,1,i)}removeKey(i){let r=this.keys.indexOf(i);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=d;class o extends d{constructor(){const i=(0,t.getDefaultValues)(),r=(0,t.getConfigurationKeys)(),l=[];for(const s of Object.keys(i))y.OVERRIDE_PROPERTY_PATTERN.test(s)&&l.push({identifiers:[(0,y.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],m=>console.error(`Conflict in default settings file: ${m}`))});super(i,r,l)}}e.DefaultConfigurationModel=o;class a{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,r){if(!S.isUndefinedOrNull(i)){const l=this.doParseContent(i);this.parseRaw(l,r)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,r){this._raw=i;const{contents:l,keys:s,overrides:m,restricted:v}=this.doParseRaw(i,r);this._configurationModel=new d(l,s,m),this._restrictedConfigurations=v||[]}doParseContent(i){let r={},l=null,s=[],m=[],v=[];function w(R){Array.isArray(s)?s.push(R):l!==null&&(s[l]=R)}let C={onObjectBegin:()=>{let R={};w(R),m.push(s),s=R,l=null},onObjectProperty:R=>{l=R},onObjectEnd:()=>{s=m.pop()},onArrayBegin:()=>{let R=[];w(R),m.push(s),s=R,l=null},onArrayEnd:()=>{s=m.pop()},onLiteralValue:w,onError:(R,f,E)=>{v.push({error:R,offset:f,length:E})}};if(i)try{_.visit(i,C),r=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return r}doParseRaw(i,r){const l=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,l,!0,r);i=s.raw;const m=(0,t.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),v=Object.keys(i),w=(0,t.toOverrides)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:m,keys:v,overrides:w,restricted:s.restricted}}filter(i,r,l,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const m={},v=[];for(let w in i)if(y.OVERRIDE_PROPERTY_PATTERN.test(w)&&l){const C=this.filter(i[w],r,!1,s);m[w]=C.raw,v.push(...C.restricted)}else{const C=r[w],R=C?typeof C.scope!="undefined"?C.scope:3:void 0;C?.restricted&&v.push(w),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&C?.restricted||(m[w]=i[w]))}return{raw:m,restricted:v}}}e.ConfigurationModelParser=a;class g extends A.Disposable{constructor(i,r,l,s){super();this.userSettingsResource=i,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,m=>m.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class k{constructor(i,r,l=new d,s=new d,m=new T.ResourceMap,v=new d,w=new T.ResourceMap,C=!0){this._defaultConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=l,this._workspaceConfiguration=s,this._folderConfigurations=m,this._memoryConfiguration=v,this._memoryConfigurationByResource=w,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,r,l){return this.getConsolidateConfigurationModel(r,l).getValue(i)}updateValue(i,r,l={}){let s;l.resource?(s=this._memoryConfigurationByResource.get(l.resource),s||(s=new d,this._memoryConfigurationByResource.set(l.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(i):s.setValue(i,r),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,r,l){const s=this.getConsolidateConfigurationModel(r,l),m=this.getFolderConfigurationModelForResource(r.resource,l),v=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,w=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),C=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),f=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),E=l?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,h=m?r.overrideIdentifier?m.freeze().override(r.overrideIdentifier).getValue(i):m.freeze().getValue(i):void 0,M=r.overrideIdentifier?v.override(r.overrideIdentifier).getValue(i):v.getValue(i),O=s.getValue(i),q=c.distinct(c.flatten(s.overrides.map(Q=>Q.identifiers))).filter(Q=>s.getOverrideValue(i,Q)!==void 0);return{defaultValue:w,userValue:C,userLocalValue:R,userRemoteValue:f,workspaceValue:E,workspaceFolderValue:h,memoryValue:M,value:O,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,workspace:E!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,workspaceFolder:h!==void 0?{value:m?.freeze().getValue(i),override:r.overrideIdentifier?m?.freeze().getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:v.getValue(i),override:r.overrideIdentifier?v.getOverrideValue(i,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const r=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,r){this._folderConfigurations.set(i,r),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,r){const l=r.filter(s=>y.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const m=(0,y.overrideIdentifierFromKey)(s),v=this._defaultConfiguration.getKeysForOverrideIdentifier(m),w=i.getKeysForOverrideIdentifier(m),C=[...w.filter(R=>v.indexOf(R)===-1),...v.filter(R=>w.indexOf(R)===-1),...v.filter(R=>!I.equals(this._defaultConfiguration.override(m).getValue(R),i.override(m).getValue(R)))];return[m,C]});return this.updateDefaultConfiguration(i),{keys:r,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:r,updated:l,removed:s,overrides:m}=(0,t.compare)(this.localUserConfiguration,i),v=[...r,...l,...s];return v.length&&this.updateLocalUserConfiguration(i),{keys:v,overrides:m}}compareAndUpdateRemoteUserConfiguration(i){const{added:r,updated:l,removed:s,overrides:m}=(0,t.compare)(this.remoteUserConfiguration,i);let v=[...r,...l,...s];return v.length&&this.updateRemoteUserConfiguration(i),{keys:v,overrides:m}}compareAndUpdateWorkspaceConfiguration(i){const{added:r,updated:l,removed:s,overrides:m}=(0,t.compare)(this.workspaceConfiguration,i);let v=[...r,...l,...s];return v.length&&this.updateWorkspaceConfiguration(i),{keys:v,overrides:m}}compareAndUpdateFolderConfiguration(i,r){const l=this.folderConfigurations.get(i),{added:s,updated:m,removed:v,overrides:w}=(0,t.compare)(l,r);let C=[...s,...m,...v];return(C.length||!l)&&this.updateFolderConfiguration(i,r),{keys:C,overrides:w}}compareAndDeleteFolderConfiguration(i){const r=this.folderConfigurations.get(i);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:l,updated:s,removed:m,overrides:v}=(0,t.compare)(r,void 0);return{keys:[...l,...s,...m],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,r){let l=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier?l.override(i.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:i},r){let l=this.getWorkspaceConsolidatedConfiguration();if(r&&i){const s=r.getFolder(i);s&&(l=this.getFolderConsolidatedConfiguration(s.uri)||l);const m=this._memoryConfigurationByResource.get(i);m&&(l=l.merge(m))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let r=this._foldersConsolidatedConfigurations.get(i);if(!r){const l=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(r=l.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(i,r)):r=l}return r}getFolderConfigurationModelForResource(i,r){if(r&&i){const l=r.getFolder(i);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,r)=>{const{contents:l,overrides:s,keys:m}=this._folderConfigurations.get(r);return i.push([r,{contents:l,overrides:s,keys:m}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>i.add(r)),this.userConfiguration.freeze().keys.forEach(r=>i.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(l=>i.add(l))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(l=>r.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(l=>r.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(l=>r.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(i).forEach(s=>r.add(s))),[...r.values()]}static parse(i){const r=this.parseConfigurationModel(i.defaults),l=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),m=i.folders.reduce((v,w)=>(v.set(P.URI.revive(w[0]),this.parseConfigurationModel(w[1])),v),new T.ResourceMap);return new k(r,l,new d,s,m,new d,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new d(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=k;function b(...D){if(D.length===0)return{keys:[],overrides:[]};if(D.length===1)return D[0];const i=new Set,r=new Map;for(const s of D)s.keys.forEach(m=>i.add(m)),s.overrides.forEach(([m,v])=>{const w=(0,T.getOrSet)(r,m,new Set);v.forEach(C=>w.add(C))});const l=[];return r.forEach((s,m)=>l.push([m,[...s.values()]])),{keys:[...i.values()],overrides:l}}e.mergeChanges=b;class u{constructor(i,r,l,s){this.change=i,this.previous=r,this.currentConfiguraiton=l,this.currentWorkspace=s,this._previousConfiguration=void 0;const m=new Set;i.keys.forEach(w=>m.add(w)),i.overrides.forEach(([,w])=>w.forEach(C=>m.add(C))),this.affectedKeys=[...m.values()];const v=new d;this.affectedKeys.forEach(w=>v.setValue(w,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=k.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(r){const l=this.previousConfiguration?this.previousConfiguration.getValue(i,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,r,this.currentWorkspace);return!I.equals(l,s)}return!0}return!1}doesAffectedKeysTreeContains(i,r){let l=(0,t.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof l=="object"&&(s=Object.keys(l)[0]);){if(i=i[s],!i)return!1;l=l[s]}return!0}}e.ConfigurationChangeEvent=u;class p extends u{constructor(i,r,l,s){super({keys:i.allKeys(),overrides:[]},void 0,i,r);this.source=l,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=p}),define(ve[86],we([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var F;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(T,I=F.Unknown,S){super(T);this._message=T,this._code=I,this._detail=S,this.isHandled=I===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(T){return T instanceof _&&T._code===F.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof _&&T._code===F.NoResolverFound}static isHandled(T){return T instanceof _&&T.isHandled}}e.RemoteAuthorityResolverError=_}),define(ve[87],we([0,1,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(P){return P.scheme===c.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=F;function _(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=_;function A(P){return P.scheme!==c.Schemas.file&&P.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function T(P){if(P.folders.length)return P.folders.every(t=>A(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&A(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=T;function I(P){return T(P)?.scheme}e.getVirtualWorkspaceScheme=I;function S(P){return T(P)!==void 0}e.isVirtualWorkspace=S}),define(ve[149],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,A,T=5){let I;return I=A(S=>{const P=typeof S=="string"?S:S.data;let t=this._terminalBufferMap.get(_);if(t){t.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(_),T);t={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(_),I.dispose()}},this._terminalBufferMap.set(_,t)}),I}stopBuffering(_){const A=this._terminalBufferMap.get(_);A&&A.dispose()}flushBuffer(_){const A=this._terminalBufferMap.get(_);A&&(this._terminalBufferMap.delete(_),this._callback(_,A.data.join("")))}}e.TerminalDataBufferer=c}),define(ve[150],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(ve[43],we([0,1,34,3,7,4,28,150]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(g){function k(b){return b&&typeof b=="object"&&typeof b.id=="string"}g.isThemeColor=k})(S=e.ThemeColor||(e.ThemeColor={}));function P(g){return{id:g}}e.themeColorFromId=P;var t;(function(g){function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||S.isThemeColor(r.color))}g.isThemeIcon=k;const b=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function u(r){const l=b.exec(r);if(!l)return;let[,s]=l;return{id:s}}g.fromString=u;function p(r,l){let s=r.id;const m=s.lastIndexOf("~");return m!==-1&&(s=s.substring(0,m)),l&&(s=`${s}~${l}`),{id:s}}g.modify=p;function D(r,l){return r.id===l.id&&r.color?.id===l.color?.id}g.isEqual=D;function i(r,l){return{id:r.id,color:l?P(l):void 0}}g.asThemeIcon=i,g.asClassNameArray=c.CSSIcon.asClassNameArray,g.asClassName=c.CSSIcon.asClassName,g.asCSSSelector=c.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function y(g){switch(g){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(k){return this.themingParticipants.push(k),this.onThemingParticipantAddedEmitter.fire(k),(0,_.toDisposable)(()=>{const b=this.themingParticipants.indexOf(k);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new n;T.Registry.add(e.Extensions.ThemingContribution,d);function o(g){return d.onColorThemeChange(g)}e.registerThemingParticipant=o;class a extends _.Disposable{constructor(k){super();this.themeService=k,this.theme=k.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(k){this.theme=k,this.updateStyles()}updateStyles(){}getColor(k,b){let u=this.theme.getColor(k);return u&&b&&(u=b(u,this.theme)),u?u.toString():null}}e.Themable=a}),define(ve[151],we([0,1,13,34,3,120,84,28,43]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(k,b,u,p){const D=this.iconsById[k];if(D){if(u&&!D.description){D.description=u,this.iconSchema.properties[k].markdownDescription=`${u} $(${k})`;const l=this.iconReferenceSchema.enum.indexOf(k);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=u),this._onDidChange.fire()}return D}let i={id:k,description:u,defaults:b,deprecationMessage:p};this.iconsById[k]=i;let r={$ref:"#/definitions/icons"};return p&&(r.deprecationMessage=p),u&&(r.markdownDescription=`${u}: $(${k})`),this.iconSchema.properties[k]=r,this.iconReferenceSchema.enum.push(k),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:k}}deregisterIcon(k){delete this.iconsById[k],delete this.iconSchema.properties[k];const b=this.iconReferenceSchema.enum.indexOf(k);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(k=>this.iconsById[k])}getIcon(k){return this.iconsById[k]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(k,b){const u=this.iconFontsById[k];if(u)return u;let p={id:k,definition:b};return this.iconFontsById[k]=p,this._onDidChange.fire(),p}deregisterIconFont(k){delete this.iconFontsById[k]}getIconFonts(){return Object.keys(this.iconFontsById).map(k=>this.iconFontsById[k])}getIconFont(k){return this.iconFontsById[k]}toString(){const k=(D,i)=>D.id.localeCompare(i.id),b=D=>{for(;S.ThemeIcon.isThemeIcon(D.defaults);)D=this.iconsById[D.defaults.id];return`codicon codicon-${D?D.id:""}`};let u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.iconsById).map(D=>this.iconsById[D]);for(const D of p.filter(i=>!!i.description).sort(k))u.push(`|<i class="${b(D)}"></i>|${D.id}|${S.ThemeIcon.isThemeIcon(D.defaults)?D.defaults.id:D.id}|${D.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const D of p.filter(i=>!S.ThemeIcon.isThemeIcon(i.defaults)).sort(k))u.push(`|<i class="${b(D)}"></i>|${D.id}|`);return u.join(`
`)}}const t=new P;I.Registry.add(e.Extensions.IconContribution,t);function y(g,k,b,u){return t.registerIcon(g,k,b,u)}e.registerIcon=y;function n(){return t}e.getIconRegistry=n;function d(){for(const g of F.iconRegistry.all)t.registerIcon(g.id,g.definition,g.description);F.iconRegistry.onDidRegister(g=>t.registerIcon(g.id,g.definition,g.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let o=I.Registry.as(T.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,t.getIconSchema());const a=new c.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=y("widget-close",F.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=y("goto-previous-location",F.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=y("goto-next-location",F.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=S.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(ve[44],we([0,1,20,24,2,4]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var T;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function I(n){const d=n;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=I;function S(n){const d=n;return!!(d&&typeof d=="object"&&_.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=S;class P{constructor(d,o,a,g){this._id=d,this._configuration=a,this._ignorePathCasing=g,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class t{constructor(d,o){this.raw=o,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,F.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function y(n){return new t({uri:n,index:0,name:(0,F.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=y}),define(ve[63],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const A=this._idPool++;return this._data.set(A,_),this.logDebugInfo(),A}get(_,A){return this._data.has(_)?this._data.get(_)[A]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(ve[64],we([0,1,2,3,4]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new F.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(S=>({name:S.name,group:S.group,resource:c.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(ve[45],we([0,1,11,4]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class _{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,I){I===null?this._providerInfo.delete(T):this._providerInfo.set(T,I)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=_,e.IExtHostFileSystemInfo=(0,F.createDecorator)("IExtHostFileSystemInfo")}),define(ve[29],we([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(ve[152],we([0,1,13]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(T,I,S){this._deferredPromises=new Map,this._id=T,this._shared=I,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const y of P.values())y.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,I){let S=this._value[T];return typeof S=="undefined"&&(S=I),S}update(T,I){this._value[T]=I;let S=this._deferredPromises.get(T);if(S!==void 0)return S.p;const P=new c.DeferredPromise;return this._deferredPromises.set(T,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class _ extends F{constructor(T,I){super(T.identifier.value,!0,I);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=_}),define(ve[153],we([0,1,3,2,14]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(I,S){this._logService=I,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,S,P){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I)).acceptModelChanged(S.value,P)}$acceptDirtyStateChanged(I,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I)).acceptDirty(S)}$acceptModelSaved(I){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(I,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,S);const P=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I));P.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};A=Be([ze(0,_.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(ve[12],we([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class F{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=F});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[154],we([0,1,26,3]),function(ne,e,c,F){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(I,S){_.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(I.identifier),et(this,_,S,"f"),Me(this,_,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(I){return Me(this,_,"f").get(this._id,I)}store(I,S){return Me(this,_,"f").store(this._id,I,S)}delete(I){return Me(this,_,"f").delete(this._id,I)}}e.ExtensionSecrets=A,_=new WeakMap}),define(ve[88],we([0,1,4,3]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(ve[65],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,_=(b,u)=>{const p={controllerId:u};return F.set(b,p),p};e.createPrivateApiFor=_;const A=b=>F.get(b);e.getPrivateApiFor=A;const T=(b,u,p,D)=>{let i=p;return{enumerable:!0,configurable:!1,get(){return i},set(r){if(!D(i,r)){const l=i;i=r,b.listener?.({op:3,key:u,value:r,previous:l})}}}},I=(b,u)=>b===u,S={range:(b,u)=>b===u?!0:!b||!u?!1:b.isEqual(u),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(b,u)=>!(b.length!==u.length||b.some(p=>!u.find(D=>p.id===D.id)))},P=Object.keys(S),t=(b,u)=>({range:T(b,"range",void 0,S.range),label:T(b,"label",u,S.label),description:T(b,"description",void 0,S.description),canResolveChildren:T(b,"canResolveChildren",!1,S.canResolveChildren),busy:T(b,"busy",!1,S.busy),error:T(b,"error",void 0,S.error),tags:T(b,"tags",[],S.tags)}),y=(b,u)=>{const p=new Map;for(const D of P)S[D](b[D],u[D])||p.set(D,u[D]);return p};e.diffTestItems=y;class n extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.DuplicateTestItemError=n;class d extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class o extends Error{constructor(u,p,D){super(`TestItem with ID "${u}" is from controller "${p}" and cannot be added as a child of an item from controller "${D}".`)}}e.MixedTestItemController=o;const a=b=>{const u=(0,e.getPrivateApiFor)(b);let p=new Map;return{get size(){return p.size},forEach(D,i){for(const r of p.values())D.call(i,r,this)},replace(D){const i=new Map,r=new Set(p.keys()),l={op:4,ops:[]};for(const s of D){if(!(s instanceof g))throw new d(s.id);const m=(0,e.getPrivateApiFor)(s).controllerId;if(m!==u.controllerId)throw new o(s.id,m,u.controllerId);if(i.has(s.id))throw new n(s.id);i.set(s.id,s),r.delete(s.id),l.ops.push({op:0,item:s})}for(const s of r.keys())l.ops.push({op:1,id:s});u.listener?.(l),p=i},add(D){if(!(D instanceof g))throw new d(D.id);p.set(D.id,D),u.listener?.({op:0,item:D})},delete(D){p.delete(D)&&u.listener?.({op:1,id:D})},get(D){return p.get(D)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class g{constructor(u,p,D,i){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,e.createPrivateApiFor)(this,u);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof k?void 0:r.parent}},children:{value:a(this),enumerable:!0,writable:!1},...t(r,D)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class k extends g{constructor(u,p){super(u,u,p,void 0)}}e.TestItemRootImpl=k}),define(ve[66],we([0,1,4,3,12]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(I){function S(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}I.fromApiTunnel=S;function P(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}I.fromServiceTunnel=P})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(S){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,P){return{dispose:()=>{}}}async $providePortAttributes(S,P,t,y,n){return[]}async $forwardPort(S,P){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Be([ze(0,_.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[6],we([0,1,16,15,77,20,79,10,2,36,59,86]),function(ne,e,c,F,_,A,T,I,S,P,t,y){"use strict";var n,d,o,a,g,k,b,u,p,D,i,r,l,s,m,v,w,C,R,f;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function E(x){function L(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(L,x),Object.setPrototypeOf(L.prototype,x.prototype),L}let h=g=class{constructor(L){n.set(this,void 0),et(this,n,L,"f")}static from(...L){let te=L;return new g(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}dispose(){typeof Me(this,n,"f")=="function"&&(Me(this,n,"f").call(this),et(this,n,void 0,"f"))}};n=new WeakMap,h=g=Be([E],h),e.Disposable=h;let M=k=class{constructor(L,te){if(L<0)throw(0,F.illegalArgument)("line must be non-negative");if(te<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ge=L[Ee];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ge=L[Ee];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(L){if(!L)return!1;if(L instanceof k)return!0;let{line:te,character:Ee}=L;return typeof te=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,F.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&te===0?this:new k(this.line+Ee,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,F.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Ee===this.line&&te===this.character?this:new k(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};M=k=Be([E],M),e.Position=M;let O=b=class{constructor(L,te,Ee,Ge){let Ze,st;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(Ze=new M(L,te),st=new M(Ee,Ge)):L instanceof M&&te instanceof M&&(Ze=L,st=te),!Ze||!st)throw new Error("Invalid arguments");Ze.isBefore(st)?(this._start=Ze,this._end=st):(this._start=st,this._end=Ze)}static isRange(L){return L instanceof b?!0:L?M.isPosition(L.start)&&M.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof b?this.contains(L._start)&&this.contains(L._end):L instanceof M?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=M.Max(L.start,this._start),Ee=M.Min(L.end,this._end);if(!te.isAfter(Ee))return new b(te,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=M.Min(L.start,this._start),Ee=M.Max(L.end,this.end);return new b(te,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,F.illegalArgument)();let Ee;return L?M.isPosition(L)?Ee=L:(Ee=L.start||this.start,te=L.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&te.isEqual(this.end)?this:new b(Ee,te)}toJSON(){return[this.start,this.end]}};O=b=Be([E],O),e.Range=O;let q=u=class extends O{constructor(L,te,Ee,Ge){let Ze,st;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(Ze=new M(L,te),st=new M(Ee,Ge)):L instanceof M&&te instanceof M&&(Ze=L,st=te),!Ze||!st)throw new Error("Invalid arguments");super(Ze,st);this._anchor=Ze,this._active=st}static isSelection(L){return L instanceof u?!0:L?O.isRange(L)&&M.isPosition(L.anchor)&&M.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=u=Be([E],q),e.Selection=q;class Q{constructor(L,te,Ee){if(typeof L!="string"||L.length===0)throw(0,F.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,F.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,F.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=Q;class $ extends Error{constructor(L,te=y.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L);this._message=L,this._code=te,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(L,te){return new $(L,y.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new $(L,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var z;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var N;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=p=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof p?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new p(L,te)}static insert(L,te){return p.replace(new O(L,L),te)}static delete(L){return p.replace(L,"")}static setEndOfLine(L){const te=new p(new O(new M(0,0),new M(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!O.isRange(L))throw(0,F.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,F.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,F.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=p=Be([E],W),e.TextEdit=W;var j;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,Ee,Ge){this._edits.push({_type:1,from:L,to:te,options:Ee,metadata:Ge})}createFile(L,te,Ee){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:Ee})}deleteFile(L,te,Ee){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:Ee})}replaceNotebookMetadata(L,te,Ee){this._edits.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,Ee,Ge,Ze){let st,ut,St=[],At;if(zt.isNotebookRange(te)&&Ft.isNotebookCellDataArray(Ee)&&!Ft.isNotebookCellDataArray(Ge)?(st=te.start,ut=te.end,St=Ee,At=Ge):typeof te=="number"&&typeof Ee=="number"&&Ft.isNotebookCellDataArray(Ge)&&(st=te,ut=Ee,St=Ge,At=Ze),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||St.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:ut-st,cells:St,metadata:At})}replaceNotebookCellMetadata(L,te,Ee,Ge){this._edits.push({_type:3,metadata:Ge,uri:L,edit:{editType:8,index:te,metadata:Ee}})}replace(L,te,Ee,Ge){this._edits.push({_type:2,uri:L,edit:new W(te,Ee),metadata:Ge})}insert(L,te,Ee,Ge){this.replace(L,new O(te,te),Ee,Ge)}delete(L,te,Ee){this.replace(L,te,"",Ee)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Ee of te)Ee&&this._edits.push({_type:2,uri:L,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ge=this._edits[Ee];Ge._type===2&&Ge.uri.toString()===L.toString()&&(this._edits[Ee]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===L.toString()&&te.push(Ee.edit);return te}entries(){const L=new A.ResourceMap;for(let te of this._edits)if(te._type===2){let Ee=L.get(te.uri);Ee||(Ee=[te.uri,[]],L.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=Be([E],Y),e.WorkspaceEdit=Y;let de=D=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof D?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=D._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const Ee=new D;Ee._tabstop=this._tabstop,L(Ee),this._tabstop=Ee._tabstop,L=Ee.value}else L=D._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const Ee=L.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Ee=new D;Ee._tabstop=this._tabstop,te(Ee),this._tabstop=Ee._tabstop,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};de=D=Be([E],de),e.SnippetString=de;var G;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(G=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(L,te){if(this.uri=L,te)if(te instanceof O)this.range=te;else if(te instanceof M)this.range=new O(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?O.isRange(L.range)&&S.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=Be([E],oe),e.Location=oe;let be=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&S.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};be=Be([E],be),e.DiagnosticRelatedInformation=be;let Ae=class{constructor(L,te,Ee=ue.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Ee}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,c.equals)(L.tags,te.tags)&&(0,c.equals)(L.relatedInformation,te.relatedInformation,be.isEqual)}};Ae=Be([E],Ae),e.Diagnostic=Ae;let Re=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};Re=Be([E],Re),e.Hover=Re;var Oe;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(L,te=Oe.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};Qe=Be([E],Qe),e.DocumentHighlight=Qe;var He;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var je;(function(x){x[x.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let U=r=class{constructor(L,te,Ee,Ge,Ze){this.name=L,this.kind=te,this.containerName=Ze,typeof Ee=="string"&&(this.containerName=Ee),Ge instanceof oe?this.location=Ge:Ee instanceof O&&(this.location=new oe(Ge,Ee)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};U=r=Be([E],U),e.SymbolInformation=U;let K=l=class{constructor(L,te,Ee,Ge,Ze){this.name=L,this.detail=te,this.kind=Ee,this.range=Ge,this.selectionRange=Ze,this.children=[],l.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(l.validate)}};K=l=Be([E],K),e.DocumentSymbol=K;var ee;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(L,te){this.title=L,this.kind=te}};ae=Be([E],ae),e.CodeAction=ae;let V=s=class{constructor(L){this.value=L}append(L){return new s(this.value?this.value+s.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+s.sep)}};V.sep=".",V=s=Be([E],V),e.CodeActionKind=V,V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll");let se=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=Be([E],se),e.SelectionRange=se;class he{constructor(L,te,Ee,Ge,Ze,st){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ge,this.range=Ze,this.selectionRange=st}}e.CallHierarchyItem=he;class Te{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Te;class Ue{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=Ue;var $e;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};Ke=Be([E],Ke),e.CodeLens=Ke;let _e=m=class{constructor(L,te=!1){d.set(this,void 0),et(this,d,new _.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof m?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Me(this,d,"f").value}set value(L){Me(this,d,"f").value=L}get isTrusted(){return Me(this,d,"f").isTrusted}set isTrusted(L){Me(this,d,"f").isTrusted=L}get supportThemeIcons(){return Me(this,d,"f").supportThemeIcons}set supportThemeIcons(L){Me(this,d,"f").supportThemeIcons=L}appendText(L){return Me(this,d,"f").appendText(L),this}appendMarkdown(L){return Me(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Me(this,d,"f").appendCodeblock(te??"",L),this}};d=new WeakMap,_e=m=Be([E],_e),e.MarkdownString=_e;let rt=class{constructor(L,te){this.label=L,this.documentation=te}};rt=Be([E],rt),e.ParameterInformation=rt;let H=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};H=Be([E],H),e.SignatureInformation=H;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Be([E],J),e.SignatureHelp=J;var me;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let Ye=class{constructor(L,te,Ee){this.text=L,this.position=te,this.kind=Ee}};Ye=Be([E],Ye),e.InlayHint=Ye;var tt;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(tt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var at;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(at=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(x){x[x.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let kt=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};kt=Be([E],kt),e.CompletionItem=kt;let ht=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};ht=Be([E],ht),e.CompletionList=ht;let yt=class{constructor(L,te,Ee){this.text=L,this.range=te,this.command=Ee}};yt=Be([E],yt),e.InlineSuggestion=yt;let It=class{constructor(L){this.items=L}};It=Be([E],It),e.InlineSuggestions=It;var ft;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(ft=e.ViewColumn||(e.ViewColumn={}));var Je;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Je=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Et;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Z;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Z=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var le;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(le=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(te){switch(te){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(L,te){if(te&&!S.URI.isUri(te))throw(0,F.illegalArgument)("target");if(!O.isRange(L)||L.isEmpty)throw(0,F.illegalArgument)("range");this.range=L,this.target=te}};ge=Be([E],ge),e.DocumentLink=ge;let fe=class{constructor(L,te,Ee,Ge){this.red=L,this.green=te,this.blue=Ee,this.alpha=Ge}};fe=Be([E],fe),e.Color=fe;let Ie=class{constructor(L,te){if(te&&!(te instanceof fe))throw(0,F.illegalArgument)("color");if(!O.isRange(L)||L.isEmpty)throw(0,F.illegalArgument)("range");this.range=L,this.color=te}};Ie=Be([E],Ie),e.ColorInformation=Ie;let xe=class{constructor(L){if(!L||typeof L!="string")throw(0,F.illegalArgument)("label");this.label=L}};xe=Be([E],xe),e.ColorPresentation=xe;var Le;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var Ve;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ve=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Xe{constructor(L,te,Ee){if(this.startIndex=L,this.length=te,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,F.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,F.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=Xe;var ie;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(ie=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(L){this.options=L,typeof L!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=pe;var re;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var B;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(B=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=v=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,F.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}get id(){return this._id}};Ce.Clean=new v("clean","Clean"),Ce.Build=new v("build","Build"),Ce.Rebuild=new v("rebuild","Rebuild"),Ce.Test=new v("test","Test"),Ce=v=Be([E],Ce),e.TaskGroup=Ce;function Se(x){let L="";for(let te=0;te<x.length;te++)L+=x[te].replace(/,/g,",,")+",";return L}let qe=class{constructor(L,te,Ee){if(typeof L!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ee):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,F.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return Se(L)}};qe=Be([E],qe),e.ProcessExecution=qe;let We=class{constructor(L,te,Ee){if(this._args=[],Array.isArray(te)){if(!L)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,F.illegalArgument)("command");this._command=L,this._args=te,this._options=Ee}else{if(typeof L!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,F.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return Se(L)}};We=Be([E],We),e.ShellExecution=We;var it;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class wt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=wt;let ot=w=class{constructor(L,te,Ee,Ge,Ze,st){this.__deprecated=!1,this._definition=this.definition=L;let ut;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ee,this.execution=Ge,ut=Ze,this.__deprecated=!0):te===mt.Global||te===mt.Workspace?(this.target=te,this._name=this.name=Ee,this._source=this.source=Ge,this.execution=Ze,ut=st):(this.target=te,this._name=this.name=Ee,this._source=this.source=Ge,this.execution=Ze,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(w.EmptyType===te||w.ProcessType===te||w.ShellType===te||w.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ot.ExtensionCallbackType="customExecution",ot.ProcessType="process",ot.ShellType="shell",ot.EmptyType="$empty",ot=w=Be([E],ot),e.Task=ot;var ct;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(L,te=Tt.None){this.collapsibleState=te,S.URI.isUri(L)?this.resourceUri=L:this.label=L}};lt=Be([E],lt),e.TreeItem=lt;var Tt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(L,te){this.id=L,this.color=te}};_t=Be([E],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Ut=class{constructor(L){this.id=L}};Ut=Be([E],Ut),e.ThemeColor=Ut;var Bt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Bt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(L,te){if(typeof L!="string"&&(!L||!S.URI.isUri(L)&&!S.URI.isUri(L.uri)))throw(0,F.illegalArgument)("base");if(typeof te!="string")throw(0,F.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=S.URI.file(L),this.base=L):S.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};Ct=Be([E],Ct),e.RelativePattern=Ct;let $t=class{constructor(L,te,Ee,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=Be([E],$t),e.Breakpoint=$t;let ti=class extends $t{constructor(L,te,Ee,Ge,Ze){super(te,Ee,Ge,Ze);if(L===null)throw(0,F.illegalArgument)("location");this.location=L}};ti=Be([E],ti),e.SourceBreakpoint=ti;let gt=class extends $t{constructor(L,te,Ee,Ge,Ze){super(te,Ee,Ge,Ze);this.functionName=L}};gt=Be([E],gt),e.FunctionBreakpoint=gt;let Yt=class extends $t{constructor(L,te,Ee,Ge,Ze,st,ut){super(Ge,Ze,st,ut);if(!te)throw(0,F.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=Ee}};Yt=Be([E],Yt),e.DataBreakpoint=Yt;let Ht=class{constructor(L,te,Ee){this.command=L,this.args=te||[],this.options=Ee}};Ht=Be([E],Ht),e.DebugAdapterExecutable=Ht;let ii=class{constructor(L,te){this.port=L,this.host=te}};ii=Be([E],ii),e.DebugAdapterServer=ii;let ni=class{constructor(L){this.path=L}};ni=Be([E],ni),e.DebugAdapterNamedPipeServer=ni;let Pt=class{constructor(L){this.implementation=L}};Pt=Be([E],Pt),e.DebugAdapterInlineImplementation=Pt;let Jt=class{constructor(L,te){this.range=L,this.expression=te}};Jt=Be([E],Jt),e.EvaluatableExpression=Jt;var vi;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(vi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,te){this.range=L,this.text=te}};Wt=Be([E],Wt),e.InlineValueText=Wt;let dt=class{constructor(L,te,Ee=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Ee}};dt=Be([E],dt),e.InlineValueVariableLookup=dt;let ri=class{constructor(L,te){this.range=L,this.expression=te}};ri=Be([E],ri),e.InlineValueEvaluatableExpression=ri;let Mt=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};Mt=Be([E],Mt),e.InlineValueContext=Mt;var Vt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Xt=C=class extends Error{constructor(L,te=t.FileSystemProviderErrorCode.Unknown,Ee){super(S.URI.isUri(L)?L.toString(!0):L);this.code=Ee?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(L){return new C(L,t.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(L){return new C(L,t.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(L){return new C(L,t.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(L){return new C(L,t.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(L){return new C(L,t.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(L){return new C(L,t.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Xt=C=Be([E],Xt),e.FileSystemError=Xt;let si=class{constructor(L,te,Ee){this.start=L,this.end=te,this.kind=Ee}};si=Be([E],si),e.FoldingRange=si;var ci;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var di;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(di=e.CommentMode||(e.CommentMode={}));class oi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=oi;function bi(x){return typeof x=="undefined"||(0,I.isStringArray)(x)}class jt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,Ee=L.tokenTypes.length;te<Ee;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,Ee=L.tokenModifiers.length;te<Ee;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,Ee,Ge,Ze){if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"&&(typeof Ze=="number"||typeof Ze=="undefined"))return typeof Ze=="undefined"&&(Ze=0),this._pushEncoded(L,te,Ee,Ge,Ze);if(O.isRange(L)&&typeof te=="string"&&bi(Ee))return this._push(L,te,Ee);throw(0,F.illegalArgument)()}_push(L,te,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,Ze=L.start.character,st=L.end.character-L.start.character,ut=this._tokenTypeStrToInt.get(te);let St=0;if(Ee)for(const At of Ee){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);St|=1<<Lt>>>0}this._pushEncoded(Ge,Ze,st,ut,St)}_pushEncoded(L,te,Ee,Ge,Ze){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Lt=0;for(let Ot=0;Ot<St;Ot++){let Nt=this._data[5*Ot],li=this._data[5*Ot+1];Nt===0?(Nt=At,li+=Lt):Nt+=At,this._data[5*Ot]=Nt,this._data[5*Ot+1]=li,At=Nt,Lt=li}}let st=L,ut=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Ze,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const Ee=L.length/5|0;for(let ut=0;ut<Ee;ut++)te[ut]=ut;te.sort((ut,St)=>{const At=L[5*ut],Lt=L[5*St];if(At===Lt){const Ot=L[5*ut+1],Nt=L[5*St+1];return Ot-Nt}return At-Lt});const Ge=new Uint32Array(L.length);let Ze=0,st=0;for(let ut=0;ut<Ee;ut++){const St=5*te[ut],At=L[St+0],Lt=L[St+1],Ot=L[St+2],Nt=L[St+3],li=L[St+4],xi=At-Ze,qi=xi===0?Lt-st:Lt,ui=5*ut;Ge[ui+0]=xi,Ge[ui+1]=qi,Ge[ui+2]=Ot,Ge[ui+3]=Nt,Ge[ui+4]=li,Ze=At,st=Lt}return Ge}build(L){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),L):new qt(jt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=jt;class qt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=qt;class Ei{constructor(L,te,Ee){this.start=L,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=Ei;class _i{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=_i;var Gt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new _t("arrow-left")},Zt=Be([E],Zt),e.QuickInputButtons=Zt;var Si;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,te,Ee){this.badge=L,this.tooltip=te,this.color=Ee}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let Kt=class{constructor(L){this.kind=L}};Kt=Be([E],Kt),e.ColorTheme=Kt;var hi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(hi=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(L,te){if(L<0)throw(0,F.illegalArgument)("start must be positive");if(te<0)throw(0,F.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof zt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,Ee=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Ee=L.end),te===this._start&&Ee===this._end?this:new zt(te,Ee)}}e.NotebookRange=zt;class Ft{constructor(L,te,Ee,Ge,Ze,st,ut){this.kind=L,this.value=te,this.languageId=Ee,this.mime=Ge,this.outputs=Ze??[],this.metadata=st,this.executionSummary=ut,Ft.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Ft.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Ft;class Fe{constructor(L){this.cells=L}}e.NotebookData=Fe;class Rt{constructor(L,te){this.data=L,this.mime=te;const Ee=(0,T.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(L){return L instanceof Rt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Rt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Rt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Rt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Rt(L,te)}static text(L,te=T.Mimes.text){const Ee=Me(Rt,o,"f",a).encode(String(L));return new Rt(Ee,te)}static json(L,te="application/json"){const Ee=JSON.stringify(L,void 0,"	");return Rt.text(Ee,te)}}e.NotebookCellOutputItem=Rt,o=Rt,a={value:new TextEncoder};class Qt{constructor(L,te,Ee){this.items=Qt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,P.generateUuid)(),this.metadata=te??Ee)}static isNotebookCellOutput(L){return L instanceof Qt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,I.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Ee=new Set,Ge=new Set;for(let Ze=0;Ze<L.length;Ze++){const st=L[Ze],ut=(0,T.normalizeMimeType)(st.mime);if(!Ee.has(ut)){Ee.add(ut);continue}Ge.add(Ze),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ge.size===0?L:L.filter((Ze,st)=>!Ge.has(st))}}e.NotebookCellOutput=Qt;var pt;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(fi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class mi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=mi;var Ii;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(L,te=[]){this.uri=L,this.provides=(0,c.asArray)(te)}}e.NotebookRendererScript=Pi;let ai=class{constructor(L,te){this.label=L,this.timestamp=te}};ai=Be([E],ai),e.TimelineItem=ai;var Ti;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var gi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(gi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Ri;class Fi{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(L,te,Ee){this.include=L,this.exclude=te,this.profile=Ee}};X=Be([E],X),e.TestRunRequest=X;let ce=R=class{constructor(L){this.message=L}static diff(L,te,Ee){const Ge=new R(L);return Ge.expectedOutput=te,Ge.actualOutput=Ee,Ge}};ce=R=Be([E],ce),e.TestMessage=ce;let ke=class{constructor(L,te){if(this.id=L,this.label=te,/\s/.test(L))throw new Error(`Test tag ID "${L}" may not include whitespace`)}};ke=Be([E],ke),e.TestTag=ke;let nt=class{constructor(L,te){this.covered=L,this.total=te}};nt=Be([E],nt),e.CoveredCount=nt;let bt=f=class{constructor(L,te,Ee,Ge){this.uri=L,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ge}static fromDetails(L,te){const Ee=new nt(0,0),Ge=new nt(0,0),Ze=new nt(0,0);for(const ut of te)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const St of ut.branches)Ge.total+=1,Ge.covered+=St.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=ut.executionCount>0?1:0;const st=new f(L,Ee,Ge.total>0?Ge:void 0,Ze.total>0?Ze:void 0);return st.detailedCoverage=te,st}};bt=f=Be([E],bt),e.FileCoverage=bt;let Dt=class{constructor(L,te,Ee=[]){this.executionCount=L,this.location=te,this.branches=Ee}};Dt=Be([E],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(L,te){this.executionCount=L,this.location=te}};Oi=Be([E],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(L,te){this.executionCount=L,this.location=te}};Ni=Be([E],Ni),e.FunctionCoverage=Ni;var zi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Hi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(L,te,Ee,Ge,Ze,st){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ge,this.range=Ze,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(ve[89],we([0,1,39,11,9,228,146,6,16]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(o,a){a?P.set(o,a):P.delete(o)}e.setWordDefinitionFor=t;function y(o){return P.get(o)}e.getWordDefinitionFor=y;class n extends A.MirrorTextModel{constructor(a,g,k,b,u,p,D,i){super(g,k,b,u);this._proxy=a,this._languageId=p,this._isDirty=D,this._notebook=i,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,S.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===F.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(g){return g?a._getTextInRange(g):a.getText()},get eol(){return a._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(g){return a._lineAt(g)},offsetAt(g){return a._offsetAt(g)},positionAt(g){return a._positionAt(g)},validateRange(g){return a._validateRange(g)},validatePosition(g){return a._validatePosition(g)},getWordRangeAtPosition(g,k){return a._getWordRangeAtPosition(g,k)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,c.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,c.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const g=this._validateRange(a);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const k=this._eol,b=g.start.line,u=g.end.line,p=[];p.push(this._lines[b].substring(g.start.character));for(let D=b+1;D<u;D++)p.push(this._lines[D]);return p.push(this._lines[u].substring(0,g.end.character)),p.join(k)}_lineAt(a){let g;if(a instanceof I.Position?g=a.line:typeof a=="number"&&(g=a),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new d(g,this._lines[g],g===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(a),k=this._lines[g.index].length;return new I.Position(g.index,Math.min(g.remainder,k))}_validateRange(a){if(!(a instanceof I.Range))throw new Error("Invalid argument");const g=this._validatePosition(a.start),k=this._validatePosition(a.end);return g===a.start&&k===a.end?a:new I.Range(g.line,g.character,k.line,k.character)}_validatePosition(a){if(!(a instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:g,character:k}=a,b=!1;if(g<0)g=0,k=0,b=!0;else if(g>=this._lines.length)g=this._lines.length-1,k=this._lines[g].length,b=!0;else{const u=this._lines[g].length;k<0?(k=0,b=!0):k>u&&(k=u,b=!0)}return b?new I.Position(g,k):a}_getWordRangeAtPosition(a,g){const k=this._validatePosition(a);if(!g)g=y(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const b=(0,T.getWordAtText)(k.character+1,(0,T.ensureValidWordDefinition)(g),this._lines[k.line],0);if(b)return new I.Range(k.line,b.startColumn-1,k.line,b.endColumn-1)}}e.ExtHostDocumentData=n;class d{constructor(a,g,k){this._line=a,this._text=g,this._isLastLine=k}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(ve[155],we([0,1,6,3,229,7,54,20,2,36]),function(ne,e,c,F,_,A,T,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,d,o,a){this._notebook=o,this._selector=a,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(k=>{const b=this._cellUris.get(k.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=k=>{k===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(k=>g(k.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const n=[],d=[];for(const o of this._notebook.getCells())o.kind===c.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),d.push(o.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(n){if(!n){let b="";for(const u of this._cells)b+=u.document.getText()+`
`;return b=b.slice(0,-1),b}if(n.isEmpty)return"";const d=this.locationAt(n.start),o=this.locationAt(n.end),a=this._cellUris.get(d.uri),g=this._cellUris.get(o.uri);if(a===void 0||g===void 0)return"";if(a===g)return this._cells[a].document.getText(new c.Range(d.range.start,o.range.end));const k=[this._cells[a].document.getText(new c.Range(d.range.start,new c.Position(this._cells[a].document.lineCount,0)))];for(let b=a+1;b<g;b++)k.push(this._cells[b].document.getText());return k.push(this._cells[g].document.getText(new c.Range(new c.Position(0,0),o.range.end))),k.join(`
`)}offsetAt(n){const d=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(d.index-1),a=this._cells[d.index].document.offsetAt(n.with(d.remainder));return o+a}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),a=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(a)}const d=this._cellUris.get(n.uri);if(d!==void 0){const o=this._cellLines.getPrefixSum(d-1);return new c.Position(o+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const d=this._cellLines.getIndexOf(n.start.line);let o=d;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const a=new c.Position(d.remainder,n.start.character),g=new c.Position(o.remainder,n.end.character),k=new c.Range(a,g),b=this._cells[d.index];return new c.Location(b.document.uri,b.document.validateRange(k))}contains(n){return this._cellUris.has(n)}validateRange(n){const d=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(d,o)}validatePosition(n){const d=this._cellLines.getIndexOf(n.line),o=new c.Position(d.remainder,n.character),a=this._cells[d.index].document.validatePosition(o),g=this._cellLines.getPrefixSum(d.index-1);return new c.Position(g+a.line,a.character)}}e.ExtHostNotebookConcatDocument=t}),define(ve[156],we([0,1,6,12,3]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(I){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let S=I==="light"?c.ColorThemeKind.Light:I==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([ze(0,F.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ve[67],we([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class F{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=F}),define(ve[157],we([0,1,23]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let P=this.buffers.indexOf(S);return P<0&&(P=this.buffers.length,this.buffers.push(S)),P}}function _(I,S){if(S.serializeBuffersForPostMessage){const P=new F,t=(d,o)=>{if(o instanceof ArrayBuffer){const a=P.add(o);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(o)){const a=A(o);if(a){const g=P.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:a,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},y=JSON.stringify(I,t),n=P.buffers.map(d=>{const o=new Uint8Array(d);return c.VSBuffer.wrap(o)});return{message:y,buffers:n}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=_;function A(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(I,S){const P=S.map(n=>{const d=new ArrayBuffer(n.byteLength);return new Uint8Array(d).set(n.buffer),d}),t=S.length?(n,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const o=d,{index:a}=o,g=P[a];if(o.view)switch(o.view.type){case 1:return new Int8Array(g,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return d}:void 0;return{message:JSON.parse(I,t),arrayBuffers:P}}e.deserializeWebviewMessage=T}),define(ve[158],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(F){function _(T){const I={items:new Map};return T.types.forEach((S,P)=>{I.items.set(S,{asString:async()=>T.items[P].asString})}),I}F.toITreeDataTransfer=_;async function A(T){const I={types:[],items:[]},S=Array.from(T.items.entries());for(const P of S)I.types.push(P[0]),I.items.push({asString:await P[1].asString()});return I}F.toTreeDataTransferDTO=A})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[68],we([0,1,11,2]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(I,S){return I.scheme===c.Schemas.http||I.scheme===c.Schemas.https?I:(S&&S.authority&&S.isRemote&&I.scheme===c.Schemas.file&&(I=F.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:I.path})),F.URI.from({scheme:c.Schemas.https,authority:`${I.scheme}+${A(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=_;function A(I){return I.replace(/./g,S=>{const P=S.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?S:"-"+P.toString(16).padStart(4,"0")})}function T(I){return I.replace(/-([0-9a-f]{4})/g,(S,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=T}),define(ve[159],we([0,1,3,7,68]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(I,S,P){this._proxy=I,this._editors=S,this._initData=P,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const t=S.getVisibleTextEditors();for(const y of this._insets.values())t.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,S,P,t,y){let n;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===I){n=u;break}if(!n)throw new Error("not a visible editor");const d=this,o=this._handlePool++,a=new c.Emitter,g=new c.Emitter,k=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,_.asWebviewUri)(u,d._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(u){this._options=u,d._proxy.$setOptions(o,u)}get options(){return this._options}set html(u){this._html=u,d._proxy.$setHtml(o,u)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(u){return d._proxy.$postMessage(o,u)}},b=new class{constructor(){this.editor=I,this.line=S,this.height=P,this.webview=k,this.onDidDispose=g.event}dispose(){d._insets.has(o)&&(d._insets.delete(o),d._proxy.$disposeEditorInset(o),g.fire(),g.dispose(),a.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,S+1,P,t||{},y.identifier,y.extensionLocation),this._insets.set(o,{editor:I,inset:b,onDidReceiveMessage:a}),b}$onDidDispose(I){const S=this._insets.get(I);S&&S.inset.dispose()}$onDidReceiveMessage(I,S){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(ve[160],we([0,1,128,10,2,7,4,42,28,16,11]),function(ne,e,c,F,_,A,T,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,c.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(12,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(13,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(14,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(15,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,c.localize)(17,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,c.localize)(18,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,c.localize)(19,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(20,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,c.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function y(f){return typeof f?.getViewState=="function"}e.isTextEditorPane=y;function n(f){if(u(f))return!1;const E=f;return _.URI.isUri(E?.resource)}e.isResourceEditorInput=n;function d(f){if(u(f))return!1;const E=f;return E?.original!==void 0&&E.modified!==void 0}e.isResourceDiffEditorInput=d;function o(f){if(u(f))return!1;const E=f;return E?E.resource===void 0||E.resource.scheme===t.Schemas.untitled||E.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=o;var a;(function(f){f[f.SHORT=0]="SHORT",f[f.MEDIUM=1]="MEDIUM",f[f.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var g;(function(f){f[f.EXPLICIT=1]="EXPLICIT",f[f.AUTO=2]="AUTO",f[f.FOCUS_CHANGE=3]="FOCUS_CHANGE",f[f.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g=e.SaveReason||(e.SaveReason={}));var k;(function(f){f[f.None=0]="None",f[f.Readonly=2]="Readonly",f[f.Untitled=4]="Untitled",f[f.Singleton=8]="Singleton",f[f.RequiresTrust=16]="RequiresTrust"})(k=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class b extends A.Disposable{}e.AbstractEditorInput=b;function u(f){return f instanceof b}e.isEditorInput=u;function p(f){const E=f;return _.URI.isUri(E?.preferredResource)}function D(f){const E=f;return u(E?.primary)&&u(E?.secondary)}e.isSideBySideEditorInput=D;function i(f){return u(f?.editor)}e.isEditorInputWithOptions=i;function r(f){const E=f;return i(f)&&E?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function l(f){const E=f;return typeof E?.groupId=="number"&&u(E.editor)}e.isEditorIdentifier=l;var s;(function(f){f[f.PRIMARY=1]="PRIMARY",f[f.SECONDARY=2]="SECONDARY",f[f.BOTH=3]="BOTH"})(s=e.SideBySideEditor||(e.SideBySideEditor={}));class m{getOriginalUri(E,h){if(!E)return;const M=D(E)?E.primary:d(E)?E.modified:void 0,O=D(E)?E.secondary:d(E)?E.original:void 0;if(h?.supportSideBySide&&M&&O){if(h?.supportSideBySide===s.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:h.filterByScheme}),secondary:this.getOriginalUri(O,{filterByScheme:h.filterByScheme})};E=h.supportSideBySide===s.PRIMARY?M:O}if(d(E))return;const q=p(E)?E.preferredResource:E.resource;return!q||!h||!h.filterByScheme?q:this.filterUri(q,h.filterByScheme)}getCanonicalUri(E,h){if(!E)return;const M=D(E)?E.primary:d(E)?E.modified:void 0,O=D(E)?E.secondary:d(E)?E.original:void 0;if(h?.supportSideBySide&&M&&O){if(h?.supportSideBySide===s.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:h.filterByScheme}),secondary:this.getCanonicalUri(O,{filterByScheme:h.filterByScheme})};E=h.supportSideBySide===s.PRIMARY?M:O}if(d(E))return;const q=E.resource;return!q||!h||!h.filterByScheme?q:this.filterUri(q,h.filterByScheme)}filterUri(E,h){if(Array.isArray(h)){if(h.some(M=>E.scheme===M))return E}else if(h===E.scheme)return E}}e.EditorResourceAccessor=new m;var v;(function(f){f[f.LEFT=0]="LEFT",f[f.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class w{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(E){const h=this.instantiationService=E.get(T.IInstantiationService);for(const[M,O]of this.editorSerializerConstructors)this.createEditorSerializer(M,O,h);this.editorSerializerConstructors.clear()}createEditorSerializer(E,h,M){const O=M.createInstance(h);this.editorSerializerInstances.set(E,O)}registerFileEditorFactory(E){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=E}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(E,h){if(this.editorSerializerConstructors.has(E)||this.editorSerializerInstances.has(E))throw new Error(`A editor serializer with type ID '${E}' was already registered.`);return this.instantiationService?this.createEditorSerializer(E,h,this.instantiationService):this.editorSerializerConstructors.set(E,h),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(E),this.editorSerializerInstances.delete(E)})}getEditorSerializer(E){return this.editorSerializerInstances.get(typeof E=="string"?E:E.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new w);async function C(f,E){if(!f||!f.length)return[];const h=await Promise.all(f.map(async M=>{const O=_.URI.revive(M.fileUri);if(!O||(await E.activateProvider(O.scheme),!E.canHandleResource(O)))return;const q=typeof M.exists=="boolean"?M.exists:await E.exists(O);if(!q&&M.openOnlyIfExists)return;const Q=q&&!(0,F.isUndefined)(M.selection)?{selection:M.selection,pinned:!0,override:M.editorOverrideId}:{pinned:!0,override:M.editorOverrideId};let $;return q?$={resource:O,options:Q,forceFile:!0}:$={resource:O,options:Q,forceUntitled:!0},$}));return(0,P.coalesce)(h)}e.pathsToEditors=C;var R;(function(f){f[f.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",f[f.SEQUENTIAL=1]="SEQUENTIAL"})(R=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[161],we([0,1,3,42,129,4,7,20,28,16,50,22,34,151]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",n.Codicon.window,(0,_.localize)(0,null));var o;(function(m){m.ViewContainersRegistry="workbench.registry.view.containers",m.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var a;(function(m){m[m.Sidebar=0]="Sidebar",m[m.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function g(m){switch(m){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=g;function k(m){return`viewContainer.${m}.enabled`}e.getEnabledViewContainerContextKey=k;class b extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(v,w,C){const R=this.get(v.id);if(R)return R;const f=v;return f.openCommandActionDescriptor=C?.donotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,I.getOrSet)(this.viewContainers,w,[]).push(f),C?.isDefault&&this.defaultViewContainers.push(f),this._onDidRegister.fire({viewContainer:f,viewContainerLocation:w}),f}deregisterViewContainer(v){for(const w of this.viewContainers.keys()){const C=this.viewContainers.get(w),R=C?.indexOf(v);if(R!==-1){C?.splice(R,1),C.length===0&&this.viewContainers.delete(w),this._onDidDeregister.fire({viewContainer:v,viewContainerLocation:w});return}}}get(v){return this.all.filter(w=>w.id===v)[0]}getViewContainers(v){return[...this.viewContainers.get(v)||[]]}getViewContainerLocation(v){return[...this.viewContainers.keys()].filter(w=>this.getViewContainers(w).filter(C=>C?.id===v.id).length>0)[0]}getDefaultViewContainer(v){return this.defaultViewContainers.find(w=>this.getViewContainerLocation(w)===v)}}S.Registry.add(o.ViewContainersRegistry,new b);var u;(function(m){m.Open="2_open",m.Debug="4_debug",m.SCM="5_scm",m.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function p(m,v){const w=m.group??u.More,C=v.group??u.More;return w!==C?w.localeCompare(C):(m.order??5)-(v.order??5)}class D extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(v,w){this.registerViews2([{views:v,viewContainer:w}])}registerViews2(v){v.forEach(({views:w,viewContainer:C})=>this.addViews(w,C)),this._onViewsRegistered.fire(v)}deregisterViews(v,w){const C=this.removeViews(v,w);C.length&&this._onViewsDeregistered.fire({views:C,viewContainer:w})}moveViews(v,w){for(const C of this._views.keys())if(C!==w){const R=this.removeViews(v,C);R.length&&(this.addViews(R,w),this._onDidChangeContainer.fire({views:R,from:C,to:w}))}}getViews(v){return this._views.get(v)||[]}getView(v){for(const w of this._viewContainers){const C=(this._views.get(w)||[]).filter(R=>R.id===v)[0];if(C)return C}return null}getViewContainer(v){for(const w of this._viewContainers)if((this._views.get(w)||[]).filter(R=>R.id===v)[0])return w;return null}registerViewWelcomeContent(v,w){return this._viewWelcomeContents.add(v,w),this._onDidChangeViewWelcomeContent.fire(v),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(v,w),this._onDidChangeViewWelcomeContent.fire(v)})}registerViewWelcomeContent2(v,w){const C=new Map;for(const[R,f]of w)this._viewWelcomeContents.add(v,f),C.set(R,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(v,f),this._onDidChangeViewWelcomeContent.fire(v)}));return this._onDidChangeViewWelcomeContent.fire(v),C}getViewWelcomeContent(v){const w=[];return this._viewWelcomeContents.forEach(v,C=>w.push(C)),w.sort(p)}addViews(v,w){let C=this._views.get(w);C||(C=[],this._views.set(w,C),this._viewContainers.push(w));for(const R of v){if(this.getView(R.id)!==null)throw new Error((0,_.localize)(1,null,R.id));C.push(R)}}removeViews(v,w){const C=this._views.get(w);if(!C)return[];const R=[],f=[];for(const E of C)v.includes(E)?R.push(E):f.push(E);return R.length&&(f.length?this._views.set(w,f):(this._views.delete(w),this._viewContainers.splice(this._viewContainers.indexOf(w),1))),R}}S.Registry.add(o.ViewsRegistry,new D),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,_.localize)(2,null));function i(m){return`view.${m}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var r;(function(m){m[m.Default=0]="Default",m[m.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var l;(function(m){m[m.None=0]="None",m[m.Collapsed=1]="Collapsed",m[m.Expanded=2]="Expanded"})(l=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(v,w){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,v),this._hasResolve=!!w,this.resolve=async C=>{if(w&&!this.resolved){const R=await w(C);R&&(this.tooltip=this.tooltip??R.tooltip,this.command=this.command??R.command)}C.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(ve[162],we([0,1,3,13,130]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,S,P,t){const y={command:I};if(S&&Object.keys(S).length>0&&(y.arguments=S),this.internalSend("request",y),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const d=this.pendingRequests.get(y.seq);if(d){this.pendingRequests.delete(y.seq);const o={type:"response",seq:0,request_seq:y.seq,success:!1,command:I,message:(0,_.localize)(0,null,t,I)};d(o)}},t)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,S){return I.type!=="event"||S.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,F.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const S=I,P=this.pendingRequests.get(S.request_seq);P&&(this.pendingRequests.delete(S.request_seq),P(S));break}}}internalSend(I,S){S.type=I,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((S,P)=>I.set(P,S)),await(0,F.timeout)(500),I.forEach((S,P)=>{S({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ve[163],we([0,1,9,2,17,22,11]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function S(l,s,m){return l.replace(I,function(v,w){return s&&w.length>0&&w[0]!=="_"?v:m&&m.hasOwnProperty(w)?m[w]:v})}e.formatPII=S;function P(l){const s={};for(const m of Object.keys(l))m.startsWith("!")||(s[m]=l[m]);return s}e.filterExceptionsFromTelemetry=P;function t(l){return l.configuration.request==="attach"&&!y(l)&&(!l.parentSession||t(l.parentSession))}e.isSessionAttach=t;function y(l){let s=l.configuration.type;if(!!s)return s==="vslsShare"&&(s=l.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(s,"extensionhost")||(0,c.equalsIgnoreCase)(s,"pwa-extensionhost")?l:l.parentSession?y(l.parentSession):void 0}e.getExtensionHostDebugSession=y;function n(l){return l.type&&(l.label||l.program||l.runtime)}e.isDebuggerMainContribution=n;function d(l,s,m){let v,w=0,C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,R=null;for(;R=C.exec(l);){let f=R.index+1,E=f+R[0].length;if(f<=s&&E>=m){v=R[0],w=f;break}}if(v){let f=/\w+/g,E=null;for(;(E=f.exec(v))&&!(E.index+1+w+E[0].length>=m););E&&(v=v.substring(0,f.lastIndex))}return v?{start:w,end:w+v.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(l){return!!(l&&l.match(o))}e.isUri=a;function g(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(a(l.path))return F.URI.parse(l.path);if((0,_.isAbsolute)(l.path))return F.URI.file(l.path)}return l.path}function k(l){if(typeof l.path=="object"){const s=F.URI.revive(l.path);if(s)return s.scheme===T.Schemas.file?s.fsPath:s.toString()}return l.path}function b(l,s){const m=s?g:k,v=(0,A.deepClone)(l);return p(v,(w,C)=>{w&&C&&(C.path=m(C))}),v}e.convertToDAPaths=b;function u(l,s){const m=s?g:k,v=(0,A.deepClone)(l);return p(v,(w,C)=>{!w&&C&&(C.path=m(C))}),v}e.convertToVSCPaths=u;function p(l,s){switch(l.type){case"event":const m=l;switch(m.event){case"output":s(!1,m.body.source);break;case"loadedSource":s(!1,m.body.source);break;case"breakpoint":s(!1,m.body.breakpoint.source);break;default:break}break;case"request":const v=l;switch(v.command){case"setBreakpoints":s(!0,v.arguments.source);break;case"breakpointLocations":s(!0,v.arguments.source);break;case"source":s(!0,v.arguments.source);break;case"gotoTargets":s(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(C=>s(!1,C));break;default:break}break;case"response":const w=l;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(C=>s(!1,C.source));break;case"loadedSources":w.body.sources.forEach(C=>s(!1,C));break;case"scopes":w.body.scopes.forEach(C=>s(!1,C.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(C=>s(!1,C.source));break;case"setBreakpoints":w.body.breakpoints.forEach(C=>s(!1,C.source));break;default:break}break}}function D(l){return l.filter(s=>!s.presentation?.hidden).sort((s,m)=>s.presentation?m.presentation?s.presentation.group?m.presentation.group?s.presentation.group!==m.presentation.group?s.presentation.group.localeCompare(m.presentation.group):i(s.presentation.order,m.presentation.order):-1:m.presentation.group?1:i(s.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=D;function i(l,s){return typeof l!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:l-s}async function r(l,s){const m=l.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorMode});if(m!=="none"&&(await s.saveAll(),m==="allEditorsInActiveGroup")){const v=s.activeEditorPane;v&&await s.save({editor:v.input,groupId:v.group.id})}await l.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(ve[90],we([0,1,27,79,11,17,25,42]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(f){f[f.Markup=1]="Markup",f[f.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(f){f[f.Running=1]="Running",f[f.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(f){f[f.Pending=2]="Pending",f[f.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(f){f[f.WithHardKernelDependency=0]="WithHardKernelDependency",f[f.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",f[f.Pure=2]="Pure",f[f.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(f){f.Always="always",f.Never="never",f.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(f){f[f.ModelChange=1]="ModelChange",f[f.Move=2]="Move",f[f.ChangeLanguage=5]="ChangeLanguage",f[f.Initialize=6]="Initialize",f[f.ChangeCellMetadata=7]="ChangeCellMetadata",f[f.Output=8]="Output",f[f.OutputItem=9]="OutputItem",f[f.ChangeCellContent=10]="ChangeCellContent",f[f.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",f[f.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",f[f.ChangeCellMime=13]="ChangeCellMime",f[f.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(f){f[f.Handle=0]="Handle",f[f.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(f){f[f.Replace=1]="Replace",f[f.Output=2]="Output",f[f.Metadata=3]="Metadata",f[f.CellLanguage=4]="CellLanguage",f[f.DocumentMetadata=5]="DocumentMetadata",f[f.Move=6]="Move",f[f.OutputItems=7]="OutputItems",f[f.PartialMetadata=8]="PartialMetadata",f[f.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var g;(function(f){f.scheme=_.Schemas.vscodeNotebookCell;const E=/^ch(\d{7,})/;function h($,z){return $.with({scheme:f.scheme,fragment:`ch${z.toString().padStart(7,"0")}${$.scheme!==_.Schemas.file?$.scheme:""}`})}f.generate=h;function M($){if($.scheme!==f.scheme)return;const z=E.exec($.fragment);return z?{handle:Number(z[1]),notebook:$.with({scheme:$.fragment.substr(z[0].length)||_.Schemas.file,fragment:null})}:void 0}f.parse=M;function O($){if($.scheme!==_.Schemas.vscodeNotebookCellMetadata)return;const z=E.exec($.fragment);return z?{handle:Number(z[1]),notebook:$.with({scheme:$.fragment.substr(z[0].length)||_.Schemas.file,fragment:null})}:void 0}f.parseCellMetadataUri=O;function q($,z,N){return $.with({scheme:N,fragment:`ch${z.toString().padStart(7,"0")}${$.scheme!==_.Schemas.file?$.scheme:""}`})}f.generateCellUri=q;function Q($,z){if($.scheme!==z)return;const N=E.exec($.fragment);return N?{handle:Number(N[1]),notebook:$.with({scheme:$.fragment.substr(N[0].length)||_.Schemas.file,fragment:null})}:void 0}f.parseCellUri=Q})(g=e.CellUri||(e.CellUri={}));const k=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(f){return k.get(f)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function u(f){return k.get(f)?.supportedByCore??!1}e.mimeTypeSupportedByCore=u;function p(f){return k.get(f)?.mergeable??!1}e.mimeTypeIsMergeable=p;function D(f,E){return T.isWindows&&(f=f.replace(/\//g,"\\"),E=E.replace(/\//g,"\\")),c.match(f,E)}function i(f,E,h){let M=0;for(let O=0;O<E.length;O++){if(D(E[O],f))return M;M++}for(let O=0;O<h.length;O++){if(D(h[O],f))return M;M++}return M}function r(f,E,h){return f.sort((M,O)=>i(M,E,h)-i(O,E,h))}e.sortMimeTypes=r;function l(f,E,h,M=(O,q)=>O===q){const O=[];function q(z,N,W){if(N===0&&W.length===0)return;const j=O[O.length-1];j&&j.start+j.deleteCount===z?(j.deleteCount+=N,j.toInsert.push(...W)):O.push({start:z,deleteCount:N,toInsert:W})}let Q=0,$=0;for(;;){if(Q===f.length){q(Q,0,E.slice($));break}if($===E.length){q(Q,f.length-Q,[]);break}const z=f[Q],N=E[$];if(M(z,N)){Q+=1,$+=1;continue}h(N)?(q(Q,1,[]),Q+=1):(q(Q,0,[N]),$+=1)}return O}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(f){f.default="default",f.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function m(f){const E=f;return!!((typeof E.include=="string"||c.isRelativePattern(E.include))&&(typeof E.exclude=="string"||c.isRelativePattern(E.exclude)))}e.isDocumentExcludePattern=m;function v(f,E,h){if(Array.isArray(f.viewType)&&f.viewType.indexOf(E)>=0||f.viewType===E)return!0;if(f.filenamePattern){let M=m(f.filenamePattern)?f.filenamePattern.include:f.filenamePattern,O=m(f.filenamePattern)?f.filenamePattern.exclude:void 0;if(c.match(M,(0,A.basename)(h.fsPath).toLowerCase()))return!(O&&c.match(O,(0,A.basename)(h.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class w{constructor(E){this.textModel=E}getElements(){const E=new Int32Array(this.textModel.cells.length);for(let h=0;h<this.textModel.cells.length;h++)E[h]=this.textModel.cells[h].getHashValue();return E}}e.CellSequence=w,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var C;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(C=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(E){return`${R._prefix}${E}`}static parse(E){if(E.startsWith(R._prefix))return E.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(ve[164],we([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState",_[_.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(ve[165],we([0,1,132,4,42]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[166],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=c;function F(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=F}),define(ve[91],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var F;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var A;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&(y.item=y.item?Object.assign(y.item,n.item):n.item)};e.applyTestItemUpdate=T;var I;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var S;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,d){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const d=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const a=o[1];if(a.parent){if(this.items.has(a.parent)){const g=this.items.get(a.parent);g.children.add(a.item.extId);const k=this.createItem(a,g);this.items.set(a.item.extId,k),d.add(k)}}else{const g=this.createItem(a);this.roots.add(g),this.items.set(a.item.extId,g),d.add(g)}a.expand===2&&this.busyControllerCount++;break}case 1:{const a=o[1],g=this.items.get(a.extId);if(!g)break;a.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,a.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,a),d.update(g);break}case 2:{const a=this.items.get(o[1]);if(!a)break;a.parent?this.items.get(a.parent).children.delete(a.item.extId):this.roots.delete(a);const g=[[o[1]]];for(;g.length;)for(const k of g.pop()){const b=this.items.get(k);b&&(g.push(b.children),this.items.delete(k),d.remove(b,b!==a),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}d.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(ve[69],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(A){A.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class _{constructor(T,I=T.length){if(this.path=T,this.viewEnd=I,T.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,I,S=T.parent){if(T.id===I)return new _([I]);let P=[T.id];for(let t=S;t&&t.id!==I;t=t.parent)P.push(t.id);return P.push(I),new _(P.reverse())}static isRoot(T){return!T.includes("\0")}static fromString(T){return new _(T.split("\0"))}static join(T,I){return new _([...T.path,I])}static joinToString(T,I){return T.toString()+"\0"+I}static compare(T,I){return T===I?0:I.startsWith(T+"\0")?2:T.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new _(this.path,T)}compare(T){if(typeof T=="string")return _.compare(this.toString(),T);for(let I=0;I<T.viewEnd&&I<this.viewEnd;I++)if(T.path[I]!==this.path[I])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=_}),define(ve[167],we([0,1,17,61,10,22,25,78,133]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,n,d){this._contributedVariables=new Map,this._context=y,this._labelService=n,d&&(this._envVariablesPromise=d.then(o=>this.prepareEnv(o)))}prepareEnv(y){if(T.isWindows){const n=Object.create(null);return Object.keys(y).forEach(d=>{n[d.toLowerCase()]=y[d]}),n}return y}resolveWithEnvironment(y,n,d){return this.recursiveResolve(this.prepareEnv(y),n?n.uri:void 0,d)}async resolveAsync(y,n){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,n)}async resolveAnyBase(y,n,d,o){const a=A.deepClone(n);return T.isWindows&&a.windows?Object.keys(a.windows).forEach(g=>a[g]=a.windows[g]):T.isMacintosh&&a.osx?Object.keys(a.osx).forEach(g=>a[g]=a.osx[g]):T.isLinux&&a.linux&&Object.keys(a.linux).forEach(g=>a[g]=a.linux[g]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,a,d,o)}async resolveAnyAsync(y,n,d){return this.resolveAnyBase(y,n,d)}async resolveAnyMap(y,n,d){const o=new Map;return{newConfig:await this.resolveAnyBase(y,n,d,o),resolvedVariables:o}}resolveWithInteractionReplace(y,n,d,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,n,d,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,n){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,n)}recursiveResolve(y,n,d,o,a){if(_.isString(d))return this.resolveString(y,n,d,o,a);if(_.isArray(d))return d.map(g=>this.recursiveResolve(y,n,g,o,a));if(_.isObject(d)){let g=Object.create(null);return Object.keys(d).forEach(k=>{const b=this.resolveString(y,n,k,o,a);g[b]=this.recursiveResolve(y,n,d[k],o,a)}),g}return d}resolveString(y,n,d,o,a){return d.replace(P.VARIABLE_REGEXP,(k,b)=>{if(b.includes(P.VARIABLE_LHS))return k;let u=this.evaluateSingleVariable(y,k,b,n,o);return a&&a.set(b,u),u!==k&&_.isString(u)&&u.match(P.VARIABLE_REGEXP)&&(u=this.resolveString(y,n,u,o,a)),u})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,n,d,o,a){let g;const k=d.split(":");k.length>1&&(d=k[0],g=k[1]);const b=()=>{const D=this._context.getFilePath();if(D)return D;throw new Error((0,S.localize)(0,null,n))},u=()=>{const D=b();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,S.localize)(1,null,n,c.basename(D)))},p=()=>{if(g){const D=this._context.getFolderUri(g);if(D)return D;throw new Error((0,S.localize)(2,null,n,g))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(d){case"env":if(g){if(y){const D=y[T.isWindows?g.toLowerCase():g];if(_.isString(D))return D}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(g){const D=this._context.getConfigurationValue(o,g);if(_.isUndefinedOrNull(D))throw new Error((0,S.localize)(6,null,n,g));if(_.isObject(D))throw new Error((0,S.localize)(7,null,n,g));return D}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,g,a,"command");case"input":return this.resolveFromMap(n,g,a,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return o||g?(0,I.normalizeDriveLetter)(this.fsPath(p())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(p()));case"lineNumber":const D=this._context.getLineNumber();if(D)return D;throw new Error((0,S.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,S.localize)(10,null,n));case"file":return b();case"fileWorkspaceFolder":return u();case"relativeFile":return o||g?c.relative(this.fsPath(p()),b()):b();case"relativeFileDirname":const r=c.dirname(b());if(o||g){const v=c.relative(this.fsPath(p()),r);return v.length===0?".":v}return r;case"fileDirname":return c.dirname(b());case"fileExtname":return c.extname(b());case"fileBasename":return c.basename(b());case"fileBasenameNoExtension":const l=c.basename(b());return l.slice(0,l.length-c.extname(l).length);case"fileDirnameBasename":return c.basename(c.dirname(b()));case"execPath":const s=this._context.getExecPath();return s||n;case"execInstallFolder":const m=this._context.getAppRoot();return m||n;case"pathSeparator":return c.sep;default:try{const v=g?`${d}:${g}`:d;return this.resolveFromMap(n,v,a,void 0)}catch(v){return n}}}}resolveFromMap(y,n,d,o){if(n&&d){const a=o===void 0?d[n]:d[o+":"+n];if(typeof a=="string")return a;throw new Error((0,S.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[92],we([0,1,4,160]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var _;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var A;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var I;(function(a){a[a.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",a[a.EVEN=1]="EVEN",a[a.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function P(a){const g=a;return(0,F.isEditorInput)(g?.editor)&&(0,F.isEditorInput)(g?.replacement)}e.isEditorReplacement=P;var t;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(a){a[a.GROUP_ACTIVE=0]="GROUP_ACTIVE",a[a.GROUP_INDEX=1]="GROUP_INDEX",a[a.GROUP_LOCKED=2]="GROUP_LOCKED",a[a.EDITOR_OPEN=3]="EDITOR_OPEN",a[a.EDITOR_CLOSE=4]="EDITOR_CLOSE",a[a.EDITOR_MOVE=5]="EDITOR_MOVE",a[a.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",a[a.EDITOR_LABEL=7]="EDITOR_LABEL",a[a.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",a[a.EDITOR_PIN=9]="EDITOR_PIN",a[a.EDITOR_STICKY=10]="EDITOR_STICKY",a[a.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(y=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function d(a){const g=a;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=d;function o(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(ve[168],we([0,1,4,92]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(A){const T=A;return typeof A=="number"||(0,F.isEditorGroup)(T)}e.isPreferredGroup=_}),define(ve[8],we([0,1,16,23,77,230,53,22,10,2,41,58,134,83,65,90,69,168,6]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(ie){function pe(B){const{selectionStartLineNumber:Ce,selectionStartColumn:Se,positionLineNumber:qe,positionColumn:We}=B,it=new b.Position(Ce-1,Se-1),mt=new b.Position(qe-1,We-1);return new b.Selection(it,mt)}ie.to=pe;function re(B){const{anchor:Ce,active:Se}=B;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}ie.from=re})(u=e.Selection||(e.Selection={}));var p;(function(ie){function pe(B){if(!B)return;const{start:Ce,end:Se}=B;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}ie.from=pe;function re(B){if(!B)return;const{startLineNumber:Ce,startColumn:Se,endLineNumber:qe,endColumn:We}=B;return new b.Range(Ce-1,Se-1,qe-1,We-1)}ie.to=re})(p=e.Range||(e.Range={}));var D;(function(ie){function pe(re){switch(re){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ie.to=pe})(D=e.TokenType||(e.TokenType={}));var i;(function(ie){function pe(B){return new b.Position(B.lineNumber-1,B.column-1)}ie.to=pe;function re(B){return{lineNumber:B.line+1,column:B.character+1}}ie.from=re})(i=e.Position||(e.Position={}));var r;(function(ie){function pe(B){switch(B){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ie.from=pe;function re(B){switch(B){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ie.to=re})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(ie){function pe(B){let Ce;return B.code&&((0,S.isString)(B.code)||(0,S.isNumber)(B.code)?Ce=String(B.code):Ce={value:String(B.code.value),target:B.code.target}),{...p.from(B.range),message:B.message,source:B.source,code:Ce,severity:m.from(B.severity),relatedInformation:B.relatedInformation&&B.relatedInformation.map(s.from),tags:Array.isArray(B.tags)?(0,c.coalesce)(B.tags.map(r.from)):void 0}}ie.from=pe;function re(B){const Ce=new b.Diagnostic(p.to(B),B.message,m.to(B.severity));return Ce.source=B.source,Ce.code=(0,S.isString)(B.code)?B.code:B.code?.value,Ce.relatedInformation=B.relatedInformation&&B.relatedInformation.map(s.to),Ce.tags=B.tags&&(0,c.coalesce)(B.tags.map(r.to)),Ce}ie.to=re})(l=e.Diagnostic||(e.Diagnostic={}));var s;(function(ie){function pe(B){return{...p.from(B.location.range),message:B.message,resource:B.location.uri}}ie.from=pe;function re(B){return new b.DiagnosticRelatedInformation(new b.Location(B.resource,p.to(B)),B.message)}ie.to=re})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(ie){function pe(B){switch(B){case b.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ie.from=pe;function re(B){switch(B){case d.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ie.to=re})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var v;(function(ie){function pe(B){return typeof B=="number"&&B>=b.ViewColumn.One?B-1:B===b.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}ie.from=pe;function re(B){if(typeof B=="number"&&B>=0)return B+1;throw new Error("invalid 'EditorGroupColumn'")}ie.to=re})(v=e.ViewColumn||(e.ViewColumn={}));function w(ie){return typeof ie.range!="undefined"}function C(ie){return ie.length===0?!0:!!w(ie[0])}e.isDecorationOptionsArr=C;var R;(function(ie){function pe(We){return We.map(ie.from)}ie.fromMany=pe;function re(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function B(We){let it;if(re(We)){const{language:ct,value:lt}=We;it={value:"```"+ct+`
`+lt+"\n```\n"}}else b.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons}:typeof We=="string"?it={value:We}:it={value:""};const mt=Object.create(null);it.uris=mt;const wt=ct=>{try{let lt=P.URI.parse(ct,!0);lt=lt.with({query:Ce(lt.query,mt)}),mt[ct]=lt}catch(lt){}return""},ot=new A.Renderer;return ot.link=wt,ot.image=ct=>wt(_.parseHrefAndDimensions(ct).href),A(it.value,{renderer:ot}),it}ie.from=B;function Ce(We,it){if(!We)return We;let mt;try{mt=(0,T.parse)(We)}catch(ot){}if(!mt)return We;let wt=!1;return mt=(0,I.cloneAndChange)(mt,ot=>{if(P.URI.isUri(ot)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ct]=ot,wt=!0,ct}else return}),wt?JSON.stringify(mt):We}function Se(We){const it=new b.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it}ie.to=Se;function qe(We){if(!!We)return typeof We=="string"?We:ie.from(We)}ie.fromStrict=qe})(R=e.MarkdownString||(e.MarkdownString={}));function f(ie){return C(ie)?ie.map(pe=>({range:p.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?R.fromMany(pe.hoverMessage):pe.hoverMessage?R.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ie.map(pe=>({range:p.from(pe)}))}e.fromRangeOrRangeWithMessage=f;function E(ie){return typeof ie=="undefined"?ie:typeof ie=="string"?P.URI.file(ie):ie}e.pathOrURIToURI=E;var h;(function(ie){function pe(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?E(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ie.from=pe})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(ie){function pe(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?E(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?h.from(re.before):void 0,after:re.after?h.from(re.after):void 0}}ie.from=pe})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ie){function pe(re){if(typeof re=="undefined")return re;switch(re){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ie.from=pe})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(ie){function pe(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?O.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?M.from(re.light):void 0,dark:re.dark?M.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?E(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?h.from(re.before):void 0,after:re.after?h.from(re.after):void 0}}ie.from=pe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Q;(function(ie){function pe(B){return{text:B.newText,eol:B.newEol&&J.from(B.newEol),range:p.from(B.range)}}ie.from=pe;function re(B){const Ce=new b.TextEdit(p.to(B.range),B.text);return Ce.newEol=typeof B.eol=="undefined"?void 0:J.to(B.eol),Ce}ie.to=re})(Q=e.TextEdit||(e.TextEdit={}));var $;(function(ie){function pe(B,Ce,Se){const qe={edits:[]};if(B instanceof b.WorkspaceEdit)for(let We of B._allEntries())if(We._type===1)qe.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const it=Ce?.getDocument(We.uri);qe.edits.push({_type:2,resource:We.uri,edit:Q.from(We.edit),modelVersionId:it?.version,metadata:We.metadata})}else We._type===3?qe.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&qe.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(ft.from)}});return qe}ie.from=pe;function re(B){const Ce=new b.WorkspaceEdit;for(const Se of B.edits)Se.edit?Ce.replace(P.URI.revive(Se.resource),p.to(Se.edit.range),Se.edit.text):Ce.renameFile(P.URI.revive(Se.oldUri),P.URI.revive(Se.newUri),Se.options);return Ce}ie.to=re})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ie){const pe=Object.create(null);pe[b.SymbolKind.File]=0,pe[b.SymbolKind.Module]=1,pe[b.SymbolKind.Namespace]=2,pe[b.SymbolKind.Package]=3,pe[b.SymbolKind.Class]=4,pe[b.SymbolKind.Method]=5,pe[b.SymbolKind.Property]=6,pe[b.SymbolKind.Field]=7,pe[b.SymbolKind.Constructor]=8,pe[b.SymbolKind.Enum]=9,pe[b.SymbolKind.Interface]=10,pe[b.SymbolKind.Function]=11,pe[b.SymbolKind.Variable]=12,pe[b.SymbolKind.Constant]=13,pe[b.SymbolKind.String]=14,pe[b.SymbolKind.Number]=15,pe[b.SymbolKind.Boolean]=16,pe[b.SymbolKind.Array]=17,pe[b.SymbolKind.Object]=18,pe[b.SymbolKind.Key]=19,pe[b.SymbolKind.Null]=20,pe[b.SymbolKind.EnumMember]=21,pe[b.SymbolKind.Struct]=22,pe[b.SymbolKind.Event]=23,pe[b.SymbolKind.Operator]=24,pe[b.SymbolKind.TypeParameter]=25;function re(Ce){return typeof pe[Ce]=="number"?pe[Ce]:6}ie.from=re;function B(Ce){for(const Se in pe)if(pe[Se]===Ce)return Number(Se);return b.SymbolKind.Property}ie.to=B})(z=e.SymbolKind||(e.SymbolKind={}));var N;(function(ie){function pe(B){switch(B){case b.SymbolTag.Deprecated:return 1}}ie.from=pe;function re(B){switch(B){case 1:return b.SymbolTag.Deprecated}}ie.to=re})(N=e.SymbolTag||(e.SymbolTag={}));var W;(function(ie){function pe(B){return{name:B.name,kind:z.from(B.kind),tags:B.tags&&B.tags.map(N.from),containerName:B.containerName,location:ue.from(B.location)}}ie.from=pe;function re(B){const Ce=new b.SymbolInformation(B.name,z.to(B.kind),B.containerName,ue.to(B.location));return Ce.tags=B.tags&&B.tags.map(N.to),Ce}ie.to=re})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(ie){function pe(B){const Ce={name:B.name||"!!MISSING: name!!",detail:B.detail,range:p.from(B.range),selectionRange:p.from(B.selectionRange),kind:z.from(B.kind),tags:B.tags?.map(N.from)??[]};return B.children&&(Ce.children=B.children.map(pe)),Ce}ie.from=pe;function re(B){const Ce=new b.DocumentSymbol(B.name,B.detail,z.to(B.kind),p.to(B.range),p.to(B.selectionRange));return(0,c.isNonEmptyArray)(B.tags)&&(Ce.tags=B.tags.map(N.to)),B.children&&(Ce.children=B.children.map(re)),Ce}ie.to=re})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(ie){function pe(B){const Ce=new b.CallHierarchyItem(z.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),p.to(B.range),p.to(B.selectionRange));return Ce._sessionId=B._sessionId,Ce._itemId=B._itemId,Ce}ie.to=pe;function re(B,Ce,Se){if(Ce=Ce??B._sessionId,Se=Se??B._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,name:B.name,detail:B.detail,kind:z.from(B.kind),uri:B.uri,range:p.from(B.range),selectionRange:p.from(B.selectionRange),tags:B.tags?.map(N.from)}}ie.from=re})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(ie){function pe(re){return new b.CallHierarchyIncomingCall(Y.to(re.from),re.fromRanges.map(B=>p.to(B)))}ie.to=pe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(ie){function pe(re){return new b.CallHierarchyOutgoingCall(Y.to(re.to),re.fromRanges.map(B=>p.to(B)))}ie.to=pe})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(ie){function pe(B){return{range:B.range&&p.from(B.range),uri:B.uri}}ie.from=pe;function re(B){return new b.Location(P.URI.revive(B.uri),p.to(B.range))}ie.to=re})(ue=e.location||(e.location={}));var oe;(function(ie){function pe(B){const Ce=B,Se=B;return{originSelectionRange:Ce.originSelectionRange?p.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Se.uri,range:p.from(Ce.targetRange?Ce.targetRange:Se.range),targetSelectionRange:Ce.targetSelectionRange?p.from(Ce.targetSelectionRange):void 0}}ie.from=pe;function re(B){return{targetUri:P.URI.revive(B.uri),targetRange:p.to(B.range),targetSelectionRange:B.targetSelectionRange?p.to(B.targetSelectionRange):void 0,originSelectionRange:B.originSelectionRange?p.to(B.originSelectionRange):void 0}}ie.to=re})(oe=e.DefinitionLink||(e.DefinitionLink={}));var be;(function(ie){function pe(B){return{range:p.from(B.range),contents:R.fromMany(B.contents)}}ie.from=pe;function re(B){return new b.Hover(B.contents.map(R.to),p.to(B.range))}ie.to=re})(be=e.Hover||(e.Hover={}));var Ae;(function(ie){function pe(B){return{range:p.from(B.range),expression:B.expression}}ie.from=pe;function re(B){return new b.EvaluatableExpression(p.to(B.range),B.expression)}ie.to=re})(Ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(ie){function pe(B){if(B instanceof b.InlineValueText)return{type:"text",range:p.from(B.range),text:B.text};if(B instanceof b.InlineValueVariableLookup)return{type:"variable",range:p.from(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};if(B instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(B.range),expression:B.expression};throw new Error("Unknown 'InlineValue' type")}ie.from=pe;function re(B){switch(B.type){case"text":return{range:p.to(B.range),text:B.text};case"variable":return{range:p.to(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};case"expression":return{range:p.to(B.range),expression:B.expression}}}ie.to=re})(Re=e.InlineValue||(e.InlineValue={}));var Oe;(function(ie){function pe(B){return{frameId:B.frameId,stoppedLocation:p.from(B.stoppedLocation)}}ie.from=pe;function re(B){return new b.InlineValueContext(B.frameId,p.to(B.stoppedLocation))}ie.to=re})(Oe=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(ie){function pe(B){return{range:p.from(B.range),kind:B.kind}}ie.from=pe;function re(B){return new b.DocumentHighlight(p.to(B.range),B.kind)}ie.to=re})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ie){function pe(re){switch(re){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ie.to=pe})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(ie){function pe(re){return{triggerKind:He.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ie.to=pe})(je=e.CompletionContext||(e.CompletionContext={}));var U;(function(ie){function pe(B){switch(B){case b.CompletionItemTag.Deprecated:return 1}}ie.from=pe;function re(B){switch(B){case 1:return b.CompletionItemTag.Deprecated}}ie.to=re})(U=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(ie){const pe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function re(Se){return pe.get(Se)??9}ie.from=re;const B=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Ce(Se){return B.get(Se)??b.CompletionItemKind.Property}ie.to=Ce})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ie){function pe(re,B){const Ce=new b.CompletionItem(re.label);return Ce.insertText=re.insertText,Ce.kind=K.to(re.kind),Ce.tags=re.tags?.map(U.to),Ce.detail=re.detail,Ce.documentation=_.isMarkdownString(re.documentation)?R.to(re.documentation):re.documentation,Ce.sortText=re.sortText,Ce.filterText=re.filterText,Ce.preselect=re.preselect,Ce.commitCharacters=re.commitCharacters,t.Range.isIRange(re.range)?Ce.range=p.to(re.range):typeof re.range=="object"&&(Ce.range={inserting:p.to(re.range.insert),replacing:p.to(re.range.replace)}),Ce.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Ce.insertText=new b.SnippetString(re.insertText):(Ce.insertText=re.insertText,Ce.textEdit=Ce.range instanceof b.Range?new b.TextEdit(Ce.range,Ce.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Ce.additionalTextEdits=re.additionalTextEdits.map(Se=>Q.to(Se))),Ce.command=B&&re.command?B.fromInternal(re.command):void 0,Ce}ie.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ie){function pe(B){return{label:B.label,documentation:B.documentation?R.fromStrict(B.documentation):void 0}}ie.from=pe;function re(B){return{label:B.label,documentation:_.isMarkdownString(B.documentation)?R.to(B.documentation):B.documentation}}ie.to=re})(ae=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(ie){function pe(B){return{label:B.label,documentation:B.documentation?R.fromStrict(B.documentation):void 0,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.from):[],activeParameter:B.activeParameter}}ie.from=pe;function re(B){return{label:B.label,documentation:_.isMarkdownString(B.documentation)?R.to(B.documentation):B.documentation,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.to):[],activeParameter:B.activeParameter}}ie.to=re})(V=e.SignatureInformation||(e.SignatureInformation={}));var se;(function(ie){function pe(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(V.from):[]}}ie.from=pe;function re(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(V.to):[]}}ie.to=re})(se=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(ie){function pe(B){return{text:B.text,position:i.from(B.position),kind:Te.from(B.kind??b.InlayHintKind.Other),whitespaceBefore:B.whitespaceBefore,whitespaceAfter:B.whitespaceAfter}}ie.from=pe;function re(B){const Ce=new b.InlayHint(B.text,i.to(B.position),Te.to(B.kind));return Ce.whitespaceAfter=B.whitespaceAfter,Ce.whitespaceBefore=B.whitespaceBefore,Ce}ie.to=re})(he=e.InlayHint||(e.InlayHint={}));var Te;(function(ie){function pe(B){return B}ie.from=pe;function re(B){return B}ie.to=re})(Te=e.InlayHintKind||(e.InlayHintKind={}));var Ue;(function(ie){function pe(B){return{range:p.from(B.range),url:B.target,tooltip:B.tooltip}}ie.from=pe;function re(B){let Ce;if(B.url)try{Ce=typeof B.url=="string"?P.URI.parse(B.url,!0):P.URI.revive(B.url)}catch(Se){}return new b.DocumentLink(p.to(B.range),Ce)}ie.to=re})(Ue=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ie){function pe(B){const Ce=new b.ColorPresentation(B.label);return B.textEdit&&(Ce.textEdit=Q.to(B.textEdit)),B.additionalTextEdits&&(Ce.additionalTextEdits=B.additionalTextEdits.map(Se=>Q.to(Se))),Ce}ie.to=pe;function re(B){return{label:B.label,textEdit:B.textEdit?Q.from(B.textEdit):void 0,additionalTextEdits:B.additionalTextEdits?B.additionalTextEdits.map(Ce=>Q.from(Ce)):void 0}}ie.from=re})($e=e.ColorPresentation||(e.ColorPresentation={}));var Ke;(function(ie){function pe(B){return new b.Color(B[0],B[1],B[2],B[3])}ie.to=pe;function re(B){return[B.red,B.green,B.blue,B.alpha]}ie.from=re})(Ke=e.Color||(e.Color={}));var _e;(function(ie){function pe(B){return{range:p.from(B.range)}}ie.from=pe;function re(B){return new b.SelectionRange(p.to(B.range))}ie.to=re})(_e=e.SelectionRange||(e.SelectionRange={}));var rt;(function(ie){function pe(re){switch(re){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ie.to=pe})(rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(ie){function pe(B){switch(B){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ie.from=pe;function re(B){switch(B){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ie.to=re})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ie){function pe(B){if(B===b.EndOfLine.CRLF)return 1;if(B===b.EndOfLine.LF)return 0}ie.from=pe;function re(B){if(B===1)return b.EndOfLine.CRLF;if(B===0)return b.EndOfLine.LF}ie.to=re})(J=e.EndOfLine||(e.EndOfLine={}));var me;(function(ie){function pe(re){if(typeof re=="object")return re.viewId;switch(re){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ie.from=pe})(me=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(ie){function pe(re){const B={start:re.start+1,end:re.end+1};return re.kind&&(B.kind=Ye.from(re.kind)),B}ie.from=pe})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ye;(function(ie){function pe(re){if(re)switch(re){case b.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}ie.from=pe})(Ye=e.FoldingRangeKind||(e.FoldingRangeKind={}));var tt;(function(ie){function pe(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?p.from(re.selection):void 0,override:typeof re.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ie.from=pe})(tt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var at;(function(ie){function pe(B){return B instanceof b.RelativePattern||typeof B=="string"?B:re(B)?new b.RelativePattern(B.base,B.pattern):B}ie.from=pe;function re(B){const Ce=B;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(at=e.GlobPattern||(e.GlobPattern={}));var vt;(function(ie){function pe(re){if(re){if(Array.isArray(re))return re.map(pe);if(typeof re=="string")return re;{const B=re;return{language:B.language,scheme:B.scheme,pattern:typeof B.pattern=="undefined"?void 0:at.from(B.pattern),exclusive:B.exclusive}}}else return}ie.from=pe})(vt=e.LanguageSelector||(e.LanguageSelector={}));var kt;(function(ie){function pe(B){return{start:B.start,end:B.end}}ie.from=pe;function re(B){return new b.NotebookRange(B.start,B.end)}ie.to=re})(kt=e.NotebookRange||(e.NotebookRange={}));var ht;(function(ie){function pe(B){return{timing:typeof B.runStartTime=="number"&&typeof B.runEndTime=="number"?{startTime:B.runStartTime,endTime:B.runEndTime}:void 0,executionOrder:B.executionOrder,success:B.lastRunSuccess}}ie.to=pe;function re(B){return{lastRunSuccess:B.success,runStartTime:B.timing?.startTime,runEndTime:B.timing?.endTime,executionOrder:B.executionOrder}}ie.from=re})(ht=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var yt;(function(ie){function pe(B){switch(B){case b.NotebookCellKind.Markup:return a.CellKind.Markup;case b.NotebookCellKind.Code:default:return a.CellKind.Code}}ie.from=pe;function re(B){switch(B){case a.CellKind.Markup:return b.NotebookCellKind.Markup;case a.CellKind.Code:default:return b.NotebookCellKind.Code}}ie.to=re})(yt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ie){function pe(B){const Ce={metadata:B.metadata??Object.create(null),cells:[]};for(let Se of B.cells)b.NotebookCellData.validate(Se),Ce.cells.push(ft.from(Se));return Ce}ie.from=pe;function re(B){const Ce=new b.NotebookData(B.cells.map(ft.to));return(0,S.isEmptyObject)(B.metadata)||(Ce.metadata=B.metadata),Ce}ie.to=re})(It=e.NotebookData||(e.NotebookData={}));var ft;(function(ie){function pe(B){return{cellKind:yt.from(B.kind),language:B.languageId,mime:B.mime,source:B.value,metadata:B.metadata,internalMetadata:ht.from(B.executionSummary??{}),outputs:B.outputs?B.outputs.map(Et.from):[]}}ie.from=pe;function re(B){return new b.NotebookCellData(yt.to(B.cellKind),B.source,B.language,B.mime,B.outputs?B.outputs.map(Et.to):void 0,B.metadata,B.internalMetadata?ht.to(B.internalMetadata):void 0)}ie.to=re})(ft=e.NotebookCellData||(e.NotebookCellData={}));var Je;(function(ie){function pe(B){return{mime:B.mime,valueBytes:F.VSBuffer.wrap(B.data)}}ie.from=pe;function re(B){return new b.NotebookCellOutputItem(B.valueBytes.buffer,B.mime)}ie.to=re})(Je=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Et;(function(ie){function pe(B){return{outputId:B.id,items:B.items.map(Je.from),metadata:B.metadata}}ie.from=pe;function re(B){const Ce=B.items.map(Je.to);return new b.NotebookCellOutput(Ce,B.outputId,B.metadata)}ie.to=re})(Et=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(ie){function pe(Se){if(Se!=null){if(Se instanceof b.RelativePattern||typeof Se=="string")return Se;if(Ce(Se))return new b.RelativePattern(Se.base,Se.pattern);if(B(Se))return{include:at.from(Se.include)||void 0,exclude:at.from(Se.exclude)||void 0}}}ie.from=pe;function re(Se){return typeof Se=="string"?Se:Ce(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}ie.to=re;function B(Se){const qe=Se,We=at.from(qe.include);if(!(We&&We instanceof b.RelativePattern||typeof We=="string"))return!1;const it=at.from(qe.exclude);return!!(it&&it instanceof b.RelativePattern||typeof it=="string")}function Ce(Se){const qe=Se;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ie){function pe(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?h.from(re.top):void 0}}ie.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var De;(function(ie){function pe(re,B,Ce){const Se=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:B.toInternal(Se,Ce),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ie.from=pe})(De=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(ie){function pe(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ie.from=pe})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var le;(function(ie){function pe(B){return{uri:B.uri,provides:B.provides}}ie.from=pe;function re(B){return new b.NotebookRendererScript(P.URI.revive(B.uri),B.provides)}ie.to=re})(le=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ie){function pe(B){return{message:R.fromStrict(B.message)||"",type:0,expected:B.expectedOutput,actual:B.actualOutput,location:B.location?ue.from(B.location):void 0}}ie.from=pe;function re(B){const Ce=new b.TestMessage(typeof B.message=="string"?B.message:R.to(B.message));return Ce.actualOutput=B.actual,Ce.expectedOutput=B.expected,Ce}ie.to=re})(ge=e.TestMessage||(e.TestMessage={}));var fe;(function(ie){let pe;(function(re){re.Delimiter="\0"})(pe||(pe={})),ie.namespace=(re,B)=>re+"\0"+B,ie.denamespace=re=>{const B=re.indexOf("\0");return{ctrlId:re.slice(0,B),tagId:re.slice(B+1)}}})(fe=e.TestTag||(e.TestTag={}));var Ie;(function(ie){function pe(Se){const qe=(0,o.getPrivateApiFor)(Se).controllerId;return{extId:g.TestId.fromExtHostTestItem(Se,qe).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>fe.namespace(qe,We.id)),range:p.from(Se.range)||null,description:Se.description||null,error:Se.error&&R.fromStrict(Se.error)||null}}ie.from=pe;function re(Se){return{id:g.TestId.fromString(Se.extId).localId,label:Se.label,uri:P.URI.revive(Se.uri),tags:(Se.tags||[]).map(qe=>{const{tagId:We}=fe.denamespace(qe);return new b.TestTag(We,We)}),range:p.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}ie.toPlain=re;function B(Se){const qe=g.TestId.fromString(Se.extId),We=new o.TestItemImpl(qe.controllerId,qe.localId,Se.label,P.URI.revive(Se.uri));return We.range=p.to(Se.range||void 0),We.description=Se.description||void 0,We}function Ce(Se){let qe;for(const We of Se.tests){const it=B(We.item);(0,o.getPrivateApiFor)(it).parent=qe,qe=it}return qe}ie.toItemFromContext=Ce})(Ie=e.TestItem||(e.TestItem={})),function(ie){function pe(B){return{id:B.id,label:B.label}}ie.from=pe;function re(B){return new b.TestTag(B.id,B.label)}ie.to=re}(fe=e.TestTag||(e.TestTag={}));var xe;(function(ie){const pe=(B,Ce)=>{const Se={...Ie.toPlain(B.item),parent:void 0,taskStates:B.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(We=>We.type===0).map(ge.to)})),children:B.children.map(qe=>Ce.get(qe)).filter(S.isDefined).map(qe=>pe(qe,Ce))};for(const qe of Se.children)qe.parent=Se;return Se};function re(B){const Ce=[],Se=new Map;for(const qe of B.items)Se.set(qe.item.extId,qe),B.request.targets.some(We=>We.controllerId===qe.controllerId&&We.testIds.includes(qe.item.extId))&&Ce.push(qe);return{completedAt:B.completedAt,results:Ce.map(qe=>pe(qe,Se))}}ie.to=re})(xe=e.TestResults||(e.TestResults={}));var Le;(function(ie){function pe(Se){return{covered:Se.covered,total:Se.covered}}function re(Se){return"line"in Se?i.from(Se):p.from(Se)}function B(Se){return"branches"in Se?{count:Se.executionCount,location:re(Se.location),type:1,branches:Se.branches.length?Se.branches.map(qe=>({count:qe.executionCount,location:qe.location&&re(qe.location)})):void 0}:{type:0,count:Se.executionCount,location:re(Se.location)}}ie.fromDetailed=B;function Ce(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(B)}}ie.fromFile=Ce})(Le=e.TestCoverage||(e.TestCoverage={}));var Ve;(function(ie){function pe(re){switch(re){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ie.to=pe})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Xe;(function(ie){function pe(B){const Ce=new b.TypeHierarchyItem(z.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),p.to(B.range),p.to(B.selectionRange));return Ce._sessionId=B._sessionId,Ce._itemId=B._itemId,Ce}ie.to=pe;function re(B,Ce,Se){if(Ce=Ce??B._sessionId,Se=Se??B._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,kind:z.from(B.kind),name:B.name,detail:B.detail??"",uri:B.uri,range:p.from(B.range),selectionRange:p.from(B.selectionRange),tags:B.tags?.map(N.from)}}ie.from=re})(Xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[169],we([0,1,2,15,6,8,231]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(P,t,y,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=y,this._thresholds=n,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,y,n)=>{const o={dispose:this._callbacks.push([t,y,P])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(P,t){const y=c.URI.revive(P);let n=!1;const d=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let a of[...this._callbacks]){if(n)break;const g=this._documents.getDocument(y),k=await this._deliverEventAsyncAndBlameBadListeners(a,{document:g,reason:A.TextDocumentSaveReason.to(t)});o.push(k)}}finally{clearTimeout(d)}return o}_deliverEventAsyncAndBlameBadListeners([P,t,y],n){const d=this._badListeners.get(P);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,t,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const a=this._badListeners.get(P);this._badListeners.set(P,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,y,n){const d=[],o=Date.now(),{document:a,reason:g}=n,{version:k}=a,b=Object.freeze({document:a,reason:g,waitUntil(u){if(Object.isFrozen(d))throw(0,F.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(u))}});try{t.apply(y,[b])}catch(u){return Promise.reject(u)}return Object.freeze(d),new Promise((u,p)=>{const D=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(D),u(i)}).catch(i=>{clearTimeout(D),p(i)})}).then(u=>{const p={edits:[]};for(const D of u)if(Array.isArray(D)&&D.every(i=>i instanceof _.TextEdit))for(const{newText:i,newEol:r,range:l}of D)p.edits.push({_type:2,resource:a.uri,edit:{range:l&&A.Range.from(l),text:i,eol:r&&A.EndOfLine.from(r)}});if(p.edits.length!==0)return k===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(ve[170],we([0,1,3,27,2,8,6]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(t,y,n,d,o){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),d&&(this._config+=2),o&&(this._config+=4);const a=(0,F.parse)(y),g=t(k=>{if(!n)for(let b of k.created){const u=_.URI.revive(b);a(u.fsPath)&&this._onDidCreate.fire(u)}if(!d)for(let b of k.changed){const u=_.URI.revive(b);a(u.fsPath)&&this._onDidChange.fire(u)}if(!o)for(let b of k.deleted){const u=_.URI.revive(b);a(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(t,y,n){this._logService=y,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,y,n,d){return new I(this._onFileSystemEvent.event,t,y,n,d)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,y){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(n=>({oldUri:_.URI.revive(n.source),newUri:_.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(n=>_.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:y.map(n=>_.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,y){return(n,d,o)=>{const a=function(k){n.call(d,k)};return a.extension=t,y.event(a,void 0,o)}}async $onWillRunFileOperation(t,y,n,d){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(o=>({oldUri:_.URI.revive(o.source),newUri:_.URI.revive(o.target)}))},n,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(o=>_.URI.revive(o.target))},n,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(o=>_.URI.revive(o.target))},n,d)}}async _fireWillEvent(t,y,n,d){const o=new Set,a=[];if(await t.fireAsync(y,d,async(k,b)=>{const u=Date.now(),p=await Promise.resolve(k);p instanceof T.WorkspaceEdit&&(a.push(p),o.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-u>n&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),d.isCancellationRequested||a.length===0)return;const g={edits:[]};for(let k of a){let{edits:b}=A.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(b)}return{edit:g,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=S}),define(ve[171],we([0,1,11,22,2,8,6,90]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,d,o,a){this.start=n,this.deletedCount=d,this.deletedItems=o,this.items=a}static asApiEvents(n){return n.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(o=>o.apiCell)}))}}class P{constructor(n,d,o){this.notebook=n,this._extHostDocument=d,this._cellData=o,this.handle=o.handle,this.uri=_.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(n,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return n._mime},set mime(o){n._mime=o},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,d,o){const a=o.map(A.NotebookCellOutputItem.to),g=this._outputs.find(k=>k.id===n);g&&(d||(g.items.length=0),g.items.push(...a))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,d,o,a,g,k){this._proxy=n,this._textDocumentsAndEditors=d,this._textDocuments=o,this._emitter=a,this.uri=g,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=k.viewType,this._metadata=Object.freeze(k.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,k.cells]],!0),this._versionId=k.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(d){return d=n._validateIndex(d),n._cells[d].apiCell},getCells(d){return(d?n._getCells(d):n._cells).map(a=>a.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,d){this._versionId=n.versionId,this._isDirty=d;for(const o of n.rawEvents)o.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===I.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let d=n.start|0,o=n.end|0;return d<0&&(d=0),o>this._cells.length&&(o=this._cells.length),n.with({start:d,end:o})}_getCells(n){n=this._validateRange(n);const d=[];for(let o=n.start;o<n.end;o++)d.push(this._cells[o]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,d){if(this._disposed)return;const o=[],a=[],g=[];n.reverse().forEach(k=>{const u=k[2].map(i=>{const r=new P(this,this._textDocumentsAndEditors,i);return d||a.push(P.asModelAddData(this.apiNotebook,i)),r}),p=new S(k[0],k[1],[],u),D=this._cells.splice(k[0],k[1],...u);for(const i of D)g.push(i.uri),p.deletedItems.push(i.apiCell);o.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:g}),d||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(o)}))}_moveCell(n,d){const o=this._cells.splice(n,1);this._cells.splice(d,0,...o);const a=[new S(n,1,o.map(g=>g.apiCell),[]),new S(d,0,[],o)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(a)}))}_setCellOutputs(n,d){const o=this._cells[n];o.setOutputs(d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(n,d,o,a){const g=this._cells[n];g.setOutputItems(d,o,a),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(n,d){const o=this._cells[n];o.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(o.uri,d)}_changeCellMime(n,d){const o=this._cells[n];o.apiCell.mime=d}_changeCellMetadata(n,d){const o=this._cells[n],a=o.apiCell.metadata;o.setMetadata(d);const g=o.apiCell.metadata;(0,F.equals)(a,g)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(n,d){const o=this._cells[n],a=o.internalMetadata;if(o.setInternalMetadata(d),a.runState!==d.runState){const g=d.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:g}))}}getCellFromApiCell(n){return this._cells.find(d=>d.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(d=>d.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(ve[93],we([0,1,6,8,15]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:P})}replaceCells(S,P,t){this._throwIfFinalized(),!(S===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:S,count:P-S,cells:t.map(F.NotebookCellData.from)})}}class T{constructor(S,P,t,y,n,d){this.id=S,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=y,this._viewColumn=d}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(P){if(!Array.isArray(P)||!P.every(c.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");S._selections=P,S._trySetSelections(P)},get visibleRanges(){return S._visibleRanges},revealRange(P,t){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(P),t??c.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(P){const t=new A(this.document.version);return P(t),S._applyEdit(t.finalize())},setDecorations(P,t){return S.setDecorations(P,t)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let y=0;y<S.cellEdits.length;y++){if(t<0){P.push(S.cellEdits[y]),t++;continue}const d=P[t],o=S.cellEdits[y];if(d.editType===1&&o.editType===1&&d.index===o.index){d.cells.push(...S.cellEdits[y].cells),d.count+=S.cellEdits[y].count;continue}P.push(S.cellEdits[y]),t++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,P)}setDecorations(S,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return P.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(P),S.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(ve[172],we([0,1,8,147,123,21,51]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(y){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=y}withProgress(y,n,d){const o=this._handles++,{title:a,location:g,cancellable:k}=n,b={label:(0,_.localize)(0,null,y.displayName||y.name),id:y.identifier.value};return this._proxy.$startProgress(o,{location:c.ProgressLocation.from(g),title:a,source:b,cancellable:k},y),this._withProgress(o,d,!!k)}_withProgress(y,n,d){let o;d&&(o=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(y,o));const a=k=>{this._proxy.$progressEnd(k),this._mapHandleToCancellationSource.delete(k),o&&o.dispose()};let g;try{g=n(new P(this._proxy,y),d&&o?o.token:A.CancellationToken.None)}catch(k){throw a(y),k}return g.then(k=>a(y),k=>a(y)),g}$acceptProgressCanceled(y){const n=this._mapHandleToCancellationSource.get(y);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(y))}}e.ExtHostProgress=I;function S(t,y){return t.message=y.message,typeof y.increment=="number"&&(typeof t.increment=="number"?t.increment+=y.increment:t.increment=y.increment),t}class P extends F.Progress{constructor(y,n){super(d=>this.throttledReport(d));this._proxy=y,this._handle=n}throttledReport(y){this._proxy.$progressReport(this._handle,y)}}Be([(0,T.throttle)(100,(t,y)=>S(t,y),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(ve[94],we([0,1,39,15,52,8,6]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(n,d,o){const a=I._Keys.nextId();n.$registerTextEditorDecorationType(d.identifier,a,A.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:a,dispose(){n.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=I,I._Keys=new _.IdGenerator("TextEditorDecorationType");class S{constructor(n,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,d){this._throwIfFinalized();let o=null;if(n instanceof T.Position)o=new T.Range(n,n);else if(n instanceof T.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,d,!1)}insert(n,d){this._throwIfFinalized(),this._pushEdit(new T.Range(n,n),d,!0)}delete(n){this._throwIfFinalized();let d=null;if(n instanceof T.Range)d=n;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(n,d,o){const a=this._document.validateRange(n);this._collectedEdits.push({range:a,text:d,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==T.EndOfLine.LF&&n!==T.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class P{constructor(n,d,o,a){this._proxy=n,this._id=d,this._accept(o),this._logService=a;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(k){g._setTabSize(k)},get insertSpaces(){return g._insertSpaces},set insertSpaces(k){g._setInsertSpaces(k)},get cursorStyle(){return g._cursorStyle},set cursorStyle(k){g._setCursorStyle(k)},get lineNumbers(){return g._lineNumbers},set lineNumbers(k){g._setLineNumbers(k)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const d=Math.floor(n);return d>0?d:null}if(typeof n=="string"){const d=parseInt(n,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(n){const d=this._validateTabSize(n);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const d=this._validateInsertSpaces(n);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const d={};let o=!1;if(typeof n.tabSize!="undefined"){const a=this._validateTabSize(n.tabSize);a==="auto"?(o=!0,d.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,o=!0,d.tabSize=a)}if(typeof n.insertSpaces!="undefined"){const a=this._validateInsertSpaces(n.insertSpaces);a==="auto"?(o=!0,d.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,o=!0,d.insertSpaces=a)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,d.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,d.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(n){n.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,d,o,a,g,k,b,u){this.id=n,this._proxy=d,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new P(this._proxy,this.id,k,o),this._visibleRanges=b,this._viewColumn=u;const p=this;this.value=Object.freeze({get document(){return a.getValue()},set document(D){throw(0,F.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(D){if(!(D instanceof T.Selection))throw(0,F.illegalArgument)("selection");p._selections=[D],p._trySetSelection()},get selections(){return p._selections},set selections(D){if(!Array.isArray(D)||D.some(i=>!(i instanceof T.Selection)))throw(0,F.illegalArgument)("selections");p._selections=D,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(D){throw(0,F.readonly)("visibleRanges")},get options(){return p._options.value},set options(D){p._disposed||p._options.assign(D)},get viewColumn(){return p._viewColumn},set viewColumn(D){throw(0,F.readonly)("viewColumn")},edit(D,i={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(a.getValue(),i);return D(r),p._applyEdit(r)},insertSnippet(D,i,r={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!i||Array.isArray(i)&&i.length===0)l=p._selections.map(s=>A.Range.from(s));else if(i instanceof T.Position){const{lineNumber:s,column:m}=A.Position.from(i);l=[{startLineNumber:s,startColumn:m,endLineNumber:s,endColumn:m}]}else if(i instanceof T.Range)l=[A.Range.from(i)];else{l=[];for(const s of i)if(s instanceof T.Range)l.push(A.Range.from(s));else{const{lineNumber:m,column:v}=A.Position.from(s);l.push({startLineNumber:m,startColumn:v,endLineNumber:m,endColumn:v})}}return d.$tryInsertSnippet(n,D.value,l,r)},setDecorations(D,i){const r=i.length===0;r&&!p._hasDecorationsForKey.has(D.key)||(r?p._hasDecorationsForKey.delete(D.key):p._hasDecorationsForKey.add(D.key),p._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return d.$trySetDecorations(n,D.key,A.fromRangeOrRangeWithMessage(i));{const l=new Array(4*i.length);for(let s=0,m=i.length;s<m;s++){const v=i[s];l[4*s]=v.start.line+1,l[4*s+1]=v.start.character+1,l[4*s+2]=v.end.line+1,l[4*s+3]=v.end.character+1}return d.$trySetDecorationsFast(n,D.key,l)}}))},revealRange(D,i){p._runOnProxy(()=>d.$tryRevealRange(n,A.Range.from(D),i||T.TextEditorRevealType.Default))},show(D){d.$tryShowEditor(n,A.ViewColumn.from(D))},hide(){d.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const d=n.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const o=d.edits.map(g=>g.range);o.sort((g,k)=>g.end.line===k.end.line?g.end.character===k.end.character?g.start.line===k.start.line?g.start.character-k.start.character:g.start.line-k.start.line:g.end.character-k.end.character:g.end.line-k.end.line);for(let g=0,k=o.length-1;g<k;g++){const b=o[g].end;if(o[g+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=d.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,a,{setEndOfLine:typeof d.setEndOfLine=="number"?A.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=t}),define(ve[173],we([0,1,126,24,2,3,7,161,13,6,10,16,8,21,158]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(b,u){if((0,t.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let p;return Array.isArray(b.highlights)&&(p=b.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),p=p.length?p:void 0),{label:b.label,highlights:p}}}class g{constructor(u,p,D){this._proxy=u,this.commands=p,this.logService=D,this.treeViews=new Map;function i(r){return r&&r.$treeViewId&&r.$treeItemHandle}p.registerArgumentProcessor({processArgument:r=>i(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(l=>i(l)?this.convertArgument(l):l):r})}registerTreeDataProvider(u,p,D){const i=this.createTreeView(u,{treeDataProvider:p},D);return{dispose:()=>i.dispose()}}createTreeView(u,p,D){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=p.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(u,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,canDragAndDrop:i}),l=this.createExtHostTreeView(u,p,D);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get message(){return l.message},set message(s){l.message=s},get title(){return l.title},set title(s){l.title=s},get description(){return l.description},set description(s){l.description=s},reveal:(s,m)=>l.reveal(s,m),dispose:async()=>{await r,this.treeViews.delete(u),l.dispose()}}}$getChildren(u,p){const D=this.treeViews.get(u);return D?D.getChildren(p):Promise.reject(new Error((0,c.localize)(0,null,u)))}async $onDrop(u,p,D){const i=this.treeViews.get(u);if(!i)return Promise.reject(new Error((0,c.localize)(1,null,u)));const r=o.TreeDataTransferConverter.toITreeDataTransfer(p);if(r.items.has(I.TREE_ITEM_DATA_TRANSFER_TYPE)){const s=JSON.parse(await r.items.get(I.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(m=>i.getExtensionElement(m)).filter(m=>!!m);s.length>0?r.items.set(I.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(s)}):r.items.delete(I.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(r,D)}async $hasResolve(u){const p=this.treeViews.get(u);if(!p)throw new Error((0,c.localize)(2,null,u));return p.hasResolve}$resolve(u,p,D){const i=this.treeViews.get(u);if(!i)throw new Error((0,c.localize)(3,null,u));return i.resolveTreeItem(p,D)}$setExpanded(u,p,D){const i=this.treeViews.get(u);if(!i)throw new Error((0,c.localize)(4,null,u));i.setExpanded(p,D)}$setSelection(u,p){const D=this.treeViews.get(u);if(!D)throw new Error((0,c.localize)(5,null,u));D.setSelection(p)}$setVisible(u,p){const D=this.treeViews.get(u);if(!D)throw new Error((0,c.localize)(6,null,u));D.setVisible(p)}createExtHostTreeView(u,p,D){const i=new k(u,p,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(u,i),i}convertArgument(u){const p=this.treeViews.get(u.$treeViewId);return p?p.getExtensionElement(u.$treeItemHandle):null}}e.ExtHostTreeViews=g;class k extends T.Disposable{constructor(u,p,D,i,r,l){super();if(this.viewId=u,this.proxy=D,this.commands=i,this.logService=r,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,l.contributes&&l.contributes.views)for(const v in l.contributes.views)for(const w of l.contributes.views[v])w.id===u&&(this._title=w.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(v=>this._onDidChangeData.fire({message:!1,element:v}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(v=>this._onDidChangeData.fire({message:!1,element:v})));let s,m;this._register(A.Event.debounce(this._onDidChangeData.event,(v,w)=>(v||(v={message:!1,elements:[]}),w.element!==!1&&(s||(s=new Promise(C=>m=C),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(w.element)?v.elements.push(...w.element):v.elements.push(w.element)),w.message&&(v.message=!0),v),200,!0)(({message:v,elements:w})=>{w.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const C=m;return s=null,this.refresh(w).then(()=>C())})),v&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,t.isUndefinedOrNull)(u))}async getChildren(u){const p=u?this.getExtensionElement(u):void 0;if(u&&!p)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(u);return D||(D=await this.fetchChildrenNodes(p)),D?D.map(i=>i.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,p){p=p||{select:!0,focus:!1};const D=(0,t.isUndefinedOrNull)(p.select)?!0:p.select,i=(0,t.isUndefinedOrNull)(p.focus)?!1:p.focus,r=(0,t.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(l=>this.resolveTreeNode(u,l[l.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:l.map(m=>m.item)},{select:D,focus:i,expand:r})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:i,expand:r})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}setExpanded(u,p){const D=this.getExtensionElement(u);D&&(p?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(u){(0,y.equals)(this._selectedHandles,u)||(this._selectedHandles=u,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(u,p){const D=this.getExtensionElement(p);if(!!D)return(0,S.asPromise)(()=>this.dndController?.onDrop(u,D))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,p){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(u);if(D){const i=this.nodes.get(D);if(i){const r=await this.dataProvider.resolveTreeItem(i.extensionItem,D,p)??i.extensionItem;return i.item.tooltip=this.getTooltip(r.tooltip),i.item.command=this.getCommand(i.disposableStore,r.command),i.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(p=>p?this.resolveUnknownParentChain(p).then(D=>this.resolveTreeNode(p,D[D.length-1]).then(i=>(D.push(i),D))):Promise.resolve([]))}resolveParent(u){const p=this.nodes.get(u);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,p){const D=this.nodes.get(u);return D?Promise.resolve(D):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(i=>this.createHandle(u,i,p,!0)).then(i=>this.getChildren(p?p.item.handle:void 0).then(()=>{const r=this.getExtensionElement(i);if(r){const l=this.nodes.get(r);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(u){if(u){let p;if(typeof u=="string"){const D=this.getExtensionElement(u);p=D?this.nodes.get(D):void 0}else p=u;return p&&p.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const p=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=u?this.nodes.get(u):void 0,i=await this.dataProvider.getChildren(u);if(p.token.isCancellationRequested)return;const r=await Promise.all((0,y.coalesce)(i||[]).map(async l=>{const s=await this.dataProvider.getTreeItem(l);return s&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(l,s,D):null}));return p.token.isCancellationRequested?void 0:(0,y.coalesce)(r)}finally{p.dispose()}}refresh(u){if(u.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(u);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const p=new Set,D=u.map(r=>this.nodes.get(r));for(const r of D)if(r&&!p.has(r.item.handle)){let l=r;for(;l&&l.parent&&D.findIndex(s=>l&&l.parent&&s&&s.item.handle===l.parent.item.handle)===-1;){const s=this.elements.get(l.parent.item.handle);l=s?this.nodes.get(s):void 0}l&&!l.parent&&p.add(r.item.handle)}const i=[];return p.forEach(r=>{const l=this.elements.get(r);if(l){const s=this.nodes.get(l);s&&(!s.parent||!p.has(s.parent.item.handle))&&i.push(r)}}),i}refreshHandles(u){const p={};return Promise.all(u.map(D=>this.refreshNode(D).then(i=>{i&&(p[D]=i.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(u){const p=this.getExtensionElement(u);if(p){const D=this.nodes.get(p);if(D)return this.clearChildren(p),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(i=>{if(i){const r=this.createTreeNode(p,i,D.parent);return this.updateNodeCache(p,r,D,D.parent),D.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,p,D){const i=this.createTreeNode(u,p,D);if(p.id&&this.elements.has(i.item.handle))throw new Error((0,c.localize)(7,null,p.id));return this.addNodeToCache(u,i),this.addNodeToParentCache(i,D),i}getTooltip(u){return P.MarkdownString.isMarkdownString(u)?n.MarkdownString.from(u):u}getCommand(u,p){return p?this.commands.toInternal(p,u):void 0}createTreeNode(u,p,D){const i=new T.DisposableStore,r=this.createHandle(u,p,D),l=this.getLightIconPath(p);return{item:{handle:r,parentHandle:D?D.item.handle:void 0,label:a(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(i,p.command),contextValue:p.contextValue,icon:l,iconDark:this.getDarkIconPath(p)||l,themeIcon:this.getThemeIcon(p),collapsibleState:(0,t.isUndefinedOrNull)(p.collapsibleState)?P.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:D,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(u){return u.iconPath instanceof P.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:p,label:D,resourceUri:i},r,l){if(p)return`${k.ID_HANDLE_PREFIX}/${p}`;const s=a(D,this.extension),m=r?r.item.handle:k.LABEL_HANDLE_PREFIX;let v=s?s.label:i?(0,F.basename)(i):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const w=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,C=this.getChildrenNodes(r)||[];let R,f=0;do{if(R=`${m}/${f}:${v}`,l||!this.elements.has(R)||w===R)break;f++}while(f<=C.length);return R}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof P.ThemeIcon))return typeof u.iconPath=="string"||_.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof P.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return _.URI.isUri(u)?u:_.URI.file(u)}addNodeToCache(u,p){this.elements.set(p.item.handle,u),this.nodes.set(u,p)}updateNodeCache(u,p,D,i){this.elements.delete(p.item.handle),this.nodes.delete(u),p.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(u,p);const r=this.getChildrenNodes(i)||[],l=r.filter(s=>s.item.handle===D.item.handle)[0];l&&r.splice(r.indexOf(l),1,p)}addNodeToParentCache(u,p){p?(p.children||(p.children=[]),p.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const p=this.nodes.get(u);if(p){if(p.children)for(const D of p.children){const i=this.elements.get(D.item.handle);i&&this.clear(i)}p.children=void 0}}else this.clearAll()}clear(u){const p=this.nodes.get(u);if(p){if(p.children)for(const D of p.children){const i=this.elements.get(D.item.handle);i&&this.clear(i)}this.nodes.delete(u),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}k.LABEL_HANDLE_PREFIX="0",k.ID_HANDLE_PREFIX="1"}),define(ve[174],we([0,1,13,3,7,10,65,8,91,69]),function(ne,e,c,F,_,A,T,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends _.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const d=this.diff[this.diff.length-1];if(d&&n[0]===1){if(d[0]===1&&d[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(d[1],n[1]);return}if(d[0]===0&&d[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(d[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,d){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||d>o.expandLevels)&&(o.expandLevels=d),o.expand===1){const a=this.resolveChildren(o);return a.isOpen()?this.expandChildren(o,d-1):a.wait().then(()=>this.expandChildren(o,d-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,d-1)):this.expandChildren(o,d-1)}}dispose(){for(const n of this.tree.values())(0,T.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,d){switch(d.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,d.id));break;case 0:this.upsertItem(d.item,n);break;case 4:for(const b of d.ops)this.onTestItemEvent(n,b);break;case 3:const{key:o,value:a,previous:g}=d,k=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(a,g,k);break;case"range":this.pushDiff([1,{extId:k,item:{range:I.Range.from(a)}}]);break;case"error":this.pushDiff([1,{extId:k,item:{error:I.MarkdownString.fromStrict(a)||null}}]);break;default:this.pushDiff([1,{extId:k,item:{[o]:a??null}}]);break}break;default:(0,A.assertNever)(d)}}upsertItem(n,d){if(!(n instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=P.TestId.fromExtHostTestItem(n,this.root.id,d?.actual),a=(0,T.getPrivateApiFor)(n);a.parent&&a.parent!==d?.actual&&a.parent.children.delete(n.id);let g=this.tree.get(o.toString());if(!g){g={fullId:o,actual:n,parent:d?o.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(g.fullId.toString(),g),this.setItemParent(n,d),this.pushDiff([0,{parent:g.parent&&g.parent.toString(),controllerId:this.controllerId,expand:g.expand,item:I.TestItem.from(n)}]),this.connectItemAndChildren(n,g,d);return}if(g.actual===n){this.connectItem(n,g,d);return}const k=g.actual.children,b=g.actual,u=(0,T.diffTestItems)(b,n);(0,T.getPrivateApiFor)(b).listener=void 0,g.actual=n,g.expand=0;for(const[p,D]of u)this.onTestItemEvent(g,{op:3,key:p,value:D,previous:b[p]});this.connectItemAndChildren(n,g,d);for(const p of k)n.children.get(p.id)||this.removeItem(P.TestId.joinToString(o,p.id))}diffTagRefs(n,d,o){const a=new Set(d.map(g=>g.id));for(const g of n)a.delete(g.id)||this.incrementTagRefs(g);this.pushDiff([1,{extId:o,item:{tags:n.map(g=>I.TestTag.namespace(this.controllerId,g.id))}}]),a.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const d=this.tags.get(n.id);d?d.refCount++:(this.tags.set(n.id,{label:n.label,refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label,label:n.label}]))}decrementTagRefs(n){const d=this.tags.get(n);d&&!--d.refCount&&(this.tags.delete(n),this.pushDiff([6,I.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,d){(0,T.getPrivateApiFor)(n).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(n,d,o){this.setItemParent(n,o);const a=(0,T.getPrivateApiFor)(n);a.parent=o?.actual,a.listener=g=>this.onTestItemEvent(d,g),this.updateExpandability(d)}connectItemAndChildren(n,d,o){this.connectItem(n,d,o);for(const a of n.children)this.upsertItem(a,d)}updateExpandability(n){let d;this._resolveHandler?n.resolveBarrier?d=n.resolveBarrier.isOpen()?3:2:d=n.actual.canResolveChildren?1:0:d=0,d!==n.expand&&(n.expand=d,this.pushDiff([1,{extId:n.fullId.toString(),expand:d}]),d===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,d){if(d<0)return;const o=[];for(const a of n.actual.children){const g=this.expand(P.TestId.joinToString(n.fullId,a.id),d);(0,c.isThenable)(g)&&o.push(g)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const g=new c.Barrier;return g.open(),g}n.expand=2,this.pushExpandStateUpdate(n);const d=n.resolveBarrier=new c.Barrier,o=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=g.stack||g.message||String(g))};let a;try{a=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(g){o(g)}return(0,c.isThenable)(a)?a.catch(o).then(()=>{d.open(),this.updateExpandability(n)}):(d.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const d=this.tree.get(n);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[d];for(;o.length;){const a=o.pop();if(!!a){(0,T.getPrivateApiFor)(a.actual).listener=void 0;for(const g of a.actual.tags)this.decrementTagRefs(g.id);this.tree.delete(a.fullId.toString());for(const g of a.actual.children)o.push(this.tree.get(P.TestId.joinToString(a.fullId,g.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(ve[175],we([0,1,4,139]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(F.IEnvironmentService)}),define(ve[176],we([0,1,26,3,17]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class T{constructor(t){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let y of t.activationEvents)y==="onUri"&&(y=`onUri:${c.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(t)}}keepOnly(t){const y=new Set;t.forEach(n=>y.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>y.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,y){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=T._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(n.map(d=>d.identifier)),y.length>0){const d=new Set;y.forEach(o=>d.add(c.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!d.has(c.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,k){this.addNode(g),this.addNode(k),this._arcs.has(g)?this._arcs.get(g).push(k):this._arcs.set(g,[k])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,k){const b=y.getArcs(g);for(let u=0;u<b.length;u++)if(!k.has(b[u]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let g of t){const k=c.ExtensionIdentifier.toKey(g.identifier);if(n.set(k,g),g.extensionDependencies)for(let b of g.extensionDependencies){const u=c.ExtensionIdentifier.toKey(b);y.addArc(k,u)}}let d=new Set;y.getNodes().filter(g=>y.getArcs(g).length===0).forEach(g=>d.add(g));let o=y.getNodes().filter(g=>!d.has(g)),a;do{a=!1;for(let g=0;g<o.length;g++){const k=o[g];y.hasOnlyGoodArcs(k,d)&&(o.splice(g,1),g--,d.add(k),a=!0)}}while(a);return o.map(g=>n.get(g))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const y=this._activationMap.get(t);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const y=this._extensionsMap.get(c.ExtensionIdentifier.toKey(t));return y||void 0}}e.ExtensionDescriptionRegistry=T;var I;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(I||(I={}));function S(P,t){const y=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(y!==n)return y-n;const d=_.posix.basename(P.extensionLocation.path),o=_.posix.basename(t.extensionLocation.path);return d<o?-1:d>o?1:0}}),define(ve[177],we([0,1,23]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function A(I){const S=c.VSBuffer.alloc(1);switch(I){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=A;function T(I,S){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=T}),define(ve[30],we([0,1,3,2,4,26,140]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var I;(function(b){b[b.None=0]="None",b[b.LocalProcess=1]="LocalProcess",b[b.LocalWebWorker=2]="LocalWebWorker",b[b.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class S{constructor(u){this.dependency=u}}e.MissingExtensionDependency=S;var P;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));class t{constructor(u,p,D,i){this.codeLoadingTime=u,this.activateCallTime=p,this.activateResolvedTime=D,this.activationReason=i}}e.ActivationTimes=t;class y{constructor(u,p){this.description=u,this.value=p}}e.ExtensionPointContribution=y,e.ExtensionHostLogFileName="exthost";var n;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function d(b){b.enableProposedApi||o(b)}e.checkProposedApiEnabled=d;function o(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=o;function a(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=a;function g(b,u){return{identifier:new A.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!u,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=g;class k{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,p){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,p,D,i,r){}_onDidActivateExtensionError(u,p){}_onExtensionRuntimeError(u,p){}_onExtensionHostExit(u){}}e.NullExtensionService=k}),define(ve[178],we([0,1,26,30,14]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class T{constructor(o,a,g,k){this.startup=o,this.codeLoadingTime=a,this.activateCallTime=g,this.activateResolvedTime=k}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class I{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,a){return o===-1||a===-1?-1:a-o}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class S{constructor(o,a,g,k,b,u){this.activationFailed=o,this.activationFailedError=a,this.activationTimes=g,this.module=k,this.exports=b,this.subscriptions=u}}e.ActivatedExtension=S;class P extends S{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends S{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class y extends S{constructor(o){super(!0,o,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=y;let n=class{constructor(o,a,g,k,b){this._logService=b,this._registry=o,this._resolvedExtensionsSet=new Set,a.forEach(u=>this._resolvedExtensionsSet.add(c.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,g.forEach(u=>this._hostExtensionsMap.set(c.ExtensionIdentifier.toKey(u),u)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const a=c.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(a)}getActivatedExtension(o){const a=c.ExtensionIdentifier.toKey(o),g=this._activatedExtensions.get(a);if(!g)throw new Error("Extension `"+o.value+"` is not known or not activated");return g}activateByEvent(o,a){if(this._alreadyActivatedEvents[o])return A;const g=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(g.map(k=>({id:k.identifier,reason:{startup:a,extensionId:k.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,a){const g=this._registry.getExtensionDescription(o);if(!g)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:g.identifier,reason:a}])}_handleActivateRequest(o,a,g){if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(o.id))){a[c.ExtensionIdentifier.toKey(o.id)]=o;return}const k=this._registry.getExtensionDescription(o.id);if(!k){const p=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,p,new F.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(o.id),new y(p));return}const b=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let u=!0;for(let p=0,D=b.length;p<D;p++){const i=b[p];if(this._resolvedExtensionsSet.has(c.ExtensionIdentifier.toKey(i)))continue;const r=this._activatedExtensions.get(c.ExtensionIdentifier.toKey(i));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const v=k.displayName||k.identifier.value,w=this._registry.getExtensionDescription(i),C=w&&w.displayName||i,R=new Error(`Cannot activate the '${v}' extension because its dependency '${C}' failed to activate`);R.detail=r.activationFailedError,this._host.onExtensionActivationError(k.identifier,R,null),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(k.identifier),new y(R));return}if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(i))){u=!1,a[c.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(c.ExtensionIdentifier.toKey(i)),reason:o.reason};continue}const l=this._registry.getExtensionDescription(i);if(l){u=!1,a[c.ExtensionIdentifier.toKey(i)]={id:l.identifier,reason:o.reason};continue}const s=k.displayName||k.identifier.value,m=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(k.identifier,m,new F.MissingExtensionDependency(i)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(k.identifier),new y(m));return}u?a[c.ExtensionIdentifier.toKey(k.identifier)]=o:g.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(b=>!this._activatedExtensions.has(c.ExtensionIdentifier.toKey(b.id))),o.length===0))return Promise.resolve(void 0);const a=Object.create(null),g=[];for(let b=0,u=o.length;b<u;b++)this._handleActivateRequest(o[b],a,g);for(let b=0,u=g.length;b<u;b++){const p=c.ExtensionIdentifier.toKey(g[b].id);a[p]&&delete a[p]}const k=Object.keys(a).map(b=>a[b]);return g.length===0?Promise.all(k.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(k).then(b=>this._activateExtensions(g))}_activateExtension(o,a){const g=c.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const k=this._activatingExtensions.get(g);if(k)return k;const b=this._host.actualActivateExtension(o,a).then(void 0,u=>{const p=new Error;return u&&u.name&&(p.name=u.name),u&&u.message?p.message=`Activating extension '${o.value}' failed: ${u.message}.`:p.message=`Activating extension '${o.value}' failed: ${u}.`,u&&u.stack&&(p.stack=u.stack),this._host.onExtensionActivationError(o,p,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(u),new y(u)}).then(u=>{this._activatedExtensions.set(g,u),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,b),b}};n=Be([ze(4,_.ILogService)],n),e.ExtensionsActivator=n}),define(ve[179],we([0,1,15]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,T)=>{this._actualOk=A,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,c.onUnexpectedError)(A))}then(A,T){return this._ensureActual().then(A,T)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=F}),define(ve[46],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const F=[];function _(S){const P=new c(!0,S);return F[P.nid]=P,P}e.createMainContextProxyIdentifier=_;function A(S){const P=new c(!1,S);return F[P.nid]=P,P}e.createExtHostContextProxyIdentifier=A;function T(S){return F[S].sid}e.getStringIdentifierForProxy=T;class I{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=I}),define(ve[5],we([0,1,53,2,46]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var T;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(u){u.name="$ident";function p(i,r){return Object.defineProperty(i,u.name,{value:r,enumerable:!0}),i}u.mixin=p;function D(i){return i[u.name]}u.of=D})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(p){return p._id=d._n++,p}}e.IdObject=d,d._n=0;var o;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(g=e.WorkspaceEditType||(e.WorkspaceEditType={}));function k(u){if(u&&u.edits)for(const p of u.edits)typeof p.resource=="object"?p.resource=F.URI.revive(p.resource):(p.newUri=F.URI.revive(p.newUri),p.oldUri=F.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,c.revive)(p.metadata));return u}e.reviveWorkspaceEditDto=k;var b;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,_.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,_.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,_.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,_.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[70],we([0,1,5,3,4]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(I){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,S){return this._proxy.$getPassword(I,S)}store(I,S,P){return this._proxy.$setPassword(I,S,P)}delete(I,S){return this._proxy.$deletePassword(I,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(ve[71],we([0,1,4,14,5,12]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(S,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(_.MainContext.MainThreadTelemetry)}report(S,P,t){const y=this.getUsageKey(S,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:S}))}getUsageKey(S,P){return`${S}-${P.identifier.value}`}};T=Be([ze(0,A.IExtHostRpcService),ze(1,F.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(I,S,P){}})}),define(ve[180],we([0,1,3,5,6,26]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,P,t,y={}){const n=A.ExtensionIdentifier.toKey(S.identifier),d=this._inFlightRequests.get(n)||[],o=[...t].sort().join(" ");let a=d.find(g=>g.scopes===o);if(a)return a.result;{const g=this._getSession(S,n,P,t,y);a={scopes:o,result:g},d.push(a),this._inFlightRequests.set(n,d);try{await g}finally{const k=d.findIndex(b=>b.scopes===o);k>-1&&(d.splice(k),this._inFlightRequests.set(n,d))}return g}}async _getSession(S,P,t,y,n={}){await this._proxy.$ensureProvider(t);const d=S.displayName||S.name;return this._proxy.$getSession(t,y,P,d,n)}async removeSession(S,P){const t=this._authenticationProviders.get(S);return t?t.provider.removeSession(P):this._proxy.$removeSession(S,P)}registerAuthenticationProvider(S,P,t,y){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:P,provider:t,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===S)||this._providers.push({id:S,label:P});const n=t.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(S,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,P,y?.supportsMultipleAccounts??!1),new _.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const d=this._providers.findIndex(o=>o.id===S);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,P){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,P){return this._onDidChangeSessions.fire({provider:{id:S,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(ve[181],we([0,1,5,12,8]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(I,S){this._extHostDocumentsAndEditors=S,this._proxy=I.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const S=_.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=Be([ze(0,F.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ve[182],we([0,1,5]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(A){const T=A.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(I){return T.$writeText(I)}})}}e.ExtHostClipboard=F}),define(ve[47],we([0,1,10,6,8,22,5,16,14,53,41,111,2,7,4,12]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(i,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=i.getProxy(T.MainContext.MainThreadCommands),this._logService=r,this.converter=new k(this,l=>{const s=this._apiCommands.get(l);return s?.result===u.Void?s:void 0},r),this._argumentProcessors=[{processArgument(l){return(0,P.revive)(l)}},{processArgument(l){return(0,A.cloneAndChange)(l,function(s){if(t.Range.isIRange(s))return _.Range.to(s);if(y.Position.isIPosition(s))return _.Position.to(s);if(t.Range.isIRange(s.range)&&n.URI.isUri(s.uri))return _.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const r=this.registerCommand(!1,i.id,async(...l)=>{const s=i.args.map((v,w)=>{if(!v.validate(l[w]))throw new Error(`Invalid argument '${v.name}' when running '${i.id}', received: ${l[w]}`);return v.convert(l[w])}),m=await this.executeCommand(i.internalId,...s);return i.result.convert(m,l,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new F.Disposable(()=>{r.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,r,l,s,m){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:l,thisArg:s,description:m}),i&&this._proxy.$registerCommand(r),new F.Disposable(()=>{this._commands.delete(r)&&i&&this._proxy.$unregisterCommand(r)})}executeCommand(i,...r){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,r,!0)}async _doExecuteCommand(i,r,l){if(this._commands.has(i))return this._executeContributedCommand(i,r);{const s=(0,A.cloneAndChange)(r,function(m){if(m instanceof F.Position)return _.Position.from(m);if(m instanceof F.Range)return _.Range.from(m);if(m instanceof F.Location)return _.location.from(m);if(F.NotebookRange.isNotebookRange(m))return _.NotebookRange.from(m);if(!Array.isArray(m))return m});try{const m=await this._proxy.$executeCommand(i,s,l);return(0,P.revive)(m)}catch(m){if(m instanceof Error&&m.message==="$executeCommand:retry")return this._doExecuteCommand(i,r,!1);throw m}}}async _executeContributedCommand(i,r){const l=this._commands.get(i);if(!l)throw new Error("Unknown command");let{callback:s,thisArg:m,description:v}=l;if(v)for(let w=0;w<v.args.length;w++)try{(0,c.validateConstraint)(r[w],v.args[w].constraint)}catch(C){throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${v.args[w].name}' - ${v.args[w].description}`)}try{return await s.apply(m,r)}catch(w){if(i===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...r);C&&(i=C.command)}throw this._logService.error(w,i),new Error(`Running the contributed command: '${i}' failed.`)}}$executeContributedCommand(i,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(r=r.map(l=>this._argumentProcessors.reduce((s,m)=>m.processArgument(s),l)),this._executeContributedCommand(i,r)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),this._proxy.$getCommands().then(r=>(i&&(r=r.filter(l=>l[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[r,l]of this._commands){let{description:s}=l;s&&(i[r]=s)}return Promise.resolve(i)}};g=Be([ze(0,a.IExtHostRpcService),ze(1,S.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class k{constructor(i,r,l){this._commands=i,this._lookupApiCommand=r,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,r){if(!i)return;const l={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return l;const s=this._lookupApiCommand(i.command);if(s)l.id=s.internalId,l.arguments=s.args.map((m,v)=>m.convert(i.arguments&&i.arguments[v]));else if((0,I.isNonEmptyArray)(i.arguments)){const m=++this._cachIdPool;this._cache.set(m,i),r.add((0,d.toDisposable)(()=>{this._cache.delete(m),this._logService.trace("CommandsConverter#DISPOSE",m)})),l.$ident=m,l.id=this.delegatingCommandId,l.arguments=[m],this._logService.trace("CommandsConverter#CREATE",i.command,m)}return l}fromInternal(i){const r=T.ObjectIdentifier.of(i);return typeof r=="number"?this._cache.get(r):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const r=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=k;class b{constructor(i,r,l,s){this.name=i,this.description=r,this.validate=l,this.convert=s}optional(){return new b(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,r){return new b(i??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",D=>n.URI.isUri(D),D=>D),b.Position=new b("position","A position in a text document",D=>F.Position.isPosition(D),_.Position.from),b.Range=new b("range","A range in a text document",D=>F.Range.isRange(D),_.Range.from),b.Selection=new b("selection","A selection in a text document",D=>F.Selection.isSelection(D),_.Selection.from),b.Number=new b("number","",D=>typeof D=="number",D=>D),b.String=new b("string","",D=>typeof D=="string",D=>D),b.CallHierarchyItem=new b("item","A call hierarchy item",D=>D instanceof F.CallHierarchyItem,_.CallHierarchyItem.from),b.TypeHierarchyItem=new b("item","A type hierarchy item",D=>D instanceof F.TypeHierarchyItem,_.TypeHierarchyItem.from);class u{constructor(i,r){this.description=i,this.convert=r}}e.ApiCommandResult=u,u.Void=new u("no result",D=>D);class p{constructor(i,r,l,s,m){this.id=i,this.internalId=r,this.description=l,this.args=s,this.result=m}}e.ApiCommand=p}),define(ve[183],we([0,1,8,6,58,47,16,81]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(c.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,T.isFalsyOrEmpty)(n))return;class o extends F.SymbolInformation{static to(g){const k=new o(g.name,c.SymbolKind.to(g.kind),g.containerName||"",new F.Location(d[0],c.Range.to(g.range)));return k.detail=g.detail,k.range=k.location.range,k.selectionRange=c.Range.to(g.selectionRange),k.children=g.children?g.children.map(o.to):[],k}}return n.map(o.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(c.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(c.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>F.Position.isPosition(d)),n=>n.map(c.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let o;for(const a of d.reverse())o=new F.SelectionRange(c.Range.to(a),o);return o}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const d=[];if(Array.isArray(n))for(let o of n)d.push(...o[1].map(c.WorkspaceSymbol.to));return d})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,I.decodeSemanticTokensDto)(n);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,I.decodeSemanticTokensDto)(n);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,o)=>{if(!n)return new F.CompletionList([]);const a=n.suggestions.map(g=>c.CompletionItem.to(g,o));return new F.CompletionList(a,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,o)=>t(a=>new F.CodeLens(c.Range.to(a.range),a.command&&o.fromInternal(a.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>F.Range.isRange(n),n=>F.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,o)=>t(a=>{if(a._isSynthetic){if(!a.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(a.command)}else{const g=new F.CodeAction(a.title,a.kind?new F.CodeActionKind(a.kind):void 0);return a.edit&&(g.edit=c.WorkspaceEdit.to(a.edit)),a.command&&(g.command=o.fromInternal(a.command)),g.isPreferred=a.isPreferred,g}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new F.ColorInformation(c.Range.to(d.range),c.Color.to(d.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof F.Color,c.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>c.NotebookExclusiveDocumentPattern.to(d))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to)))];class P{static register(d){S.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=P;function t(n){return d=>{if(Array.isArray(d))return d.map(n)}}function y(n){if(!Array.isArray(n))return;const d=[];for(const o of n)_.isLocationLink(o)?d.push(c.DefinitionLink.to(o)):d.push(c.location.to(o));return d}}),define(ve[184],we([0,1,13,51,3,7,2,58,26,8,6,5]),function(ne,e,c,F,_,A,T,I,S,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(d,o,a){const g=d.getProxy(y.MainContext.MainThreadComments);class k{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const m=this._commentControllers.get(s.handle);return m||s}else if(s&&s.$mid===7){const m=this._commentControllers.get(s.commentControlHandle);if(!m)return s;const v=m.getCommentThread(s.commentThreadHandle);return v||s}else if(s&&s.$mid===8){const m=this._commentControllers.get(s.thread.commentControlHandle);if(!m)return s;const v=m.getCommentThread(s.thread.commentThreadHandle);return v?{thread:v,text:s.text}:s}else if(s&&s.$mid===9){const m=this._commentControllers.get(s.thread.commentControlHandle);if(!m)return s;const v=m.getCommentThread(s.thread.commentThreadHandle);if(!v)return s;let w=s.commentUniqueId,C=v.getCommentByUniqueId(w);return C||s}else if(s&&s.$mid===10){const m=this._commentControllers.get(s.thread.commentControlHandle);if(!m)return s;const v=m.getCommentThread(s.thread.commentThreadHandle);if(!v)return s;let w=s.text,C=s.commentUniqueId,R=v.getCommentByUniqueId(C);return R?(R.body=w,R):s}return s}})}createCommentController(s,m,v){const w=k.handlePool++,C=new u(s,w,m,v);this._commentControllers.set(C.handle,C);const R=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(s.identifier))||[];return R.push(C),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(s.identifier),R),C.value}$createCommentThreadTemplate(s,m,v){const w=this._commentControllers.get(s);!w||w.$createCommentThreadTemplate(m,v)}async $updateCommentThreadTemplate(s,m,v){const w=this._commentControllers.get(s);!w||w.$updateCommentThreadTemplate(m,v)}$deleteCommentThread(s,m){const v=this._commentControllers.get(s);v&&v.$deleteCommentThread(m)}$provideCommentingRanges(s,m,v){const w=this._commentControllers.get(s);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const C=a.getDocument(T.URI.revive(m));return(0,c.asPromise)(()=>w.commentingRangeProvider.provideCommentingRanges(C,v)).then(R=>R?R.map(f=>P.Range.from(f)):void 0)}$toggleReaction(s,m,v,w,C){const R=this._commentControllers.get(s);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const f=R.getCommentThread(m);if(f){const E=f.getCommentByUniqueId(w.uniqueIdInThread);if(R!==void 0&&E&&R.reactionHandler)return R.reactionHandler(E,i(C))}return Promise.resolve(void 0)})}dispose(){}}k.handlePool=0;class b{constructor(s,m,v,w,C,R,f){this._commentControllerHandle=m,this._id=v,this._uri=w,this._range=C,this._comments=R,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),g.$createCommentThread(m,this.handle,this._id,this._uri,P.Range.from(this._range),f),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(m,this.handle)}});const E=this;this.value={get uri(){return E.uri},get range(){return E.range},set range(h){E.range=h},get comments(){return E.comments},set comments(h){E.comments=h},get collapsibleState(){return E.collapsibleState},set collapsibleState(h){E.collapsibleState=h},get canReply(){return E.canReply},set canReply(h){E.canReply=h},get contextValue(){return E.contextValue},set contextValue(h){E.contextValue=h},get label(){return E.label},set label(h){E.label=h},dispose:()=>{E.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const s=v=>Object.prototype.hasOwnProperty.call(this.modifications,v),m={};s("range")&&(m.range=P.Range.from(this._range)),s("label")&&(m.label=this.label),s("contextValue")&&(m.contextValue=this.contextValue),s("comments")&&(m.comments=this._comments.map(v=>p(this,v,this._commentsMap))),s("collapsibleState")&&(m.collapseState=r(this._collapseState)),s("canReply")&&(m.canReply=this.canReply),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(s){for(let m of this._commentsMap){let v=m[0],w=m[1];if(s===w)return v}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}b._handlePool=0,Be([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class u{constructor(s,m,v,w){this._extension=s,this._handle=m,this._id=v,this._label=w,this._threads=new Map,g.$registerCommentController(this.handle,v,w);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(R){C.options=R},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(R){C.commentingRangeProvider=R},get reactionHandler(){return C.reactionHandler},set reactionHandler(R){C.reactionHandler=R},createCommentThread(R,f,E){return C.createCommentThread(R,f,E).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,m,v,w){if(typeof s=="string"){const C=new b(this.id,this.handle,s,m,v,w,this._extension.identifier);return this._threads.set(C.handle,C),C}else{const C=new b(this.id,this.handle,void 0,s,m,v,this._extension.identifier);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(s,m){const v=new b(this.id,this.handle,void 0,T.URI.revive(s),P.Range.to(m),[],this._extension.identifier);return v.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(v.handle,v),v}$updateCommentThreadTemplate(s,m){let v=this._threads.get(s);v&&(v.range=P.Range.to(m))}$deleteCommentThread(s){let m=this._threads.get(s);m&&m.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function p(l,s,m){let v=m.get(s);v||(v=++l.commentHandle,m.set(s,v));const w=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:v,body:P.MarkdownString.from(s.body),userName:s.author.name,userIconPath:w,label:s.label,commentReactions:s.reactions?s.reactions.map(C=>D(C)):void 0}}function D(l){return{label:l.label,iconPath:l.iconPath?P.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function i(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?T.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function r(l){if(l!==void 0)switch(l){case t.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new k}e.createExtHostComments=n}),define(ve[95],we([0,1,2,5,6,4,12,14,16,9,17]),function(ne,e,c,F,_,A,T,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class pi{constructor(d,o){this._logService=o,this._provider=new Map,this._proxy=d.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,o){const a=pi._handlePool++;this._provider.set(a,{provider:d,extensionId:o}),this._proxy.$registerDecorationProvider(a,o.value);const g=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(a,null);return}let b=(0,S.asArray)(k);if(b.length<=pi._maxEventSize){this._proxy.$onDidChange(a,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,b.length);const u=b.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),p=(0,S.groupBy)(u,(i,r)=>i.rank-r.rank||(0,P.compare)(i.uri.path,r.uri.path));let D=[];e:for(let i of p){let r;for(let l of i){let s=(0,t.dirname)(l.uri.path);if(r!==s&&(r=s,D.push(l.uri)>=pi._maxEventSize))break e}}this._proxy.$onDidChange(a,D)});return new _.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(d,o,a){if(!this._provider.has(d))return Object.create(null);const g=Object.create(null),{provider:k,extensionId:b}=this._provider.get(d);return await Promise.all(o.map(async u=>{try{const{uri:p,id:D}=u,i=await Promise.resolve(k.provideFileDecoration(c.URI.revive(p),a));if(!i)return;try{_.FileDecoration.validate(i),g[D]=[i.propagate,i.tooltip,i.badge,i.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${b.value}': ${r}`)}}catch(p){this._logService.error(p)}})),g}};y._handlePool=0,y._maxEventSize=250,y=Be([ze(0,T.IExtHostRpcService),ze(1,I.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(ve[185],we([0,1,121,83,2,5,6,8,3,14,20]),function(ne,e,c,F,_,A,T,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class y{constructor(o,a,g,k,b){this._name=o,this._owner=a,this._maxDiagnosticsPerFile=g,this._proxy=k,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new t.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,a){if(!o){this.clear();return}this._checkDisposed();let g=[];if(_.URI.isUri(o)){if(!a){this.delete(o);return}this._data.set(o,a.slice()),g=[o]}else if(Array.isArray(o)){g=[];let b;o=[...o].sort(y._compareIndexedTuplesByUri);for(const u of o){const[p,D]=u;if((!b||p.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=p,g.push(p),this._data.set(p,[])),D){const i=this._data.get(p);i&&i.push(...D)}else{const i=this._data.get(p);i&&(i.length=0)}}}if(this._onDidChangeDiagnostics.fire(g),!this._proxy)return;const k=[];for(let b of g){let u=[];const p=this._data.get(b);if(p)if(p.length>this._maxDiagnosticsPerFile){u=[];const D=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(let r of p)if(r.severity===D[i]&&u.push(I.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;u.push({severity:F.MarkerSeverity.Info,message:(0,c.localize)(0,null,p.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=p.map(D=>I.Diagnostic.from(D));k.push([b,u])}this._proxy.$changeMany(this._owner,k)}delete(o){this._checkDisposed(),this._onDidChangeDiagnostics.fire([o]),this._data.delete(o),this._proxy&&this._proxy.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(o,a){this._checkDisposed();for(let g of this._data.keys())o.apply(a,[g,this.get(g),this])}get(o){this._checkDisposed();const a=this._data.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this._data.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=y;let n=class ei{constructor(o,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ei._mapper),this._proxy=o.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(o){const a=new t.ResourceMap;for(const g of o)a.set(g,g);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(o,a){const{_collections:g,_proxy:k,_onDidChangeDiagnostics:b,_logService:u}=this,p=new class{$changeMany(r,l){k.$changeMany(r,l),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,r,l.length===0?"CLEARING":l)}$clear(r){k.$clear(r),u.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,r)}dispose(){k.dispose()}};let D;if(!a)a="_generated_diagnostic_collection_name_#"+ei._idPool++,D=a;else if(!g.has(a))D=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do D=a+ei._idPool++;while(g.has(D))}return new class extends y{constructor(){super(a,D,ei._maxDiagnosticsPerFile,p,b);g.set(D,this)}dispose(){super.dispose(),g.delete(D)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const a=new Map,g=[];for(const k of this._collections.values())k.forEach((b,u)=>{let p=a.get(b.toString());typeof p=="undefined"&&(p=g.length,a.set(b.toString(),p),g.push([b,[]])),g[p][1]=g[p][1].concat(...u)});return g}}_getDiagnostics(o){let a=[];for(let g of this._collections.values())g.has(o)&&(a=a.concat(g.get(o)));return a}$acceptMarkersChange(o){if(!this._mirrorCollection){const a="_generated_mirror",g=new y(a,a,ei._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,g),this._mirrorCollection=g}for(const[a,g]of o)this._mirrorCollection.set(_.URI.revive(a),g.map(I.Diagnostic.to))}};n._idPool=0,n._maxDiagnosticsPerFile=1e3,n=Be([ze(1,P.ILogService)],n),e.ExtHostDiagnostics=n}),define(ve[186],we([0,1,2,5]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(T){this._proxy=T.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(I=>I?I.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(I=>I?c.URI.revive(I):void 0)}}e.ExtHostDialogs=_}),define(ve[187],we([0,1,15,2,6,5,11,21,9]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,n,d){this._documentsAndEditors=n,this._logService=d,this._documentContentProviders=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,n){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const d=P._handlePool++;this._documentContentProviders.set(d,n),this._proxy.$registerTextContentProvider(d,y);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(a=>{if(a.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(d,a).then(g=>{if(!g&&typeof g!="string")return;const k=this._documentsAndEditors.getDocument(a);if(!k)return;const b=(0,S.splitLines)(g);if(!k.equalLines(b))return this._proxy.$onVirtualDocumentChange(a,g)},c.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(y,n){const d=this._documentContentProviders.get(y);return d?Promise.resolve(d.provideTextDocumentContent(F.URI.revive(n),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ve[188],we([0,1,3,7,2,5,89,8,10,22,6]),function(ne,e,c,F,_,A,T,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(d,o){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const g of a)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const g of a)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const o=this._documentsAndEditors.getDocument(d);if(o)return o}getDocument(d){const o=this.getDocumentData(d);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return o.document}ensureDocumentData(d){const o=this._documentsAndEditors.getDocument(d);if(o)return Promise.resolve(o);let a=this._documentLoader.get(d.toString());return a||(a=this._proxy.$tryOpenDocument(d).then(g=>{this._documentLoader.delete(d.toString());const k=_.URI.revive(g);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(k))},g=>(this._documentLoader.delete(d.toString()),Promise.reject(g))),this._documentLoader.set(d.toString(),a)),a}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(o=>_.URI.revive(o))}$acceptModelModeChanged(d,o){const a=_.URI.revive(d),g=this._documentsAndEditors.getDocument(a);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(o),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(d){const o=_.URI.revive(d),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(d,o){const a=_.URI.revive(d),g=this._documentsAndEditors.getDocument(a);if(!g)throw new Error("unknown document");g._acceptIsDirty(o),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,o,a){const g=_.URI.revive(d),k=this._documentsAndEditors.getDocument(g);if(!k)throw new Error("unknown document");k._acceptIsDirty(a),k.onEvents(o);let b;o.isUndoing?b=t.TextDocumentChangeReason.Undo:o.isRedoing&&(b=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:k.document,contentChanges:o.changes.map(u=>({range:I.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:b}))}setWordDefinitionFor(d,o){(0,T.setWordDefinitionFor)(d,o)}}e.ExtHostDocuments=y}),define(ve[48],we([0,1,39,3,7,2,4,5,89,12,94,8,14,20,11,189,103]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class k{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(p,D){this._extHostRpc=p,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const D=[],i=[],r=[];if(p.removedDocuments)for(const l of p.removedDocuments){const s=A.URI.revive(l),m=this._documents.get(s);m?.unref()&&(this._documents.delete(s),D.push(m.value))}if(p.addedDocuments)for(const l of p.addedDocuments){const s=A.URI.revive(l.uri);let m=this._documents.get(s);if(m&&s.scheme!==o.Schemas.vscodeNotebookCell&&s.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);m||(m=new k(new S.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),s,l.lines,l.EOL,l.versionId,l.modeId,l.isDirty,l.notebook)),this._documents.set(s,m),i.push(m.value)),m.ref()}if(p.removedEditors)for(const l of p.removedEditors){const s=this._editors.get(l);this._editors.delete(l),s&&r.push(s)}if(p.addedEditors)for(const l of p.addedEditors){const s=A.URI.revive(l.documentUri);c.ok(this._documents.has(s),`document '${s}' does not exist`),c.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const m=this._documents.get(s).value,v=new t.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>m.document),l.selections.map(y.Selection.to),l.options,l.visibleRanges.map(w=>y.Range.to(w)),typeof l.editorPosition=="number"?y.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,v)}p.newActiveEditor!==void 0&&(c.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,_.dispose)(D),(0,_.dispose)(r),p.removedDocuments&&this._onDidRemoveDocuments.fire(D),p.addedDocuments&&this._onDidAddDocuments.fire(i),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return p?D:D?.value}allEditors(){return[...this._editors.values()]}};b=Be([ze(0,P.IExtHostRpcService),ze(1,n.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[190],we([0,1,2,5,7,6,8,232,9,23]),function(ne,e,c,F,_,A,T,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const o=this._schemes.indexOf(d);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),o=[];let a,g,k=14,b=14;for(const u of d){let p=a?(0,S.commonPrefixLength)(a,u):0;for(p===0?g=1:g=b;p<u.length;p++)p+1===u.length?(k=b,b=9):b+=1,o.push([g,u.toUpperCase().charCodeAt(p),b]),o.push([g,u.toLowerCase().charCodeAt(p),b]),g=b;a=u,b=k}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new I.StateMachine(o)}}provideDocumentLinks(d){this._initStateMachine();const o=[],a=I.LinkComputer.computeLinks({getLineContent(g){return d.lineAt(g-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const g of a){const k=T.DocumentLink.to(g);k.target&&o.push(k)}return o}}class y{constructor(d,o){this._extHostLanguageFeatures=o,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=d.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,o,a,g={},k){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(b,a),this._enableProposedApi.set(b,k??!1);let u=2;g.isCaseSensitive&&(u+=1024),g.isReadonly&&(u+=2048),typeof a.copy=="function"&&(u+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(b,o,u).catch(D=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${o}`),console.error(D)});const p=a.onDidChangeFile(D=>{const i=[];for(const r of D){let{uri:l,type:s}=r;if(l.scheme!==o)continue;let m;switch(s){case A.FileChangeType.Changed:m=0;break;case A.FileChangeType.Created:m=1;break;case A.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:l,type:m})}this._proxy.$onFileSystemChange(b,i)});return(0,_.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(d,o){const{type:a,ctime:g,mtime:k,size:b,permissions:u}=d;return o?{type:a,ctime:g,mtime:k,size:b,permissions:u}:{type:a,ctime:g,mtime:k,size:b}}$stat(d,o){return Promise.resolve(this._getFsProvider(d).stat(c.URI.revive(o))).then(a=>y._asIStat(a,this._enableProposedApi.get(d)??!1))}$readdir(d,o){return Promise.resolve(this._getFsProvider(d).readDirectory(c.URI.revive(o)))}$readFile(d,o){return Promise.resolve(this._getFsProvider(d).readFile(c.URI.revive(o))).then(a=>P.VSBuffer.wrap(a))}$writeFile(d,o,a,g){return Promise.resolve(this._getFsProvider(d).writeFile(c.URI.revive(o),a.buffer,g))}$delete(d,o,a){return Promise.resolve(this._getFsProvider(d).delete(c.URI.revive(o),a))}$rename(d,o,a,g){return Promise.resolve(this._getFsProvider(d).rename(c.URI.revive(o),c.URI.revive(a),g))}$copy(d,o,a,g){const k=this._getFsProvider(d);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(c.URI.revive(o),c.URI.revive(a),g))}$mkdir(d,o){return Promise.resolve(this._getFsProvider(d).createDirectory(c.URI.revive(o)))}$watch(d,o,a,g){const k=this._getFsProvider(d).watch(c.URI.revive(a),g);this._watches.set(o,k)}$unwatch(d,o){const a=this._watches.get(o);a&&(a.dispose(),this._watches.delete(o))}$open(d,o,a){const g=this._getFsProvider(d);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(c.URI.revive(o),a))}$close(d,o){const a=this._getFsProvider(d);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(o))}$read(d,o,a,g){const k=this._getFsProvider(d);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const b=P.VSBuffer.alloc(g);return Promise.resolve(k.read(o,a,b.buffer,0,g)).then(u=>b.slice(0,u))}$write(d,o,a,g){const k=this._getFsProvider(d);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(o,a,g.buffer,0,g.byteLength))}_getFsProvider(d){const o=this._fsProvider.get(d);if(!o){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return o}}e.ExtHostFileSystem=y}),define(ve[72],we([0,1,5,59,6,23,4,12,45]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class xt{constructor(y,n){const d=y.getProxy(c.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return d.$stat(o).catch(xt._handleError)},readDirectory(o){return d.$readdir(o).catch(xt._handleError)},createDirectory(o){return d.$mkdir(o).catch(xt._handleError)},async readFile(o){return d.$readFile(o).then(a=>a.buffer).catch(xt._handleError)},writeFile(o,a){return d.$writeFile(o,A.VSBuffer.wrap(a)).catch(xt._handleError)},delete(o,a){return d.$delete(o,{recursive:!1,useTrash:!1,...a}).catch(xt._handleError)},rename(o,a,g){return d.$rename(o,a,{overwrite:!1,...g}).catch(xt._handleError)},copy(o,a,g){return d.$copy(o,a,{overwrite:!1,...g}).catch(xt._handleError)},isWritableFileSystem(o){const a=n.getCapabilities(o);if(typeof a=="number")return!(a&2048)}})}static _handleError(y){if(!(y instanceof Error))throw new _.FileSystemError(String(y));if(y.name==="ENOPRO")throw _.FileSystemError.Unavailable(y.message);switch(y.name){case F.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(y.message);case F.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(y.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(y.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(y.message);case F.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(y.message);case F.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(y.message);default:throw new _.FileSystemError(y.message,y.name)}}};P=Be([ze(0,I.IExtHostRpcService),ze(1,S.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[191],we([0,1,2,47]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(T,I,S,P){this._extHostNotebooks=I,this._textDocumentsAndEditors=S,this._commands=P;const t=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new F.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new F.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new F.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new F.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:c.URI.revive(y.notebookUri),inputUri:c.URI.revive(y.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(y.notebookUri),inputUri:c.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(T,I,S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],modeId:S,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=_}),define(ve[192],we([0,1,7,5]),function(ne,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(T){this._handlePool=0,this._proxy=T.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,T),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=_}),define(ve[193],we([0,1,2,22,8,6,5,9,41,16,10,233,7,81,52,63,194,15,3]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentSymbols(U,K){const ee=this._documents.getDocument(U),ae=await this._provider.provideDocumentSymbols(ee,K);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(_.DocumentSymbol.from):u._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((ae,V)=>{let se=ae.location.range.start.compareTo(V.location.range.start);return se===0&&(se=V.location.range.end.compareTo(ae.location.range.end)),se});const K=[],ee=[];for(const ae of U){const V={name:ae.name||"!!MISSING: name!!",kind:_.SymbolKind.from(ae.kind),tags:ae.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:_.Range.from(ae.location.range),selectionRange:_.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(V),K.push(V);break}const se=ee[ee.length-1];if(S.Range.containsRange(se.range,V.range)&&!S.Range.equalsRange(se.range,V.range)){se.children&&se.children.push(V),ee.push(V);break}ee.pop()}}return K}}class p{constructor(U,K,ee){this._documents=U,this._commands=K,this._provider=ee,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,K){const ee=this._documents.getDocument(U),ae=await this._provider.provideCodeLenses(ee,K);if(!ae||K.isCancellationRequested)return;const V=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(V,se);const he={cacheId:V,lenses:[]};for(let Te=0;Te<ae.length;Te++)he.lenses.push({cacheId:[V,Te],range:_.Range.from(ae[Te].range),command:this._commands.toInternal(ae[Te].command,se)});return he}async resolveCodeLens(U,K){const ee=U.cacheId&&this._cache.get(...U.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,K),ae||(ae=ee),K.isCancellationRequested)return;const V=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!V)return U.command=this._commands.toInternal(ae.command??p._badCmd,V),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function D(je){return Array.isArray(je)?je.map(_.DefinitionLink.from):je?[_.DefinitionLink.from(je)]:[]}class i{constructor(U,K){this._documents=U,this._provider=K}async provideDefinition(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.provideDefinition(ae,V,ee);return D(se)}}class r{constructor(U,K){this._documents=U,this._provider=K}async provideDeclaration(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.provideDeclaration(ae,V,ee);return D(se)}}class l{constructor(U,K){this._documents=U,this._provider=K}async provideImplementation(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.provideImplementation(ae,V,ee);return D(se)}}class s{constructor(U,K){this._documents=U,this._provider=K}async provideTypeDefinition(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.provideTypeDefinition(ae,V,ee);return D(se)}}class m{constructor(U,K){this._documents=U,this._provider=K}async provideHover(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.provideHover(ae,V,ee);if(!(!se||(0,P.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(V)),se.range||(se.range=new A.Range(V,V)),_.Hover.from(se)}}class v{constructor(U,K){this._documents=U,this._provider=K}async provideEvaluatableExpression(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.provideEvaluatableExpression(ae,V,ee);if(se)return _.EvaluatableExpression.from(se)}}class w{constructor(U,K){this._documents=U,this._provider=K}async provideInlineValues(U,K,ee,ae){const V=this._documents.getDocument(U),se=await this._provider.provideInlineValues(V,_.Range.to(K),_.InlineValueContext.to(ee),ae);if(Array.isArray(se))return se.map(he=>_.InlineValue.from(he))}}class C{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentHighlights(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.provideDocumentHighlights(ae,V,ee);if(Array.isArray(se))return se.map(_.DocumentHighlight.from)}}class R{constructor(U,K){this._documents=U,this._provider=K}async provideLinkedEditingRanges(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.provideLinkedEditingRanges(ae,V,ee);if(se&&Array.isArray(se.ranges))return{ranges:(0,P.coalesce)(se.ranges.map(_.Range.from)),wordPattern:se.wordPattern}}}class f{constructor(U,K){this._documents=U,this._provider=K}async provideReferences(U,K,ee,ae){const V=this._documents.getDocument(U),se=_.Position.to(K),he=await this._provider.provideReferences(V,se,ee,ae);if(Array.isArray(he))return he.map(_.location.from)}}class E{constructor(U,K,ee,ae,V,se,he){this._documents=U,this._commands=K,this._diagnostics=ee,this._provider=ae,this._logService=V,this._extension=se,this._apiDeprecation=he,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,K,ee,ae){const V=this._documents.getDocument(U),se=y.Selection.isISelection(K)?_.Selection.to(K):_.Range.to(K),he=[];for(const rt of this._diagnostics.getDiagnostics(U))if(se.intersection(rt.range)&&he.push(rt)>E._maxCodeActionsPerFile)break;const Te={diagnostics:he,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:_.CodeActionTriggerKind.to(ee.trigger)},Ue=await this._provider.provideCodeActions(V,se,Te,ae);if(!(0,P.isNonEmptyArray)(Ue)||ae.isCancellationRequested)return;const $e=this._cache.add(Ue),Ke=new n.DisposableStore;this._disposables.set($e,Ke);const _e=[];for(let rt=0;rt<Ue.length;rt++){const H=Ue[rt];!H||(E._isCommand(H)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:H.title,command:this._commands.toInternal(H,Ke)})):(Te.only&&(H.kind?Te.only.contains(H.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${H.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[$e,rt],title:H.title,command:H.command&&this._commands.toInternal(H.command,Ke),diagnostics:H.diagnostics&&H.diagnostics.map(_.Diagnostic.from),edit:H.edit&&_.WorkspaceEdit.from(H.edit),kind:H.kind&&H.kind.value,isPreferred:H.isPreferred,disabled:H.disabled?.reason})))}return{cacheId:$e,actions:_e}}async resolveCodeAction(U,K){const[ee,ae]=U,V=this._cache.get(ee,ae);if(!V||E._isCommand(V)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(V,K)??V;return se?.edit?_.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}E._maxCodeActionsPerFile=1e3;class h{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentFormattingEdits(U,K,ee){const ae=this._documents.getDocument(U),V=await this._provider.provideDocumentFormattingEdits(ae,K,ee);if(Array.isArray(V))return V.map(_.TextEdit.from)}}class M{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentRangeFormattingEdits(U,K,ee,ae){const V=this._documents.getDocument(U),se=_.Range.to(K),he=await this._provider.provideDocumentRangeFormattingEdits(V,se,ee,ae);if(Array.isArray(he))return he.map(_.TextEdit.from)}}class O{constructor(U,K){this._documents=U,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,K,ee,ae,V){const se=this._documents.getDocument(U),he=_.Position.to(K),Te=await this._provider.provideOnTypeFormattingEdits(se,he,ee,ae,V);if(Array.isArray(Te))return Te.map(_.TextEdit.from)}}class q{constructor(U,K){this._provider=U,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,K){const ee=T.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(U,K);if((0,P.isNonEmptyArray)(ae))for(const V of ae){if(!V)continue;if(!V.name){this._logService.warn("INVALID SymbolInformation, lacks name",V);continue}const se=T.IdObject.mixin(_.WorkspaceSymbol.from(V));this._symbolCache.set(se._id,V),ee.symbols.push(se)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(U,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const ee=this._symbolCache.get(U._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,K);return ae&&(0,F.mixin)(U,_.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(U){const K=this._resultCache.get(U);if(K){for(let[ee,ae]=K;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(U)}}}class Q{constructor(U,K,ee){this._documents=U,this._provider=K,this._logService=ee}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,K,ee,ae){const V=this._documents.getDocument(U),se=_.Position.to(K);try{const he=await this._provider.provideRenameEdits(V,se,ee,ae);return he?_.WorkspaceEdit.from(he):void 0}catch(he){const Te=Q._asMessage(he);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(U,K,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(U),V=_.Position.to(K);try{const se=await this._provider.prepareRename(ae,V,ee);let he,Te;if(A.Range.isRange(se)?(he=se,Te=ae.getText(se)):(0,t.isObject)(se)&&(he=se.range,Te=se.placeholder),!he||!Te)return;if(he.start.line>V.line||he.end.line<V.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(he),text:Te}}catch(se){const he=Q._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ${constructor(U,K){this.resultId=U,this.tokens=K}}class z{constructor(U,K){this._documents=U,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,K,ee){const ae=this._documents.getDocument(U),V=K!==0?this._previousResults.get(K):null;let se=typeof V?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,V.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return V&&this._previousResults.delete(K),se?(se=z._fixProvidedSemanticTokens(se),this._send(z._convertToEdits(V,se),se)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return z._isSemanticTokens(U)?z._isCorrectSemanticTokens(U)?U:new A.SemanticTokens(new Uint32Array(U.data),U.resultId):z._isSemanticTokensEdits(U)?z._isCorrectSemanticTokensEdits(U)?U:new A.SemanticTokensEdits(U.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const K of U.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,K){if(!z._isSemanticTokens(K)||!U||!U.tokens)return K;const ee=U.tokens,ae=ee.length,V=K.data,se=V.length;let he=0;const Te=Math.min(ae,se);for(;he<Te&&ee[he]===V[he];)he++;if(he===ae&&he===se)return new A.SemanticTokensEdits([],K.resultId);let Ue=0;const $e=Te-he;for(;Ue<$e&&ee[ae-Ue-1]===V[se-Ue-1];)Ue++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Ue,data:V.subarray(he,se-Ue)}],K.resultId)}_send(U,K){if(z._isSemanticTokens(U)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(U.resultId,U.data)),(0,d.encodeSemanticTokensDto)({id:ee,type:"full",data:U.data})}if(z._isSemanticTokensEdits(U)){const ee=this._nextResultId++;return z._isSemanticTokens(K)?this._previousResults.set(ee,new $(K.resultId,K.data)):this._previousResults.set(ee,new $(U.resultId)),(0,d.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(U.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class N{constructor(U,K){this._documents=U,this._provider=K}async provideDocumentRangeSemanticTokens(U,K,ee){const ae=this._documents.getDocument(U),V=await this._provider.provideDocumentRangeSemanticTokens(ae,_.Range.to(K),ee);return V?this._send(V):null}_send(U){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=N;class W{constructor(U,K,ee,ae,V){this._documents=U,this._commands=K,this._provider=ee,this._apiDeprecation=ae,this._extension=V,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,K,ee,ae){const V=this._documents.getDocument(U),se=_.Position.to(K),he=V.getWordRangeAtPosition(se)||new A.Range(se,se),Te=he.with({end:se}),Ue=new g.StopWatch(!0),$e=await this._provider.provideCompletionItems(V,se,ae,_.CompletionContext.to(ee));if(!$e||ae.isCancellationRequested)return;const Ke=Array.isArray($e)?new A.CompletionList($e):$e,_e=W.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),rt=new n.DisposableStore;this._disposables.set(_e,rt);const H=[],J={x:_e,b:H,a:{replace:_.Range.from(he),insert:_.Range.from(Te)},c:Ke.isIncomplete||void 0,d:Ue.elapsed()};for(let me=0;me<Ke.items.length;me++){const Ne=Ke.items[me],Ye=this._convertCompletionItem(Ne,[_e,me],Te,he);H.push(Ye)}return J}async resolveCompletionItem(U,K){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...U);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,K);if(!!ae)return this._convertCompletionItem(ae,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,K,ee,ae){const V=this._disposables.get(K[0]);if(!V)throw Error("DisposableStore is missing...");const se={x:K,a:U.label,b:U.kind!==void 0?_.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(_.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(U.command,V)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=U.textEdit.newText):typeof U.insertText=="string"?se.h=U.insertText:U.insertText instanceof A.SnippetString&&(se.h=U.insertText.value,se.i|=4);let he;return U.textEdit?he=U.textEdit.range:U.range&&(he=U.range),A.Range.isRange(he)?se.j=_.Range.from(he):he&&(!ee?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(se.j={insert:_.Range.from(he.inserting),replace:_.Range.from(he.replacing)}),se}}class j{constructor(U,K,ee){this._documents=U,this._provider=K,this._commands=ee,this._cache=new a.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,K,ee,ae){const V=this._documents.getDocument(U),se=_.Position.to(K),he=await this._provider.provideInlineCompletionItems(V,se,{selectedSuggestionInfo:ee.selectedSuggestionInfo?{range:_.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Te=(0,t.isArray)(he)?{items:he}:he,Ue=this._cache.add(Te.items);let $e;return{pid:Ue,items:Te.items.map((Ke,_e)=>{let rt;return Ke.command&&($e||($e=new n.DisposableStore,this._disposables.set(Ue,$e)),rt=this._commands.toInternal(Ke.command,$e)),{text:Ke.text,range:Ke.range?_.Range.from(Ke.range):void 0,command:rt,idx:_e}})}}disposeCompletions(U){this._cache.delete(U);const K=this._disposables.get(U);K&&K.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,K){const ee=this._cache.get(U,K);ee&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let K=Y.map.get(U);return K||(K=new Y,Y.map.set(U,K)),K}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class de{constructor(U,K){this._documents=U,this._provider=K,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(U,K,ee,ae){const V=this._documents.getDocument(U),se=_.Position.to(K),he=this.reviveContext(ee),Te=await this._provider.provideSignatureHelp(V,se,ae,he);if(Te){const Ue=this._cache.add([Te]);return{..._.SignatureHelp.from(Te),id:Ue}}}reviveContext(U){let K;if(U.activeSignatureHelp){const ee=_.SignatureHelp.to(U.activeSignatureHelp),ae=this._cache.get(U.activeSignatureHelp.id,0);ae?(K=ae,K.activeSignature=ee.activeSignature,K.activeParameter=ee.activeParameter):K=ee}return{...U,activeSignatureHelp:K}}releaseSignatureHelp(U){this._cache.delete(U)}}class G{constructor(U,K){this._documents=U,this._provider=K}async provideInlayHints(U,K,ee){const ae=this._documents.getDocument(U),V=await this._provider.provideInlayHints(ae,_.Range.to(K),ee);return V?{hints:V.map(_.InlayHint.from)}:void 0}}class ue{constructor(U,K){this._documents=U,this._provider=K,this._cache=new a.Cache("DocumentLink")}async provideLinks(U,K){const ee=this._documents.getDocument(U),ae=await this._provider.provideDocumentLinks(ee,K);if(!(!Array.isArray(ae)||ae.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(ue._validateLink).map(_.DocumentLink.from)};{const V=this._cache.add(ae),se={links:[],id:V};for(let he=0;he<ae.length;he++){if(!ue._validateLink(ae[he]))continue;const Te=_.DocumentLink.from(ae[he]);Te.cacheId=[V,he],se.links.push(Te)}return se}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,K){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...U);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,K);if(!(!ae||!ue._validateLink(ae)))return _.DocumentLink.from(ae)}releaseLinks(U){this._cache.delete(U)}}class oe{constructor(U,K){this._documents=U,this._provider=K}async provideColors(U,K){const ee=this._documents.getDocument(U),ae=await this._provider.provideDocumentColors(ee,K);return Array.isArray(ae)?ae.map(se=>({color:_.Color.from(se.color),range:_.Range.from(se.range)})):[]}async provideColorPresentations(U,K,ee){const ae=this._documents.getDocument(U),V=_.Range.to(K.range),se=_.Color.to(K.color),he=await this._provider.provideColorPresentations(se,{document:ae,range:V},ee);if(!!Array.isArray(he))return he.map(_.ColorPresentation.from)}}class be{constructor(U,K){this._documents=U,this._provider=K}async provideFoldingRanges(U,K,ee){const ae=this._documents.getDocument(U),V=await this._provider.provideFoldingRanges(ae,K,ee);if(!!Array.isArray(V))return V.map(_.FoldingRange.from)}}class Ae{constructor(U,K,ee){this._documents=U,this._provider=K,this._logService=ee}async provideSelectionRanges(U,K,ee){const ae=this._documents.getDocument(U),V=K.map(_.Position.to),se=await this._provider.provideSelectionRanges(ae,V,ee);if(!(0,P.isNonEmptyArray)(se))return[];if(se.length!==V.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Te=0;Te<V.length;Te++){const Ue=[];he.push(Ue);let $e=V[Te],Ke=se[Te];for(;;){if(!Ke.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(_.SelectionRange.from(Ke)),!Ke.parent)break;$e=Ke.range,Ke=Ke.parent}}return he}}class Re{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.prepareCallHierarchy(ae,V,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo(U,K,ee){const ae=this._itemFromCache(U,K);if(!ae)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!V)return V.map(se=>({from:this._cacheAndConvertItem(U,se.from),fromRanges:se.fromRanges.map(he=>_.Range.from(he))}))}async provideCallsFrom(U,K,ee){const ae=this._itemFromCache(U,K);if(!ae)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!V)return V.map(se=>({to:this._cacheAndConvertItem(U,se.to),fromRanges:se.fromRanges.map(he=>_.Range.from(he))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){const ee=this._cache.get(U),ae=_.CallHierarchyItem.from(K,U,ee.size.toString(36));return ee.set(ae._itemId,K),ae}_itemFromCache(U,K){return this._cache.get(U)?.get(K)}}class Oe{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,ee){const ae=this._documents.getDocument(U),V=_.Position.to(K),se=await this._provider.prepareTypeHierarchy(ae,V,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,se)]}async provideSupertypes(U,K,ee){const ae=this._itemFromCache(U,K);if(!ae)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!V)return V.map(se=>this._cacheAndConvertItem(U,se))}async provideSubtypes(U,K,ee){const ae=this._itemFromCache(U,K);if(!ae)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!V)return V.map(se=>this._cacheAndConvertItem(U,se))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){const ee=this._cache.get(U),ae=_.TypeHierarchyItem.from(K,U,ee.size.toString(36));return ee.set(ae._itemId,K),ae}_itemFromCache(U,K){return this._cache.get(U)?.get(K)}}class Qe{constructor(U,K){this.adapter=U,this.extension=K}}class He{constructor(U,K,ee,ae,V,se,he){this._adapter=new Map,this._uriTransformer=K,this._proxy=U.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=V,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector(U){return(0,P.coalesce)((0,P.asArray)(U).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:_.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new A.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return He._handlePool++}_withAdapter(U,K,ee,ae,V=!1){const se=this._adapter.get(U);if(!se)return Promise.resolve(ae);if(se.adapter instanceof K){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${K.name}'`));const Te=ee(se.adapter,se.extension),Ue=se.extension;return Ue&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),$e=>{V&&$e instanceof k.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error($e))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,K){const ee=this._nextHandle();return this._adapter.set(ee,new Qe(U,K)),ee}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,K,ee,ae){const V=this._addNewAdapter(new u(this._documents,ee),U),se=ae&&ae.label||He._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(V,this._transformDocumentSelector(K),se),this._createDisposable(V)}$provideDocumentSymbols(U,K,ee){return this._withAdapter(U,u,ae=>ae.provideDocumentSymbols(c.URI.revive(K),ee),void 0)}registerCodeLensProvider(U,K,ee){const ae=this._nextHandle(),V=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new p(this._documents,this._commands.converter,ee),U)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(K),V);let se=this._createDisposable(ae);if(V!==void 0){const he=ee.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(V));se=A.Disposable.from(se,he)}return se}$provideCodeLenses(U,K,ee){return this._withAdapter(U,p,ae=>ae.provideCodeLenses(c.URI.revive(K),ee),void 0)}$resolveCodeLens(U,K,ee){return this._withAdapter(U,p,ae=>ae.resolveCodeLens(K,ee),void 0)}$releaseCodeLenses(U,K){this._withAdapter(U,p,ee=>Promise.resolve(ee.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(U,K,ee){const ae=this._addNewAdapter(new i(this._documents,ee),U);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDefinition(U,K,ee,ae){return this._withAdapter(U,i,V=>V.provideDefinition(c.URI.revive(K),ee,ae),[])}registerDeclarationProvider(U,K,ee){const ae=this._addNewAdapter(new r(this._documents,ee),U);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDeclaration(U,K,ee,ae){return this._withAdapter(U,r,V=>V.provideDeclaration(c.URI.revive(K),ee,ae),[])}registerImplementationProvider(U,K,ee){const ae=this._addNewAdapter(new l(this._documents,ee),U);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideImplementation(U,K,ee,ae){return this._withAdapter(U,l,V=>V.provideImplementation(c.URI.revive(K),ee,ae),[])}registerTypeDefinitionProvider(U,K,ee){const ae=this._addNewAdapter(new s(this._documents,ee),U);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideTypeDefinition(U,K,ee,ae){return this._withAdapter(U,s,V=>V.provideTypeDefinition(c.URI.revive(K),ee,ae),[])}registerHoverProvider(U,K,ee,ae){const V=this._addNewAdapter(new m(this._documents,ee),U);return this._proxy.$registerHoverProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideHover(U,K,ee,ae){return this._withAdapter(U,m,V=>V.provideHover(c.URI.revive(K),ee,ae),void 0)}registerEvaluatableExpressionProvider(U,K,ee,ae){const V=this._addNewAdapter(new v(this._documents,ee),U);return this._proxy.$registerEvaluatableExpressionProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideEvaluatableExpression(U,K,ee,ae){return this._withAdapter(U,v,V=>V.provideEvaluatableExpression(c.URI.revive(K),ee,ae),void 0)}registerInlineValuesProvider(U,K,ee,ae){const V=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new w(this._documents,ee),U);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(K),V);let he=this._createDisposable(se);if(V!==void 0){const Te=ee.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(V));he=A.Disposable.from(he,Te)}return he}$provideInlineValues(U,K,ee,ae,V){return this._withAdapter(U,w,se=>se.provideInlineValues(c.URI.revive(K),ee,ae,V),void 0)}registerDocumentHighlightProvider(U,K,ee){const ae=this._addNewAdapter(new C(this._documents,ee),U);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentHighlights(U,K,ee,ae){return this._withAdapter(U,C,V=>V.provideDocumentHighlights(c.URI.revive(K),ee,ae),void 0)}registerLinkedEditingRangeProvider(U,K,ee){const ae=this._addNewAdapter(new R(this._documents,ee),U);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideLinkedEditingRanges(U,K,ee,ae){return this._withAdapter(U,R,async V=>{const se=await V.provideLinkedEditingRanges(c.URI.revive(K),ee,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?He._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(U,K,ee){const ae=this._addNewAdapter(new f(this._documents,ee),U);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideReferences(U,K,ee,ae,V){return this._withAdapter(U,f,se=>se.provideReferences(c.URI.revive(K),ee,ae,V),void 0)}registerCodeActionProvider(U,K,ee,ae){const V=new n.DisposableStore,se=this._addNewAdapter(new E(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(K),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,V)}))},He._extLabel(U),Boolean(ee.resolveCodeAction)),V.add(this._createDisposable(se)),V}$provideCodeActions(U,K,ee,ae,V){return this._withAdapter(U,E,se=>se.provideCodeActions(c.URI.revive(K),ee,ae,V),void 0)}$resolveCodeAction(U,K,ee){return this._withAdapter(U,E,ae=>ae.resolveCodeAction(K,ee),void 0)}$releaseCodeActions(U,K){this._withAdapter(U,E,ee=>Promise.resolve(ee.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(U,K,ee){const ae=this._addNewAdapter(new h(this._documents,ee),U);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(U,K,ee,ae){return this._withAdapter(U,h,V=>V.provideDocumentFormattingEdits(c.URI.revive(K),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(U,K,ee){const ae=this._addNewAdapter(new M(this._documents,ee),U);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(U,K,ee,ae,V){return this._withAdapter(U,M,se=>se.provideDocumentRangeFormattingEdits(c.URI.revive(K),ee,ae,V),void 0)}registerOnTypeFormattingEditProvider(U,K,ee,ae){const V=this._addNewAdapter(new O(this._documents,ee),U);return this._proxy.$registerOnTypeFormattingSupport(V,this._transformDocumentSelector(K),ae,U.identifier),this._createDisposable(V)}$provideOnTypeFormattingEdits(U,K,ee,ae,V,se){return this._withAdapter(U,O,he=>he.provideOnTypeFormattingEdits(c.URI.revive(K),ee,ae,V,se),void 0)}registerWorkspaceSymbolProvider(U,K){const ee=this._addNewAdapter(new q(K,this._logService),U);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(U,K,ee){return this._withAdapter(U,q,ae=>ae.provideWorkspaceSymbols(K,ee),{symbols:[]})}$resolveWorkspaceSymbol(U,K,ee){return this._withAdapter(U,q,ae=>ae.resolveWorkspaceSymbol(K,ee),void 0)}$releaseWorkspaceSymbols(U,K){this._withAdapter(U,q,ee=>ee.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(U,K,ee){const ae=this._addNewAdapter(new Q(this._documents,ee,this._logService),U);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(K),Q.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(U,K,ee,ae,V){return this._withAdapter(U,Q,se=>se.provideRenameEdits(c.URI.revive(K),ee,ae,V),void 0)}$resolveRenameLocation(U,K,ee,ae){return this._withAdapter(U,Q,V=>V.resolveRenameLocation(c.URI.revive(K),ee,ae),void 0)}registerDocumentSemanticTokensProvider(U,K,ee,ae){const V=this._nextHandle(),se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(V,new Qe(new z(this._documents,ee),U)),this._proxy.$registerDocumentSemanticTokensProvider(V,this._transformDocumentSelector(K),ae,se);let he=this._createDisposable(V);if(se){const Te=ee.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=A.Disposable.from(he,Te)}return he}$provideDocumentSemanticTokens(U,K,ee,ae){return this._withAdapter(U,z,V=>V.provideDocumentSemanticTokens(c.URI.revive(K),ee,ae),null,!0)}$releaseDocumentSemanticTokens(U,K){this._withAdapter(U,z,ee=>ee.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(U,K,ee,ae){const V=this._addNewAdapter(new N(this._documents,ee),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(V,this._transformDocumentSelector(K),ae),this._createDisposable(V)}$provideDocumentRangeSemanticTokens(U,K,ee,ae){return this._withAdapter(U,N,V=>V.provideDocumentRangeSemanticTokens(c.URI.revive(K),ee,ae),null,!0)}registerCompletionItemProvider(U,K,ee,ae){const V=this._addNewAdapter(new W(this._documents,this._commands.converter,ee,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(V,this._transformDocumentSelector(K),ae,W.supportsResolving(ee),`${U.identifier.value}(${ae.join("")})`),this._createDisposable(V)}$provideCompletionItems(U,K,ee,ae,V){return this._withAdapter(U,W,se=>se.provideCompletionItems(c.URI.revive(K),ee,ae,V),void 0)}$resolveCompletionItem(U,K,ee){return this._withAdapter(U,W,ae=>ae.resolveCompletionItem(K,ee),void 0)}$releaseCompletionItems(U,K){this._withAdapter(U,W,ee=>ee.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(U,K,ee){const ae=this._addNewAdapter(new j(this._documents,ee,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideInlineCompletions(U,K,ee,ae,V){return this._withAdapter(U,j,se=>se.provideInlineCompletions(c.URI.revive(K),ee,ae,V),void 0)}$handleInlineCompletionDidShow(U,K,ee){this._withAdapter(U,j,async ae=>{ae.handleDidShowCompletionItem(K,ee)},void 0)}$freeInlineCompletionsList(U,K){this._withAdapter(U,j,async ee=>{ee.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(U,K,ee,ae){const V=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new de(this._documents,ee),U);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(K),V),this._createDisposable(se)}$provideSignatureHelp(U,K,ee,ae,V){return this._withAdapter(U,de,se=>se.provideSignatureHelp(c.URI.revive(K),ee,ae,V),void 0)}$releaseSignatureHelp(U,K){this._withAdapter(U,de,ee=>ee.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(U,K,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,V=this._addNewAdapter(new G(this._documents,ee),U);this._proxy.$registerInlayHintsProvider(V,this._transformDocumentSelector(K),ae);let se=this._createDisposable(V);if(ae!==void 0){const he=ee.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(ae));se=A.Disposable.from(se,he)}return se}$provideInlayHints(U,K,ee,ae){return this._withAdapter(U,G,V=>V.provideInlayHints(c.URI.revive(K),ee,ae),void 0)}registerDocumentLinkProvider(U,K,ee){const ae=this._addNewAdapter(new ue(this._documents,ee),U);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(K),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(U,K,ee){return this._withAdapter(U,ue,ae=>ae.provideLinks(c.URI.revive(K),ee),void 0)}$resolveDocumentLink(U,K,ee){return this._withAdapter(U,ue,ae=>ae.resolveLink(K,ee),void 0)}$releaseDocumentLinks(U,K){this._withAdapter(U,ue,ee=>ee.releaseLinks(K),void 0)}registerColorProvider(U,K,ee){const ae=this._addNewAdapter(new oe(this._documents,ee),U);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentColors(U,K,ee){return this._withAdapter(U,oe,ae=>ae.provideColors(c.URI.revive(K),ee),[])}$provideColorPresentations(U,K,ee,ae){return this._withAdapter(U,oe,V=>V.provideColorPresentations(c.URI.revive(K),ee,ae),void 0)}registerFoldingRangeProvider(U,K,ee){const ae=this._nextHandle(),V=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new be(this._documents,ee),U)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(K),V);let se=this._createDisposable(ae);if(V!==void 0){const he=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(V));se=A.Disposable.from(se,he)}return se}$provideFoldingRanges(U,K,ee,ae){return this._withAdapter(U,be,V=>V.provideFoldingRanges(c.URI.revive(K),ee,ae),void 0)}registerSelectionRangeProvider(U,K,ee){const ae=this._addNewAdapter(new Ae(this._documents,ee,this._logService),U);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideSelectionRanges(U,K,ee,ae){return this._withAdapter(U,Ae,V=>V.provideSelectionRanges(c.URI.revive(K),ee,ae),[])}registerCallHierarchyProvider(U,K,ee){const ae=this._addNewAdapter(new Re(this._documents,ee),U);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareCallHierarchy(U,K,ee,ae){return this._withAdapter(U,Re,V=>Promise.resolve(V.prepareSession(c.URI.revive(K),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(U,K,ee,ae){return this._withAdapter(U,Re,V=>V.provideCallsTo(K,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(U,K,ee,ae){return this._withAdapter(U,Re,V=>V.provideCallsFrom(K,ee,ae),void 0)}$releaseCallHierarchy(U,K){this._withAdapter(U,Re,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}registerTypeHierarchyProvider(U,K,ee){const ae=this._addNewAdapter(new Oe(this._documents,ee),U);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareTypeHierarchy(U,K,ee,ae){return this._withAdapter(U,Oe,V=>Promise.resolve(V.prepareSession(c.URI.revive(K),ee,ae)),void 0)}$provideTypeHierarchySupertypes(U,K,ee,ae){return this._withAdapter(U,Oe,V=>V.provideSupertypes(K,ee,ae),void 0)}$provideTypeHierarchySubtypes(U,K,ee,ae){return this._withAdapter(U,Oe,V=>V.provideSubtypes(K,ee,ae),void 0)}$releaseTypeHierarchy(U,K){this._withAdapter(U,Oe,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,I.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:He._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:He._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?He._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?He._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:He._serializeRegExp(U.beforeText),afterText:U.afterText?He._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?He._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(He._serializeOnEnterRule)}setLanguageConfiguration(U,K,ee){let{wordPattern:ae}=ee;if(ae&&(0,I.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(K,ae):this._documents.setWordDefinitionFor(K,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const V=this._nextHandle(),se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?He._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?He._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?He._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(V,K,se),this._createDisposable(V)}$setWordDefinitions(U){for(const K of U)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=He,He._handlePool=0}),define(ve[195],we([0,1,5,8,6,35,13]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(P,t){this._handlePool=0,this._proxy=P.getProxy(c.MainContext.MainThreadLanguages),this._documents=t}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,t){await this._proxy.$changeLanguage(P,t);const y=this._documents.getDocumentData(P);if(!y)throw new Error(`document '${P.toString}' NOT found`);return y.document}async tokenAtPosition(P,t){const y=P.version,n=F.Position.from(t),d=await this._proxy.$tokensAtPosition(P.uri,n),o={type:_.StandardTokenType.Other,range:P.getWordRangeAtPosition(t)??new _.Range(t.line,t.character,t.line,t.character)};if(!d)return o;const a={range:F.Range.to(d.range),type:F.TokenType.to(d.type)};return!a.range.contains(t)||y!==P.version?o:a}createLanguageStatusItem(P){const t=this._handlePool++,y=this._proxy,n={selector:P,text:"",detail:"",severity:_.LanguageStatusSeverity.Information};let d;const o=()=>{d?.dispose(),d=(0,T.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(t,{selector:n.selector,text:n.text,message:typeof n.detail=="string"?n.detail:F.MarkdownString.from(n.detail),severity:n.severity===_.LanguageStatusSeverity.Error?A.default.Error:n.severity===_.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info})},0)},a={get selector(){return n.selector},set selector(g){n.selector=g,o()},get text(){return n.text},set text(g){n.text=g,o()},get detail(){return n.detail},set detail(g){n.detail=g,o()},get severity(){return n.severity},set severity(g){n.severity=g,o()},dispose(){d?.dispose(),y.$removeLanguageStatus(t)}};return o(),a}}e.ExtHostLanguages=I}),define(ve[196],we([0,1,5,14,30]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(I){return I&&I.title}let T=class{constructor(S,P){this._logService=P,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,P,t,y,n){const d={extension:S};let o;typeof y=="string"||A(y)?o=[y,...n]:(d.modal=y?.modal,d.useCustom=y?.useCustom,d.detail=y?.detail,o=n),d.useCustom&&(0,_.checkProposedApiEnabled)(S);const a=[];for(let g=0;g<o.length;g++){const k=o[g];if(typeof k=="string")a.push({title:k,handle:g,isCloseAffordance:!1});else if(typeof k=="object"){let{title:b,isCloseAffordance:u}=k;a.push({title:b,isCloseAffordance:!!u,handle:g})}else this._logService.warn("Invalid message item:",k)}return this._proxy.$showMessage(P,t,d,a).then(g=>{if(typeof g=="number")return o[g]})}};T=Be([ze(1,F.ILogService)],T),e.ExtHostMessageService=T}),define(ve[197],we([0,1,23,3,57,7,20,9,10,2,63,5,8,6,46,171,93]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{constructor(u,p,D,i,r){this._textDocumentsAndEditors=D,this._textDocuments=i,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=u.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===12){const s=l.notebookEditor?.notebookUri,m=l.cell.handle,w=this._documents.get(s)?.getCell(m);if(w)return w.apiCell}return l}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}getEditorById(u){const p=this._editors.get(u);if(!p)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(u){for(const[p,D]of this._editors)if(D.apiEditor===u)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(u,p){const D=this._documents.get(u);if(!D&&!p)throw new Error(`NO notebook document for '${u}'`);return D}_getProviderData(u){const p=this._notebookContentProviders.get(u);if(!p)throw new Error(`NO provider for '${u}'`);return p}registerNotebookContentProvider(u,p,D,i,r){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:u,provider:D});let l;return D.onDidChangeNotebookContentOptions&&(l=D.onDidChangeNotebookContentOptions(()=>{const s=n.NotebookDocumentContentOptions.from(D.options);this._notebookProxy.$updateNotebookProviderOptions(p,s)})),this._notebookProxy.$registerNotebookProvider({id:u.identifier,location:u.extensionLocation},p,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(u,r)),new d.Disposable(()=>{l?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(u,p){if(!p)return;const D=p.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(p.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:p.displayName,filenamePattern:D,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,p,D){const i=k._notebookStatusBarItemProviderHandlePool++,r=typeof D.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,r,p);let l;return r!==void 0&&(l=D.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(r))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,r),l&&l.dispose()})}async createNotebookDocument(u){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:u.viewType,content:u.content&&n.NotebookData.from(u.content)});return P.URI.revive(p)}async openNotebookDocument(u){const p=this._documents.get(u);if(p)return p.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(u),i=this._documents.get(P.URI.revive(D));return(0,S.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(u,p){P.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let D;typeof p=="object"?D={position:n.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(n.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:D={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.notebookType,D),r=i&&this._editors.get(i)?.apiEditor;if(r)return r;throw i?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,p,D,i){const r=this._notebookStatusBarItemProviders.get(u),l=P.URI.revive(p),s=this._documents.get(l);if(!s||!r)return;const m=s.getCellFromIndex(D);if(!m)return;const v=await r.provideCellStatusBarItems(m.apiCell,i);if(!v)return;const w=new A.DisposableStore,C=this._statusBarCache.add([w]),f=(Array.isArray(v)?v:[v]).map(E=>n.NotebookStatusBarItem.from(E,this._commandsConverter,w));return{cacheId:C,items:f}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}registerNotebookSerializer(u,p,D,i,r){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const l=this._handlePool++;return this._notebookSerializer.set(l,D),this._notebookProxy.$registerNotebookSerializer(l,{id:u.identifier,location:u.extensionLocation},p,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(u,r)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(l)})}async $dataToNotebook(u,p,D){const i=this._notebookSerializer.get(u);if(!i)throw new Error("NO serializer found");const r=await i.deserializeNotebook(p.buffer,D);return new o.SerializableObjectWithBuffers(n.NotebookData.from(r))}async $notebookToData(u,p,D){const i=this._notebookSerializer.get(u);if(!i)throw new Error("NO serializer found");const r=await i.serializeNotebook(n.NotebookData.to(p.value),D);return c.VSBuffer.wrap(r)}async $openNotebook(u,p,D,i,r){const{provider:l}=this._getProviderData(u),s=await l.openNotebook(P.URI.revive(p),{backupId:D,untitledDocumentData:i?.buffer},r);return new o.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(n.NotebookCellData.from)})}async $saveNotebook(u,p,D){const i=this.getNotebookDocument(P.URI.revive(p)),{provider:r}=this._getProviderData(u);return await r.saveNotebook(i.apiNotebook,D),!0}async $saveNotebookAs(u,p,D,i){const r=this.getNotebookDocument(P.URI.revive(p)),{provider:l}=this._getProviderData(u);return await l.saveNotebookAs(P.URI.revive(D),r.apiNotebook,i),!0}async $backupNotebook(u,p,D){const i=this.getNotebookDocument(P.URI.revive(p)),r=this._getProviderData(u),l=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),s=String((0,_.hash)([i.uri.toString(),this._backupIdPool++])),m=P.URI.joinPath(l,s),v=await r.provider.backupNotebook(i.apiNotebook,{destination:m},D);return i.updateBackup(v),v.id}_createExtHostEditor(u,p,D){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const i=new g.ExtHostNotebookEditor(p,this._notebookEditorsProxy,u,D.visibleRanges.map(n.NotebookRange.to),D.selections.map(n.NotebookRange.to),typeof D.viewColumn=="number"?n.ViewColumn.to(D.viewColumn):void 0);this._editors.set(p,i)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const D of u.value.removedDocuments){const i=P.URI.revive(D),r=this._documents.get(i);r&&(r.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(l=>l.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const l of this._editors.values())l.notebookData.uri.toString()===i.toString()&&this._editors.delete(l.id)}if(u.value.addedDocuments){const D=[];for(const i of u.value.addedDocuments){const r=P.URI.revive(i.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const l=this,s=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(m){l._onDidChangeNotebookCells.fire(m)},emitCellOutputsChange(m){l._onDidChangeCellOutputs.fire(m)},emitCellMetadataChange(m){l._onDidChangeCellMetadata.fire(m)},emitCellExecutionStateChange(m){l._onDidChangeCellExecutionState.fire(m)}},r,i);D.push(...i.cells.map(m=>a.ExtHostCell.asModelAddData(s.apiNotebook,m))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(u.value.addedEditors)for(const D of u.value.addedEditors){if(this._editors.has(D.id))return;const i=P.URI.revive(D.documentUri),r=this._documents.get(i);r&&this._createExtHostEditor(r,D.id,D)}const p=[];if(u.value.removedEditors)for(const D of u.value.removedEditors){const i=this._editors.get(D);i&&(this._editors.delete(D),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),p.push(i))}if(u.value.visibleEditors){this._visibleNotebookEditors=u.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const D=new Set;this._visibleNotebookEditors.forEach(i=>D.add(i.id));for(const i of this._editors.values()){const r=D.has(i.id);i._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this._activeNotebookEditor=void 0:u.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(ve[198],we([0,1,3,52,14,5,12,8]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(y,n){const d=S._Keys.nextId();y.$registerNotebookEditorDecorationType(d,I.NotebookDecorationRenderOptions.from(n)),this.value={key:d,dispose(){y.$removeNotebookEditorDecorationType(d)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(y,n,d){this._logService=y,this._extHostRpc=n,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new S(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,n);const d=this._notebooksAndEditors.getEditorById(y);n.visibleRanges&&d._acceptVisibleRanges(n.visibleRanges.ranges.map(I.NotebookRange.to)),n.selections&&d._acceptSelections(n.selections.selections.map(I.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const n in y)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(I.ViewColumn.to(y[n]))}};P=Be([ze(0,_.ILogService),ze(1,T.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(ve[199],we([0,1,16,13,21,3,7,20,2,26,14,5,8,6,68,164,30,46]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(r,l,s,m){this._initData=l,this._extHostNotebook=s,this._logService=m,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(y.MainContext.MainThreadNotebookKernels)}createNotebookController(r,l,s,m,v,w){for(let Y of this._kernelData.values())if(Y.controller.id===l&&P.ExtensionIdentifier.equals(r.identifier,Y.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const C=this._handlePool++,R=this;this._logService.trace(`NotebookController[${C}], CREATED by ${r.identifier.value}, ${l}`);const f=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${r.identifier}'`);let E=!1;const h=new T.DisposableStore,M=new A.Emitter,O=new A.Emitter,q={id:`${r.identifier.value}/${l}`,notebookType:s,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:m||r.identifier.value,preloads:w?w.map(n.NotebookRendererScript.from):[]};let Q=v??f,$;this._proxy.$addKernel(C,q).catch(Y=>{console.log(Y),E=!0});let z=0;const N=()=>{if(E)return;const Y=++z;Promise.resolve().then(()=>{Y===z&&this._proxy.$updateKernel(C,q)})},W=new I.ResourceMap,j={get id(){return l},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return q.label},set label(Y){q.label=Y??r.displayName??r.name,N()},get detail(){return q.detail??""},set detail(Y){q.detail=Y,N()},get description(){return q.description??""},set description(Y){q.description=Y,N()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(Y){q.supportedLanguages=Y,N()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){q.supportsExecutionOrder=Y,N()},get rendererScripts(){return q.preloads?q.preloads.map(n.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(Y){Q=Y??f},get interruptHandler(){return $},set interruptHandler(Y){$=Y,q.supportsInterrupt=Boolean(Y),N()},createNotebookCellExecution(Y){if(E)throw new Error("notebook controller is DISPOSED");if(!W.has(Y.notebook.uri))throw R._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(W.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return R._createNotebookCellExecution(Y)},dispose:()=>{E||(this._logService.trace(`NotebookController[${C}], DISPOSED`),E=!0,this._kernelData.delete(C),h.dispose(),M.dispose(),O.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(Y,de){R._proxy.$updateNotebookPriority(C,Y.uri,de)},onDidReceiveMessage:O.event,postMessage(Y,de){return(0,g.checkProposedApiEnabled)(r),R._proxy.$postMessage(C,de&&R._extHostNotebook.getIdByEditor(de),Y)},asWebviewUri(Y){return(0,g.checkProposedApiEnabled)(r),(0,o.asWebviewUri)(Y,R._initData.remote)}};return this._kernelData.set(C,{extensionId:r.identifier,controller:j,onDidReceiveMessage:O,onDidChangeSelection:M,associatedNotebooks:W}),j}$acceptNotebookAssociation(r,l,s){const m=this._kernelData.get(r);if(m){const v=this._extHostNotebook.getNotebookDocument(S.URI.revive(l));s?m.associatedNotebooks.set(v.uri,!0):m.associatedNotebooks.delete(v.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,v.uri.toString(),s),m.onDidChangeSelection.fire({selected:s,notebook:v.apiNotebook})}}async $executeCells(r,l,s){const m=this._kernelData.get(r);if(!m)return;const v=this._extHostNotebook.getNotebookDocument(S.URI.revive(l)),w=[];for(let C of s){const R=v.getCell(C);R&&w.push(R.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,v.uri.toString(),w.length),await m.controller.executeHandler.call(m.controller,w,v.apiNotebook,m.controller)}catch(C){this._logService.error(`NotebookController[${r}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(r,l,s){const m=this._kernelData.get(r);if(!m)return;const v=this._extHostNotebook.getNotebookDocument(S.URI.revive(l));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,v.apiNotebook);else for(let w of s){const C=v.getCell(w);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,l,s){const m=this._kernelData.get(r);if(!m)return;const v=this._extHostNotebook.getEditorById(l);m.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:s}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const m=new p(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,m);const v=m.onDidChangeState(()=>{m.state===u.Resolved&&(m.dispose(),v.dispose(),this._activeExecutions.delete(s.uri))});return m.asApiObject()}};b=Be([ze(3,t.ILogService)],b),e.ExtHostNotebookKernels=b;var u;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(u||(u={}));class p extends T.Disposable{constructor(r,l,s){super();this._document=r,this._cell=l,this._proxy=s,this._handle=p.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new D(10,m=>this.update(m)),this._executionOrder=l.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const l=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new k.SerializableObjectWithBuffers(l))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let l=this._cell;if(r&&(l=this._document.getCellFromApiCell(r)),!l)throw new Error("INVALID cell");return l.handle}validateAndConvertOutputs(r){return r.map(l=>{const s=d.NotebookCellOutput.ensureUniqueMimeTypes(l.items,!0);return s===l.items?n.NotebookCellOutput.from(l):n.NotebookCellOutput.from({items:s,id:l.id,metadata:l.metadata})})}async updateOutputs(r,l,s){const m=this.cellIndexToHandle(l),v=this.validateAndConvertOutputs((0,c.asArray)(r));return this.updateSoon({editType:a.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:m,append:s,outputs:v})}async updateOutputItems(r,l,s){return r=d.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.updateSoon({editType:a.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(n.NotebookCellOutputItem.from),outputId:l.id,append:s})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(s){r._executionOrder=s,r.update([{editType:a.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(s){if(r._state===u.Resolved||r._state===u.Started)throw new Error("Cannot call start again");r._state=u.Started,r._onDidChangeState.fire(),r.update({editType:a.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:s})},end(s,m){if(r._state===u.Resolved)throw new Error("Cannot call resolve twice");r._state=u.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:a.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:m,lastRunSuccess:s}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(s){return r.verifyStateForOutput(),r.updateOutputs([],s,!1)},appendOutput(s,m){return r.verifyStateForOutput(),r.updateOutputs(s,m,!0)},replaceOutput(s,m){return r.verifyStateForOutput(),r.updateOutputs(s,m,!1)},appendOutputItems(s,m){return r.verifyStateForOutput(),r.updateOutputItems(s,m,!0)},replaceOutputItems(s,m){return r.verifyStateForOutput(),r.updateOutputItems(s,m,!1)}})}}p.HANDLE=0;class D{constructor(r,l){this.delay=r,this.callback=l,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const l=this.batch;return this.batch=[],this.callback(l).finally(()=>r.complete())}}}),define(ve[200],we([0,1,3,5,93]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(I,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,S,P){const t=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(S)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(I,S){if(!I.contributes?.notebookRenderer?.some(n=>n.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const P=!!I.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,d,o)=>{const a=P?n:g=>{const k={};t.set(k,g.editor),n({editor:k,message:g.message})};return this.getOrCreateEmitterFor(S).event(a,d,o)},postMessage:(n,d)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,d]=[d,n]);const o=P?d:t.get(d),a=o&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(o);return this.proxy.$postMessage(a?.id,S,n)}}}getOrCreateEmitterFor(I){let S=this._rendererMessageEmitters.get(I);return S||(S=new c.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,S),S)}}e.ExtHostNotebookRenderers=A}),define(ve[96],we([0,1,5,3,7,23,4,12]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends _.Disposable{constructor(o,a,g,k,b){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=b,this._id=b.$register(this.name,a,g,k),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?A.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(a=>this._proxy.$clear(a,o))}show(o,a){this.validate(),this._id.then(g=>this._proxy.$reveal(g,!!(typeof o=="boolean"?o:a)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class P extends S{constructor(o,a,g){super(o,!1,void 0,a,g)}append(o){super.append(o),this._id.then(a=>this._proxy.$append(a,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends S{constructor(o,a,g){super(o,!0,a,void 0,g)}append(o){throw new Error("Not supported")}}class y{constructor(o,a){this.name=o,this._channel=a}append(o){this._channel.then(a=>a.append(o))}appendLine(o){this._channel.then(a=>a.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,a){this._channel.then(g=>g.show(o,a))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=y;let n=class{constructor(o){this._proxy=o.getProxy(c.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o,a){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new P(o,a.identifier.value,this._proxy)}createOutputChannelFromLogFile(o,a){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new t(o,a,this._proxy)}};n=Be([ze(0,I.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(ve[201],we([0,1,13,21,3,7,5,2,6,15,16,35,43]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(o,a,g){const k=o.getProxy(T.MainContext.MainThreadQuickOpen);class b{constructor(v,w){this._sessions=new Map,this._instances=0,this._workspace=v,this._commands=w}showQuickPick(v,w,C,R=F.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(v),E=++this._instances,h=k.$show(E,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},R),M={},O=h.then(()=>M);return Promise.race([O,f]).then(q=>{if(q!==M)return f.then(Q=>{const $=[];for(let z=0;z<Q.length;z++){const N=Q[z];let W,j,Y,de,G;typeof N=="string"?W=N:(W=N.label,j=N.description,Y=N.detail,de=N.picked,G=N.alwaysShow),$.push({label:W,description:j,handle:z,detail:Y,picked:de,alwaysShow:G})}return C&&typeof C.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{C.onDidSelectItem(Q[z])}),k.$setItems(E,$),h.then(z=>{if(typeof z=="number")return Q[z];if(Array.isArray(z))return z.map(N=>Q[N])})})}).then(void 0,q=>{if(!(0,P.isPromiseCanceledError)(q))return k.$setError(E,q),Promise.reject(q)})}$onItemSelected(v){this._onDidSelectItem&&this._onDidSelectItem(v)}showInput(v,w=F.CancellationToken.None){return this._validateInput=v?v.validateInput:void 0,k.$input(v,typeof this._validateInput=="function",w).then(void 0,C=>{if(!(0,P.isPromiseCanceledError)(C))return Promise.reject(C)})}$validateInput(v){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(v)):Promise.resolve(void 0)}async showWorkspaceFolderPick(v,w=F.CancellationToken.None){const C=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!C)return;const R=await this._workspace.getWorkspaceFolders2();if(!!R)return R.find(f=>f.uri.toString()===C.uri.toString())}createQuickPick(v,w){const C=new l(v,w,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(v){const w=new s(v,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}$onDidChangeValue(v,w){const C=this._sessions.get(v);C&&C._fireDidChangeValue(w)}$onDidAccept(v){const w=this._sessions.get(v);w&&w._fireDidAccept()}$onDidChangeActive(v,w){const C=this._sessions.get(v);C instanceof l&&C._fireDidChangeActive(w)}$onDidChangeSelection(v,w){const C=this._sessions.get(v);C instanceof l&&C._fireDidChangeSelection(w)}$onDidTriggerButton(v,w){const C=this._sessions.get(v);C&&C._fireDidTriggerButton(w)}$onDidTriggerItemButton(v,w,C){const R=this._sessions.get(v);R instanceof l&&R._fireDidTriggerItemButton(w,C)}$onDidHide(v){const w=this._sessions.get(v);w&&w._fireDidHide()}}class u{constructor(v,w){this._extensionId=v,this._onDidDispose=w,this._id=l._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(v){this._title=v,this.update({title:v})}get step(){return this._steps}set step(v){this._steps=v,this.update({step:v})}get totalSteps(){return this._totalSteps}set totalSteps(v){this._totalSteps=v,this.update({totalSteps:v})}get enabled(){return this._enabled}set enabled(v){this._enabled=v,this.update({enabled:v})}get busy(){return this._busy}set busy(v){this._busy=v,this.update({busy:v})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(v){this._ignoreFocusOut=v,this.update({ignoreFocusOut:v})}get value(){return this._value}set value(v){this._value=v,this.update({value:v})}get placeholder(){return this._placeholder}set placeholder(v){this._placeholder=v,this.update({placeholder:v})}get buttons(){return this._buttons}set buttons(v){this._buttons=v.slice(),this._handlesToButtons.clear(),v.forEach((w,C)=>{const R=w===S.QuickInputButtons.Back?-1:C;this._handlesToButtons.set(R,w)}),this.update({buttons:v.map((w,C)=>({...r(w),tooltip:w.tooltip,handle:w===S.QuickInputButtons.Back?-1:C}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(v){this._value=v,this._onDidChangeValueEmitter.fire(v)}_fireDidTriggerButton(v){const w=this._handlesToButtons.get(v);w&&this._onDidTriggerButtonEmitter.fire(w)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),k.$dispose(this._id))}update(v){if(!this._disposed){for(const w of Object.keys(v)){const C=v[w];this._pendingUpdate[w]=C===void 0?null:C}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){k.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}u._nextId=1;function p(m){if(m instanceof S.ThemeIcon)return{id:m.id};const v=i(m),w=D(m);return{dark:typeof v=="string"?I.URI.file(v):v,light:typeof w=="string"?I.URI.file(w):w}}function D(m){return typeof m=="object"&&"light"in m?m.light:m}function i(m){return typeof m=="object"&&"dark"in m?m.dark:m}function r(m){const v=p(m.iconPath);let w,C;return"id"in v?C=n.ThemeIcon.asClassName(v):w=v,{iconPath:w,iconClass:C}}class l extends u{constructor(v,w,C){super(v,C);this.enableProposedApi=w,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(v){this._items=v.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),v.forEach((w,C)=>{this._handlesToItems.set(C,w),this._itemsToHandles.set(w,C)}),this.update({items:v.map((w,C)=>({label:w.label,description:w.description,handle:C,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,buttons:w.buttons&&this.enableProposedApi?w.buttons.map((R,f)=>({...r(R),tooltip:R.tooltip,handle:f})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(v){this._canSelectMany=v,this.update({canSelectMany:v})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(v){this._matchOnDescription=v,this.update({matchOnDescription:v})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(v){this._matchOnDetail=v,this.update({matchOnDetail:v})}get sortByLabel(){return this._sortByLabel}set sortByLabel(v){this._sortByLabel=v,this.update({sortByLabel:v})}get activeItems(){return this._activeItems}set activeItems(v){this._activeItems=v.filter(w=>this._itemsToHandles.has(w)),this.update({activeItems:this._activeItems.map(w=>this._itemsToHandles.get(w))})}get selectedItems(){return this._selectedItems}set selectedItems(v){this._selectedItems=v.filter(w=>this._itemsToHandles.has(w)),this.update({selectedItems:this._selectedItems.map(w=>this._itemsToHandles.get(w))})}_fireDidChangeActive(v){const w=(0,t.coalesce)(v.map(C=>this._handlesToItems.get(C)));this._activeItems=w,this._onDidChangeActiveEmitter.fire(w)}_fireDidChangeSelection(v){const w=(0,t.coalesce)(v.map(C=>this._handlesToItems.get(C)));this._selectedItems=w,this._onDidChangeSelectionEmitter.fire(w)}_fireDidTriggerItemButton(v,w){const C=this._handlesToItems.get(v);if(!C||!C.buttons||!C.buttons.length)return;const R=C.buttons[w];R&&this._onDidTriggerItemButtonEmitter.fire({button:R,item:C})}}class s extends u{constructor(v,w){super(v,w);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(v){this._password=v,this.update({password:v})}get prompt(){return this._prompt}set prompt(v){this._prompt=v,this.update({prompt:v})}get validationMessage(){return this._validationMessage}set validationMessage(v){this._validationMessage=v,this.update({validationMessage:v,severity:v?y.default.Error:y.default.Ignore})}}return new b(a,g)}e.createExtHostQuickOpen=d}),define(ve[202],we([0,1,2,3,51,7,13,5,16,107,14,26,30,43,8]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(v){if(v)return typeof v.iconPath=="string"?c.URI.file(v.iconPath):c.URI.isUri(v.iconPath)||d.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function g(v,w){if(!v.iconPath&&!w.iconPath)return 0;if(v.iconPath){if(!w.iconPath)return 1}else return-1;const C=typeof v.iconPath=="string"?v.iconPath:c.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,R=typeof w.iconPath=="string"?w.iconPath:c.URI.isUri(w.iconPath)?w.iconPath.fsPath:w.iconPath.id;return(0,P.comparePaths)(C,R)}function k(v,w){let C=0;if(v.strikeThrough!==w.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==w.faded)return v.faded?1:-1;if(v.tooltip!==w.tooltip)return(v.tooltip||"").localeCompare(w.tooltip||"");if(C=g(v,w),C!==0)return C;if(v.light&&w.light)C=g(v.light,w.light);else{if(v.light)return 1;if(w.light)return-1}if(C!==0)return C;if(v.dark&&w.dark)C=g(v.dark,w.dark);else{if(v.dark)return 1;if(w.dark)return-1}return C}function b(v,w){if(v.command!==w.command)return v.command<w.command?-1:1;if(v.title!==w.title)return v.title<w.title?-1:1;if(v.tooltip!==w.tooltip){if(v.tooltip!==void 0&&w.tooltip!==void 0)return v.tooltip<w.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(w.tooltip!==void 0)return-1}if(v.arguments===w.arguments)return 0;if(v.arguments)if(w.arguments){if(v.arguments.length!==w.arguments.length)return v.arguments.length-w.arguments.length}else return 1;else return-1;for(let C=0;C<v.arguments.length;C++){const R=v.arguments[C],f=w.arguments[C];if(R!==f)return R<f?-1:1}return 0}function u(v,w){let C=(0,P.comparePaths)(v.resourceUri.fsPath,w.resourceUri.fsPath,!0);if(C!==0)return C;if(v.command&&w.command)C=b(v.command,w.command);else{if(v.command)return 1;if(w.command)return-1}if(C!==0)return C;if(v.decorations&&w.decorations)C=k(v.decorations,w.decorations);else{if(v.decorations)return 1;if(w.decorations)return-1}return C}function p(v,w){for(let C=0;C<v.length;C++)if(v[C]!==w[C])return!1;return!0}function D(v,w){return v.command===w.command&&v.title===w.title&&v.tooltip===w.tooltip&&(v.arguments&&w.arguments?p(v.arguments,w.arguments):v.arguments===w.arguments)}function i(v,w){return(0,S.equals)(v,w,D)}class r{constructor(w,C,R){this._extension=w,this._proxy=C,this._sourceControlHandle=R,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(w){this._proxy.$setInputBoxValue(this._sourceControlHandle,w),this.updateValue(w)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(w){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,w),this._placeholder=w}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(w){if((0,n.checkProposedApiEnabled)(this._extension),w&&typeof w!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=w,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!w)}get visible(){return this._visible}set visible(w){w=!!w,this._visible!==w&&(this._visible=w,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,w))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(w,C){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,w,C)}$onInputBoxValueChange(w){this.updateValue(w)}updateValue(w){this._value=w,this._onDidChange.fire(w)}}e.ExtHostSCMInputBox=r;class l{constructor(w,C,R,f,E){this._proxy=w,this._commands=C,this._sourceControlHandle=R,this._id=f,this._label=E,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=l._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(w){this._label=w,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,w)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(w){this._hideWhenEmpty=w,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(w){this._resourceStates=[...w],this._onDidUpdateResourceStates.fire()}getResourceState(w){return this._resourceStatesMap.get(w)}$executeResourceCommand(w,C){const R=this._resourceStatesCommandsMap.get(w);return R?(0,T.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const w=[...this._resourceStates].sort(u),R=(0,S.sortedDiff)(this._resourceSnapshot,w,u).map(h=>{const M=h.toInsert.map(O=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,O);const Q=O.resourceUri;let $;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const be=new A.DisposableStore;$=this._commands.converter.toInternal(O.command,be),this._resourceStatesDisposablesMap.set(q,be)}else this._resourceStatesCommandsMap.set(q,O.command);const z=a(O.decorations),N=O.decorations&&a(O.decorations.light)||z,W=O.decorations&&a(O.decorations.dark)||z,j=[N,W],Y=O.decorations&&O.decorations.tooltip||"",de=O.decorations&&!!O.decorations.strikeThrough,G=O.decorations&&!!O.decorations.faded,ue=O.contextValue||"";return{rawResource:[q,Q,j,Y,de,G,ue,$],handle:q}});return{start:h.start,deleteCount:h.deleteCount,toInsert:M}}),f=R.map(({start:h,deleteCount:M,toInsert:O})=>[h,M,O.map(q=>q.rawResource)]),E=R.reverse();for(const{start:h,deleteCount:M,toInsert:O}of E){const q=O.map($=>$.handle),Q=this._handlesSnapshot.splice(h,M,...q);for(const $ of Q)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=w,f}dispose(){this._disposed=!0,this._onDidDispose.fire()}}l._handlePool=0;class s{constructor(w,C,R,f,E,h){this._proxy=C,this._commands=R,this._id=f,this._label=E,this._rootUri=h,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(w,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,f,E,h)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(w){this._count!==w&&(this._count=w,this._proxy.$updateSourceControl(this.handle,{count:w}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(w){this._quickDiffProvider=w,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!w})}get commitTemplate(){return this._commitTemplate}set commitTemplate(w){w!==this._commitTemplate&&(this._commitTemplate=w,this._proxy.$updateSourceControl(this.handle,{commitTemplate:w}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(w){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=w;const C=this._commands.converter.toInternal(w,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:C})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(w){if(this._statusBarCommands&&w&&i(this._statusBarCommands,w))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=w;const C=(w||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(w,C){const R=new l(this._proxy,this._commands,this.handle,w,C),f=F.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,f),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const w=[],C=[];for(const[R,f]of this.createdResourceGroups){f.dispose();const E=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});F.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),E.dispose(),this._groups.delete(R.handle),this._proxy.$unregisterGroup(this.handle,R.handle)}),w.push([R.handle,R.id,R.label,R.features]);const h=R._takeResourceStateSnapshot();h.length>0&&C.push([R.handle,h]),this._groups.set(R.handle,R)}this._proxy.$registerGroups(this.handle,w,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const w=[];this.updatedResourceGroups.forEach(C=>{const R=C._takeResourceStateSnapshot();R.length!==0&&w.push([C.handle,R])}),w.length>0&&this._proxy.$spliceResourceStates(this.handle,w),this.updatedResourceGroups.clear()}getResourceGroup(w){return this._groups.get(w)}setSelectionState(w){this._selected=w,this._onDidChangeSelection.fire(w)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(w=>w.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,Be([(0,_.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),Be([(0,_.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let m=class Ui{constructor(w,C,R){this._commands=C,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=w.getProxy(I.MainContext.MainThreadSCM),this._telemetry=w.getProxy(I.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===3){const E=this._sourceControls.get(f.sourceControlHandle);if(!E)return f;const h=E.getResourceGroup(f.groupHandle);return h?h.getResourceState(f.handle):f}else if(f&&f.$mid===4){const E=this._sourceControls.get(f.sourceControlHandle);return E?E.getResourceGroup(f.groupHandle):f}else if(f&&f.$mid===5){const E=this._sourceControls.get(f.handle);return E||f}return f}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(w,C,R,f){this.logService.trace("ExtHostSCM#createSourceControl",w.identifier.value,C,R,f),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:w.identifier.value});const E=Ui._handlePool++,h=new s(w,this._proxy,this._commands,C,R,f);this._sourceControls.set(E,h);const M=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(w.identifier))||[];return M.push(h),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(w.identifier),M),h}getLastInputBox(w){this.logService.trace("ExtHostSCM#getLastInputBox",w.identifier.value);const C=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(w.identifier)),R=C&&C[C.length-1];return R&&R.inputBox}$provideOriginalResource(w,C,R){const f=c.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",w,f.toString());const E=this._sourceControls.get(w);return!E||!E.quickDiffProvider||!E.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>E.quickDiffProvider.provideOriginalResource(f,R)).then(h=>h||null)}$onInputBoxValueChange(w,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",w);const R=this._sourceControls.get(w);return R&&R.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(w,C,R,f){this.logService.trace("ExtHostSCM#$executeResourceCommand",w,C,R);const E=this._sourceControls.get(w);if(!E)return Promise.resolve(void 0);const h=E.getResourceGroup(C);return h?h.$executeResourceCommand(R,f):Promise.resolve(void 0)}$validateInput(w,C,R){this.logService.trace("ExtHostSCM#$validateInput",w);const f=this._sourceControls.get(w);return!f||!f.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>f.inputBox.validateInput(C,R)).then(E=>{if(!E)return Promise.resolve(void 0);const h=o.MarkdownString.fromStrict(E.message);return h?Promise.resolve([h,E.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(w){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",w),w!==void 0&&this._sourceControls.get(w)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=w,Promise.resolve(void 0)}};m._handlePool=0,m=Be([ze(2,t.ILogService)],m),e.ExtHostSCM=m});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[203],we([0,1,6,5,124,7,8]),function(ne,e,c,F,_,A,T){"use strict";var I,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(d,o,a,g,k=c.StatusBarAlignment.Left,b){I.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,I,d,"f"),et(this,S,o,"f"),this._entryId=P.ID_GEN++,this._extension=a,this._id=g,this._alignment=k,this._priority=b}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!P.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Me(this,S,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Me(this,S,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let o;this._name?o=this._name:o=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let a=this._color;this._backgroundColor&&(a=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const g=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Me(this,I,"f").$setEntry(this._entryId,d,o,this._text,g,this._command?.internal,a,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,I=new WeakMap,S=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const o={message:d};return this._messages.unshift(o),this._update(),new c.Disposable(()=>{const a=this._messages.indexOf(o);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class y{constructor(d,o){this._proxy=d.getProxy(F.MainContext.MainThreadStatusBar),this._commands=o,this._statusMessage=new t(this)}createStatusBarEntry(d,o,a,g){return new P(this._proxy,this._commands,d,o,a,g)}setStatusBarMessage(d,o){const a=this._statusMessage.setMessage(d);let g;return typeof o=="number"?g=setTimeout(()=>a.dispose(),o):typeof o!="undefined"&&o.then(()=>a.dispose(),()=>a.dispose()),new c.Disposable(()=>{a.dispose(),clearTimeout(g)})}}e.ExtHostStatusBar=y}),define(ve[73],we([0,1,5,3,4]),function(ne,e,c,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(I){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,S){this._proxy.$registerExtensionStorageKeysToSync(I,S)}getValue(I,S,P){return this._proxy.$getValue(I,S).then(t=>t||P)}setValue(I,S,P){return this._proxy.$setValue(I,S,P)}$acceptValue(I,S,P){this._onDidChangeStorage.fire({shared:I,key:S,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(ve[74],we([0,1,4,29,14,72,2]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let I=class{constructor(P,t,y){this._logService=t,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return T.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return T.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return T.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=Be([ze(0,F.IExtHostInitDataService),ze(1,_.ILogService),ze(2,A.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(ve[37],we([0,1,3,5,4,2,12,7,6,125,15,166,21,36,149,43,10]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class k{constructor(m,v,w,C){this._proxy=m,this._id=v,this._creationOptions=w,this._name=C,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(f=>this._pidPromiseComplete=f);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(f,E=!0){R._checkDisposed(),R._proxy.$sendText(R._id,f,E)},show(f){R._checkDisposed(),R._proxy.$show(R._id,f)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(m,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:m.name,shellPath:(0,g.withNullAsUndefined)(m.shellPath),shellArgs:(0,g.withNullAsUndefined)(m.shellArgs),cwd:(0,g.withNullAsUndefined)(m.cwd),env:(0,g.withNullAsUndefined)(m.env),icon:(0,g.withNullAsUndefined)(r(m.iconPath)),color:a.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:(0,g.withNullAsUndefined)(m.message),strictEnv:(0,g.withNullAsUndefined)(m.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(m.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(v?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(v?.useShellEnvironment),location:v?.location||this._serializeParentTerminal(m.location,v?.resolvedExtHostIdentifier,v?.location)})}async createExtensionTerminal(m,v,w,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:a.ThemeColor.isThemeColor(C)?C.id:void 0,location:this._serializeParentTerminal(m,v)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(m,v,w){return typeof m=="object"&&"parentTerminal"in m?v?{parentTerminal:v}:void 0:(w&&(m=w),m)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(m){this._name=m}setExitCode(m){this._exitStatus=Object.freeze({code:m})}setDimensions(m,v){return m===this._cols&&v===this._rows||m===0||v===0?!1:(this._cols=m,this._rows=v,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(m){this._pidPromiseComplete?(this._pidPromiseComplete(m),this._pidPromiseComplete=void 0):this._pidPromise.then(v=>{v!==m&&(this._pidPromise=Promise.resolve(m))})}}e.ExtHostTerminal=k;class b{constructor(m){this._pty=m,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new c.Emitter,this._onProcessTitleChanged=new c.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new c.Emitter,this._onProcessShellTypeChanged=new c.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(m){this._pty.handleInput&&this._pty.handleInput(m)}resize(m,v){this._pty.setDimensions&&this._pty.setDimensions({columns:m,rows:v})}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(m){this._pty.onDidWrite(v=>this._onProcessData.fire(v)),this._pty.onDidClose&&this._pty.onDidClose((v=void 0)=>{this._onProcessExit.fire(v===void 0?void 0:v)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(v=>this._onProcessOverrideDimensions.fire(v&&{cols:v.columns,rows:v.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(v=>this._onProcessTitleChanged.fire(v)),this._pty.open(m||void 0),this._pty.setDimensions&&m&&this._pty.setDimensions(m),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let u=1,p=class extends I.Disposable{constructor(m,v){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=v.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(m),this._register({dispose:()=>{for(const[w,C]of this._terminalProcesses)C.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(m=>m.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(m,v){const w=new k(this._proxy,(0,d.generateUuid)(),m,m.name),C=new b(m.pty);return w.createExtensionTerminal(this._resolveLocation(m.location),v?.resolvedExtHostIdentifier,r(m.iconPath),l(m.color)).then(R=>{const f=this._setupExtHostProcessListeners(R,C);this._terminalProcessDisposables[R]=f}),this._terminals.push(w),w.value}_resolveLocation(m){if(!(typeof m=="object"&&"parentTerminal"in m))return m}attachPtyToTerminal(m,v){if(!this._getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const C=new b(v),R=this._setupExtHostProcessListeners(m,C);this._terminalProcessDisposables[m]=R}async $acceptActiveTerminalChanged(m){const v=this._activeTerminal;if(m===null){this._activeTerminal=void 0,v!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(m);w&&(this._activeTerminal=w,v!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(m,v){const w=this._getTerminalById(m);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:v})}async $acceptTerminalDimensions(m,v,w){const C=this._getTerminalById(m);C&&C.setDimensions(v,w)&&this._onDidChangeTerminalDimensions.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(m,v,w){this._terminalProcesses.get(m)?.resize(v,w)}async $acceptTerminalTitleChange(m,v){const w=this._getTerminalById(m);w&&(w.name=v)}async $acceptTerminalClosed(m,v){const w=this._getTerminalObjectIndexById(this._terminals,m);if(w!==null){const C=this._terminals.splice(w,1)[0];C.setExitCode(v),this._onDidCloseTerminal.fire(C.value)}}$acceptTerminalOpened(m,v,w,C){if(v){const E=this._getTerminalObjectIndexById(this._terminals,v);if(E!==null){this._terminals[E]._id=m,this._onDidOpenTerminal.fire(this.terminals[E]),this._terminals[E].isOpen=!0;return}}const R={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:A.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},f=new k(this._proxy,m,R,w);this._terminals.push(f),this._onDidOpenTerminal.fire(f.value),f.isOpen=!0}async $acceptTerminalProcessId(m,v){const w=this._getTerminalById(m);w&&w._setProcessId(v)}async $startExtensionTerminal(m,v){const w=this._getTerminalById(m);if(!w)return{message:(0,P.localize)(0,null,m)};w.isOpen||await new Promise(R=>{const f=this.onDidOpenTerminal(async E=>{E===w.value&&(f.dispose(),R())})});const C=this._terminalProcesses.get(m);C?C.startSendingEvents(v):this._extensionTerminalAwaitingStart[m]={initialDimensions:v}}_setupExtHostProcessListeners(m,v){const w=new I.DisposableStore;w.add(v.onProcessReady(R=>this._proxy.$sendProcessReady(m,R.pid,R.cwd))),w.add(v.onProcessTitleChanged(R=>this._proxy.$sendProcessTitle(m,R))),this._bufferer.startBuffering(m,v.onProcessData),w.add(v.onProcessExit(R=>this._onProcessExit(m,R))),v.onProcessOverrideDimensions&&w.add(v.onProcessOverrideDimensions(R=>this._proxy.$sendOverrideDimensions(m,R))),this._terminalProcesses.set(m,v);const C=this._extensionTerminalAwaitingStart[m];return C&&v instanceof b&&(v.startSendingEvents(C.initialDimensions),delete this._extensionTerminalAwaitingStart[m]),w}$acceptProcessAckDataEvent(m,v){this._terminalProcesses.get(m)?.acknowledgeDataEvent(v)}$acceptProcessInput(m,v){this._terminalProcesses.get(m)?.input(v)}$acceptTerminalInteraction(m){const v=this._getTerminalById(m);v?.setInteractedWith()&&this._onDidChangeTerminalState.fire(v.value)}$acceptProcessResize(m,v,w){try{this._terminalProcesses.get(m)?.resize(v,w)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(m,v){this._terminalProcesses.get(m)?.shutdown(v)}$acceptProcessRequestInitialCwd(m){this._terminalProcesses.get(m)?.getInitialCwd().then(v=>this._proxy.$sendProcessInitialCwd(m,v))}$acceptProcessRequestCwd(m){this._terminalProcesses.get(m)?.getCwd().then(v=>this._proxy.$sendProcessCwd(m,v))}$acceptProcessRequestLatency(m){return m}registerLinkProvider(m){return this._linkProviders.add(m),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(m),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(m,v,w){if(this._profileProviders.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this._profileProviders.set(v,w),this._proxy.$registerProfileProvider(v,m.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(v),this._proxy.$unregisterProfileProvider(v)})}async $createContributedProfileTerminal(m,v){const w=new n.CancellationTokenSource().token,C=await this._profileProviders.get(m)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,v);return}this.createTerminalFromOptions(C.options,v)}}async $provideLinks(m,v){const w=this._getTerminalById(m);if(!w)return[];this._terminalLinkCache.delete(m);const C=this._terminalLinkCancellationSource.get(m);C&&C.dispose(!0);const R=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(m,R);const f=[],E={terminal:w.value,line:v},h=[];for(const q of this._linkProviders)h.push(new Promise(async Q=>{R.token.onCancellationRequested(()=>Q({provider:q,links:[]}));const $=await q.provideTerminalLinks(E,R.token)||[];R.token.isCancellationRequested||Q({provider:q,links:$})}));const M=await Promise.all(h);if(R.token.isCancellationRequested)return[];const O=new Map;for(const q of M)q&&q.links.length>0&&f.push(...q.links.map(Q=>{const $={id:u++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return O.set($.id,{provider:q.provider,link:Q}),$}));return this._terminalLinkCache.set(m,O),f}$activateLink(m,v){const w=this._terminalLinkCache.get(m)?.get(v);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(m,v){this._bufferer.stopBuffering(m),this._terminalProcesses.delete(m),delete this._extensionTerminalAwaitingStart[m];const w=this._terminalProcessDisposables[m];w&&(w.dispose(),delete this._terminalProcessDisposables[m]),this._proxy.$sendProcessExit(m,v)}_getTerminalById(m){return this._getTerminalObjectById(this._terminals,m)}_getTerminalObjectById(m,v){const w=this._getTerminalObjectIndexById(m,v);return w!==null?m[w]:null}_getTerminalObjectIndexById(m,v){let w=null;return m.some((C,R)=>C._id===v?(w=R,!0):!1),w}getEnvironmentVariableCollection(m){let v=this._environmentVariableCollections.get(m.identifier.value);return v||(v=new D,this._setEnvironmentVariableCollection(m.identifier.value,v)),v}_syncEnvironmentVariableCollection(m,v){const w=(0,y.serializeEnvironmentVariableCollection)(v.map);this._proxy.$setEnvironmentVariableCollection(m,v.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(m){m.forEach(v=>{const w=v[0],C=new D(v[1]);this._setEnvironmentVariableCollection(w,C)})}$acceptDefaultProfile(m,v){this._defaultProfile=m,this._defaultAutomationProfile=v}_setEnvironmentVariableCollection(m,v){this._environmentVariableCollections.set(m,v),v.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(m,v)})}};p=Be([ze(1,T.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class D{constructor(m){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(m)}get persistent(){return this._persistent}set persistent(m){this._persistent=m,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(m,v){this._setIfDiffers(m,{value:v,type:S.EnvironmentVariableMutatorType.Replace})}append(m,v){this._setIfDiffers(m,{value:v,type:S.EnvironmentVariableMutatorType.Append})}prepend(m,v){this._setIfDiffers(m,{value:v,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(m,v){const w=this.map.get(m);(!w||w.value!==v.value||w.type!==v.type)&&(this.map.set(m,v),this._onDidChangeCollection.fire())}get(m){return this.map.get(m)}forEach(m,v){this.map.forEach((w,C)=>m.call(v,C,w,this))}delete(m){this.map.delete(m),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=D;let i=class extends p{constructor(m){super(!1,m)}createTerminal(m,v,w){throw new t.NotSupportedError}createTerminalFromOptions(m,v){throw new t.NotSupportedError}};i=Be([ze(0,T.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function r(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function l(s){return a.ThemeColor.isThemeColor(s)?s:void 0}});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[204],we([0,1,23,21,3,234,57,189,7,22,10,36,5,12,65,8,6,174,91,69]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let D=class{constructor(h,M){this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=h.getProxy(n.MainContext.MainThreadTesting),this.observer=new C(this.proxy),this.runTracker=new r(this.proxy),M.registerArgumentProcessor({processArgument:O=>O?.$mid===13?a.TestItem.toItemFromContext(O):O})}createTestController(h,M){if(this.controllers.has(h))throw new Error(`Attempt to insert a duplicate controller with ID "${h}"`);const O=new S.DisposableStore,q=O.add(new k.SingleUseTestCollection(h));q.root.label=M;const Q=new Map,$=this.proxy,z={items:q.root.children,get label(){return M},set label(W){M=W,q.root.label=W,$.$updateControllerLabel(h,M)},get id(){return h},createRunProfile:(W,j,Y,de,G)=>{let ue=(0,T.hash)(W);for(;Q.has(ue);)ue++;const oe=new R(this.proxy,h,ue,W,j,Y,de,G);return Q.set(ue,oe),oe},createTestItem(W,j,Y){return new o.TestItemImpl(h,W,j,Y)},createTestRun:(W,j,Y=!0)=>this.runTracker.createTestRun(h,q,W,j,Y),set resolveHandler(W){q.resolveHandler=W},get resolveHandler(){return q.resolveHandler},dispose:()=>{O.dispose()}};z.createRunConfiguration=z.createRunProfile,$.$registerTestController(h,M),O.add((0,S.toDisposable)(()=>$.$unregisterTestController(h)));const N={controller:z,collection:q,profiles:Q};return this.controllers.set(h,N),O.add((0,S.toDisposable)(()=>this.controllers.delete(h))),O.add(q.onDidGenerateDiff(W=>$.$publishDiff(h,W))),z}createTestObserver(){return this.observer.checkout()}async runTests(h,M=F.CancellationToken.None){const O=l(h);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.controllers.get(O.controllerId);if(!q)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:h.include?.map(Q=>Q.id)??[q.collection.root.id],profileGroup:f[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:h.exclude?.map(Q=>Q.id)},M)}$provideFileCoverage(h,M,O){return I.Iterable.find(this.runTracker.trackers,q=>q.id===h)?.getCoverage(M)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(h,M,O,q){return I.Iterable.find(this.runTracker.trackers,Q=>Q.id===h)?.getCoverage(M)?.resolveFileCoverage(O,q)??Promise.resolve([])}$configureRunProfile(h,M){this.controllers.get(h)?.profiles.get(M)?.configureHandler?.()}$publishTestResults(h){this.results=Object.freeze(h.map(M=>(0,P.deepFreeze)(a.TestResults.to(M))).concat(this.results).sort((M,O)=>O.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(h,M){const O=this.controllers.get(u.TestId.fromString(h).controllerId)?.collection;O&&(await O.expand(h,M<0?Infinity:M),O.flushDiff())}$acceptDiff(h){this.observer.applyDiff(h)}async $runControllerTests(h,M){const O=this.controllers.get(h.controllerId);if(!O)return;const{collection:q,profiles:Q}=O,$=Q.get(h.profileId);if(!$)return;const z=h.testIds.map(Y=>q.tree.get(Y)).filter(t.isDefined),N=h.excludeExtIds.map(Y=>O.collection.tree.get(Y)).filter(t.isDefined).filter(Y=>z.some(de=>de.fullId.compare(Y.fullId)===2));if(!z.length)return;const W=new g.TestRunRequest(z.some(Y=>Y.actual instanceof o.TestItemRootImpl)?void 0:z.map(Y=>Y.actual),N.map(Y=>Y.actual),$),j=this.runTracker.prepareForMainThreadTestRun(W,s.fromInternal(h,O.collection),M);try{await $.runHandler(W,M)}finally{j.isRunning&&!M.isCancellationRequested&&await _.Event.toPromise(j.onEnd),this.runTracker.cancelRunById(h.runId)}}$cancelExtensionTestRun(h){h===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(h)}};D=Be([ze(0,d.IExtHostRpcService)],D),e.ExtHostTesting=D;class i extends S.Disposable{constructor(h,M,O){super();this.dto=h,this.proxy=M,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new _.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:q}of this.tasks.values())q.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(h){return this.tasks.get(h)?.coverage}createRun(h){const M=this.dto.id,O=this.dto.controllerId,q=(0,y.generateUuid)(),Q=new m(this.proxy,M,q),$=W=>(j,...Y)=>{if(z){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),W(j,...Y))};let z=!1;const N={isPersisted:this.dto.isPersisted,token:this.cts.token,name:h,get coverageProvider(){return Q.coverageProvider},set coverageProvider(W){Q.coverageProvider=W},enqueued:$(W=>{this.proxy.$updateTestStateInRun(M,q,u.TestId.fromExtHostTestItem(W,O).toString(),1)}),skipped:$(W=>{this.proxy.$updateTestStateInRun(M,q,u.TestId.fromExtHostTestItem(W,O).toString(),5)}),started:$(W=>{this.proxy.$updateTestStateInRun(M,q,u.TestId.fromExtHostTestItem(W,O).toString(),2)}),errored:$((W,j,Y)=>{this.proxy.$appendTestMessagesInRun(M,q,u.TestId.fromExtHostTestItem(W,O).toString(),j instanceof Array?j.map(a.TestMessage.from):[a.TestMessage.from(j)]),this.proxy.$updateTestStateInRun(M,q,u.TestId.fromExtHostTestItem(W,O).toString(),6,Y)}),failed:$((W,j,Y)=>{this.proxy.$appendTestMessagesInRun(M,q,u.TestId.fromExtHostTestItem(W,O).toString(),j instanceof Array?j.map(a.TestMessage.from):[a.TestMessage.from(j)]),this.proxy.$updateTestStateInRun(M,q,u.TestId.fromExtHostTestItem(W,O).toString(),4,Y)}),passed:$((W,j)=>{this.proxy.$updateTestStateInRun(M,q,u.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString(),3,j)}),appendOutput:(W,j,Y)=>{z||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(M,q,c.VSBuffer.fromString(W),j&&a.location.from(j),Y&&u.TestId.fromExtHostTestItem(Y,O).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(M,q),this.tasks.delete(q),this.isRunning||this.dispose())}};return this.tasks.set(q,{run:N,coverage:Q}),this.proxy.$startedTestRunTask(M,{id:q,name:h,running:!0}),N}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(h){if(!(h instanceof o.TestItemImpl))throw new o.InvalidTestItemError(h.id);if(this.sharedTestIds.has(h.id))return;const M=[];for(;M.unshift(a.TestItem.from(h)),!(this.sharedTestIds.has(h.id)||(this.sharedTestIds.add(h.id),!h.parent));)h=h.parent;const O=this.dto.colllection.root;this.sharedTestIds.has(O.id)||(this.sharedTestIds.add(O.id),M.unshift(a.TestItem.from(O))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,M)}}class r{constructor(h){this.proxy=h,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(h,M,O){return this.getTracker(h,M,O)}cancelRunById(h){for(const M of this.tracked.values())if(M.id===h){M.dispose();return}}cancelAllRuns(){for(const h of this.tracked.values())h.dispose()}createTestRun(h,M,O,q,Q){const $=this.tracked.get(O);if($)return $.createRun(q);const z=s.fromPublic(h,M,O,Q),N=l(O);this.proxy.$startedExtensionTestRun({controllerId:h,profile:N&&{group:f[N.kind],id:N.profileId},exclude:O.exclude?.map(j=>j.id)??[],id:z.id,include:O.include?.map(j=>j.id)??[M.root.id],persist:Q});const W=this.getTracker(O,z);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),W.createRun(q)}getTracker(h,M,O){const q=new i(M,this.proxy,O);return this.tracked.set(h,q),q.onEnd(()=>this.tracked.delete(h)),q}}e.TestRunCoordinator=r;const l=E=>{if(!!E.profile){if(!(E.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return E.profile}};class s{constructor(h,M,O,q,Q,$){this.controllerId=h,this.id=M,this.isPersisted=Q,this.colllection=$,this.includePrefix=O.map(z=>z+"\0"),this.excludePrefix=q.map(z=>z+"\0")}static fromPublic(h,M,O,q){return new s(h,(0,y.generateUuid)(),O.include?.map(Q=>u.TestId.fromExtHostTestItem(Q,h).toString())??[h],O.exclude?.map(Q=>u.TestId.fromExtHostTestItem(Q,h).toString())??[],q,M)}static fromInternal(h,M){return new s(h.controllerId,h.runId,h.testIds,h.excludeExtIds,!0,M)}isIncluded(h){const M=u.TestId.fromExtHostTestItem(h,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(M===O||M.startsWith(O))return!1;for(const O of this.includePrefix)if(M===O||M.startsWith(O))return!0;return!1}}e.TestRunDto=s;class m{constructor(h,M,O){this.proxy=h,this.runId=M,this.taskId=O}set coverageProvider(h){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!h||(this._coverageProvider=h,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(h){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(h))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(M){throw this.fileCoverage=void 0,M}}async resolveFileCoverage(h,M){const O=await this.fileCoverage;let q=O?.[h];return!this._coverageProvider||!O||!q?[]:(q.detailedCoverage||(q=O[h]=await this._coverageProvider.resolveFileCoverage?.(q,M)??q),q.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class v extends b.IncrementalChangeCollector{constructor(h){super();this.emitter=h,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(h){this.added.add(h)}update(h){Object.assign(h.revived,a.TestItem.toPlain(h.item)),this.added.has(h)||this.updated.add(h)}remove(h){if(this.added.has(h)){this.added.delete(h);return}if(this.updated.delete(h),h.parent&&this.alreadyRemoved.has(h.parent)){this.alreadyRemoved.add(h.item.extId);return}this.removed.add(h)}getChangeEvent(){const{added:h,updated:M,removed:O}=this;return{get added(){return[...h].map(q=>q.revived)},get updated(){return[...M].map(q=>q.revived)},get removed(){return[...O].map(q=>q.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class w extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(h){return this.items.get(h)}getMirroredTestDataByReference(h){return this.items.get(h.id)}createItem(h,M){return{...h,revived:a.TestItem.toPlain(h.item),depth:M?M.depth+1:0,children:new Set}}createChangeCollector(){return new v(this.changeEmitter)}}e.MirroredTestCollection=w;class C{constructor(h){this.proxy=h}checkout(){this.current||(this.current=this.createObserverData());const h=this.current;return h.observers++,{onDidChangeTest:h.tests.onDidChangeTests,get tests(){return[...h.tests.rootTests].map(M=>M.revived)},dispose:(0,A.once)(()=>{--h.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(h){return this.current?.tests.getMirroredTestDataByReference(h)}applyDiff(h){this.current?.tests.apply(h)}createObserverData(){const h=new w;return this.proxy.$subscribeToDiffs(),{observers:0,tests:h}}}class R{constructor(h,M,O,q,Q,$,z=!1,N=void 0){this.controllerId=M,this.profileId=O,this._label=q,this.kind=Q,this.runHandler=$,this._isDefault=z,this._tag=N,p.set(this,void 0),et(this,p,h,"f");const W=f[Q];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);Me(this,p,"f").$publishTestRunProfile({profileId:O,controllerId:M,tag:N?a.TestTag.namespace(this.controllerId,N.id):null,label:q,group:W,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(h){h!==this._label&&(this._label=h,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:h}))}get isDefault(){return this._isDefault}set isDefault(h){h!==this._isDefault&&(this._isDefault=h,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:h}))}get tag(){return this._tag}set tag(h){h?.id!==this._tag?.id&&(this._tag=h,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:h?a.TestTag.namespace(this.controllerId,h.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(h){h!==this._configureHandler&&(this._configureHandler=h,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!h}))}dispose(){Me(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=R,p=new WeakMap;const f={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(ve[205],we([0,1,3,16,5,94,8,6]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(t,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const y=this._extHostDocumentsAndEditors.allEditors();return t?y:y.map(n=>n.value)}async showTextDocument(t,y,n){let d;typeof y=="number"?d={position:T.ViewColumn.from(y),preserveFocus:n}:typeof y=="object"?d={position:T.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?T.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:d={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(t.uri,d),a=o&&this._extHostDocumentsAndEditors.getEditor(o);if(a)return a.value;throw o?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,y){return new A.TextEditorDecorationType(this._proxy,t,y).value}$acceptEditorPropertiesChanged(t,y){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(y.options&&n._acceptOptions(y.options),y.selections){const d=y.selections.selections.map(T.Selection.to);n._acceptSelections(d)}if(y.visibleRanges){const d=F.coalesce(y.visibleRanges.map(T.Range.to));n._acceptVisibleRanges(d)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...y.options,lineNumbers:T.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const d=I.TextEditorSelectionChangeKind.fromValue(y.selections.source),o=y.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:d})}if(y.visibleRanges){const d=F.coalesce(y.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:d})}}$acceptEditorPositionData(t){for(const y in t){const n=this._extHostDocumentsAndEditors.getEditor(y);if(!n)throw new Error("Unknown text editor");const d=T.ViewColumn.to(t[y]);n.value.viewColumn!==d&&(n._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:d}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=S}),define(ve[206],we([0,1,2,4,5,7,6]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class I{constructor(t,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const d=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(d))?.get(n.handle)}return n}})}async $getTimeline(t,y,n,d,o){return this._providers.get(t)?.provideTimeline(c.URI.revive(y),n,d,o)}registerTimelineProvider(t,y,n,d){const o=new A.DisposableStore,a=this.convertTimelineItem(y.id,d,o).bind(this);let g;y.onDidChange&&(g=y.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:y.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:t,onDidChange:void 0,async provideTimeline(b,u,p,D){D?.resetCache&&(o.clear(),k.get(y.id)?.clear());const i=await y.provideTimeline(b,u,p);if(i==null)return;const r=a(b,D);return{...i,source:y.id,items:i.items.map(r)}},dispose(){for(const b of k.values())b.get(y.id)?.clear();g?.dispose(),o.dispose()}})}convertTimelineItem(t,y,n){return(d,o)=>{let a;if(o?.cacheResults){let g=this._itemsBySourceAndUriMap.get(t);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(t,g));const k=S(d);a=g.get(k),a===void 0&&(a=new Map,g.set(k,a))}return g=>{const{iconPath:k,...b}=g,u=`${t}|${g.id??g.timestamp}`;a?.set(u,g);let p,D,i;return g.iconPath&&(k instanceof T.ThemeIcon?i={id:k.id,color:k.color}:c.URI.isUri(k)?(p=k,D=k):{light:p,dark:D}=k),{...b,id:b.id??void 0,handle:u,source:t,command:g.command?y.toInternal(g.command,n):void 0,icon:p,iconDark:D,themeIcon:i,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=I;function S(P){return P?.toString()}}),define(ve[207],we([0,1,7,11,2,5]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,P,t,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=y.schemes.find(d=>!T.supportedSchemes.has(d));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,y.schemes,S,y.label),(0,c.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(S,P,t){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener with id: ${S}`);const n=_.URI.revive(P);return y.canOpenExternalUri(n,t)}async $openUri(S,P,t){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener id: '${S}'`);return y.openExternalUri(_.URI.revive(P.resolvedUri),{sourceUri:_.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(ve[208],we([0,1,5,2,7,15,26]),function(ne,e,c,F,_,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(T.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=I.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(P)),this.handlers.set(y,t),this._proxy.$registerUriHandler(y,P),(0,_.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,t){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(F.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return F.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=I,I.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[49],we([0,1,3,2,135,157,68,5]),function(ne,e,c,F,_,A,T,I){"use strict";var S,P,t,y,n,d,o,a,g,k,b,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(w,C,R,f,E,h,M){S.set(this,void 0),P.set(this,void 0),t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),d.set(this,void 0),o.set(this,""),a.set(this,void 0),g.set(this,!1),k.set(this,!1),b.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new c.Emitter),this._onDidDispose=Me(this,u,"f").event,et(this,S,w,"f"),et(this,P,C,"f"),et(this,a,R,"f"),et(this,y,f,"f"),et(this,n,E,"f"),et(this,d,h,"f"),et(this,b,D(h),"f"),et(this,t,M,"f")}dispose(){et(this,g,!0,"f"),Me(this,u,"f").fire(),Me(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return et(this,k,!0,"f"),(0,T.asWebviewUri)(w,Me(this,y,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Me(this,o,"f")}set html(w){this.assertNotDisposed(),Me(this,o,"f")!==w&&(et(this,o,w,"f"),!Me(this,k,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(et(this,k,!0,"f"),Me(this,t,"f").report("Webview vscode-resource: uris",Me(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,P,"f").$setHtml(Me(this,S,"f"),w))}get options(){return this.assertNotDisposed(),Me(this,a,"f")}set options(w){this.assertNotDisposed(),Me(this,P,"f").$setOptions(Me(this,S,"f"),l(Me(this,d,"f"),Me(this,n,"f"),w)),et(this,a,w,"f")}async postMessage(w){if(Me(this,g,"f"))return!1;const C=(0,A.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Me(this,b,"f")});return Me(this,P,"f").$postMessage(Me(this,S,"f"),C.message,...C.buffers)}assertNotDisposed(){if(Me(this,g,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,S=new WeakMap,P=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,d=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap,k=new WeakMap,b=new WeakMap,u=new WeakMap;function D(v){try{const w=(0,_.normalizeVersion)((0,_.parseVersion)(v.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=D;class i{constructor(w,C,R,f,E){this.initData=C,this.workspace=R,this._logService=f,this._deprecationService=E,this._webviews=new Map,this._webviewProxy=w.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(w,C,...R){const f=this.getWebview(w);if(f){const{message:E}=(0,A.deserializeWebviewMessage)(C,R);f._onMessageEmitter.fire(E)}}$onMissingCsp(w,C){this._logService.warn(`${C} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,C,R){const f=new p(w,this._webviewProxy,s(C),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(w,f),f._onDidDispose(()=>{this._webviews.delete(w)}),f}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=i;function r(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=r;function l(v,w,C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots||m(v,w)}}e.serializeWebviewOptions=l;function s(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(w=>F.URI.from(w))}}e.reviveOptions=s;function m(v,w){return[...(w?.getWorkspaceFolders()||[]).map(C=>C.uri),v.extensionLocation]}}),define(ve[209],we([0,1,21,57,7,11,24,2,8,49,63,5,6]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(i,r){this.document=i,this._storagePath=r,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,r){await this.getEdit(i).undo(),r||this.disposeBackup()}async redo(i,r){await this.getEdit(i).redo(),r||this.disposeBackup()}disposeEdits(i){for(const r of i)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=p(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const r=this._edits.get(i,0);if(!r)throw new Error("No edit found");return r}}class o{constructor(){this._documents=new Map}get(i,r){return this._documents.get(this.key(i,r))}add(i,r,l){const s=this.key(i,r.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${i} resource:${r.uri}`);const m=new d(r,l);return this._documents.set(s,m),m}delete(i,r){const l=this.key(i,r.uri);this._documents.delete(l)}key(i,r){return`${i}@@@${r}`}}var a;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(a||(a={}));class g{constructor(){this._providers=new Map}addTextProvider(i,r,l){return this.add(0,i,r,l)}addCustomProvider(i,r,l){return this.add(1,i,r,l)}get(i){return this._providers.get(i)}add(i,r,l,s){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:i,extension:l,provider:s}),new n.Disposable(()=>this._providers.delete(r))}}class k{constructor(i,r,l,s,m){this._extHostDocuments=r,this._extensionStoragePaths=l,this._extHostWebview=s,this._extHostWebviewPanels=m,this._editorProviders=new g,this._documents=new o,this._proxy=i.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,r,l,s){const m=new _.DisposableStore;return b(l)?(m.add(this._editorProviders.addTextProvider(r,i,l)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),r,s.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(m.add(this._editorProviders.addCustomProvider(r,i,l)),this.supportEditing(l)&&m.add(l.onDidChangeCustomDocument(v=>{const w=this.getCustomDocumentEntry(r,v.document.uri);if(u(v)){const C=w.addEdit(v);this._proxy.$onDidEdit(v.document.uri,r,C,v.label)}else this._proxy.$onContentChange(v.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),r,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(m,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(i,r,l,s,m){const v=this._editorProviders.get(r);if(!v)throw new Error(`No provider found for '${r}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${r}'`);const w=I.URI.revive(i),C=await v.provider.openCustomDocument(w,{backupId:l,untitledDocumentData:s?.buffer},m);let R;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(R=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(r,C,R),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(i,r){const l=this._editorProviders.get(r);if(!l)throw new Error(`No provider found for '${r}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${r}'`);const s=I.URI.revive(i),{document:m}=this.getCustomDocumentEntry(r,s);this._documents.delete(r,m),m.dispose()}async $resolveWebviewEditor(i,r,l,s,m,v){const w=this._editorProviders.get(l);if(!w)throw new Error(`No provider found for '${l}'`);const C=S.ViewColumn.to(m),R=this._extHostWebview.createNewWebview(r,s.webviewOptions,w.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(r,l,s.title,C,s.panelOptions,R),E=I.URI.revive(i);switch(w.type){case 1:{const{document:h}=this.getCustomDocumentEntry(l,E);return w.provider.resolveCustomEditor(h,f,v)}case 0:{const h=this._extHostDocuments.getDocument(E);return w.provider.resolveCustomTextEditor(h,f,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,r,l){this.getCustomDocumentEntry(r,i).disposeEdits(l)}async $onMoveCustomEditor(i,r,l){const s=this._editorProviders.get(l);if(!s)throw new Error(`No provider found for '${l}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const m=this._extHostWebviewPanels.getWebviewPanel(i);if(!m)throw new Error("No webview found");const v=I.URI.revive(r),w=this._extHostDocuments.getDocument(v);await s.provider.moveCustomTextEditor(w,m,c.CancellationToken.None)}async $undo(i,r,l,s){return this.getCustomDocumentEntry(r,i).undo(l,s)}async $redo(i,r,l,s){return this.getCustomDocumentEntry(r,i).redo(l,s)}async $revert(i,r,l){const s=this.getCustomDocumentEntry(r,i);await this.getCustomEditorProvider(r).revertCustomDocument(s.document,l),s.disposeBackup()}async $onSave(i,r,l){const s=this.getCustomDocumentEntry(r,i);await this.getCustomEditorProvider(r).saveCustomDocument(s.document,l),s.disposeBackup()}async $onSaveAs(i,r,l,s){const m=this.getCustomDocumentEntry(r,i);return this.getCustomEditorProvider(r).saveCustomDocumentAs(m.document,I.URI.revive(l),s)}async $backup(i,r,l){const s=this.getCustomDocumentEntry(r,i),v=await this.getCustomEditorProvider(r).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},l);return s.updateBackup(v),v.id}getCustomDocumentEntry(i,r){const l=this._documents.get(i,I.URI.revive(r));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(i){const l=this._editorProviders.get(i)?.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=k;function b(D){return typeof D.resolveCustomTextEditor=="function"}function u(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function p(D){const i=D.scheme===A.Schemas.file||D.scheme===A.Schemas.untitled?D.fsPath:D.toString();return(0,F.hash)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[210],we([0,1,3,7,2,36,8,49,5,6]),function(ne,e,c,F,_,A,T,I,S,P){"use strict";var t,y,n,d,o,a,g,k,b,u,p,D,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends F.Disposable{constructor(v,w,C,R,f,E,h){super();t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),d.set(this,void 0),o.set(this,void 0),a.set(this,void 0),g.set(this,void 0),k.set(this,void 0),b.set(this,!0),u.set(this,!0),p.set(this,!1),D.set(this,this._register(new c.Emitter)),this.onDidDispose=Me(this,D,"f").event,i.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Me(this,i,"f").event,et(this,t,v,"f"),et(this,y,w,"f"),et(this,n,C,"f"),et(this,o,E,"f"),et(this,k,f,"f"),et(this,a,R,"f"),et(this,d,h,"f")}dispose(){Me(this,p,"f")||(et(this,p,!0,"f"),Me(this,D,"f").fire(),Me(this,y,"f").$disposeWebview(Me(this,t,"f")),Me(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,d,"f")}get viewType(){return this.assertNotDisposed(),Me(this,n,"f")}get title(){return this.assertNotDisposed(),Me(this,a,"f")}set title(v){this.assertNotDisposed(),Me(this,a,"f")!==v&&(et(this,a,v,"f"),Me(this,y,"f").$setTitle(Me(this,t,"f"),v))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(v){this.assertNotDisposed(),Me(this,g,"f")!==v&&(et(this,g,v,"f"),Me(this,y,"f").$setIconPath(Me(this,t,"f"),_.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Me(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,k,"f")=="number"&&Me(this,k,"f")<0))return Me(this,k,"f")}get active(){return this.assertNotDisposed(),Me(this,u,"f")}get visible(){return this.assertNotDisposed(),Me(this,b,"f")}_updateViewState(v){Me(this,p,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(et(this,u,v.active,"f"),et(this,b,v.visible,"f"),et(this,k,v.viewColumn,"f"),Me(this,i,"f").fire({webviewPanel:this}))}reveal(v,w){this.assertNotDisposed(),Me(this,y,"f").$reveal(Me(this,t,"f"),{viewColumn:v?T.ViewColumn.from(v):void 0,preserveFocus:!!w})}assertNotDisposed(){if(Me(this,p,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,y=new WeakMap,n=new WeakMap,d=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap,k=new WeakMap,b=new WeakMap,u=new WeakMap,p=new WeakMap,D=new WeakMap,i=new WeakMap;class l{constructor(v,w,C){this.webviews=w,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(v,w,C,R,f={}){const E=typeof R=="object"?R.viewColumn:R,h={viewColumn:T.ViewColumn.from(E),preserveFocus:typeof R=="object"&&!!R.preserveFocus},M=(0,I.shouldSerializeBuffersForPostMessage)(v),O=l.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(v),O,w,{title:C,panelOptions:s(f),webviewOptions:(0,I.serializeWebviewOptions)(v,this.workspace,f),serializeBuffersForPostMessage:M},h);const q=this.webviews.createNewWebview(O,f,v);return this.createNewWebviewPanel(O,w,C,E,f,q)}$onDidChangeWebviewPanelViewStates(v){const w=Object.keys(v);w.sort((C,R)=>{const f=v[C],E=v[R];return f.active?1:E.active?-1:+f.visible-+E.visible});for(const C of w){const R=this.getWebviewPanel(C);if(!R)continue;const f=v[C];R._updateViewState({active:f.active,visible:f.visible,viewColumn:T.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,w,C){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:C,extension:v}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(v)}),new P.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(v,w,C,R){const f=this._serializers.get(w);if(!f)throw new Error(`No serializer found for '${w}'`);const{serializer:E,extension:h}=f,M=this.webviews.createNewWebview(v,C.webviewOptions,h),O=this.createNewWebviewPanel(v,w,C.title,R,C.panelOptions,M);await E.deserializeWebviewPanel(O,C.state)}createNewWebviewPanel(v,w,C,R,f,E){const h=new r(v,this._proxy,w,C,R,f,E);return this._webviewPanels.set(v,h),h}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=l;function s(m){return{enableFindWidget:m.enableFindWidget,retainContextWhenHidden:m.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[211],we([0,1,3,7,49,5,6]),function(ne,e,c,F,_,A,T){"use strict";var I,S,P,t,y,n,d,o,a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class k extends F.Disposable{constructor(p,D,i,r,l,s){super();I.set(this,void 0),S.set(this,void 0),P.set(this,void 0),t.set(this,void 0),y.set(this,!1),n.set(this,void 0),d.set(this,void 0),o.set(this,void 0),a.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Me(this,a,"f").event,g.set(this,this._register(new c.Emitter)),this.onDidDispose=Me(this,g,"f").event,et(this,P,i,"f"),et(this,d,r,"f"),et(this,I,p,"f"),et(this,S,D,"f"),et(this,t,l,"f"),et(this,n,s,"f")}dispose(){Me(this,y,"f")||(et(this,y,!0,"f"),Me(this,g,"f").fire(),Me(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,d,"f")}set title(p){this.assertNotDisposed(),Me(this,d,"f")!==p&&(et(this,d,p,"f"),Me(this,S,"f").$setWebviewViewTitle(Me(this,I,"f"),p))}get description(){return this.assertNotDisposed(),Me(this,o,"f")}set description(p){this.assertNotDisposed(),Me(this,o,"f")!==p&&(et(this,o,p,"f"),Me(this,S,"f").$setWebviewViewDescription(Me(this,I,"f"),p))}get visible(){return Me(this,n,"f")}get webview(){return Me(this,t,"f")}get viewType(){return Me(this,P,"f")}_setVisible(p){p===Me(this,n,"f")||Me(this,y,"f")||(et(this,n,p,"f"),Me(this,a,"f").fire())}show(p){this.assertNotDisposed(),Me(this,S,"f").$show(Me(this,I,"f"),!!p)}assertNotDisposed(){if(Me(this,y,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,S=new WeakMap,P=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,d=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap;class b{constructor(p,D){this._extHostWebview=D,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,D,i,r){if(this._viewProviders.has(D))throw new Error(`View provider for '${D}' already registered`);return this._viewProviders.set(D,{provider:i,extension:p}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(p),D,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(D),this._proxy.$unregisterWebviewViewProvider(D)})}async $resolveWebviewView(p,D,i,r,l){const s=this._viewProviders.get(D);if(!s)throw new Error(`No view provider found for '${D}'`);const{provider:m,extension:v}=s,w=this._extHostWebview.createNewWebview(p,{},v),C=new k(p,this._proxy,D,i,w,!0);this._webviewViews.set(p,C),await m.resolveWebviewView(C,{state:r},l)}async $onDidChangeWebviewViewVisibility(p,D){this.getWebviewView(p)._setVisible(D)}async $disposeWebviewView(p){const D=this.getWebviewView(p);this._webviewViews.delete(p),D.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const D=this._webviewViews.get(p);if(!D)throw new Error("No webview found");return D}}e.ExtHostWebviewViews=b}),define(ve[97],we([0,1,3,5,2,11,9,4,12]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Bi{constructor(y){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bi.InitialState,this._proxy=y.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,n){let d;if(typeof y=="string"){d=y;try{y=_.URI.parse(y)}catch(o){return Promise.reject(`Invalid uri - '${y}'`)}}return(0,T.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,d,n)}async asExternalUri(y,n){if((0,T.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(y,n);return _.URI.from(d)}};P.InitialState={focused:!0},P=Be([ze(0,S.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(ve[212],we([0,1,14,5,29,12]),function(ne,e,c,F,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends c.AbstractLogger{constructor(S,P){super();this._proxy=S.getProxy(F.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...P){this.getLevel()<=c.LogLevel.Trace&&this._proxy.$log(this._logFile,c.LogLevel.Trace,Array.from(arguments))}debug(S,...P){this.getLevel()<=c.LogLevel.Debug&&this._proxy.$log(this._logFile,c.LogLevel.Debug,Array.from(arguments))}info(S,...P){this.getLevel()<=c.LogLevel.Info&&this._proxy.$log(this._logFile,c.LogLevel.Info,Array.from(arguments))}warn(S,...P){this.getLevel()<=c.LogLevel.Warning&&this._proxy.$log(this._logFile,c.LogLevel.Warning,Array.from(arguments))}error(S,...P){this.getLevel()<=c.LogLevel.Error&&this._proxy.$log(this._logFile,c.LogLevel.Error,Array.from(arguments))}critical(S,...P){this.getLevel()<=c.LogLevel.Critical&&this._proxy.$log(this._logFile,c.LogLevel.Critical,Array.from(arguments))}flush(){}};T=Be([ze(0,A.IExtHostRpcService),ze(1,_.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(ve[213],we([0,1,13,23,21,15,3,7,108,179,46]),function(ne,e,c,F,_,A,T,I,S,P,t){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(f,E){try{return JSON.stringify(f,E)}catch(h){return"null"}}const d="$$ref$$",o={[d]:-1};class a{constructor(E,h){this.jsonString=E,this.referencedBuffers=h}}function g(f,E=null,h=!1){const M=[];return{jsonString:(h?n:JSON.stringify)(f,(q,Q)=>{if(typeof Q=="undefined")return o;if(typeof Q=="object"){if(Q instanceof F.VSBuffer){const $=M.push(Q)-1;return{[d]:$}}if(E)return E(q,Q)}return Q}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=g;function k(f,E,h){return JSON.parse(f,(M,O)=>{if(O){const q=O[d];if(typeof q=="number")return E[q];if(h&&O.$mid===1)return h.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=k;function b(f,E){return JSON.stringify(f,E)}function u(f){return f?(E,h)=>h&&h.$mid===1?f.transformOutgoing(h):h:null}var p;(function(f){f[f.LocalSide=0]="LocalSide",f[f.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(f){f[f.Responsive=0]="Responsive",f[f.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},r=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class s extends I.Disposable{constructor(E,h=null,M=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=E,this._logger=h,this._uriTransformer=M,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,q=t.ProxyIdentifier.count;O<q;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(E=>{this._pendingRPCReplies[E].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(E){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(E){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(E){this._responsiveState!==E&&(this._responsiveState=E,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(E){return this._uriTransformer?(0,S.transformIncomingURIs)(E,this._uriTransformer):E}getProxy(E){const{nid:h,sid:M}=E;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,M)),this._proxies[h]}_createProxy(E,h){let M={get:(O,q)=>(typeof q=="string"&&!O[q]&&q.charCodeAt(0)===36&&(O[q]=(...Q)=>this._remoteCall(E,q,Q)),q===l?h:O[q])};return new Proxy(Object.create(null),M)}set(E,h){return this._locals[E.nid]=h,h}assertRegistered(E){for(let h=0,M=E.length;h<M;h++){const O=E[h];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(E){if(this._isDisposed)return;const h=E.byteLength,M=m.read(E,0),O=M.readUInt8(),q=M.readUInt32();switch(O){case 1:case 2:{let{rpcId:Q,method:$,args:z}=w.deserializeRequestJSONArgs(M);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(h,q,Q,$,z,O===2);break}case 3:case 4:{let{rpcId:Q,method:$,args:z}=w.deserializeRequestMixedArgs(M);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(h,q,Q,$,z,O===4);break}case 5:{this._logger&&this._logger.logIncoming(h,q,0,"ack"),this._onDidReceiveAcknowledge(q);break}case 6:{this._receiveCancel(h,q);break}case 7:{this._receiveReply(h,q,void 0);break}case 9:{let Q=w.deserializeReplyOKJSON(M);this._uriTransformer&&(Q=(0,S.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveReply(h,q,Q);break}case 10:{const Q=w.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(h,q,Q);break}case 8:{let Q=w.deserializeReplyOKVSBuffer(M);this._receiveReply(h,q,Q);break}case 11:{let Q=w.deserializeReplyErrError(M);this._uriTransformer&&(Q=(0,S.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveReplyErr(h,q,Q);break}case 12:{this._receiveReplyErr(h,q,void 0);break}default:console.error("received unexpected message"),console.error(E)}}_receiveRequest(E,h,M,O,q,Q){this._logger&&this._logger.logIncoming(E,h,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(M)}.${O}(`,q);const $=String(h);let z,N;if(Q){const j=new _.CancellationTokenSource;q.push(j.token),z=this._invokeHandler(M,O,q),N=()=>j.cancel()}else z=this._invokeHandler(M,O,q),N=i;this._cancelInvokedHandlers[$]=N;const W=w.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(W.byteLength,h,1,"ack"),this._protocol.send(W),z.then(j=>{delete this._cancelInvokedHandlers[$];const Y=w.serializeReplyOK(h,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(Y.byteLength,h,1,"reply:",j),this._protocol.send(Y)},j=>{delete this._cancelInvokedHandlers[$];const Y=w.serializeReplyErr(h,j);this._logger&&this._logger.logOutgoing(Y.byteLength,h,1,"replyErr:",j),this._protocol.send(Y)})}_receiveCancel(E,h){this._logger&&this._logger.logIncoming(E,h,1,"receiveCancel");const M=String(h);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(E,h,M){this._logger&&this._logger.logIncoming(E,h,0,"receiveReply:",M);const O=String(h);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const q=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],q.resolveOk(M)}_receiveReplyErr(E,h,M){this._logger&&this._logger.logIncoming(E,h,0,"receiveReplyErr:",M);const O=String(h);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const q=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let Q;M&&(M.$isError?(Q=new Error,Q.name=M.name,Q.message=M.message,Q.stack=M.stack):Q=M),q.resolveErr(Q)}_invokeHandler(E,h,M){try{return Promise.resolve(this._doInvokeHandler(E,h,M))}catch(O){return Promise.reject(O)}}_doInvokeHandler(E,h,M){const O=this._locals[E];if(!O)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(E));let q=O[h];if(typeof q!="function")throw new Error("Unknown method "+h+" on actor "+(0,t.getStringIdentifierForProxy)(E));return q.apply(O,M)}_remoteCall(E,h,M){if(this._isDisposed)return Promise.reject(A.canceled());let O=null;if(M.length>0&&_.CancellationToken.isCancellationToken(M[M.length-1])&&(O=M.pop()),O&&O.isCancellationRequested)return Promise.reject(A.canceled());const q=w.serializeRequestArguments(M,this._uriReplacer),Q=++this._lastMessageId,$=String(Q),z=new P.LazyPromise;O&&O.onCancellationRequested(()=>{const W=w.serializeCancel(Q);this._logger&&this._logger.logOutgoing(W.byteLength,Q,0,"cancel"),this._protocol.send(w.serializeCancel(Q))}),this._pendingRPCReplies[$]=z,this._onWillSendRequest(Q);const N=w.serializeRequest(Q,E,h,q,!!O);return this._logger&&this._logger.logOutgoing(N.byteLength,Q,0,`request: ${(0,t.getStringIdentifierForProxy)(E)}.${h}(`,M),this._protocol.send(N),z}}e.RPCProtocol=s,y=r,s.UNRESPONSIVE_TIME=3*1e3;class m{constructor(E,h){this._buff=E,this._offset=h}static alloc(E,h,M){let O=new m(F.VSBuffer.alloc(M+1+4),0);return O.writeUInt8(E),O.writeUInt32(h),O}static read(E,h){return new m(E,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(E){this._buff.writeUInt8(E,this._offset),this._offset+=1}readUInt8(){const E=this._buff.readUInt8(this._offset);return this._offset+=1,E}writeUInt32(E){this._buff.writeUInt32BE(E,this._offset),this._offset+=4}readUInt32(){const E=this._buff.readUInt32BE(this._offset);return this._offset+=4,E}static sizeShortString(E){return 1+E.byteLength}writeShortString(E){this._buff.writeUInt8(E.byteLength,this._offset),this._offset+=1,this._buff.set(E,this._offset),this._offset+=E.byteLength}readShortString(){const E=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,M}static sizeLongString(E){return 4+E.byteLength}writeLongString(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readLongString(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+E).toString();return this._offset+=E,M}writeBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}static sizeVSBuffer(E){return 4+E.byteLength}writeVSBuffer(E){this._buff.writeUInt32BE(E.byteLength,this._offset),this._offset+=4,this._buff.set(E,this._offset),this._offset+=E.byteLength}readVSBuffer(){const E=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+E);return this._offset+=E,h}static sizeMixedArray(E){let h=0;h+=1;for(let M=0,O=E.length;M<O;M++){const q=E[M];switch(h+=1,q.type){case 1:h+=this.sizeLongString(q.value);break;case 2:h+=this.sizeVSBuffer(q.value);break;case 3:h+=this.sizeUInt8(),h+=this.sizeLongString(q.value);for(let Q=0;Q<q.buffers.length;++Q)h+=this.sizeVSBuffer(q.buffers[Q]);break;case 4:break}}return h}writeMixedArray(E){this._buff.writeUInt8(E.length,this._offset),this._offset+=1;for(let h=0,M=E.length;h<M;h++){const O=E[h];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt8(O.buffers.length),this.writeLongString(O.value);for(let q=0;q<O.buffers.length;++q)this.writeBuffer(O.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const E=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(E);for(let M=0;M<E;M++)switch(this.readUInt8()){case 1:h[M]=this.readLongString();break;case 2:h[M]=this.readVSBuffer();break;case 3:const q=this.readUInt8(),Q=this.readLongString(),$=[];for(let z=0;z<q;++z)$.push(this.readVSBuffer());h[M]=new t.SerializableObjectWithBuffers(k(Q,$,null));break;case 4:h[M]=void 0;break}return h}}var v;(function(f){f[f.Simple=0]="Simple",f[f.Mixed=1]="Mixed"})(v||(v={}));class w{static _useMixedArgSerialization(E){for(let h=0,M=E.length;h<M;h++)if(E[h]instanceof F.VSBuffer||E[h]instanceof t.SerializableObjectWithBuffers||typeof E[h]=="undefined")return!0;return!1}static serializeRequestArguments(E,h){if(this._useMixedArgSerialization(E)){const M=[];for(let O=0,q=E.length;O<q;O++){const Q=E[O];if(Q instanceof F.VSBuffer)M[O]={type:2,value:Q};else if(typeof Q=="undefined")M[O]={type:4};else if(Q instanceof t.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:z}=g(Q.value,h);M[O]={type:3,value:F.VSBuffer.fromString($),buffers:z}}else M[O]={type:1,value:F.VSBuffer.fromString(b(Q,h))}}return{type:1,args:M}}return{type:0,args:b(E,h)}}static serializeRequest(E,h,M,O,q){switch(O.type){case 0:return this._requestJSONArgs(E,h,M,O.args,q);case 1:return this._requestMixedArgs(E,h,M,O.args,q)}}static _requestJSONArgs(E,h,M,O,q){const Q=F.VSBuffer.fromString(M),$=F.VSBuffer.fromString(O);let z=0;z+=m.sizeUInt8(),z+=m.sizeShortString(Q),z+=m.sizeLongString($);let N=m.alloc(q?2:1,E,z);return N.writeUInt8(h),N.writeShortString(Q),N.writeLongString($),N.buffer}static deserializeRequestJSONArgs(E){const h=E.readUInt8(),M=E.readShortString(),O=E.readLongString();return{rpcId:h,method:M,args:JSON.parse(O)}}static _requestMixedArgs(E,h,M,O,q){const Q=F.VSBuffer.fromString(M);let $=0;$+=m.sizeUInt8(),$+=m.sizeShortString(Q),$+=m.sizeMixedArray(O);let z=m.alloc(q?4:3,E,$);return z.writeUInt8(h),z.writeShortString(Q),z.writeMixedArray(O),z.buffer}static deserializeRequestMixedArgs(E){const h=E.readUInt8(),M=E.readShortString(),O=E.readMixedArray(),q=new Array(O.length);for(let Q=0,$=O.length;Q<$;Q++){const z=O[Q];typeof z=="string"?q[Q]=JSON.parse(z):q[Q]=z}return{rpcId:h,method:M,args:q}}static serializeAcknowledged(E){return m.alloc(5,E,0).buffer}static serializeCancel(E){return m.alloc(6,E,0).buffer}static serializeReplyOK(E,h,M){if(typeof h=="undefined")return this._serializeReplyOKEmpty(E);if(h instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(E,h);if(h instanceof t.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:q}=g(h.value,M,!0);return this._serializeReplyOKJSONWithBuffers(E,O,q)}else return this._serializeReplyOKJSON(E,n(h,M))}static _serializeReplyOKEmpty(E){return m.alloc(7,E,0).buffer}static _serializeReplyOKVSBuffer(E,h){let M=0;M+=m.sizeVSBuffer(h);let O=m.alloc(8,E,M);return O.writeVSBuffer(h),O.buffer}static deserializeReplyOKVSBuffer(E){return E.readVSBuffer()}static _serializeReplyOKJSON(E,h){const M=F.VSBuffer.fromString(h);let O=0;O+=m.sizeLongString(M);let q=m.alloc(9,E,O);return q.writeLongString(M),q.buffer}static _serializeReplyOKJSONWithBuffers(E,h,M){const O=F.VSBuffer.fromString(h);let q=0;q+=m.sizeUInt8(),q+=m.sizeLongString(O);for(const $ of M)q+=m.sizeVSBuffer($);let Q=m.alloc(10,E,q);Q.writeUInt8(M.length),Q.writeLongString(O);for(const $ of M)Q.writeBuffer($);return Q.buffer}static deserializeReplyOKJSON(E){const h=E.readLongString();return JSON.parse(h)}static deserializeReplyOKJSONWithBuffers(E,h){const M=E.readUInt8(),O=E.readLongString(),q=[];for(let Q=0;Q<M;++Q)q.push(E.readVSBuffer());return new t.SerializableObjectWithBuffers(k(O,q,h))}static serializeReplyErr(E,h){return h?this._serializeReplyErrEror(E,h):this._serializeReplyErrEmpty(E)}static _serializeReplyErrEror(E,h){const M=F.VSBuffer.fromString(n(A.transformErrorForSerialization(h),null));let O=0;O+=m.sizeLongString(M);let q=m.alloc(11,E,O);return q.writeLongString(M),q.buffer}static deserializeReplyErrError(E){const h=E.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(E){return m.alloc(12,E,0).buffer}}var C;(function(f){f[f.RequestJSONArgs=1]="RequestJSONArgs",f[f.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",f[f.RequestMixedArgs=3]="RequestMixedArgs",f[f.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",f[f.Acknowledged=5]="Acknowledged",f[f.Cancel=6]="Cancel",f[f.ReplyOKEmpty=7]="ReplyOKEmpty",f[f.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",f[f.ReplyOKJSON=9]="ReplyOKJSON",f[f.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",f[f.ReplyErrError=11]="ReplyErrError",f[f.ReplyErrEmpty=12]="ReplyErrEmpty"})(C||(C={}));var R;(function(f){f[f.String=1]="String",f[f.VSBuffer=2]="VSBuffer",f[f.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",f[f.Undefined=4]="Undefined"})(R||(R={}))}),define(ve[214],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(A){const T=I=>{self.removeEventListener("message",T);const S=I.data;Object.defineProperties(self,{postMessage:{value(P,t){S.postMessage(P,t)}},onmessage:{get(){return S.onmessage},set(P){S.onmessage=P}}}),S.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",T)}.toString();class F extends EventTarget{constructor(A,T,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${c})('${T}'))`,P=new Blob([S],{type:"application/javascript"}),t=URL.createObjectURL(P),y=new MessageChannel,n=t,d={type:"_newWorker",id:n,port:y.port2,url:t,options:I};A(d,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};y.port1.postMessage(o),URL.revokeObjectURL(t),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(o){y.port1.onmessage=o}},onmessageerror:{get(){return y.port1.onmessageerror},set(o){y.port1.onmessageerror=o}}}),y.port1.addEventListener("messageerror",o=>{const a=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(a)}),y.port1.addEventListener("message",o=>{const a=new MessageEvent("message",{data:o.data});this.dispatchEvent(a)}),y.port1.start()}}e.NestedWorker=F}),define(ve[215],we([0,1,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(ve[216],we([0,1,11,17,25,2,4,87,44,175,215]),function(ne,e,c,F,_,A,T,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let y=class $i{constructor(d,o,a,g){this.localUserHome=d,this.remoteAgentService=o,this.environmentService=a,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||_.OS)(),this.resolveUserHome=(async()=>{const k=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=k?.userHome||d})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,o){if(d.remoteAuthority)return c.Schemas.vscodeRemote;const a=(0,I.getVirtualWorkspaceScheme)(o.getWorkspace());if(a)return a;const g=o.getWorkspace().folders[0];if(g)return g.uri.scheme;const k=o.getWorkspace().configuration;return k?k.scheme:c.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?F.win32:F.posix)}async fileURI(d){let o="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const g=d.indexOf("/",2);g===-1?(o=d.substring(2),d="/"):(o=d.substring(2,g),d=d.substring(g)||"/")}return A.URI.from({scheme:c.Schemas.file,authority:o,path:d,query:"",fragment:""})}};y=Be([ze(1,t.IRemoteAgentService),ze(2,P.IWorkbenchEnvironmentService),ze(3,S.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(ve[98],we([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(T,I){this.line=T,this.character=I}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,I){return new c(0,0)}with(T){return new c(0,0)}}e.Position=c;class F{constructor(T,I,S,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(T,I),this.end=new c(S,P)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new F(0,0,0,0)}with(T){return new F(0,0,0,0)}}e.Range=F;var _;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[38],we([0,1,16,27,22,40,9,4,17,15,98,10]),function(ne,e,c,F,_,A,T,I,S,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",d=" characters skipped \u27EB",o=(n.length+d.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var a;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function k(W){return!!W.preview}e.resultIsMatch=k;function b(W){return!!W.resource}e.isFileMatch=b;function u(W){return!!W.message}e.isProgressMessage=u;var p;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(j){this.resource=j,this.results=[]}}e.FileMatch=D;class i{constructor(j,Y,de){this.ranges=Y;const G=Array.isArray(Y)?Y:[Y];if(de&&de.matchLines===1&&r(G)){j=(0,T.getNLines)(j,de.matchLines);let ue="",oe=0,be=0;const Ae=Math.floor(de.charsPerLine/5),Re=[];for(const Oe of G){const Qe=Math.max(Oe.startColumn-Ae,0),He=Oe.startColumn+de.charsPerLine;if(Qe>be+Ae+o){const je=n+(Qe-be)+d;ue+=je+j.slice(Qe,He),oe+=Qe-(be+je.length)}else ue+=j.slice(be,He);Re.push(new s(0,Oe.startColumn-oe,Oe.endColumn-oe)),be=He}this.preview={text:ue,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const ue=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:j,matches:(0,c.mapArrayOrNot)(Y,oe=>new l(oe.startLineNumber-ue,oe.startColumn,oe.endLineNumber-ue,oe.endColumn))}}}}e.TextSearchMatch=i;function r(W){const j=W[0].startLineNumber;for(const Y of W)if(Y.startLineNumber!==j||Y.endLineNumber!==j)return!1;return!0}class l{constructor(j,Y,de,G){this.startLineNumber=j,this.startColumn=Y,this.endLineNumber=de,this.endColumn=G}}e.SearchRange=l;class s extends l{constructor(j,Y,de){super(j,Y,j,de)}}e.OneLineRange=s;var m;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function v(W,j=!0){const Y=W&&W.files&&W.files.exclude,de=j&&W&&W.search&&W.search.exclude;if(!Y&&!de)return;if(!Y||!de)return Y||de;let G=Object.create(null);return G=_.mixin(G,_.deepClone(Y)),G=_.mixin(G,_.deepClone(de),!0),G}e.getExcludes=v;function w(W,j){return W.excludePattern&&F.match(W.excludePattern,j)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&F.match(W.includePattern,j)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(Y=>{const de=Y.folder.fsPath;if(A.isEqualOrParent(j,de)){const G=S.relative(de,j);return!Y.includePattern||!!F.match(Y.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=w;var C;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(C=e.SearchErrorCode||(e.SearchErrorCode={}));class R extends Error{constructor(j,Y){super(j);this.code=Y}}e.SearchError=R;function f(W){const j=W.message;if((0,P.isPromiseCanceledError)(W))return new R(j,C.canceled);try{const Y=JSON.parse(j);return new R(Y.message,Y.code)}catch(Y){return new R(j,C.other)}}e.deserializeSearchError=f;function E(W){const j={message:W.message,code:W.code};return new Error(JSON.stringify(j))}e.serializeSearchError=E;function h(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=h;function M(W){return W.type==="success"}e.isSerializedSearchSuccess=M;function O(W){return!!W.path}e.isSerializedFileMatch=O;function q(W,j){const Y=W.searchPath?W.searchPath:W.relativePath;return(0,T.fuzzyContains)(Y,j)}e.isFilePatternMatch=q;class Q{constructor(j){this.path=j,this.results=[]}addMatch(j){this.results.push(j)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Q;function $(W,j){const Y={...W||{},...j||{}};return Object.keys(Y).filter(de=>{const G=Y[de];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=$;class z{constructor(j,Y){this._parsedIncludeExpression=null,this._excludeExpression={...j.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let de=j.includePattern;Y.includePattern&&(de?de={...de,...Y.includePattern}:de=Y.includePattern),de&&(this._parsedIncludeExpression=F.parse(de))}includedInQuerySync(j,Y,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,Y,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(j,Y,de))}includedInQuery(j,Y,de){const G=this._parsedExcludeExpression(j,Y,de),ue=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(j,Y,de):!0;return(0,y.isPromise)(G)?G.then(oe=>oe?!1:ue()):ue()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=z;function N(W){for(const j in W)if(typeof W[j]!="boolean")return!0;return!1}}),define(ve[31],we([0,1,16,13,21,3,20,11,76,24,9,10,2,127,4,14,142,44,45,29,12,6,38,5]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b,u,p,D,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(E,h,M){return new P.ExtUri(O=>w(O,M)).isEqual(E,h)}function s(E,h,M){return l(E.uri,h.uri,M)?0:(0,t.compare)(E.uri.toString(),h.uri.toString())}function m(E,h,M){return E.index!==h.index?E.index<h.index?-1:1:l(E.uri,h.uri,M)?(0,t.compare)(E.name,h.name):(0,t.compare)(E.uri.toString(),h.uri.toString())}function v(E,h,M,O){const q=E.slice(0).sort(($,z)=>M($,z,O)),Q=h.slice(0).sort(($,z)=>M($,z,O));return(0,c.delta)(q,Q,($,z)=>M($,z,O))}function w(E,h){const M=h.getCapabilities(E.scheme);return!(M&&M&1024)}class C extends k.Workspace{constructor(h,M,O,q,Q,$){super(h,O.map(z=>new k.WorkspaceFolder(z)),q,$);this._name=M,this._isUntitled=Q,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris($),O.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(h,M,O,q){if(!h)return{workspace:null,added:[],removed:[]};const{id:Q,name:$,folders:z,configuration:N,isUntitled:W}=h,j=[],Y=M;M?z.forEach((oe,be)=>{const Ae=n.URI.revive(oe.uri),Re=C._findFolder(O||M,Ae,q);Re?(Re.name=oe.name,Re.index=oe.index,j.push(Re)):j.push({uri:Ae,name:oe.name,index:be})}):j.push(...z.map(({uri:oe,name:be,index:Ae})=>({uri:n.URI.revive(oe),name:be,index:Ae}))),j.sort((oe,be)=>oe.index<be.index?-1:1);const de=new C(Q,$,j,N?n.URI.revive(N):null,!!W,oe=>w(oe,q)),{added:G,removed:ue}=v(Y?Y.workspaceFolders:[],de.workspaceFolders,s,q);return{workspace:de,added:G,removed:ue}}static _findFolder(h,M,O){for(let q=0;q<h.folders.length;q++){const Q=h.workspaceFolders[q];if(l(Q.uri,M,O))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(h,M){return M&&this._structure.get(h)&&(h=(0,P.dirname)(h)),this._structure.findSubstr(h)}resolveWorkspaceFolder(h){return this._structure.get(h)}}let R=class{constructor(h,M,O,q){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=q,this._extHostFileSystemInfo=O,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=h.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=h.getProxy(r.MainContext.MainThreadMessageService);const Q=M.workspace;this._confirmedWorkspace=Q?new C(Q.id,Q.name,[],Q.configuration?n.URI.revive(Q.configuration):null,!!Q.isUntitled,$=>w($,O)):void 0}$initializeWorkspace(h,M){this._trusted=M,this.$acceptWorkspaceData(h),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:I.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(h,M,O,...q){const Q=[];if(Array.isArray(q)&&q.forEach(j=>{n.URI.isUri(j.uri)&&!Q.some(Y=>l(Y.uri,j.uri,this._extHostFileSystemInfo))&&Q.push({uri:j.uri,name:j.name||(0,P.basenameOrAuthority)(j.uri)})}),this._unconfirmedWorkspace||[M,O].some(j=>typeof j!="number"||j<0)||O===0&&Q.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+O>$.length)return!1;const z=$.slice(0);z.splice(M,O,...Q.map(j=>({uri:j.uri,name:j.name||(0,P.basenameOrAuthority)(j.uri),index:void 0})));for(let j=0;j<z.length;j++){const Y=z[j];if(z.some((de,G)=>G!==j&&l(Y.uri,de.uri,this._extHostFileSystemInfo)))return!1}z.forEach((j,Y)=>j.index=Y);const{added:N,removed:W}=v($,z,m,this._extHostFileSystemInfo);if(N.length===0&&W.length===0)return!1;if(this._proxy){const j=h.displayName||h.name;this._proxy.$updateWorkspaceFolders(j,M,O,Q).then(void 0,Y=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,d.localize)(0,null,j,Y.toString()),{extension:h},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(h,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(h,M)}async getWorkspaceFolder2(h,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(h,M)}async resolveWorkspaceFolder(h){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(h)}getPath(){if(!this._actualWorkspace)return;const{folders:h}=this._actualWorkspace;if(h.length!==0)return h[0].uri.fsPath}getRelativePath(h,M){let O,q="";if(typeof h=="string"?(O=n.URI.file(h),q=h):typeof h!="undefined"&&(O=h,q=h.fsPath),!O)return q;const Q=this.getWorkspaceFolder(O,!0);if(!Q)return q;typeof M=="undefined"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let $=(0,P.relativePath)(Q.uri,O);return M&&Q.name&&($=`${Q.name}/${$}`),$}trySetWorkspaceFolders(h){this._actualWorkspace&&(this._unconfirmedWorkspace=C.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:h,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(h){const{workspace:M,added:O,removed:q}=C.toExtHostWorkspace(h,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:q}))}findFiles(h,M,O,q,Q=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let $;if(M===null?$=!1:M&&(typeof M=="string"?$=M:$=M.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:N}=f(h);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(z),(0,y.withUndefinedAsNull)(N),(0,y.withUndefinedAsNull)($),(0,y.withUndefinedAsNull)(O),Q).then(W=>Array.isArray(W)?W.map(j=>n.URI.revive(j)):[])}async findTextInFiles(h,M,O,q,Q=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),z=typeof M.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:N,folder:W}=f(M.include),j=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,Y={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:z,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:N,excludePattern:j},de=!1;if(this._activeSearchCallbacks[$]=G=>{if(de)return;const ue=n.URI.revive(G.resource);G.results.forEach(oe=>{(0,i.resultIsMatch)(oe)?O({uri:ue,preview:{text:oe.preview.text,matches:(0,c.mapArrayOrNot)(oe.preview.matches,be=>new D.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,c.mapArrayOrNot)(oe.ranges,be=>new D.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):O({uri:ue,text:oe.text,lineNumber:oe.lineNumber})})},Q.isCancellationRequested)return{};try{const G=await this._proxy.$startTextSearch(h,(0,y.withUndefinedAsNull)(W),Y,$,Q);return delete this._activeSearchCallbacks[$],G||{}}catch(G){throw delete this._activeSearchCallbacks[$],G}}$handleTextSearchResult(h,M){this._activeSearchCallbacks[M]&&this._activeSearchCallbacks[M](h)}saveAll(h){return this._proxy.$saveAll(h)}resolveProxy(h){return this._proxy.$resolveProxy(h)}get trusted(){return this._trusted}requestWorkspaceTrust(h){return this._proxy.$requestWorkspaceTrust(h)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};R=Be([ze(0,p.IExtHostRpcService),ze(1,u.IExtHostInitDataService),ze(2,b.IExtHostFileSystemInfo),ze(3,a.ILogService)],R),e.ExtHostWorkspace=R,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function f(E){let h,M;return E&&(typeof E=="string"?h=E:(h=E.pattern,M=E.baseFolder||n.URI.file(E.base))),{includePattern:h,folder:M}}}),define(ve[32],we([0,1,22,3,31,5,6,148,62,10,13,4,12,14,2]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(r,l){if(l){const s=l.split(".");let m=r;for(let v=0;m&&v<s.length;v++)m=m[s[v]];return m}}function g(r){return r instanceof o.URI}function k(r){return r&&r.uri instanceof o.URI&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function u(r){return r&&r.uri instanceof o.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function p(r){if(g(r))return{resource:r};if(k(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(b(r))return{overrideIdentifier:r.languageId};if(u(r))return{resource:r.uri};if(r===null)return{resource:null}}let D=class{constructor(l,s,m){this._proxy=l.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=m,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new i(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,s){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(l,s))}};D=Be([ze(0,n.IExtHostRpcService),ze(1,_.IExtHostWorkspace),ze(2,d.ILogService)],D),e.ExtHostConfiguration=D;class i{constructor(l,s,m,v){this._onDidChangeConfiguration=new F.Emitter,this._proxy=l,this._logService=v,this._extHostWorkspace=s,this._configuration=I.Configuration.parse(m),this._configurationScopes=this._toMap(m.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,s){const m={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,m))}getConfiguration(l,s,m){const v=p(s)||{},w=this._toReadonlyValue(l?a(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,v,m?.identifier);function C(f){if(f==null)return null;if(typeof f=="boolean")return f?1:4;switch(f){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const R={has(f){return typeof a(w,f)!="undefined"},get:(f,E)=>{this._validateConfigurationAccess(l?`${l}.${f}`:f,v,m?.identifier);let h=a(w,f);if(typeof h=="undefined")h=E;else{let M;const O=(q,Q)=>{let $;const z=()=>{M=M||(0,c.deepClone)(w),$=$||a(M,Q)};return(0,P.isObject)(q)?new Proxy(q,{get:(N,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return z(),()=>$;if(M)return $=$||a(M,Q),$[W];const j=N[W];return typeof W=="string"?O(j,`${Q}.${W}`):j},set:(N,W,j)=>(z(),$&&($[W]=j),!0),deleteProperty:(N,W)=>(z(),$&&delete $[W],!0),defineProperty:(N,W,j)=>(z(),$&&Object.defineProperty($,W,j),!0)}):q};h=O(h,f)}return h},update:(f,E,h,M)=>{f=l?`${l}.${f}`:f;const O=C(h);return E!==void 0?this._proxy.$updateConfigurationOption(O,f,E,v,M):this._proxy.$removeConfigurationOption(O,f,v,M)},inspect:f=>{f=l?`${l}.${f}`:f;const E=(0,c.deepClone)(this._configuration.inspect(f,v,this._extHostWorkspace.workspace));if(E)return{key:f,defaultValue:E.default?.value,globalValue:E.user?.value,workspaceValue:E.workspace?.value,workspaceFolderValue:E.workspaceFolder?.value,defaultLanguageValue:E.default?.override,globalLanguageValue:E.user?.override,workspaceLanguageValue:E.workspace?.override,workspaceFolderLanguageValue:E.workspaceFolder?.override,languageIds:E.overrideIdentifiers}}};return typeof w=="object"&&(0,c.mixin)(R,w,!1),Object.freeze(R)}_toReadonlyValue(l){const s=m=>(0,P.isObject)(m)?new Proxy(m,{get:(v,w)=>s(v[w]),set:(v,w,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(v,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(v,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return s(l)}_validateConfigurationAccess(l,s,m){const v=S.OVERRIDE_PROPERTY_PATTERN.test(l)?4:this._configurationScopes.get(l),w=m?`[${m.value}] `:"";if(v===4){typeof s?.resource=="undefined"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){s?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,s){const m=new I.ConfigurationChangeEvent(l,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,w)=>m.affectsConfiguration(v,p(w))})}_toMap(l){return l.reduce((s,m)=>(s.set(m[0],m[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[99],we([0,1,2,13,3,5,6,31,48,32,21,37,12,29,4,11,25,14,71,165,15]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b,u,p){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(Q){function $(N){if(N!=null)return N}Q.from=$;function z(N){if(N!=null)return N}Q.to=z})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(Q){function $(N){if(N!=null)return N}Q.from=$;function z(N){if(N!=null)return N}Q.to=z})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var l;(function(Q){function $(N){if(N!=null)return N}Q.from=$;function z(N){if(N!=null)return N}Q.to=z})(l=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(Q){function $(W){if(W){const j=W;return j&&!!j.process}else return!1}Q.is=$;function z(W){if(W==null)return;const j={process:W.process,args:W.args};return W.options&&(j.options=l.from(W.options)),j}Q.from=z;function N(W){if(W!=null)return new T.ProcessExecution(W.process,W.args,W.options)}Q.to=N})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var m;(function(Q){function $(N){if(N!=null)return N}Q.from=$;function z(N){if(N!=null)return N}Q.to=z})(m=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var v;(function(Q){function $(W){if(W){const j=W;return j&&(!!j.commandLine||!!j.command)}else return!1}Q.is=$;function z(W){if(W==null)return;const j={};return W.commandLine!==void 0?j.commandLine=W.commandLine:(j.command=W.command,j.args=W.args),W.options&&(j.options=m.from(W.options)),j}Q.from=z;function N(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new T.ShellExecution(W.commandLine,W.options):new T.ShellExecution(W.command,W.args?W.args:[],W.options)}Q.to=N})(v=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(Q){function $(W){if(W){let j=W;return j&&j.customExecution==="customExecution"}else return!1}Q.is=$;function z(W){return{customExecution:"customExecution"}}Q.from=z;function N(W,j){return j.get(W)}Q.to=N})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var C;(function(Q){function $(z,N){let W;return z.scope!==void 0&&typeof z.scope!="number"?W=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===T.TaskScope.Workspace&&N&&N.workspaceFile?W=N.workspaceFile:W=u.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:W}}Q.from=$})(C=e.TaskHandleDTO||(e.TaskHandleDTO={}));var R;(function(Q){function $(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}Q.from=$})(R=e.TaskGroupDTO||(e.TaskGroupDTO={}));var f;(function(Q){function $(W,j){if(W==null)return[];const Y=[];for(let de of W){const G=z(de,j);G&&Y.push(G)}return Y}Q.fromMany=$;function z(W,j){if(W==null)return;let Y;W.execution instanceof T.ProcessExecution?Y=s.from(W.execution):W.execution instanceof T.ShellExecution?Y=v.from(W.execution):W.execution&&W.execution instanceof T.CustomExecution&&(Y=w.from(W.execution));const de=i.from(W.definition);let G;return W.scope?typeof W.scope=="number"?G=W.scope:G=W.scope.uri:G=T.TaskScope.Workspace,!de||!G?void 0:{_id:W._id,definition:de,name:W.name,source:{extensionId:j.identifier.value,label:W.source,scope:G},execution:Y,isBackground:W.isBackground,group:R.from(W.group),presentationOptions:r.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}Q.from=z;async function N(W,j,Y){if(W==null)return;let de;s.is(W.execution)?de=s.to(W.execution):v.is(W.execution)?de=v.to(W.execution):w.is(W.execution)&&(de=w.to(W._id,Y));const G=i.to(W.definition);let ue;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?ue=W.source.scope:ue=await j.resolveWorkspaceFolder(c.URI.revive(W.source.scope)):ue=T.TaskScope.Workspace),!G||!ue)return;const oe=new T.Task(G,ue,W.name,W.source.label,de,W.problemMatchers);return W.isBackground!==void 0&&(oe.isBackground=W.isBackground),W.group!==void 0&&(oe.group=T.TaskGroup.from(W.group._id),oe.group&&(oe.group=new T.TaskGroup(oe.group.id,oe.group.label),W.group.isDefault&&(oe.group.isDefault=W.group.isDefault))),W.presentationOptions&&(oe.presentationOptions=r.to(W.presentationOptions)),W._id&&(oe._id=W._id),W.detail&&(oe.detail=W.detail),oe}Q.to=N})(f=e.TaskDTO||(e.TaskDTO={}));var E;(function(Q){function $(N){return N}Q.from=$;function z(N){if(!!N)return Object.assign(Object.create(null),N)}Q.to=z})(E=e.TaskFilterDTO||(e.TaskFilterDTO={}));class h{constructor($,z,N){this._id=z,this._task=N,D.set(this,void 0),et(this,D,$,"f")}get task(){return this._task}terminate(){Me(this,D,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}D=new WeakMap;var M;(function(Q){function $(z){return{id:z._id,task:void 0}}Q.from=$})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor($,z,N,W,j,Y,de,G){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=$.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=W,this._configurationService=j,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=de,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,z,N){if(!N)return new T.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:z,provider:N,extension:$}),this._proxy.$registerTaskProvider(W,z),new T.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem($,z){this._proxy.$registerTaskSystem($,z)}fetchTasks($){return this._proxy.$fetchTasks(E.from($)).then(async z=>{const N=[];for(let W of z){const j=await f.to(W,this._workspaceProvider,this._providedCustomExecutions2);j&&N.push(j)}return N})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(z=>$.push(z)),$}terminateTask($){if(!($ instanceof h))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,z,N){const W=this._providedCustomExecutions2.get($.id);if(W){if(this._activeCustomExecutions2.get($.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set($.id,W),this._terminalService.attachPtyToTerminal(z,await W.callback(N))}this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const z=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const z=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:z,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const z=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:$.exitCode})}$provideTasks($,z){const N=this._handlers.get($);if(!N)return Promise.reject(new Error("no handler found"));const W=[],j=(0,F.asPromise)(()=>N.provider.provideTasks(t.CancellationToken.None)).then(Y=>this.provideTasksInternal(z,W,N,Y));return new Promise(Y=>{j.then(de=>{Promise.all(W).then(()=>{Y(de)})})})}async $resolveTask($,z){const N=this._handlers.get($);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const W=await f.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const j=await N.provider.resolveTask(W,t.CancellationToken.None);if(!j)return;this.checkDeprecation(j,N);const Y=f.from(j,N.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(Y.execution)&&await this.addCustomExecution(Y,j,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution($,z,N){const W=await this._proxy.$createTaskId($);!N&&!this._providedCustomExecutions2.has(W)&&this._notProvidedCustomExecutions.add(W),this._providedCustomExecutions2.set(W,z.execution)}async getTaskExecution($,z){if(typeof $=="string"){const j=this._taskExecutionPromises.get($);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let N=this._taskExecutionPromises.get($.id);if(N)return N;const W=new Promise(async(j,Y)=>{const de=z||await f.to($.task,this._workspaceProvider,this._providedCustomExecutions2);de?j(new h(this,$.id,de)):Y("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set($.id,W),W.then(j=>(this._taskExecutions.set($.id,j),j),j=>Promise.reject(j))}checkDeprecation($,z){$._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));let N=this._notProvidedCustomExecutions.values(),W=N.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=N.next()}};O=Be([ze(0,n.IExtHostRpcService),ze(1,d.IExtHostInitDataService),ze(2,I.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,k.ILogService),ze(7,b.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let q=class extends O{constructor($,z,N,W,j,Y,de,G){super($,z,N,W,j,Y,de,G);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask($,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=f.from(z,$);if(N===void 0)throw new Error("Task is not valid");if(w.is(N.execution))await this.addCustomExecution(N,z,!1);else throw new p.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),z);return this._proxy.$executeTask(N).catch(j=>{throw new Error(j)}),W}provideTasksInternal($,z,N,W){const j=[];if(W)for(let Y of W){this.checkDeprecation(Y,N),(!Y.definition||!$[Y.definition.type])&&this._logService.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const de=f.from(Y,N.extension);de&&w.is(de.execution)?(j.push(de),z.push(this.addCustomExecution(de,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:N.extension}}async resolveTaskInternal($){if(w.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,z,N){}};q=Be([ze(0,n.IExtHostRpcService),ze(1,d.IExtHostInitDataService),ze(2,I.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,k.ILogService),ze(7,b.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(ve[217],we([0,1,16,50,27,78,20,11,17,24,9,10,2,110,131,85,44,92,216,38]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(C,R,f,E){this.configurationService=C,this.workspaceContextService=R,this.editorGroupsService=f,this.pathService=E}text(C,R,f={}){C=this.getContentPattern(C,f);const E=this.configurationService.getValue(),h=R&&R.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(R?.map(g.toWorkspaceFolder),f),type:2,contentPattern:C,previewOptions:f.previewOptions,maxFileSize:f.maxFileSize,usePCRE2:E.search.usePCRE2||h||!1,beforeContext:f.beforeContext,afterContext:f.afterContext,userDisabledExcludesAndIgnoreFiles:f.disregardExcludeSettings&&f.disregardIgnoreFiles}}getContentPattern(C,R){const f=this.configurationService.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const E={...C,wordSeparators:f.editor.wordSeparators};return this.isCaseSensitive(C,R)&&(E.isCaseSensitive=!0),this.isMultiline(C)&&(E.isMultiline=!0),E}file(C,R={}){return{...this.commonQuery(C,R),type:1,filePattern:R.filePattern?R.filePattern.trim():R.filePattern,exists:R.exists,sortByScore:R.sortByScore,cacheKey:R.cacheKey}}handleIncludeExclude(C,R){return C?(C=Array.isArray(C)?C.map(s):s(C),R?this.parseSearchPaths(C):{pattern:i(...Array.isArray(C)?C:[C])}):{}}commonQuery(C=[],R={}){const f=this.handleIncludeExclude(R.includePattern,R.expandPatterns),E=this.handleIncludeExclude(R.excludePattern,R.expandPatterns),h=C.length>1,M=(f.searchPaths&&f.searchPaths.length?f.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,R,E)):C.map(Q=>this.getFolderQueryForRoot(Q,R,E,h))).filter(Q=>!!Q),O={_reason:R._reason,folderQueries:M,usingSearchPaths:!!(f.searchPaths&&f.searchPaths.length),extraFileResources:R.extraFileResources,excludePattern:E.pattern,includePattern:f.pattern,onlyOpenEditors:R.onlyOpenEditors,maxResults:R.maxResults};if(R.onlyOpenEditors){const $=c.coalesce(c.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(W=>W.resource)))).filter(N=>(0,u.pathIncludedInQuery)(O,N.fsPath)),z=this.commonQueryFromFileList($);return{...O,...z}}const q=R.extraFileResources&&R.extraFileResources.filter(Q=>(0,u.pathIncludedInQuery)(O,Q.fsPath));return O.extraFileResources=q&&q.length?q:void 0,O}commonQueryFromFileList(C){const R=[],f=new T.ResourceMap,E={};let h=!1;return C.forEach(M=>{if(M.scheme===I.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(M)){const q=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:S.dirname(M.fsPath)});let Q=f.get(q);Q||(h=!0,Q={folder:q,includePattern:{}},R.push(Q),f.set(q,Q));const $=S.relative(q.fsPath,M.fsPath);(0,y.assertIsDefined)(Q.includePattern)[$.replace(/\\/g,"/")]=!0}else M.fsPath&&(h=!0,E[M.fsPath]=!0)}),{folderQueries:R,includePattern:E,usingSearchPaths:!0,excludePattern:h?void 0:{"**/*":!0}}}isCaseSensitive(C,R){if(R.isSmartCase){if(C.isRegExp){if(t.containsUppercaseCharacter(C.pattern,!0))return!0}else if(t.containsUppercaseCharacter(C.pattern))return!0}return!!C.isCaseSensitive}isMultiline(C){return C.isMultiline||C.isRegExp&&(0,d.isMultilineRegexSource)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const R=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),E=(Array.isArray(C)?C:r(C)).map(z=>{const N=this.pathService.resolvedUserHome;return N?(0,A.untildify)(z,N.scheme===I.Schemas.file?N.fsPath:N.path):z}),h=F.groupBy(E,z=>R(z)?"searchPaths":"exprSegments"),M=(h.exprSegments||[]).map(z=>t.rtrim(z,"/")).map(z=>t.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),l(z))),O={},q=this.expandSearchPathPatterns(h.searchPaths||[]);q&&q.length&&(O.searchPaths=q);const Q=c.flatten(M),$=i(...Q);return $&&(O.pattern=$),O}getExcludesForFolder(C,R){return R.disregardExcludeSettings?void 0:(0,u.getExcludes)(C,!R.disregardSearchExcludeSettings)}expandSearchPathPatterns(C){if(!C||!C.length)return[];const R=c.flatten(C.map(E=>{let{pathPortion:h,globPortion:M}=D(E);M&&(M=m(M));const O=this.expandOneSearchPath(h);return c.flatten(O.map(q=>this.resolveOneSearchPathPattern(q,M)))})),f=new Map;return R.forEach(E=>{const h=E.searchPath.toString(),M=f.get(h);M?E.pattern&&(M.pattern=M.pattern||{},M.pattern[E.pattern]=!0):f.set(h,{searchPath:E.searchPath,pattern:E.pattern?i(E.pattern):void 0})}),Array.from(f.values())}expandOneSearchPath(C){if(S.isAbsolute(C)){const R=this.workspaceContextService.getWorkspace().folders;return R[0]&&R[0].uri.scheme!==I.Schemas.file?[{searchPath:R[0].uri.with({path:C})}]:[{searchPath:n.URI.file(S.normalize(C))}]}if(this.workspaceContextService.getWorkbenchState()===2){const R=this.workspaceContextService.getWorkspace().folders[0].uri;if(C=s(C),C.startsWith("../")||C===".."){const E=S.posix.resolve(R.path,C);return[{searchPath:R.with({path:E})}]}const f=m(C);return[{searchPath:R,pattern:f}]}else{if(C==="./"||C===".\\")return[];{const R=C.replace(/^\.[\/\\]/,""),E=this.workspaceContextService.getWorkspace().folders.map(h=>{const M=R.match(new RegExp(`^${t.escapeRegExpCharacters(h.name)}(?:/(.*)|$)`));return M?{match:M,folder:h}:null}).filter(y.isDefined);if(E.length)return E.map(h=>{const M=h.match[1];return{searchPath:h.folder.uri,pattern:M&&m(M)}});{const h=C.match(/\.[\/\\](.+)[\/\\]?/),M=h?h[1]:C,O=o.localize(0,null,M);throw new Error(O)}}}}resolveOneSearchPathPattern(C,R){const f=C.pattern&&R?`${C.pattern}/${R}`:C.pattern||R,E=[{searchPath:C.searchPath,pattern:f}];return f&&!f.endsWith("**")&&E.push({searchPath:C.searchPath,pattern:f+"/**"}),E}getFolderQueryForSearchPath(C,R,f){const E=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(C.searchPath),R,f,!1);return E?{...E,includePattern:C.pattern}:null}getFolderQueryForRoot(C,R,f,E){let h;const M=n.URI.isUri(C)?C:C.uri;if(f.searchPaths){const z=f.searchPaths.filter(N=>(0,P.isEqual)(N.searchPath,M))[0];if(z&&!z.pattern)return null;z&&(h=z.pattern)}const O=this.configurationService.getValue({resource:M}),Q={...this.getExcludesForFolder(O,R)||{},...h||{}},$=n.URI.isUri(C)?(0,P.basename)(C):C.name;return{folder:M,folderName:E?$:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof R.disregardIgnoreFiles=="boolean"?R.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof R.disregardGlobalIgnoreFiles=="boolean"?R.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof R.ignoreSymlinks=="boolean"?R.ignoreSymlinks:!O.search.followSymlinks}}};p=Be([ze(0,a.IConfigurationService),ze(1,g.IWorkspaceContextService),ze(2,k.IEditorGroupsService),ze(3,b.IPathService)],p),e.QueryBuilder=p;function D(w){const C=w.match(/[\*\{\}\(\)\[\]\?]/);if(C){const R=C.index,f=w.substr(0,R).match(/[/|\\][^/\\]*$/);if(f){let E=w.substr(0,f.index);return E.match(/[/\\]/)||(E+="/"),{pathPortion:E,globPortion:w.substr((f.index||0)+1)}}}return{pathPortion:w}}function i(...w){return w.length?w.reduce((C,R)=>(C[R]=!0,C),Object.create(null)):void 0}function r(w){return _.splitGlobAware(w,",").map(C=>C.trim()).filter(C=>!!C.length)}function l(w){return[`**/${w}/**`,`**/${w}`].map(R=>R.replace(/\*\*\/\*\*/g,"**"))}function s(w){return w.replace(/\\/g,"/")}function m(w){return s(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(w,C){w=c.distinct(w,E=>E.toString());const R=[],f=C.getWorkspace();return w&&w.forEach(E=>{let h;if(C.getWorkbenchState()===2)h=(0,P.relativePath)(f.folders[0].uri,E),h&&h!=="."&&(h="./"+h);else{const M=C.getWorkspaceFolder(E);if(M){const O=M.name;if(f.folders.filter(Q=>Q.name===O).length===1){const Q=(0,P.relativePath)(M.uri,E);Q===""?h=`./${M.name}`:h=`./${M.name}/${Q}`}else h=E.fsPath}}h&&R.push(h)}),R}e.resolveResourcesForSearchIncludes=v}),define(ve[218],we([0,1,24,2,21,15,4,217,38,44]),function(ne,e,c,F,_,A,T,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function y(a,g){const k=g.activationEvents;if(!k)return Promise.resolve(void 0);const b=[],u=[];for(const s of k)if(/^workspaceContains:/.test(s)){const m=s.substr("workspaceContains:".length);m.indexOf("*")>=0||m.indexOf("?")>=0||a.forceUsingSearch?u.push(m):b.push(m)}if(b.length===0&&u.length===0)return Promise.resolve(void 0);let p;const D=new Promise((s,m)=>{p=s}),i=s=>p({activationEvent:s}),r=Promise.all(b.map(s=>n(a,s,i))).then(()=>{}),l=d(a,g.identifier,u,i);return Promise.all([r,l]).then(()=>{p(void 0)}),D}e.checkActivateWorkspaceContainsExtension=y;async function n(a,g,k){for(const b of a.folders)if(await a.exists(c.joinPath(F.URI.revive(b),g))){k(`workspaceContains:${g}`);return}}async function d(a,g,k,b){if(k.length===0)return Promise.resolve(void 0);const u=new _.CancellationTokenSource,p=a.checkExists(a.folders,k,u.token),D=setTimeout(async()=>{u.cancel(),b(`workspaceContainsTimeout:${k.join(",")}`)},t);let i=!1;try{i=await p}catch(r){A.isPromiseCanceledError(r)||A.onUnexpectedError(r)}u.dispose(),clearTimeout(D),i&&b(`workspaceContains:${k.join(",")}`)}function o(a,g,k,b){const u=a.get(T.IInstantiationService),p=a.get(S.ISearchService),i=u.createInstance(I.QueryBuilder).file(g.map(r=>(0,P.toWorkspaceFolder)(F.URI.revive(r))),{_reason:"checkExists",includePattern:k,exists:!0});return p.fileSearch(i,b).then(r=>!!r.limitHit,r=>A.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=o});var et=this&&this.__classPrivateFieldSet||function(ne,e,c,F,_){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!_:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?_.call(ne,c):_?_.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!F:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(ne):F?F.value:e.get(ne)};define(ve[33],we([0,1,122,17,75,24,13,7,20,2,14,5,32,178,73,31,30,176,15,26,23,152,6,86,4,29,74,12,60,66,37,3,218,70,154]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b,u,p,D,i,r,l,s,m,v,w,C,R,f,E,h,M){"use strict";var O,q,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let $=class Wi extends I.Disposable{constructor(j,Y,de,G,ue,oe,be,Ae,Re,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new f.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=de,this._initData=be,this._extHostWorkspace=G,this._extHostConfiguration=ue,this._logService=oe,this._extHostTunnelService=Re,this._extHostTerminalService=Oe,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new k.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new h.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=j.createChild(new w.ServiceCollection([o.IExtHostStorage,this._storage],[h.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(He=>Qe.add(u.ExtensionIdentifier.toKey(He))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,je,U)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(je),U)},actualActivateExtension:async(He,je)=>{if(Qe.has(u.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,je),new d.HostExtension;const U=this._registry.getExtensionDescription(He);return this._activateExtension(U,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){b.onUnexpectedError(j)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._registry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch(Y){}await Promise.all(j)}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}_activateByEvent(j,Y){return this._activator.activateByEvent(j,Y)}_activateById(j,Y){return this._activator.activateById(j,Y)}activateByIdWithErrors(j,Y){return this._activateById(j,Y).then(()=>{const de=this._activator.getActivatedExtension(j);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._registry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const j=S.TernarySearchTree.forPaths(),Y=this._registry.getAllExtensionDescriptions().map(de=>{if(!!this._getEntryPoint(de))return this._hostUtils.realpath(de.extensionLocation.fsPath).then(G=>j.set(P.URI.file(G).fsPath,de))});this._extensionPathIndex=Promise.all(Y).then(()=>j)}return this._extensionPathIndex}_deactivate(j){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return Y;const de=this._activator.getActivatedExtension(j);if(!de)return Y;try{typeof de.module.deactivate=="function"&&(Y=Promise.resolve(de.module.deactivate()).then(void 0,G=>(this._logService.error(G),Promise.resolve(void 0))))}catch(G){this._logService.error(G)}try{(0,I.dispose)(de.subscriptions)}catch(G){this._logService.error(G)}return Y}async _activateExtension(j,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,Y).then(de=>{const G=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,G.codeLoadingTime,G.activateCallTime,G.activateResolvedTime,Y),this._logExtensionActivationTimes(j,Y,"success",G),de},de=>{throw this._logExtensionActivationTimes(j,Y,"failure"),de})}_logExtensionActivationTimes(j,Y,de,G){const ue=z(j,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...G||{},outcome:de})}_doActivateExtension(j,Y){const de=z(j,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const G=this._getEntryPoint(j);if(!G)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value} ${JSON.stringify(Y)}`),this._logService.flush();const ue=new d.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(j.identifier,(0,A.joinPath)(j.extensionLocation,G),ue),this._loadExtensionContext(j)]).then(oe=>(_.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),Wi._callActivate(this._logService,j.identifier,oe[0],oe[1],ue))).then(oe=>(_.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),oe))}_loadExtensionContext(j){const Y=new D.ExtensionGlobalMemento(j,this._storage),de=new D.ExtensionMemento(j.identifier.value,!1,this._storage),G=new M.ExtensionSecrets(j,this._secretState),ue=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,oe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([Y.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Ae;return Object.freeze({globalState:Y,workspaceState:de,secrets:G,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(Re){return F.join(j.extensionLocation.fsPath,Re)},get storagePath(){return be._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return be._storagePath.globalValue(j).fsPath},get logPath(){return F.join(be._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return P.URI.joinPath(be._initData.logsLocation,j.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(j)},get globalStorageUri(){return be._storagePath.globalValue(j)},get extensionMode(){return ue},get extension(){return Ae===void 0&&(Ae=new N(be,j.identifier,j,oe)),Ae},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(j),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(j)}})})}static _callActivate(j,Y,de,G,ue){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,Y,de,G,ue).then(oe=>new d.ActivatedExtension(!1,null,ue.build(),de,oe,G.subscriptions))}static _callActivateOptional(j,Y,de,G,ue){if(typeof de.activate=="function")try{ue.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const oe=typeof global=="object"?global:self,be=de.activate.apply(oe,[G]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(be).then(Ae=>(ue.activateResolveStop(),Ae))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(de)}_activateOneStartupFinished(j,Y){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:Y}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const j of this._registry.getAllExtensionDescriptions())if(j.activationEvents)for(const Y of j.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(j,Y)}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,ue=>{this._logService.error(ue)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ue=>this._handleWorkspaceContainsEagerExtensions(ue.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(Y),G=Promise.all([j,de]).then(()=>{});return Promise.race([G,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),G}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(j,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,Y){if(this.isActivated(Y.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,G={folders:j.map(oe=>oe.uri),forceUsingSearch:de,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,be,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(oe,be,Ae)},ue=await(0,E.checkActivateWorkspaceContainsExtension)(G,Y);if(!!ue)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:ue.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:Y}=this._initData.environment;if(!j||!Y)throw new Error(c.localize(0,null));const de=await this._loadCommonJSModule(null,Y,new d.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(c.localize(1,null,Y.toString()));return new Promise((G,ue)=>{const oe=(Re,Oe)=>{Re?ue(Re):G(typeof Oe=="number"&&Oe>0?1:0)},be=(0,A.originalFSPath)(Y),Ae=de.run(be,oe);Ae&&Ae.then&&Ae.then(()=>{G(0)}).catch(Re=>{ue(Re.toString())})})}async $extensionTestsExit(j){this._logService.info(`extension host terminating: test runner requested exit with code ${j}`),this._logService.info(`exiting with code ${j}`),this._logService.flush(),this._hostUtils.exit(j)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(j,Y){return this._resolvers[j]=Y,(0,I.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const Y=j.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const de=j.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(j,Y){const{authorityPrefix:de,resolver:G}=await this._activateAndGetResolver(j);if(!G)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(G)),_.mark(`code/extHost/willResolveAuthority/${de}`);const ue=await G.resolve(j,{resolveAttempt:Y});_.mark(`code/extHost/didResolveAuthorityOK/${de}`);const oe={authority:j,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},be={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted};return{type:"ok",value:{authority:oe,options:be,tunnelInformation:{environmentTunnels:ue.environmentTunnels}}}}catch(ue){if(_.mark(`code/extHost/didResolveAuthorityError/${de}`),ue instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(j,Y){const{authorityPrefix:de,resolver:G}=await this._activateAndGetResolver(j);if(!G)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const ue=P.URI.revive(Y);if(typeof G.getCanonicalURI=="undefined")return ue;const oe=await(0,T.asPromise)(()=>G.getCanonicalURI(ue));return oe||ue}$startExtensionHost(j){return this._registry.keepOnly(j),this._startExtensionHost()}$activateByEvent(j,Y){return Y===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(j,!1))}async $activate(j,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(j)?(await this._activateById(j,Y),!0):!1}async $deltaExtensions(j,Y){j.forEach(G=>G.extensionLocation=P.URI.revive(G.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(Y.map(async G=>{const ue=this._registry.getExtensionDescription(G);if(!ue)return;const oe=await this._hostUtils.realpath(ue.extensionLocation.fsPath);de.delete(P.URI.file(oe).fsPath)})),await Promise.all(j.map(async G=>{const ue=await this._hostUtils.realpath(G.extensionLocation.fsPath);de.set(P.URI.file(ue).fsPath,G)})),this._registry.deltaExtensions(j,Y),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){let Y=p.VSBuffer.alloc(j),de=Math.random()%256;for(let G=0;G<j;G++)Y.writeUInt8(de,G);return Y}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};$=Be([ze(0,l.IInstantiationService),ze(1,e.IHostUtils),ze(2,v.IExtHostRpcService),ze(3,a.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,s.IExtHostInitDataService),ze(7,m.IExtensionStoragePaths),ze(8,C.IExtHostTunnelService),ze(9,R.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function z(W,j){return{id:W.identifier.value,name:W.name,extensionVersion:W.version,publisherDisplayName:W.publisher,activationEvents:W.activationEvents?W.activationEvents.join(","):null,isBuiltin:W.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class N{constructor(j,Y,de,G){O.set(this,void 0),q.set(this,void 0),Q.set(this,void 0),et(this,O,j,"f"),et(this,q,Y,"f"),et(this,Q,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.normalize((0,A.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=G}get isActive(){return Me(this,O,"f").isActivated(Me(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,O,"f").getExtensionExports(Me(this,Q,"f"))}activate(){return Me(this,O,"f").activateByIdWithErrors(Me(this,Q,"f"),{startup:!1,extensionId:Me(this,q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,O=new WeakMap,q=new WeakMap,Q=new WeakMap}),define(ve[100],we([0,1,17,2,3,13,5,6,162,31,33,48,167,32,163,12,4,10,61,64]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let p=class{constructor(w,C,R,f,E,h){this._workspaceService=C,this._extensionService=R,this._editorsService=f,this._configurationService=E,this._editorTabs=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=w.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(O=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(w,C){const R=w;if(typeof R.sourceReference=="number"&&R.sourceReference>0){let f=`debug:${encodeURIComponent(R.path||"")}`,E="?";return C&&(f+=`${E}session=${encodeURIComponent(C.id)}`,E="&"),f+=`${E}ref=${R.sourceReference}`,F.URI.parse(f)}else{if(R.path)return F.URI.file(R.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(w){const C=[];for(const R of w.getAllExtensionDescriptions())if(R.contributes){const f=R.contributes.debuggers;if(f&&f.length>0)for(const E of f)(0,o.isDebuggerMainContribution)(E)&&C.push(E.type)}this._debugServiceProxy.$registerDebugTypes(C)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const w=[];return this._breakpoints.forEach(C=>w.push(C)),w}addBreakpoints(w){this.startBreakpoints();const C=w.filter(E=>{const h=E.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,E),!0)});this.fireBreakpointChanges(C,[],[]);const R=[],f=new Map;for(const E of C)if(E instanceof I.SourceBreakpoint){let h=f.get(E.location.uri.toString());h||(h={type:"sourceMulti",uri:E.location.uri,lines:[]},f.set(E.location.uri.toString(),h),R.push(h)),h.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character})}else E instanceof I.FunctionBreakpoint&&R.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName});return this._debugServiceProxy.$registerBreakpoints(R)}removeBreakpoints(w){this.startBreakpoints();const C=w.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],C,[]);const R=C.filter(h=>h instanceof I.SourceBreakpoint).map(h=>h.id),f=C.filter(h=>h instanceof I.FunctionBreakpoint).map(h=>h.id),E=C.filter(h=>h instanceof I.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(R,f,E)}startDebugging(w,C,R){return this._debugServiceProxy.$startDebugging(w?w.uri:void 0,C,{parentSessionID:R.parentSession?R.parentSession.id:void 0,lifecycleManagedByParent:R.lifecycleManagedByParent,repl:R.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:R.noDebug,compact:R.compact,debugUI:R.debugUI})}stopDebugging(w){return this._debugServiceProxy.$stopDebugging(w?w.id:void 0)}registerDebugConfigurationProvider(w,C,R){if(!C)return new I.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:w,handle:f,provider:C}),this._debugServiceProxy.$registerDebugConfigurationProvider(w,R,!!C.provideDebugConfigurations,!!C.resolveDebugConfiguration,!!C.resolveDebugConfigurationWithSubstitutedVariables,f),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(E=>E.provider!==C),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(w,C,R){if(!R)return new I.Disposable(()=>{});if(!this.definesDebugType(w,C))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${C}' debugger.`);if(this.getAdapterDescriptorFactoryByType(C))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:C,handle:f,factory:R}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(C,f),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(E=>E.factory!==R),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(w,C){if(!C)return new I.Disposable(()=>{});const R=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:w,handle:R,factory:C}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==C)})}async $runInTerminal(w,C){return Promise.resolve(void 0)}async $substituteVariables(w,C){if(!this._variableResolver){const[E,h]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(E||[],this._editorsService,h)}let R;const f=await this.getFolder(w);return f&&(R={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(R,C)}createDebugAdapter(w,C){if(w.type==="implementation")return new s(w.implementation)}createSignService(){}async $startDASession(w,C){const R=this,f=await this.getSession(C);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const h=this.convertToDto(E),M=this.createDebugAdapter(h,f);if(!M)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const O=M;return this._debugAdapters.set(w,O),this.getDebugAdapterTrackers(f).then(q=>(q&&this._debugAdaptersTrackers.set(w,q),O.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const $=Q,z={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign($.arguments.value);z.body={signature:N},O.sendResponse(z)}else throw new Error("no signer")}catch(N){z.success=!1,z.message=N.message,O.sendResponse(z)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(Q),Q=(0,o.convertToVSCPaths)(Q,!0),R._debugServiceProxy.$acceptDAMessage(w,Q)}),O.onError(Q=>{q&&q.onError&&q.onError(Q),this._debugServiceProxy.$acceptDAError(w,Q.name,Q.message,Q.stack)}),O.onExit(Q=>{q&&q.onExit&&q.onExit((0,k.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(w,(0,k.withNullAsUndefined)(Q),void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),O.startSession()))})}$sendDAMessage(w,C){C=(0,o.convertToDAPaths)(C,!1);const R=this._debugAdaptersTrackers.get(w);R&&R.onWillReceiveMessage&&R.onWillReceiveMessage(C);const f=this._debugAdapters.get(w);f&&f.sendMessage(C)}$stopDASession(w){const C=this._debugAdaptersTrackers.get(w);this._debugAdaptersTrackers.delete(w),C&&C.onWillStopSession&&C.onWillStopSession();const R=this._debugAdapters.get(w);return this._debugAdapters.delete(w),R?R.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(w){const C=[],R=[],f=[];if(w.added)for(const E of w.added){const h=E.id;if(h&&!this._breakpoints.has(h)){let M;if(E.type==="function")M=new I.FunctionBreakpoint(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage);else if(E.type==="data")M=new I.DataBreakpoint(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage);else{const O=F.URI.revive(E.uri);M=new I.SourceBreakpoint(new I.Location(O,new I.Position(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage)}M._id=h,this._breakpoints.set(h,M),C.push(M)}}if(w.removed)for(const E of w.removed){const h=this._breakpoints.get(E);h&&(this._breakpoints.delete(E),R.push(h))}if(w.changed){for(const E of w.changed)if(E.id){const h=this._breakpoints.get(E.id);if(h){if(h instanceof I.FunctionBreakpoint&&E.type==="function"){const M=h;M.enabled=E.enabled,M.condition=E.condition,M.hitCondition=E.hitCondition,M.logMessage=E.logMessage,M.functionName=E.functionName}else if(h instanceof I.SourceBreakpoint&&E.type==="source"){const M=h;M.enabled=E.enabled,M.condition=E.condition,M.hitCondition=E.hitCondition,M.logMessage=E.logMessage,M.location=new I.Location(F.URI.revive(E.uri),new I.Position(E.line,E.character))}f.push(h)}}}this.fireBreakpointChanges(C,R,f)}$provideDebugConfigurations(w,C,R){return(0,A.asPromise)(async()=>{const f=this.getConfigProviderByHandle(w);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.getFolder(C);return f.provideDebugConfigurations(E,R)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(w,C,R,f){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(w);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(C);return E.resolveDebugConfiguration(h,R,f)})}$resolveDebugConfigurationWithSubstitutedVariables(w,C,R,f){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(w);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(C);return E.resolveDebugConfigurationWithSubstitutedVariables(h,R,f)})}async $provideDebugAdapter(w,C){const R=this.getAdapterDescriptorFactoryByHandle(w);if(!R)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(C);return this.getAdapterDescriptor(R,f).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(E)})}async $acceptDebugSessionStarted(w){const C=await this.getSession(w);this._onDidStartDebugSession.fire(C)}async $acceptDebugSessionTerminated(w){const C=await this.getSession(w);C&&(this._onDidTerminateDebugSession.fire(C),this._debugSessions.delete(C.id))}async $acceptDebugSessionActiveChanged(w){this._activeDebugSession=w?await this.getSession(w):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(w,C){const R=await this.getSession(w);R&&R._acceptNameChanged(C)}async $acceptDebugSessionCustomEvent(w,C){const f={session:await this.getSession(w),event:C.event,body:C.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(w){if(w instanceof I.DebugAdapterExecutable)return{type:"executable",command:w.command,args:w.args,options:w.options};if(w instanceof I.DebugAdapterServer)return{type:"server",port:w.port,host:w.host};if(w instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:w.path};if(w instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:w.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(w){const C=this._adapterFactories.filter(R=>R.type===w);if(C.length>0)return C[0].factory}getAdapterDescriptorFactoryByHandle(w){const C=this._adapterFactories.filter(R=>R.handle===w);if(C.length>0)return C[0].factory}getConfigProviderByHandle(w){const C=this._configProviders.filter(R=>R.handle===w);if(C.length>0)return C[0].provider}definesDebugType(w,C){if(w.contributes){const R=w.contributes.debuggers;if(R&&R.length>0){for(const f of R)if(f.label&&f.type&&f.type===C)return!0}}return!1}getDebugAdapterTrackers(w){const R=w.configuration.type,f=this._trackerFactories.filter(E=>E.type===R||E.type==="*").map(E=>(0,A.asPromise)(()=>E.factory.createDebugAdapterTracker(w)).then(h=>h,h=>null));return Promise.race([Promise.all(f).then(E=>{const h=E.filter(M=>!!M);if(h.length>0)return new l(h)}),new Promise((E,h)=>{const M=setTimeout(()=>{clearTimeout(M),h(new Error("timeout"))},1e3)})]).catch(E=>{})}async getAdapterDescriptor(w,C){const R=C.configuration.debugServer;if(typeof R=="number")return Promise.resolve(new I.DebugAdapterServer(R));if(w){const E=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>w.createDebugAdapterDescriptor(C,this.daExecutableFromPackage(C,E))).then(h=>{if(h)return h})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(C,f))}daExecutableFromPackage(w,C){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(w,C,R){(w.length>0||C.length>0||R.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:w,removed:C,changed:R}))}async getSession(w){if(w)if(typeof w=="string"){const C=this._debugSessions.get(w);if(C)return C}else{let C=this._debugSessions.get(w.id);if(!C){const R=await this.getFolder(w.folderUri),f=w.parent?this._debugSessions.get(w.parent):void 0;C=new D(this._debugServiceProxy,w.id,w.type,w.name,R,w.configuration,f),this._debugSessions.set(C.id,C),this._debugServiceProxy.$sessionCached(C.id)}return C}throw new Error("cannot find session")}getFolder(w){if(w){const C=F.URI.revive(w);return this._workspaceService.resolveWorkspaceFolder(C)}return Promise.resolve(void 0)}};p=Be([ze(0,a.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,d.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class D{constructor(w,C,R,f,E,h,M){this._debugServiceProxy=w,this._id=C,this._type=R,this._name=f,this._workspaceFolder=E,this._configuration=h,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(w){this._name=w,this._debugServiceProxy.$setDebugSessionName(this._id,w)}get parentSession(){return this._parentSession}_acceptNameChanged(w){this._name=w}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(w,C){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,w,C)}getDebugProtocolBreakpoint(w){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,w.id)}}e.ExtHostDebugSession=D;class i{constructor(w){this.value=Object.freeze({append(C){w.$appendDebugConsole(C)},appendLine(C){this.append(C+`
`)}})}}e.ExtHostDebugConsole=i;class r extends n.AbstractVariableResolverService{constructor(w,C,R,f,E){function h(){if(C){const M=C.activeEditor();if(M)return M.document.uri;const O=f.tabs.filter(q=>q.isActive);if(O.length>0)return O[0].resource}}super({getFolderUri:M=>{const O=w.filter(q=>q.name===M);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>w.length,getConfigurationValue:(M,O)=>R.getConfiguration(void 0,M).get(O),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const M=h();if(M)return c.normalize(M.fsPath)},getWorkspaceFolderPathForFile:()=>{if(E){const M=h();if(M){const O=E.getWorkspaceFolder(M);if(O)return c.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(C){const M=C.activeEditor();if(M&&!M.selection.isEmpty)return M.document.getText(M.selection)}},getLineNumber:()=>{if(C){const M=C.activeEditor();if(M)return String(M.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=r;class l{constructor(w){this.trackers=w}onWillStartSession(){this.trackers.forEach(w=>w.onWillStartSession?w.onWillStartSession():void 0)}onWillReceiveMessage(w){this.trackers.forEach(C=>C.onWillReceiveMessage?C.onWillReceiveMessage(w):void 0)}onDidSendMessage(w){this.trackers.forEach(C=>C.onDidSendMessage?C.onDidSendMessage(w):void 0)}onWillStopSession(){this.trackers.forEach(w=>w.onWillStopSession?w.onWillStopSession():void 0)}onError(w){this.trackers.forEach(C=>C.onError?C.onError(w):void 0)}onExit(w,C){this.trackers.forEach(R=>R.onExit?R.onExit(w,C):void 0)}}class s extends S.AbstractDebugAdapter{constructor(w){super();this.implementation=w,w.onDidSendMessage(C=>{this.acceptMessage(C)})}startSession(){return Promise.resolve(void 0)}sendMessage(w){this.implementation.handleMessage(w)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let m=class extends p{constructor(w,C,R,f,E,h){super(w,C,R,f,E,h)}createVariableResolver(w,C,R){return new r(w,C,R,this._editorTabs)}};m=Be([ze(0,a.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,d.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],m),e.WorkerExtHostDebugService=m}),define(ve[219],we([0,1,75,2,5,32,30,26,12,29,4,33,61,14]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(u,p,D,i,r,l,s){this._apiFactory=u,this._extensionRegistry=p,this._instaService=D,this._extHostConfiguration=i,this._extHostExtensionService=r,this._initData=l,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,p,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(k,p,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let p of u.nodeModuleName)this._factories.set(p,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(p=>u.alternativeModuleName(p))}};o=Be([ze(2,t.IInstantiationService),ze(3,A.IExtHostConfiguration),ze(4,y.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,d.ILogService)],o),e.RequireInterceptor=o;class a{constructor(u,p,D,i,r){this._apiFactory=u,this._extensionPaths=p,this._extensionRegistry=D,this._configProvider=i,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,p){const D=this._extensionPaths.findSubstr(p.fsPath);if(D){let i=this._extApiImpl.get(I.ExtensionIdentifier.toKey(D.identifier));return i||(i=this._apiFactory(D,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(D.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((r,l)=>i+=`	${l} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(u,p){this.nodeModuleName="keytar";const{environment:D}=p,i=u.getProxy(_.MainContext.MainThreadKeytar);if(D.appRoot){let r=D.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,l)=>i.$getPassword(r,l),setPassword:(r,l,s)=>i.$setPassword(r,l,s),deletePassword:(r,l)=>i.$deletePassword(r,l),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(u,p){return this._impl}alternativeModuleName(u){const p=u.length;if(p<=7||!this.alternativeNames)return;const D=p-7;if((u.charAt(D)==="/"||u.charAt(D)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};g=Be([ze(0,S.IExtHostRpcService),ze(1,P.IExtHostInitDataService)],g);let k=class{constructor(u,p,D){this._extensionPaths=u,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=D.getProxy(_.MainContext.MainThreadTelemetry);const i=D.getProxy(_.MainContext.MainThreadWindow);this._impl=(r,l)=>{const s=F.URI.parse(r);return l?this.callOriginal(r,l):s.scheme==="http"||s.scheme==="https"?i.$openUri(s,r,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?i.$openUri(s,r,{}):this.callOriginal(r,l)}}load(u,p,D){const i=this._extensionPaths.findSubstr(p.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=D(u),this._impl}callOriginal(u,p){return this.sendNoForwardTelemetry(),this._original(u,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};k=Be([ze(2,S.IExtHostRpcService)],k)}),define(ve[220],we([0,1,13,15,75,7,2,5,213,14,56,60,29,141,12,67,33,37]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(p,D,i,r){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new S.RPCProtocol(p,null,r),D=b._transform(D,this._rpcProtocol);const l=new y.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());l.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...D}),l.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),l.set(a.IURITransformerService,new a.URITransformerService(r)),l.set(g.IHostUtils,i);const s=new d.InstantiationService(l,!0),m=s.invokeFunction(R=>R.get(k.IExtHostTerminalService));this._disposables.add(m),this._logService=s.invokeFunction(R=>R.get(P.ILogService)),_.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",D),this._extensionService=s.invokeFunction(R=>R.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(R=>{Error.prepareStackTrace=(f,E)=>{let h="",M,O;for(const q of E)h+=`
	at ${q.toString()}`,O=q.getFileName(),!M&&O&&(M=R.findSubstr(O));return v.set(f,M),`${f.name||"Error"}: ${f.message||""}${h}`}});const w=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),C=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(R=>{const f=F.transformErrorForSerialization(R),E=v.get(R);E?w.$onExtensionRuntimeError(E.identifier,f):C.$onUnexpectedError(f)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const D=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,c.timeout)(4e3),D]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(p,D){p.extensions.forEach(r=>r.extensionLocation=T.URI.revive(D.transformIncomingURIs(r.extensionLocation))),p.environment.appRoot=T.URI.revive(D.transformIncomingURIs(p.environment.appRoot));const i=p.environment.extensionDevelopmentLocationURI;return i&&(p.environment.extensionDevelopmentLocationURI=i.map(r=>T.URI.revive(D.transformIncomingURIs(r)))),p.environment.extensionTestsLocationURI=T.URI.revive(D.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=T.URI.revive(D.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=T.URI.revive(D.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=T.URI.revive(D.transformIncomingURIs(p.logsLocation)),p.logFile=T.URI.revive(D.transformIncomingURIs(p.logFile)),p.workspace=D.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=b}),define(ve[221],we([0,1,17,21,55,27,24,194,38]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,d,o){this.config=n,this.provider=d,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const d=this.config.folderQueries||[];return new Promise((o,a)=>{const g=k=>{this.resultCount++,n(k)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(k=>{const b=k.toString(),u=c.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,u)||this.matchFile(g,{base:k,basename:u})}),Promise.all(d.map(k=>this.searchInFolder(k,g))).then(k=>{o({limitHit:this.isLimitHit,stats:k[0]||void 0})},k=>{a(new Error((0,_.toErrorMessage)(k)))})})}async searchInFolder(n,d){const o=new F.CancellationTokenSource,a=this.getSearchOptionsForFolder(n),g=this.initDirectoryTree(),k=new S.QueryGlobTester(this.config,n),b=!k.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(o),u=I.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,o.token),D=u.elapsed(),i=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(r=>{const l=c.posix.relative(n.folder.path,r.path);if(b){const s=c.basename(r.path);this.matchFile(d,{base:n.folder,relativePath:l,basename:s});return}this.addDirectoryEntries(g,n.folder,l,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,k,d),{providerTime:D,postProcessTime:i.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const d=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:d,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},d,o,a){if(o===this.filePattern){const k=c.basename(this.filePattern);this.matchFile(a,{base:d,relativePath:this.filePattern,basename:k})}function g(k){const b=c.basename(k),u=c.dirname(k);let p=n[u];p||(p=n[u]=[],g(u)),p.push({base:d,relativePath:k,basename:b})}g(o)}matchDirectoryTree({rootEntries:n,pathToEntries:d},o,a){const g=this,k=this.filePattern;function b(u){const p=A.hasSiblingFn(()=>u.map(D=>D.basename));for(let D=0,i=u.length;D<i;D++){const r=u[D],{relativePath:l,basename:s}=r;if(!o.includedInQuerySync(l,s,k!==s?p:void 0))continue;const m=d[l];if(m)b(m);else{if(l===k)continue;g.matchFile(a,r)}if(g.isLimitHit)break}}b(n)}matchFile(n,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(d))}}class t{constructor(){this.sessions=new Map}fileSearch(n,d,o,a){const g=this.getSessionTokenSource(n.cacheKey),k=new P(n,d,g&&g.token);let b=0;const u=p=>{b+=p.length,o(p.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(k,t.BATCH_SIZE,u,a).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:p.stats}}))}clearCache(n){const d=this.getSessionTokenSource(n);d&&d.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new F.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:T.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,d,o,a){a.onCancellationRequested(()=>{n.cancel()});const g=b=>{b&&(k.push(b),d>0&&k.length>=d&&(o(k),k=[]))};let k=[];return n.search(g).then(b=>(k.length&&o(k),b),b=>(k.length&&o(k),Promise.reject(b)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(ve[222],we([0,1,16,21,55,27,11,17,24,10,2,38]),function(ne,e,c,F,_,A,T,I,S,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(u,p,D,i){this.query=u,this.provider=p,this.fileUtils=D,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,p){const D=this.query.folderQueries||[],i=new F.CancellationTokenSource;return p.onCancellationRequested(()=>i.cancel()),new Promise((r,l)=>{this.collector=new o(u);let s=!1;const m=(v,w)=>{if(!s&&!this.isLimitHit){const C=this.resultSize(v);g(v)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,s=!0,i.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const R=this.resultSize(v);this.resultCount+=R,(R>0||!g(v))&&this.collector.add(v,w)}};Promise.all(D.map((v,w)=>this.searchInFolder(v,C=>m(C,w),i.token))).then(v=>{i.dispose(),this.collector.flush();const w=v.some(C=>!!C&&!!C.limitHit);r({limitHit:this.isLimitHit||w,messages:(0,c.flatten)(v.map(C=>C?.message?(0,P.isArray)(C.message)?C.message:[C.message]:[])),stats:{type:this.processType}})},v=>{i.dispose();const w=(0,_.toErrorMessage)(v);l(new Error(w))})})}resultSize(u){return g(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,p){const D=Array.isArray(u.ranges)?u.ranges:[u.ranges],i=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:D.slice(0,p),preview:{matches:i.slice(0,p),text:u.preview.text},uri:u.uri}}async searchInFolder(u,p,D){const i=new y.QueryGlobTester(this.query,u),r=[],l={report:v=>{if(!this.validateProviderResult(v))return;const w=u.folder.scheme===T.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(v.uri))):void 0,C=S.relativePath(u.folder,v.uri);if(C){const R=i.includedInQuery(C,I.basename(C),w);(0,P.isPromise)(R)?r.push(R.then(f=>{f&&p(v)})):R&&p(v)}}},s=this.getSearchOptionsForFolder(u),m=await this.provider.provideTextSearchResults(d(this.query.contentPattern),s,l,D);return r.length&&await Promise.all(r),m}validateProviderResult(u){if(g(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const p=(0,y.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),D=(0,y.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),i={folder:t.URI.from(u.folder),excludes:D,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function d(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class o{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,p=>this.sendItems(p))}add(u,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!S.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(a(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=o;function a(b){return g(b)?{preview:{matches:(0,c.mapArrayOrNot)(b.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:b.preview.text},ranges:(0,c.mapArrayOrNot)(b.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function g(b){return!!b.preview}e.extensionResultIsMatch=g;class k{constructor(u,p){this.maxBatchSize=u,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,p){!u||this.addItemToBatch(u,p)}addItems(u,p){!u||this.addItemsToBatch(u,p)}addItemToBatch(u,p){this.batch.push(u),this.batchSize+=p,this.onUpdate()}addItemsToBatch(u,p){this.batch=this.batch.concat(u),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(ve[101],we([0,1,7,5,4,221,12,67,14,2,222]),function(ne,e,c,F,_,A,T,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let y=class{constructor(a,g,k){this.extHostRpc=a,this._uriTransformer=g,this._logService=k,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,g){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const k=this._handlePool++;return this._textSearchProvider.set(k,g),this._proxy.$registerTextSearchProvider(k,this._transformScheme(a)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}registerFileSearchProvider(a,g){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const k=this._handlePool++;return this._fileSearchProvider.set(k,g),this._proxy.$registerFileSearchProvider(k,this._transformScheme(a)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}$provideFileSearchResults(a,g,k,b){const u=n(k),p=this._fileSearchProvider.get(a);if(p)return this._fileSearchManager.fileSearch(u,p,D=>{this._proxy.$handleFileMatch(a,g,D.map(i=>i.resource))},b);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,g,k,b){const u=this._textSearchProvider.get(a);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const p=n(k);return this.createTextSearchManager(p,u).search(i=>this._proxy.$handleTextMatch(a,g,i),b)}$enableExtensionHostSearch(){}createTextSearchManager(a,g){return new t.TextSearchManager(a,g,{readdir:k=>Promise.resolve([]),toCanonicalName:k=>k},"textSearchProvider")}};y=Be([ze(0,T.IExtHostRpcService),ze(1,I.IURITransformerService),ze(2,S.ILogService)],y),e.ExtHostSearch=y;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(d),extraFileResources:o.extraFileResources&&o.extraFileResources.map(a=>P.URI.revive(a))}}e.reviveQuery=n;function d(o){return{...o,folder:P.URI.revive(o.folder)}}}),define(ve[223],we([0,1,21,15,3,35,2,145,80,112,54,59,5,183,182,47,184,32,185,186,187,169,188,48,33,190,170,193,195,196,96,172,201,202,203,73,37,205,173,8,6,208,49,97,31,30,50,159,192,87,95,99,100,101,14,67,12,29,197,156,66,71,180,206,155,74,72,211,209,210,181,45,204,207,70,64,88,199,98,200,11,143,198,153,191]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b,u,p,D,i,r,l,s,m,v,w,C,R,f,E,h,M,O,q,Q,$,z,N,W,j,Y,de,G,ue,oe,be,Ae,Re,Oe,Qe,He,je,U,K,ee,ae,V,se,he,Te,Ue,$e,Ke,_e,rt,H,J,me,Ne,Ye,tt,at,vt,kt,ht,yt,It,ft,Je,Et,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(Z){const le=Z.get(ee.IExtHostInitDataService),ge=Z.get(Ne.IExtHostFileSystemInfo),fe=Z.get(_e.IExtHostConsumerFileSystem),Ie=Z.get(l.IExtHostExtensionService),xe=Z.get(de.IExtHostWorkspace),Le=Z.get(kt.IExtHostTelemetry),Ve=Z.get(k.IExtHostConfiguration),Xe=Z.get(U.IURITransformerService),ie=Z.get(K.IExtHostRpcService),pe=Z.get(O.IExtHostStorage),re=Z.get(Ke.IExtensionStoragePaths),B=Z.get(je.ILogService),Ce=Z.get(se.IExtHostTunnelService),Se=Z.get(he.IExtHostApiDeprecationService),qe=Z.get(Y.IExtHostWindow),We=Z.get(at.IExtHostSecretState),it=Z.get(vt.IExtHostEditorTabs);ie.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ie.set(n.ExtHostContext.ExtHostLogService,B),ie.set(n.ExtHostContext.ExtHostWorkspace,xe),ie.set(n.ExtHostContext.ExtHostConfiguration,Ve),ie.set(n.ExtHostContext.ExtHostExtensionService,Ie),ie.set(n.ExtHostContext.ExtHostStorage,pe),ie.set(n.ExtHostContext.ExtHostTunnelService,Ce),ie.set(n.ExtHostContext.ExtHostWindow,qe),ie.set(n.ExtHostContext.ExtHostSecretState,We),ie.set(n.ExtHostContext.ExtHostTelemetry,Le),ie.set(n.ExtHostContext.ExtHostEditorTabs,it);const mt=ie.set(n.ExtHostContext.ExtHostDecorations,Z.get(Re.IExtHostDecorations)),wt=ie.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(r.IExtHostDocumentsAndEditors)),ot=ie.set(n.ExtHostContext.ExtHostCommands,Z.get(a.IExtHostCommands)),ct=ie.set(n.ExtHostContext.ExtHostTerminalService,Z.get(q.IExtHostTerminalService)),lt=ie.set(n.ExtHostContext.ExtHostDebugService,Z.get(Qe.IExtHostDebugService)),Tt=ie.set(n.ExtHostContext.ExtHostSearch,Z.get(He.IExtHostSearch)),_t=ie.set(n.ExtHostContext.ExtHostTask,Z.get(Oe.IExtHostTask)),Ut=ie.set(n.ExtHostContext.ExtHostOutputService,Z.get(R.IExtHostOutputService)),Bt=ie.set(n.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(ie)),Ct=ie.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ie,wt)),$t=ie.set(n.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(ie,wt,B)),ti=ie.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new D.ExtHostDocumentSaveParticipant(B,Ct,ie.getProxy(n.MainContext.MainThreadBulkEdits))),gt=ie.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(ie,ot,wt,Ct,re)),Yt=ie.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(B,gt)),Ht=ie.set(n.ExtHostContext.ExtHostNotebookEditors,new Et.ExtHostNotebookEditors(B,ie,gt)),ii=ie.set(n.ExtHostContext.ExtHostNotebookKernels,new ht.ExtHostNotebookKernels(ie,le,gt,B)),ni=ie.set(n.ExtHostContext.ExtHostNotebookRenderers,new It.ExtHostNotebookRenderers(ie,gt)),Pt=ie.set(n.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(ie,wt)),Jt=ie.set(n.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(ie.getProxy(n.MainContext.MainThreadTreeViews),ot,B)),vi=ie.set(n.ExtHostContext.ExtHostEditorInsets,new oe.ExtHostEditorInsets(ie.getProxy(n.MainContext.MainThreadEditorInsets),Pt,le)),Wt=ie.set(n.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(ie,B)),dt=ie.set(n.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(ie,Xe,Ct,ot,Wt,B,Se)),ri=ie.set(n.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(ie,dt)),Mt=ie.set(n.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(ie,B,wt)),Vt=ie.set(n.ExtHostContext.ExtHostQuickOpen,(0,E.createExtHostQuickOpen)(ie,xe,ot)),Xt=ie.set(n.ExtHostContext.ExtHostSCM,new h.ExtHostSCM(ie,ot,B)),si=ie.set(n.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(ie,ot,Ct)),ci=ie.set(n.ExtHostContext.ExtHostProgress,new f.ExtHostProgress(ie.getProxy(n.MainContext.MainThreadProgress))),wi=ie.set(n.ExtHostContext.ExtHosLabelService,new be.ExtHostLabelService(ie)),di=ie.set(n.ExtHostContext.ExtHostTheming,new V.ExtHostTheming(ie)),oi=ie.set(n.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(ie)),bi=ie.set(n.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(ie,ot)),jt=ie.set(n.ExtHostContext.ExtHostWebviews,new j.ExtHostWebviews(ie,{remote:le.remote},xe,B,Se)),qt=ie.set(n.ExtHostContext.ExtHostWebviewPanels,new J.ExtHostWebviewPanels(ie,jt,xe)),Ei=ie.set(n.ExtHostContext.ExtHostCustomEditors,new H.ExtHostCustomEditors(ie,Ct,re,jt,qt)),_i=ie.set(n.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(ie,jt)),Gt=ie.set(n.ExtHostContext.ExtHostTesting,new Ye.ExtHostTesting(ie,ot)),yi=ie.set(n.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(ie));ie.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ie,gt,wt,ot));const Zt=(0,ue.values)(n.ExtHostContext);ie.assertRegistered(Zt);const Si=new me.ExtHostBulkEdits(ie,wt),Di=new o.ExtHostClipboard(ie),Kt=new C.ExtHostMessageService(ie,B),hi=new u.ExtHostDialogs(ie),zt=new M.ExtHostStatusBar(ie,ot.converter),Ft=new w.ExtHostLanguages(ie,Ct);return d.ExtHostApiCommands.register(ot),function(Fe,Rt,Qt){const pt=function(){let X=!Fe.isUnderDevelopment;function ce(ke){X||(B.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(nt){if(Array.isArray(nt))nt.forEach(ke);else if(typeof nt=="string")ce(nt);else{const bt=nt;typeof bt.scheme=="undefined"&&ce(nt),!Fe.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,G.throwProposedApiError)(Fe)}return nt}}(),Ci={getSession(X,ce,ke){return ke?.forceNewSession&&(0,G.checkProposedApiEnabled)(Fe),oi.getSession(Fe,X,ce,ke)},get onDidChangeSessions(){return oi.onDidChangeSessions},registerAuthenticationProvider(X,ce,ke,nt){return oi.registerAuthenticationProvider(X,ce,ke,nt)}},ki={registerCommand(X,ce,ke){return ot.registerCommand(!0,X,ce,ke)},registerTextEditorCommand(X,ce,ke){return ot.registerCommand(!0,X,(...nt)=>{const bt=Pt.getActiveTextEditor();if(!bt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(Dt=>{ce.apply(ke,[bt,Dt,...nt])}).then(Dt=>{Dt||B.warn("Edits from command "+X+" were not applied.")},Dt=>{B.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,ce,ke)=>((0,G.checkProposedApiEnabled)(Fe),ot.registerCommand(!0,X,async(...nt)=>{const bt=wt.activeEditor(!0);if(!bt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await Pt.getDiffInformation(bt.id);ce.apply(ke,[Dt,...nt])})),executeCommand(X,...ce){return ot.executeCommand(X,...ce)},getCommands(X=!1){return ot.getCommands(X)}},fi={get machineId(){return le.telemetryInfo.machineId},get sessionId(){return le.telemetryInfo.sessionId},get language(){return le.environment.appLanguage},get appName(){return le.environment.appName},get appRoot(){return le.environment.appRoot?.fsPath??""},get appHost(){return le.environment.appHost},get uriScheme(){return le.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return Le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(le.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return qe.openUri(X,{allowTunneling:!!le.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===le.environment.appUriScheme)return Bt.createAppUri(X);try{return await qe.asExternalUri(X,{allowTunneling:!!le.remote.authority})}catch(ce){if((0,Je.matchesScheme)(X,ft.Schemas.http)||(0,Je.matchesScheme)(X,ft.Schemas.https))return X;throw ce}},get remoteName(){return(0,Ae.getRemoteName)(le.remote.authority)},get uiKind(){return le.uiKind}};le.environment.extensionTestsLocationURI||Object.freeze(fi);const mi=le.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Ii={createTestController(X,ce){return Gt.createTestController(X,ce)},createTestObserver(){return(0,G.checkProposedApiEnabled)(Fe),Gt.createTestObserver()},runTests(X){return(0,G.checkProposedApiEnabled)(Fe),Gt.runTests(X)},get onDidChangeTestResults(){return(0,G.checkProposedApiEnabled)(Fe),Gt.onResultsChanged},get testResults(){return(0,G.checkProposedApiEnabled)(Fe),Gt.results}},Pi={getExtension(X){const ce=Rt.getExtensionDescription(X);if(ce)return new l.Extension(Ie,Fe.identifier,ce,mi)},get all(){return Rt.getAllExtensionDescriptions().map(X=>new l.Extension(Ie,Fe.identifier,X,mi))},get onDidChange(){return Rt.onDidChange}},ai={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Fe.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Ft.getLanguages()},setTextDocumentLanguage(X,ce){return Ft.changeLanguage(X.uri,ce)},match(X,ce){return(0,t.score)(z.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,ke){return dt.registerCodeActionProvider(Fe,pt(X),ce,ke)},registerCodeLensProvider(X,ce){return dt.registerCodeLensProvider(Fe,pt(X),ce)},registerDefinitionProvider(X,ce){return dt.registerDefinitionProvider(Fe,pt(X),ce)},registerDeclarationProvider(X,ce){return dt.registerDeclarationProvider(Fe,pt(X),ce)},registerImplementationProvider(X,ce){return dt.registerImplementationProvider(Fe,pt(X),ce)},registerTypeDefinitionProvider(X,ce){return dt.registerTypeDefinitionProvider(Fe,pt(X),ce)},registerHoverProvider(X,ce){return dt.registerHoverProvider(Fe,pt(X),ce,Fe.identifier)},registerEvaluatableExpressionProvider(X,ce){return dt.registerEvaluatableExpressionProvider(Fe,pt(X),ce,Fe.identifier)},registerInlineValuesProvider(X,ce){return dt.registerInlineValuesProvider(Fe,pt(X),ce,Fe.identifier)},registerDocumentHighlightProvider(X,ce){return dt.registerDocumentHighlightProvider(Fe,pt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return dt.registerLinkedEditingRangeProvider(Fe,pt(X),ce)},registerReferenceProvider(X,ce){return dt.registerReferenceProvider(Fe,pt(X),ce)},registerRenameProvider(X,ce){return dt.registerRenameProvider(Fe,pt(X),ce)},registerDocumentSymbolProvider(X,ce,ke){return dt.registerDocumentSymbolProvider(Fe,pt(X),ce,ke)},registerWorkspaceSymbolProvider(X){return dt.registerWorkspaceSymbolProvider(Fe,X)},registerDocumentFormattingEditProvider(X,ce){return dt.registerDocumentFormattingEditProvider(Fe,pt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return dt.registerDocumentRangeFormattingEditProvider(Fe,pt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,ke,...nt){return dt.registerOnTypeFormattingEditProvider(Fe,pt(X),ce,[ke].concat(nt))},registerDocumentSemanticTokensProvider(X,ce,ke){return dt.registerDocumentSemanticTokensProvider(Fe,pt(X),ce,ke)},registerDocumentRangeSemanticTokensProvider(X,ce,ke){return dt.registerDocumentRangeSemanticTokensProvider(Fe,pt(X),ce,ke)},registerSignatureHelpProvider(X,ce,ke,...nt){return typeof ke=="object"?dt.registerSignatureHelpProvider(Fe,pt(X),ce,ke):dt.registerSignatureHelpProvider(Fe,pt(X),ce,typeof ke=="undefined"?[]:[ke,...nt])},registerCompletionItemProvider(X,ce,...ke){return dt.registerCompletionItemProvider(Fe,pt(X),ce,ke)},registerInlineCompletionItemProvider(X,ce){return(0,G.checkProposedApiEnabled)(Fe),dt.registerInlineCompletionsProvider(Fe,pt(X),ce)},registerDocumentLinkProvider(X,ce){return dt.registerDocumentLinkProvider(Fe,pt(X),ce)},registerColorProvider(X,ce){return dt.registerColorProvider(Fe,pt(X),ce)},registerFoldingRangeProvider(X,ce){return dt.registerFoldingRangeProvider(Fe,pt(X),ce)},registerSelectionRangeProvider(X,ce){return dt.registerSelectionRangeProvider(Fe,X,ce)},registerCallHierarchyProvider(X,ce){return dt.registerCallHierarchyProvider(Fe,X,ce)},setLanguageConfiguration:(X,ce)=>dt.setLanguageConfiguration(Fe,X,ce),getTokenInformationAtPosition(X,ce){return(0,G.checkProposedApiEnabled)(Fe),Ft.tokenAtPosition(X,ce)},registerInlayHintsProvider(X,ce){return(0,G.checkProposedApiEnabled)(Fe),dt.registerInlayHintsProvider(Fe,X,ce)},registerTypeHierarchyProvider(X,ce){return(0,G.checkProposedApiEnabled)(Fe),dt.registerTypeHierarchyProvider(Fe,X,ce)},createLanguageStatusItem(X){return(0,G.checkProposedApiEnabled)(Fe),Ft.createLanguageStatusItem(X)}},Ti={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(X,ce,ke){const nt=await(T.URI.isUri(X)?Promise.resolve(gi.openTextDocument(X)):Promise.resolve(X));return Pt.showTextDocument(nt,ce,ke)},createTextEditorDecorationType(X){return Pt.createTextEditorDecorationType(Fe,X)},onDidChangeActiveTextEditor(X,ce,ke){return Pt.onDidChangeActiveTextEditor(X,ce,ke)},onDidChangeVisibleTextEditors(X,ce,ke){return Pt.onDidChangeVisibleTextEditors(X,ce,ke)},onDidChangeTextEditorSelection(X,ce,ke){return Pt.onDidChangeTextEditorSelection(X,ce,ke)},onDidChangeTextEditorOptions(X,ce,ke){return Pt.onDidChangeTextEditorOptions(X,ce,ke)},onDidChangeTextEditorVisibleRanges(X,ce,ke){return Pt.onDidChangeTextEditorVisibleRanges(X,ce,ke)},onDidChangeTextEditorViewColumn(X,ce,ke){return Pt.onDidChangeTextEditorViewColumn(X,ce,ke)},onDidCloseTerminal(X,ce,ke){return ct.onDidCloseTerminal(X,ce,ke)},onDidOpenTerminal(X,ce,ke){return ct.onDidOpenTerminal(X,ce,ke)},onDidChangeActiveTerminal(X,ce,ke){return ct.onDidChangeActiveTerminal(X,ce,ke)},onDidChangeTerminalDimensions(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),ct.onDidChangeTerminalDimensions(X,ce,ke)},onDidChangeTerminalState(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),ct.onDidChangeTerminalState(X,ce,ke)},onDidWriteTerminalData(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),ct.onDidWriteTerminalData(X,ce,ke)},get state(){return qe.state},onDidChangeWindowState(X,ce,ke){return qe.onDidChangeWindowState(X,ce,ke)},showInformationMessage(X,...ce){return Kt.showMessage(Fe,A.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return Kt.showMessage(Fe,A.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return Kt.showMessage(Fe,A.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,ke){return Vt.showQuickPick(X,!!Fe.enableProposedApi,ce,ke)},showWorkspaceFolderPick(X){return Vt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Vt.showInput(X,ce)},showOpenDialog(X){return hi.showOpenDialog(X)},showSaveDialog(X){return hi.showSaveDialog(X)},createStatusBarItem(X,ce,ke){let nt,bt,Dt;return typeof X=="string"?(nt=X,bt=ce,Dt=ke):(bt=X,Dt=ce),zt.createStatusBarEntry(Fe,nt,bt,Dt)},setStatusBarMessage(X,ce){return zt.setStatusBarMessage(X,ce)},withScmProgress(X){return Se.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),ci.withProgress(Fe,{location:N.ProgressLocation.SourceControl},(ce,ke)=>X({report(nt){}}))},withProgress(X,ce){return ci.withProgress(Fe,X,ce)},createOutputChannel(X){return Ut.createOutputChannel(X,Fe)},createWebviewPanel(X,ce,ke,nt){return qt.createWebviewPanel(Fe,X,ce,ke,nt)},createWebviewTextEditorInset(X,ce,ke,nt){return(0,G.checkProposedApiEnabled)(Fe),vi.createWebviewEditorInset(X,ce,ke,nt,Fe)},createTerminal(X,ce,ke){return typeof X=="object"?("location"in X&&(0,G.checkProposedApiEnabled)(Fe),"pty"in X?ct.createExtensionTerminal(X):ct.createTerminalFromOptions(X)):ct.createTerminal(X,ce,ke)},registerTerminalLinkProvider(X){return ct.registerLinkProvider(X)},registerTerminalProfileProvider(X,ce){return ct.registerProfileProvider(Fe,X,ce)},registerTreeDataProvider(X,ce){return Jt.registerTreeDataProvider(X,ce,Fe)},createTreeView(X,ce){return Jt.createTreeView(X,ce,Fe)},registerWebviewPanelSerializer:(X,ce)=>qt.registerWebviewPanelSerializer(Fe,X,ce),registerCustomEditorProvider:(X,ce,ke={})=>Ei.registerCustomEditorProvider(Fe,X,ce,ke),registerFileDecorationProvider(X){return mt.registerFileDecorationProvider(X,Fe.identifier)},registerUriHandler(X){return Bt.registerUriHandler(Fe.identifier,X)},createQuickPick(){return Vt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Fe.identifier)},get activeColorTheme(){return di.activeColorTheme},onDidChangeActiveColorTheme(X,ce,ke){return di.onDidChangeActiveColorTheme(X,ce,ke)},registerWebviewViewProvider(X,ce,ke){return _i.registerWebviewViewProvider(Fe,X,ce,ke?.webviewOptions)},get activeNotebookEditor(){return(0,G.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(X,ce,ke)},get visibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),Ht.onDidChangeNotebookEditorSelection(X,ce,ke)},onDidChangeNotebookEditorVisibleRanges(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),Ht.onDidChangeNotebookEditorVisibleRanges(X,ce,ke)},showNotebookDocument(X,ce){return(0,G.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),yi.registerExternalUriOpener(Fe.identifier,X,ce,ke)},get openEditors(){return(0,G.checkProposedApiEnabled)(Fe),it.tabs},get onDidChangeOpenEditors(){return(0,G.checkProposedApiEnabled)(Fe),it.onDidChangeTabs},getInlineCompletionItemController(X){return(0,G.checkProposedApiEnabled)(Fe),v.InlineCompletionController.get(X)}},gi={get rootPath(){return Se.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(X){throw F.readonly()},getWorkspaceFolder(X){return xe.getWorkspaceFolder(X)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(X){throw F.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(X){throw F.readonly()},updateWorkspaceFolders:(X,ce,...ke)=>xe.updateWorkspaceFolders(Fe,X,ce||0,...ke),onDidChangeWorkspaceFolders:function(X,ce,ke){return xe.onDidChangeWorkspace(X,ce,ke)},asRelativePath:(X,ce)=>xe.getRelativePath(X,ce),findFiles:(X,ce,ke,nt)=>xe.findFiles(z.GlobPattern.from(X),z.GlobPattern.from(ce),ke,Fe.identifier,nt),findTextInFiles:(X,ce,ke,nt)=>{let bt,Dt;return typeof ce=="object"?(bt=ce,Dt=ke):(bt={},Dt=ce,nt=ke),xe.findTextInFiles(X,bt||{},Dt,Fe.identifier,nt)},saveAll:X=>xe.saveAll(X),applyEdit(X){return Si.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,ke,nt)=>Mt.createFileSystemWatcher(z.GlobPattern.from(X),ce,ke,nt),get textDocuments(){return Ct.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw F.readonly()},openTextDocument(X){let ce;const ke=X;if(typeof X=="string")ce=Promise.resolve(T.URI.file(X));else if(T.URI.isUri(X))ce=Promise.resolve(X);else if(!ke||typeof ke=="object")ce=Ct.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(nt=>Ct.ensureDocumentData(nt).then(bt=>bt.document))},onDidOpenTextDocument:(X,ce,ke)=>Ct.onDidAddDocument(X,ce,ke),onDidCloseTextDocument:(X,ce,ke)=>Ct.onDidRemoveDocument(X,ce,ke),onDidChangeTextDocument:(X,ce,ke)=>Ct.onDidChangeDocument(X,ce,ke),onDidSaveTextDocument:(X,ce,ke)=>Ct.onDidSaveDocument(X,ce,ke),onWillSaveTextDocument:(X,ce,ke)=>ti.getOnWillSaveTextDocumentEvent(Fe)(X,ce,ke),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,ce){let ke;if(T.URI.isUri(X))ke=X,await gt.openNotebookDocument(X);else if(typeof X=="string")ke=T.URI.revive(await gt.createNotebookDocument({viewType:X,content:ce}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,ce,ke,nt){return gt.registerNotebookSerializer(Fe,X,ce,ke,Fe.enableProposedApi?nt:void 0)},registerNotebookContentProvider:(X,ce,ke,nt)=>((0,G.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,X,ce,ke,Fe.enableProposedApi?nt:void 0)),onDidChangeConfiguration:(X,ce,ke)=>Qt.onDidChangeConfiguration(X,ce,ke),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,Qt.getConfiguration(X,ce,Fe)},registerTextDocumentContentProvider(X,ce){return $t.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Se.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Fe,X,ce)),registerFileSystemProvider(X,ce,ke){return ri.registerFileSystemProvider(Fe.identifier,X,ce,ke,Fe.enableProposedApi)},get fs(){return fe.value},registerFileSearchProvider:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),Tt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),Tt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),Ie.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,G.checkProposedApiEnabled)(Fe),wi.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,ke)=>Mt.onDidCreateFile(X,ce,ke),onDidDeleteFiles:(X,ce,ke)=>Mt.onDidDeleteFile(X,ce,ke),onDidRenameFiles:(X,ce,ke)=>Mt.onDidRenameFile(X,ce,ke),onWillCreateFiles:(X,ce,ke)=>Mt.getOnWillCreateFileEvent(Fe)(X,ce,ke),onWillDeleteFiles:(X,ce,ke)=>Mt.getOnWillDeleteFileEvent(Fe)(X,ce,ke),onWillRenameFiles:(X,ce,ke)=>Mt.getOnWillRenameFileEvent(Fe)(X,ce,ke),openTunnel:X=>((0,G.checkProposedApiEnabled)(Fe),Ce.openTunnel(Fe,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,G.checkProposedApiEnabled)(Fe),Ce.getTunnels()},onDidChangeTunnels:(X,ce,ke)=>((0,G.checkProposedApiEnabled)(Fe),Ce.onDidChangeTunnels(X,ce,ke)),registerPortAttributesProvider:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),Ce.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),bi.registerTimelineProvider(X,ce,Fe.identifier,ot.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:X=>((0,G.checkProposedApiEnabled)(Fe),xe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ce,ke)=>xe.onDidGrantWorkspaceTrust(X,ce,ke)},Ai={get inputBox(){return Se.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Fe)},createSourceControl(X,ce,ke){return Xt.createSourceControl(Fe,X,ce,ke)}},Ri={createCommentController(X,ce){return si.createCommentController(Fe,X,ce)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,ce,ke){return lt.onDidStartDebugSession(X,ce,ke)},onDidTerminateDebugSession(X,ce,ke){return lt.onDidTerminateDebugSession(X,ce,ke)},onDidChangeActiveDebugSession(X,ce,ke){return lt.onDidChangeActiveDebugSession(X,ce,ke)},onDidReceiveDebugSessionCustomEvent(X,ce,ke){return lt.onDidReceiveDebugSessionCustomEvent(X,ce,ke)},onDidChangeBreakpoints(X,ce,ke){return lt.onDidChangeBreakpoints(X,ce,ke)},registerDebugConfigurationProvider(X,ce,ke){return lt.registerDebugConfigurationProvider(X,ce,ke||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return lt.registerDebugAdapterDescriptorFactory(Fe,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return lt.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(X,ce,{parentSession:ke}):lt.startDebugging(X,ce,ke||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,ce){return lt.asDebugSourceUri(X,ce)}},Mi={registerTaskProvider:(X,ce)=>_t.registerTaskProvider(Fe,X,ce),fetchTasks:X=>_t.fetchTasks(X),executeTask:X=>_t.executeTask(Fe,X),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(X,ce,ke)=>_t.onDidStartTask(X,ce,ke),onDidEndTask:(X,ce,ke)=>_t.onDidEndTask(X,ce,ke),onDidStartTaskProcess:(X,ce,ke)=>_t.onDidStartTaskProcess(X,ce,ke),onDidEndTaskProcess:(X,ce,ke)=>_t.onDidEndTaskProcess(X,ce,ke)},Li={createNotebookController(X,ce,ke,nt,bt){return ii.createNotebookController(Fe,X,ce,ke,nt,Fe.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(X,ce)=>gt.registerNotebookCellStatusBarItemProvider(Fe,X,ce),get onDidSaveNotebookDocument(){return(0,G.checkProposedApiEnabled)(Fe),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,G.checkProposedApiEnabled)(Fe),Ht.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ni.createRendererMessaging(Fe,X)},onDidChangeNotebookDocumentMetadata(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),Yt.onDidChangeNotebookDocumentMetadata(X,ce,ke)},onDidChangeNotebookCells(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(X,ce,ke)},onDidChangeNotebookCellExecutionState(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(X,ce,ke)},onDidChangeCellOutputs(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(X,ce,ke)},onDidChangeCellMetadata(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(X,ce,ke)},createConcatTextDocument(X,ce){return(0,G.checkProposedApiEnabled)(Fe),new $e.ExtHostNotebookConcatDocument(gt,Ct,X,ce)}};return{version:le.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:fi,extensions:Pi,languages:ai,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:gi,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:P.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:n.UIKind,Uri:T.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:yt.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(ve[224],we([0,1,56,96,31,95,32,47,48,37,99,100,101,73,66,71,97,72,45,70,88,64]),function(ne,e,c,F,_,A,T,I,S,P,t,y,n,d,o,a,g,k,b,u,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService),(0,c.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,c.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,c.registerSingleton)(k.IExtHostConsumerFileSystem,k.ExtHostConsumerFileSystem),(0,c.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,c.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,c.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,c.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,c.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,c.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,c.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,c.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,c.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,c.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,c.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs)}),define(ve[225],we([0,1,223,33,219,6,13,5,11]),function(ne,e,c,F,_,A,T,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(o){const a=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(k,...b)=>{b.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const u=b.slice(0,-1).join(","),p=b.pop().toString();return`(function anonymous(${u}) {
${p}
})`}});function g(...k){return a?self.eval(a.createScript("",...k)):new Function(...k)}o.create=g})(P||(P={}));class t extends _.RequireInterceptor{_installInterceptor(){}getModule(a,g){for(let k of this._alternatives){let b=k(a);if(b){a=b;break}}if(this._factories.has(a))return this._factories.get(a).load(a,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);d(a,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,g,k){g=g.with({path:n(g.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const b=await fetch(S.FileAccess.asBrowserUri(g).toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),b.status!==200)throw new Error(b.statusText);const u=await b.text(),p=`${g.toString(!0)}#vscode-extension`,D=`${u}
//# sourceURL=${p}`;let i;try{i=P.create(y._ttpExtensionScripts?.createScript("module")??"module",y._ttpExtensionScripts?.createScript("exports")??"exports",y._ttpExtensionScripts?.createScript("require")??"require",y._ttpExtensionScripts?.createScript(D)??D)}catch(m){throw console.error(a?`Loading code for extension ${a.value} failed: ${m.message}`:`Loading code failed: ${m.message}`),console.error(`${g.toString(!0)}${typeof m.line=="number"?` line ${m.line}`:""}${typeof m.column=="number"?` column ${m.column}`:""}`),console.error(m),m}const r={},l={exports:r},s=m=>{const v=this._fakeModules.getModule(m,g);if(v===void 0)throw new Error(`Cannot load module '${m}'`);return v};try{return k.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),i(l,r,s),l.exports!==r?l.exports:r}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),k.codeLoadingStop()}}async $setRemoteEnvironment(a){}async _waitForDebuggerAttachment(a=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+a;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,T.timeout)(10)}}e.ExtHostExtensionService=y,y._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:o=>o});function n(o,a){return o.endsWith(a)?o:o+a}function d(o,a){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(u,p){const D=console[u];console[u]=function(){o.$logExtensionHostMessage({type:"__$console",severity:p,arguments:b(arguments)}),a&&D.apply(console,arguments)}}const k=1e5;function b(u){const p=[],D=[];if(u.length)for(let i=0;i<u.length;i++){if(typeof u[i]=="undefined")u[i]="undefined";else if(u[i]instanceof Error){const r=u[i];r.stack?u[i]=r.stack:u[i]=r.toString()}D.push(u[i])}try{const i=JSON.stringify(D,function(r,l){if(l&&typeof l=="object"){if(p.indexOf(l)!==-1)return"[Circular]";p.push(l)}return l});return i.length>k?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(ve[226],we([0,1,56,14,33,74,225,212]),function(ne,e,c,F,_,A,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(_.IExtHostExtensionService,T.ExtHostExtensionService),(0,c.registerSingleton)(F.ILogService,I.ExtHostLogService),(0,c.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(ve[235],we([0,1,23,3,177,220,214,17,75,11,2,224,226]),function(ne,e,c,F,_,A,T,I,S,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const b=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:p=>p}),u=self.Worker;Worker=function(p,D){/^file:/i.test(p.toString())&&(p=P.FileAccess.asBrowserUri(t.URI.parse(p.toString())).toString(!0));const i=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${p}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;D=D||{},D.name=D.name||I.basename(p.toString());const r=new Blob([i],{type:"application/javascript"}),l=URL.createObjectURL(r);return new u(b?b.createScriptURL(l):l,D)}}else self.Worker=class extends T.NestedWorker{constructor(b,u){super(n,b,{name:I.basename(b.toString()),...u})}};const d=new class{exit(b){y()}async exists(b){return!0}async realpath(b){return b}};class o{constructor(){const u=new MessageChannel,p=new F.Emitter;let D=!1;n(u.port2,[u.port2]),u.port1.onmessage=i=>{const{data:r}=i;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const l=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,_.isMessageOfType)(l,2)){D=!0,g("received terminate message from renderer");return}p.fire(l)},this.protocol={onMessage:p.event,send:i=>{if(!D){const r=i.buffer.buffer.slice(i.buffer.byteOffset,i.buffer.byteOffset+i.buffer.byteLength);u.port1.postMessage(r,[r])}}}}}function a(b){return new Promise(u=>{const p=b.onMessage(D=>{p.dispose();const i=JSON.parse(D.toString());b.send((0,_.createMessageOfType)(0)),u({protocol:b,initData:i})});b.send((0,_.createMessageOfType)(1))})}let g=b=>y();function k(){const b=new o;S.mark("code/extHost/willConnectToRenderer"),a(b.protocol).then(u=>{S.mark("code/extHost/didWaitForInitData");const p=new A.ExtensionHostMain(u.protocol,u.initData,d,null);g=D=>p.terminate(D)})}e.create=k})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5f19eee5dc9588ca96192f89587b5878b7d7180d/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
